#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 5;

vector <int> g[maxn], nxt[maxn], ans;

int n, m, h, hour[maxn], answer, q[maxn], aux[maxn];

void check( int node, int cycle ) {
    int moved = 1, left, right;
    for (int i = 1; i <= n; i++) {
        aux[ i ] = hour[ i ];
    }

    left = right = 0;
    q[ right++ ] = node;
    aux[ node ] = (aux[ node ] + 1) % h;
    while (left < right) {
        node = q[ left++ ];
        for (int son: g[ node ]) {
            if (aux[ son ] == aux[ node ]) {
                aux[ son ] = (aux[ son ] + 1) % h;
                q[ right++ ] = son;
                moved++;
            }
        }
    }

    if (moved < answer) {
        answer = moved;
        ans.clear();
        for (int i = 0; i < right; i++)
            ans.push_back( q[ i ] );
    }
}

int main()
{
    ios::sync_with_stdio(false);

    //freopen( "input", "r", stdin );
    //freopen( "output","w", stdout);

    int x, y;

    cin >> n >> m >> h;

    for (int i = 1; i <= n; i++)
        cin >> hour[ i ];

    for (int i = 1; i <= m; i++) {
        cin >> x >> y;
        g[ x ].push_back( y );
        g[ y ].push_back( x );
        if ((hour[ x ] + 1) % h == hour[ y ])
            nxt[ x ].push_back( y );
        else
            if ((hour[ y ] + 1) % h == hour[ x ])
                nxt[ y ].push_back( x );
    }

    answer = 0x3f3f3f3f;
    for (int i = 1; i <= n; i++) {
        check( i, hour[ i ] );
    }

    cout << answer << '\n';
    for (int sol: ans)
        cout << sol << " ";

    return 0;
}
