#include <bits/stdc++.h>
#define MAXN 100000

int v[1 + MAXN], out[1 + MAXN];
std::vector <int> G[1 + MAXN];

int st[1 + MAXN], last, inst[1 + MAXN];
int pos[1 + MAXN], lowlink[1 + MAXN];
std::vector <std::vector <int>> M;

std::vector <int> CTC;
int comp[1 + MAXN];
void tarjan(int node){
    st[++last] = node;
    inst[node] = 1;
    lowlink[node] = pos[node] = last;
    for(auto y: G[node]){
        if(!pos[y]) tarjan(y), lowlink[node] = std::min(lowlink[node], lowlink[y]);
        else if(inst[y]) lowlink[node] = std::min(lowlink[node], lowlink[y]);
    }
    if(lowlink[node] == pos[node]){
        CTC.clear();
        while(last >= pos[node]){
            CTC.push_back(st[last]);
            inst[st[last]] = 0;
            last--;
        }
        M.push_back(CTC);
    }
}


int min = 1000000000, legood;
int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in","r");
    //fo = fopen("a.out","w");
    fi = stdin;
    fo = stdout;

    int n, m, h;
    fscanf(fi,"%d%d%d", &n, &m, &h);
    for(int i = 1; i <= n; i++)
        fscanf(fi,"%d", &v[i]);
    for(int i = 1; i <= m; i++){
        int x, y;
        fscanf(fi,"%d%d", &x, &y);
        if((v[x] + 1) % h == v[y]) G[x].push_back(y);
        if((v[y] + 1) % h == v[x]) G[y].push_back(x);
    }
    for(int i = 1; i <= n; i++) if(!pos[i]) tarjan(i);

    for(int i = 0; i < M.size(); i++)
        for(auto y: M[i]) comp[y] = i;
    for(int i = 0; i < M.size(); i++)
        for(auto y: M[i])
            for(auto z: G[y]) if(comp[y] != comp[z]) out[comp[y]] = 1;
    for(int i = 0; i < M.size(); i++)
        if(!out[i] && M[i].size() < min) min = M[i].size(), legood = i;
    fprintf(fo,"%d\n", min);
    for(auto y: M[legood]) fprintf(fo,"%d ", y);
    return 0;
}
