#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y)
{
    if(x > y)
        x = y;
}
template<class T, class T1> void chkmax(T &x, const T1 &y)
{
    if(x < y)
        x = y;
}
const int MAXN = (1 << 20);

int ST_N, MAX_V;
int a[MAXN];

namespace solution_wrong
{
const int OFFSET = (1 << 17);

int n;
bitset<1 << 18> bs, dp;
int max_bit = 0;
clock_t START;

void read()
{
    START = clock();

    n = ST_N;
    for(int i = 0; i < n; i++)
    {
        int val;
        val = a[i];
        //if(rand() % 2) val = -val;

        bs[val + OFFSET] = 1;

        int pos_val = val;
        if(pos_val < 0)
            pos_val *= -1;

        int c_log = 0;
        while((1 << c_log) <= pos_val)
            c_log++;
        chkmax(max_bit, c_log);
    }
}

vector<int> answer;
vector<int> curr;

void rec(int p)
{
    if(curr.size() > answer.size())
        return;

    if((double)(clock() - START) / (double)CLOCKS_PER_SEC > 0.75)
    {
        cout << answer.size() << endl;
        for(int x: answer)
            cout << x << " ";
        cout << endl;
        exit(0);
    }

    if(p == max_bit + 1)
    {
        if((bs & dp) != bs)
            return;
        if(curr.size() < answer.size())
            answer = curr;
        return;
    }

    bitset<1 << 18> emp = dp;

    rec(p + 1);

    curr.push_back((1 << p));
    dp = emp | (emp << ((1 << p)));
    rec(p + 1);
    curr.pop_back();

    curr.push_back(-(1 << p));
    dp = emp | (emp >> ((1 << p)));
    rec(p + 1);
    curr.pop_back();
}

void solve()
{
    for(int i = 1; i < (1 << max_bit); i <<= 1)
        answer.push_back(-i);
    answer.push_back(1 << max_bit);

    dp[OFFSET] = 1;
    rec(0);

    cout << answer.size() << endl;
    for(int x: answer)
        cout << x << " ";
    cout << endl;
}
};

namespace solution_5000
{
const int OFFSET = (1 << 14);

int n;
bitset<1 << 15> bs, dp;
int max_bit = 0;
clock_t START;

void read()
{
    START = clock();

    n = ST_N;
    for(int i = 0; i < n; i++)
    {
        int val;
        val = a[i];
        //if(rand() % 2) val = -val;

        bs[val + OFFSET] = 1;

        int pos_val = val;
        if(pos_val < 0)
            pos_val *= -1;

        int c_log = 0;
        while((1 << c_log) <= pos_val)
            c_log++;
        chkmax(max_bit, c_log);
    }
}

vector<int> answer;
vector<int> curr;

void rec(int p)
{
    if(curr.size() > answer.size())
        return;

    if((double)(clock() - START) / (double)CLOCKS_PER_SEC > 0.75)
    {
        cout << answer.size() << endl;
        for(int x: answer)
            cout << x << " ";
        cout << endl;
        exit(0);
    }

    if(p == max_bit + 1)
    {
        if((bs & dp) != bs)
            return;
        if(curr.size() < answer.size())
            answer = curr;
        return;
    }

    bitset<1 << 15> emp = dp;

    rec(p + 1);

    curr.push_back((1 << p));
    dp = emp | (emp << ((1 << p)));
    rec(p + 1);
    curr.pop_back();

    curr.push_back(-(1 << p));
    dp = emp | (emp >> ((1 << p)));
    rec(p + 1);
    curr.pop_back();
}

void solve()
{
    for(int i = 1; i < (1 << max_bit); i <<= 1)
        answer.push_back(-i);
    answer.push_back(1 << max_bit);

    dp[OFFSET] = 1;
    rec(0);

    cout << answer.size() << endl;
    for(int x: answer)
        cout << x << " ";
    cout << endl;
}
};

namespace solution_3000
{
const int OFFSET = (1 << 13);

int n;
bitset<1 << 14> bs, dp;
int max_bit = 0;
clock_t START;

void read()
{
    START = clock();

    n = ST_N;
    for(int i = 0; i < n; i++)
    {
        int val;
        val = a[i];
        //if(rand() % 2) val = -val;

        bs[val + OFFSET] = 1;

        int pos_val = val;
        if(pos_val < 0)
            pos_val *= -1;

        int c_log = 0;
        while((1 << c_log) <= pos_val)
            c_log++;
        chkmax(max_bit, c_log);
    }
}

vector<int> answer;
vector<int> curr;

void rec(int p)
{
    if(curr.size() > answer.size())
        return;

    if((double)(clock() - START) / (double)CLOCKS_PER_SEC > 0.75)
    {
        cout << answer.size() << endl;
        for(int x: answer)
            cout << x << " ";
        cout << endl;
        exit(0);
    }

    if(p == max_bit + 1)
    {
        if((bs & dp) != bs)
            return;
        if(curr.size() < answer.size())
            answer = curr;
        return;
    }

    bitset<1 << 14> emp = dp;

    rec(p + 1);

    curr.push_back((1 << p));
    dp = emp | (emp << ((1 << p)));
    rec(p + 1);
    curr.pop_back();

    curr.push_back(-(1 << p));
    dp = emp | (emp >> ((1 << p)));
    rec(p + 1);
    curr.pop_back();
}

void solve()
{
    for(int i = 1; i < (1 << max_bit); i <<= 1)
        answer.push_back(-i);
    answer.push_back(1 << max_bit);

    dp[OFFSET] = 1;
    rec(0);

    cout << answer.size() << endl;
    for(int x: answer)
        cout << x << " ";
    cout << endl;
}
};

namespace solution_1000
{
const int OFFSET = (1 << 10);

int n;
bitset<1 << 11> bs, dp;
int max_bit = 0;
clock_t START;

void read()
{
    START = clock();

    n = ST_N;
    for(int i = 0; i < n; i++)
    {
        int val;
        val = a[i];
        //if(rand() % 2) val = -val;

        bs[val + OFFSET] = 1;

        int pos_val = val;
        if(pos_val < 0)
            pos_val *= -1;

        int c_log = 0;
        while((1 << c_log) <= pos_val)
            c_log++;
        chkmax(max_bit, c_log);
    }
}

vector<int> answer;
vector<int> curr;

void rec(int p)
{
    if(curr.size() > answer.size())
        return;

    if(p == max_bit + 1)
    {
        if((bs & dp) != bs)
            return;
        if(curr.size() < answer.size())
            answer = curr;
        return;
    }

    bitset<1 << 11> emp = dp;

    rec(p + 1);

    curr.push_back((1 << p));
    dp = emp | (emp << ((1 << p)));
    rec(p + 1);
    curr.pop_back();

    curr.push_back(-(1 << p));
    dp = emp | (emp >> ((1 << p)));
    rec(p + 1);
    curr.pop_back();
}

void solve()
{
    for(int i = 1; i < (1 << max_bit); i <<= 1)
        answer.push_back(-i);
    answer.push_back(1 << max_bit);

    dp[OFFSET] = 1;
    rec(0);

    cout << answer.size() << endl;
    for(int x: answer)
        cout << x << " ";
    cout << endl;
}
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> ST_N;
    for(int i = 0; i < ST_N; i++)
    {
        cin >> a[i];
        chkmax(MAX_V, a[i]);
        chkmax(MAX_V, -a[i]);
    }

    if(MAX_V > 5000)
    {
        solution_wrong::read();
        solution_wrong::solve();
        return 0;
    }

    if(MAX_V > 3000)
    {
        solution_5000::read();
        solution_5000::solve();
        return 0;
    }

    if(MAX_V > 1000)
    {
        solution_3000::read();
        solution_3000::solve();
        return 0;
    }

    solution_1000::read();
    solution_1000::solve();
    return 0;
}
