#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 2e5 + 5;

vector< int > ans[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s;
	
	int indOfAns = 0;
	
	queue< int > endingWithOnes, endingWithZeros;

	for(int i = 0; i < (int) s.size(); i++) {
		if(s[i] == '1') {
			if(endingWithZeros.empty()) {
				cout << -1 << endl;
				return 0;
			}
			else {
				ans[endingWithZeros.front()].push_back(i + 1);
				endingWithOnes.push(endingWithZeros.front());
				endingWithZeros.pop();
			}
		}
		else {
			if(endingWithOnes.empty()) {
				ans[indOfAns].push_back(i + 1);
				endingWithZeros.push(indOfAns);
				indOfAns++;
			}
			else {
				ans[endingWithOnes.front()].push_back(i + 1);
				endingWithZeros.push(endingWithOnes.front());
				endingWithOnes.pop();
			}
		}
	}

	if(!endingWithOnes.empty()) {
		cout << -1 << endl;
		return 0;
	}

	cout << indOfAns << endl;
	for(int i = 0; i < indOfAns; i++) {
		cout << ans[i].size();
		for(int x : ans[i]) {
			cout << " " << x;
		}
		cout << endl;
	}

	return 0;
}
