#include<iostream>
#include<vector>
#include<climits>

using namespace std;

const int MAXN = 1e5 + 5;

int u, v;
int n, m, h;
int a[MAXN];

bool used[MAXN];

vector <int> topSort;
vector <int> graph[MAXN];

int minLen = INT_MAX, currentLen;
vector <int> answer, current;

int newValue(int x)
{
    x++;
    if(x==h) x = 0;

    return x;
}

int DFS(int x)
{
    current.push_back(x);

    used[x] = true;
    int answer = 1;

    for(int i = 0;i<graph[x].size();i++)
    {
        if(used[ graph[x][i] ]==false)
        {
            answer += DFS(graph[x][i]);
        }
    }

    used[x] = false;
    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> h;
    for(int i = 1;i<=n;i++)
    {
        cin >> a[i];
    }

    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        if(newValue(a[u])==a[v]) graph[u].push_back(v);
        if(newValue(a[v])==a[u]) graph[v].push_back(u);
    }

    for(int i = 1;i<=n;i++)
    {
        current.clear();
        currentLen = DFS(i);

        if(currentLen<minLen)
        {
            minLen = currentLen;
            answer = current;
        }
    }

    cout << minLen << '\n';
    for(int i = 0;i<minLen;i++)
        cout << answer[i] << " ";
}
/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
