#include<iostream>
#include<vector>
#include<climits>

using namespace std;

const int MAXN = 1e5 + 5;

int u, v;
int n, m, h;
int a[MAXN], aCopy[MAXN];

vector < pair <int, int> > users;

bool used[MAXN];

vector <int> topSort;
vector <int> graph[MAXN];

int minLen = INT_MAX, currentLen;
vector <int> answer, current;

int newValue(int x)
{
    x++;
    if(x==h) x = 0;

    return x;
}

bool ok()
{
    for(int i = 0;i<m;i++)
    {
        if(aCopy[ users[i].first ]==aCopy[ users[i].second ]) return false;
    }

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> h;
    for(int i = 1;i<=n;i++)
    {
        cin >> a[i];
    }

    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;

        users.push_back(make_pair(u, v));
    }

    for(int i = 1;i<=n;i++)
    {
        for(int i = 1;i<=n;i++)
        {
            aCopy[i] = a[i];
        }

        aCopy[i] = newValue(aCopy[i]);

        current.clear();
        current.push_back(i);

        while(ok()==false)
        {
            for(int j = 0;j<m;j++)
            {
                if(aCopy[ users[j].first ]==aCopy[ users[j].second ])
                {
                    if(aCopy[ users[j].first ]==a[ users[j].first ])
                    {
                        aCopy[ users[j].first ] = newValue(a[ users[j].first ]);
                        current.push_back(users[j].first);
                    }
                    else
                    {
                        aCopy[ users[j].second ] = newValue(a[ users[j].second ]);
                        current.push_back(users[j].second);
                    }
                }
            }
        }

        if(current.size()<minLen)
        {
            minLen = current.size();
            answer = current;
        }
    }

    cout << minLen << '\n';
    for(int i = 0;i<minLen;i++)
        cout << answer[i] << " ";
}
/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/


