#include<iostream>
#include<vector>

using namespace std;

const int MAXN = 1e5 + 5, MAXA = 2*(1005), MAXSelected = 25;
const int offSet = MAXA/2;

int n;
int a[MAXN];

int maxNumber = -MAXA, minNumber = MAXA;

bool dp[MAXA];
int seq[MAXN];

vector <int> options;

int minLen = MAXN;
int answer[MAXN];

int sum = 0;
bool check(int m)
{
    for(int i = 0;i<=maxNumber+offSet;i++)
        dp[i] = 0;
    sum = 0;

    dp[offSet] = true;
    for(int i = 0;i<m;i++)
    {
        if(seq[i]<0) continue;

        for(int j = sum+offSet;j>=offSet;j--)
        {
            if(dp[j]==true)
            {
                dp[ j + seq[i] ] = true;
            }
        }

        sum += seq[i];
    }

    for(int i = 0;i<m;i++)
    {
        if(seq[i]>0) continue;

        for(int j = offSet;j<=sum+offSet;j++)
        {
            if(dp[j]==true)
            {
                dp[ j + seq[i] ] = true;
            }
        }
    }

    for(int i = 0;i<n;i++)
    {
        if(dp[ a[i] + offSet ]==false) return false;
    }

    return true;
}

void bruteForce(int addIndex, int index, int sumPos, int sumNeg)
{
    if(check(index)==true)
    {
        if(index<minLen)
        {
            minLen = index;
            for(int i = 0;i<minLen;i++)
                answer[i] = seq[i];
        }

        return;
    }

    if(addIndex==options.size()) return;
    //if(sumPos+sumNeg<minNumber) return;

    bruteForce(addIndex+1, index, sumPos, sumNeg);
    for(int i = 0;i<4;i++)
    {
        seq[index] = options[addIndex];
        index++;

        if(options[addIndex]>0) sumPos += options[addIndex];
        else sumNeg += options[addIndex];

        bruteForce(addIndex+1, index, sumPos, sumNeg);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int toAdd = 1;

    cin >> n;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i];

        maxNumber = max(a[i], maxNumber);
        minNumber = min(a[i], minNumber);
    }

    toAdd = 1;
    while(toAdd<3*maxNumber)
    {
        options.push_back(toAdd);
        toAdd *= 2;
    }

    toAdd = -1;
    while(toAdd>3*minNumber)
    {
        options.push_back(toAdd);
        toAdd *= 2;
    }

    bruteForce(0, 0, 0, 0);

    cout << minLen << '\n';
    for(int i = 0;i<minLen;i++)
        cout << answer[i] << " ";
    cout << '\n';
}
/*
5
-1 3 0 4 7

4
2 -2 14 18
*/
