#include<iostream>
#include<vector>

using namespace std;

const int MAXN = (1e5)*2 + 5;

int n;
string s;

bool used[MAXN];

int seq = 0;
vector <int> answer[MAXN];

int findFirst(int index, int target)
{
    for(int i = index;i<n;i++)
    {
        if(s[index]==target+'0' && used[i]==false) return i;
    }

    return -1;
}

bool ready()
{
    for(int i = 0;i<n;i++)
        if(used[i]==false) return false;

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int index = 0;
    int target = 0;

    cin >> s;
    n = s.size();

    while(ready()==false)
    {
        target = 0;
        index = findFirst(0, target);

        if(index==-1)
        {
            cout << "-1" << '\n';
            return 0;
        }

        do
        {
            answer[seq].push_back(index);
            used[index] = true;

            target ^= 1;
            index = findFirst(index+1, target);
        }
        while(index!=-1);

        index = answer[seq][ answer[seq].size() - 1 ];
        if(s[index]=='1')
        {
            used[index] = false;
            answer[seq].pop_back();
        }

        seq++;
    }

    cout << seq << '\n';
    for(int i = 0;i<seq;i++)
    {
        cout << answer[i].size();
        for(int j = 0;j<answer[i].size();j++)
            cout << " " << answer[i][j] + 1;
        cout << '\n';
    }
}
