#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 1e5 + 1;
vector<int> in[MAX_N], out[MAX_N];
int u[MAX_N];
bool check[MAX_N];

vector<int> dfs( int n ) {
    vector<int> d, ans;
    d.push_back( n );
    while ( d.size() > 0 ) {
        int t = d.back();
        d.pop_back();

        if ( !check[t] ) {
            ans.push_back( t );
            check[t] = 1;
            for ( int x : out[t] )
                d.push_back( x );
        }
    }
    return ans;
}

int main() {
    int n, m, h, x, y;
    cin >> n >> m >> h;

    for ( int i = 1; i <= n; i ++ )
        cin >> u[i];
    for ( int i = 0; i < m; i ++ ) {
        cin >> x >> y;

        if ( ( u[x] + 1 ) % h == u[y] ) {
            out[x].push_back( y );
            in[y].push_back( x );
        } else if ( ( u[y] + 1 ) % h == u[x] ) {
            out[y].push_back( x );
            in[x].push_back( y );
        }
    }

    int i = 1;
    while ( i <= n && out[i].size() )
        i ++;

    if ( i <= n ) {
        cout << 1 << endl << i;
    } else {
        vector<int> ans;
        for ( i = 1; i <= n; i ++ )
            if ( !check[i] ) {
                vector<int> x = dfs( i );
                if ( !ans.size() || ans.size() > x.size() )
                    ans = x;
            }
        cout << ans.size() << endl;
        for ( int x : ans )
            cout << x << ' ';
    }

    return 0;
}
