#include <iostream>
#include <cassert>

using namespace std;

const int MAX_N = 1e5;
const int MAX_VAL = 1e5;
int v[MAX_N];
bool f_aux[1 + 2 * MAX_VAL];
#define f (f_aux + MAX_VAL)
int comb[20];

int popcnt( int x ) {
    x = (x & 1431655765) + (( x >> 1 ) & 1431655765);
    x = (x & 858993459)  + (( x >> 2 ) &  858993459);
    x = (x & 252645135)  + (( x >> 4 )  & 252645135);
    x = (x & 16711935)   + (( x >> 8 )   & 16711935);
    x = (x & 65535)      + ( x >> 16 );
    return x;
}

int main() {
    int n, mx = 0, nuls = 0;
    cin >> n;

    for ( int i = 0; i < n; i ++ ) {
        cin >> v[i];
        while ( ( 1 << mx ) <= abs( v[i] ) )
            mx ++;
        nuls += ( v[i] == 0 );
    }
    mx += 1;

    if ( nuls == n ) {
        cout << 0;
        return 0;
    }

    int num_cards = 0, j = 0;
    do {
        num_cards ++;
        for ( int mask = 0; mask < ( 1 << 2 * mx ); mask ++ ) {
            if ( popcnt( mask ) != num_cards )
                continue;
            int ix = 0;
            for ( int i = 0; i < 2 * mx; i ++ )
                if ( mask >> i & 1 )
                    comb[ix ++] = ( i < mx ? 1 << i : -( 1 << i - mx ) );

            for ( int i = -( 2 << mx ); i <= ( 2 << mx ); i ++ )
                f[i] = 0;

            for ( int mask2 = 0; mask2 < ( 1 << num_cards ); mask2 ++ ) {
                int s = 0;
                for ( int i = 0; i < num_cards; i ++ )
                    if ( mask2 >> i & 1 )
                        s += comb[i];
                f[s] = 1;
            }

            j = 0;
            while ( j < n && f[v[j]] )
                j ++;
            if ( j == n )
                break;
        }
    } while ( j < n );

    cout << num_cards << endl;
    for ( int i = 0; i < num_cards; i ++ )
        cout << comb[i] << ' ';

    return 0;
}
