#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

const int MAX_N = 2e5 + 1;
char s[MAX_N];
int bad[MAX_N], good[MAX_N];
int num_bad, num_good;

int main() {
    FILE *fin = fopen( "input.txt", "r" ), *fout = fopen( "output.txt", "w" );

    fscanf( fin, "%s", s );
    int n = strlen( s );

    for ( int i = 0; i < n; i ++ ) {
        if ( s[i] == '0' )
            bad[num_bad ++] = i + 1;
        else
            good[num_good ++] = i + 1;
    }

    //printf( "%d %d\n", num_bad, num_good );

    if ( num_good >= num_bad ) {
        fprintf( fout, "-1" );
    } else {
        fprintf( fout, "%d\n", num_bad - num_good );
        while ( num_bad > num_good + 1 )
            fprintf( fout, "1 %d\n", bad[-- num_bad] );

        fprintf( fout, "%d ", num_bad + num_good );
        int i = 0, j = 0;
        while ( i < num_bad && j < num_good ) {
            if ( bad[i] < good[i] )
                fprintf( fout, "%d ", bad[i ++] );
            else
                fprintf( fout, "%d ", good[j ++] );
        }
        while ( i < num_bad )
            fprintf( fout, "%d ", bad[i ++] );
        while ( j < num_good)
            fprintf( fout, "%d ", good[j ++] );
    }

    fclose( fin );
    fclose( fout );

    return 0;
}
