#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <set>

using namespace std;

const int MAX_N = 2e5 + 1;
char s[MAX_N];
set<int> bad, good;
vector<vector<int> > ans;

int main() {
    FILE *fin = fopen( "input.txt", "r" ), *fout = fopen( "output.txt", "w" );

    fscanf( fin, "%s", s );
    int n = strlen( s );

    for ( int i = 0; i < n; i ++ ) {
        if ( s[i] == '0' )
            bad.insert( i + 1 );
        else
            good.insert( i + 1 );
    }

    //printf( "%d %d\n", num_bad, num_good );

    while ( bad.size() != 0 ) {
        set<int>::iterator x = bad.begin(), y;
        ans.push_back( vector<int>() );
        ans.back().push_back( *x );
        bad.erase( x );
        do {
            y = good.lower_bound( *x );
            if ( y != good.end() ) {
                x = bad.lower_bound( *y );
                if ( x != bad.end() ) {
                    ans.back().push_back( *y );
                    ans.back().push_back( *x );
                    good.erase( y );
                    bad.erase( x );
                } else
                    break;
            } else
                break;
        } while ( 1 );
    }

    //printf( "%d %d\n", bad.size(), good.size() );

    if ( good.size() )
        fprintf( fout, "-1\n" );
    else {
        fprintf( fout, "%d\n", ans.size() );
        for ( vector<int>& x : ans ) {
            fprintf( fout, "%d ", x.size() );
            for ( int y : x )
                fprintf( fout, "%d ", y );
            fprintf( fout, "\n" );
        }
    }

    fclose( fin );
    fclose( fout );

    return 0;
}
