#include <cstdio>
#include <vector>

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define MAXN 100009

std::vector < int > g[MAXN], t[MAXN];
int c[MAXN], gr[MAXN];
bool viz[MAXN], ok[MAXN];
int v[MAXN], comp, u[MAXN];

void dfs1(int x) {
    viz[x] = 1;
    for (auto &y : g[x])
        if (viz[y] == 0)
            dfs1(y);
    v[++v[0]] = x;
}

void dfs2(int x) {
    viz[x] = 0;
    c[x] = comp;
    gr[comp]++;
    for (auto &y : t[x])
        if (viz[y] == 1)
            dfs2(y);
        else if (c[y] != comp)
            ok[comp] = 0;
}

int main() {
    int n, m, h;
    fscanf(fin, "%d%d%d", &n, &m, &h);

    for (int i = 1; i <= n; i++)
        fscanf(fin, "%d", &u[i]);

    for (int i = 0; i < m; i++) {
        int x, y;
        fscanf(fin, "%d%d", &x, &y);

        if ((u[x] + 1) % h == u[y])
            g[x].push_back(y), t[y].push_back(x);
        if ((u[y] + 1) % h == u[x])
            g[y].push_back(x), t[x].push_back(y);
    }

    for (int i = 1; i <= n; i++)
        if (viz[i] == 0)
            dfs1(i);

    for (int i = 1; i <= n; i++) {
        if (viz[v[i]] == 1) {
            comp++;
            ok[comp] = 1;
            dfs2(v[i]);
        }
    }

    int ans = n + 1, cine = 0;
    for (int i = 1; i <= comp; i++)
        if (ok[i] == 1 && gr[i] < ans)
            ans = gr[i], cine = i;

    fprintf(fout, "%d\n", ans);
    for (int i = 1; i <= n; i++)
        if (c[i] == cine)
            fprintf(fout, "%d", i);

    fclose(fin);
    fclose(fout);
    return 0;
}
