#include <cstdio>

FILE *fin = fopen("input.txt", "r"), *fout= fopen("output.txt", "w");

#define MAXN 100009
#define LOGN 16

int p, n, d, x, a[MAXN], b;
int dr[MAXN], st[MAXN], cat[MAXN];

inline bool ok(int k) {
    int lim = n - k;
    if (p == 1)
        lim = n;
    for (int i = k + 1; i <= lim; i++)
        if (a[dr[i]] - a[st[i] - 1] < b * (cat[i] - k))
            return 0;
    return 1;
}

int main() {
    fscanf(fin, "%d%d%d%d", &p, &n, &d, &b);
    for (int i = 1; i <= n; i++) {
        fscanf(fin, "%d", &a[i]);
        a[i] += a[i - 1];
    }

    if (p == 1) {
        for (int i = 1; i <= n; i++) {
            long long right = i + 1LL * i * d;
            if (right <= n)
                dr[i] = right;
            else dr[i] = n;
            st[i] = 1;
            cat[i] = i;
        }
    } else {
        for (int i = 1; i <= n; i++) {
            if (i <= n / 2)
                cat[i] = i;
            else cat[i] = n - i + 1;
            long long right = i + 1LL * cat[i] * d;
            if (right <= n)
                dr[i] = right;
            else dr[i] = n;
            long long left = i - 1LL * cat[i] * d;
            if (left > 1)
                st[i] = left;
            else st[i] = 1;
        }
    }

    int rez = -1;
    for (int pas = 1 << LOGN; pas; pas >>= 1)
        if (!ok(rez + pas))
            rez += pas;

    fprintf(fout, "%d\n", rez + 1);

    fclose(fin);
    fclose(fout);
    return 0;
}
