#include <cstdio>
#include <vector>

FILE *fin = fopen("input.txt", "r"), *fout = fopen("output.txt", "w");

#define MAXN 200000

char s[MAXN + 10];
std::vector < int > v[MAXN + 2];

int main() {
    fgets(s, MAXN + 5, fin);
    int n = 0, k = 0, p = 0;
    bool ok = 1;
    while ((s[n] == '0' || s[n] == '1') && ok) {
        if (s[n] == '1') {
            if (p >= k)
                ok = 0;
            v[p].push_back(n);
            p++;
        } else if (s[n] == '0') {
            if (p == 0) {
                v[k].push_back(n);
                k++;
            } else {
                p--;
                v[p].push_back(n);
            }
        }
        n++;
    }

    if (p != 0)
        ok = 0;

    if (ok == 0)
        fprintf(fout, "-1");
    else {
        fprintf(fout, "%d", k);
        for (int i = 0; i < k; i++) {
            fprintf(fout, "\n%u", v[i].size());
            for (auto &x : v[i])
                fprintf(fout, " %d", x + 1);
        }
    }

    fclose(fin);
    fclose(fout);
    return 0;
}
