#include <bits/stdc++.h>
#pragma optimize("O3")

using namespace std;

#define fi first
#define se second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

typedef vector<int> vint;
typedef long double ld;
typedef long long ll;
typedef string str;

const int MX = 1e6;

int num[MX], u[MX], deg[MX];
int n, m, h, timer = 1;

pair<int, int> cen[MX];
set<int> par[MX], g[MX], ans, cur;

vint in;

void solve(int v) {
    cur.insert(v);
    u[v] = timer;
    for (int to : g[v])
        if (u[to] < timer)
            solve(to);
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> num[i];
    for (int i = 0; i < m; ++i) {
        cin >> cen[i].fi >> cen[i].se;
        --cen[i].fi, --cen[i].se;
        par[cen[i].fi].insert(cen[i].se);
        par[cen[i].se].insert(cen[i].fi);
    }
    for (int i = 0; i < n; ++i) {
        for (int to : par[i]) {
            if (num[to] == (num[i] + 1) % h) {
                g[i].insert(to);
                ++deg[i];
            }
        }
    }
    for (int i = 0; i < n; ++i)
        if (deg[i] == 0)
            in.pb(i);
    for (int x : in) {
        solve(x);
        ++timer;
        if (sz(cur) && (ans.empty() || sz(cur) < sz(ans)))
            ans.swap(cur);
        cur.clear();
    }
    timer -= (sz(in) > 0);
    for (int i = 0; i < n; ++i) {
        if (u[i] == 0) {
            solve(i);
            if (sz(cur) && (ans.empty() || sz(cur) < sz(ans)))
                ans.swap(cur);
            cur.clear();
        }
    }
    cout << ans.size() << endl;
    for (int x : ans)
        cout << x + 1 <<  " ";
}
