#include<bits/stdc++.h>
#define int long long
using namespace std;
const int MAXN = 1e5 + 10;
int q[MAXN];
vector<int> g[MAXN];
vector<int> gr[MAXN];
int cnt_in[MAXN];
int cnt_out[MAXN];
int used[MAXN];
int color[MAXN];
vector<int> topsort;

void dfs(int v){
    used[v] = 1;
    for(auto to : g[v]){
        if(used[to]) continue;
        dfs(to);
    }
    topsort.push_back(v);
}

void dfs_1(int v, int clr){
    color[v] = clr;
    for(auto to : gr[v]){
        if(color[to] != -1) continue;
        dfs_1(to, clr);
    }
}

signed main(){
    //freopen("C:\\Olymp\\Stress\\test.txt", "r", stdin);
    //freopen("C:\\Olymp\\Clever\\Clever.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    for(int i = 0; i < n; i++){
        cin >> q[i];
    }
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;b--;
        if((q[a] + 1) % h == q[b]){
            g[a].push_back(b);
            gr[b].push_back(a);
            cnt_out[a]++;
            cnt_in[b]++;
        }
        if((q[b] + 1) % h == q[a]){
            g[b].push_back(a);
            gr[a].push_back(b);
            cnt_out[b]++;
            cnt_in[a]++;
        }
    }
    for(int i = 0; i < n; i++){
        if(cnt_out[i] == 0){
            cout << 1 << '\n' << i+1;
            return 0;
        }
    }
    for(int i = 0; i < n; i++){
        if(!used[i]) dfs(i);
    }
    reverse(topsort.begin(), topsort.end());
    int curcol = 0;
    memset(color, -1, sizeof(color));
    for(auto it : topsort){
        if(color[it] == -1){
            dfs_1(it, curcol++);
        }
    }
    vector<int> cnt_col(curcol);
    vector<int> out_col(curcol);
    for(int i = 0; i < n; i++){
        cnt_col[color[i]]++;
    }
    for(int i = 0; i < n; i++){
        for(auto to : g[i]){
            if(color[i] == color[to]) continue;
            out_col[color[i]]++;
        }
    }
    int ans = 1e9;
    int fincol = -1;
    for(int i = 0; i < curcol; i++){
        if(out_col[i] == 0) {
            if(ans > cnt_col[i]){
                ans = cnt_col[i];
                fincol = i;
            }
        }
    }
    cout << ans << '\n';
    for(int i = 0; i < n; i++){
        if(color[i] == fincol) cout << i + 1 << ' ';
    }
    return 0;
}
