#include<bits/stdc++.h>
#define int long long
using namespace std;
const int MAXN = 10;
const int ISTOK = 0;
const int STOK = MAXN + 1;
int G[MAXN + 2][MAXN + 2];
int used[MAXN + 2];
int ver = 0;
bool dfs(int v){
    if(v == STOK) return 1;
    used[v] = 1;
    for(int i = 0; i <= STOK; i++){
        if(G[v][i] == 0 || used[i]) continue;
        if(dfs(i)){
            G[v][i]--;
            G[i][v]++;
            return 1;
        }
    }
    return 0;
}

int flow(){
    while(dfs(ISTOK)){
        memset(used, 0, sizeof(used));
    }
}




signed main(){
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    if(p == 1) {
        vector<int> q(n);
        for(int i = 0; i < n; i++){
            cin >> q[i];
        }
        vector<int> res(n);
        for(int i = 0; i < n; i++){
            int l = -1;
            int r = i;
            while(l + 1 < r){
                int m = (l + r) / 2;
                if((i - m + d - 1) / d <= m + 1){
                    r = m;
                }
                else l = m;
            }
            res[r] += q[i];
        }
        int sum = 0;
        int ans = 0;
        for(int i = 0; i < n; i++){
            sum += res[i];
            if(sum >= b){
                sum -= b;
                ans++;
            }
        }
        cout << n - ans;
        return 0;
    }
    vector<int> sw(n);
    for(int i = 0; i < n; i++){
        int a;
        cin >> sw[i];
        a = sw[i];
        for(int j = 0; j < n; j++){
            int dist = abs(i - j);
            int tm;
            if(p == 1 || j <= n/2) tm = j + 1;
            else{
                tm = (n - j);
            }
            if(tm * d >= dist){
                for(int z = ver; z < ver + a; z++) G[z + 1][j + 1 + n * b] = 1;
            }
        }
        ver += a;
    }
    for(int i = 0; i < n * b; i++){
        G[0][i + 1] = 1;
    }
    for(int i = 0; i < n; i++){
        G[i + 1 + n*b][STOK] = b;
    }
    flow();
    int ans1 = 0;
    int ans2 = 0;
    for(int i = 0; i <= n/2; i++){
        if(G[i + 1 + n * b][STOK] != 0) ans1++;
    }
    for(int i = n/2 + 1; i < n; i++){
        if(G[i + 1 + n * b][STOK] != 0) ans2++;
    }
    cout << max(ans1, ans2);
    return 0;
}
