#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> gr, grr;
vector<int> ts;
vector<bool> used;
vector<int> comp;

void dfs1(int u) {
    used[u] = true;
    for (int v : gr[u]) {
        if (!used[v]) {
            dfs1(v);
        }
    }
    ts.push_back(u);
}

void dfs2(int u, int cc) {
    comp[u] = cc;
    for (int v : grr[u]) {
        if (comp[v] == -1) {
            dfs2(v, cc);
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    gr.resize(n);
    for (int i = 0; i < m; i++) {
        int c, d;
        cin >> d >> c;
        c--;
        d--;
        if ((a[c] + 1) % h == a[d]) {
            gr[c].push_back(d);
        }
        if ((a[d] + 1) % h == a[c]) {
            gr[d].push_back(c);
        }
    }

    grr.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j : gr[i]) {
            grr[j].push_back(i);
        }
    }

    used.resize(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(ts.begin(), ts.end());

    comp.assign(n, -1);
    int cc = 0;
    for (int u : ts) {
        if (comp[u] == -1) {
            dfs2(u, cc++);
        }
    }

    vector<int> sz(cc);
    vector<int> pout(cc);
    for (int i = 0; i < n; i++) {
        sz[comp[i]]++;
    }
    for (int u = 0; u < n; u++) {
        for (int v : gr[u]) {
            if (comp[u] != comp[v]) {
                pout[comp[u]]++;
            }
        }
    }

    int mn = n + 1;
    int cn = -1;
    for (int i = 0; i < cc; i++) {
        if (pout[i] == 0) {
            if (sz[i] < mn) {
                mn = sz[i];
                cn = i;
            }
        }
    }

    cout << mn << endl;
    for (int i = 0; i < n; i++) {
        if (comp[i] == cn) {
            cout << i + 1 << " ";
        }
    }
    cout << endl;

    return 0;
}