#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4,tune=native,popcnt")
#endif

#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3000;
const int MAXP = 12;

const int SZ = 2 * MAXN + 1;

bitset<SZ> want;

int best;
vector<int> ans;

vector<int> tk;

void gen(int p, bitset<SZ> &have) {
    if ((want | have) == have) {
        if (tk.size() < best) {
            best = tk.size();
            ans = tk;
        }
        return;
    }
    if (p > MAXP) {
        return;
    }

    // don't take
    gen(p + 1, have);

    // take +
    auto havep = have;
    havep |= have << (1 << p);
    tk.push_back(1 << p);
    gen(p + 1, havep);
    tk.pop_back();

    // take -
    auto havem = have;
    havem |= have >> (1 << p);
    tk.push_back(-(1 << p));
    gen(p + 1, havem);
    tk.pop_back();
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        want[a[i] + MAXN] = 1;
    }

    best = 1000000;
    bitset<SZ> start;
    start[MAXN] = true;
    gen(0, start);

    cout << best << endl;
    for (int i : ans) {
        cout << i << " ";
    }
    cout << endl;

    return 0;
}
