#include <bits/stdc++.h>

using namespace std;

int n, m, h, cnt =0;
vector<int> t;
vector<vector<int>> G;
vector<vector<int>> rG;
vector<set<int>> con;
vector<set<int>> con2;
vector<int> used;

void clear() { cnt++; }

bool _set(int v) { used[v] = cnt; }

bool _used(int v) { return used[v] == cnt; }

void dfs(int v, int V) {
    con[V].insert(v);
    _set(v);
    for (int to : G[v])
        if (!_used(to))
            dfs(to, V);
}

void dfs2(int v, int V) {
    if (con[V].count(v)) con2[V].insert(v);
    _set(v);
    for (int to : rG[v])
        if (!_used(to))
            dfs2(to, V);
}

int main() {
    cin >> n >> m >> h;
    G.resize(n);
    rG.resize(n);
    con.resize(n);
    con2.resize(n);
    t.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) cin >> t[i];
    int u, v;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v, u--, v--;
        if ((t[u] + 1) % h == t[v]) { G[u].push_back(v); rG[v].push_back(u); }
        if ((t[v] + 1) % h == t[u]) { G[v].push_back(u); rG[u].push_back(v); }
    }
    for (int i = 0; i < n; ++i) {
        clear();
        dfs(i, i);
    }
    for (int i = 0; i < n; ++i) {
        clear();
        dfs2(i, i);
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) ans[i] = con2[i].size();
    for (int i = 0; i < n; ++i)
        for (int to : G[i])
            if (!con2[i].count(to))
                ans[i] = n;
    int i_ans = 0, min_ans = ans[0];
    for (int i = 0; i < n; ++i)
        if (ans[i] < min_ans) {
            min_ans = ans[i];
            i_ans = i;
        }
    cout << ans[i_ans] << endl;
    for (auto i : con2[i_ans]) cout << i + 1 << ' ';
}
