#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <ctime>

using namespace std;
const int MAXN = 2e5 + 100;

int n, m, h;
int mas[MAXN];
bool used[MAXN];
vector<int> g[MAXN];
vector<int> gr[MAXN];
vector<int> st;
int ttm = 0;
vector<int> cd[MAXN];
int clr[MAXN];
bool pd[MAXN];

void dfs1(int v){
    if (used[v]){
        return;
    }

    used[v] = true;

    for (auto to : g[v]){
        dfs1(to);
    }

    st.push_back(v);
}

void dfs2(int v){
    if (used[v]){
        return;
    }

    used[v] = true;
    cd[ttm].push_back(v);
    clr[v] = ttm;

    for (auto to : gr[v]){
        dfs2(to);
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> h;

    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    for (int i = 0; i < m; ++i){
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;

        if ((mas[v1] + 1) % h == mas[v2]){
            g[v1].push_back(v2);
            gr[v2].push_back(v1);
        }

        if ((mas[v2] + 1) % h == mas[v1]){
            g[v2].push_back(v1);
            gr[v1].push_back(v2);
        }
    }

    fill(used, used + n, false);
    for (int i = 0; i < n; ++i){
        dfs1(i);
    }


    reverse(st.begin(), st.end());
    fill(used, used + n, false);

    for (auto e : st){
        if (!used[e]){
            dfs2(e);
            ttm++;
        }
    }

    fill(pd, pd + n, true);

    for (int i = 0; i < n; ++i){
        for (auto j : g[i]){
            if (clr[i] != clr[j]){
                pd[clr[i]] = false;
            }
        }
    }

    pair<int, int> ans = {n, 0};

    for (int i = 0; i < n; ++i){
        if (pd[clr[i]]){
            ans = min(ans, {cd[clr[i]].size(), clr[i]});
        }
    }

    cout << cd[ans.second].size() << endl;
    for (auto e : cd[ans.second]){
        cout << e + 1 << ' ';
    }
    cout << endl;

    return 0;
}
