#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <ctime>

using namespace std;
const int MAXN = 1e5 + 100;

int p, n, d, b;
int mas[MAXN];

bool mnr(long long a, long long b, long long c){
    return a <= b * c;
}

int f(int k, int s){
    int cs = 0;
    int r = 0;
    int ca = 0;
    int ss = 0;
    for (int i = 0; i < k; ++i){
        while ((r < n) && (mnr(r - i, d, i + 1))){
            if (ss + mas[r] <= s){
                cs += mas[r];
                ss += mas[r];
                r++;
            } else {
                cs += s - ss;
                ss += s - ss;
                break;
            }
        }

        if (cs >= b){
            ca++;
            cs -= b;
        }
    }

    return k - ca;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> p >> n >> d >> b;
    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    if (p == 1){
        cout << f(n, n * b) << endl;
    } else {
        int mas2[MAXN];

        for (int i = 0; i < n; ++i){
            mas2[i] = mas[n - i - 1];
        }

        int l = 0;
        int r = n * b + 1;

        while (l + 1 < r){
            int m = (l + r) / 2;

            int l1 = f((n + 1) / 2, m);
            swap(mas, mas2);
            int l2 = f(n / 2, n * b - m);
            swap(mas, mas2);

            //cout << m << ' ' << l1 << ' ' << l2 << endl;

            if (l1 >= l2){
                l = m;
            } else {
                r = m;
            }
        }

        //cout << l << endl;
        int l1 = f((n + 1) / 2, l);
        swap(mas, mas2);
        int l2 = f(n / 2, n * b - l);
        swap(mas, mas2);

        cout << max(l1, l2) << endl;
    }

    return 0;
}
