#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

int gcd(int a, int b) {
    while (a && b) {
        if (a < b)
            b %= a;
        else
            a %= b;
    }
    return a + b;
}

vector<int> get(int a) {
    vector<int> tmp;
    int c = a;
    while (c) {
        tmp.push_back(c & 1);
        c >>= 1;
    }
    reverse(all(tmp));
    vector<int> res;
    for (int i = 0; i < size(tmp); ++i)
        if (tmp[i])
            res.push_back(1 << i);
    return res;
}

int main() {
   // freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int a;
    cin >> a;
    if (a < 0) {
        auto x = get(-a);
        cout << size(x) << endl;
        for (auto u : x)
            cout << "-" << u << ' ';
    } else if (!a) {
        cout << "2\n1 -1";
    } else {
        auto x = get(a);
        cout << size(x) << endl;
        for (auto u : x)
            cout << u << ' ';
    }
    return 0;
}