#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

vector<int> g(int a) {
    vector<int> tmp;
    while (a) {
        tmp.push_back(a & 1);
        a >>= 1;
    }
    reverse(all(tmp));
    vector<int> res;
    for (int i = 0; i < size(tmp); ++i)
        if (tmp[i])
            res.push_back(1 << i);
    return res;
}

vector<int> ans(int a) {
    int t = 1;
    while (t < a)
        t <<= 1;
    if (a == t)
        return { t };
    auto x = g(a), y = g(t - a);
    if (size(x) < size(y) + 1)
        return x;
    for (auto &u : y)
        u *= -1;
    y.push_back(t);
    return y;
}

int main() {
    //freopen("inp2.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> n;
    if (!n) {
        cout << 0;
        return 0;
    }
    int sgn = n < 0 ? -1 : 1;
    n = abs(n);
    auto x = ans(n);
    cout << size(x) << '\n';
    for (auto u : x)
        cout << u * sgn << ' ';
    return 0;
}