#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

vector<int> g(int a) {
    vector<int> tmp;
    while (a) {
        tmp.push_back(a & 1);
        a >>= 1;
    }
    reverse(all(tmp));
    vector<int> res;
    for (int i = 0; i < size(tmp); ++i)
        if (tmp[i])
            res.push_back(1 << i);
    return res;
}

vector<int> t(int a) {
    int t = 1;
    while (t < a)
        t <<= 1;
    if (a == t)
        return { t };
    auto x = g(a), y = g(t - a);
    if (size(x) < size(y) + 1)
        return x;
    for (auto &u : y)
        u *= -1;
    y.push_back(t);
    return y;
}

int main() {
    //freopen("inp2.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> ans;
    while(n--) {
        int a;
        cin >> a;
        if (!a)
            continue;
        int sgn = a > 0 ? 1 : -1;
        a = abs(a);
        auto x = t(a);
        for (auto u : x)
            ans.push_back(u * sgn);
     //   sort(all(ans));
       // ans.erase(unique(all(ans)), ans.end());
    }
    cout << size(ans) << endl;
    for (auto u : ans)
        cout << u << ' ';
    return 0;
}