#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

int gcd(int a, int b) {
    while (a && b) {
        if (a < b)
            b %= a;
        else
            a %= b;
    }
    return a + b;
}

string s;
int len;
vector<vector<int>> ans;

void die() {
    cout << "-1";
    exit(0);
}

int main() {
   // freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> s;
    len = size(s);
    set<int> nice, wo;
    for (int i = 0; i < len; ++i) {
        if (s[i] == '0') {
            if (wo.empty()) {
                nice.insert(size(ans));
                ans.push_back({ i });
            } else {
                int u = *wo.begin();
                wo.erase(wo.begin());
                ans[u].push_back(i);
                nice.insert(u);
            }
        } else {
            if (nice.empty())
                die();
            int u = *nice.begin();
            nice.erase(nice.begin());
            wo.insert(u);
            ans[u].push_back(i);
        }
    }
    if (!wo.empty())
        die();
    cout << size(ans) << '\n';
    for (int i = 0; i < size(ans); ++i) {
        cout << size(ans[i]) << ' ';
        for (auto u : ans[i])
            cout << u + 1 << ' ';
        cout << '\n';
    }
    return 0;
}