#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

#define F first
#define S second

#define en end()
#define bg begin()

#define mp make_pair
#define pb push_back

#define rev reverse
#define y1 y0123456789
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x) * 1ll * (x))
#define sqrd(x) ((x) * 1.0 * (x))

#define forn(i, x) for (int i = 1; i <= x; i++)

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int N = 100500;

bool bad[N];
map < int, bool > us[N];
vector < int > ord, g[N], gr[N], vec[N];
int n, m, h, col, u[N], a[N], cnt[N], e[N][3];

void dfs(int v) {
	u[v] = 1;
	for (auto to : g[v])
		if (!u[to])
			dfs(to);
	ord.pb(v);
}

void dfs1(int v) {
	u[v] = col;
	cnt[col]++;
	//cerr << v << " ";
	for (auto to : gr[v])
		if (!u[to])
			dfs1(to);
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//srand(time(NULL));
	
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;

	cin >> n >> m >> h;

	for (int i = 1; i <= n; i++)
		cin >> a[i];

	for (int i = 1; i <= n; i++) {
		cin >> e[i][1] >> e[i][2];
		vec[e[i][1]].pb(i);
		vec[e[i][2]].pb(i);
	}

	for (int i = 1; i <= n; i++) {
		for (auto j : vec[i]) {
			if (e[j][1] == i && (a[i] + 1) % h == a[e[j][2]]) {
				if (!us[i].count(e[j][2])) {
					g[i].pb(e[j][2]);
					gr[e[j][2]].pb(i);
					us[i][e[j][2]] = 1;
					//cerr << "edge " << i << " -> " << j << endl;
				}
			}
			if (e[j][2] == i && (a[i] + 1) % h == a[e[j][1]]) {
				if (!us[i].count(e[j][1])) {
					g[i].pb(e[j][1]);
					gr[e[j][1]].pb(i);
					us[i][e[j][1]] = 1;
					//cerr << "edge " << i << " -> " << j << endl;
				}
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		if (!u[i])
			dfs(i);
	}

	rev(all(ord));

	memset(u, 0, sizeof(u));

	for (auto v : ord) {
		if (!u[v]) {
			col++;
			dfs1(v);
		}
	}

	for (int i = 1; i <= n; i++) {
		for (auto j : g[i]) {
			if (u[i] != u[j])
				bad[u[i]] = 1;
		}
	}

	int best = -1;

	for (int i = 1; i <= col; i++)
		if (!bad[i] && (best == -1 || cnt[i] < cnt[best]))
			best = i;

	cout << cnt[best] << endl;

	for (int i = 1; i <= n; i++)
		if (u[i] == best)
			cout << i << " ";

	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
