#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const int MAXN = 1e5;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int p;
    cin >> p;

    if (p == 1) {
        int n, d, b;
        cin >> n >> d >> b;

        vii a(n), pref(n);
        forn(i, n) cin >> a[i], (i == 0 ? pref[i] = a[i] : pref[i] = pref[i - 1] + a[i]);

        int comp = 0;
        forn(i, n) {
            if (pref[min(n - 1, i + d * (i + 1))] - comp * b >= b)
                comp++;
        }

        cout << n - comp;
    }
    else {
        int n, d, b;
        cin >> n >> d >> b;

        vii a(n), pref(n);
        forn(i, n) cin >> a[i], (i == 0 ? pref[i] = a[i] : pref[i] = pref[i - 1] + a[i]);

        int comp = 0;
        forn(i, n / 2) {
            if (pref[min(n - 1, i + d * (i + 1))] - comp / 2 * b >= b && pref[n - 1] - (n - 1 - i - d * (i + 1) - 1 < 0 ? 0 : pref[max(0, n - 1 - i - d * (i + 1) - 1)]) - comp / 2 * b >= b)
                comp += 2;
        }

        cout << n / 2 - comp / 2;
    }

    return 0;
}