#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <stack>
#include <deque>
#include <iterator>
#include <functional>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <bitset>
#include <cinttypes>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define sqr(x) ((x)*(x))
#define cube(x) (sqr(x)*(x))
#define mp make_pair
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vii vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvii vector<vii>
#define vvll vector<vll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define forn(i,n) for(int i=0;i<n;i++)
#define forab(i,a,b) for(int i=a;i<=b;i++)
#define fornout(i,n,c) for(int i=0;i<n;i++,cout<<c)

const ld PI = acos(-1);
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const int MAXN = 1e5;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    int n = s.length();
    vpii a(n);
    vii nul;
    vii remforw(n, -1);
    set <int> nl;
    forn(i, n)
        if (s[i] == '0')
            nul.pb(i), nl.insert(i);

    int dec = 0;
    forn(i, n) {
        if (s[i] == '0')
            a[i] = mp(-1, -1);
        else {
            if (dec == nul.size()) {
                cout << -1;
                return 0;
            }
            if (nl.upper_bound(i) == nl.end()) {
                cout << -1;
                return 0;
            }
            if (i < nul[dec]) {
                cout << -1;
                return 0;
            }
            a[i] = mp(nul[dec], *nl.upper_bound(i));
            remforw[nul[dec++]] = i;
            nl.erase(nl.upper_bound(i));
        }
    }

    vvii ans;
    vii remem(n);
    set <int> usago;
    forn(i, n) {
        if (remforw[i] == -1) {
            if (usago.find(i) == usago.end()) {
                ans.push_back(vii(1, i));
                remforw[i] = -3;
            }
            else {
                ans[remem[i]].push_back(i);
                usago.erase(i);
                remforw[i] = -3;
            }
        }
        else if (remforw[i] >= 0) {
            if (usago.find(i) == usago.end()) {
                ans.push_back(vii(0));
                usago.insert(a[remforw[i]].second);
                remem[a[remforw[i]].second] = ans.size() - 1;
                ans[ans.size() - 1].push_back(i);
                ans[ans.size() - 1].push_back(remforw[i]);
                remforw[remforw[i]] = -3;
                remforw[i] = -3;
            }
            else {
                usago.insert(a[remforw[i]].second);
                usago.erase(i);
                remem[a[remforw[i]].second] = remem[i];
                ans[remem[i]].push_back(i);
                ans[remem[i]].push_back(remforw[i]);
                remforw[remforw[i]] = -3;
                remforw[i] = -3;
            }
        }
    }

    cout << ans.size() << '\n';
    fornout(i, ans.size(), '\n') {
        cout << ans[i].size() << ' ';
        fornout(j, ans[i].size(), ' ')
            cout << ans[i][j] + 1;
    }

    return 0;
}