#include <bits/stdc++.h>

using namespace std;

#define time time179

vector<vector<int> > gr;
vector<bool> used;
vector<int> tin;
int time = 0;
vector<vector<int > > gr2;
vector<int> color;

void dfs(int x)
{
    if (used[x]) return;
    used[x] = true;
    for (int i = 0; i < gr[x].size(); ++i)
    {
        dfs(gr[x][i]);
    }
    tin[x] = time++;
}

void dfs2(int x)
{
    for (int i = 0; i < gr2[x].size(); ++i)
    {
        if (color[gr2[x][i]] == -1)
        {
            color[gr2[x][i]] = color[x];
            dfs2(gr2[x][i]);
        }
    }
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (int i = 0; i < n; ++i) cin >> u[i];
    gr.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if ((u[a] + 1) % h == u[b])
        {
            gr[a].push_back(b);
        }
        if ((u[b] + 1) % h == u[a])
        {
            gr[b].push_back(a);
        }
    }
    used.resize(n, false);
    tin.resize(n, -1);
    for (int i = 0; i < n; ++i)
    {
        if (!used[i]) {
            dfs(i);
        }
    }
    vector<pair<int, int> > all;
    for (int i = 0; i < n; ++i)
    {
        all.push_back({-tin[i], i});
    }
    sort(all.begin(), all.end());
    gr2.resize(n);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < gr[i].size(); ++j)
        {
            gr2[gr[i][j]].push_back(i);
        }
    }
    int col = 0;
    color.resize(n, -1);
    for (int i = 0; i < n; ++i)
    {
        if (color[all[i].second] == -1)
        {
            color[all[i].second] = col++;
            dfs2(all[i].second);
        }
    }
    vector<bool> good(col, true);
    vector<int> sz(col, 0);
    for (int i = 0; i < n; ++i)
    {
        ++sz[color[i]];
        for (int j = 0; j < gr[i].size(); ++j)
        {
            if (color[i] != color[gr[i][j]])
            {
                good[color[i]] = false;
            }
        }
    }
    int MIN = 1000000000;
    int ind = -1;
    for (int i = 0; i < sz.size(); ++i)
    {
        if (sz[i] < MIN && good[i])
        {
            MIN = sz[i];
            ind = i;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i)
    {
        if (color[i] == ind) ans.push_back(i + 1);
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) cout << ans[i] << " ";
    cout << endl;

}
