#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100005;

int n, m, a[MAXN], b[MAXN];
vector<int> cards, sub, ans;

void Check()
{
    int pos = 0, neg = 0;
    b[MAXN / 2] = 1;
    for (int i = 0; i < sub.size(); ++ i)
    {
        if (sub[i] > 0)
        {
            pos += sub[i];
            for (int j = pos; j >= neg; -- j)
            {
                if (b[MAXN / 2 + j - sub[i]] == 1) b[MAXN / 2 + j] = 1;
            }
        }
        if (sub[i] < 0)
        {
            neg += sub[i];
            for (int j = neg; j <= pos; ++ j)
            {
                if (b[MAXN / 2 + j - sub[i]] == 1) b[MAXN / 2 + j] = 1;
            }
        }
    }

    bool ch = true;
    for (int i = 1; i <= n; ++ i)
    {
        if (b[MAXN / 2 + a[i]] == 0) ch = false;
    }
    if (ch and (ans.size() == 0 or (ans.size() > sub.size()))) ans = sub;

    for (int i = neg; i <= pos; ++ i)
    {
        b[MAXN / 2 + i] = 0;
    }
}

void Rec(int x = 0)
{
    if (x == cards.size())
    {
        Check();
        return;
    }

    Rec(x + 1);
    sub.push_back(cards[x]);
    Rec(x + 1);
    sub.pop_back();
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        m = max(m, a[i]);
    }

    int x = 1;
    while (x <= 256)
    {
        cards.push_back(+x);
        cards.push_back(-x);
        x <<= 1;
    }
//    if ((x & (-x)) != 0)
//    {
//        cards.push_back(+x);
//        cards.push_back(-x);
//    }

    Rec();

    cout << ans.size() << endl;
    for (int e : ans)
    {
        cout << e << ' ';
    }
    cout << endl;
    return 0;
}
