#include <bits/stdc++.h>

using namespace std;
vector<vector<int> > graph;
vector<int> arr;
vector<bool> used;
vector<int> c;
vector<bool> l;

bool dfs(int v, int t)
{
    c[v] = t;
    bool res = true;
    for (int i = 0; i < graph[v].size(); i++)
    {
        int u = graph[v][i];
        if (c[u] == -1)
        {
            res = res && dfs(u, t);
        }
        else if (c[u] != c[v])
        {
            res = false;
        }
    }
    return res;
}

void f(int v)
{
    used[v] = true;
    for (int i = 0; i < graph[v].size(); i++)
    {
        int u = graph[v][i];
        if (!used[u])
            f(u);
    }
    arr.push_back(v);
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t;
    t.resize(n);
    graph.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i];
    }
    map <pair<int, int>, bool> q;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (!q[make_pair(a, b)])
        {
            q[make_pair(a, b)] = true;
            q[make_pair(b, a)] = true;
            if ((t[a] + 1) % h == t[b])
            {
                graph[a].push_back(b);
            }
            if ((t[b] + 1) % h == t[a])
                graph[b].push_back(a);
        }
    }
    used.resize(n, false);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            f(i);
        }
    }
    c.resize(n, -1);
    l.resize(n, false);
    int time_ = 0;
    for (int i = 0; i < n; i++)
    {
        if (c[arr[i]] == -1)
        {
            l[time_] = dfs(arr[i], time_);
            time_++;
        }
    }
    int a[time_];
    for (int i = 0; i < time_; i++)
        a[i] = 0;
    for (int i = 0; i < n; i++)
    {
        a[c[i]]++;
    }
    int min_ = 1e9;
    int res = -1;
    for (int i = 0; i < time_; i++)
    {
        if (l[i] && a[i] < min_)
        {
            min_ = a[i];
            res = i;
        }
    }
    cout << a[res] << endl;
    for (int i = 0; i < n; i++)
    {
        if (c[i] == res)
        {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return 0;
}
