#include <bits/stdc++.h>

using namespace std;
vector<vector<int> > graph;
vector<vector<int> > graph1;
vector<int> arr;
vector<bool> used;
vector<int> c;
vector<bool> l;

void dfs(int v, int t)
{
    c[v] = t;
    for (int i = 0; i < graph1[v].size(); i++)
    {
        int u = graph1[v][i];
        if (c[u] == -1)
        {
            dfs(u, t);
        }
    }
    return;
}

void f(int v)
{
    used[v] = true;
    for (int i = 0; i < graph[v].size(); i++)
    {
        int u = graph[v][i];
        if (!used[u])
            f(u);
    }
    arr.push_back(v);
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t;
    t.resize(n);
    graph.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i];
    }
    map <pair<int, int>, bool> q;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (!q[make_pair(a, b)])
        {
            q[make_pair(a, b)] = true;
            q[make_pair(b, a)] = true;
            if ((t[a] + 1) % h == t[b])
            {
                graph[a].push_back(b);
            }
            if ((t[b] + 1) % h == t[a])
                graph[b].push_back(a);
        }
    }
    /*for (int i = 0; i < n; i++)
    {
        cout << i << " : ";
        for (int j = 0; j < graph[i].size(); j++)
            cout << graph[i][j] << " ";
        cout << endl;
    }*/
    used.resize(n, false);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            f(i);
        }
    }
    graph1.resize(n);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < graph[i].size(); j++)
        {
            graph1[graph[i][j]].push_back(i);
        }
    }
    /*for (int i = 0; i < n; i++)
    {
        cout << i << " : ";
        for (int j = 0; j < graph1[i].size(); j++)
            cout << graph1[i][j] << " ";
        cout << endl;
    }*/
    c.resize(n, -1);
    l.resize(n, true);
    int time_ = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        if (c[arr[i]] == -1)
        {
            dfs(arr[i], time_);
            time_++;
        }
    }
    /*for (int i = 0; i < arr.size(); i++)
        cout << arr[i] << " ";
    cout << endl;
    for (int i = 0; i < n; i++)
        cout << c[i] << " ";
    cout << endl;*/
    int a[time_];
    for (int i = 0; i < time_; i++)
        a[i] = 0;
    for (int i = 0; i < n; i++)
    {
        a[c[i]]++;
    }
    int min_ = 1e9;
    int res = -1;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < graph[i].size(); j++)
        {
            if (c[graph[i][j]] != c[i])
                l[c[i]] = false;
        }
    }
    for (int i = 0; i < time_; i++)
    {
        if (l[i] && a[i] < min_)
        {
            min_ = a[i];
            res = i;
        }
    }
    cout << a[res] << endl;
    for (int i = 0; i < n; i++)
    {
        if (c[i] == res)
        {
            cout << i + 1 << " ";
        }
    }
    cout << endl;
    return 0;
}
/*
12 14 4
0 1 2 3 2 3 0 1 3 0 1 2
1 2
2 3
3 4
1 4
2 5
6 5
7 6
8 7
5 8
3 9
9 10
10 11
11 12
12 9
*/
