#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100001;

set<int> g[MAXN];

int h[MAXN];
bool used[MAXN];
bool printUsed[MAXN];

void print(int v) {
    printUsed[v] = true;
    for(int e : g[v]) {
        if(!printUsed[e])
            print(e);
    }
    cout << v + 1 << " ";
}

int calcSize(int v) {
    used[v] = true;
    int res = 1;
    for(int e : g[v])
        if(!used[e])
            res += calcSize(e);
    return res;
}

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    int n, m, H;
    cin >> n >> m >> H;

//    assert(n == 10 || n <= 5);

    for(int i = 0; i < n; ++i)
        cin >> h[i];

    int u, v;
    for(int i = 0; i < m; ++i) {
        cin >> u >> v;
        u--, v--;
        if((h[u] + 1) % H == h[v])
            g[u].insert(v);
        if((h[v] + 1) % H == h[u])
            g[v].insert(u);
    }

    for(int i = 0; i < n; ++i) {
        if(g[i].size() == 0) {
            cout << 1 << "\n";
            cout << i + 1;
            return 0;
        }
    }

    int ans = INT_MAX;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j)
            used[j] = 0;
        int cur = calcSize(i);
        if(cur < ans) {
            ans = cur;
            v = i;
        }
    }

    cout << ans << "\n";
    print(v);
}