#include <bits/stdc++.h>

using namespace std;

#define ss second
#define ff first
typedef long long ll;

int solve();

int main(){
#ifdef home
    freopen ("input.txt", "r", stdin);
#endif // home

    solve();
}

const int MAXN = (int)1e5 + 7;

int n, a[MAXN], x, y, m, h, p[MAXN], rnk[MAXN], cnt[MAXN], ans = MAXN, num;
vector <int> g[MAXN];

int get(int a){
    return (a == p[a] ? a : p[a] = get(p[a]));
}

void union_dsu (int a, int b){
    a = get(a), b = get(b);
    if (a == b) return;

    if (rnk[a] > rnk[b]) p[b] = a;
    else if (rnk[b] > rnk[a]) p[a] = b;
    else p[a] = b, rnk[b]++;
}

int solve(){

    cin >> n >> m >> h;

    for (int i = 1; i <= n; ++i) cin >> a[i];

    for (int i = 0; i < m; ++i){
        cin >> x >> y;
        if ((a[x] + 1) % h == a[y]) g[x].push_back(y);
        if ((a[y] + 1) % h == a[x]) g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i){
        if (!g[i].size()){
            cout << "1\n" << i << "\n";
            return 0;
        }
    }

    for (int i = 1; i <= n; ++i) p[i] = i, rnk[i] = 1;

    for (int i = 1; i <= n; ++i){
        for (auto u : g[i]) union_dsu(i, u);
    }

    for (int i = 1; i <= n; ++i) cnt[get(i)]++;

    for (int i = 1; i <= n; ++i)
        if (cnt[get(i)] && cnt[get(i)] < ans){
            ans = cnt[get(i)];
            num = get(i);
        }
    cout << ans << "\n";
    for (int i = 1; i <= n; ++i)
        if (get(i) == num) cout << i << ' ';

    return 0;
}
