#ifndef home
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unroll-all-loops")
#pragma GCC target("abm,mmx,popcnt,avx,tune=native,sse,sse2")
#endif

//#include <bits/extc++.h>
#include <ext/numeric>
#include <iomanip>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <bitset>
#include <deque>
#include <map>
#include <iostream>
#include <queue>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <climits>
#include <tuple>
#include <cassert>

using namespace __gnu_cxx;
using namespace std;
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define foru(i, l, r) for(auto i=l;i<r;++i)
#define forn(i, n) foru(i,0,n)
#define ford(i, r, l) for(auto i=r;i>=l;--i)
#define bcnt __builtin_popcount
using ll = long long;
using lint = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
const int inf = INT_MAX;
const ll linf = LLONG_MAX;
template<class X, class C=less<X>, class Y=__gnu_pbds::null_type> using ordered_set=
__gnu_pbds::tree<X, Y, C, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<class X, class C=greater<X>> using heap=__gnu_pbds::priority_queue<X, C>;

template<class X>
inline void mini(X &x, X y) {
    if (x > y)x = y;
}

template<class X>
inline void maxi(X &x, X y) {
    if (x < y)x = y;
}

//#define fast_memory 2e8
#ifdef fast_memory
char allmem[(size_t) fast_memory];
size_t allpos;

inline void *operator new(size_t n) {
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (size_t) fast_memory);
    return (void *) res;
}

inline void operator delete(void *)noexcept {}

inline void operator delete(void *, size_t)noexcept {}

#endif

int u[100020];
vector<int> g[100020];
int was[100030];
int c;
int cnt;

void dfs(int v) {
    if (was[v] == c)return;
    cnt++;
    was[v] = c;
    for (auto x:g[v])dfs(x);
}

void print(int v) {
    if (was[v] == c)return;
    cout << v + 1 << ' ';
    was[v] = c;
    for (auto x:g[v])print(x);
}

int main() {
#ifdef home
    assert(freopen("../input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(11) << fixed;
    int n, m, h;
    cin >> n >> m >> h;
    forn(i, n)cin >> u[i];
    forn(i, m) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if ((u[x] + 1) % h == u[y])g[x].push_back(y);
        if ((u[y] + 1) % h == u[x])g[y].push_back(x);
    }
    int ans = inf, v;
    forn(i, n) {
        c++;
        cnt = 0;
        dfs(i);
        if (ans > cnt) {
            ans = cnt;
            v = i;
        }
    }
    c++;
    cout << ans << '\n';
    print(v);
    return 0;
}
