#ifndef home
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unroll-all-loops")
#pragma GCC target("abm,mmx,popcnt,avx,tune=native,sse,sse2")
#endif

//#include <bits/extc++.h>
#include <ext/numeric>
#include <iomanip>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <bitset>
#include <deque>
#include <map>
#include <iostream>
#include <queue>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <climits>
#include <tuple>
#include <cassert>

using namespace __gnu_cxx;
using namespace std;
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define foru(i, l, r) for(auto i=l;i<r;++i)
#define forn(i, n) foru(i,0,n)
#define ford(i, r, l) for(auto i=r;i>=l;--i)
using ll = long long;
using lint = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
const int inf = INT_MAX;
const ll linf = LLONG_MAX;
template<class X, class C=less<X>, class Y=__gnu_pbds::null_type> using ordered_set=
__gnu_pbds::tree<X, Y, C, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<class X, class C=greater<X>> using heap=__gnu_pbds::priority_queue<X, C>;

template<class X>
inline void mini(X &x, X y) {
    if (x > y)x = y;
}

template<class X>
inline void maxi(X &x, X y) {
    if (x < y)x = y;
}

//#define fast_memory 2e8
#ifdef fast_memory
char allmem[(size_t) fast_memory];
size_t allpos;

inline void *operator new(size_t n) {
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (size_t) fast_memory);
    return (void *) res;
}

inline void operator delete(void *)noexcept {}

inline void operator delete(void *, size_t)noexcept {}

#endif
const int lim = (1 << 9);
bool dp[lim][lim], dp0[lim][lim];
int u1[lim], u2[lim];
int c;

int main() {
#ifdef home
    assert(freopen("../input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(11) << fixed;
    int n;
    cin >> n;
    forn(i, lim) forn(j, lim)dp0[i][j] = true;
    forn(ii, n) {
        int a;
        cin >> a;
        if (a > 0)
            forn(d, lim - a) {
                forn(m1, lim) forn(m2, lim) {
                        if (((a + d) & m1) == a + d && (d & m2) == d) {
                            dp[m1][m2] = true;
                        }
                    }
            }
        else
            forn(d, a + lim) {
                forn(m1, lim) forn(m2, lim) {
                        if (((-a + d) & m2) == -a + d && (d & m1) == d) {
                            dp[m1][m2] = true;
                        }
                    }
            }
        forn(i, lim) forn(j, lim)dp[i][j] &= dp0[i][j];
        swap(dp, dp0);
        memset(dp, 0, sizeof(dp));
    }
//    forn(i, 8) {
//        forn(j, 8)cout << dp0[i][j] << ' ';
//        cout << '\n';
//    }
    int m1, m2, ans = inf;
    forn(i, lim) forn(j, lim) {
            if (dp0[i][j] && __builtin_popcount(i) + __builtin_popcount(j) < ans) {
                ans = __builtin_popcount(i) + __builtin_popcount(j);
                m1 = i;
                m2 = j;
            }
        }
    cout << ans << '\n';
    for (int i = 1; i < lim; i *= 2) {
        if (m1 & i)cout << i << ' ';
        if (m2 & i)cout << -i << ' ';
    }

    return 0;
}