#ifndef home
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unroll-all-loops")
#pragma GCC target("abm,mmx,popcnt,avx,tune=native,sse,sse2")
#endif

//#include <bits/extc++.h>
#include <ext/numeric>
#include <iomanip>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <bitset>
#include <deque>
#include <map>
#include <iostream>
#include <queue>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <climits>
#include <tuple>
#include <cassert>

using namespace __gnu_cxx;
using namespace std;
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define foru(i, l, r) for(auto i=l;i<r;++i)
#define forn(i, n) foru(i,0,n)
#define ford(i, r, l) for(auto i=r;i>=l;--i)
using ll = long long;
using lint = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<class X, class C=less<X>, class Y=__gnu_pbds::null_type> using ordered_set=
__gnu_pbds::tree<X, Y, C, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<class X, class C=greater<X>> using heap=__gnu_pbds::priority_queue<X, C>;

template<class X>
inline void mini(X &x, X y) {
    if (x > y)x = y;
}

template<class X>
inline void maxi(X &x, X y) {
    if (x < y)x = y;
}

//#define fast_memory 2e8
#ifdef fast_memory
char allmem[(size_t) fast_memory];
size_t allpos;

inline void *operator new(size_t n) {
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (size_t) fast_memory);
    return (void *) res;
}

inline void operator delete(void *)noexcept {}

inline void operator delete(void *, size_t)noexcept {}

#endif
int pr[200002], id[200002];

int main() {
#ifdef home
    assert(freopen("../input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(11) << fixed;
    string s;
    cin >> s;
    forn(i, sz(s))pr[i] = -1;
    set<int> o, z;
    forn(i, sz(s)) {
        if (s[i] == '0') {
            if (!o.empty()) {
                pr[i] = *o.begin();
                o.erase(o.begin());
            }
            z.insert(i);
        } else {
            if (z.empty()) {
                cout << -1;
                return 0;
            }
            pr[i] = *z.begin();
            z.erase(z.begin());
            o.insert(i);
        }
    }
    if (!o.empty()) {
        cout << -1;
        return 0;
    }
    vector<vector<int>> ans;
    forn(i, sz(s)) {
        if (pr[i] == -1) {
            id[i] = sz(ans);
            ans.emplace_back(1, i + 1);
        } else {
            id[i] = id[pr[i]];
            ans[id[pr[i]]].push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto &v:ans) {
        cout << v.size();
        for (auto x:v)cout << ' ' << x;
        cout << '\n';
    }
    return 0;
}
