#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef long ll;
template<class A>void addlog(A a)
{cerr<<a<<endl;}
template<class A,class... B>void
addlog(A a,B... b){cerr<<a<<' ';addlog(b...);}

const ll MAX_N = 1e5 + 1024;
ll N, M, H;
ll u[MAX_N], c1[MAX_N], c2[MAX_N];

void start () {
    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> N >> M >> H;
    for (ll i = 0; i < N; ++ i) cin >> u[i];
    for (ll i = 0; i < M; ++ i) {
        cin >> c1[i] >> c2[i];
        -- c1[i]; -- c2[i];
    }
}

bool check (ll mask) {
    assert(mask > 0);
    bitset<64> on(mask);
                                                        //addlog("checking", on);
    bool result = true;
    for (ll i = 0; i < 64; ++ i)
    if (on[i]) u[i] = (u[i] + 1) % H;
                                                        //addlog("u[] =", u[0], u[1]);
    for (ll i = 0; i < M; ++ i) {
        ll t1 = u[c1[i]];
        ll t2 = u[c2[i]];
        if (t1 == t2)
            result = false;
    }

    for (ll i = 0; i < 64; ++ i)
    if (on[i]) u[i] = (u[i] + H - 1) % H;
                                                        //addlog("Result", result);
    return result;
}

int main () {
    start();

    const ll MAX_MASK = (1L << N);
    ll bestK = 1e9 - 1;
    ll bestMask = 0;

    for (ll mask = 1; mask < MAX_MASK; ++ mask) {
        //addlog(bitset<64>(mask)); // shifted
        if (check(mask)) {
            ll currentK = __builtin_popcount(mask);
            if (currentK < bestK) {
                bestK = currentK;
                bestMask = mask;
            }
        }
    }

    cout << bestK << endl;
    bitset<64> answer(bestMask);

    for (ll i = 0; i < 20; ++ i)
        if (answer[i])
            cout << i + 1 << ' ';
    cout << endl;
    return 0;
}
