#pragma GCC optimize("Ofast")
#define NDEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef long long ll;
template<class A>void addlog(A a)
{cerr<<a<<endl;}
template<class A,class... B>void
addlog(A a,B... b){cerr<<a<<' ';addlog(b...);}

const ll MAX_MEM = 4e8;
char mem[MAX_MEM];
char* curMem = mem;

void *operator new (size_t n) {
    char *res = curMem;
    curMem += n;
    return (void *)res;
}
void operator delete (void *) noexcept {}
void operator delete (void *, size_t) {}

const ll MAX_N = 2e5 + 19;
ll used[MAX_N], nextDiff[MAX_N], prevDiff[MAX_N];
vector< vector<ll> > answer;
string s;
ll N, nUsed = 0;
void start () {
    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> s; fill(all(nextDiff), MAX_N - 1);
    N = s.size();

    for (ll i = N - 2; i >= 0; -- i) {
        if (s[i] == s[i + 1])
            nextDiff[i] = nextDiff[i + 1];
        else
            nextDiff[i] = i + 1;
    }
}

int main () {
    start();

    addlog(N);

    ll lastFirst = 0;

    while (nUsed < N) {
        ll lastNUsed = nUsed;
        vector<ll> curAnswer;

        ll curFirst = -1;

        char need = '0'; ll lastSet = -1;
        for (ll i = lastFirst; i < N; ++ i)
        if ((!used[i]) && (s[i] == need)) {
            if (curFirst == -1) curFirst = i;
            used[i] = true; ++ nUsed; lastSet = i;
            curAnswer.push_back(i);
            need ^= 1; i = nextDiff[i] - 1;
        }
        lastFirst = curFirst;

        if ((curAnswer.size() > 0) && ((curAnswer.size() & 1) == 0)) {
            curAnswer.pop_back();
            used[lastSet] = false;
            -- nUsed;
        }

        if (nUsed == lastNUsed) {
            cout << -1 << endl;
            return 0;
        } else {
            answer.push_back(curAnswer);
        }
    }

    cout << answer.size() << '\n';
    for (auto &v : answer) {
        cout << v.size() << ' ';
        for (auto i : v)
            cout << i + 1 << ' ';
        cout << '\n';
    }
    return 0;
}
