#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 1e5, INF = 1e9;

int p, n, d, b, opt;

int f1(deque<pair<int, int>> &q1) {
    int ans1 = 0;
    for(int j = 0; j < (n + 1) / 2; j++) {
                    int x = 0;
                    bool succ = false;
                    for(int y = 0; y < sz(q1) && x < b && (abs(q1[y].first - j) + d - 1) / d <= j + 1; y++) {
                        if(x + q1[y].second < b) x += q1[y].second;
                        else {
                            succ = true;
                            x = b;
                        }
                    }
                    if(!succ) {
                        if(++ans1 >= opt) break;
                        continue;
                    }
                    x = 0;
                    while(x < b) {
                        if(x + q1.front().second < b) x += q1.front().second, q1.pop_front();
                        else {
                            q1.front().second -= b - x;
                            x = b;
                            if(!q1.front().second) q1.pop_front();
                        }
                    }
                }
    return ans1;
}

int f2(deque<pair<int, int>> &q2) {
    int ans2 = 0;
    for(int j = n - 1; j >= (n + 1) / 2; j--) {
                    int x = 0;
                    bool succ = false;
                    for(int y = sz(q2) - 1; y >= 0 && x < b && (abs(q2[y].first - j) + d - 1) / d <= n - j; y--) {
                        if(x + q2[y].second < b) x += q2[y].second;
                        else {
                            succ = true;
                            x = b;
                        }
                    }
                    if(!succ) {
                        if(++ans2 >= opt) break;
                        continue;
                    }
                    x = 0;
                    while(x < b) {
                        if(x + q2.back().second < b) x += q2.back().second, q2.pop_back();
                        else {
                            q2.back().second -= b - x;
                            x = b;
                            if(!q2.back().second) q2.pop_back();
                        }
                    }
                }
    return ans2;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> p >> n >> d >> b;
    if(p == 1) {
        deque<pair<int, int>> q;
        for(int i = 0; i < n; i++) {
            int x; cin >> x; q.push_back({i, x});
        }
        int ans = 0;
        for(int i = 0; i < n; i++) {
            int x = 0;
            bool succ = false;
            for(int j = 0; j < sz(q) && x < b && (abs(q[j].first - i) + d - 1) / d <= i + 1; j++) {
                if(x + q[j].second < b) x += q[j].second;
                else {
                    succ = true;
                    x = b;
                }
            }
            if(!succ) {
                ans++;
                continue;
            }
            x = 0;
            while(x < b) {
                if(x + q.front().second < b) x += q.front().second, q.pop_front();
                else {
                    q.front().second -= b - x;
                    x = b;
                    if(!q.front().second) q.pop_front();
                }
            }
        }
        cout << ans;
        return 0;
    } else {
        vector<int> a(n);
        for(int i = 0; i < n; i++) cin >> a[i];
        int onl = 0;

        opt = INF;
        for(int i = 0; i < n; i++) {
            for(int tol = 0; tol <= a[i]; tol++) {
                if(3 * (onl + tol) < b * n || 3 * (b * n - onl - tol) < b * n) continue;
                deque<pair<int, int>> q1, q2;
                for(int j = 0; j < i; j++) q1.push_back({j, a[j]});
                if(tol) q1.push_back({i, tol});
                if(a[i] - tol) q2.push_back({i, a[i] - tol});
                for(int j = i + 1; j < n; j++) q2.push_back({j, a[j]});
                int ans1 = f1(q1);
                if(ans1 >= opt) continue;
                int ans2 = f2(q2);
                opt = min(opt, max(ans1, ans2));
            }
            onl += a[i];
        }
        cout << opt;
    }
}
