#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e5 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
ifstream in("input.txt");
ofstream out("output.txt");
vector < int > g[MAXN];
int tim[MAXN];
int h[MAXN];
bool used[MAXN];
int mini;
int ind;
int color;
int n;

void dfs(int v) {
    used[v] = true;
    if (g[v].size() == 0) {
        mini = 1;
        ind = v;
    }
    else {
        for (int i = 0; i < g[v].size(); i++) {
            int to = g[v][i];
            if (used[to]) {
                if (h[v] - h[to] + 1 < mini && h[v] - h[to] < n && h[v] > h[to] + 1) {
                    mini = h[v] - h[to] + 1;
                    ind = to;
                }
            }
            else {
                h[to] = color;
                color++;
                dfs(to);
            }
        }
    }
}

void dfs2(int v) {
    used[v] = true;
    cout << v + 1 << ' ';
    for (int i = 0; i < g[v].size(); i++) if (!used[g[v][i]]) dfs2(g[v][i]);
}

main() {
    int m, Q;
    cin >> n >> m >> Q;
    mini = n;
    ind = 0;
    for (int i = 0; i < n; i++) cin >> tim[i];
    for (int i = 0; i < m; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        if ((tim[v1] + 1) % Q == tim[v2]) g[v1].push_back(v2);
        if ((tim[v2] + 1) % Q == tim[v1]) g[v2].push_back(v1);
    }
    for (int i = 0; i < n; i++) used[i] = 0;
    color = 1;
    h[0] = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i);
        color += 2 * n;
    }
    for (int i = 0; i < n; i++) used[i] = 0;
    cout << mini << endl;
    dfs2(ind);
    return 0;
}
