#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e5 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
ifstream in("input.txt");
ofstream out("output.txt");
vector < int > g[MAXN];
int tim[MAXN];
bool used[MAXN];
bool global_used[MAXN];
vector < int > ans;
int color;

void dfs(int v) {
    if (color == 1) return;
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++) {
        if (global_used[g[v][i]]) {
            color = 1;
            return;
        }
        if (!used[g[v][i]]) dfs(g[v][i]);
    }
}

main() {
    srand( time (0) );
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) cin >> tim[i];
    for (int i = 0; i < m; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        if ((tim[v1] + 1) % h == tim[v2]) g[v1].push_back(v2);
        if ((tim[v2] + 1) % h == tim[v1]) g[v2].push_back(v1);
    }
    for (int i = 0; i < n; i++) {
        ans.push_back(i);
        global_used[i] = false;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) used[j] = 0;
        color = 0;
        dfs(i);
        global_used[i] = true;
        if (color) continue;
        int cnt = 0;
        for (int j = 0; j < n; j++) if (used[j]) cnt++;
        if (ans.size() > cnt) {
            ans.clear();
            for (int j = 0; j < n; j++) if (used[j]) ans.push_back(j);
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) cout << ans[i] + 1 << ' ';
    return 0;
}
