#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e3 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
ifstream in("input.txt");
ofstream out("output.txt");
int test[100];

struct point {
    double x;
    double y;
};

struct vect {
    double x;
    double y;
};

vect make_v(point p1, point p2) {
    vect ans;
    ans.x = p2.x - p1.x;
    ans.y = p2.y - p1.y;
    return ans;
}

double r(point p1, point p2) {
    vect AB = make_v(p1, p2);
    return (pow(AB.x * AB.x + AB.y * AB.y, 0.5));
}

double scal(vect v1, vect v2) {
    return (v1.x * v1.y + v2.x * v2.y);
}

double vec(vect v1, vect v2) {
    return (v1.x * v2.y - v2.x * v1.y);
}

struct Node {
    Node* left;
    Node* right;
    int l;
    int r;
    int sum;
};

Node* build(int l, int r) {
    if (l + 1 == r) return new Node({0, 0, l, r, test[l]});
    Node* left = build(l, (l + r) / 2);
    Node* right = build((l + r) / 2, r);
    return new Node({left, right, l, r, left->sum + right->sum});
}

int getsum(Node* root, int l, int r) {
    if (root->l >= r || root->r <= l) return 0;
    if (root->l >= l && root->r <= r) return root->sum;
    return getsum(root->left, l, r) + getsum(root->right, l, r);
}

void change(Node* root, int ind, int val) {
    if (root->r <= ind || root->l > ind) return;
    if (root->r - root->l == 1) {
        root->sum = val;
        return;
    }
    change(root->left, ind, val);
    change(root->right, ind, val);
    root->sum = root->left->sum + root->right->sum;
}

struct node {
    node* left;
    node* right;
    int x;
    int y;
};

pair < node*, node* > split(node* root, int val) {
    if (root == 0) return {0, 0};
    if (root->x >= val) {
        pair < node*, node* > par = split(root->right, val);
        root->right = par.first;
        return {root, par.second};
    }
    else {
        pair < node*, node* > par = split(root->left, val);
        root->left = par.second;
        return {par.first, root};
    }
}

node* merg(node* root1, node* root2) {
    if (root1 == 0) return root2;
    if (root2 == 0) return root1;
    if (root1->y > root2->y) {
        root1->right = merg(root1->right, root2);
        return root1;
    }
    else {
        root2->left = merg(root2->left, root1);
        return root2;
    }
}

main() {
    srand( time (0) );

    return 0;
}
