#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;

const int base = 500;

int n , m , h , cnt;
vector < vector < int > > g;
vector < int > f;
vector < bool > used;
int t[100005];

void dfs(int v , int color , bool out = 0){
    f[v] = color;
    if (out)
        cout << v + 1 << " ";
    cnt++;
    used[v] = 1;
    for (int i = 0 ; i < g[v].size() ; i++){
        int to = g[v][i];
        if (f[to] == color)
            continue;
        dfs(to , color , out);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> m >> h;
    g.resize(n);
    f.resize(n , 0);
    used.resize(n , 0);
    for (int i = 0 ; i < n ; i++){
        cin >> t[i];
    }
    for (int i = 0 ; i < m ; i++){
        int x , y;
        cin >> x >> y;
        x--;
        y--;
        if ((t[x] + 1) % h == t[y])
            g[x].push_back(y);
        if ((t[y] + 1) % h == t[x])
            g[y].push_back(x);
    }
    int ans = n;
    int v = 0;
    int cc = 1;
    for (int i = 0 ; i < n ; i++){
        cnt = 0;
        dfs(i , cc);
        cc++;
        if (cnt < ans)
            ans = cnt , v = i;
    }
    cout << ans << endl;
    dfs(v , cc , 1);
    return 0;
}

