#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

vector <int> g[N];
int comp[N];
vector <int> rg[N];
bool us[N];

vector <int> t;

void dfs(int v)
{
    us[v] = true;
    for (int to : g[v])
    {
        if (!us[to])
        {
            dfs(to);
        }
    }
    t.push_back(v);
}

vector <int> cur;

void rdfs(int v, int c)
{
    cur.push_back(v);
    us[v] = true;
    comp[v] = c;
    for (int to : rg[v])
    {
        if (!us[to])
        {
            rdfs(to, c);
        }
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> u(n);
    for (int i = 0; i < n; i++)
    {
        cin >> u[i];
    }
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if (u[b] == (u[a] + 1) % h)
        {
            g[a].push_back(b);
            rg[b].push_back(a);
        }
        if (u[a] == (u[b] + 1) % h)
        {
            g[b].push_back(a);
            rg[a].push_back(b);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!us[i])
        {
            dfs(i);
        }
    }
    reverse(t.begin(), t.end());
    for (int v : t)
    {
        us[v] = 0;
    }
    int sz = 1;
    vector <int> ans;
    for (int v : t)
    {
        if (!us[v])
        {
            cur.clear();
            rdfs(v, sz++);
            bool bad = false;
            for (int v : cur)
            {
                for (int to : g[v])
                {
                    if (comp[v] != comp[to])
                    {
                        bad = true;
                    }
                }
            }
            if (!bad)
            {
                if (ans.empty() || cur.size() < ans.size())
                {
                    ans = cur;
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (int v : ans)
    {
        cout << v + 1 << ' ';
    }
    cout << '\n';
}
