#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int N = 1000 + 7;
const int ADD = 500;

bitset <N> dp;

bool check(const vector <int> &need, const vector <int> &arr)
{
    dp.reset();
    dp[ADD] = 1;
    for (int x : arr)
    {
        if (x < 0)
        {
            dp |= dp >> (-x);
        }
        else
        {
            dp |= dp << x;
        }
    }
    for (int x : need)
    {
        if (!dp[x + ADD])
        {
            return false;
        }
    }
    return true;
}

int ans;

vector <int> cur;
vector <int> need;

const int MX = (1 << 6);

void brute(int last, int cnt, int i)
{
    if (i == ans)
    {
        if (check(need, cur))
        {
            cout << ans << '\n';
            for (int x : cur) cout << x << ' ';
            cout << '\n';
            exit(0);
        }
    }
    else
    {
        while (last < MX)
        {
            cur.push_back(last);
            if (cnt <= 2) brute(last, cnt + 1, i + 1);
            cnt = 0;
            if (last < 0)
            {
                last /= 2;
                if (last == 0)
                {
                    last = 1;
                }
            }
            else
            {
                last *= 2;
            }
            cur.pop_back();
        }
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        need.push_back(x);
    }
    for (ans = 0; ; ans++)
    {
        brute(-(MX / 2), 0, 0);
    }
}
