#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

vector <int> res[N];


int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    string s;
    cin >> s;
    int n = (int) s.size();
    set <pair <int, int> > q1;
    set <pair <int, int> > q2;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
        {
            q1.insert({i, i});
            q2.insert({i, i});
            res[i].push_back(i);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '1')
        {
            auto it = q1.lower_bound({i, -1});
            auto jt = q2.lower_bound({i, -1});
            if (it != q1.end() && jt != q2.begin())
            {
                jt = prev(jt);
                int l1 = jt->second, r1 = jt->first;
                int l2 = it->first, r2 = it->second;
                q1.erase({l1, r1});
                q2.erase({r1, l1});
                q1.erase({l2, r2});
                q2.erase({r2, l2});
                if (res[r1].size() < res[r2].size())
                {
                    for (int x : res[r1]) res[r2].push_back(x);
                    res[r1].clear();
                }
                else
                {
                    for (int x : res[r2]) res[r1].push_back(x);
                    res[r2].clear();
                    res[r1].swap(res[r2]);
                }
                res[r2].push_back(i);
                q1.insert({l1, r2});
                q2.insert({r2, l1});
            }
            else
            {
                cout << -1 << '\n';
                return 0;
            }
        }
    }
    cout << q1.size() << '\n';
    for (int i = 0; i < n; i++)
    {
        if (!res[i].empty())
        {
            sort(res[i].begin(), res[i].end());
            cout << res[i].size() << ' ';
            for (int x : res[i]) cout << x + 1 << ' ';
            cout << '\n';
        }
    }
}
