#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <stack>
#include <deque>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

//---------------------------------------------------------------------
using namespace std;
typedef long long ll;
#define read(v) {for(int i_ = 0; i_ < v.size(); i_++){cin >> v[i_];}}
#define prv(v) {for(auto i_ : v){cout << i_ << " ";}cout<<"\n";}
#define prmat(v) {for(auto i_ : v){prv(i_);}}
//---------------------------------------------------------------------

int main() {
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> update(n);
	read(update);
	vector<int> s1(m);
	vector<int> s2(m);
	for (int i = 0; i < m; i++) {
		cin >> s1[i] >> s2[i];
		s1[i]--;
		s2[i]--;
	}
	int min_mask = (1 << n) - 1;
	int minn = 1e9;
	for (int mask = 1; mask < (1 << n); mask++) {
		vector<int> new_upd = update;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if ((mask & (1 << i))) {
				new_upd[i]++;
				new_upd[i] %= h;
				cnt++;
			}
		}
		bool fl = 1;
		for (int i = 0; i < m; i++) {
			if (new_upd[s1[i]] == new_upd[s2[i]]) {
				fl = 0;
				break;
			}
		}
		if (fl && cnt < minn) {
			min_mask = mask;
			minn = cnt;
		}
	}
	vector<int> ans;
	for(int i = 0; i < n; i++) {
		if ((min_mask & (1 << i))) {
			ans.push_back(i + 1);
		}
	}
	cout << ans.size() << "\n";
	prv(ans);
}
/*
3 3 5
4 4 0
1 3
3 2
3 1
*/