#include <bits/stdc++.h>

int main() {
	std::string s;
	std::cin >> s;
	if ( s[0] == '1' || s.back() == '1' ) {
		printf( "-1" );
		return 0;
	}
	std::vector <std::vector <int>> res;
	std::vector <bool> used( s.size(), false );
	int left = 0, right = 0;
	int size = (int)s.size();
	for ( int i = 1; i < size - 1; ++i ) {
		if ( s[i] == '0' ) continue;
		while ( left < i && ( used[left] || s[left] == '1' ) ) {
			++left;
		}
		if ( right < i ) {
			right = i + 1;
		}
		while ( right < size && ( used[right] || s[right] == '1' ) ) {
			++right;
		}
		if ( left == i || right == size ) {
			printf( "-1" );
			return 0;
		}
		assert( left < i && i < right && !used[left] && !used[i] && !used[right] && s[left] == '0' && s[i] == '1' && s[right] == '0' );
		used[left] = used[i] = used[right] = true;
		res.push_back( { left, i, right } );
	}
	for ( int i = 0; i < (int)s.size(); ++i ) {
		if ( s[i] == '0' && !used[i] ) {
			res.push_back( { i } );
		}
	}
	printf( "%d\n", (int)res.size() );
	for ( const auto& vec : res ) {
		printf( "%d ", (int)vec.size() );
		for ( int val : vec ) {
			printf( "%d ", val + 1 );
		}
		printf( "\n" );
	}
	return 0;
}