#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimaze("Ofast");
//#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back

const int INF = 1e18;
const int MAXN = 1e6;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

int p, n, d, b;
vector<int> a;

int solve() {
    int ans = 0;
    for (int i = 0; i < n / 2; i++) {
        vector<int> cop = a;
        int l = i;
        int r = n - i - 1;
        bool flag1 = 0, flag2 = 0;
        int pos1 = -1, pos2 = -1;
        int s = 0;
        for (int j = 0; j < n; j++) {
            if (abs(l - j) > (i + 1) * d) continue;
            if (s == b) {
                flag1 = 1;
                break;
            }
            int d = min(b - s, a[j]);
            s += d;
            a[j] -= d;
            if (s == b) {
                flag1 = 1;
                break;
            }
        }
        s = 0;
        for (int j = 0; j < n; j++) {
            if (abs(r - j) > (i + 1) * d) continue;
            if (s == b) {
                flag2 = 1;
                break;
            }
            int d = min(b - s, a[j]);
            s += d;
            a[j] -= d;
            if (s == b) {
                flag2 = 1;
                break;
            }
        }
        if (!(flag1 && flag2)) {
            a = cop;
            ans++;
        }
    }
    return ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
//-------------------------------------------------------------

    cin >> p >> n >> d >> b;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (p == 2) {
        cout << solve() << "\n";
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] > b) a[i + 1] += abs(a[i] - b);
        if (a[i] == b) continue;
        int s = 0;
        if (a[i] < b) {
            for (int j = i; j < n; j++) {
                if (s == b) break;
                if (j - i > (i + 1) * d) break;
                int d = min(a[j], b - s);
                s += d;
            }
            if (s == b) {
                s = 0;
                for (int j = i; j < n; j++) {
                    if (s == b) break;
                    if (j - i > (i + 1) * d) break;
                    int d = min(a[j], b - s);
                    s += d;
                    a[j] -= d;
                }
            } else {
                ans++;
            }
        }
    }
    cout << ans << "\n";
}