#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

const int N = 200001;
vector<int> t;
vector<int> g[N], gr[N];
vector<int> cur;
vector<int> used, col, siz, top;
int numc;

void dfs1(int v)
{
    used[v] = 1;
    for (int u : g[v])
        if (!used[u])
            dfs1(u);
    top.push_back(v);
}

void dfs2(int v)
{
    used[v] = 1;
    col[v] = numc;
    siz[numc]++;
    for (int u : gr[v])
        if (!used[u])
            dfs2(u);
}

/*
void dfs(int v)
{
    used[v] = 1;
    cur.push_back(v);
    for (int u : gr[v])
        if (!used[u])
            dfs(u);
}
*/
int solve()
{
    ios::sync_with_stdio(0);
    int n, m, h;
    if (!(cin >> n))
        return 1;
    cin >> m >> h;
    t.assign(n + 1, 0);
    for (int i = 1; i <= n; i++)
    {
        cin >> t[i];
        g[i].clear();
        gr[i].clear();
    }
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int v = 1; v <= n; v++)
        for (int u : g[v])
        {
            if (((t[v] + 1) % h) == t[u])
                gr[v].push_back(u);
        }
    for (int i = 1; i <= n; i++)
    {
        g[i] = gr[i];
        gr[i].clear();
    }
    for (int v = 1; v <= n; v++)
        for (int u : g[v])
            gr[u].push_back(v);
    used.assign(n + 1, 0);
    top.clear();
    for (int i = 1; i <= n; i++)
        if (!used[i])
            dfs1(i);
    reverse(top.begin(), top.end());
    used.assign(n + 1, 0);
    numc = 0;
    col.assign(n + 1, -1);
    siz.assign(n + 1, 0);
    for (int v : top)
        if (!used[v])
        {
            dfs2(v);
            numc++;
        }
    vector<int> out(numc, 0);
    for (int v = 1; v <= n; v++)
        for (int u : g[v])
            if (col[v] != col[u])
                out[col[v]]++;
    int bestcol = -1;
    for (int i = 0; i < numc; i++)
        if (out[i] == 0 && (bestcol == -1 || siz[bestcol] > siz[i]))
            bestcol = i;
    vector<int> ans;
    for (int i = 1; i <= n; i++)
        if (col[i] == bestcol)
            ans.push_back(i);
  /*  for (int i = 1; i <= n; i++)
    {
        cur.clear();
        used.assign(n + 1, 0);
        dfs(i);
        if (sz(cur) < sz(ans))
            ans = cur;
    } */
    cout << sz(ans) << endl;
    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC;
    #endif
    return 0;
}
