#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

int rnd()
{
    return abs(((rand() << 15) | rand()));
}

int solve()
{
    ios::sync_with_stdio(0);
    int n;
    if (!(cin >> n))
        return 1;
    vector<int> a(n);
    int maxa = 0;
    int maxpos = 0;
    int maxneg = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        maxa = max(maxa, abs(a[i]));
        if (a[i] > 0)
            maxpos = max(maxpos, a[i]);
        else
            maxneg = max(maxneg, -a[i]);
    }
    int st = 0;
    while ((1 << st) <= 2 * maxa)
        st++;
    int B = (1 << st);
    vector<int> ans;
    for (int i = 0; i < st; i++)
    {
        ans.push_back((1 << i));
        ans.push_back(-(1 << i));
    }
    maxa = (1 << st) + 5;
    const int maxA = 2060;
    //for (int mask1 = 0; mask1 < B; mask1++)
    int T = 3e5;
    for (int i = 0; i < T; i++)
    {
        int mask1 = rnd() % B;
        int mask2 = rnd() % B;
        vector<int> pos;
        for (int i = 0; i < st; i++)
                if ((mask1 & (1 << i)))
                    pos.push_back((1 << i));
//for (int mask2 = 0; mask2 < B; mask2++)
        {
            vector<int> neg;
            for (int i = 0; i < st; i++)
                if ((mask2 & (1 << i)))
                    neg.push_back((1 << i));
            //vector<int> posknap(maxa + 1, 0), negknap(maxa + 1, 0);
            bitset<maxA> posknap, negknap;
            posknap[0] = negknap[0] = 1;
            for (int i = 0; i < pos.size(); i++)
            {
               /* for (int j = maxa - pos[i]; j >= 0; j--)
                {
                    if (posknap[j])
                        posknap[j + pos[i]] = 1;
                }*/
                posknap |= (posknap << pos[i]);
            }
            for (int i = 0; i < neg.size(); i++)
            {
               /* for (int j = neg[i]; j <= maxa; j++)
                {
                    if (posknap[j])
                        posknap[j - neg[i]] = 1;
                }*/
                posknap |= (posknap >> neg[i]);
            }
            swap(pos, neg);
            for (int i = 0; i < pos.size(); i++)
            {
               /* for (int j = maxa - pos[i]; j >= 0; j--)
                {
                    if (negknap[j])
                        negknap[j + pos[i]] = 1;
                }*/
                negknap |= (negknap << pos[i]);
            }
            for (int i = 0; i < neg.size(); i++)
            {
               /* for (int j = neg[i]; j <= maxa; j++)
                {
                    if (negknap[j])
                        negknap[j - neg[i]] = 1;
                }*/
                negknap |= (negknap >>  neg[i]);
            }
            swap(neg, pos);
            bool ok = true;
            for (int i = 0; i < n; i++)
                if ((a[i] > 0 && !posknap[a[i]]) || (a[i] < 0 && !negknap[-a[i]]))
                    ok = false;
            if (ok && sz(ans) > sz(pos) + sz(neg))
            {
                ans = pos;
                for (int i : neg)
                    ans.push_back(-i);
            }
        }
    }
    cout << sz(ans) << endl;
    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms";
    #endif
    return 0;
}
