#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>
#include <math.h>
#include <string>

using namespace std;

int main()
{
    ifstream fin("input.txt");
    string s;
    getline(fin, s);
    int n = s.length();
    int c0 = 0, c1 = 0;
    int m[n];
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            m[i] = 0;
        }
        else {
            m[i] = 1;
        }
    }
    vector< vector<int> > p(n);
    queue<int> p0;
    queue<int> p1;
    for (int i = 0; i < n; i++) {
        if (m[i] == 0) {
            if (c1 == 0) {
                c0++;
                p0.push(i);
                p[i].push_back(i);
            }
            else {
                c1--;
                c0++;
                int v = p1.front();
                p1.pop();
                p[v].push_back(i);
                p0.push(v);
            }
        }
        else {
            if (c0 == 0) {
                cout << -1;
                return 0;
            }
            else {
                c0--;
                c1++;
                int v = p0.front();
                p0.pop();
                p1.push(v);
                p[v].push_back(i);
            }
        }
    }
    int k = 0;
    for (int i = 0; i < n; i++) {
        if (p[i].size() > 0) {
            k++;
        }
    }
    cout << k << endl;
    for (int i = 0; i < n; i++) {
        if (p[i].size() > 0) {
            cout << p[i].size();
            for (int j = 0; j < p[i].size(); j++) {
                cout << ' ' << p[i][j] + 1;
            }
            cout << endl;
        }
    }
}
