#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define ALL(a) a.begin(), (a).end()
#define pf push_front
#define ppf pop_front
#define ppb pop_back

const ll MAXN = 1e6;
const ll INF = 1e9;
const ld eps = 1e-9;
const ll M = 1e5;
const ld pi = acos(-1);

ll tm1[MAXN];
set <pair <ll, ll>> arr[MAXN];
vector <ll> ans;
vector <ll> g[MAXN];
bool g_flag = false;
bool mark[MAXN];
ll n, m, h;

void dfs(ll v, vector <ll> &q) {
    if (g_flag)
        return;
    mark[v] = true;
    ll tmm = (tm1[v] + 1) % h;

    vector <ll> f = q;
    f.pb(v);

    ll cnt = 0;
    bool flag = true;
    for (auto i : arr[v]) {
        cnt++;
        if (cnt > arr[v].size())
            break;
        if (i.first == tmm) {
            flag = false;
            for (ll j = 0; j < g[v].size(); j++) {
                ll to = g[v][j];
                arr[to].erase(mp(tm1[v], v));
                arr[to].insert(mp(tmm, v));
            }
            if (!mark[i.second]) {
                dfs(i.second, f);
            }
            for (ll j = 0; j < g[v].size(); j++) {
                ll to = g[v][j];
                arr[to].insert(mp(tm1[v], v));
                arr[to].erase(mp(tmm, v));
            }
        }
    }

    if (flag) {
        if (ans.empty())
            ans = f;
        else
            if (ans.size() > f.size())
                ans = f;
        g_flag = true;
        return;
    }
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m >> h;

    for (ll i = 0; i < n; i++) {
        cin >> tm1[i];
    }

    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].pb(y);
        g[y].pb(x);
        arr[x].insert(mp(tm1[y], y));
        arr[y].insert(mp(tm1[x], x));
    }
    vector <ll> z;

    for (ll i = 0; i < n; i++) {
        dfs(i, z);
        z.clear();
        for (ll j = 0; j < n; j++)
            mark[j] = false;
        g_flag = false;
    }
    if (ans.empty())
        for (;;)
        {
            }
    cout << ans.size() << endl;
    for (ll i = 0; i < ans.size(); i++)
        cout << ans[i] + 1 << ' ';
    return 0;
}
