#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string.h>
#include <set>
using namespace std;
typedef long long ll;

const int maxn = 200000;
int u[maxn], h, comp;
vector <int> v[maxn], vr[maxn], component[maxn];
bool compv[maxn];
int comps[maxn];
bool used[maxn];
vector <int> tout;

int next(int x) {
    if (x == h - 1) {
        return 0;
    }
    return x + 1;
}

void dfs(int k) {
    if (!used[k]) {
        used[k] = true;
        for (int i = 0; i < v[k].size(); i++) {
            dfs(v[k][i]);
        }
        tout.push_back(k);
    }
}

void dfs2(int k) {
    if (!used[k]) {
        comps[k] = comp;
        component[comp].push_back(k);
        used[k] = true;
        for (int i = 0; i < vr[k].size(); i++) {
            dfs2(vr[k][i]);
        }
    }
}

int main() {
    int n, m;
    scanf("%d %d %d", &n, &m, &h);
    for (int i = 0; i < n; i++) {
        scanf("%d", &u[i]);
    }
    for (int i = 0; i < m; i++) {
        int c1, c2;
        scanf("%d %d", &c1, &c2); c1--; c2--;
        if (next(u[c1]) == u[c2]) {
            v[c1].push_back(c2);
            vr[c2].push_back(c1);
        }
        if (next(u[c2]) == u[c1]) {
            vr[c1].push_back(c2);
            v[c2].push_back(c1);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; i++) {
        used[i] = false;
    }
    
    for (int i = n - 1; i >= 0; i--) {
        int ind = tout[i];
        if (!used[ind]) {
            dfs2(ind);
            comp++;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < v[i].size(); j++) {
            if (comps[i] != comps[v[i][j]]) {
                compv[comps[i]] = false;
            }
        }
    }
    int minim = n + 1;
    vector <int> ans;
    for (int i = 0; i < comp; i++) {
        if (compv[i] && component[i].size() < minim) {
            minim = component[i].size();
            ans.clear();
            for (int j = 0; j < component[i].size(); j++) {
                ans.push_back(component[i][j]);
            }
        }
    }
    printf("%d\n", ans.size());
    for (int i = 0; i < ans.size(); i++) {
        printf("%d ", ans[i] + 1);
    }
    return 0;
}