#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 501;

int a[N];
vector<int> g[N];
bool used[N];
vector<int> cur;

void dfs(int v)
{
	if (used[v])
	{
		return;
	}
	used[v] = true;
	cur.push_back(v);
	for (int to : g[v]) dfs(to);
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, h;
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < m; i++)
	{
		int x, y;
		cin >> x >> y;
		--x, --y;
		if ((a[x] + 1) % h == a[y])
		{
			g[x].push_back(y);
		}
		if ((a[y] + 1) % h == a[x])
		{
			g[y].push_back(x);
		}
	}
	vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		ans.push_back(i);
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			used[j] = false;
		}
		cur.clear();
		dfs(i);
		if (cur.size() < ans.size())
		{
			ans.swap(cur);
		}
	}

	cout << ans.size() << "\n";
	for (int i : ans)
	{
		cout << i + 1 << " ";
	}


#ifdef _DEBUG
	while (1);
#endif
}