#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 100000 + 100;

int a[N], cp[N];
int p, n, d, b;
int t[4 * N];

void add(int v, int tl, int tr, int pos, int x)
{
	if (tl + 1 == tr)
	{
		t[v] += x;
	}
	else
	{
		int c = (tl + tr) / 2;
		if (pos < c)
		{
			add(2 * v, tl, c, pos, x);
		}
		else
		{
			add(2 * v + 1, c, tr, pos, x);
		}
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}

inline void add(int pos, int x)
{
	add(1, 0, n, pos, x);
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl)
	{
		return 0;
	}
	if (tl >= l && tr <= r)
	{
		return t[v];
	}
	int c = (tl + tr) / 2;
	return get(2 * v, tl, c, l, r) + get(2 * v + 1, c, tr, l, r);
}
int get(int l, int r)
{
	return get(1, 0, n, l, r);
}

bool check(int pref)
{
	ll sm = 0;
	int ptr = pref;
	for (int i = 0; i < n;)
	{

		int l = (int)max((ll)0, (ll)i - (ll)d * (ll)(min(ptr, n - 1 - ptr) + 1));
		int r = (int)min((ll)n - 1, (ll)i + (ll)d * (ll)(min(ptr, n - 1 - ptr) + 1));

		if (sm < b)
		{
			int need = max(0LL, min((ll)b - sm, (ll)a[i]));
			if (l <= ptr && ptr <= r)
			{
				sm += need;
				a[i] -= need;
			}
			if (sm == b && ptr != n - 1 - pref)
			{
				++ptr;
				sm = 0;
			}
		}
		if ((ptr == n - 1 - pref && sm >= b) || a[i] == 0 || !(l <= ptr && ptr <= r))
		{
			++i;
		}
	}

	return ptr == n - 1 - pref && sm >= b;
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> p >> n >> d >> b;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		cp[i] = a[i];
		add(i, a[i]);
	}

	if (p == 2)
	{

		int l = -1, r = n / 2 + n % 2;
		while (r - l > 1)
		{
			for (int i = 0; i < n; i++)
			{
				a[i] = cp[i];
			}
			int mid = (l + r) / 2;
			if (check(mid))
			{
				r = mid;
			}
			else
			{
				l = mid;
			}
		}

		cout << r;

	}

	else

	{
		int bad = 0;
		int ptr = 0;
		for (int i = 0; i < n; i++)
		{
			int l = i;
			int r = min(n - 1, i + d * (i + 1)) + 1;

			ptr = max(ptr, i + 1);
			int cur = get(i, i + 1);
			while (cur < b && ptr < r)
			{
				int here = get(ptr, ptr + 1);
				int kek = min(here, b - cur);
				cur += kek;
				add(ptr, -kek);
				if (here - kek == 0)
				{
					++ptr;
				}
			}
			if (cur < b)
			{
				++bad;
			}
			if (cur > b)
			{
				add(i + 1, cur - b);
			}
		}
		cout << bad;
	}


#ifdef _DEBUG
	while (1);
#endif
}