#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 1e6 + 100;

int n;
int a[N];

const int M = 8;
const int K = 257;

inline int pp(int n)
{
	int ret = 0;
	while (n)
	{
		ret += n & 1;
		n >>= 1;
	}
	return ret;
}

vector<int> submasks[1 << M];
unordered_set<int> kek[1 << M];
int p[1 << M];
int mtn[1 << M];

vector<int> can[1 << M][2*K+2];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	for (int i = 0; i < (1 << M); i++)
	{
		p[i] = pp(i);
		int lol = 0;
		for (int j = 0; j < M; j++)
		{
			if ((i >> j) & 1)
			{
				lol += 1 << j;
			}
		}
		mtn[i] = lol;
		for (int j = 0; j < (1 << M); j++)
		{
			if ((i & j) == j)
			{
				submasks[i].push_back(j);
				kek[i].insert(j);
			}
		}
	}

	int best = 0;
	int cnt = 10000000;

	for (int mask1 = 0; mask1 < (1 << M); mask1++)
	{
		for (int mask2 = 0; mask2 < (1 << M); mask2++)
		{
			bool ok = true;
			for (int t = 0; t < n; t++)
			{ 
				bool good = false;
				for (int i : submasks[mask1])
				{
					if (kek[mask2].count(i - a[t]))
						good = true;
				}
				if (!good)
				{
					ok = false;
					break;
				}
			}
			if (ok)
			{
				if (p[mask1] + p[mask2] < cnt)
				{
					cnt = p[mask1] + p[mask2];
					best = mask1 | (mask2 << M);
				}
			}
		}
	}

	cout << cnt << "\n";
	for (int i = 0; i < M; i++)
	{
		if ((best >> i) & 1)
		{
			cout << (1 << i) << " ";
		}
		if ((best >> (i + M)) & 1)
		{
			cout << -(1 << i) << " ";
		}
	}
	

#ifdef _DEBUG
	while (1);
#endif
}