#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;


signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;
	int n = s.length();

	int cur = 0, cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			++cur;
		}
		else
		{
			--cur;
		}
		if (cur < 0)
		{
			cout << -1;
			return 0;
		}
	}

	vector<vector<int>> ans;
	vector<bool> used(n, false);
	cnt = n;

	while (cnt)
	{
		vector<int> cur;
		int want = 0;
		for (int i = 0; i < n; i++)
		{
			if ((int)(s[i] - '0') == want && !used[i])
			{
				used[i] = true;
				cur.push_back(i + 1);
				--cnt;
				want = 1 - want;
			}
		}
		if (want != 1)
		{
			cout << -1;
			return 0;
		}
		ans.push_back(cur);
	}
	cout << ans.size() << "\n";
	for (auto it : ans)
	{
		cout << it.size() << " ";
		for (int p : it)
		{
			cout << p << " ";
		}
		cout << "\n";
	}


#ifdef _DEBUG
	while (1);
#endif
}