#include <bits/stdc++.h>
#define mp make_pair
#define x first
#define y second
#define pb push_back

using namespace std;

typedef long long ll;

vector <int> g[100005], obr[100005], tps;
bool used[100005], is[100005];
int hour[100005], komp[100005], sz[100005];
pair <int, int> rebr[100005];

void topsort(int v)
{
    used[v] = true;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        int u = g[v][i];
        if (!used[u]) topsort(u);
    }
    tps.pb(v);
    return;
}

void dfs(int v, int cnt)
{
    komp[v] = cnt;
    for (int i = 0; i < (int) obr[v].size(); i++)
    {
        int u = obr[v][i];
        if (komp[u] == 0) dfs(u, cnt);
    }
    return;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
        cin >> hour[i];
    for (int i = 1; i <= m; i++)
    {
        int u, v;
        cin >> u >> v;
        rebr[i] = mp(u, v);
        if (hour[u] == (hour[v] + 1) % h) g[u].pb(v), obr[v].pb(u);
        if (hour[v] == (hour[u] + 1) % h) g[v].pb(u), obr[u].pb(v);
    }

    for (int i = 1; i <= n; i++)
        if (!used[i]) topsort(i);

    int cnt = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        int v = tps[i];
        if (komp[v] == 0)
        {
            cnt++;
            dfs(v, cnt);
        }
    }
    for (int i = 1; i <= cnt; i++)
        is[i] = true;
    for (int i = 1; i <= n; i++)
        sz[komp[i]]++;

    for (int i = 1; i <= m; i++)
    {
        int u = rebr[i].x, v = rebr[i].y;
        int t1 = komp[u], t2 = komp[v];
        if (t1 == t2) continue;
        if (hour[u] == (hour[v] + 1) % h) is[t2] = false;
        if (hour[v] == (hour[u] + 1) % h) is[t1] = false;
    }

    int answ = n + 1, uk = 1;
    for (int i = 1; i <= cnt; i++)
    {
        if (is[i] && sz[i] < answ)
        {
            answ = sz[i];
            uk = i;
        }
    }
    cout << answ << '\n';
    for (int i = 1; i <= n; i++)
        if (komp[i] == uk) cout << i << ' ';
    return 0;
}
