#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

const int MAXN = 2e5 + 1337;
vector<int> g[MAXN], gr[MAXN];
bool used[MAXN];
vector<int> kekos, topsort;
int comp[MAXN], out[MAXN], cnt_comp[MAXN];
int comps = 0;

void topsort1(int v) {
	used[v] = true;
	for (int u : g[v])
		if (!used[u])
			topsort1(u);
	topsort.pb(v);
}

void dfs_comp(int v) {
	comp[v] = comps;
	used[v] = true;
	++cnt_comp[comps];
	for (int u : gr[v])
		if (!used[u])
			dfs_comp(u);
}

void get_ans(int v) {
	used[v] = true;
	kekos.pb(v);
	for (int u : g[v])
		if (!used[u])
			get_ans(u);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// freopen("input.txt", "r", stdin);
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> t(n), t1(n);
	for (int i = 0; i < n; ++i)
		cin >> t[i], t1[i] = (t[i] + 1) % h, t1[i] = (t1[i] == h ? 0 : t1[i]);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		if (t1[u] == t[v])
			g[u].pb(v);
		if (t1[v] == t[u])
			g[v].pb(u);
	}
	for (int i = 0; i < n; ++i)
		for (int j : g[i])
			gr[j].pb(i);

	for (int i = 0; i < n; ++i)
		if (!used[i])
			topsort1(i);
	memset(used, 0, sizeof used);
	reverse(all(topsort));
	for (int i : topsort) {
		if (!used[i]) {
			dfs_comp(i);
			comps++;
		}
	}

	for (int i = 0; i < n; ++i) {
		int u = comp[i];
		for (int j : g[i]) {
			int v = comp[j];
			if (u != v)
				++out[u];
		}
	}
	int ans = n + 1, from = 0;
	for (int i = 0; i < comps; ++i) {
		if (out[i]) continue;
		if (ans > cnt_comp[i]) {
			ans = cnt_comp[i];
			from = i;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (comp[i] == from) {
			from = i;
			break;
		}
	}
	memset(used, 0, sizeof used);
	get_ans(from);
	cout << kekos.size() << '\n';
	for (int i : kekos)
		cout << i + 1 << ' ';
	cout << endl;
	return 0;
}