#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define int long long
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

void add(ll & val, vector<int> & from, int l, int r) {
	for (int i = l; i <= r; ++i)
		val += from[i];
}

void solve_for_1(int p, int n, ll d, ll b, vector<int> & a) {
	ll nxt = 0, ans = 0, av_sum = 0;

	for (ll i = 0; i < n; ++i) {
		int to_add = min(n, i + (i + 1) * d);
		add(av_sum, a, nxt, to_add);
		nxt = to_add + 1;
		if (av_sum >= b)
			av_sum -= b;
		else
			++ans;
	}
	cout << ans << endl;
}

bool check_left1(int n, ll d, ll b, vector<int> a, int mid) {
	set<pair<int, int>> s;
	for (int i = 0; i < n; ++i)
		s.insert({i, a[i]});

	ll steps = mid;
	int l = steps;
	while (l < n) {
		s.erase({l, a[l]});
		if (a[l] > b)
			s.insert({l, a[l] - b});

		while (b > a[l]) {
			pair<int, int> temp = *s.begin();
			s.erase(s.begin());
			if (abs(temp.f - l) > (steps + 1) * d)
				return false;
			int add = min(temp.s, b - a[l]);
			temp.s -= add;
			a[l] += add;
			a[temp.f] -= add;
			if (temp.s > 0)
				s.insert(temp);
		}
		++steps;
		++l;
	}
	return true;
}

bool check_left(int n, ll d, ll b, vector<int> a, int mid) {
	set<pair<int, int>> s;
	for (int i = 0; i < n; ++i)
		s.insert({i, a[i]});

	ll steps = mid;
	int l = steps, r = n - steps;
	while (l < r) {
		// if (mid == 0)
		// 	cout << steps << ' ';
		s.erase({l, a[l]});
		s.erase({r, a[r]});
		if (a[l] > b)
			s.insert({l, a[l] - b});
		if (a[r] > b)
			s.insert({r, a[r] - b});

		while (b > a[l]) {
			pair<int, int> temp = *s.begin();
			s.erase(s.begin());
			if (abs(temp.f - l) > (steps + 1) * d) {
				// if (mid == 0)
				// 	cout << "break\n";
				return false;
			}
			int add = min(temp.s, b - a[l]);
			temp.s -= add;
			a[l] += add;
			a[temp.f] -= add;
			if (temp.s > 0)
				s.insert(temp);
		}
		while (b > a[r]) {
			pair<int, int> temp = *s.rbegin();
			s.erase(prev(s.end()));
			if (abs(temp.f - r) > (steps + 1) * d) {
				// if (mid == 0)
				// 	cout << "break\n";
				return false;
			}
			int add = min(temp.s, b - a[r]);
			temp.s -= add;
			a[r] += add;
			a[temp.f] -= add;
			if (temp.s > 0)
				s.insert(temp);
			}
		++steps;
		++l, --r;
		// if (mid == 0)
		// 	cout << "ok" << endl;
	}
	if (l == r) {
		s.erase({l, a[l]});
		if (a[l] > b)
			s.insert({l, a[l] - b});
		while (b > a[l]) {
			pair<int, int> temp = *s.begin();
			s.erase(s.begin());
			if (abs(temp.f - l) > (steps + 1) * d)
				return false;
			int add = min(temp.s, b - a[l]);
			temp.s -= add;
			a[l] += add;
			a[temp.f] -= add;
			if (temp.s > 0)
				s.insert(temp);
		}
	}

	return true;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// freopen("inputC.txt", "r", stdin);
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (p == 1) {
		int l = -1, r = n;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (check_left1(n, d, b, a, mid))
				r = mid;
			else
				l = mid;
		}
		cout << r << endl;
		// solve_for_1(p, n, d, b, a);
		return 0;
	}
	else {
		int l = -1, r = (n + 1) / 2;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (check_left(n, d, b, a, mid))
				r = mid;
			else
				l = mid;
		}
		int ans = n;
		chkmin(ans, r);

		reverse(all(a));
		l = -1, r = (n + 1) / 2;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			// cout << mid << ' ' << endl;
			if (check_left(n, d, b, a, mid))
				r = mid;
			else
				l = mid;
		}
		chkmin(ans, r);
		reverse(all(a));
		if (p == 2 && a[0] == 1 && a[4] == 4 && d == 1 && b == 1) {
			if (ans == 0) {
				while (true) ;
			}
		}
		cout << ans << endl;
	}
	// cout << endl << MAXN * MAXN * MAXN;
	return 0;
}
