#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

const int MAXABS = 31;
const int MAGIC = 1;
int DEG = 0;
int MAX_DEG;

unordered_set<int> need;
unordered_set<int> can;

int ans;
vector<int> kekos;
vector<int> cans;

void recount(int nw, int & cnt_need) {
	vector<int> av;
	for (int i : can) {
		if (abs(i + nw) <= MAXABS)
			av.pb(i + nw);
	}
	for (int i : av) {
		if (can.find(i) == can.end() && need.find(i) != need.end())
			--cnt_need;
		can.insert(i);
	}
}

void rec(int cnt, int cnt_need) {
	// cout << cnt_need << endl;
	if (cans.size() >= ans) return;
	if (!cnt_need) {
		if (ans > cans.size()) {
			ans = cans.size();
			kekos = cans;
		}
		return;
	}
	int last = (cans.empty() ? -MAX_DEG : cans.back());
	if (cnt <= MAGIC) {
		cans.pb(last);
		auto tmp = can;
		int tmp_cnt_need = cnt_need;

		recount(last, cnt_need);
		rec(cnt + 1, cnt_need);

		can = tmp;
		cnt_need = tmp_cnt_need;
		cans.pop_back();
	}
	int nxt = (last == -1 ? 1 : (last < 0 ? last / 2 : last * 2));
	while (nxt <= MAX_DEG) {
		cans.pb(nxt);
		auto tmp = can;
		int tmp_cnt_need = cnt_need;
		recount(nxt, cnt_need);
		rec(1, cnt_need);
		can = tmp;
		cnt_need = tmp_cnt_need;
		cans.pop_back();
		nxt = (nxt == -1 ? 1 : (nxt < 0 ? nxt / 2 : nxt * 2));
	}
}

void init() {
	while (1 << DEG <= MAXABS) ++DEG;
	MAX_DEG = 1 << DEG;
	ans = DEG * 2;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// freopen("inputD.txt", "r", stdin);
	init();
	int n;
	cin >> n;
	can.insert(0);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x)
			need.insert(x);
	}
	rec(0, need.size());
	cout << ans << '\n';
	for (int i : kekos)
		cout << i << ' ';
	// cout << endl << MAXN * MAXN * MAXN;
	return 0;
}
