#include <iostream>
#include <set>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <vector>

#define x first
#define y second
#define mp(a, b) make_pair((a), (b))
#define sqr(a) (a) * (a)

using namespace std;
typedef long long ll;

const double EPS = 10e-8;
const double INF = 10e8;

void setup();

vector<int> deck[200001];
int l = 100000, r = l + 1;

int main() {
    setup();
    string s;
    for(int i = 50000; i < 150000; i++){
        deck[i].reserve(1000);
    }
    cin >> s;
    if(s[0] == '1'){
        cout << "-1" << endl;
        return 0;
    }
    deck[l + 1].emplace_back(0);
    for(int i = 1; i < s.length(); i++){
        vector<int> temp;
        if(s[i] == '0'){
            if(s[deck[r].back()] == '1'){
                deck[r].emplace_back(i);
                temp = deck[r];
                r--;
                deck[l] = temp;
                l--;
            } else {
                deck[l].emplace_back(i);
                l--;
            }
        } else {
            if(s[deck[l + 1].back()] == '0'){
                deck[l + 1].emplace_back(i);
                temp = deck[l + 1];
                l++;
                r++;
                deck[r] = temp;
            } else {
                cout << "-1" << endl;
                return 0;
            }
        }
    }
    if(s[deck[r].back()] == '1'){
        cout << "-1" << endl;
        return 0;
    }
    cout << r - l << endl;
    for(int i = l + 1; i <= r; i++){
        cout << deck[i].size() << ' ';
        for(auto j: deck[i]){
            cout << j + 1 << ' ';
        }
        cout << endl;
    }
    return 0;
}

void setup(){
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(false);
}