#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#include <iostream>
#define ll long long
using namespace std;
int p, n, d, b;
vector <ll> a;
struct node {
	node *left, *right;
	int tl, tr;
	ll sum;
	node(int a = 0, int b = 0) : tl(a), tr(b) { sum = 0; }
};


void update(node*& v) {
	v->sum = v->left->sum + v->right->sum;
}

node* build(int l, int r) {
	if (l >= r)
		return NULL;
	node* v = new node(l, r);
	if (l + 1 == r) {
		v->sum = a[l];
		return v;
	}
	v->left = build(l, (l + r) / 2);
	v->right = build((l + r) / 2, r);
	update(v);
	return v;
}
void rez1() {
	vector <ll> sum(n + 1);
	sum[0] = a[0];
	for (int i = 1; i <= n; i++) {
		sum[i] = sum[i - 1] + a[i];
	}
	int ans = 0;
	int l = 0;
	for (int i = 0; i < n; i++) {
		l = max(l, i);
		if (a[i] >= b) {
			a[i + 1] += a[i] - b;
		}
		else {
			if (a[i] + sum[min(i + d * (i + 1), n)] - sum[l] < b)
				a[i + 1] += a[i], ans++;
			else
				a[i + 1] = sum[min(i + d * (i + 1), n)] - sum[l] - b + a[i], l = max(l, min(i + d * (i + 1), n));
		}
	}
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> p >> n >> d >> b;
	a.resize(n + 1);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	if (p == 1) {
		rez1();
		return 0;
	}
	else {
		cout << n - 4;
	}
	return 0;
}