#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#include <iostream>
#define ll long long
using namespace std;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	vector <int> nx(n, -1), used(n, 0);
	int l = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0')
			continue;
		while ((l < i) && (s[l] != '0'))
			l++;
		nx[l] = i;
		if (l == i) {
			cout << -1;
			return 0;
		}
		l++;
	}
	int r = n - 1;

	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '0')
			continue;
		while ((r > i) && (s[r] != '0'))
			r--;
		nx[i] = r;
		if (r == i) {
			cout << -1;
			return 0;
		}
		r--;
	}

	vector <vector <int> > ans;
	int k = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			ans.push_back(vector <int>(0));
			int p = i;
			while (p != -1) {
				used[p] = 1;
				ans[k].push_back(p + 1);
				p = nx[p];
			}
			k++;
		}
	}

	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size() << " ";
		for (int x : ans[i])
			cout << x << " ";
		cout << "\n";
	}
	return 0;
}