#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define F(i, n) for(int i = 0; i < n; ++ i)

int input() {
    int n = 0, m = 1;
    char c = getchar();
    while(!((c >= '0' && c <= '9') || c == '-')) c = getchar();
    if(c == '-') m = -1, c = getchar();
    while(c >= '0' && c <= '9') {
        n = n * 10 + c - '0';
        c = getchar();
    }
    return n * m;
}

vector<int> v;

vector<int> h;

bool bit(int &msk, int ind) {
    return ((msk >> ind) & 1);
}

bool contains(vector<int> &g, int element) {
    auto iter = lower_bound(g.begin(), g.end(), element);
    return (iter != g.end() && *iter == element);
}

int get_next(int y) {
    if(contains(h, y)) return y;
    return *upper_bound(h.begin(), h.end(), y);
}

int get_prev(int y) {
    if(contains(h, y)) return y;
    auto iter = upper_bound(h.begin(), h.end(), y);
    -- iter;
    return *iter;
}

bool fch(int o, vector<int> &g) {
    int f = o;
        bool b = true;
        while(f) {
            int x = get_prev(f);
            //cout << 'x' << x << endl;
            if(!contains(g, x)) {
                b = false;
                break;
            }
            f -= x;
        }
        if(b) return true;

        b = true;
        int nxt = get_next(o);
        f = nxt - o;
        if(!contains(g, nxt)) return false;
        while(f) {
            int x = get_prev(f);
            if(!contains(g, -x)) {
                b = false;
                break;
            }
            f -= x;
        }
        return b;
}

bool dch(int o, vector<int> &g) {
    int f = o;
        bool b = true;
        while(f) {
            int x = get_prev(f);
            //cout << 'x' << x << endl;
            if(!contains(g, -x)) {
                b = false;
                break;
            }
            f -= x;
        }
        if(b) return true;

        b = true;
        int nxt = get_next(o);
        f = nxt - o;
        if(!contains(g, -nxt)) return false;
        while(f) {
            int x = get_prev(f);
            if(!contains(g, x)) {
                b = false;
                break;
            }
            f -= x;
        }
        return b;
}

bool check(vector<int> g) {
    for(int i = 0; i < v.size(); ++ i) {
        int o = v[i];
        //cout << 'o' << o << endl;
        if(o > 0) {
            if(!fch(o, g)) return false;
        }
        if(o < 0) {
            if(!dch(-o, g)) return false;
        }
    }
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    //freopen("output.txt", "w", stdout);
    int n = input();
    v.resize(n);
    F(i, n) v[i] = input();
    vector<int> q;
    for(int i = 1; i < 2e5; i *= 2) {
        q.push_back(i);
        q.push_back(-i);
    }
    h = q;
    sort(h.begin(), h.end());
    /*vector<int> ch;
    ch.push_back(4);
    cout << check(ch);
    return 0;*/
    vector<int> ans;
    int bst = INT_MAX;
    for(int msk = 0; msk < (1 << 17); ++ msk) {
        vector<int> g;
        for(int i = 0; i < 20; ++ i) {
            if(bit(msk, i)) g.push_back(q[i]);
        }
        sort(g.begin(), g.end());
        if(check(g)) {
            if(g.size() < bst) {
                bst = g.size();
                ans = g;
            }
        }
    }
    cout << ans.size() << endl;
    F(i, ans.size()) cout << ans[i] << ' ';
}

