#include <iostream>
#include <vector>
using namespace std;

vector<vector<int> > g;

vector<int> used;

vector<int> cur;

vector<int> changed;

void dfs(int v, int c){
    used[v] = c;
    cur.push_back(v);
    for (auto i : g[v]){
        if (used[i] != c){
            dfs(i, c);
        }
    }
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> time(n);
    for (int i = 0; i < n; i++){
        cin >> time[i];
    }
    g.resize(n);
    vector<pair<int, int> > p(m);
    vector<vector<int> > q(n);
    for (int i = 0; i < m; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first--;
        p[i].second--;
        q[p[i].first].push_back(i);
        q[p[i].second].push_back(i);
    }
    for (int i = 0; i < n; i++){
        for (auto f : q[i]){
            if (i == p[f].first){
                if (time[p[f].second] == (time[i] + 1) % h){
                    g[i].push_back(p[f].second);
                }
            }else{
                if (time[p[f].first] == (time[i] + 1) % h){
                    g[i].push_back(p[f].first);
                }
            }
        }
    }
    vector<int> answer;
    int ans = 1e9;
    used.resize(0);
    used.resize(n, -1);
    for (int i = 0; i < n; i++){
        changed.resize(0);
        cur.resize(0);
        dfs(i, i);
        if (ans > cur.size()){
            answer = cur;
            ans = cur.size();
        }
    }
    cout << ans << endl;
    for (auto i : answer){
        cout << i + 1 << ' ';
    }
    cout << endl;
    return 0;
}
