#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int n, m, h;
vec<unordered_set<int> > g;
vec<int> color, a;
bool f = false;

int dfs(int v) {
    color[v] = true;

    int u = *g[v].begin();
    if (color[u]) { f = true; cout << v + 1 << " "; return u; }
    int x = dfs(u);
    if (f) { cout << v + 1 << " "; }
    if (x == v) { f = false; }
    return x;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> h;
    g = vec<unordered_set<int> >(n);
    a = color = vec<int>(n);

    for (int &k : a) { cin >> k; }
    for (int k = 0; k < m; k++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        if ((a[v] + 1) % h == a[u]) { g[v].insert(u); }
        if ((a[u] + 1) % h == a[v]) { g[u].insert(v); }
    }

    for (int k = 0; k < n; k++) {
        if (g[k].empty()) { cout << "1 \n" << k + 1 << '\n'; return 0; }
    }
    cout << h << '\n';
    dfs(0);

    return 0;
}
