#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

using namespace std;

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    
	string s;
	cin >> s;
	int n = s.length();

	vector<vector<int>> answ;

	vector<int> o, e;

	fi(n)
	{
		if (s[i] == '0')
		{
			if (e.empty())
			{
				answ.push_back({i + 1});
				o.push_back(answ.size() - 1);
			}
			else
			{
				answ[e.back()].push_back(i + 1);
				o.push_back(e.back());
				e.pop_back();
			}
		}
		else
		{
			if (o.empty())
				return cout << -1 << endl, 0;
			answ[o.back()].push_back(i + 1);
			e.push_back(o.back());
			o.pop_back();
		}
	}

	for (auto &i : answ)
		if (s[i.back() - 1] == '1')
			return cout << -1 << endl, 0;
	cout << answ.size() << endl;
	for (auto &j : answ)
	{
		cout << j.size() << " ";
		for (auto &i : j)
			cout << i << " ";
		cout << endl;
	}
    return 0;
}

