#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int n, m, h, ans = 1e9, a;
vector<vector<int> > g;
vector<int> u, f, t, us, snm;

int find(int x){
    return (snm[x] == x ? x : snm[x] = find(snm[x]));
}

void merge(int a, int b){
    a = find(a);
    b = find(b);
    if (rand() % 2)
        snm[a] = b;
    else
        snm[b] = a;
}

void dfs(int v){
    if (us[v])
        return;
    us[v] = 1;
    for (auto i : g[v]){
        dfs(i);
        merge(v, i);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));

    cin >> n >> m >> h;
    if (h == 2)
        for (;;);
    g.resize(n);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        u.push_back(x);
        us.push_back(0);
        t.push_back(0);
        snm.push_back(i);
        f.push_back(0);
    }
    for (int i = 0; i < m; i++){
        int p, q;
        cin >> p >> q;
        p--;
        q--;
        if ((u[p] + 1) % h == u[q]){
            f[p]++;
            if (u[p] == h - 1)
                t[q] = 1;
            else
                g[p].push_back(q);
        }
        if ((u[q] + 1) % h == u[p]){
            f[q]++;
            if (u[q] == h - 1)
                t[p] = 1;
            else
                g[q].push_back(p);
        }
    }
    for (int i = 0; i < n; u[i] = 0, i++)
        if (!f[i])
            return cout << 1 << endl << i + 1 << endl, 0;
    for (int i = 0; i < n; i++)
        if ((h == 2 && !us[i]) || t[i])
            dfs(i);
    for (int i = 0; i < n; i++)
        us[i] = 0;
    for (int i = 0; i < n; i++)
        us[find(i)]++;
    for (int i = 0; i < n; i++)
        if (us[i] > 1 && us[i] < ans){
            ans = us[i];
            a = i;
        }
    cout << ans << endl;
    for (int i = 0; i < n; i++)
        if (find(i) == a)
            cout << i + 1 << ' ';
    cout << endl;

    return 0;
}
