#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(s) s.begin(), s.end()

#define bp __builtin_popcountll
#define b_clz __builtin_clzll
#define b_ctz __builtin_ctzll

typedef long long llong;
typedef unsigned long long ullong;

typedef vector <int> vi;
typedef vector <llong> vl;

typedef pair <int, int> pii;

const int MXN = 1e6 + 1;
const int MNN = 1e3 + 1;
const int INF = 1e9;
const llong MOD = 1e9 + 7;
const llong LINF = 1e18;

llong log2 (llong x) {return 64 - b_clz (x) - 1;};
llong __lcm (llong x, llong y) {return x / __gcd (x, y) * y;};

string s;

int n;

bool used[MXN];

vi pos[2];
vector <vi> ans;

char inv (char x) {
	return (x == '1' ? '0' : '1');
}

int main () {
	//freopen ("input.txt", "r", stdin);
	cin >> s;
	n = s.size ();
	for (int i = 0; i < n; ++ i) {
		pos[s[i] - '0'].pb (i);
	}
	for (int i : pos[0]) {
		if (used[i]) continue;
		vi cur;
		int x = i;
		cur.pb (x);
		while (1) {
			int ppos = -1;
			for (int j : pos[inv (s[x]) - '0']) {
				if (!used[j] && i < j) {
					used[j] = 1;
					ppos = j;
					break;
				}
			}
			if (ppos == -1) break;
			cur.pb (ppos);
			x = ppos;
		}
		if (s[cur[cur.size () - 1]] == '1') {
			used[cur[cur.size () - 1]] = 0;
			cur.erase (cur.begin () + (cur.size () - 1));
		}
		ans.pb (cur);
	}
	for (int i = 0; i < n; ++ i) {
		if (!used[i] && s[i] == '1') return cout << "-1", 0;
	}
	cout << ans.size () << '\n';
	for (vi it : ans) {
		cout << it.size () << ' ';
		for (int i : it) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}
	return 0;
}