#include <bits/stdc++.h>


using namespace std;

vector <int> c;
vector <vector <int> > g, g1;
vector <set <int> > gc;
vector <bool> used;
vector <int> order;
vector <int> sz;
vector <int> dp;

const int INF = 1e9;

void sortdfs(int v, bool f) {
    if (f) {
        cout << v + 1 << " ";
    }
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            sortdfs(u, f);
        }
    }
    order.push_back(v);
}

void coldfs(int v, int col) {
    c[v] = col;
    sz[col]++;
    for (int u : g1[v]) {
        if (c[u] == -1) {
            coldfs(u, col);
        }
    }
}

int solve(int v) {
    if (dp[v] != -1) {
        return dp[v];
    }
    dp[v] = sz[c[v]];
    for (int u : gc[v]) {
        dp[v] += solve(u);
    }
    return dp[v];
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    g.resize(n);
    g1.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if ((t[u] + 1) % h == t[v]) {
            g[u].push_back(v);
            g1[v].push_back(u);
        }
        if ((t[v] + 1) % h == t[u]) {
            g[v].push_back(u);
            g1[u].push_back(v);
        }
    }
    used.resize(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            sortdfs(i, 0);
        }
    }
    reverse(order.begin(), order.end());
    c.resize(n, -1);
    int k = 0;
    sz.resize(n, 0);
    for (int i = 0; i < n; i++) {
        if (c[order[i]] == -1) {
            coldfs(order[i], k++);
        }
    }
    gc.resize(k);
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            if (c[i] != c[j]) {
                gc[i].insert(j);
            }
        }
    }
    dp.resize(k, -1);
    for (int i = 0; i < k; i++) {
        if (dp[i] == -1) {
            solve(i);
        }
    }
    int mn = INF, id;
    for (int i = 0; i < n; i++) {
        if (dp[c[i]] < mn) {
            mn = dp[c[i]];
            id = i;
        }
    }
    cout << mn << endl;
    used.assign(n, false);
    sortdfs(id, 1);
    return 0;
}
