#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;


const int INF = 1e9;

int main()
{
    map <pair <int, int>, set <int> > d;
    vector <int> cnt(512);
    for (int i = 0; i < 512; i++) {
        for (int j = 0; j < 9; j++) {
            cnt[i] += (bool)(i & (1 << j));
        }
    }
    for (int pos = 0; pos < 64; pos++) {
        for (int neg = 0; neg < 64; neg++) {
            if (pos == 0) {
                if (neg == 0) {
                    d[{pos, neg}] = {0};
                    continue;
                }
                int i = 0;
                while(!(neg & (1 << i))) i++;
                set <int> old = d[{pos, neg ^ (1 << i)}];
                d[{pos, neg}] = old;
                for (auto x : old) {
                    d[{pos, neg}].insert(x - (1 << i));
                }
            }
            else {
                int i = 0;
                while(!(pos & (1 << i))) i++;
                set <int> old = d[{pos ^ (1 << i), neg}];
                d[{pos, neg}] = old;
                for (auto x : old) {
                    d[{pos, neg}].insert(x + (1 << i));
                }
            }
        }
    }
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int mn = INF;
    pair <int, int> ans;
    for (int pos = 0; pos < 64; pos++) {
        for (int neg = 0; neg < 64; neg++) {
            bool f = true;
            for (int j = 0; j < n; j++) {
                if (!d[{pos, neg}].count(a[j])) {
                    f = false;
                    break;
                }
            }
            if (f && cnt[pos] + cnt[neg] < mn) {
                mn = cnt[pos] + cnt[neg];
                ans = {pos, neg};
            }
        }
    }
    cout << mn << endl;
    for (int i = 0; i < 9; i++) {
        if (ans.first & (1 << i)) {
            cout << (1 << i) << " ";
        }
    }
    for (int i = 0; i < 9; i++) {
        if (ans.second & (1 << i)) {
            cout << -(1 << i) << " ";
        }
    }
    return 0;
}
