#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int int64_t
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

vector <vector <int> > g;
vector <bool> used;

void dfs(int v) {
    used[v] = true;
    for (auto x : g[v]) {
        if (!used[x])
            dfs(x);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    g.resize(n);
    vector <int> t(n);
    cin >> t;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        assert(t[a] != t[b]);
        --a;
        --b;
        if ((t[a] + 1) % h == t[b])
            g[a].push_back(b);
        else if (t[a] == (t[b] + 1) % h)
            g[b].push_back(a);
    }
    vector <int> ans(n + 1);
    for (int i = 0; i < n; ++i) {
        used.assign(n, false);
        dfs(i);
        int cnt = 0;
        for (auto x : used)
            cnt += x;
        if (cnt < ans.size()) {
            ans.clear();
            for (int i = 0; i < n; ++i) {
                if (used[i]) {
                    ans.push_back(i + 1);
                }
            }
        }
    }
    cout << ans.size() << endl;
    cout << ans << endl;
    return 0;
}
