
#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int int64_t
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}


signed main()
{
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector <int> arr(n);
    cin >> arr;
    vector <int> pref(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + arr[i];
    if (p == 1) {
        int l = -1, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            bool flag = true;
            for (int i = m; i < n; ++i) {
                int rr = min(n - 1, i + i * d + d);
                if (pref[rr + 1] < (i - m + 1) * b) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                r = m;
            }
            else {
                l = m;
            }
        }
        cout << r << endl;
    }
    else {
        int l = -1, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            bool flag = false;
            for (int i = 0; i < m; ++i) {
                bool flag2 = true;
                for (int j = i + 1; j < n / 2 & flag2; ++j) {
                    int t = j + 1;
                    int rr = min(n - 1, j + t * d);
                    if (pref[rr + 1] < (j - i) * b) {
                        flag2 = false;
                    }
                }
                for (int j = n / 2; j < n - (m - i) && flag2; ++j) {
                    int ll = max(0ll, n - j);
                    if (pref[n] - pref[ll] < n - (m - i) - j) {
                        flag2 = false;
                    }
                }
                if (flag2) {
                    flag = true;
                    break;
                }
            }
            if (flag) {
                r = m;
            }
            else {
                l = m;
            }
        }
        cout << r << endl;
    }
    return 0;
}
