#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int int64_t
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;
    int n = s.size();
    vector <int> group(n);
    set <int> nol;
    set <int> odin;
    int it = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (odin.size() > 0) {
                group[i] = group[*odin.begin()];
                odin.erase(odin.begin());
                nol.insert(i);
            }
            else {
                group[i] = it++;
                nol.insert(i);
            }
        }
        else {
            if (nol.size() == 0)
            {
                cout << -1 << endl;
                return 0;
            }
            odin.insert(i);
            group[i] = group[*nol.begin()];
            nol.erase(nol.begin());
        }
    }
    if (odin.size() > 0) {
        cout << -1 << endl;
        return 0;
    }
    vector <vector <int> > ans(it);
    for (int i = 0; i < n; ++i) {
        ans[group[i]].push_back(i + 1);
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].size() << " " << ans[i];
    }
    return 0;
}
