#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define kektor vector
#define kektorov vector
#define all(a) a.begin(), a.end()

/*
  :

  :
-   ?
- ,    

 -     ,
         ,
   !   !

- ,  
-    ?

-     ?
- " "?
- " ".

    ,
   .
 ,   
   .
*/

using namespace std;

void main30(int n, int m, int h){
    vector<int> ans;
    int answer = 1e9 + 1000;
    kektor<int> kek(n);
    kektor<pair<int, int>> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> kek[i];
        b[i] = {kek[i], i};
    }
    sort(all(b));
    kektor<kektorov<int>> v(n, kektor<int>(n, 0));
    for (int i = 0; i < m; ++i) {
        int u1, u2;
        cin >> u1 >> u2;
        u1--;
        u2--;
        v[u1][u2] = 1;
        v[u2][u1] = 1;
    }
    int mask = 1;

    while (mask <= ((1 << n) - 1)) {
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                int j;
                if (b[i].first == h-1) {
                    j = 0;
                }
                else {
                    j = i + 1;
                }
                while (j < n && b[j].first <= (b[i].first + 1) % h) {
                    if (b[j].first == (b[i].first + 1) % h)
                        if (!((mask >> j) & 1) && v[b[i].second][b[j].second]) {
                            ok = false;
                            break;
                        }
                    j++;;
                }
            }
            if (! ok) {
                break;
            }
        }
        if (ok) {
            int newans = 0;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    newans++;
                }
            }
            if (newans < answer) {
                answer = newans;
                ans.resize(0);
                for (int i = 0; i < n; ++i) {
                    if ((mask >> i) & 1) {
                        ans.push_back(b[i].second + 1);
                    }
                }
            }
        }
        mask++;
    }
    cout << answer << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] << " ";
    }
}

struct node{
    int u = 0;
    int nom = 0;
    vector<int> go;
};

vector<node> v;
vector<bool> used;
vector<int> dist;

vector<int> ans;
int kol = 1e9 + 1000;

void dfs(int i) {
    used[i] = true;
    for (int j = 0; j < v[i].go.size(); ++j) {
        int u = v[i].go[j];
        if (!used[u]) {
            dfs(u);
        }
        dist[i] = max(dist[i], dist[u]);
    }
    dist[i]++;
}

void dfs1(int i) {
    ans.push_back(v[i].nom);
    //cout << "--> " << v[i].nom << endl;
    used[i] = true;
    for (int j = 0; j < v[i].go.size(); ++j) {
        int u = v[i].go[j];
        //cout << "-> " << u << endl;
        if (!used[u]) {
            dfs1(u);
        }
    }
}

void main60() {
    int n, m, h;
    cin >> n >> m >> h;
    if (n <= 10) {
        main30(n, m, h);
    }
    v.resize(n);
    used.resize(n);
    dist.resize(n);
    vector<pair<int, int>> a(n);
    vector<vector<int>> g(n, vector<int> (n, 0));
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(all(a));
    for (int i = 0; i < m; ++i) {
        int u1, u2;
        cin >> u1 >> u2;
        u1--; u2--;
        g[u1][u2] = 1;
        g[u2][u1] = 1;
    }
    for (int i = 0; i < n; ++i) {
        v[i].u = a[i].first;
        v[i].nom = a[i].second + 1;
        int j = 0;
        if (v[i].u == h-1)
            j = 0;
        while (j < n && a[j].first <= (a[i].first + 1) % h) {
            if (a[j].first == (a[i].first + 1) % h && g[a[j].second][a[i].second]) {
                v[i].go.push_back(j);
            }
            j++;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (v[i].go.empty()) {
            cout << 1 << endl << v[i].nom;
            return;
        }
    }

    int vert = 0;
    for (int i = 0; i < n; ++i) {
        dist.clear();
        used.clear();
        dist.resize(n, 0);
        used.resize(n, false);
        dfs(i);
        if (dist[i] < kol) {
            kol = dist[i];
            vert = i;
        }
    }
/*
    for (int i = 0; i < v[1].go.size(); ++i) {
        cout << v[1].go[i] << " ";
    }
    cout << endl;
*/
    used.clear();
    used.resize(n, false);
    dfs1(vert);
    cout << kol << endl;
    for (int i = 0; i < kol; ++i) {
        cout << ans[i] << " ";
    }
}

int main()
{
    main60();
    return 0;
}
