#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (int i = 0; i < n; i++) {
        cin >> u[i];
    }
    vector<vector<int> > g(n);
    int x, y;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
          x--;
          y--;
        if ((u[x] + 1) % h == u[y]) {
            g[x].push_back(y);
        }
        if ((u[y] + 1) % h == u[x]) {
            g[y].push_back(x);
        }
    }
    bool flag = true;
    for (int i = 0; i < n && flag; i++) {
        if (g[i].size() == 0) {
            flag = false;
            cout << 1 << endl << i + 1;
        }
    }
    if (flag) {
        vector<bool> used2(n, false);
        queue<int> q;
        vector<int> c;
        vector<int> ans;
        vector<int> prev(n);
        for (int i = 0; i < n; i++) {
                fill(used2.begin(), used2.end(), false);
                c.clear();
                q.push(i);
                used2[i] = true;
                while(!q.empty()) {
                    x = q.front();
                    q.pop();
                    c.push_back(x);
                    for (int j = 0; j < g[x].size(); j++) {
                        y = g[x][j];
                        if (!used2[y]) {
                            q.push(y);
                            prev[y] = x;
                            used2[y] = true;
                        }
                    }
                }
                if (ans.size() > c.size() || ans.size() == 0) {
                    ans = c;
                }
        }
        cout << ans.size() << endl;
        for (int i = 0; i < n; i++) {
            cout << ans[i] + 1 << " ";
        }
    }
    return 0;
}
