#include <iostream>
#include <cstring>
#include <stack>
#include <vector>

using namespace std;

int main()
{
    string s;
    cin >> s;
    int x = 0;
    int y = 0;
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            x++;
        }
        else {
            y++;
        }
    }
    if (y >= x) {
        cout << -1;
    }
    else if (y == 0) {
        cout << n << endl;
        for (int i = 1; i <= n; i++) {
            cout << 1 << " " << i << endl;
        }
    }
    else {
        vector<int> p(n, -1);
        stack<int> a0;
        stack<int> a1;
        bool flag = true;
        for (int i = 0; i < n && flag; i++) {
            if (s[i] == '0') {
                if (!a1.empty()) {
                    p[i] = a1.top();
                    a1.pop();
                }
                a0.push(i);
            }
            else {
                if (!a0.empty()) {
                    p[i] = a0.top();
                    a0.pop();
                }
                else {
                    flag = false;
                }
                a1.push(i);
            }
        }
        if (!a1.empty()) {
            flag = false;
        }
        if (!flag) {
            cout << -1;
        }
        else {
            int o;
            vector<vector<int> > ans;
            vector<int> c;
            vector<bool> used(n, false);
            for (int i = n - 1; i >= 0; i--) {
                if (!used[i]) {
                    c.clear();
                    o = i;
                    used[i] = true;
                    while (p[o] >= 0) {
                        c.push_back(o + 1);
                        o = p[o];
                        used[o] = true;
                    }
                    used[o] = true;
                    c.push_back(o + 1);
                    ans.push_back(c);
                }
            }
            cout << ans.size() << endl;
            for (int i = 0; i < ans.size(); i++) {
                cout << ans[i].size() << " ";
                for (int j = ans[i].size() - 1; j >= 0; j--) {
                    cout << ans[i][j] << " ";
                }
                cout << endl;
            }
        }
    }
    return 0;
}
