#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

ll maxp = 5;

ll sign(ll a)
{
	if (a > 0)
		return 1;

	if (a < 0)
		return -1;

	return 0;
}

void getp(ll val, vector<ll> &used)
{
	vector<ll> v;

	while (val > 0)
	{
		v.push_back(val % 2);
		val /= 2;
	}

	reverse(v.begin(), v.end());

	ll p = 0;

	for (int i = v.size() - 1; i >= 0; --i)
	{
		used[p] += v[i];
		++p;
	}
}

int main()
{
    //freopen("inputD.txt", "r", stdin);
    //freopen("outputD.txt", "w", stdout);

	ll n;
	cin >> n;

	vector<ll> a(n);
	
	vector<ll> ans;

	ll sg= 1;

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];

		sg = sign(a[i]);

		a[i] *= sg;

		vector<ll> used(maxp);
		getp(a[i], used);

		for (int j = 0; j < used.size(); ++j)
		{
			if (used[j])
			{
				ans.push_back(j);
			}
		}
	}

	cout << ans.size() << endl;

	for (int i = 0; i < ans.size(); ++i)
	{
		cout << (1 << ans[i]) * sg << " ";
	}
	
	puts("");
    return 0;
}