#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

ll maxp = 5;

ll sign(ll a)
{
	if (a > 0)
		return 1;

	if (a < 0)
		return -1;

	return 0;
}

void getp(ll val, vector<ll> &used)
{
	vector<ll> v;

	while (val > 0)
	{
		v.push_back(val % 2);
		val /= 2;
	}

	reverse(v.begin(), v.end());

	ll p = 0;

	for (int i = v.size() - 1; i >= 0; --i)
	{
		used[p] += v[i];
		++p;
	}
}

void pls(vector<ll> &vec)
{
	ll ost = 1;

	for (int i = vec.size() - 1; i >= 0; --i)
	{
		vec[i] += ost;
		ost = 0;

		if (vec[i] > 2)
		{
			vec[i] = 0;
			ost = 1;
		}
	}
}

int main()
{
    //freopen("inputD.txt", "r", stdin);
    //freopen("outputD.txt", "w", stdout);

	
	ll n;
	cin >> n;

	vector<ll> a(n);
	
	vector<ll> ans;

	ll sg= 1;

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];

		vector<ll> msk(maxp, 0);

		for (int iter = 0; iter < pow(3, maxp); ++iter)
		{
			ll val = 0;
			
			vector<ll> curans;
			for (int j = 0; j < msk.size(); ++j)
			{
				if (msk[j] == 1)
				{
					val += (1 << j);
					curans.push_back(1ll << j);
				}
				else if (msk[j] == 2)
				{
					val -= (1 << j);
					curans.push_back(- (1ll << j));
				}
			}

			if (val == a[i] && (curans.size() < ans.size() || ans.size() == 0))
			{
				ans = curans;
			}

			pls(msk);
		}

	}

	cout << ans.size() << endl;

	for (int i = 0; i < ans.size(); ++i)
	{
		cout << ans[i] << " ";
	}
	
	puts("");
    return 0;
}