#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int F(long now, vector <long> &data, vector <vector <long> > &basa, long h, vector <long> &v) {
    for (int i = 0; i < basa[now].size(); i++) {
        if (data[now - 1] == data[basa[now][i] - 1]) {
            data[basa[now][i] - 1] = (data[basa[now][i] - 1] + 1) % h;
            v.push_back(basa[now][i]);
            F(basa[now][i], data, basa, h, v);
        }
    }
}

int main() {
    long n, m, h, x, ind = 0;
    cin >> n >> m >> h;
    vector <long> data(n);
    set <long> s;
    for (int i = 0; i < n; i++) {
        cin >> data[i];
        s.insert(data[i]);
    }
    vector <pair <long, long> > cli(m);
    vector <vector <long> > basa(n + 1);
    for (int i = 0; i < m; i++) {
        cin >> cli[i].first >> cli[i].second;
        basa[cli[i].first].push_back(cli[i].second);
        basa[cli[i].second].push_back(cli[i].first);
    }
    vector <long> v;
    for (int i = 0; i < n; i++) {
        x = data[i] + 1;
        if (x == h) x = 0;
        if (s.find(x) == s.end()) {
            cout << 1 << endl << i + 1 << endl;
            ind = 1;
            break;
        }
    }
    if (ind == 0) {
        long min1 = basa[1].size(), now = 1, time;
        for (int i = 1; i <= n; i++) {
            if (basa[i].size() < min1) {
                min1 = basa[i].size();
                now = i;
            }
        }
        time = data[now - 1] + 1;
        if (time == h) time = 0;
        data[now - 1] = time;
        v.push_back(now);
        F(now, data, basa, h, v);
        cout << v.size()<< endl;
        for (int i = 0; i < v.size(); i++)
            cout << v[i] << " ";
    }
}

