#include<iostream>
#include<vector>
#include<stack>
#include<algorithm>
#include<unordered_set>

using namespace std;


stack<int> visit;
vector<int> anssize;
 


void dfs1(int curr, vector<vector<int>> &gr, vector<int> &used)
{
	used[curr] = 1;
	visit.push(curr);
	for (int i = 0; i < gr[curr].size(); i++)
	{
		if (used[gr[curr][i]] == 0)
		{
			dfs1(gr[curr][i], gr, used);
			anssize[curr] += anssize[gr[curr][i]];
		}
		if (used[gr[curr][i]] == 2) {
			anssize[curr] += anssize[gr[curr][i]];
		}
	}
	used[curr] = 2;
}


void dfs(int curr, vector<vector<int>> &gr, vector<int> &ans, vector<bool> &used) 
{
	if (used[curr]) return;
	used[curr] = true;
	ans.push_back(curr);
	for (int i = 0; i < gr[curr].size(); i++)
	{
		dfs(gr[curr][i], gr, ans, used);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, h;
	cin >> n >> m >> h;

	vector<int> u(n);

	for (int i = 0; i < n; i++)
	{
		cin >> u[i];
	}

	vector<vector<int>> gr(n);
	anssize = vector<int>(n, 1);

	vector<unordered_set<int>> alrd(n);

	int c1, c2;
	for (int i = 0; i < m; i++) {
		cin >> c1 >> c2;
		c1--; c2--;
		if ((u[c1] + 1)%h == u[c2])
		{
			if (alrd[c1].find(c2) == alrd[c1].end())
			{
				gr[c1].push_back(c2);
				alrd[c1].insert(c2);
			}
		}
		if ((u[c2] + 1) % h == u[c1])
		{
			if (alrd[c2].find(c1) == alrd[c2].end())
			{
				gr[c2].push_back(c1);
				alrd[c2].insert(c1);
			}
		}
	}

	/*cout << '\n';
	for (int i = 0; i < n; i++) {
		cout << i << ": ";
		for (int j = 0; j < gr[i].size(); j++) {
			cout << gr[i][j] << ' ';
		}
		cout << '\n';
	}
	cout << '\n';*/

	/*vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		vector<int> res;
		vector<bool> used(n, false);
		dfs(i, gr, res, used);
		if (ans.size() > res.size() || ans.empty()) {
			ans = res;
		}
	}*/

	vector<int> used1(n);
	for (int i = 0; i < n; i++) {
		if (used1[i] == 0)
		{
			dfs1(i, gr, used1);
		}
	}

	while (!visit.empty()) {
		int num = visit.top();
		visit.pop();
		for (int i = 0; i < gr[num].size(); i++) {
			anssize[num] = max(anssize[num], anssize[gr[num][i]]);
		}
	}

	int anspos = -1;
	int ansval = 1e9;

	//cout << "as: ";
	for (int i = 0; i < n; i++)
	{
		//cout << anssize[i] << ' ';
		if (anssize[i] < ansval) {
			ansval = anssize[i];
			anspos = i;
		}
	}
	//cout << '\n';

	vector<bool> used(n);
	vector<int> ans;
	dfs(anspos, gr, ans, used);

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << '\n';

	//cout << "Hi\n";

	//system("pause");
	return 0;
}