#include<iostream>
#include<vector>
#include<stack>
#include<algorithm>
#include<unordered_set>
#include<unordered_map>

using namespace std;


stack<int> visit;

void dfs1(int curr, vector<vector<int>> &gr, vector<bool> &used)
{
	if (used[curr]) return;
	used[curr] = true;
	for (int i = 0; i < gr[curr].size(); i++)
	{
			dfs1(gr[curr][i], gr, used);
	}
	visit.push(curr);
}

vector<int> dict;


void dfs2(int curr, vector<vector<int>> &gr, vector<bool> &used, int iter)
{
	if (!used[curr]) return;
	used[curr] = false;
	dict[curr] = iter;
	for (int i = 0; i < gr[curr].size(); i++)
	{
		dfs2(gr[curr][i], gr, used, iter);
	}
}

/*void dfs(int curr, vector<vector<int>> &gr, vector<int> &ans, vector<bool> &used) 
{
	if (!used[curr]) return;
	used[curr] = false;
	ans.push_back(curr);
	for (int i = 0; i < gr[curr].size(); i++)
	{
		dfs(gr[curr][i], gr, ans, used);
	}
}*/

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, h;
	cin >> n >> m >> h;

	vector<int> u(n);

	for (int i = 0; i < n; i++)
	{
		cin >> u[i];
	}

	dict = vector<int>(n);

	vector<vector<int>> gr(n);
	vector<vector<int>> grrev(n);

	vector<unordered_set<int>> alrd(n);
	vector<unordered_set<int>> alrdrev(n);

	int c1, c2;
	for (int i = 0; i < m; i++) {
		cin >> c1 >> c2;
		c1--; c2--;
		if ((u[c1] + 1)%h == u[c2])
		{
			if (alrd[c1].find(c2) == alrd[c1].end())
			{
				gr[c1].push_back(c2);
				alrd[c1].insert(c2);
			}

			if (alrdrev[c2].find(c1) == alrdrev[c2].end())
			{
				grrev[c2].push_back(c1);
				alrdrev[c2].insert(c1);
			}

		}
		if ((u[c2] + 1) % h == u[c1])
		{
			if (alrd[c2].find(c1) == alrd[c2].end())
			{
				gr[c2].push_back(c1);
				alrd[c2].insert(c1);
			}

			if (alrdrev[c1].find(c2) == alrdrev[c1].end())
			{
				grrev[c1].push_back(c2);
				alrdrev[c1].insert(c2);
			}
		}
	}

	vector<bool> used(n);
	for (int i = 0; i < n; i++) {
		if (used[i] == 0)
		{
			dfs1(i, gr, used);
		}
	}
	//cout << "dfs1 OK\n";

	int iterat = 0;
	while (!visit.empty()) {
		int num = visit.top();
		visit.pop();
		if (used[num]) {
			dfs2(num, grrev, used, iterat);
			iterat++;
		}
	}
	//iterat--;
	//cout << "dfs2 OK\n";

	/*cout << "dict: ";
	for (int i = 0; i < n; i++) {
		cout << dict[i] << " ";
	}
	cout << '\n';*/

	vector<bool> lucky(iterat, true);
	vector<int> summ(iterat);
	for (int i = 0; i < n; i++) {
		summ[dict[i]]++;
		for (int j = 0; j < gr[i].size(); j++) {
			if (dict[i] != dict[gr[i][j]]) {
				lucky[dict[i]] = false;
			}
		}
	}

	int minval = -1;
	int minsum = 1e9;

	for (int i = 0; i < iterat; i++) {
		if (lucky[i] && summ[i] < minsum)
		{
			minval = i;
			minsum = summ[i];
		}
	}


	cout << minsum << '\n';
	for (int i = 0; i < n; i++) {
		if (dict[i] == minval) cout << i + 1 << ' ';
	}

	//cout << "Hi\n";

	system("pause");
	return 0;
}