#include <iostream>
#include <set>
#include <vector>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    string s;
    cin >> s;
    set<int> a0;
    set<int> a1;
    for(int i=0; i<s.size(); i++) {
        s[i] == '0' ? a0.insert(i+1) : a1.insert(i+1);
    }
    if(a0.size() == 0) cout << -1;
    else {
        vector<vector<int> > ans;
        while(a0.size() != 0) {
            int f = -1;
            ans.resize(ans.size()+1);
            while(1) {
                auto it1 = a0.upper_bound(f);
                if(it1 == a0.end()) break;
                f = *it1;
                ans.back().push_back(f);
                a0.erase(it1);
                auto it2 = a1.upper_bound(f);
                if(it2 == a1.end()) break;
                f = *it2;
                a1.erase(it2);
                ans.back().push_back(f);
            }
            if(s[ans.back().back()-1] == '1') ans.back().pop_back();
        }
        int k = 0;
        for(int i=0; i<ans.size(); i++) {
            k += ans[i].size();
        }
        if(k != s.size()) {
            cout << -1;
            return 0;
        }
        cout << ans.size() << "\n";
        for(int i=0; i<ans.size(); i++) {
            cout << ans[i].size() << " ";
            for(int p : ans[i])
                cout << p << " ";
            cout << "\n";
        }
    }
    return 0;
}
