#include <map>
#include <set>
#include <list>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <cassert>
#include <complex>
#include <cstdlib>
#include <iomanip>
#include <numeric>
#include <iostream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using namespace chrono;

inline void bad() {
	cout << -1 << endl;
	exit(0);
}

int main() {
	#ifdef DEBUG
		stdin = freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	
	string s; cin >> s;
	int n = s.size();
	set<int> zero, one;
	for (int i = 0; i < n; i++) {
		(s[i] == '0' ? zero : one).insert(i);
	}
	
	vector< vector<int> > ans;
	while (!zero.empty() || !one.empty()) {
		if (zero.empty()) {
			bad();
		}
		ans.emplace_back();
		int idx = *zero.begin();
		ans.back().push_back(idx);
		zero.erase(idx);
		for (;;) {
			auto it2 = one.upper_bound(idx);
			if (it2 == one.end()) {
				break;
			}
			auto it3 = zero.upper_bound(*it2);
			if (it3 == zero.end()) {
				break;
			}
			ans.back().push_back(*it2);
			ans.back().push_back(*it3);
			one.erase(it2);
			zero.erase(it3);
		}
	}
	
	cout << ans.size() << endl;
	for (auto i: ans) {
		cout << i.size();
		for (int j: i) {
			cout << " " << j+1;
		}
		cout << "\n";
	}
	
	return 0;
}
