#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 69;
vector<int> o;
vector<int> g[MAXN];
vector<int> g1[MAXN];
map<pair<int, int>, bool> u;
bitset<MAXN> used;

void dfs(int v)
{
    used[v] = 1;
    for (int to : g[v])
    {
        if (!used[to])
            dfs(to);
    }
    o.push_back(v);
}

vector<int> tp[MAXN];
vector<int> gr[MAXN];
int color[MAXN];

void dfs1(int v, int cl)
{
    used[v] = 1;
    for (int to : g1[v])
    {
        if (!used[to])
            dfs1(to, cl);
    }
    tp[cl].push_back(v);
    color[v] = cl;
}
int n, m, h;
int a[MAXN];

int main()
{

   // freopen("in.txt", "r", stdin);
    ios_base::sync_with_stdio(0);cin.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
    {
        int a1, b1;
        cin >> a1 >> b1;
        a1--, b1--;
        if ((a[a1] + 1) % h == a[b1] && !u[{a1, b1}])
        {
            g[a1].push_back(b1);
            g1[b1].push_back(a1);
            u[{a1, b1}] = 1;
        }

        if ((a[b1] + 1) % h == a[a1] && !u[{b1, a1}])
        {
            u[{b1, a1}] = 1;
            g[b1].push_back(a1);
            g1[a1].push_back(b1);
        }
    }

    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs(i);
    used.reset();
    int cnt = 0;
    for (int i = n - 1; i >= 0; --i)
    {
        if (!used[o[i]])
        {
            dfs1(o[i], cnt);
            cnt++;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j : g[i])
        {
            if (color[i] != color[j])
            {
                gr[color[i]].push_back(color[j]);
            }
        }
    }
    int ma = MAXN * 10;
    int comp = 0;
    for (int i = 0; i < cnt; ++i)
    {
       // cout << "new comp " << cnt << endl;
        if (gr[i].size() == 0)
        {
            if (tp[i].size() < ma)
            {
                ma = tp[i].size();
                comp = i;
            }
        }
    }
    cout << tp[comp].size() << endl;
    for (int j : tp[comp])
        cout << j + 1 << " ";
    return 0;
}
