#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 7;
//  ,  257 .

ll pref[MAXN];
ll num[MAXN];
int n, p, d;
ll b;

ll Pref(int i) {
    if (i >= n) return n * b;
    return pref[i];
}

ll Pref1(int i, ll cap) {
    if (i >= n || pref[i] > cap) return cap;
    return pref[i];
}

ll Pref2(int i, ll cap) {
    cap = n * b - cap;
    if (i >= n || n * b - pref[n - i] > cap) return cap;
    return n * b - pref[n - i];
}

int Check(ll cap) {
    int res = 0;
    for (int i = 0; i < (n + 1) / 2; ++i) {
        num[i] = (i ? num[i - 1] : 0) + Pref1((i + 1) * (d + 1), cap) - Pref1(i * (d + 1), cap);
        if (num[i] >= b) {
            ++res;
            num[i] -= b;
        }
    }
    for (int i = n - 1; i >= (n + 1) / 2; --i) {
        int j = n - i;
        num[i] = num[i + 1] + Pref2(j * (d + 1), cap) - Pref2((j - 1) * (d + 1), cap);
        if (num[i] >= b) {
            ++res;
            num[i] -= b;
        }
    }
    return res;
}

int main() {
    cin >> p >> n >> d >> b;
    for (int i = 0; i < n; ++i) {
        cin >> num[i];
        pref[i + 1] = pref[i] + num[i];
    }
    if (p == 2) {
        //ll l = 0, r = n * b;
        //while (r - l > 10ll) {
        //    int m1 = (l + r) / 2;
        //    int m2 = m1 + 1;
        //    if (Check(m1) < Check(m2))
        //        l = m1;
        //    else
        //        r = m2;
        //}
        int res = 0;
        for (int i = 0; i <= n * b; ++i)
            chkmax(res, Check(i));
        //for (int i = l; i <= r; ++i)
        //    chkmax(res, Check(i));
        cout << n - res << '\n';
        return 0;
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        num[i] = (i ? num[i - 1] : 0) + Pref((i + 1) * (d + 1)) - Pref(i * (d + 1));
        if (num[i] >= b) {
            ++res;
            num[i] -= b;
        }
    }
    cout << n - res << '\n';
}

