#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 2e5 + 88;

int n, m, h;
int u[maxn];
vector<int> g[maxn];

int used[maxn];

void dfs(int v)
{
    if (used[v])
        return;
    used[v] = 1;
    for (int i = 0; i < g[v].size(); i++)
        dfs(g[v][i]);
}

void solve()
{
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((u[a] + 1) % h == u[b])
        {
            g[a].pb(b);
        }
        if ((u[b] + 1) % h == u[a])
        {
            g[b].pb(a);
        }
    }
    vector<int> minr;
    int minrr = inf;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            used[j] = 0;
        dfs(i);
        int uc = 0;
        for (int j = 0; j < n; j++)
            uc += used[j];
        if (uc < minrr)
        {
            minrr = uc;
            minr.clear();
            for (int j = 0; j < n; j++)
                if (used[j])
                    minr.pb(j + 1);
        }
    }
    cout << minrr << endl;
    for (int i = 0; i < minrr; i++)
        cout << minr[i] << " ";
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
