#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 2e3 + 88;

int p, n, d, b;
int a[maxn];

void tryop(int x)
{
    int r = b - a[x];
    if (r < 0)
    {
        a[x] += r;
        a[x + 1] -= r;
    }
    if (r > 0)
    {
        for (int i = x + 1; i < min(n, x + d + 1); i++)
        {
            a[x] += min(r, a[i]);
            a[i] -= min(r, a[i]);
        }
        for (int i = x + 1; i < x + 2; i++)
        {
            if (a[i] > b)
            {
                a[i + 1] += (a[i] - b);
                a[i] = b;
            }
        }
    }
}

void solve()
{
    cin >> p >> n >> d >> b;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        tryop(i);
        if (a[i] != b)
            cnt++;
    }
    cout << cnt << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
