#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 1e3+123;
const int inf = 1e9;

vector< vector<int> > g;
vector<int> used, vr;
int a[maxn], d[maxn], tin[maxn], u, v, n, m, h;
set< pair<int, int> > st;

void dfs(int v, int pr, int p, int l)
{
    used[v] = l;
    tin[v] = p;
    int t = (a[v]+1)%h, ans = 0;
    for(int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if(to == pr) continue;
        if(a[to] == t) {
            if(!used[to]) {
                dfs(to, v, p+1, l);
                ans += d[to];
            }
            else {
                if(used[to] == l) ans += p-tin[to];
                else ans += d[to];
            }
        }
    }
    d[v] = ans+1;
}

void dfs1(int v, int pr)
{
    used[v] = 1;
    vr.pb(v);
    int t = (a[v]+1)%h;
    for(int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if(a[to] == t) {
            if(!used[to]) dfs1(to, v);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m >> h;
    g.resize(n), used.resize(n);
    for(int i=0; i<n; i++) {
        cin >> a[i];
    }
    for(int i=0; i<m; i++) {
        cin >> u >> v;
        u--, v--;
        if(u > v) swap(u, v);
        if(st.find({u, v}) != st.end()) continue;
        st.insert({u, v});
        g[v].pb(u);
        g[u].pb(v);
    }
    for(int i=0; i<n; i++) {
        if(!used[i]) {
            dfs(i, -1, 0, i+1);
        }
    }
    int ans = inf, v;
    for(int i=0; i<n; i++) {
        if(ans > d[i]) {
            ans = min(ans, d[i]);
            v = i;
        }
    }
    used.assign(n, 0);
    dfs1(v, -1);
    cout << ans << endl;
    for(int i=0; i<vr.size(); i++) {
        cout << vr[i]+1 << ' ';
    }
    return 0;
}
