#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 1e5+123;
const int inf = 1e9;

int n, m, h, u, v, a[maxn];
vector<int> used, cur, ans;
vector< vector<int> > g;

void dfs(int v, int pr)
{
    used[v] = 1;
    cur.pb(v);
    int t = (a[v]+1)%h;
    for(int i=0; i<g[v].size(); i++) {
        int to = g[v][i];
        if(!used[to] && a[to] == t) {
            dfs(to, v);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m >> h;
    g.resize(n), used.resize(n);
    for(int i=0; i<n; i++) {
        cin >> a[i];
    }
    for(int i=0; i<m; i++) {
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    int an = inf;
    for(int i=0; i<n; i++) {
        used.assign(n, 0);
        cur.clear();
        dfs(i, -1);
        if(cur.size() < an) {
            ans = cur;
            an = cur.size();
        }
    }
    cout << ans.size() << endl;
    for(int i=0; i<ans.size(); i++) {
        cout << ans[i]+1 << ' ';
    }
    return 0;
}
