#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <iterator>
#include <algorithm>
#include <numeric>
#include <list>
#include <queue>
#include <iomanip>
#define fr first
#define sc second
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int maxn = 2*1e5+123;
const int inf = 1e9;

vector< vector<int> > ans;
vector<int> t;
int pred[maxn], pr[maxn], met[maxn];
string s;

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> s;
    int n = s.size();
    int cnt = 0;
    for(int i=0; i<n; i++) {
        if(s[i] == '1') {
            cnt--;
        }
        else cnt++;
        if(cnt < 0) {
            cout << -1;
            return 0;
        }
    }
    cnt = 0;
    for(int i=n-1; i>=0; i--) {
        if(s[i] == '1') {
            cnt--;
        }
        else cnt++;
        if(cnt < 0) {
            cout << -1;
            return 0;
        }
    }
    int posn = -1, posd = -1;
    for(int i=0; i<n; i++) {
        if(s[i] == '1') {
            pred[i] = posn;
            if(posn >= 0) posn = pr[posn];
            pr[i] = posd;
            posd = i;
        }
        else {
            pred[i] = posd;
            if(posd >=0) posd = pr[posd];
            pr[i] = posn;
            posn = i;
        }
    }
    for(int i=n-1; i>=0; i--) {
        if(met[i]) continue;
        t.clear();
        int j = i;
        while(j >= 0) {
            met[j] = 1;
            t.pb(j);
            j = pred[j];
        }
        ans.pb(t);
    }
    cout << ans.size() << endl;
    for(int i=0; i<ans.size(); i++) {
        cout << ans[i].size();
        for(int j=ans[i].size()-1; j>=0; j--) {
            cout << ' ' << ans[i][j]+1;
        }
        cout << endl;
    }
    return 0;
}
