#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

template<typename T>
struct segtree{
  int n;
  vector<T> t;
  segtree(int sz):n(1 << ((int)log2(n - 1) + 1)), t(n << 1, 0){}
  segtree(){}
  T combine(T x, T y){
    return x + y;
  }
  void modify(int p, T val, int v, int l, int r){
    if (r - l == 1){
      t[p] = val;
      return;
    }
    int mid = (l + r) >> 1;
    if (p < mid){
      modify(p, val, v << 1, l, mid);
    } else {
      modify(p, val, v << 1 | 1, mid, r);
    }
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
  }
  void modify(int p, T val){
    modify(p, val, 1, 0, n);
  }
  T query(int cl, int cr, int v, int l, int r){
    if (r <= cl || l >= cr) return 0;
    if (l >= cl && r <= cr) return t[v];
    int mid = (l + r) >> 1;
    return combine(query(cl, cr, v << 1, l, mid), query(cl, cr, v << 1 | 1, mid, r));
  }
  T query(int l, int r){
    query(l, r, 1, 0, n);
  }
};

const int N = 100100;

vector<int> g[N];
vector<int> g1[N];
vector<int> rev_g1[N];
vector<bool> used(N, false);
vector<int> order;
vector<vector<int>> all;
vector<int> comp;
vector<int> num;
int n, m, h;
int u[N];

void dfs1(int v){
  used[v] = true;
  for (auto to : g1[v]){
    if (!used[to]){
      dfs1(to);
    }
  }
  order.pb(v);
}

void dfs2(int v){
  used[v] = true;
  for (auto to : rev_g1[v]){
    if (!used[to]){
      dfs2(to);
    }
  }
  comp.pb(v);
}

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  cin >> n >> m >> h;
  for (int i = 0; i < n; i++){
    cin >> u[i];
  }
  for (int i = 0; i < m; i++){
    int c1, c2;
    cin >> c1 >> c2;
    g[c1 - 1].pb(c2 - 1);
    g[c2 - 1].pb(c1 - 1);
  }
  for (int i = 0; i < n; i++){
    for (auto to : g[i]){
      if ((u[i] + 1) % h == u[to]){
        g1[i].pb(to);
        rev_g1[to].pb(i);
      }
    }
  }
  for (int i = 0; i < n; i++){
    if (!used[i]){
      dfs1(i);
    }
  }
  reverse(order.begin(), order.end());
  used.assign(n, false);
  num.resize(n, 0);
  int timer = 0;
  for (auto it : order){
    if (!used[it]){
      comp.clear();
      dfs2(it);
      for (auto kek : comp) num[kek] = timer;
      timer++;
      all.pb(comp);
    }
  }
  vector<int> ans;
  int sz = 1e9;
  for (auto &cur : all){
    bool f = true;
    for (auto v : cur){
      for (auto to : g1[v]){
        if (num[v] != num[to]){
          f = false;
        }
      }
    }
    if (f){
      if (cur.size() < sz){
        sz = cur.size();
        ans = cur;
      }
    }
  }
  cout << ans.size() << endl;
  for (auto it : ans) cout << it + 1 << ' ';
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
