#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int getroom(int x, vector<int> &P) {
	return lower_bound(P.begin(), P.end(), x) - P.begin();
}

const int dd = (int)1e5 + 7;
//int dp[dd][dd];
pair<int, int> dp[dd];

//void upd(int &a, int b) { if (a > b) a = b; }

void upd(pair<int, int> &a, pair<int, int> b) {
	if (max(b.first, b.second) < max(a.first, a.second))
		a = b;
	else if (min(b.first, b.second) < min(a.first, a.second))
		a = b;
}

int main() {
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) cin >> a[i];
	
	if (p == 1) {
		int sum = b, cur = 0, j = 1;
		int res = 0;
		for (int i = 1; i <= n; i++) {
			while (j <= n && cur < sum)
				cur += a[j], j++;
			if (cur >= sum && (j - 1) - i <= 1ll * i * d) sum += b;
			else res++;
		}	
		cout << res << "\n";
		return 0;
	} 
	
	vector<int> P(n + 1);
	for (int i = 1; i <= n; i++) P[i] = P[i - 1] + a[i];
	
	fill(dp, dp + n + 1, make_pair((int)1e9, (int)1e9));
	dp[0] = { 0, 0 };
	
	for (int i = 1; i <= n; i++) {
		int l = i;
		int r = n + 1 - i;
		
		if (l > r) break;
		
		int val1 = dp[i - 1].first;
   		int val2 = dp[i - 1].second;
   		
   		int stL = b * (i - 1 - val1) + 1;
   		int stR = 1ll * n * b - b * (i - 1 - val2);
   		
   		int iL = getroom(stL + b - 1, P);
   		int iR = getroom(stR - b + 1, P);
   		
   		if (stL + b - 1 < stR - b + 1) {
   			if (iL - i <= 1ll * i * d && n + 1 - i - iR <= 1ll * i * d) {
   				upd(dp[i], { val1, val2 });
   			}
   		}
   		if (stL + b - 1 == stR) {
   			if (iL - i <= 1ll * i * d) upd(dp[i], { val1, val2 });
   		}
   		if (stL + b - 1 < stR) {
   			if (iL - i <= 1ll * i * d) upd(dp[i], { val1, val2 + 1 });
   		}
   		if (stR - b + 1 > stL) {
   			if (n + 1 - i - iR <= 1ll * i * d) upd(dp[i], { val1 + 1, val2 });
   		}
   		upd(dp[i], { val1 + 1, val2 + 1 });
	}
	
	int i = (n + 1) / 2;
	cout << max(dp[i].first, dp[i].second) << "\n";
	
	return 0;
}