#include <iostream>
#include <vector>
#include <deque>

#define MAX(a, b) (((a) > (b)) ? (a): (b))
#define MIN(a, b) (((a) < (b)) ? (a): (b))
#define m_p make_pair
#define m_t make_tuple
#define ft first
#define sd second
#define ll long long
#define forn(i, j, n) for(ll i = j; i < n; ++i)
#define forc(i, n, j) for(ll i = n-1; i >= j; --i)
#define forr(i, j, n, d) for(auto i = j; i != n; d)

using namespace std;

vector<vector<long>> g, g_ob;
vector<bool> used, used_ob;
vector<long> activ, mass_kol, mass_kol_sv;
vector<long> tim, nums, tin, tout;
long kol = 0, cur_t = 0;
deque<long> mem;

void dfs_sj(long v) {
	if (!used[v]) {
		mem.push_back(v);
		tin[v] = cur_t++;
		used[v] = true;
		for (auto u : g[v]) {
			dfs_sj(u);
		}
		tout[v] = cur_t++;
	}
}

void dfs_obr_sj(long v) {
	if ((used[v] && nums[v] == -1)) {
		nums[v] = kol;
		for (auto u:g_ob[v]) {
			if (tin[v] < tout[u]) {
				dfs_obr_sj(u);
			}
		}
	}
}
void dfs_ans(long v) {

}

int main()
{
	long n, m, h;
	cin >> n >> m >> h;
	g.resize(n, vector<long>(0));
	g_ob.resize(n, vector<long>(0));
	tim.resize(n);
	tin.resize(n); tout.resize(n);
	nums.resize(n, -1);
	used.resize(n, false);


	forn(u, 0, n) {
		cin >> tim[u];
	}

	forn(u, 0, m) {
		long a, b;
		cin >> a >> b; --a; --b;
		/*g[a].push_back(b);
		g_ob[b].push_back(a);*/
		if (tim[a] > tim[b]) swap(a, b);
		if (tim[b] - tim[a] == 1) {
			g[a].push_back(b);
			g_ob[b].push_back(a);
		} else if (tim[b] - tim[a]+1 == h) {
			g[b].push_back(a);
			g_ob[a].push_back(b);
		}
	}

	forn(u, 0, n) {
		if (!g[u].size()) {
			cout << 1 << endl << u + 1 << endl;
			return 0;
		}
	}

	forn(u, 0, n) {
		if (nums[u] == -1) {
			dfs_sj(u);
			while (!mem.empty()) {
				if (nums[mem.front()] == -1) {
					dfs_obr_sj(mem.front());
					++kol;
				}
				mem.pop_front();
			}
		}
	}
	forn(u, 0, n) {
		dfs_ans(u);
	}

	mass_kol.resize(kol, 0);
	mass_kol_sv.resize(kol, 0);
	forn(u, 0, n) {
		++mass_kol[nums[u]];
		for (auto v : g[u]) {
			if (nums[u] != nums[v]) ++mass_kol_sv[nums[u]];
		}
	}
	long prob_ans = -1, ans_k = -1;
	forn (u, 0, kol) {
		if (mass_kol_sv[u] == 0) {
			if (prob_ans == -1 || ans_k > mass_kol[u]) {
				prob_ans = u; ans_k = mass_kol[u];
			}
		}
	}

	cout << ans_k << endl;

	forn(u, 0, n) {
		if (nums[u] == prob_ans) cout << u + 1 << ' ';
	}
	cout << endl;

	cin >> n;

	return 0;
}