#include <iostream>
#include <vector>

#define MAX(a, b) (((a) > (b)) ? (a): (b))
#define MIN(a, b) (((a) < (b)) ? (a): (b))
#define m_p make_pair
#define m_t make_tuple
#define ft first
#define sd second
#define ll long long
#define forn(i, j, n) for(ll i = j; i < n; ++i)
#define forc(i, n, j) for(ll i = n-1; i >= j; --i)
#define forr(i, j, n, d) for(auto i = j; i != n; d)

using namespace std;

vector<vector<long>> g;
vector<long> used, tim;
long kol = 0;

void dfs(long v, long k) {
	if (used[v] != k) {
		used[v] = k;
		++kol;
		for (auto u : g[v]) {
			dfs(u, k);
		}
	}
}

void dfs_ans(long v) {
	if (used[v] != 1e9) {
		used[v] = 1e9;
		cout << v + 1 << ' ';
		for (auto u : g[v]) {
			dfs_ans(u);
		}
	}
}

int main()
{
	long n, m, h;
	cin >> n >> m >> h;
	g.resize(n, vector<long>(0));
	tim.resize(n);
	used.resize(n, -1);


	forn(u, 0, n) {
		cin >> tim[u];
	}

	forn(u, 0, m) {
		long a, b;
		cin >> a >> b; --a; --b;
		/*g[a].push_back(b);
		g_ob[b].push_back(a);*/
		if (tim[a] > tim[b]) swap(a, b);
		if (tim[b] == tim[a]+1) {
			g[a].push_back(b);
		} else if ((tim[b]+1)%h == tim[a]) {
			g[b].push_back(a);
		}
	}
	dfs(0, 0);
	long ans = 0, ans_kol = kol;
	forn(u, 1, n) {
		kol = 0;
		dfs(u, u);
		if (ans_kol > kol) {
			ans = u; ans_kol = kol;
		}
	}

	cout << ans_kol << endl;
	dfs_ans(ans);
	cout << endl;

	cin >> n;

	return 0;
}