#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define m_p make_pair
#define endl '\n'
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0)

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
/*order_of_key, find_by_order*/

typedef long long ll;
const int MAXN = 1123456;
const int MAXINT = 2146483648;
const ll MAXLL = 9223372035854775808LL;

vector <int> g[MAXN];
int h, t[MAXN], t1[MAXN];
bool used[MAXN];
vector <int> now_ans;
vector <int> ans;
bool bad = 0;

void dfs(int v, int new_time) {

    if (used[v] && t1[v] != new_time) bad = 1;
    if (used[v]) return;
    t1[v] = new_time;
    now_ans.push_back(v);
    used[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (t1[v] == t[to]) dfs(to, (t[to] + 1) % h);
    }
}

int main()
{
    fast_io;

    int n, m;

    cin >> n >> m >> h;
    for (int i = 1; i <= n; ++i) cin >> t[i];
    for (int i = 1; i <= m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    for (int i = 1; i <= n; ++i) {
        now_ans.clear();
        bad = 0;
        for (int j = 1; j <= n; ++j) t1[j] = t[j];
        for (int j = 1; j <= n; ++j) used[j] = 0;
        dfs(i, (t[i] + 1) % h);
        if (bad) continue;
        if (ans.size() == 0) ans = now_ans;
        if (ans.size() > now_ans.size() )ans = now_ans;
    }

    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) cout << ans[i] << " ";

    return 0;
}
