import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {

    public void solve() throws IOException {
        int n = nextInt();
        int a = nextInt();
        int aCopy = a;
        List<Integer> ans = new ArrayList<>();
        if (a < 0)
            a = -a;
        for (int i = 0; i < 32; i++) {
            if (((a >> i) & 1) == 1) {
                ans.add(1 << i);
            }
        }
        out.println(ans.size());
        for (int i = 0; i < ans.size(); i++) {
            if (aCopy < 0)
                out.print("-");
            out.print(ans.get(i) + " ");
        }
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }
}
