#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 1e5 + 7;
const int M = 1e5 + 7;
const int H = 1e5 + 7;

set<int> g[N];

int n, m, mxh;
int h[N], ch[N];

void read()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m >> mxh;
    for(int i = 0 ; i < n ; i ++)
        cin >> ch[i];
    for(int i = 0 ; i < m ; i ++)
    {
        int f, t; cin >> f >> t; --f, --t;
        g[f].insert(t);
        g[t].insert(f);
    }
}

inline int get_nh(int a)
{
    return (a + 1) % mxh;
}

bool used[N];

vector<int> path;
int ans_s = INT_MAX;

bool dfs(int v)
{
    for(auto next : g[v])
    {
        if(h[v] != h[next]) continue;
        if(used[next]) return false;
        used[next] = true;

        h[next] = get_nh( h[next] );
        path.push_back(next);
        if(path.size() >= ans_s) return false;
        if(!dfs(next)) return false;
    }
    return true;
}

vector<int> ans;

void solve()
{
    for(int i = 0 ; i < n ; i ++)
    {
        path.clear();
        for(int j = 0 ; j < n ; j ++)
        {
            used[j] = false;
            h[j] = ch[j];
        }
        used[i] = true;
        h[i] = get_nh(h[i]);
        path.push_back(i);
        if(dfs(i) && ans_s > path.size())
        {
            ans_s = path.size();
            ans = path;
        }
    }
}

void print()
{
    cout << ans_s << endl;
    for(auto i : ans)
        cout << i + 1 << ' ';
}

int32_t main()
{
    read();
    solve();
    print();
}
