#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > g;
vector<int> used;

int dfs(int v) {
	used[v] = true;
	int cur = 1;
	for (int to : g[v]) {
		if (!used[to]) {
			cur += dfs(to);
		}
	}
	return cur;
}

void dfs1(int v) {
	cout << v + 1 << " ";
	used[v] = true;
	int cur = 1;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs1(to);
		}
	}
}

void solve() {
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> u(n);
	for (int& uu : u) cin >> uu;
	g.resize(n);
	used.resize(n, false);
	for (int i = 0; i < m; ++i) {
		int c1, c2;
		cin >> c1 >> c2;
		--c1; --c2;
		if ((u[c1] + 1) % h == u[c2])
			g[c1].push_back(c2);
		if ((u[c2] + 1) % h == u[c1])
			g[c2].push_back(c1);
	}
	int ans = 0, res = 2e9;
	for (int i = 0; i < n; ++i) {
		int cur = dfs(i);
		used.assign(n, false);
		if (cur < res) {
			ans = i;
			res = cur;
		}
	}
	cout << res << endl;
	dfs1(ans);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}