#include <bits/stdc++.h>

using namespace std;

vector<int> a;

bool checkAllSums(vector<int> arr) {
	set<int> left, right;
	left.insert(0);
	right.insert(0);
	for (int mask = 0; mask < (1 << int(arr.size() / 2)); ++mask) {
		int sum = 0;
		for (int i = 0; i < int(arr.size()) / 2; ++i)
			sum += ((mask >> i) & 1) * arr[i];
		left.insert(sum);
	}
	int rsz = arr.size() - arr.size() / 2;
	for (int mask = 0; mask < (1 << rsz); ++mask) {
		int sum = 0;
		for (int i = 0; i < rsz; ++i)
			sum += ((mask >> i) & 1) * arr[i + int(arr.size() / 2)];
		right.insert(sum);
	}
	for (int i = 0; i < a.size(); ++i) {
		bool test = false;
		for (int sum : left) {
			if (right.find(a[i] - sum) != right.end()) {
				test = true;
				break;
			}
		}
		if (!test) {
			return false;
		}		
	}
	return true;
}

void solve() {
	int n = 0;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	const int MAX_POW = 9;
	int ans = 2e9;
	vector<int> cards;
	for (int mask = 0; mask < (1 << (2 * MAX_POW)); ++mask) {
		vector<int> cur;
		for (int i = 0; i < MAX_POW; ++i) {
			if ((mask >> i) & 1) {
				cur.push_back(1 << i);
			}
		}
		for (int i = MAX_POW; i < 2 * MAX_POW; ++i) {
			if ((mask >> i) & 1) {
				cur.push_back(- (1 << (i - MAX_POW)));
			}
		}
		if (checkAllSums(cur) && ans > cur.size()) {
			cards = cur;
			ans = cur.size();
		}
	}
	cout << ans << endl;
	for (int card : cards)
		cout << card << " ";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}