//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

int n, m, h;
vector <int> arr;
vector < vector<int> > g;

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> h;

    arr.resize(n);
    g.resize(n);

    forn(i, n)
        cin >> arr[i];

    int a, b;
    forn(i, m)
    {
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    vector <int> ans;
    forn(t, n)
    {
        vector <int> now;
        queue <int> q;
        vector <bool> inq(n);

        now.push_back(t);
        inq[t] = true;
        q.push(t);

        while (!q.empty())
        {
            int v = q.front();
            q.pop();
            forn(i, (int)g[v].size())
            {
                int to = g[v][i];
                if (arr[to] == (arr[v] + 1) % h && !inq[to])
                {
                    q.push(to);
                    inq[to] = true;
                    now.push_back(to);
                }
            }
        }

        if (ans.empty() || (int)now.size() < (int)ans.size())
            ans = now;
    }

    cout << (int)ans.size() << endl;
    forn(i, (int)ans.size())
        cout << ans[i] + 1 << " ";

    return 0;
}