//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

int n, m, h;
vector <int> arr;
vector < vector<int> > g, g1;
vector <int> color;
vector <int> order;
vector <int> comp;
vector <int> outside;

void dfs(int v)
{
    color[v] = 1;
    forn(i, (int)g[v].size())
    {
        int to = g[v][i];
        if (color[to] == 0)
            dfs(to);
    }
    color[v] = 2;
    order.push_back(v);
}

vector < vector<int> > comp_unit;
int cur_comp = 0;
void dfs1(int v)
{
    comp[v] = cur_comp;
    comp_unit[cur_comp].push_back(v);
    color[v] = 1;
    forn(i, (int)g1[v].size())
    {
        int to = g1[v][i];
        if (color[to] == 0)
            dfs1(to);
    }
    color[v] = 2;
}

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m >> h;

    arr.resize(n);
    g.resize(n);
    g1.resize(n);
    color.resize(n);
    comp.resize(n);

    forn(i, n)
        cin >> arr[i];

    int a, b;
    forn(i, m)
    {
        cin >> a >> b;
        a--; b--;
        // a -> b
        if ((arr[a] + 1) % h == arr[b])
        {
            g[a].push_back(b);
            g1[b].push_back(a);
        }
        // b -> a
        if ((arr[b] + 1) % h == arr[a])
        {
            g[b].push_back(a);
            g1[a].push_back(b);
        }
    }

    forn(i, n)
    {
        if (color[i] == 0)
            dfs(i);
    }
    forn(i, n)
        color[i] = 0;

    reverse(order.begin(), order.end());
    forn(i, n)
    {
        int now = order[i];
        if (color[now] == 0)
        {
            comp_unit.push_back({});
            dfs1(now);
            cur_comp++;
        }
    }

    //dag.resize(cur_comp);
    outside.resize(cur_comp);
    forn(i, n)
    {
        forn(j, (int)g[i].size())
        {
            a = comp[i]; b = comp[g[i][j]];
            if (a != b)
                outside[a]++;
        }
    }

    int anscnt = n + 1, ans = -1;
    forn(i, cur_comp)
    {
        if (outside[i] > 0)
            continue;
        if ((int)comp_unit[i].size() < anscnt)
        {
            anscnt = (int)comp_unit[i].size();
            ans = i;
        }
    }

    cout << anscnt << endl;
    forn(i, anscnt)
        cout << comp_unit[ans][i] + 1 << " ";

    return 0;
}