#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

signed main()
{
	ios::sync_with_stdio(0);
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (p == 1) {
		int l = -1, r = n;
		while (r - l > 1) {
			int mid = l + (r - l) / 2;
			auto t = a;
			int j1 = 0, j2 = 0;
			bool ok = 1;
			for (int i = mid; i < n; i++) {
				t[i] -= b;
				while (t[i] < 0 && j1 < i) {
					int dx = min(-t[i], t[j1]);
					t[i] += dx, t[j1] -= dx;
					if (t[j1] > 0) break;
					j1++;
				}
				if (t[i] < 0) {
					j2 = max(j2, i + 1);
					while (t[i] < 0 && j2 < n && j2 - i <= d * (i + 1)) {
						int dx = min(-t[i], t[j2]);
						t[i] += dx, t[j2] -= dx;
						if (t[j2] > 0) break;
						j2++;
					}
				}
				if (t[i] < 0) {
					ok = 0;
					break;
				}
			}
			if (ok) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		cout << r << endl;
	}
	else {
		int l = -1, r = n / 2;
		while (r - l > 1) {
			int mid = l + (r - l) / 2;
			auto t = a;
			int j1 = 0, j2 = 0, j3 = n - 1, j4 = n - 1;
			bool ok = 1;
			for (int i = mid, j = n - mid - 1; i < j; i++, j--) {
				t[i] -= b;
				while (t[i] < 0 && j1 < i) {
					int dx = min(-t[i], t[j1]);
					t[i] += dx, t[j1] -= dx;
					if (t[j1] > 0) break;
					j1++;
				}
				if (t[i] < 0) {
					j2 = max(j2, i + 1);
					while (t[i] < 0 && j2 < n && j2 - i <= d * (i + 1)) {
						int dx = min(-t[i], t[j2]);
						t[i] += dx, t[j2] -= dx;
						if (t[j2] > 0) break;
						j2++;
					}
				}
				if (t[i] < 0) {
					ok = 0;
					break;
				}
				t[j] -= b;
				while (t[j] < 0 && j3 > j) {
					int dx = min(-t[j], t[j3]);
					t[j] += dx, t[j3] -= dx;
					if (t[j3] > 0) break;
					j3--;
				}
				if (t[j] < 0) {
					j4 = min(j4, j - 1);
					while (t[j] < 0 && j4 >= 0 && j - j4 <= d * (i + 1)) {
						int dx = min(-t[j], t[j4]);
						t[j] += dx, t[j4] -= dx;
						if (t[j4] > 0) break;
						j4--;
					}
				}
				if (t[j] < 0) {
					ok = 0;
					break;
				}
			}
			if (ok) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		cout << r << endl;
	}
    return 0;
}

