#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

vector<int> a, cur, ans_cur;
int n, sz, cnt;
int ans = 100;

void gen(int pos) {
	if (pos == sz) {
		if (ans > sz - cnt) {
			ans = sz - cnt, ans_cur = cur;
		}
		return;
	}
	int pw = (1 << pos) * 2;
	vector<int> ind;
	for (int i = 0; i < n; i++) {
		if (a[i] % pw != 0) {
			ind.push_back(i);
		}
	}
	if (ind.empty()) {
		gen(pos + 1);
	}
	else {
		cnt--;
		cur[pos] = 1;
		for (int i : ind) a[i] -= pw / 2;
		gen(pos + 1);
		cur[pos] = -1;
		for (int i : ind) a[i] += pw;
		gen(pos + 1);
		cur[pos] = 0;
		for (int i : ind) a[i] -= pw / 2;
		cnt++;
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin >> n;
	a.resize(n);
	int mx = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(mx, abs(a[i]));
	}
	sz = log2(mx + 1) + 2;
	cnt = sz;
	cur.resize(sz);
	gen(0);
	cout << ans << endl;
	for (int i = 0; i < sz; i++) {
		if (ans_cur[i]) cout << ans_cur[i] * (1 << i) << ' ';
	}
	cout << endl;
	return 0;
}

