#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------

const int MAXN = 100005;
int a[MAXN];
int p, n, d, b;

int get_left_cell(int x) {
	int L = -1, R = x;
	while (R - L > 1) {
		int m = (L + R) / 2;
		int t = (x - m + (d - 1)) / d;
		if (t <= m + 1) {
			R = m;
		}
		else {
			L = m;
		}
	}
	return R;
}

signed main() {
	doRoutine();

	cin >> p >> n >> d >> b;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}


	if (p == 1) {
		int LBS = -1, RBS = n;
		while (RBS - LBS > 1) {
			int MBS = (LBS + RBS) / 2;
			int pref_len = MBS;

			vi left(n);
			for (int i = pref_len; i < n; ++i) {
				left[i] = max(pref_len, get_left_cell(i));
			}

			vi val(n);
			for (int i = 0; i < n; ++i) {
				val[i] = a[i];
			}

			for (int i = pref_len; i < n; ++i) {
				if (left[i] < i) {
					val[left[i]] += val[i];
					val[i] = 0;
				}
			}

			int sum = 0;
			for (int i = 0; i < pref_len; ++i) {
				sum += a[i];
			}
			bool ok = true;
			for (int i = pref_len; i < n; ++i) {
				sum += val[i];
				if (sum < b * (i - pref_len + 1)) {
					ok = false;
				}
			}
			if (ok) {
				RBS = MBS;
			}
			else {
				LBS = MBS;
			}
		}
		cout << RBS << endl;
	}

	return 0;
}