#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vb vector<bool>
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------


signed main() {
	doRoutine();

	string s;
	cin >> s;
	int n = s.size();

	vi pos0, pos1;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '0') {
			pos0.pb(i);
		}
		else {
			pos1.pb(i);
		}
	}

	vector<pair<int, pii> > ans;
	vb used(n);
	int l = 0, r = (int)pos0.size() - 1;
	for (int i = 0; i < pos1.size(); ++i) {
		if (l >= r) {
			cout << -1 << endl;
			return 0;
		}
		else {
			used[pos0[l]] = true;
			used[pos0[r]] = true;
			ans.pb({pos0[l], {pos1[i], pos0[r]}});
			++l;
			--r;
		}
	}

	int cnt = ans.size();
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0' && !used[i]) {
			++cnt;
		}
	}

	cout << cnt << endl;
	for (auto el : ans) {
		cout << 3 << " " << el.fi + 1 << " " << el.se.fi + 1 << " " << el.se.se + 1 << endl;
	}
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0' && !used[i]) {
			cout << 1 << " " << i + 1 << endl;
		}
	}

	return 0;
}