#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vb vector<bool>
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------


signed main() {
	doRoutine();

	string s;
	cin >> s;
	int n = s.size();

	vi pref0(n + 1);
	for (int i = 0; i < n; ++i) {
		pref0[i + 1] = pref0[i];
		if (s[i] == '0') {
			++pref0[i + 1];
		}
	}

	int cur_cnt_1 = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			++cur_cnt_1;
		}
		if (cur_cnt_1 > pref0[i]) {
			cout << -1 << endl;
			return 0;
		}
	}

	cur_cnt_1 = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] == '1') {
			++cur_cnt_1;
		}
		if (cur_cnt_1 > pref0[n] - pref0[i + 1]) {
			cout << -1 << endl;
			return 0;
		}
	}

	// now answer exists

	vi pos0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0') {
			pos0.pb(i);
		}
	}

	vb used0(n);
	vi left(n), right(n);
	int ptr = 0;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			left[i] = pos0[ptr];
			used0[pos0[ptr]] = true;
			++ptr;
		}
	}
	ptr = (int)pos0.size() - 1;
	for (int i = n - 1; i >= 0; --i) {
		if (s[i] == '1') {
			right[i] = pos0[ptr];
			used0[pos0[ptr]] = true;
			--ptr;
		}
	}

	int cnt_1 = n - (int)pos0.size();
	int ans_len = cnt_1 + (n - cnt_1 * 3);

	cout << ans_len << endl;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			cout << 3 << " " << left[i] + 1 << " " << i + 1 << " " << right[i] + 1 << endl;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0' && !used0[i]) {
			cout << 1 << " " << i + 1 << endl;
		}
	}


	return 0;
}