#include <bits/stdc++.h>

using namespace std;

void build (int curr, map <int, vector <vector <int>>> & m, int res, string s) {
    if (curr == 5) {
        vector <int> a;
        for (int i = 0; i < (int)s.size(); ++i)
        if (s[i] == '-')
        a.push_back(-(1 << ((int)s.size() - 1 - i)));
        else if (s[i] == '+')
        a.push_back(1 << ((int)s.size() - 1 - i));

        m[res].push_back(a);
    }
    else
    for (int i = -1; i <= 1; ++i) {
        if (i == -1) build(curr + 1, m, res + i * (1 << curr), '-' + s);
        else if (i == 0) build(curr + 1, m, res + i * (1 << curr), '0' + s);
        else build(curr + 1, m, res + i * (1 << curr), '+' + s);
    }
}

void build_var (int curr, vector <int> & a, map <int, vector <vector <int>>> & m, set <int> & st, set <int> & best) {
    if (curr == (int)a.size()) {
        if (best.empty() || st.size() < best.size()) {
            best = st;
        }
        return;
    }
    else {
        for (auto elem : m[a[curr]]) {
            set <int> p = st;
            for (auto elem1 : elem)
                p.insert(elem1);
            build_var(curr + 1, a, m, p, best);
        }
    }
}

void best_res (int n, map <int, vector <vector <int>>> & m) {
    set <int> best;

    vector <int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    set <int> st;
    build_var(0, a, m, st, best);

    cout << best.size() << endl;
    for (auto elem : best)
        cout << elem << " ";
    cout << endl;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    map <int, vector <vector <int>>> m;
    set <int> st;
    build(0, m, 0, "");

    int n; cin >> n;
    best_res(n, m);

    return 0;
}
