#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

vector <int> best;
vector <set<int>> gt;
vector <bool> used;
vector <int> path;

int n, m, h;
void dfs(int v)
{
    if (path.size() > best.size() && !best.empty())
        return;
    path.push_back(v);
    used[v] = true;
    if (path.size() == n)
    {
        return;
    }
    for (auto i : gt[v])
    {
        if (!used[i])
        {
            dfs(i);
        }
    }
}

signed main()
{
    cin >> n >> m >> h;
    vector <int> wu(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &wu[i]);
    }
    gt.resize(n);
    int a, b;
    for (int i = 0; i < m; i++)
    {
        scanf("%d", &a, &b);
        a--;
        b--;
        if ((wu[a] + 1) % h == wu[b])
            gt[a].insert(b);
        if ((wu[b] + 1) % h == wu[a])
            gt[b].insert(a);
    }
    for (int i = 0; i < n; i++)
    {
        if (gt[i].size() == 0)
            return cout << 1 << endl << i + 1 << endl, 0;
    }
    for (int i = 0; i < n; i++)
    {
        used = vector <bool> (n);
        if (!used[i])
        {
            path.clear();
            dfs(i);
            if (best.size() > path.size() || best.empty())
                best = path;
        }
    }
    cout << best.size() << endl;
    for (auto x: best)
        cout << x + 1 << " ";
    cout << endl;
    return 0;
}

/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
