#include <iostream>
#include <vector>
#pragma gcc optimize(O3)

using namespace std;

const int N = 1e5+1;

vector<int> g[N];
vector<int> comp;
bool used[N];

void dfs(int v) {
	used[v] = 1;
	for (int to : g[v]) {	
		if (!used[to])
			dfs(to);
	}
	comp.push_back(v);
}

int main() {
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> time(n+1);
	for (int i = 1; i <= n; ++i) {
		cin >> time[i];
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for (int i = 1; i <= n; ++i) {
		bool bo = true;
		int newtime = time[i] + 1;
		if (newtime == h)
			newtime = 0;
		for (int to : g[i]) {
			if (newtime == time[to]){
				bo = false;
				break;
			}
		}
		if (bo) {
			return !(cout << 1 << '\n' << i);
		}
	}
	vector<vector<int> > comps;
	for (int i = 1; i <= n; ++i) {
		if (!used[i]) {
			comp.clear();
			dfs(i);
			comps.push_back(comp);
		}
	}
	vector<int> anscomp;
	int minsize = N;
	for (vector<int> p : comps) {
		if (p.size() <= minsize) {
			anscomp = p;
			minsize = p.size();
		}
	}
	// for (auto p : comps) {
	// 	for (int pp : p)
	// 		cout << pp << " ";
	// 	cout << endl;
	// }
	cout << minsize << endl;
	for (int p : anscomp)
		cout << p << " ";
	return 0;
}