#pragma gcc optimize(O3)
#include <iostream>
#include <vector>
#define pb push_back

using namespace std;

const int N = 1e5+1;

vector<int> g[N];
vector<int> comp;
bool used[N];

void dfs(int v) {
	used[v] = 1;
	comp.push_back(v);
	for (int to : g[v]) {	
		if (!used[to])
			dfs(to);
	}
}

vector<int> tm;
	int n, m, h;
int cnt = 0;
bool used1[N];
void go(int v) {
	used1[v] = 1;
	int newtm = tm[v] + 1;
	cnt++;
	comp.pb(v);
	// cout << v << " " << newtm << endl;
	if (newtm == h)
		newtm = 0;
	for (int to : g[v]) {
		if (!used1[to] && newtm == tm[to])
			go(to);
	}
}

int main() {
	cin >> n >> m >> h;
	tm.assign(n+1, 0);
	for (int i = 1; i <= n; ++i) {
		cin >> tm[i];
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for (int i = 1; i <= n; ++i) {
		bool bo = true;
		int newtm = tm[i] + 1;
		if (newtm == h)
			newtm = 0;
		for (int to : g[i]) {
			if (newtm == tm[to]){
				bo = false;
				break;
			}
		}
		if (bo) {
			return !(cout << 1 << '\n' << i);
		}
	}
	int ans = N;
	vector<int> answer;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j){
			used1[j] = 0;
		}
		comp.clear();
		cnt = 0;
		go(i);
		if (ans >= cnt) {
			answer = comp;
			ans = cnt;
		}
	}
	cout << ans << endl;
	for (int p : answer)
		cout << p << " ";
	return 0;
}