#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <set>
#define ll long long
using namespace std;

const int N = 2e5;
bool used[N];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.length();
	int need = 0;
	vector<vector<int> > ans;
	int cnt = 0;
	set<pair<char,int> > se;
	for (int i = 0; i < n; ++i) {
		se.insert(make_pair(s[i], i));
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] || s[i]-'0' == 1) continue;
		vector<int> cur(1, i+1);
		need = 1;
		set<pair<char,int> > newse;
		for (auto p : se) {
			int j = p.second;
			if (used[j]) continue;
			if (s[j]-'0' == need) {
				cur.push_back(j+1);
				used[j] = 1;
				need = (need == 0 ? 1 : 0);
			}
		}
		for (auto p : se) {
			if (!used[p.second]) {
				newse.insert(p);
			}
		}
		se = newse;
		ans.push_back(cur);
		cnt += cur.size();
		if (cur.size() % 2 == 0) {
			return !(cout << -1);
		}
	}
	if (cnt != n || s.back() == '1' || s[0] == '1') {
		return !(cout << -1);
	}
	cout << ans.size() << endl;
	for (auto p : ans) {
		cout << p.size() << " ";
		for (int pp : p)
			cout << pp << " ";
		cout << endl;
	}
	return 0;
}