#include <iostream>
#include <vector>

using namespace std;

bool check(int num, int states)
{
    bool can_pos = true;
    bool can_neg = true;
    int num2 = -num;
    for(int i = 0; ((num << 1) >> i); i++)
    {
        int state = states % 3;
        states /= 3;
        bool cp = (state == 2) && (num2 & (1 << i)) && can_neg;
        bool cn = (state == 0) && (num & (1 << i)) && can_pos;
        if(num & (1 << i))
            can_pos &= state == 2;
        if(num2 & (1 << i))
            can_neg &= state == 0;
        can_pos |= cp;
        can_neg |= cn;
    }
    return can_pos;
}

int main()
{
    int n; 
    cin >> n;
    int data[n];
    for(int i = 0; i < n; i++)
        cin >> data[i];
    int max_power = 0;
    for(int i = 0; i < n; i++)
    {
        int power = 32 - __builtin_clz(abs(data[i]));
        max_power = max(power, max_power);
    }
    int m = 1;
    for(int i = 0; i <= max_power; i++)
        m *= 3;
    vector<int> best_ans;
    int best = 32;
    for(int mask = 0; mask < m; mask++)
    {
        for(int i = 0; i < n; i++)
            if(!check(data[i], mask))
                goto fail;
        {
            int mask2 = mask;
#define mask mask2
            vector<int> ans;
            int x = 1;
            for(int i = 0; i <= max_power; i++)
            {
                int state = mask % 3;
                mask /= 3;
                if(state == 0)
                    ans.push_back(-x);
                if(state == 2)
                    ans.push_back(x);
                x <<= 1;
            }
            if(ans.size() < best)
            {
                best = ans.size();
                swap(ans, best_ans);
            }
        }
    fail:;
    }
    cout << best_ans.size() << endl;
    cout << best_ans[0];
    for(int i = 1; i < best_ans.size(); i++)
        cout << ' ' << best_ans[i];
    cout << endl;
    return 0;
}
