#include<bits/stdc++.h>
#define int long long
#define pb push_back
#define ld long double
#define F first
#define S second
#define all(a) a.begin(), a.end()
using namespace std;
const int N = 1e5 + 5;
vector<int> g[N], euler, gr[N];
int mark[N], comp[N], was[N], dp[N], siz[N];
int am, now;
set<int> graph[N];

int countdp(int u)
{
    if(was[u])
    {
        return dp[u];
    }
    was[u] = 1;
    int ans = siz[u];
    for(auto to : graph[u])
    {
        ans += countdp(to);
    }
    return dp[u] = ans;
}

void dfs1(int u)
{
    mark[u] = 1;
    for(auto to : g[u])
    {
        if(mark[to] == 0)
        {
            dfs1(to);
        }
    }
    euler.pb(u);
}

void dfs2(int u)
{
    comp[u] = am;
    mark[u] = 1;
    now++;
    for(auto to : gr[u])
    {
        if(mark[to] == 0)
        {
            dfs2(to);
        }
    }
}

inline void solve()
{
    int n, m, h;
    cin >> n >> m >> h;
    int t[n];
    for(int i = 0; i < n; i++)
    {
        cin >> t[i];
    }
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if((t[a] + 1) % h == t[b])
        {
            g[a].pb(b);
            gr[b].pb(a);
        }
        if((t[b] + 1) % h == t[a])
        {
            g[b].pb(a);
            gr[a].pb(b);
        }
    }
    for(int i = 0; i < n; i++)
    {
        if(mark[i] == 0)
        {
            dfs1(i);
        }
    }
    for(int i = 0; i < n; i++)
    {
        mark[i] = 0;
    }
    reverse(all(euler));
    for(int i = 0; i < n; i++)
    {
        if(mark[euler[i]] == 0)
        {
            dfs2(euler[i]);
            siz[am] = now;
            now = 0;
            am++;
        }
    }
    for(int i = 0; i < n; i++)
    {
        for(auto to : g[i])
        {
            if(comp[to] != comp[i])
            {
                graph[comp[i]].insert(comp[to]);
            }
        }
    }
    int num = 0, ans = 1e9;
    for(int i = 0; i < am; i++)
    {
        if(was[i] == 0)
        {
            countdp(i);
        }
        if(dp[i] < ans)
        {
            ans = dp[i];
            num = i;
        }
    }
    cout << ans << "\n";
    for(int i = 0; i < n; i++)
    {
        if(comp[i] == num)
        {
            cout << i + 1 << " ";
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while(t--)
    {
        solve();
    }
    return 0;
}
/*
3 3 5
4 4 0
1 3
3 2
3 1
*/
/*
4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
