#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <stack>

using namespace std;

vector<vector<int>> edge, edgec;
int n, m, h, t, st, fn, sz;
vector<int> srvrs, numc;
vector<pair<int, int>> chk;
vector<int> used, here, minh;
vector<bool> colored;
int clr;
stack<int> stck;

void dfs(int v) {
    used[v] = clr;
    here[sz++] = v;
    for (auto nxt : edge[v]) {
        if (used[nxt] != clr) {
            dfs(nxt);
        }
    }
}

int main()
{
    scanf("%d %d %d", &n, &m, &h);
    srvrs.resize(n);
    edge.resize(n);
    edgec.resize(n);
    chk.resize(n);
    numc.resize(n);
    here.resize(n);
    minh.resize(n);
    colored.resize(n, false);
    used.resize(n, 0);
    for (int i=0;i<n;i++) {
        scanf("%d", &srvrs[i]);
        chk[i] = {srvrs[i], i};
    }
    for (int i=0;i<m;i++) {
        scanf("%d %d", &st, &fn);
        st--;
        fn--;
        if (srvrs[st] + 1 == srvrs[fn] || (srvrs[st] == h - 1 && srvrs[fn] == 0)) edge[st].push_back(fn);
        if (srvrs[fn] + 1 == srvrs[st] || (srvrs[fn] == h - 1 && srvrs[st] == 0)) edge[fn].push_back(st);
    }
    int mins = 1000000;
    int whr = -1;
    clr = 2;
    for (int i=0;i<n;i++) {
        sz = 0;
        dfs(i);
        if (mins > sz) {
            for (int i=0;i<sz;i++) {
                minh[i] = here[i];
            }
            mins = sz;
        }
        clr++;
    }
    printf("%d\n", mins);
    for (int i=0;i<mins;i++) {
        printf("%d ", minh[i] + 1);
    }

    return 0;
}