#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 1e5 + 5;
const int mod = 1e9 + 7;

vector <int> g[N];
int cur[N];
bool used[N];
int c[N];
bool ok = 1;


void dfs(int v){
    used[v] = 1;
    for (int to : g[v]){
        if (cur[v] == cur[to]) ok = 0;
        if (used[to]) continue;
        dfs(to);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    vector <int> res;
    for (int mask = 1; mask < (1 << n); mask++){
        vector <int> upd;
        for (int i = 0; i < n; i++){
            if (mask & (1 << i)){
                cur[i] = (c[i] + 1) % h;
                upd.pb(i);
            } else cur[i] = c[i];
            used[i] = 0;
        }
        ok = 1;
        for (int i = 0; i < n; i++){
            if (used[i]) continue;
            dfs(i);
        }
        if (ok){
            if (!res.size()) res = upd;
            if (upd.size() < res.size()) res = upd;
        }
    }
    cout << res.size() << endl;
    for (auto x : res) cout << x + 1 << " ";
    return 0;
}

