#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define pii pair <int, int>
#define endl '\n'

using namespace std;

const int N = 2e5 + 5;
const int mod = 1e9 + 7;

vector <int> g[N];
int used[N];
bool was[N];
vector <int> comp;
int c[N];

void dfs(int v){
    used[v] = 1;
    comp.pb(v);
    for (int to : g[v]){
        if (used[to]) continue;
        dfs(to);
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if ((c[x] + 1) % h == c[y]) g[x].pb(y);
        if ((c[y] + 1) % h == c[x]) g[y].pb(x);
    }
    for (int i = 0; i < n; i++){
        if (!g[i].size()){
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }
    }
    vector <int> res;
    for (int i = 0; i < n; i++){
        if (used[i]) continue;
        comp.clear();
        dfs(i);
        if (!res.size()) res = comp;
        else if (comp.size() < res.size()) res = comp;
    }
    cout << res.size() << endl;
    for (auto x : res) cout << x + 1 << " ";
    return 0;
}
