#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll p, n, d, b, i, j;
    cin >> p >> n >> d >> b;

    vector<ll> num(n, 0);
    for (i = 0; i < n; i++)
        cin >> num[i];

    ll s = 0;
    ll cur = 1;
    vector<pair<ll, ll>> borders(n, {-1, -1});
    for (i = 0; i < n; i++)
    {
        s += num[i];
        while (s >= cur * b)
        {
            if (borders[cur - 1].first == -1)
                borders[cur - 1].first = i;
            borders[cur - 1].second = i;
            cur++;
        }

        if (s > (cur - 1) * b)
            borders[cur - 1].first = i;
    }

    int ans1 = 0;
    int ans2 = 0;
    for (i = 0; i < n; i++)
    {
        ll val;
        if (p == 1)
            val = (i + 1) * d;
        else
            val = min(i + 1, n - i) * d;

        if (max(abs(borders[i].first - i),
                abs(borders[i].second - i)) > val)
        {
            if (i + 1 <= n - i)
                ans1++;
            else
                ans2++;
        }
    }

    cout << max(ans1, ans2) << endl;

    return 0;
}
