#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll p, n, d, b, i, j;
    cin >> p >> n >> d >> b;

    vector<ll> num(n, 0);
    for (i = 0; i < n; i++)
        cin >> num[i];

    ll s = 0;
    ll cur = 1;
    vector<pair<ll, ll>> borders(n, {-1, -1});
    for (i = 0; i < n; i++)
    {
        s += num[i];

        while (s >= cur * b)
        {
            if (borders[cur - 1].first == -1)
                borders[cur - 1].first = i;
            borders[cur - 1].second = i;
            cur++;
        }

        if (s > (cur - 1) * b && borders[cur - 1].first == -1)
            borders[cur - 1].first = i;
    }

    vector<ll> indices;
    if (p == 1)
    {
        for (i = 0; i < n; i++)
            indices.push_back(i);
    }
    else
    {
        for (i = 0; i < n / 2; i++)
        {
            indices.push_back(i);
            indices.push_back(n - 1 - i);
        }

        if (n % 2 == 1)
            indices.push_back(n / 2);
    }

    vector<bool> done(n, false);
    ll ans1 = 0;
    ll ans2 = 0;
    ll off1 = 0;
    ll off2 = 0;
    for (ll i : indices)
    {
        ll val, off;
        if (p == 1)
        {
            val = (i + 1) * d;

            off = off1;
        }
        else
        {
            val = min(i + 1, n - i) * d;

            if (i + 1 <= n - i)
                off = off1;
            else
                off = off2;
        }

        if (max(abs(borders[i + off].first - i),
                abs(borders[i + off].second - i)) > val)
        {
            if (i + 1 <= n - i)
            {
                ans1++;
                off1--;
            }
            else
            {
                ans2++;
                off2++;
            }
        }
    }

    cout << max(ans1, ans2) << endl;

    return 0;
}
