//#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const int MAXN = 1e5 + 100;
int n, m, h;
vector <int> g[MAXN], ng[MAXN], rng[MAXN];
int t[MAXN];
vector <bool> used;

void read() {
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v; u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int v = 0; v < n; v++) {
        for (auto u : g[v]) {
            if (t[u] == (t[v] + 1) % h) {
                ng[v].push_back(u);
                rng[u].push_back(v);
            }
        }
    }
}

void dfs(int v, vector <int> &ans) {
    ans.push_back(v);
    used[v] = true;
    for (auto u : ng[v]) {
        if (!used[u]) {
            dfs(u, ans);
        }
    }
}

vector <int> order;

void dfsTopSort(int v) {
    used[v] = true;
    for (auto u : ng[v]) {
        if (!used[u]) {
            dfsTopSort(u);
        }
    }
    order.push_back(v);
}

void solve() {
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfsTopSort(i);
        }
    }
    used.assign(n, false);
    vector <int> ans;
    dfs(order[0], ans);
    /*
    for (int i = 0; i < n; i++) {
        ans.push_back(i);
    }
    for (int i = 0; i < n; i++) {
        vector <int> now;
        used.assign(n, false);
        dfs(i, now);
        if (now.size() < ans.size()) {
            ans = now;
        }
    }
    */
    cout << ans.size() << '\n';
    for (auto u : ans) {
        cout << u + 1 << ' ';
    }
}

int main() {
    read();
    solve();
}