#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

int main(){
    i_o;
    string s;
    cin >> s;
    int n = s.size();
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = s[i] - '0';
    }
    vector <int> _next(n);
    int it = 0;
    for (int i = 0; i < n; i++, it = max(it, i)) {
        if (a[i] == 0) continue;
        while (it < n && a[it] == 1) {
            it++;
        }
        _next[i] = it; it++;
    }
    it = 0;
    for (int i = 0; i < n; i++, it = max(it, i)) {
        if (a[i] == 1) continue;
        while (it < n && a[it] == 0) {
            it++;
        }
        _next[i] = it; it++;
        it = max(it, i);
    }
    
    for (int i = 0; i < n; i++) {
        if (a[i] == 1 && _next[i] >= n) {
            cout << -1;
            return 0;
        }
    }
    vector <bool> used(n);
    vector <vector <int> > ans;
    it = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        ans.push_back({});
        int now = i;
        while (now < n) {
            ans[it].push_back(now);
            used[now] = true;
            now = _next[now];
        }
        it++;
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].size() << ' ';
        for(auto u : ans[i]) {
            cout << u + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}

