#include <iostream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <stdio.h>
#include <string>
#include <cstring>
#include <algorithm>
#include <assert.h>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <fstream>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const int N = 2e5 + 2, oo = 1e9, md = 1e9 + 7;
vector <int> v[N], out;
bool use[N];
int ans[N], mas[N], t[N];

void dfs (int prev, int cur, int start){
    if (use[cur]){
        ans[prev] = oo;
        return;
    }
    mas[cur]++;
    use[cur] = 1;
    for (auto x : v[cur]){
        bool flag = use[x];
        dfs(cur, x, start);
        if (!flag) mas[cur] += mas[x];
        if (ans[x] == oo && cur != start) ans[cur] = oo;
    }
    ans[cur] = max(ans[cur], mas[cur]);
}

void dfs_o (int cur){
    if (use[cur]) return;
    use[cur] = 1;
    out.push_back(cur + 1);
    for (auto x : v[cur]) dfs_o(x);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(); cout.tie();
    //freopen ("input.txt", 'r', stdin);
    //freopen ("output.txt", 'w', stdout);

    int n, m, h, mn = oo, start = -1;
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i){
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        a--, b--;
        if ((t[a] + 1) % h == t[b]) v[a].push_back(b);
        if ((t[b] + 1) % h == t[a]) v[b].push_back(a);
    }
    for (int i = 0; i < n; ++i){
        if (!use[i]){
            dfs(-1, i, i);
        }
    }
    for (int i = 0; i < n; ++i){
        if (ans[i] < mn){
            mn = ans[i];
            start = i;
        }
    }
    memset(use, 0, n);
    if (start == -1) assert(0);
    dfs_o(start);
    cout << mn << endl;
    for (auto x : out) cout << x << ' ';

    return 0;
}