#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <ctime>

#define ll long long
#define X first
#define Y second
#define pb push_back
#define is insert
#define mp make_pair
#define MEM(x, y) memset(x, y, sizeof(x))
#define pii pair<int, int>
using namespace std;

void solve();	

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	///open-2018-169
	///2aqjf9v6
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}

const int  maxn = 100500;
int f;
int n, m, h;
int u[maxn];
set<int> e[maxn];
set<int> re[maxn];
int used[maxn];
vector<int> tops, ans;
void dfs(int v) {
	if (used[v])return;
	used[v] = 1;
	for (auto i : e[v])
		dfs(i);
	tops.push_back(v);
}
void dfs_rest(int v) {
	if (used[v] != 1)return;
	used[v] = f;
	for (auto i : re[v])
		dfs_rest(i);
}
int cnt[maxn];
bool noedge[maxn];
void solve() {
	cin >> n >> m >> h;
	for (int i = 0; i < n; ++i)
		cin >> u[i];
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		if ((u[a] + 1) % h == u[b])e[a].insert(b), re[b].insert(a);
		if ((u[b] + 1) % h == u[a])e[b].insert(a), re[a].insert(b);
	}
	for(int i = 0; i < n; ++i)
		if (e[i].empty()) {
			cout << 1 << endl << i + 1 << endl;
			return;
		}
	for (int i = 0; i < n; ++i)
		dfs(i);
	reverse(tops.begin(), tops.end());
	f = 1;
	for (auto i : tops) {
		if (used[i] != 1)continue;
		++f;
		dfs_rest(i);
	}
	for (int i = 0; i < n; ++i)
		cnt[used[i]]++;
	for (int i = 0; i < n; ++i)
		for(auto j : e[i])
			if(used[i] != used[j])
			noedge[used[i]] = true;
	int opt = -1;
	for(int i = 2; i <= f; ++i)
		if (!noedge[i] && (opt != -1  || cnt[opt] > cnt[i]))opt = i;
	for (int i = 0; i < n; ++i)
		if (used[i] == opt)ans.push_back(i);

	cout << ans.size() << endl;
	for (auto i : ans)
		cout << i + 1 << ' ';
	cout << endl;
}