#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int ans = 0;
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    vector<pair<int, int>> edges(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        edges[i] = {i, i};
    }

    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                edges[j].first -= d;
                edges[j].second += d;
            }
            if (a[i] < b) {
                ll sm = 0;
                for (int j = i + 1; j < n; ++j) {
                    if (edges[j].first <= i)
                        sm += a[j];
                }
                if (a[i] + sm < b) {
                    a[min(i + d, n - 1)] += a[i];
                    a[i] = 0;
                    ++ans;
                } else {
                    for (int j = i + 1; j < n; ++j) {
                        if (edges[j].first <= i) {
                            ll toadd = a[j];
                            if (a[i] + toadd >= b) {
                                a[j] -= b - a[i];
                                a[i] = b;
                                break;
                            } else {
                                a[j] -= toadd;
                                a[i] += toadd;
                            }
                        }
                    }
                }
            } else {
                ll toadd = a[i] - b;
                a[min(i + d, n - 1)] += toadd;
                a[i] -= toadd;
            }
        }
        cout << ans;
    } else {
        int x1 = 0, x2 = 0;
        for (int i = 0, k = n - 1; i < (n + 1) / 2; ++i, --k) {
            for (int q = 0; q < n; ++q) {
                edges[q].first -= d;
                edges[q].second += d;
            }
            if (n % 2 == 1 && i == n / 2 || x1 >= x2) {
                if (a[i] < b) {
                    ll sm = 0;
                    for (int j = 0; j < n; ++j) {
                        if (j != i && edges[j].first <= i && edges[j].second >= i)
                            sm += a[j];
                    }
                    if (a[i] + sm < b) {
                        ++x1;
                    } else {
                        for (int j = 0; j < n; ++j) {
                            if (j != i && edges[j].first <= i && edges[j].second >= i) {
                                ll toadd = a[j];
                                if (a[i] + toadd >= b) {
                                    a[j] -= b - a[i];
                                    a[i] = 0;
                                    break;
                                } else {
                                    a[j] -= toadd;
                                    a[i] += toadd;
                                }
                            }
                        }
                    }
                } else {
                    a[i] -= b;
                }

                if (a[k] < b) {
                    ll sm = 0;
                    for (int j = 0; j < n; ++j) {
                        if (j != k && edges[j].first <= k && edges[j].second >= k)
                            sm += a[j];
                    }
                    if (a[k] + sm < b) {
                        ++x2;
                    } else {
                        for (int j = 0; j < n; ++j) {
                            if (j != k && edges[j].first <= k && edges[j].second >= k) {
                                ll toadd = a[j];
                                if (a[k] + toadd >= b) {
                                    a[j] -= b - a[k];
                                    a[k] = 0;
                                    break;
                                } else {
                                    a[j] -= toadd;
                                    a[k] += toadd;
                                }
                            }
                        }
                    }
                } else {
                    a[k] -= b;
                }

            } else {
                if (a[k] < b) {
                    ll sm = 0;
                    for (int j = 0; j < n; ++j) {
                        if (j != k && edges[j].first <= k && edges[j].second >= k)
                            sm += a[j];
                    }
                    if (a[k] + sm < b) {
                        ++x2;
                    } else {
                        for (int j = 0; j < n; ++j) {
                            if (j != k && edges[j].first <= k && edges[j].second >= k) {
                                ll toadd = a[j];
                                if (a[k] + toadd >= b) {
                                    a[j] -= b - a[k];
                                    a[k] = 0;
                                    break;
                                } else {
                                    a[j] -= toadd;
                                    a[k] += toadd;
                                }
                            }
                        }
                    }
                } else {
                    a[k] -= b;
                }

                if (a[i] < b) {
                    ll sm = 0;
                    for (int j = 0; j < n; ++j) {
                        if (j != i && edges[j].first <= i && edges[j].second >= i)
                            sm += a[j];
                    }
                    if (a[i] + sm < b) {
                        ++x1;
                    } else {
                        for (int j = 0; j < n; ++j) {
                            if (j != i && edges[j].first <= i && edges[j].second >= i) {
                                ll toadd = a[j];
                                if (a[i] + toadd >= b) {
                                    a[j] -= b - a[i];
                                    a[i] = 0;
                                    break;
                                } else {
                                    a[j] -= toadd;
                                    a[i] += toadd;
                                }
                            }
                        }
                    }
                } else {
                    a[i] -= b;
                }
            }
        }
        cout << max(x1, x2);
    }
    return 0;
}
