#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

void add(string &s) {
    for (int i = s.size() - 1; i >= 0; --i) {
        if (s[i] == '3') {
            s[i] = '0';
        } else {
            s[i]++;
            break;
        }
    }
}

vector<int> slog;

bool check(string &s, vector<int> &a) {
    vector<int> all;
    for (int i = s.size() - 1, curr = 1; i >= 0; --i, curr <<= 1) {
        if (s[i] == '3') {
            all.push_back(curr);
            all.push_back(-curr);
        } else if (s[i] == '2') {
            all.push_back(curr);
        } else if (s[i] == '1') {
            all.push_back(-curr);
        }
    }

    int n = all.size();
    for (int &ii : a) {
        int per = (1 << n) - 1;
        bool fl = 0;
        while (per >= 0) {
            int rr = 0;
            for (int i = 0; i < n; ++i) {
                rr += all[i] * ((per >> i) % 2);
            }
            if (rr == ii) {
                fl = 1;
                //cout << "! ";
                //for (int &i : all) cout << i << ' ';
                //cout << " ; " << per << ' ' << rr <<  endl;
                break;
            }
            --per;
        }
        if (!fl) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    cin >> n;
    vector<int> a(n);
    int mxb = 1, pow2 = 0;
    for (int &i : a) {
        cin >> i;
        int cr = abs(i);
        while (cr >= mxb) {
            mxb *= 2;
            ++pow2;
        }
    }

    string s(pow2 + 1, '0');
    ll c = 1;
    for (int i = 0; i < pow2 + 1; ++i) {
        c *= 4;
    }

    string ans(pow2 + 1, '3');
    ans[0] = '0';
    int res = 2 * pow2;
    while (c--) {
        int cr = 0;
        for (char &c : s) {
            if (c == '3') {
                cr += 2;
            } else if (c != '0') {
                ++cr;
            }
        }
        if (cr >= res) {
            add(s);
        } else {
            if (check(s, a)) {
                ans = s;
                res = cr;
            }
            add(s);
        }
    }

    cout << res << endl;
    for (int i = ans.size() - 1, cr = 1; i >= 0; --i, cr *= 2) {
        if (ans[i] == '3') {
            cout << -cr << ' ' << cr << ' ';
        } else if (ans[i] == '2') {
            cout << cr << ' ';
        } else if (ans[i] == '1') {
            cout << -cr << ' ';
        }
    }
    return 0;
}