
#include <vector>
#include <iostream>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <math.h>
#include <deque>

using namespace std;

typedef long long ll;

vector<bool> been;
vector<int> tim;
vector<vector<int>> g;
int n, m, h;

int dfs(int id) {
	if (been[id]) {
		return 0;
	}
	been[id] = true;
	int sum = 0;
	for(int i = 0; i < g[id].size(); i++) {
		if (tim[g[id][i]] == tim[id] + 1 && been[g[id][i]]) {
			return -1;
		}
		if (tim[g[id][i]] == (tim[id] + 1) % h) {
			int a = dfs(g[id][i]) + 1;
			if (a == 0) {
				return -1;
			}
			sum += a;
		}
	}
	return sum;
}


vector<int> dfsAns(int id) {
	if (been[id]) {
		return{};
	}
	been[id] = true;
	vector<int> ret;
	for (int i = 0; i < g[id].size(); i++) {
		if (tim[g[id][i]] == (tim[id] + 1) % h) {
			if (been[g[id][i]]) {
				continue;
			}
			ret.push_back(g[id][i]);
			vector<int> temp = dfsAns(g[id][i]);
			for (int j = 0; j < temp.size(); j++) {
				ret.push_back(temp[j]);
			}
		}
	}
	return ret;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> h;
	tim.resize(n);
	g.resize(n);
	been.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> tim[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;        
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int mn = 1e9;
	int ind = -1;
	for (int i = 0; i < n; i++) {
		been.assign(n, false);
		int tmp = dfs(i);
		if (tmp == -1) {
			continue;
		}
 		if (tmp < mn) {
			mn = tmp;
			ind = i;
		}
		
	}
	been.assign(n, false);
	vector<int> tAns = { ind };
	vector<int> ans = dfsAns(ind);
	for (int i = 0; i < ans.size(); i++) {
		tAns.push_back(ans[i]);
	}
	cout << tAns.size() << endl;
	for (int i = 0; i < tAns.size(); i++) {
		cout << tAns[i]+1 << " ";
	}


	//system("pause");
}