
#include <vector>
#include <iostream>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <math.h>
#include <deque>

using namespace std;

typedef long long ll;

vector<bool> been;
vector<int> tim;
vector<vector<int>> g;
int n, m, h;
vector<int> dp;
int dfs(int id, int pre) {
	if (been[id]) {
		return 0;
	}
	been[id] = true;
	int sum = 0;
	for(int i = 0; i < g[id].size(); i++) {
		if (g[id][i] == pre) {
			continue;
		}
		if (tim[g[id][i]] == (tim[id] + 1) % h) {
			int a = dfs(g[id][i], id) + 1;
			sum += a;
		}
		else {
			dfs(g[id][i], id);
		}
	}
	if (pre == -1 || (tim[id] + 1) % h != tim[pre]) {
		dp[id] = sum;
	}

	return sum;
}


vector<int> dfsAns(int id, int pre) {
	if (been[id]) {
		return{};
	}
	been[id] = true;
	vector<int> ret;
	for (int i = 0; i < g[id].size(); i++) {
		if (g[id][i] == pre) {
			continue;
		}
		if (tim[g[id][i]] == (tim[id] + 1) % h) {
			if (been[g[id][i]]) {
				continue;
			}
			ret.push_back(g[id][i]);
			vector<int> temp = dfsAns(g[id][i], id);
			for (int j = 0; j < temp.size(); j++) {
				ret.push_back(temp[j]);
			}
		}
	}
	return ret;
}
// ДЛЯ КАЖДОЙ ВЕРШИНЫ СЧИТАЕМ СКОЛЬКО НУЖНО ИЗМЕНИТЬ ЕСЛИ +1 к ней. ВЫБИРАЕМ минимальную. РЕШЕНИЕ ЗА ОБХОД ГРАФА НА 100.
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> h;
	tim.resize(n);
	g.resize(n);
	been.resize(n);
	dp.assign(n,1e9);
	for (int i = 0; i < n; i++) {
		cin >> tim[i];
	}
	vector<set<int>> tmpg(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;        
		a--;
		b--;
		tmpg[a].insert(b);
		tmpg[b].insert(a);
	}
	for (int i = 0; i < n; i++) {
		for (auto it = tmpg[i].begin(); it != tmpg[i].end(); it++) {
			int val = *it;
			g[i].push_back(val);
		}
	}
	int mn = 1e9;
	int ind = -1;
	for (int i = 0; i < n; i++) {
		if (been[i]) {
			continue;
		}
 		int tmp = dfs(i,-1);
		if (tmp == -1) {
			continue;
		}
 		if (tmp < mn) {
			mn = tmp;
			ind = i;
		}
	}
	int lolich = 1e9;
	int index = -1;
	for (int i = 0; i < n; i++) {
		if (dp[i] < lolich) {
			lolich = dp[i];
			index = i;
		}
	}
	been.assign(n, false);
	vector<int> tAns = { index };
	vector<int> ans = dfsAns(index, -1);
	for (int i = 0; i < ans.size(); i++) {
		tAns.push_back(ans[i]);
	}
	cout << tAns.size() << endl;
	for (int i = 0; i < tAns.size(); i++) {
		cout << tAns[i]+1 << " ";
	}


	system("pause");
}