#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG

#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int n;
int *a;

int best = INT32_MAX / 2;
vector<int> bans = {};
char *can;
int mx;
int sz;
vector<int> sums;

inline bool dip(int i) {
    return (i > -sz && i < sz);

}

vector<int> ans;
vector<int> av;
int lim;
void calc(int mn, int already) {
    bool done = true;
    for (int i = 0; i < n; i++)done = done && can[a[i]];
    if (done) {
        if (best > already) {
            best = already;
            bans = ans;
        }
        return;
    }

    if (already == lim)return;
   
    for (int j = mn + 1; j < sums.size(); j++) {
        vector<int> added;
        for (auto k : av) {
            int p1 = k + sums[j];
            if (dip(p1) &&!can[p1]) {
                can[p1] = 1;
                av.push_back(p1);
                added.push_back(p1);
            }
        }
        ans.push_back(sums[j]);
        calc(j,already +1);
        ans.pop_back();
        for (auto k : added) {
            av.pop_back();
            can[k] = 0;
        }

    }
}

int __main() {
    cin >> n;
    a = new int[n];
    for (int i = 0; i < n; i++)cin >> a[i];
    sort(a, a + n);

    int d = max(abs(a[0]), abs(a[n - 1]));
    int pw = (log2(d) + 1);
    sz = max(abs(a[0]), abs(a[n - 1])) + 2;
    can = new char[2*sz];
    fill_n(can, 2 * sz, 0);
    can += sz;
    can[0] = 1;
    mx = pw;

    for (int i = 0; i < pw; i++) {
        sums.push_back(1 << i);
        sums.push_back(-(1 << i));
    }

    lim = sums.size();
    ans = vector<int>();
    av = vector<int>(1, 0);
    

    sort(sums.begin(), sums.end());
    calc(-1,0);
    cout << best << endl;
    for (auto j : bans)cout << j << " ";
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}