#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
#include <bitset> 
using namespace std;
#define int long long
#define INF 1791791791


int dfs(int x, vector<set<int>> & g, vector<int> & vis)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y])
            c += dfs(y, g, vis);
    }
    vis[x] = 2;
    return c;
}

int dfs2(int x, vector<set<int>> & g, vector<int> & vis, vector<int> & valid, vector<int> & cnt, vector<int> & h)
{
    vis[x] = 1;
    int c = 1;
    for (int y : g[x]) {
        if (!vis[y]) {
            h[y] = h[x] + 1;
            c += dfs2(y, g, vis, valid, cnt, h);

        }
        else if (vis[y] == 1) {
            valid[x] = min(valid[x], valid[y]);
        }
    }
    vis[x] = 2;
    return c;
}

signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    bitset<100000> test[100000] = {};
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
        swap(x, y);
        if (a[x] + 1 == a[y] || a[x] == h - 1 && a[y] == 0)
            g[x].insert(y);
    }
    vector<vector<int>> vis(n, vector<int>(n));
    int mv = n + 1;
    int ans;
    for (int i = 0; i < n; ++i) {
        int c = dfs(i, g, vis[i]);
        if (c < mv) {
            mv = c;
            ans = i;
        }
    }
    cout << mv << '\n';
    for (int i = 0; i < n; ++i)
        if (vis[ans][i])
            cout << i + 1 << ' ';
}

