#include<bits/stdc++.h>
#define x first
#define y second

using namespace std;

int n,  m, h;
vector<vector<int>> G;
vector<int> T, Emp(0), Met, Ans;
vector<int> Used(0);


pair<int, int>  dfs(int v)
{
    Met[v] = 1;
    Used.push_back(v);

    for(int i = 0; i < G[v].size(); i++)
    {
        if(Met[G[v][i]] == 2)
        {
            Met[v] = 2;
            return {1, Ans[G[v][i]]};
        }

        if(Met[G[v][i]] == 0)
        {
            pair<int, int> p = dfs(G[v][i]);
            if(p.x == 1)
            {
                Met[v] = 2;
                return p;
            }
        }
    }

    Met[v] = 2;

    return {0, 0};
}



int cou = 0;
void dfs2(int v)
{
    cou++;
    Met[v] = 1;

    for(int i = 0; i < G[v].size(); i++)
    {
        if(Met[G[v][i]] == 1) continue;
        dfs2(G[v][i]);
    }
    return;
}

void dfs3(int v)
{
    cout << v + 1 << ' ';
    Met[v] = 1;

    for(int i = 0; i < G[v].size(); i++)
    {
        if(Met[G[v][i]] == 1) continue;
        dfs3(G[v][i]);
    }
    return;
}




int main()
{
    //ifstream cin("input.txt");
    //ofstream cout("output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);


    string s;

    cout.precision(20);
    cin >> n >> m >> h;

    G.resize(n, Emp);
    T.resize(n);
    Met.resize(n);

    for(int i = 0; i < n; i++)
    {
        cin >> T[i];
    }

    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        if((T[a] + 1) % h == T[b]) G[a].push_back(b);
        if((T[b] + 1) % h == T[a]) G[b].push_back(a);
    }

    int mi = 2e9, minum = -1;


    Ans.resize(n, -1);

    vector<int> Sootv;
    for(int i = 0; i < n; i++)
    {
        if(Ans[i] != -1) continue;

        Used.clear();

        pair<int, int> res = dfs(i);
        if(res.x == 0)
        {
            for(int j = 0; j < Used.size(); j++)
            {
                Ans[Used[j]] = i;
            }
            Sootv.push_back(i);
        }
        else
        {
            for(int j = 0; j < Used.size(); j++)
            {
                Ans[Used[j]] = res.y;
            }
        }
    }

    Met.assign(n, 0);

    for(int i = 0; i < Sootv.size(); i++)
    {
        cou = 0;
        dfs2(Sootv[i]);

        if(cou < mi)
        {
            minum = Sootv[i];
            mi = cou;
        }
    }

    cout << mi << "\n";

    Met.assign(n, 0);
    dfs3(minum);





}
