#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e5 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

int t[maxn];
int t1[maxn];
vector<int> g[maxn];
bool used[maxn];
vector<int> tmp;

void dfs(int v){
    used[v] = 1;
    tmp.pb(v);
    for(int to : g[v])
        if(!used[to])
            dfs(to);

}

void solve(){
    int n, m, h;
    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++){
        cin >> t[i];
        t1[i] = t[i] + 1;
        if(t1[i] == h)
            t1[i] = 0;
    }
    for(int i = 0; i < m; i++){
        int v, u;
        cin >> v >> u;
        if(t1[v] == t[u])
            g[v].pb(u);
        if(t1[u] == t[v])
            g[u].pb(v);
    }
    vector<int> ans;
    for(int i = 1; i <= n; i++){
        tmp.clear();
        dfs(i);
        for(int j = 1; j <= n; j++)
            used[j] = 0;
        if(ans.size() == 0 || ans.size() > tmp.size()){
            ans = tmp;
        }
    }
    cout << ans.size() << "\n";
    for(int x : ans)
        cout << x << " ";
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
