#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e5 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

ll a[maxn];
ll t[maxn];

void build(int v, int l, int r){
    if(l == r){
        t[v] = a[l];
        return;
    }
    int c = (l + r)/2;
    build(v * 2, l, c);
    build(v * 2 + 1, c + 1, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

ll get(int v, int tl, int tr, int l, int r){
    if(l > r)
        return 0;
    if(tl == l && tr == r)
        return t[v];
    int c = (tl + tr)/2;
    return get(v * 2, tl, c, l, min(r, c)) +
           get(v * 2 + 1, c + 1, tr, max(c + 1, l), r);
}

void update(int v, int l, int r,int pos, ll d){
    if(l == r){
        t[v] += d;
        return;
    }
    int c = (l + r)/2;
    if(pos <= c)
        update(v * 2, l, c, pos, d);
    else
        update(v * 2 + 1, c + 1, r, pos, d);
    t[v] += d;
}

void solve(){
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    build(1, 1, n);
    int ans = 0;
    if(p == 1){
        int r = d + 1;
        ll inRooms = 0;
        for(int i = 1; i <= n; i++){
            if(get(1, 1, n, 1, r) - inRooms < b){
                ans++;
            }
            else{
                inRooms += b;
            }
            r = min(r + d + 1, n);
        }
    }
    else{

    }
    cout << ans;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
