//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	int n, m, h;
	cin >> n >> m >> h;
	vector <int> time(n);
	for (int i = 0; i < n; i++) {
		cin >> time[i];
	}
	vector <pair <int, int> > par(m);
	for (int i = 0; i < m; i++) {
		cin >> par[i].first >> par[i].second;
	}
	int mask = 0;
	int minl = 1e9;
	for (int i = 1; i < (1 << n); i++) {
		int count = 0;
		for (int j = 0; j < n; j++) {
			if (((i >> j) & 1) == 1) {
				time[j] = (time[j] + 1) % h;
				count++;
			}
		}
		bool good = true;
		for (int j = 0; j < m; j++) {
			if (time[par[j].first - 1] == time[par[j].second - 1]) {
				good = false;
			}
		}
		if (count < minl && good) {
			mask = i;
			minl = count;
		}
		for (int j = 0; j < n; j++) {
			if (((i >> j) & 1) == 1) {
				time[j] = (time[j] - 1 + h) % h;
				count++;
			}
		}
	}
	vector <int> ans;
	for (int i = 0; i < n; i++) {
		if ((mask >> i) & 1) {
			ans.push_back(i + 1);
		}
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}