//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void dfs(int v, vector <vector <int> > &g, vector <bool> &deep) {
	deep[v] = 1;
	for (int i = 0; i < g[v].size(); i++) {
		if (deep[g[v][i]] == 0) {
			dfs(g[v][i], g, deep);
		}
	}
}
void solve() {
	int n, m, h;
	cin >> n >> m >> h;
	vector <int> time(n);
	for (int i = 0; i < n; i++) {
		cin >> time[i];
	}
	vector <pair <int, int> > par(m);
	vector <set <int> > prep(n);
	for (int i = 0; i < m; i++) {
		cin >> par[i].first >> par[i].second;
		if ((time[par[i].first - 1] + 1) % h == time[par[i].second - 1]) {
			prep[par[i].first - 1].insert(par[i].second - 1);
		}
		if ((time[par[i].second - 1] + 1) % h == time[par[i].first - 1]) {
			prep[par[i].second - 1].insert(par[i].first - 1);
		}
	}
	vector <vector <int> > g(n);
	for (int i = 0; i < n; i++) {
		for (auto nownow : prep[i]) {
			g[i].push_back(nownow);
		}
	}
	int minl = 1e9;
	vector <bool> ans;
	for (int i = 0; i < n; i++) {
		vector <bool> deep(n, 0);
		dfs(i, g, deep);
		int count = 0;
		for (int i = 0; i < n; i++) {
			if (deep[i])
			count++;
		}
		if (count < minl) {
			ans = deep;
			minl = count;
		}
	}
	cout << minl << endl;
	for (int i = 0; i < n; i++) {
		if (ans[i]) {
			cout << i + 1 << " ";
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}