//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (p == 1) {
		vector <bool> bad(n);
		for (int i = 0; i < n; i++) {
			if (a[i] > b) {
				vector < pair <int, int> > man;
				for (int j = max(i - d, 0); j <= min(i + d, n - 1); j++) {
					if (a[i] > b && a[j] < b) {
						int cnst = min(a[i] - a[j], b - a[j]);
						a[i] -= cnst;
						a[j] += cnst;
						man.push_back({ j,cnst });
					}
				}
				if (a[i] > b) {
					bad[i] = true;
				}
				for (int i = 0; i < man.size(); i++) {
					a[man[i].first] -= man[i].second;
				}
			}
		}
		vector <bool> verybad(n);
		int ans = 0;
		for (int i = 0; i < n; i++) {
			if (bad[i]) {
				bool good = true;
				for (int j = max(i - d, 0); j <= min(i + d, n - 1); j++) {
					if (verybad[j]) {
						good = false;
						bad[i] = false;
						break;
					}
				}
				for (int j = min(i + d, n - 1); j >= max(i - d, 0); j--) {
					if (bad[j]) {
						verybad[j] = true;
						ans++;
						good = false;
						bad[i] = false;
						break;
					}
				}
				if (good) {
					verybad[i] = true;
					ans++;
				}
			}
		}
		cout << ans;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}