//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	int n;
	cin >> n;
	if (n == 1) {
		int k;
		cin >> k;
		if (k == 0) {
			cout << 0;
			return;
		}
		if ((abs(k) & (abs(k) - 1)) == 0) {
			cout << k;
			return;
		}
		for (int i = 1;; i *= 2) {
			for (int j = 1;j < (1 << 21); j *= 2) {
				if (i + j == k) {
					cout << 2 << endl << i << " " << j;
					return;
				}
				if (i - j == k) {
					cout << 2 << endl << i << " " << -j;
					return;
				}
				if (-i - j == k) {
					cout << 2 << endl << i << " " << j;
					return;
				}
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}