//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	vector <pair <char,long long> > count;
	count.push_back({ '0',1 });
	long long pos = 0;
	for (long long i = 1; i < s.size(); i++) {
		if (s[i] != count.back().first) {
			count.push_back({ s[i],1 });
		}
		else {
			count.back().second++;
		}
	}
	vector <vector <long long> > l;
	set <long long> zero;
	long long sum = 1;
	for (long long i = 0; i < count.size(); i++) {
		if (count[i].first == '1') {
			for (long long j = 0; j < count[i].second; j++) {
				if (l.size() == j) {
					l.push_back({0, sum});
				}
				else {
					l[j].push_back(sum);
				}
				sum++;
			}
		}
		else {
			for (long long j = 0; j < count[i].second; j++) {
				zero.insert(sum);
				sum++;
			}
		}
	}
	vector <vector <long long> > newl;
	for (long long i = 0; i < l.size(); i++) {
		newl.push_back({});
		for (long long j = 0; j < l[i].size(); j++) {
			auto now = zero.lower_bound(l[i][j]);
			if (now == zero.end()) {
				cout << -1;
				exit(0);
			}
			if (l[i][j] != 0) {
				if (newl[i][newl[i].size() - 1] > l[i][j]) {
					cout << -1;
					exit(0);
				}
				newl[i].push_back(l[i][j]);
			}
			newl[i].push_back(*now);
			zero.erase(now);
		}
	}
	cout << zero.size() + newl.size() << endl;
	for (long long i = 0; i < newl.size(); i++) {
		cout << newl[i].size();
		for (long long j = 0; j < newl[i].size(); j++) {
			cout << " " << newl[i][j];
		}
		cout << endl;
	}
	for (auto now : zero) {
		cout << 1 << " " << now << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}