//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	vector <vector <int> > ans;
	for (int i = 0; i < s.size(); i++) {
		bool fs = false;
		for (int j = 0; j < ans.size(); j++) {
			if (s[ans[j].back() - 1] != s[i]) {
				ans[j].push_back(i + 1);
				fs = true;
				break;
			}
		}
		if (fs) continue;
		if (s[i] == '1') {
			cout << -1;
			exit(0);
		}
		else {
			ans.push_back({ i + 1 });
		}
	}
	for (int i = 0; i < ans.size(); i++) {
		if (s[ans[i].back() - 1] == '1') {
			cout << -1;
			return;
		}
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size();
		for (int j = 0; j < ans[i].size(); j++) {
			cout << " " << ans[i][j];
		}
		cout << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}