//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	vector <vector <int> > ans;
	set <int> one;
	set <int> zero;
	for (int i = 0; i < s.size(); i++) {
		bool fs = false;
		if (s[i] == '1') {
			if (zero.size() == 0) {
				cout << -1;
				return;
			}
			auto kek = zero.begin();
			one.insert(*kek);
			ans[*kek].push_back(i + 1);
			zero.erase(kek);
		}
		else {
			if (one.size() == 0) {
				zero.insert(ans.size());
				ans.push_back({ i + 1 });
				continue;
			}
			auto kek = one.begin();
			zero.insert(*kek);
			ans[*kek].push_back(i + 1);
			one.erase(kek);
		}
	}
	for (int i = 0; i < ans.size(); i++) {
		if (s[ans[i].back() - 1] == '1') {
			cout << -1;
			return;
		}
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size();
		for (int j = 0; j < ans[i].size(); j++) {
			cout << " " << ans[i][j];
		}
		cout << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}