#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
	int n = 0, m = 0, h = 0;
	cin >> n >> m >> h;
	vector<set<int>> v(n), tm(h);
	vector<int> t(n);
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (int i = 0; i < m; i++)
	{
		int a = 0, b = 0;
		cin >> a >> b;
		v[a - 1].insert(i);
		v[b - 1].insert(i);
		tm[t[a - 1]].insert(i);
		tm[t[b - 1]].insert(i);
	}
	for (int i = 0; i < n; i++)
	{
		bool good = true;
		for (auto j : v[i])
		{
			if (tm[(t[i] + 1) % h].count(j))
			{
				good = false;
			}
		}
		if (good)
		{
			cout << 1 << endl << i + 1 << endl;
			return 0;
		}
	}
	cout << n << endl;
	for (int i = 0; i < n;i++)
	{
		cout << i + 1 <<" ";
	}
	cout << endl;
	return 0;
}