#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cmath>

using namespace std;

vector<int> used, cnt;
vector<set<int>> g;
vector<int> dpt, par, clr;
int ans, temp, ts, te;
int ansstart, ansend;

void dfs(int v, int c, int d, int p)
{
	par[v] = p;
	used[v] = c;
	dpt[v] = d;
	clr[c]++;
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i, c, d + 1, v);
		}
	}
}

int main()
{
	int n = 0, m = 0, h = 0;
	cin >> n >> m >> h;
	vector<set<int>> v(n), tm(h);
	vector<int> t(n);
	g.resize(n);
	used.resize(n, 0);
	dpt.resize(n, 0);
	par.resize(n, 0);
	clr.resize(n + 1, 0);
	ans = n + 100;
	temp = -1;
	ansstart = -1, ansend = -1;
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (int i = 0; i < m; i++)
	{
		int a = 0, b = 0;
		cin >> a >> b;
		v[a - 1].insert(i);
		v[b - 1].insert(i);
		tm[t[a - 1]].insert(i);
		tm[t[b - 1]].insert(i);
		if ((t[a - 1] + 1) % h == t[b - 1])
		{
			g[a - 1].insert(b - 1);
		}
		if ((t[b - 1] + 1) % h == t[a - 1])
		{
			g[b - 1].insert(a - 1);
		}
	}
	// for (int i = 0; i < n; i++)
	// {
	// 	cerr << i << " ";
	// 	for (auto j : g[i])
	// 	{
	// 		cerr << j << " ";
	// 	}
	// 	cerr << endl;
	// }
	for (int i = 0; i < n; i++)
	{
		bool good = true;
		for (auto j : v[i])
		{
			if (tm[(t[i] + 1) % h].count(j))
			{
				good = false;
			}
		}
		if (good)
		{
			cout << 1 << endl << i + 1 << endl;
			return 0;
		}
	}
	int col = 1;
	for (int i = 0; i < n; i++)
	{
		temp = -1;
		if (used[i] == 0)
		{
			dfs(i, col++, 0, i);
		}
	}
	int mx = n + 100, mxi = 0;
	for (int i = 0; i <= n; i++)
	{
		if (clr[i] != 0 && clr[i] <= mx)
		{
			mx = clr[i];
			mxi = i;
		}
	}
	cout << mx << endl;
	for (int i = 0; i < n; i++)
	{
		if (used[i] == mxi)
		{
			cout << i + 1 << " ";
		}
	}
	cout << endl;
	return 0;
}