#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <bitset>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cctype>
#include <cmath>
#include <iomanip>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define fr first
#define sc second
#define get0 get<0>
#define get1 get<1>
#define get2 get<2>
#define pb push_back
#define pp pop_back

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tiii;
typedef pair<ll, ll> pll;
typedef tuple<ll, ll, ll> tlll;

const int INF = 1e9 + 7;
const int SZ = 2e5 + 100;
vector<int> l0, l1;

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    string s;
    cin >> s;
    vector<vector<int>> all(SZ);
    int cur = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (s[i] == '0')
        {
            if (l1.size() > 0)
            {
                all[l1.back()].pb(i);
                l0.pb(l1.back());
                l1.pop_back();
            }
            else
            {
                all[cur].pb(i);
                l0.pb(cur);
                cur++;
            }
        }
        else
        {
            if (l0.size() > 0)
            {
                all[l0.back()].pb(i);
                l1.pb(l0.back());
                l0.pop_back();
            }
            else
            {
                cout << -1; return 0;
            }
        }
    }

    if (l1.size())
    {
        cout << -1; return 0;
    }
    cout << l0.size() << endl;
    for (int i = 0; i < l0.size(); i++)
    {
        cout << all[l0[i]].size() << ' ';
        for (int j : all[l0[i]])
            cout << j + 1 << ' '; cout << endl;
    }
    return 0;
}