#include<iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    string s;
    cin >> s;
    int n = s.size();
    vector<vector<int>> ans;
    vector<vector<int>> inds(2);
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (inds[1].empty()) {
                inds[1].push_back(ans.size());
                ans.emplace_back();
            }
            ans[inds[1].back()].push_back(i);
            inds[0].push_back(inds[1].back());
            inds[1].pop_back();
        } else {
            if (inds[0].empty()) {
                cout << "-1\n";
                return 0;
            }
            ans[inds[0].back()].push_back(i);
            inds[1].push_back(inds[0].back());
            inds[0].pop_back();
        }
    }
    if (!inds[1].empty()) {
        cout << "-1\n";
        return 0;
    }
    cout << ans.size() << "\n";
    for (auto &v : ans) {
        cout << v.size() << " ";
        for (auto p : v) {
            cout << p + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}
//#include<iostream>
//#include <vector>
//
//using namespace std;
//
//typedef long long ll;
//
//int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(NULL);
//    string s;
//    cin >> s;
//    vector<int> ind(s.size());
//    for (int i = 0; i < s.size(); ++i) {
//        ind[i] = i;
//    }
//    vector<vector<int>> ans;
//    while (!s.empty()) {
//        int n = s.size();
//        string ns;
//        vector<int> nind;
//        vector<int> zeb;
//        vector<int> toAns;
//        vector<bool> used(n, false);
//        int last1 = -1;
//        for (int i = 0; i < n; ++i) {
//            if (s[i] == '1') {
//                last1 = i;
//            } else {
//                if (zeb.empty()) {
//                    zeb.push_back(i);
//                    toAns.push_back(ind[i]);
//                    used[i] = true;
//                } else if (last1 > zeb.back()) {
//                    zeb.push_back(last1);
//                    toAns.push_back(ind[last1]);
//                    zeb.push_back(i);
//                    toAns.push_back(ind[i]);
//                    used[last1] = used[i] = true;
//                }
//            }
//        }
//        if (zeb.empty()) {
//            cout << "-1\n";
//            return 0;
//        }
//        ans.push_back(toAns);
//        for (int i = 0; i < n; ++i) {
//            if (!used[i]) {
//                ns += s[i];
//                nind.push_back(ind[i]);
//            }
//        }
//        s = ns;
//        ind = nind;
//    }
//    cout << ans.size() << "\n";
//    for (auto &v : ans) {
//        cout << v.size() << " ";
//        for (auto p : v) {
//            cout << p + 1 << " ";
//        }
//        cout << "\n";
//    }
//    return 0;
//}