#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(),(x).end()
//#define int long long

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef vector <pii> vpii;
typedef long double ld;

template <typename T1, typename T2> bool umax(T1 &x, const T2 &y){if(x<y)return x=y,true;else return false;}
template <typename T1, typename T2> bool umin(T1 &x, const T2 &y){if(x>y)return x=y,true;else return false;}

template <typename T>
T getint() {
    T x = 0, p = 1;
    char c = getchar();
    while(c == '\n' || c == ' ')
        c = getchar();
    if(c == '-') p = -1, c = getchar();
    while('0' <= c && c <= '9') {
        x = x*10+c-'0';
        c = getchar();
    }
    return x*p;
}

const int N = (int)1e6+10;
const int mod = (int)1e9+7;
const int INF = (int)2e9+10;
const ll LLINF = (ll)1e18+10;
const ld pi = acos(-1.0);
const ld eps = (ld)1e-5;

//bool check1(int num) {
//    int id = n;
//    for(int i = 0; i < num; ++i) {
//        int val = a[i];
//
//    }
//}

int a[N];
int p, n, d, b;

void solve1() {
    int id = n;
    for(int i = n; i >= 1; --i) {
        int f = 0;
        while(f<b) {
            if(id == 0) {
                cout << i;
                return;
            }
            if(abs(id-i) > d*i) {
                --id; continue;
            }
            int k = min(b-f, a[id]);
            f += k;
            a[id] -= k;
            if(a[id]==0) --id;
        }
    }
    cout << 0 << '\n';
}

int ar[N];
bool check(int len) {
    int id1 = 1, id2 = n;
    for(int i = 1; i <= n; ++i) {
        ar[i] = a[i];
    }
    for(int i = len; i >= 0; --i) {
        int pos1 = n/2-i;
        int pos2 = n/2+i+((n&1)^1);
        if(pos1 < 1 || pos2 > n) return false;
        int f = 0;
        while(f < b) {
            if(id1>id2) return false;
            if(abs(id1-pos1)>d*pos1) {
                ++id1; continue;
            }
            int k = min(b-f, ar[id1]);
            f += k;
            ar[id1] -= k;
            if(ar[id1]==0) ++id1;
        }
        if(pos1 == pos2) continue;
        f = 0;
        while(f < b) {
            if(id1>id2) return false;
            if(abs(id2-pos2)>d*(n-pos2+1)) {
                --id2; continue;
            }
            int k = min(b-f, ar[id2]);
            f += k;
            ar[id2] -= k;
            if(ar[id2]==0) --id2;
        }
    }
    return true;
}

void solve2() {
    int l = 0, r = n+1;
    while(r-l>1) {
        int mid = (l+r)/2;
        if(check(mid)) l = mid;
        else r = mid;
    }
    cout << n/2-l-1 << '\n';
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> p >> n >> d >> b;
    for(int i = 1; i <= n; ++i) {
        cin >> a[i];
    }

    if(p == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}
