#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;

int d, b;

int solve(vector<int> &mas) {
	int n = sz(mas);
	int s = 0;
	for (int i = 0; i <= min(d, n - 1); i++)
		s += mas[i];

	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (s < b) {
			ans++;
		}
		else {
			s -= b;
		}
		int start = (i + 1) * (d + 1);
		for (int j = start; j < min(n, start + d + 1); j++) {
			s += mas[j];
		}
	}
	return ans;
}

void run() {
	
	int p, n;
	cin >> p >> n >> d >> b;
	vector<int> mas(n);
	for (int i = 0; i < n; i++)
		cin >> mas[i];
	if (p == 1) {
		cout << solve(mas);
		return;
	}

	int ans = INF;
	for (int i = 0; i < n; i++) {
		for (int j = 1; j <= mas[i]; j++) {
			vector<int> a1, a2;
			for (int k = 0; k <= i; k++) {
				if (k == i)
					a1.pb(j);
				else
					a1.pb(mas[k]);
			}
			for (int k = i; k < n; k++) {
				if (k == i)
					a2.pb(mas[i] - j);
				else
					a2.pb(mas[k]);
			}

			reverse(all(a2));

			while (sz(a1) < n / 2 + n % 2)
				a1.pb(0);
			while (sz(a2) < n / 2)
				a2.pb(0);
			ans = min(ans, max(solve(a1), solve(a2)));
		}
	}

	cout << ans;

}