#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;

int d, b;
int S = 0;

int solve(vector<int> &mas, int cnt) {
	int n = sz(mas);
	int s = 0;
	for (int i = 0; i <= min(d, n - 1); i++)
		s += mas[i];

	int ans = 0;
	for (int i = 0; i < cnt; i++) {
		if (s < b) {
			ans++;
		}
		else {
			s -= b;
		}
		int start = (i + 1) * (d + 1);
		for (int j = start; j < min(n, start + d + 1); j++) {
			s += mas[j];
		}
	}
	return ans;
}

int f(vector<int> &mas, int cnt) {
	if (cnt > S || cnt < 0)
		return INF;
	int n = sz(mas);
	vector<int> a1, a2;
	int s = 0;
	for (int i = 0; i < n; i++) {
		s += mas[i];
		if (s >= cnt) {

			for (int j = 0; j <= i; j++) {
				a1.push_back(mas[j]);
			}
			a1.push_back(s - cnt);
			a2.push_back(mas[i] - s + cnt);
			for (int j = i + 1; j < n; j++) {
				a2.push_back(mas[j]);
			}
			reverse(all(a2));

			while (sz(a1) < n / 2 + n % 2)
				a1.pb(0);
			while (sz(a2) < n / 2)
				a2.pb(0);
			return max(solve(a1, n / 2 + n % 2), solve(a2, n / 2));
		}
	}
}

void run() {
	
	int p, n;
	cin >> p >> n >> d >> b;
	vector<int> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
		S += mas[i];
	}
	if (p == 1) {
		cout << solve(mas, n);
		return;
	}

	int l = 0;
	int r = S + 2;
	while (r - l > 2) {
		int m1 = l + (r - l) / 3;
		int m2 = r - (r - l) / 3;
		int r1 = f(mas, m1);
		int r2 = f(mas, m2);
		if (r1 < r2) {
			l = m1;
		}
		else
			r = m2;
	}

	int ans = INF;
	for (int i = l - 10; i < l + 10; i++)
		ans = min(ans, f(mas, i));
	cout << ans;
}