#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 10;
const int MOD = 1e9 + 7;

int po[10][10];

int popcnt(int n) {
	int ans = 0;
	while (n) {
		ans++;
		n -= (n & (-n));
	}
	return ans;
}

void run() {

	for (int i = 1; i < 10; i++) {
		po[i][0] = 1;
		for (int j = 1; j < 10; j++) {
			po[i][j] = po[i][j - 1] * i;
		}
	}

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int ans = INF;
	vector<int> res;
	for (int mask = 0; mask < (1 << N); mask++) {
		vector<int> kek;
		int cnt = popcnt(mask);
		for (int i = 0; i < N / 2; i++) {
			if (mask & (1 << i)) {
				kek.push_back(-(1 << i));
			}
		}
		for (int i = N / 2; i < N; i++) {
			if (mask & (1 << i)) {
				kek.push_back((1 << (i - N / 2)));
			}
		}

		for (int mask1 = 0; mask1 < (1 << sz(kek)); mask1++) {
			vector<int> kkek;
			for (int i = 0; i < sz(kek); i++) {
				if (mask1 & (1 << i))
					kkek.push_back(kek[i]);
				kkek.push_back(kek[i]);
			}
			bool found = true;
			for (int i = 0; i < n; i++) {
				bool ok = false;
				for (int mask2 = 0; mask2 < (1 << sz(kkek)); mask2++) {
					int cur = a[i];
					for (int j = 0; j < sz(kkek); j++) {
						if (mask2 & (1 << j)) {
							cur -= kkek[j];
						}
					}
					if (!cur) {
						ok = true;
						break;
					}
				}
				if (!ok) {
					found = false;
					break;
				}
			}
			if (found) {
				if (sz(kkek) < ans) {
					ans = sz(kkek);
					res = kkek;
				}
			}
		}
	}

	cout << ans << endl;
	for (auto it : res)
		cout << it << ' ';

}