#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 10;
const int MOD = 1e9 + 7;

int po[10][10];

int popcnt(int n) {
	int ans = 0;
	while (n) {
		ans++;
		n -= (n & (-n));
	}
	return ans;
}

int kek[25];
int kek_cnt = 0;

int kkek[50];
int kkek_cnt = 0;

int res[50];

void run() {

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int ans = INF;
	for (int mask = 0; mask < (1 << N); mask++) {
		kek_cnt = 0;
		for (int i = 0; i < N / 2; i++) {
			if (mask & (1 << i)) {
				kek[kek_cnt++] = -(1 << i);
			}
		}
		for (int i = N / 2; i < N; i++) {
			if (mask & (1 << i)) {
				kek[kek_cnt++] = (1 << (i - N / 2));
			}
		}

		for (int mask1 = 0; mask1 < (1 << kek_cnt); mask1++) {
			kkek_cnt = 0;
			for (int i = 0; i < kek_cnt; i++) {
				if (mask1 & (1 << i))
					kkek[kkek_cnt++] = kek[i];
				kkek[kkek_cnt++] = kek[i];
				
			}
			bool found = true;
			for (int i = 0; i < n; i++) {
				bool ok = false;
				for (int mask2 = 0; mask2 < (1 << kkek_cnt); mask2++) {
					int cur = a[i];
					for (int j = 0; j < kkek_cnt; j++) {
						if (mask2 & (1 << j)) {
							cur -= kkek[j];
						}
					}
					if (!cur) {
						ok = true;
						break;
					}
				}
				if (!ok) {
					found = false;
					break;
				}
			}
			if (found) {
				if (kkek_cnt < ans) {
					ans = kkek_cnt;
					for (int i = 0; i < kkek_cnt; i++)
						res[i] = kkek[i];
				}
			}
		}
	}

	cout << ans << endl;
	for (int i = 0; i < ans; i++)
		cout << res[i] << ' ';

}