#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;


void run() {
	
	string s;
	cin >> s;

	int n = sz(s);
	vector<int> zs;
	vector<int> ns;
	vector<int> which(n, -1);
	int cur = 0;
	vector<vector<int>> ans;
	for (int i = 0; i < n; i++) {
		if (s[i] == '1') {
			if (zs.empty()) {
				cout << -1;
				return;
			}
			else {
				which[i] = which[zs.back()];
				ans[which[zs.back()]].push_back(i);
				zs.pop_back();
				ns.push_back(i);
			}
		}
		else {
			if (ns.empty()) {
				which[i] = cur++;
				ans.push_back(vector<int>());
				ans[which[i]].push_back(i);
				zs.push_back(i);
			}
			else {
				ans[which[ns.back()]].push_back(i);
				which[i] = which[ns.back()];
				ns.pop_back();
				zs.push_back(i);
			}
		}
	}
	for (auto it : ans) {
		if (s[it.back()] != '0') {
			cout << -1;
			return;
		}
	}
	cout << sz(ans) << endl;
	for (auto v : ans) {
		cout << sz(v) << ' ';
		for (auto it : v)
			cout << it + 1 << ' ';
		cout << endl;
	}

}