import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    int tree[], n, l, r;
    int sz = 1;
    int a[];

    void build() {
        while (sz < n) sz <<= 1;
        tree = new int[2 * sz];
        for (int i = 0; i < n; i++) {
            tree[sz + i] = a[i];
        }
        for (int i = sz - 1; i > 0; i++) {
            tree[i] = tree[2 * i] + tree[2 * i + 1];
        }
    }


    public void solve() throws IOException {
        int p = nextInt(), n = nextInt(), d = nextInt(), b = nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        if (p == 1) {
            int r = 0;
            int sum = 0;
            int ans = 0;
            for (int i = 0; i < n; i++) {
                while (r != Math.min(n, i + ((long)i + 1)*d + 1)) {
                    sum += a[r];
                    r++;
                }
                if(sum >= b){
                    sum -= b;
                }else ans++;
            }
            out.print(ans);
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
