#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 1e5 + 123;
const int C = (int) (1 << 21) + 5;
const int L = 20;

int n;
int a[N];
int dp[2 * C];
pair<int, int> from[2 * C];

void run() {
	fill(dp, dp + 2 * C, INF);
	queue<int> q;
	q.push(C);
	dp[C] = 0;
	while (sz(q)) {
		int v = q.front();
		q.pop();
		rep(i, 0, L + 1) {
			int x = (1 << i);
			if (v - x >= 0 && mini(dp[v - x], dp[v] + 1)) {
				from[v - x] = {i, -1};
				q.push(v - x);
			}
			if (v + x < 2 * C && mini(dp[v + x], dp[v] + 1)) {
				from[v + x] = {i, +1};
				q.push(v + x);
			}
		}
	}
	
	cin >> n;
	int ans = 0;
	vector<int> take;
	rep(i, 0, n) {
		int a;
		cin >> a;
		a += C;
		ans += dp[a];
		int x = a;
		while (x != C) {
			int what = 1 << from[x].first;
			what *= from[x].second;
			take.pb(what);
			x -= what;
		}
	}
	cout << ans << "\n";
	for (int x : take) {
		cout << x << " ";
	}
	cout << "\n";
}
