#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }

vector<vll> g, rg, gk, aa;

vll ans, color, topsort, pos, used;

ll timer = 0;

void dfs(ll v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (used[to]) continue;
        dfs(to);
    }
    pos[v] = topsort.size();
    topsort.push_back(v);
}

ll k = 0;

void paint(ll v, ll &col) {
    color[v] = col;
    for (auto to : rg[v]) {
        if (!color[to]) paint(to, col);
        else col = color[to];
    }
    color[v] = col;
}

int source() {
    ll n, m, h;
    cin >> n >> m >> h;
    vll u(n);
    for (int i = 0; i < n; ++i) cin >> u[i];
    g.resize(n), rg.resize(n);
    for (int i = 0; i < m; ++i) {
        ll v, to;
        cin >> v >> to;
        --v, --to;
        if (u[v] > u[to]) swap(v, to);
        if (u[to] - u[v] == 1) {
            g[v].push_back(to);
            rg[to].push_back(v);
        }
        if (u[to] - u[v] == h - 1) {
             swap(v, to);
             g[v].push_back(to);
             rg[to].push_back(v);
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        if (g[i].size() == 0) {
            cout << "1\n" << i + 1 << '\n';
            return 0;
        }
    }
    pos.assign(n, -1);
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        dfs(i);
    }
    color.assign(n, 0);
    for (int i = n - 1; i >= 0; --i) {
        assert(pos[i] >= 0);
        ll v = topsort[i];
        ++k;
        ll col = k;
        paint(v, col);
        if (col != k) --k;
    }
    //cerr << k << '\n';
    //for (int i =0 ; i < n; ++i) cerr << color[i] << ' ';
    //cerr << '\n';
    vll gk(k);
    for (int i = 0; i < n; ++i) {
        for (auto to : g[i]) {
            if (color[to] != color[i]) gk[color[i] - 1]++;
        }
    }
    aa.resize(k);
    for (int i = 0; i < n; ++i) aa[color[i] - 1].push_back(i);
    for (int i = 0; i < k; ++i) {
        if (gk[i] || aa[i].size() == 1) continue;
        if (ans.size() == 0 || ans.size() > aa[i].size()) ans = aa[i];
    }
    assert(ans.size() != 0);
    cout << ans.size() << '\n';
    for (auto to : ans) cout << to + 1 << ' ';
    /*
    */
    return 0;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    //cin >> test;
#endif // aokigahara

    ll test = 1;
    for (int i = 0; i < test; ++i) {
        source();
        cout << '\n';
    }

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
