#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x)*(x))
#define pw(x) (1ll << (x))
#define _ inline

ll logn(ll n) { return ll(log2(ld(n))); }
ll rnd() { return (rand() << 16) + rand(); }

int source() {
    string s;
    cin >> s;
    ll n = s.size();
    if (s[0] == '1') {
        cout << -1;
        return 0;
    }
    vll g(n, -1);
    ll it = 0;
    for (ll i = 0; i < n; ++i) {
        if (s[i] == '0') continue;
        it = max(it, i);
        while (it != n && s[it] != '0') ++it;
        if (it == n) {
            cout << -1;
            return 0;
        }
        g[i] = it;
        g[it] = i;
        ++it;
    }
    vector<vll> a;
    for (int i = 0; i < n; ++i) {
        if (g[i] == -1) a.push_back(vll(1, i));
    }
    reverse(all(a));
    for (int i = 1; i < n; ++i) {
        if (s[i] == '0') continue;
            ll l = -1, r = a.size();
            while (r - l > 1) {
                ll m = (l + r) / 2;
                if (a[m].back() < i) r = m;
                else l = m;
            }
            if (r == a.size()) {
                cout << -1;
                return 0;
            }
            //cerr << r << ' ';
            a[r].push_back(i);
            a[r].push_back(g[i]);
    }
    cout << a.size() << '\n';
    for (int i = 0; i < a.size(); ++i) {
        cout << a[i].size() <<' ';
        sort(all(a[i]));
        for (int j = 0;j < a[i].size(); ++j) cout << a[i][j] + 1 << ' ';
        cout <<'\n';
    }
    return 0;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    ll test = 1;
#ifdef aokigahara
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
    cin >> test;
#endif // aokigahara

    for (int i = 0; i < test; ++i) {
        source();
        cout << '\n';
    }

#ifdef aokigahara
    cerr << fixed << setprecision(12) << "\n\nTIME : " << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
