#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<cmath>
using namespace std;
#define elif else if
#define int long long
class point
{
public:
	double x, y;
	point operator +(point a)
	{
		return { a.x + x,a.y + y };
	}
	point operator -(point a)
	{
		return { x - a.x,y - a.y };
	}
	point operator *(double k)
	{
		return { k*x,k*y };
	}
	point operator /(double k)
	{
		return { x / k,y / k };
	}
	double operator *(point a)
	{
		return a.x*x + a.y*y;
	}
	double operator %(point a)
	{
		return x * a.y - y * a.x;
	}
	double lensqr()
	{
		return x * x + y * y;
	}
	double len()
	{
		return sqrt(lensqr());
	}
	point norm()
	{
		return { x / len(),y / len() };
	}
};
int32_t main()
{
	ios_base::sync_with_stdio(0);
	string s;
	cin >> s;
	vector<int>usd(s.size(), 0);
	vector<vector<int>>ans;
	for (int i = 0; i < s.size(); ++i)
	{
		if (usd[i])
		{
			continue;
		}
		if (s[i] == '1')
		{
			cout << -1;
			return 0;
		}
		usd[i] = 1;
		bool cur = 1;
		ans.push_back({ i });
		for (int q = i + 1; q < s.size(); ++q)
		{
			if (usd[q])
				continue;
			if (s[q] == '0' + (int)cur)
			{
				cur = !cur;
				usd[q] = 1;
				ans.back().push_back(q);
			}
		}
		if (cur == 0)
		{
			usd[ans.back().back()] = 0;
			ans.back().pop_back();
		}
	}
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i)
	{
		cout << ans[i].size();
		for (int q = 0; q < ans[i].size(); ++q)
		{
			cout << ' ' << ans[i][q] + 1;
		}
		cout << '\n';
	}
	return 0;
}