#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<stack>
#include<cmath>
#include<list>
using namespace std;
#define elif else if
#define int long long
class point
{
public:
	double x, y;
	point operator +(point a)
	{
		return { a.x + x,a.y + y };
	}
	point operator -(point a)
	{
		return { x - a.x,y - a.y };
	}
	point operator *(double k)
	{
		return { k*x,k*y };
	}
	point operator /(double k)
	{
		return { x / k,y / k };
	}
	double operator *(point a)
	{
		return a.x*x + a.y*y;
	}
	double operator %(point a)
	{
		return x * a.y - y * a.x;
	}
	double lensqr()
	{
		return x * x + y * y;
	}
	double len()
	{
		return sqrt(lensqr());
	}
	point norm()
	{
		return { x / len(),y / len() };
	}
};
int32_t main()
{
	ios_base::sync_with_stdio(0);
	string s;
	cin >> s;
	vector<int>usd(s.size(), 0);
	vector<vector<int>>ans;
	set<int>num;
	for (int i = 0; i < s.size(); ++i)
	{
		num.insert(i);
	}
	for (auto it = num.begin(); it != num.end(); ++it)
	{
		int i = *it;
		if (s[i] == '1')
		{
			cout << -1;
			return 0;
		}
		bool cur = 1;
		auto it2 = ++it;
		--it;
		ans.push_back({ i });
		for (; it2 != num.end();)
		{
			int q = *it2;
			if (s[q] == '0' + (int)cur)
			{
				cur = !cur;
				auto it3 = it2++;
				num.erase(it3);
				ans.back().push_back(q);
			}
			else ++it2;
		}
		if (cur == 0)
		{
			num.insert(ans.back().back());
			ans.back().pop_back();
		}
	}
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i)
	{
		cout << ans[i].size();
		for (int q = 0; q < ans[i].size(); ++q)
		{
			cout << ' ' << ans[i][q] + 1;
		}
		cout << '\n';
	}
	return 0;
}