#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

#define F first
#define S second
#define add push_back
#define ins insert
#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

const ll INF = (ll)1e9 + 2018;

const int N = 1e5 + 10;
int arr[N], col[N];
set <int> gr[N], rgr[N];
bool used[N], w[N];
vector <int> order, comp[N];

void dfs1(int v) {
    used[v] = 1;
    for (int u : gr[v]) {
        if (!used[u]) {
            dfs1(u);
        }
    }
    order.add(v);
}

void dfs2(int v, int c) {
    col[v] = c;
    for (int u : rgr[v]) {
        if (!col[u]) {
            dfs2(u, c);
        }
    }
    comp[c].add(v);
}

void $main() {
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if ((arr[u] + 1) % h == arr[v]) {
            gr[u].ins(v);
            rgr[v].ins(u);
        }
        if ((arr[v] + 1) % h == arr[u]) {
            gr[v].ins(u);
            rgr[u].ins(v);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(all(order));
    int cnt = 0;
    for (int v : order) {
        if (!col[v]) {
            cnt++;
            dfs2(v, cnt);
        }
    }
    for (int i = 1; i <= cnt; i++) {
        w[i] = 1;
    }
    for (int i = 0; i < n; i++) {
        for (int u : gr[i]) {
            if (col[i] != col[u]) {
                w[col[i]] = 0;
            }
        }
    }
    vector <int> ans;
    ans.resize(n + 10, INF);
    for (int i = 1; i <= cnt; i++) {
        if (w[i]) {
            if (sz(ans) > sz(comp[i])) {
                ans.clear();
                for (int v : comp[i]) {
                    ans.add(v);
                }
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        cout << col[i] << " ";
    }
    cout << endl;*/
    cout << sz(ans) << endl;
    for (int it : ans) {
        cout << it + 1 << " ";
    }
}

int main() {
    ios::sync_with_stdio(0);
#ifdef flaax
    freopen("input.txt", "r", stdin);
#endif
    $main();
}
