#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define X first
#define Y second
#define inb push_back

const int M = 1e5 + 5;

int n, m, h;
vector<int> g[M], an;
int u[M];
bool us[M];

void dfs(int v)
{
	us[v] = 1;
	for (int u : g[v])
		if (!us[u]) dfs(u);
	an.inb(v);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	scanf("%d%d%d", &n, &m, &h);
	for (int i = 1; i <= n; ++i)
		scanf("%d", &u[i]);
	for (int i = 0, a, b; i < m; ++i)
	{
		scanf("%d%d", &a, &b);
		if (u[a] > u[b]) swap(a, b);
		if (u[a] + 1 == u[b]) g[a].inb(b);
		if (!u[a] && u[b] == h - 1) g[b].inb(a);
	}
	vector<int> ans;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= n; ++j) us[j] = 0;
		an.clear();
		dfs(i);
		if (!ans.size() || ans.size() > an.size()) swap(ans, an);
	}
	cout << ans.size() << '\n';
	for (int i : ans) cout << i << ' ';
}