#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 1e5 + 5;

int n, m, h;
vector<int> g[M], an, ord, gt[M];
int u[M], col[M], cn, kol[M];
bool us[M];

void dfs(int v)
{
	us[v] = 1;
	for (int u : g[v])
		if (!us[u]) dfs(u);
	ord.inb(v);
}

void rdfs(int v)
{
	col[v] = cn;
	kol[cn]++;
	for (int u : gt[v])
		if (!col[u])
			rdfs(u);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	scanf("%d%d%d", &n, &m, &h);
	for (int i = 1; i <= n; ++i)
		scanf("%d", &u[i]);
	for (int i = 0, a, b; i < m; ++i)
	{
		scanf("%d%d", &a, &b);
		if (u[a] > u[b]) swap(a, b);
		if (u[a] + 1 == u[b]) g[a].inb(b), gt[b].inb(a);
		if (!u[a] && u[b] == h - 1) g[b].inb(a), gt[a].inb(b);
	}
	vector<int> ans;
	for (int i = 1; i <= n; ++i)
		if (!us[i]) dfs(i);
	for (int i = 1; i <= n; ++i) us[i] = 0;
	reverse(all(ord));
	for (int i = 0; i < ord.size(); ++i)
		if (!col[ord[i]])
			++cn, rdfs(ord[i]);
	for (int i = 1; i <= n; ++i)
		for (int j : g[i])
			if (col[i] != col[j])
				us[col[i]] = 1;
	int an = -1;
	for (int i = 1; i <= cn; ++i)
		if (!us[i] && (an == -1 || kol[i] < kol[an])) an = i;
	for (int i = 1; i <= n; ++i)
		if (col[i] == an) ans.inb(i);
	cout << ans.size() << '\n';
	for (int i : ans) cout << i << ' ';
}