#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <time.h>

using namespace std;

const int MEM = 2e8;
char mem[MEM];
int mpos;
inline void * operator new(size_t n)
{
	char * res = mem + mpos;
	mpos += n;
	return (void *)res;
}
inline void operator delete(void *) {}

typedef pair<int, int> pii;
typedef long long ll;

#define X first
#define Y second
#define inb push_back
#define all(v) (v).begin(), (v).end()

const int M = 2005;

int n, w[M], r, a[M], d[M];

bool ch()
{
	for (int i = 0; i <= 1000; ++i) d[i] = 0;
	d[500] = -1;
	for (int j = 0; j < r; ++j)
		for (int k = 0; k <= 1000; ++k)
			if (d[k] && d[k] != j + 1 && k + w[j] >= 0)
				d[k + w[j]] = j + 1;
	for (int i = 0; i < n; ++i)
		if (!d[a[i] + 500])
			return 0;
	return 1;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	cin >> n;
	vector<int> an;
	for (int i = 0; i < n; ++i) cin >> a[i];
	vector<pair<int, pii>> dd;
	for (int i = 0; i < 1024; ++i)
		for (int j = 0; j < 1024; ++j)
		{
			r = 0;
			for (int k = 0; k < 10; ++k)
			{
				if ((1 << k) & i) ++r;
				if ((1 << k) & j) ++r;
			}
			dd.inb({ r, {i, j} });
		}
	sort(all(dd));
	for(int q = 0, i, j; q < dd.size(); ++q)
	{
		i = dd[q].Y.X, j = dd[q].Y.Y;
		r = 0;
		for (int k = 0; k < 10; ++k)
		{
			if ((1 << k) & i) w[r++] = (1 << k);
			if ((1 << k) & j) w[r++] = -(1 << k);
		}
		if (ch())
		{
			for (int k = 0; k < 10; ++k)
			{
				if ((1 << k) & i) an.inb((1 << k));
				if ((1 << k) & j) an.inb(-(1 << k));
			}
			break;
		}
	}
	cout << an.size() << '\n';
	for (int i : an) cout << i << ' ';
}