#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 100100;

int n, m, h;
int u[N];
std::vector<int> g[N];
std::vector<int> curAns;
bool used[N];

void dfs(int v) {
    curAns.push_back(v);
    used[v] = true;
    for (auto to: g[v]) {
        if (!used[to] && (u[v] + 1) % h == u[to] % h) {
            dfs(to);
        }
    }
}

int main(void) {
    scanf("%d%d%d", &n, &m, &h);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &u[i]);
    }
    for (int i = 0; i < m; ++i) {
        int from, to;
        scanf("%d%d", &from, &to);
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
    std::vector<int> answer;
    for (int i = 0; i < n; ++i) {
        memset(used, false, n * sizeof(bool));
        curAns.clear();
        dfs(i);
        if (answer.empty() || curAns.size() < answer.size()) {
            answer.swap(curAns);
        }
    }
    printf("%d\n", answer.size());
    for (auto i: answer) {
        printf("%d ", i + 1);
    }
    return 0;
}