#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 200100;

bool used[N];

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string str;
    std::cin >> str;
    int n = str.size();
    for (int i = 1; i < n; ++i) {
        if (str[i] == '1' && str[i - 1] == '1') {
            std::cout << "-1\n";
            return 0;
        }
    }
    if (str[0] == '1' || str[n - 1] == '1') {
        std::cout << "-1\n";
        return 0;
    }
    std::vector<std::vector<int>> ans(1);
    ans[0].push_back(0);
    used[0] = true;
    for (int i = 0; i < n; ++i) {
        if (str[i] == '1') {
            ans[0].push_back(i);
            ans[0].push_back(i + 1);
            used[i] = true;
            used[i + 1] = true;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ans.push_back(std::vector<int>());
            ans.back().push_back(i);
        }
    }
    std::cout << ans.size() << '\n';
    for (auto i: ans) {
        std::cout << i.size() << ' ';
        for (auto j: i) {
            std::cout << j + 1 << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}