#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 200100;

bool used[N];

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string str;
    std::cin >> str;
    int n = str.size();
    int zeroL = 0, zeroR = 0;
    std::vector<std::vector<int>> ans;
    for (int i = 0; i < n; ++i) {
        if (str[i] == '1') {
            while (zeroL < i && (used[zeroL] || str[zeroL] != '0')) {
                ++zeroL;
            }
            if (zeroL == i) {
                std::cout << "-1\n";
                return 0;
            }
            used[zeroL] = true;
            while (zeroR < n && (zeroR <= i || used[zeroR] || str[zeroR] != '0')) {
                ++zeroR;
            }
            if (zeroR == n) {
                std::cout << "-1\n";
                return 0;
            }
            used[zeroR] = true;
            ans.push_back(std::vector<int>());
            ans.back().push_back(zeroL);
            ans.back().push_back(i);
            ans.back().push_back(zeroR);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (str[i] == '0' && !used[i]) {
            ans.push_back(std::vector<int>());
            ans.back().push_back(i);
        }
    }
    std::cout << ans.size() << '\n';
    for (auto i: ans) {
        std::cout << i.size() << ' ';
        for (auto j: i) {
            std::cout << j + 1 << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}