//#include "stdafx.h"


#include <fstream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <deque>
#include <iostream>

using namespace std;

int n, m, h, ans = 1e9;
vector <vector <int > > a;
vector <int > u, use, len, p;


void bfs(int st)
{
	deque <int > q;
	q.push_back(st);
	use.clear();
	p.clear();
	use.resize(n, -1);
	p.resize(n, -1);
	use[st] = 0;
	p[st] = -1;
	while (!q.empty())
	{
		auto v = q.front();
		q.pop_front();
		for (int i = 0; i < a[v].size(); i++)
			if (use[a[v][i]] == -1)
			{
				use[a[v][i]] = use[v] + 1;
				p[a[v][i]] = v;
				q.push_back(a[v][i]);
			}
			else if (a[v][i] == st)
			{
				if (ans > use[v] + 1)
				{
					ans = min(ans, use[v] + 1);
					len.clear();
					len.push_back(a[v][i]);
					while (p[v] != -1)
					{
						len.push_back(v);
						v = p[v];
					}
				}
				return;
			}
	}
}

int main()
{
	ifstream cin("input.txt");
	//	ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m >> h;

	u.resize(n);
	for (int i = 0; i < n; i++)
		cin >> u[i];

	a.resize(n);
	int x, y;
	for (int i = 0; i < m; i++)
	{
		cin >> x >> y;
		if ((u[x - 1] + 1) % h == u[y - 1])
			a[x - 1].push_back(y - 1);
		else if ((u[y - 1] + 1) % h == u[x - 1])
			a[y - 1].push_back(x - 1);
	}

	len.resize(n, 0);
	for (int i = 0; i < n; i++)
		if (a[i].size() == 0)
		{
			ans = 1;
			len.clear();
			len.push_back(i);
		}
		else bfs(i);

	cout << ans << endl;
	for (int i = 0; i < ans; i++)
		cout << len[i] + 1 << ' ';
	return 0;
}

