#include "stdafx.h"


#include <fstream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <deque>
#include <iostream>

using namespace std;

int n, m, h, ans = 1e9, ans2;
vector <vector <int > > a;
vector <int > u, use, len, len2, len3, p;

int dfs(int v, int c)
{
	use[v] = c;
	int sum = 1;
	for (int i = 0; i < a[v].size(); i++)
		if (use[a[v][i]] != c)
			sum += dfs(a[v][i], c);
	return sum;
}

void dfs2(int v, int c)
{
	use[v] = c;
	len.push_back(v);
	for (int i = 0; i < a[v].size(); i++)
		if (use[a[v][i]] != c)
			dfs2(a[v][i], c);
}

int main()
{
	ifstream cin("input.txt");
	//	ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m >> h;

	u.resize(n);
	for (int i = 0; i < n; i++)
		cin >> u[i];

	a.resize(n);
	int x, y;
	for (int i = 0; i < m; i++)
	{
		cin >> x >> y;
		if ((u[x - 1] + 1) % h == u[y - 1])
			a[x - 1].push_back(y - 1);
		if ((u[y - 1] + 1) % h == u[x - 1])
			a[y - 1].push_back(x - 1);
	}

	len.resize(n, 0);
	for (int i = 0; i < n; i++)
		if (a[i].size() == 0)
		{
			ans = 1;
			len.clear();
			len.push_back(i);
		}

	int q = 0, iq = 0;
	if (ans == 1e9)
	{
		use.resize(n, -1);
		for (int i = 0; i < n; i++)
		{
			q = dfs(i, i + 1);
			if (q < ans)
			{
				iq = i;
				ans = q;
			}
		}
		cout << ans << endl;
		len.clear();
		dfs2(iq, 1e7);
		for (int i = 0; i < ans; i++)
			cout << len[i] + 1 << ' ';
		return 0;
	}
	cout << ans << endl;
	for (int i = 0; i < ans; i++)
		cout << len[i] + 1 << ' ';
	return 0;
}

