#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>

using namespace std;

#define ll long long

vector <vector <int>> ans;

void print(vector <vector <int>> &add, string &s) {
    cout << "got" << endl;
    for (auto i : add) {
        for (auto j : i) {
            cout << j << " ";
        }
        cout << ": ";
        for (auto j : i) {
            cout << s[j] << " ";
        }
        cout << endl;
    }
}

bool rec(int ind, string &s, vector <vector <int>> add) {
    if (ind >= s.size()) {
        for (auto &i : add) {
            if (s[i.back()] == '1') return 0;
        }
        ans = add;
        return 1;
    }
    for (auto &i : add) {
        if (s[i.back()] != s[ind]) {
            i.push_back(ind);
            if (rec(ind + 1, s, add)) return 1;
            i.pop_back();
        }
    }
    if (s[ind] == '0') {
        vector <int> tmp(1, ind);
        add.push_back(tmp);
        if (rec(ind + 1, s, add)) return 1;
    }
    return 0;
}


int main() {
    //freopen("in.txt", "r", stdin);
    string s;
    cin >> s;

    int cnt1 = 0, cnt0 = 0;

    for (int i = 0; i < n; ++i) {
        cnt0 += (s[i] == '0');
        cnt1 += (s[i] == '1');
    }
    if (s[0] == '1' || cnt1 > cnt0) {
        cout << -1;
        return 0;
    }

    vector <vector <int>> add;
    if (rec(0, s, add)) {
        cout << ans.size() << endl;
        for (auto i : ans) {
            cout << i.size() << " ";
            for (auto j : i) cout << j + 1 << " ";
            cout << endl;
        }
    }
    else {
        cout << -1;
    }

    return 0;
}

