#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 10;

vector <int> g[MAXN];
vector <int> rg[MAXN];
vector <int> tg[MAXN];

int t1[MAXN], t2[MAXN];

bool used[MAXN];

int t = 0;

int tout[MAXN];

void dfs(int u)
{
    used[u] = 1;
    for (int v : g[u])
        if (!used[v])
            dfs(v);
    tout[t++] = u;
}


int color[MAXN];

void rdfs(int u, int p)
{
    color[u] = p;
    for (int v : rg[u])
        if (!color[v])
            rdfs(v, p);
}

int used2[MAXN];

set <int> st;
void check(int u, int p, bool &ok)
{
    st.insert(u);
    used2[u] = 1;

    for (int v : g[u])
    {
        if (color[v] == p && !used2[v])
            check(v, p, ok);
        if (!color[v])
        {
            ok = 0;
            return;
        }
    }
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
    {
        cin >> t1[i];
        t2[i] = (t1[i] + 1) % h;
    }
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        tg[u].push_back(v);
        tg[v].push_back(u);
    }

    int ans = n + 1, ansu = 0;
    for (int u = 1; u <= n; u++)
    {
        for (int v : tg[u])
        {
            if (t2[u] == t1[v])
            {
                g[u].push_back(v);
                rg[v].push_back(u);
//                cout << u << " " << v;
            }
        }
    }

    for (int i = 1; i <= n; i++)
    {
        if (g[i].empty())
            return cout << "1\n" << i, 0;
        if (!used[i])
            dfs(i);
    }

    int sz = n + 2;
    set <int> best;

    for (int i = n - 1; i >= 0; i--)
    {
        if (!color[tout[i]])
        {
            st.clear();
            rdfs(tout[i], tout[i]);
            bool ok = 1;
            check(tout[i], tout[i], ok);
            if (ok && sz > st.size())
            {
                best = st;
                sz = best.size();
            }
        }
    }
    cout << best.size() << "\n";
    for (int i : best)
        cout << i << " ";

    return 0;
}

//60
