#include <bits/stdc++.h>
using namespace std;
//#define int int64_t
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define pob pop_back
#define sz(v) ((int) (v).size())
#define all(v) (v).begin(), (v).end()
#define forn(i, j, n) for (int (i) = (j); (i) < (n); ++i)
#define forc(i, n, j) for (int (i) = (n) - (1); (i) >= (j); --i)
typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <double> vd;
typedef vector <bool> vb;

const int MAX = (int) 1e5 + 5;

vi g[MAX], grev[MAX], comp[MAX], topsort;

int color[MAX], calc[MAX], cnt;

bool used[MAX];

void dfs(int v)
{
    used[v] = true;
    for (auto u : g[v])
        if (!used[u])
            dfs(u);
    topsort.pb(v);
}

void dfs1(int v)
{
    used[v] = true;
    comp[cnt].pb(v);
    color[v] = cnt;
    for (auto u : grev[v])
        if (!used[u])
            dfs1(u);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    int arr[n];
    forn(i, 0, n)
        cin >> arr[i];
    forn(i, 0, m)
    {
        int a, b;
        cin >> a >> b;
        --a, --b;
        if ((arr[a] + 1) % h == arr[b])
        {
            g[a].pb(b);
            grev[b].pb(a);
        }
        if ((arr[b] + 1) % h == arr[a])
        {
            g[b].pb(a);
            grev[a].pb(b);
        }
    }
    forn(i, 0, n)
        if (!used[i])
            dfs(i);
    reverse(all(topsort));
    fill(used, used + n, false);
    for (auto v : topsort)
    {
        if (used[v])
            continue;
        dfs1(v);
        ++cnt;
    }
    forn(v, 0,n)
        for (auto u : g[v])
            if (color[v] != color[u])
                calc[color[v]]++;
    int ans = n + 1, pos;
    forn(i, 0, cnt)
    {
        if (calc[i])
            continue;
        if (sz(comp[i]) < ans)
        {
            ans = sz(comp[i]);
            pos = i;
        }
    }
    cout << sz(comp[pos]) << endl;
    for (auto el : comp[pos])
        cout << el + 1 << ' ';
    return 0;
}
