#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int p, n, d, b;
vector<int> nums, pref;

bool check(int x)
{
    return pref[min(n, d * (x + 1) + x + 1)] >= b;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> p >> n >> d >> b;
    nums.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> nums[i];
        pref[i + 1] = pref[i] + nums[i];
    }

    int left = -1, right = n;
    while (right - left > 1) {
        int middle = (left + right) / 2;
        //cout << middle << " " << check(middle) << endl;
        if (check(middle))
            right = middle;
        else
            left = middle;
    }

    cout << right << endl;

    return 0;
}
