#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int p, n, d, b;
vector<int> nums;

bool check(int x)
{
    int sum = 0;
    for (int i = 0; i <= min(n - 1, x + d * (x + 1)); ++i)
        sum += nums[i];
    //cout << x << " " << sum << endl;
    if (sum < b)
        return false;

    int last = x + d * (x + 1);
    for (int i = x + 1; i < n; ++i) {
        sum -= b;
        for (int j = last + 1; j <= min(n - 1, last + d + 1); ++j)
            sum += nums[j];
        last += d + 1;
        //cout << x << " " << i << " " << sum << " " << last << endl;
        if (sum < b)
            return false;
    }

    return true;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> p >> n >> d >> b;
    nums.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    int left = -1, right = n;
    while (right - left > 1) {
        int middle = (left + right) / 2;
        //cout << middle << " " << check(middle) << endl;
        if (check(middle))
            right = middle;
        else
            left = middle;
    }

    if (p == 1)
        cout << right << endl;
    else {
        int ans = right;
        reverse(all(nums));

        int left = -1, right = n;
        while (right - left > 1) {
            int middle = (left + right) / 2;
            //cout << middle << " " << check(middle) << endl;
            if (check(middle))
                right = middle;
            else
                left = middle;
        }

        cout << ans + right << endl;
    }

    return 0;
}
