#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7, MAXP = 6;
const ld EPS = 1e-9, PI = acos(-1);

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, start = 0;
    cin >> n;
    vector<int> nums(n);
    for (int i = 0; i < n; ++i) {
        cin >> nums[i];
        int one = 0;
        for (int j = 0; j < MAXP; ++j)
            if (nums[i] & (1 << j))
                one++;
        start = max(start, min(one, MAXP + 1 - one));
    }

    for (int sz = start; ; ++sz) {
        vector<int> now(sz, -(1 << MAXP));
        //cout << sz << endl;
        for (;;) {
            /*if (sz == 3) {
                for (int elem : now)
                    cout << elem << " ";
                cout << endl;
            }*/

            bool success = true;
            for (int i = 0; i < n; ++i) {
                //cout << i << endl;
                int sum = 0;
                bool correct = false;
                for (int mask = 0; mask < (1 << sz); ++mask) {
                    sum = 0;
                    for (int j = 0; j < sz; ++j)
                        if (mask & (1 << j))
                            sum += now[j];

                    //if (sz == 3 && now[0] == -1 && now[1] == 4 && now[2] == 4)
                    //    cout << mask << " " << sum << endl;

                    if (nums[i] == sum) {
                        correct = true;
                        break;
                    }
                }

                if (!correct) {
                    success = false;
                    break;
                }
            }

            if (success) {
                cout << sz << endl;
                for (int elem : now)
                    cout << elem << " ";
                return 0;
            }

            int i;
            for (i = sz - 1; i > -1; --i) {
                if (now[i] < -1)
                    now[i] /= 2;
                else if (now[i] == -1)
                    now[i] = 1;
                else if (now[i] > 0 && now[i] < (1 << MAXP))
                    now[i] *= 2;
                else {
                    now[i] = -(1 << MAXP);
                    continue;
                }
                break;
            }

            if (i == -1)
                break;
        }
    }

    return 0;
}
