#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int32_t main()
{
    string s;
    cin >> s;
    int n = s.size();

    vector<vector<int>> ans;
    vector<bool> used(n);
    int rem = n;
    bool success = true;
    while (rem > 0) {
        vector<int> row;
        int now = 0;
        for (int i = 0; i < n; ++i) {
            if (used[i] || (s[i] - '0' != now))
                continue;
            row.pb(i + 1);
            used[i] = true;
            rem--;
            now ^= 1;
        }

        if (row.empty() || s[row.back() - 1] == '1') {
            success = false;
            break;
        }
        ans.pb(row);
    }

    if (!success) {
        cout << -1 << endl;
        return 0;
    }

    cout << ans.size() << endl;
    for (auto &elem : ans) {
        cout << elem.size() << " ";
        for (int el : elem)
            cout << el << " ";
        cout << endl;
    }

    return 0;
}

