#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < b; ++i)

int debug = 0;

const int N = 3e5;
int n, m, h, clr, a[N], sz[N], was[N];
vector <int> g[N], gt[N], g2[N], top;

int dist(int x, int y) {
    int dif = a[y] - a[x];
    return (dif + h + h) % h;
}

void dfs1(int v) {
    if (was[v]) return;
    was[v] = 1;
    for (int u : g[v]) dfs1(u);
    top.push_back(v);
}

void dfs2(int v) {
    was[v] = clr;
    sz[clr]++;
    for (int u : gt[v]) {
        if (was[u] == 0) {
            dfs2(u);
        } else if (was[u] != clr) {
            g2[was[u]].push_back(clr);
        }
    }
}

main() {
    cin >> n >> m >> h;
    rep(i, 0, n) { scanf("%d", &a[i]); }
    rep(i, 0, m) {
        int u, v;
        scanf("%d%d", &u, &v);
        --u, --v;
        if (dist(u, v) == 1) {
            g[u].push_back(v);
            gt[v].push_back(u);
        }
        if (dist(v, u) == 1) {
            g[v].push_back(u);
            gt[u].push_back(v);
        }
    }
    vector <int> ans;
    int mn = N, clr_opt;
    rep(i, 0, n) dfs1(i);
    fill(was, was + n, 0);
    clr = 1;
    reverse(top.begin(), top.end());
    for (int i : top) {
        if (!was[i]) {
            dfs2(i);
            clr++;
        }
    }
    rep(i, 1, clr) {
        if (g2[i].empty()) {
            if (sz[i] < mn) {
                mn = sz[i];
                clr_opt = i;
            }
        }
    }
    if (debug) {
        cerr << " clr = " << clr << " clr_opt=" << clr_opt << endl;
        rep(i,0,n) cerr << was[i] << ' ';
        cerr << " =was\n";
    }
    rep(i, 0, n) {
        if (was[i] == clr_opt) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) cout << i + 1 << ' ';
    return 0;
}
