#include <bits/stdc++.h>
#define int long long
#define fastio() ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

using namespace std;

const int inf = (int)1e8;



vector < vector < int > > g;
vector < vector < int > > invg;
vector < vector < int > > con;
vector < set < int > > newg;
vector < int > order;
vector < int > t;
vector < int > used;
vector < int > dp;
map < int, int > stob;
int n, m, h;

void dfs1(int v, vector < int > &used){
    used[v] = 1;
    for(int i = 0; i < g[v].size(); ++i){
        int u = g[v][i];
        if(used[u] == 0)dfs1(u, used);
    }
    order.push_back(v);
}


void dfs2(int v, vector < int > &used, vector < int > &comp){
    used[v] = 1;
    comp.push_back(v);
    for(int i = 0; i < g[v].size(); ++i){
        int u = g[v][i];
        if(used[u] == 0)dfs2(u, used, comp);
    }
}


void dfs3(int v, vector < int > &used, vector < int > &curcomp){
    used[v] = 1;
    curcomp.push_back(v);
    for(int i = 0; i < invg[v].size(); ++i){
        int u = invg[v][i];
        if(used[u] == 0)dfs3(u, used, curcomp);
    }
}

void dfs4(int v, vector < int > &used){
    used[v] = 1;
    for(int i = 0; i < g[v].size(); ++i){
        int to = g[v][i];
        if(stob[to] != stob[v]){
            newg[stob[v]].insert(stob[to]);
        }
        if(used[to] == 0)dfs4(to, used);
    }
}


void dfs5(int v, vector < int > &bused){
    bused[v] = 1;
    int res = con[v].size();
    for(auto u: newg[v]){
        if(used[u] == 0)dfs5(u, bused);
        res += dp[u];
    }
    dp[v] = res;
}



signed main()
{
    fastio();
    cin >> n >> m >> h;
    dp.resize(n);
    t.resize(n);
    used.resize(n);
    g.resize(n);
    invg.resize(n);
    for(int i = 0; i < n; ++i)cin >> t[i];
    for(int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        --v, --u;
        if((t[v] + 1) % h == t[u]){
            g[v].push_back(u);
            invg[u].push_back(v);
        }
        if((t[u] + 1) % h == t[v]){
            g[u].push_back(v);
            invg[v].push_back(u);
        }
    }

    for(int i = 0; i < n; ++i){
        if(used[i] == 0)dfs1(i, used);
    }
    //reverse(order.begin(), order.end());
    fill(used.begin(), used.end(), 0);
    for(int i = 0; i < n; ++i){
        int curv = order[i];
        if(used[curv] == 1)continue;
        vector < int > curcomp;
        dfs3(curv, used, curcomp);
        for(int j = 0; j < curcomp.size(); ++j){
            int v = curcomp[j];
            stob[v] = con.size();
        }
        con.push_back(curcomp);
    }
    newg.resize(con.size());
    dp.resize(newg.size());
    fill(used.begin(), used.end(), 0);
    for(int i = 0; i < n; ++i){
        if(used[i] == 0){
            dfs4(i, used);
        }
    }
    vector < int > bused(con.size(), 0);
    for(int i = 0; i < con.size(); ++i){
        if(bused[i] == 0)dfs5(i, bused);
    }
    fill(bused.begin(), bused.end(), 0);
    int mn = inf;
    int st = -1;
    for(int i = 0; i < con.size(); ++i){
        if(dp[i] < mn){
            mn = dp[i];
            st = con[i][0];
        }
    }
    vector < int > comp;
    fill(used.begin(), used.end(), 0);
    dfs2(st, used, comp);
    cout << comp.size() << "\n";
    for(int i = 0; i < comp.size(); ++i){
        cout << comp[i] + 1 << " ";
    }
}
