#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(1235);

const int maxn = 1e5 + 100, maxw = 1e6 + 100, inf = 1e9 + 100, mod = 1e9 + 7, sq = 300, LG = 18;

int lels = -inf, plels = -inf;

int n;

int a[maxn];

int MX;

int taken[LG];

vector<int> answer;

bool e[2 * LG][2 * LG];

int top[2 * LG];

int sz;

bool vis[2 * LG];

int ind[2 * LG];

bool sure[2 * LG];

void clv(){
    for (int i = 0; i < 2 * MX; i++)
        vis[i] = 0;
}

void dfs0(int v){
    vis[v] = 1;
    for (int i = 0; i < 2 * MX; i++)
    if (e[v][i] && !vis[i])
        dfs0(i);
    top[sz++] = v;
}

void dfs1(int v, int num){
    vis[v] = 1;
    ind[v] = num;
    for (int i = 0; i < 2 * MX; i++)
    if (e[i][v] && !vis[i])
        dfs1(i, num);
}

bool canfind(int v, int fnd){
    vis[v] = 1;
    if (v == fnd)
        return 1;
    for (int i = 0; i < 2 * MX; i++)
    if (e[v][i] && !vis[i] && canfind(i, fnd))
        return 1;
    return 0;
}

void gos(int v){
    vis[v] = 1;
    sure[v] = 1;
    for (int i = 0; i < 2 * MX; i++)
    if (e[v][i] && !vis[i])
        gos(i);
}

void gods(int v){
    vis[v] = 1;
    for (int i = 0; i < 2 * MX; i++)
    if (e[v][i] && !vis[i])
        gods(i);
}

int arr[2 * LG];

int prekek[maxw];

int obrs[maxw];

void sat(){
    sz = 0;
    clv();
    for (int i = 0; i < 2 * MX; i++)
    if (!vis[i])
        dfs0(i);
    reverse(top, top + sz);
    clv();
    int cnts = 0;
    for (int i = 0; i < sz; i++)
    if (!vis[top[i]])
        dfs1(top[i], cnts), cnts++;
    for (int i = 0; i < MX; i++)
    if (ind[i] == ind[i + MX])
        return;
    clv();
    for (int i = 0; i < 2 * MX; i++)
    if (sure[i] && !vis[i])
        gos(i);
    int alls = 0;
    for (int i = 0; i < MX; i++)
    if (taken[i])
        alls++;
    for (int i = 0; i < 2 * MX; i++){
        clv();
        gods(i);
        arr[i] = 0;
        for (int j = 0; j < 2 * MX; j++)
        if (vis[j])
            arr[i] += (1 << j);
    }
    int pepe = 0;
    for (int i = 0; i < MX; i++)
    if (sure[i])
        pepe += (1 << i);
    for (int mask = 0; mask < (1 << MX); mask++)
    if ((mask & pepe) == pepe){
        int dop = obrs[mask];
        bool is = 1;
        for (int i = 0; i < 2 * MX; i++)
        if ((1 << i) & dop)
            if ((arr[i] & dop) != arr[i]){
                is = 0;
                break;
            }
        if (is && answer.size() > prekek[mask] + alls){
            vector<int> ans;
            for (int i = 0; i < MX; i++){
                if (taken[i])
                    ans.push_back(1 << i);
                if (mask & (1 << i))
                    ans.push_back(-(1 << i));
            }
            swap(ans, answer);
        }
    }
}

int ob(int x){
    if (x < MX)
        return x + MX;
    return x - MX;
}

void edge(int v, int u){
    e[ob(v)][u] = 1;
    e[ob(u)][v] = 1;
}

void calc(){
    for (int i = 0; i < MX; i++)
        sure[i] = 0;
    for (int i = 0; i < 2 * MX; i++)
        for (int j = 0; j < 2 * MX; j++)
            e[i][j] = 0;
    int sum = 0;
    for (int i = 0; i < MX; i++)
    if (taken[i])
        sum += (1 << i);
    if (sum < plels)
        return;
    for (int its = 0; its < n; its++){
        int val = sum - a[its];
        for (int i = MX; i >= 0; i--)
        if ((1 << i) & val){
            if ((1 << i) & sum)
                continue;
            bool can = 0;
            for (int j = i - 1; j >= 0; j--){
                if ((1 << j) & sum){
                    if (((1 << j) & val) == 0){
                        can = 1;
                        if (i == MX){
                            for (int k = j; k < i; k++)
                                sure[k] = 1;
                        }
                        else{
                            for (int k = j; k < i; k++)
                                edge(i, k);
                            can = 1;
                        }
                        break;
                    }
                }
                else
                if ((1 << j) & val)
                    break;
            }
            if (!can)
                sure[i] = 1;
        }
    }
    sat();
}

void go(int it){
    if (it == MX){
        calc();
        return;
    }
    taken[it] = 0;
    go(it + 1);
    taken[it] = 1;
    go(it + 1);
}

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    //freopen("a.in", "w", stdout);
    #endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*n = 3000;
    cout << n << '\n';
    for (int i = 0; i < n; i++){
        int v = rnd() % (n + 1);
        if (rnd() & 1)
            v *= -1;
        cout << v << ' ';
    }
    return 0;*/
    for (int i = 0; i < maxw; i++)
        prekek[i] = __builtin_popcount(i);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i], lels = max(lels, abs(a[i])), plels = max(plels, a[i]);
    while ((1 << MX) <= lels)
        MX++;
    MX++;
    for (int mask = 0; mask < (1 << MX); mask++){
        obrs[mask] = mask;
        for (int i = 0; i < MX; i++)
        if (((1 << i) & mask) == 0)
            obrs[mask] += (1 << (i + MX));
    }
    for (int i = 0; i < MX; i++)
        answer.push_back((1 << i)), answer.push_back(-(1 << i));
    go(0);
    cout << answer.size() << '\n';
    for (auto i : answer)
        cout << i << ' ';
}
