#include <bits/stdc++.h>
//B
using namespace std;

typedef long long ll;
typedef long double ld;

vector<int> u;
vector<vector<int> > g;
vector<int> used;
map<pair<int, int>, int> usedp;

void dfs(int v, int uu, vector<int> &cur)
{
	used[v] = uu;
	cur.push_back(v);
	for (auto to : g[v])
	{
		if (used[to] != uu)
			dfs(to, uu, cur);
		
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("in.txt", "r", stdin);
	int n, m, h;
	cin >> n >> m >> h;
	u.resize(n);
	g.resize(n);
	for (int i = 0; i < n; i++)
		cin >> u[i];
	
	for (int j = 0; j < m; j++)
	{
		int a, b;
		cin >> a >> b;
		a--, b--;
		if (usedp[{a, b}] || usedp[{b, a}])
			continue;
		usedp[{a, b}] = 1;
		if ((u[a] + 1) % h == u[b])
			g[a].push_back(b);
		if ((u[b] + 1) % h == u[a])
		{
			g[b].push_back(a);
		}
	}
	used.resize(n, 0);
	vector<int> ans, cur;
	int uu = 0;
	for (int i = 0; i < n; i++)
	{
		cur.clear();
		uu++;
		dfs(i, uu, cur);
		
		if (ans.empty() || cur.size() < ans.size())
			ans = cur;
	}
	cout << ans.size() << "\n";
	for (auto x : ans)
		cout << x + 1 << " ";
	return 0;
	
}


