#include <bits/stdc++.h>
//B
using namespace std;

typedef long long ll;
typedef long double ld;

vector<int> u;
vector<vector<int> > g, revg;
map<pair<int, int>, int> usedp;
vector<int> comp;
vector<int> szcomp;
int sz = 0;
vector<int> out;
vector<int> in;

void dfs(int v, vector<int> &used, vector<int> &order, int uu)
{
	if (in[v] == 0)
	{
		order.push_back(v);
		used[v] = uu;
	}
	for (auto to : g[v])
	{
		if (used[to] != uu)
		{
			in[to]--;
			dfs(to, used, order, uu);
		}
	}
}

void dfs2(int v, vector<int> &used, int uu)
{
	comp[v] = sz;
	used[v] = uu;
	szcomp[sz]++;
	for (auto to: revg[v])
	{
		if (used[to] != uu)
			dfs2(to, used, uu);
	}	
}




int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("in.txt", "r", stdin);
	int n, m, h;
	cin >> n >> m >> h;
	u.resize(n);
	g.resize(n);
	revg.resize(n);
	in.resize(n, 0);
	for (int i = 0; i < n; i++)
		cin >> u[i];
	
	for (int j = 0; j < m; j++)
	{
		int a, b;
		cin >> a >> b;
		a--, b--;
		if (usedp[{a, b}] || usedp[{b, a}])
			continue;
		usedp[{a, b}] = 1;
		if ((u[a] + 1) % h == u[b])
		{
			g[a].push_back(b);
			revg[b].push_back(a);
			in[b]++;
		}
		if ((u[b] + 1) % h == u[a])
		{
			g[b].push_back(a);
			revg[a].push_back(b);
			in[a]++;
		}
	}
	
	vector<int> order;
	vector<int> used(n, 0);
	int uu = 1;
	for (int i = 0; i < n; i++)
	{
		if (in[i] == 0)
			dfs(i, used, order, uu);
	}
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			if (in[i] > 0)
				in[i]--;
			dfs(i, used, order, uu);
		}
	}
	uu++;
	comp.resize(n, -1);
	/*cout << "order:\n";
	for (int i = 0; i < n; i++)
		cout << order[i] << " ";
	cout << endl;*/
	
	
	for (int i = 0; i < n; i++)
	{
		int v = order[i];
		if (used[v] != uu)
		{
			//cout << "v = " << v << endl;
			szcomp.push_back(0);
			dfs2(v, used, uu);
			sz++;
		}
	}
	out.resize(sz, 0);
	for (int i = 0; i < n; i++)
	{
		for (auto to : g[i])
		{
			if (comp[to] != comp[i])
				out[comp[i]] = 1;
		}
	}
	/*for (int i = 0; i < n; i++)
		cout << " i = " << i << " comp = " << comp[i] << endl;*/
	int ans = 2 * n;
	int cid = -1;
	for (int i = 0; i < sz; i++)
	{
		if (out[i] == 0 && szcomp[i] < ans)
		{
			ans = szcomp[i];
			cid = i;
		}
	}
	cout << ans << "\n";
	for (int i = 0; i < n; i++)
		if (comp[i] == cid)
			cout << i + 1 << " ";
	return 0;
	
}

