#include <bits/stdc++.h>
//B
using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int> > g, revg;
map<pair<int, int>, int> usedp;
vector<int> comp;
vector<int>compsz;
vector<int> u;
int id = 0;


void dfs2 (int v, vector<int> &ok, vector<int> &used)
{	
	used[v] = 1;
	comp[v] = id;
	compsz[id]++;
	for (auto to : revg[v])
	{
		if (ok[to] && !used[to])
		{
			dfs2(to, ok, used);
		}
	}
}


bool dfs(int v, vector<int> & clr, vector<int> &vec)
{
	clr[v] = 1;
	vec.push_back(v);
	for (auto to : g[v])
	{
		if (clr[to] == 0)
		{
			if (!dfs(to, clr, vec))
				return false;
		}
		else if (clr[to] == 2)
			return false;
	}
	clr[v] = 2;
	return true;
}



int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("in.txt", "r", stdin);
	int n, m, h;
	cin >> n >> m >> h;
	u.resize(n);
	g.resize(n);
	revg.resize(n);
	for (int i = 0; i < n; i++)
		cin >> u[i];
	
	for (int j = 0; j < m; j++)
	{
		int a, b;
		cin >> a >> b;
		a--, b--;
		if (usedp[{a, b}] || usedp[{b, a}])
			continue;
		usedp[{a, b}] = 1;
		if ((u[a] + 1) % h == u[b])
		{
			g[a].push_back(b);
			revg[b].push_back(a);
		}
		if ((u[b] + 1) % h == u[a])
		{
			g[b].push_back(a);
			revg[a].push_back(b);
		}
	}
	vector<int> used(n, 0);
	vector<vector<int>> order;
	vector<int> clr(n, 0);
	vector<int> ok(n, 0);
	comp.resize(n, -1);
	id = 0;
	for (int i = 0; i < n; i++)
	{
		if (clr[i] == 0)
		{
			vector<int> vec;	
			if (dfs(i, clr, vec))
			{
				for (auto v : vec)
					ok[v] = 1;
				order.push_back(vec);
			}
		}
	}
	
	for (auto vec : order)
	{
		for (auto v : vec)
		{
			if (!used[v])
			{
				//cerr << "v = " << v << endl;
				compsz.push_back(0);
				
				dfs2(v, ok, used);
				//cerr << "dfs ok\n";
				id++;
			}
		}
	}
	//cerr << "dfsd\n";
	vector<set<int> > out(id);
	for (int v = 0; v < n; v++)
	{
		if (ok[v])
		{
			for (auto to : g[v])
			{
				if (ok[to] && comp[v] != comp[to])
					out[v].insert(comp[to]);
			}
		}
	}
	int ans = 2 * n;
	int idc = -1;
	for (int i = 0; i < id; i++)
	{
		if (out[i].size() == 0)
		{
			if (compsz[i] < ans)
			{
				ans = compsz[i];
				idc = i;
			}
		}
	}
	cout << ans << "\n";
	for (int i = 0; i < n; i++)
		if (comp[i] == idc)
			cout << i + 1 << " ";
	return 0;
	
}

