#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

int main() {

    string s;
    cin >> s;
    vector<vector<pair<int, int>>> pos(2);
    for (int i = 0; i < s.size(); i++) {
        if ((s[i] - '0') == 0) {
            pos[0].push_back({i + 1, i + 1});
            int tempj = pos[1].size() - 1;
            while (0 <= tempj && pos[1][tempj].second == -1) {
                pos[1][tempj].second = pos[0].size() - 1;
                tempj--;
            }
        } else {
            pos[1].push_back({i + 1, -1});
        }
    }
    vector<bool> used(pos[0].size(), false);
    vector<vector<int>> ans;
    int j = 0, check = 0;
    for (int i = 0; i < pos[0].size(); i++) {
        if (!used[i]) {
            ans.push_back({pos[0][i].first});
            used[i] = 1;
            check++;
            while (j < pos[1].size()) {
                ans[ans.size() - 1].push_back(pos[1][j].first);
                int tempi = pos[1][j].second;
                if (tempi == -1) {
                    cout << -1;
                    return 0;
                }
                while (tempi < used.size() && used[tempi]) {
                    tempi++;
                }
                if (tempi == used.size()) {
                    cout << -1;
                    return 0;
                }
                ans[ans.size() - 1].push_back(pos[0][tempi].first);
                used[tempi] = 1;
                j++, check += 2;
            }
        }
    }
    if (check == s.size()) {
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i].size() << " ";
            for (j = 0; j < ans[i].size(); j++) {
                cout << ans[i][j] << " ";
            }
            cout << "\n";
        }
    } else {
        cout << -1;
    }
    return 0;
}