#include <bits/stdc++.h>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;
const int INF = 1e9;
const int mx = 3e5;
int p, n, d, b, a[mx], pl[mx], pr[mx], l[mx], r[mx], sum = 0, ans;

int solve_l(int cnt) {
	//cout << "solving_l for " << cnt << endl;
	for (int i = 0; i < n; ++i) {
		l[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] >= cnt) {
			l[pl[i]] += cnt;
			break;
		}
		else {
			l[pl[i]] += a[i];
			cnt -= a[i];
		}
	}
	int res = 0;
	for (int i = 0; i < (n + 1) / 2; ++i) {
		if (l[i] < b) {
			l[i + 1] += l[i];
			res++;
		}
		else {
			l[i + 1] += (l[i] - b);
		}
	}
	//cout << "returning " << res << endl;
	return res;
}

int solve_r(int cnt) {
	//cout << "solving_r for " << cnt << endl;
	for (int i = 0; i < n; ++i) {
		r[i] = 0;
	}
	for (int i = n - 1; i >= 0; --i) {
		if (a[i] >= cnt) {
			r[pr[i]] += cnt;
			break;
		}
		else {
			r[pr[i]] += a[i];
			cnt -= a[i];
		}
	}
	int res = 0;
	for (int i = n - 1; i >= (n + 1) / 2; --i) {
		if (r[i] < b) {
			r[i - 1] += r[i];
			res++;
		}
		else {
			r[i - 1] += (r[i] - b);
		}
	}
	//cout << "returning " << res << endl;
	return res;
}

void binsearch() {
	int l = 0, r = sum;
	while (l != r) {
		int mid = (l + r) / 2;
		int r1 = solve_l(mid);
		int r2 = solve_r(sum - mid);
		ans = min(ans, max(r1, r2));
		if (r1 < r2)
			l = mid + 1;
		else
			r = mid;
	}
	int r1 = solve_l(l);
	int r2 = solve_r(r);
	ans = min(ans, max(r1, r2));
}

int main() {
	cin >> p >> n >> d >> b;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	//!  p = 1
	for (int i = 0; i < n; ++i) {
		pl[i] = i / (d + 1);
	}
	for (int i = 0; i < n; ++i) {
		int j = n - 1 - i;
		int f = j / (d + 1);
		pr[i] = n - 1 - f;
	}
	ans = INF;
	for (int i = 0; i < n; ++i) {
		sum += a[i];
	}
	if (p == 1) {
		ans = solve_l(sum);
		cout << ans << endl;
	}
	else {
		binsearch();
		cout << ans << endl;
	}
}