import java.io.*;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }

    ArrayList<ArrayList<Integer>> q;
    boolean[] used;
    ArrayList<Integer> res;
    ArrayList<Integer> res2;
    ArrayList<Integer> a1;
    ArrayList<Integer> a2;
    Queue<Integer> e;
    ArrayList<ArrayList<Integer>> c;
    int[] c1;

    void dfs1(int v) {
        if (!used[v]) {
            used[v] = true;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs1(q.get(v).get(i));
            }
            e.add(v);
        }
    }

    void dfs0(int v) {
        if (!used[v]) {
            used[v] = true;
            c.get(c.size() - 1).add(v);
            c1[v] = c.size() - 1;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs0(q.get(v).get(i));
            }
        }
    }

    void dfs(int v) {
        if (!used[v]) {
            used[v] = true;
            if (v % 2 == 0) {
                a1.add(v);
            } else {
                a2.add(v);
            }
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs(q.get(v).get(i));
            }
            int u = v + 1 - (v % 2);
            if (!used[u]) {
                int h = c1[u];
                for (int i = 0; i < c.get(h).size(); i++) {
                    int u1 = c.get(h).get(i);
                    used[u1] = true;
                    if (u1 % 2 == 0) {
                        a2.add(u1);
                    }else {
                        a1.add(u1);
                    }
                }
            }
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int h = nextInt();
        q = new ArrayList<>();
        for (int i = 0; i < 2 * n; i++) {
            q.add(new ArrayList<>());
        }
        res = new ArrayList<>();
        int[] d = new int[n];
        for (int i = 0; i < n; i++) {
            d[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            int a = nextInt() - 1;
            int b = nextInt() - 1;
            if (d[a] == d[b]) {
                q.get(2 * a).add(2 * b + 1);
                q.get(2 * b).add(2 * a + 1);
                q.get(2 * a + 1).add(2 * b);
                q.get(2 * b + 1).add(2 * a);
            }
            if (d[b] == (d[a] + 1) % h) {
                int c = a;
                a = b;
                b = c;
            }
            if (d[a] == (d[b] + 1) % h) {
                q.get(2 * a).add(2 * b);
                q.get(2 * b + 1).add(2 * a + 1);
            }
        }
        e = new LinkedList<>();
        used = new boolean[2 * n];
        for (int i = 0; i < 2 * n; i++) {
            if (!used[i]) {
                dfs1(i);
            }
        }
        used = new boolean[2 * n];
        Queue<Integer> e1 = e;
        c = new ArrayList<>();
        c1 = new int[2 * n];
        while (e1.size() > 0) {
            int v = e.poll();
            if (!used[v]) {
                c.add(new ArrayList<>());
                dfs0(v);
            }
        }
        used = new boolean[2 * n];
        res2 = new ArrayList<>();
        int y = n + 2;
        res = new ArrayList<>();
        for (int i = 0; i < c.size(); i++) {
            if (!used[c.get(i).get(0)]) {
                a1 = new ArrayList<>();
                a2 = new ArrayList<>();
                dfs(c.get(i).get(0));
                if (a1.size() != 0 && a1.size() < y) {
                    y = a1.size();
                    res2 = a1;
                }
                if (a2.size() != 0 && a2.size() < y) {
                    y = a2.size();
                    res2 = a2;
                }
                if (a1.size() < a2.size()) {
                    for (int j = 0; j < a1.size(); j++) {
                        res.add(a1.get(j));
                    }
                } else {
                    for (int j = 0; j < a2.size(); j++) {
                        res.add(a2.get(j));
                    }
                }
            }
        }
        if (res.size() != 0) {
            out.println(res.size());
            for (int i = 0; i < res.size(); i++) {
                out.print((res.get(i) / 2 + 1) + " ");
            }
        } else {
            out.println(n);
            for (int i = 0; i < n; i++) {
                out.print((i + 1) + " ");
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
