import java.io.*;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;
    public void solve() throws IOException {
        nextInt();
        int n = nextInt();
        int d = nextInt();
        int b = nextInt();
        int max = 0;
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int x = 0;
        int t = 0;
        for (int i = 0; i < n; i++) {
            int t1 = t;
            for (; t < Math.min(n,t1 + d + 1); t++) {
                x += a[t];
            }
            max = Math.min(max + 1,x / b);
        }
        out.print(n - max);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
