import java.io.*;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }

    ArrayList<ArrayList<Integer>> q;
    boolean[] used;
    ArrayList<Integer> res;
    ArrayList<Integer> res2;
    ArrayList<Integer> a1;
    ArrayList<Integer> a2;
    Queue<Integer> e;
    ArrayList<ArrayList<Integer>> c;
    int[] c1;

    void dfs1(int v) {
        if (!used[v]) {
            used[v] = true;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs1(q.get(v).get(i));
            }
            e.add(v);
        }
    }

    void dfs0(int v) {
        if (!used[v]) {
            used[v] = true;
            c.get(c.size() - 1).add(v);
            c1[v] = c.size() - 1;
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs0(q.get(v).get(i));
            }
        }
    }

    void dfs(int v) {
        if (!used[v]) {
            used[v] = true;
            if (v % 2 == 0) {
                a1.add(v);
            } else {
                a2.add(v);
            }
            for (int i = 0; i < q.get(v).size(); i++) {
                dfs(q.get(v).get(i));
            }
            int u = v + 1 - (v % 2);
            if (!used[u]) {
                int h = c1[u];
                for (int i = 0; i < c.get(h).size(); i++) {
                    int u1 = c.get(h).get(i);
                    used[u1] = true;
                    if (u1 % 2 == 0) {
                        a2.add(u1);
                    }else {
                        a1.add(u1);
                    }
                }
            }
        }
    }

    public void solve() throws IOException {
       int n = nextInt();
       int z1 = 0;
       boolean[] a = new boolean[63];
        for (int i = 0; i < n; i++) {
            int b = nextInt();
            if (b == 0)continue;
            if (!a[b + 30])z1++;
            a[b + 30] = true;
        }
        ArrayList<Integer> res = new ArrayList<>();
        int y = Integer.MAX_VALUE;
        for (int i = 0; i < 1 << 14; i++) {
            ArrayList<Integer> b = new ArrayList<>();
            for (int j = 0; j < 12; j++) {
                if (j < 7){
                    if ((i >> j) % 2 == 1){
                        b.add(-1 * (1 >> j));
                    }
                }else {
                    if ((i >> j) % 2 == 1){
                        b.add((1 >> (j - 7)));
                    }
                }
            }
            int z = 0;
            boolean[] v = new boolean[61];
            v[30] = true;
            for (int j = 0; j < b.size(); j++) {
                int g = b.get(j);
                for (int k = 0; k < 61; k++) {
                    if (v[k] && k + g >= 0 && k + g <= 60){
                        if (a[k + g]){
                            z++;
                        }
                        v[k + g] = true;
                    }
                }
            }
            if (z == z1){
                if (b.size() < y){
                    y = b.size();
                    res = b;
                }
            }
        }
        out.println(res.size());
        for (int i = 0; i < res.size(); i++) {
            out.print(res.get(i) + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
