import java.io.*;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }
    ArrayList<ArrayList<Integer>> q;
    boolean[] used;
    public void solve() throws IOException {
        String s = nextToken();
        int n = s.length();
        int z = -1;
        q = new ArrayList<>();
        if (s.charAt(0) == '1'){
            out.print(-1);
            return;
        }
        q.add(new ArrayList<>());
        q.get(0).add(0);
        z = -1;
        for (int i = 1; i < n; i++) {
            if (s.charAt(i) == '0'){
                if (z == -1){
                    q.add(new ArrayList<>());
                    q.get(q.size() - 1).add(i);
                }else {
                    q.get(z).add(i);
                    z--;
                }
            }else {
                if (z == q.size() - 1){
                    out.print(-1);
                    return;
                }
                z++;
                q.get(z).add(i);
            }
        }
        out.println(q.size());
        for (int i = 0; i < q.size(); i++) {
            out.print(q.get(i).size() + " ");
            for (int j = 0; j < q.get(i).size(); j++) {
                out.print((q.get(i).get(j) + 1) + " ");
            }
            out.println();
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
