#include <bits/stdc++.h>

using namespace std;

const long long maxn = 1e5 + 7;

long long a[maxn];
long long t[4 * maxn];

void build(long long v, long long tl, long long tr){
    if (tl ==  tr){
        t[v] = a[tl];
        return;
    }

    long long tm = (tl + tr) / 2;

    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm + 1, tr);

    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

long long get(long long v, long long tl, long long tr, long long l, long long r){
    if (l > r)
        return 0;
    if (tl == l && tr == r)
        return t[v];

    long long tm = (tl + tr) / 2;

    return get(v * 2 + 1, tl, tm, l, min(tm, r)) + get(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
}

int main()
{
    long long p, n, d, b;
    cin >> p >> n >> d >> b;
    for (long long i = 0; i < n; ++i)
        cin >> a[i];

    if (p == 1){
        long long ans = 0;
        long long ost = 0;
        long long le = 0;
        build(0, 0, n - 1);
        for (long long i = 0; i < n; ++i){
            ost += get(0, 0, n - 1, le, min(n - 1, i + (i + 1) * d));
            le = min(n - 1, i + (i + 1) * d) + 1;

            if (ost >= b){
                ost -= b;
            }
            else{
                ++ans;
            }
        }

        cout << ans << '\n';
        return 0;
    }
    return 0;
}
