#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>

using namespace std;

typedef long long LL;

vector<int> ps;

pair<bool, vector<int>> run(vector<int> a, int p = 0) {
  if (p >= ps.size()) return { false, vector<int>() };

  if (a.size() == 1 && a[0] == 0)
    return { true, vector<int>() };

  bool f = 0;
  for (int i = 0; i < a.size(); ++i) {
    if (a[i] % 2 != 0) {
      f = 1;
      break;
    }
  }

  if (!f) {
    for (int i = 0; i < a.size(); ++i) {
      a[i] /= 2;
    }
    a.resize(unique(a.begin(), a.end()) - a.begin());
    return run(a, p + 1);
  }
  
  pair<bool, vector<int>> ans;
  ans.first = false;

  { // +1 * 2^p
    vector<int> tmp = a;
    for (int i = 0; i < tmp.size(); ++i) {
      if (tmp[i] % 2)
        tmp[i] -= 1;
      tmp[i] /= 2;
    }
    tmp.resize(unique(tmp.begin(), tmp.end()) - tmp.begin());

    auto got = run(tmp, p + 1);
    if (got.first) {
      got.second.push_back(ps[p]);
      
      if (ans.first == false)
        ans = got;
      else if (ans.second.size() > got.second.size())
        ans = got;
    }
  }

  { // -1 * 2^p
    vector<int> tmp = a;
    for (int i = 0; i < tmp.size(); ++i) {
      if (tmp[i] % 2)
        tmp[i] += 1;
      tmp[i] /= 2;
    }
    tmp.resize(unique(tmp.begin(), tmp.end()) - tmp.begin());

    auto got = run(tmp, p + 1);
    if (got.first) {
      got.second.push_back(-ps[p]);

      if (ans.first == false)
        ans = got;
      else if (ans.second.size() > got.second.size())
        ans = got;
    }
  }

  return ans;
}

int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  
  cin.tie(0);
  cin.sync_with_stdio(0);

  ps.push_back(1);
  for (int i = 1; i <= 20; ++i) {
    ps.push_back(ps.back() * 2);
  }

  int n;
  cin >> n;

  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  sort(a.begin(), a.end());
  a.resize(unique(a.begin(), a.end()) - a.begin());

  pair<bool, vector<int>> ans = run(a);
  assert(ans.first);

  cout << ans.second.size() << '\n';
  for (auto x : ans.second)
    cout << x << ' ';

  return 0;
}