#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>
using namespace std;

int n, m , h, t[112345] ;
bool b[112345] ;

vector <int> a[112345] ;

void dfs ( int v )
{
    b[v] = true ;

    for ( int i=0; i<a[v].size(); i++ )
        if ( ! b[ a[v][i] ]  )
            dfs ( a[v][i] ) ;

    return ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i, x, y, j ;

    cin >> n >> m >> h ;

    for ( i=1; i<=n; i++ )
        cin >> t[i] ;

    for ( i=0; i<m; i++ )
    {
        cin >> x >> y ;

        if ( ( t[x] + 1 ) % h == t[y] )
            a[ x ].push_back ( y ) ;

        if ( ( t[y] + 1 ) % h == t[x] )
            a[ y ].push_back ( x ) ;
    }

    int ans = 1e9, k = -1 ;

    for ( i=1; i<=n; i++ )
    {
        for ( j=1; j<=n; j++ )
            b[j] = false ;

        dfs ( i ) ;

        int cnt = 0 ;
        for ( j=1; j<=n; j++ )
            cnt += b[j] ;

        if ( cnt < ans )
        {
            ans = cnt ;
            k = i ;
        }
    }

    cout << ans << endl ;
    for ( j=1; j<=n; j++ )
        b[j] = false ;

    dfs ( k ) ;

    for ( j=1; j<=n; j++ )
        if ( b[j] )
            cout << j << " " ;


    return 0;
}
