#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>
using namespace std;

int n, m , h, t[112345], color[112345], cc ;
bool b[112345] ;

vector <int> q, a[112345], kek[112345] ;

void dfs ( int v )
{
    b[v] = true ;

    for ( int i=0; i<a[v].size(); i++ )
        if ( ! b[ a[v][i] ]  )
            dfs ( a[v][i] ) ;

    q.push_back( v ) ;
    return ;
}

void dfs2 ( int v )
{
    color[v] = cc ;
    kek[ cc ].push_back ( v ) ;

    for ( int i=0; i<a[v].size(); i++ )
        if ( color[ a[v][i] ]  ==  -1 )
            dfs2 ( a[v][i] ) ;

    return ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i, x, y, j ;

    cin >> n >> m >> h ;

    for ( i=1; i<=n; i++ )
    {
        cin >> t[i] ;
        color[i] = -1 ;
        b[i] = false ;
    }

    for ( i=0; i<m; i++ )
    {
        cin >> x >> y ;

        if ( ( t[x] + 1 ) % h == t[y] )
            a[ x ].push_back ( y ) ;

        if ( ( t[y] + 1 ) % h == t[x] )
            a[ y ].push_back ( x ) ;
    }

    for ( i=1; i<=n; i++ )
        if ( !b[i] )
            dfs ( i ) ;

    cc = 1 ;
    for ( i=0; i<q.size(); i++ )
        if ( color[ q[i] ] == -1 )
        {
            dfs2 ( q[i] ) ;
            cc ++ ;
        }

    int ans = 1e9, k = -1 ;
    for ( i=1; i<cc; i++ )
        if ( ans > kek[i].size() )
        {
            ans = kek[i].size() ;
            k = i ;
        }

    cout << ans << endl ;
    for ( i=0; i<kek[k].size(); i++ )
        cout << kek[k][i] << " " ;

    return 0;
}
