#pragma GCC optimize("O3")

#ifdef _DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mk make_pair
#define all(v) (v).begin(), (v).end()
#define inb push_back
#define head dominateotkritka

int solve();

int main()
{
	solve();
	return 0;
}

const int BUFSZ = 2e5 + 7;

char buff[BUFSZ];

string get_str()
{
	scanf(" %s", buff);
	return string(buff);
}

const int MAXN = 1e5 + 7;

vector<int> g[MAXN], gt[MAXN], G[MAXN];
int sz[MAXN], was[MAXN], col[MAXN];

int solve()
{
	int n, m, h;
	scanf("%d %d %d", &n, &m, &h);
	vi t(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d", &t[i]);
	}
	vector<pii> ee;
	for (int i = 0; i < m; ++i)
	{
		int x, y;
		scanf("%d %d", &x, &y);
		--x, --y;
		for (int it = 0; it < 2; ++it)
		{
			if ((t[x] + 1) % h == t[y])
			{
				g[x].inb(y);
				g[y].inb(x);
				ee.inb(mk(x, y));
			}
			swap(x, y);
		}
	}
	sort(all(ee));
	ee.resize(unique(all(ee)) - ee.begin());
	vi order;
	function<void(int)> dfs1 = [&](int u)
	{
		col[u] = 1;
		for (int to : g[u])
		{
			if (!col[to])
				dfs1(to);
		}
		order.inb(u);
	};
	for (int i = 0; i < n; ++i)
	{
		if (!col[i])
			dfs1(i);
	}
	int cnt = 0;
	function<void(int)> dfs2 = [&](int u)
	{
		col[u] = cnt;
		sz[cnt]++;
		for (int to : gt[u])
		{
			if (col[to] == -1)
				dfs2(to);
		}
	};
	memset(col, -1, sizeof col);
	reverse(all(order));
	for (int u : order)
	{
		if (col[u] == -1)
		{
			dfs2(u);
			++cnt;
		}
	}
	vector<pii> ec;
	for (pii e : ee)
	{
		if (col[e.X] != col[e.Y])
		{
			ec.inb(mk(col[e.X], col[e.Y]));
		}
	}
	sort(all(ec));
	ec.resize(unique(all(ec)) - ec.begin());
	for (int i = 0; i < (int)ec.size(); ++i)
		G[ec[i].X].inb(ec[i].Y);
	function<void(int)> dfs3 = [&](int u)
	{
		was[u] = 1;
		for (int to : G[u])
		{
			dfs3(to);
			sz[u] += sz[to];
		}
	};
	for (int i = 0; i < cnt; ++i)
	{
		if (!was[i])
			dfs3(i);
	}//*/
	int colans = -1;
	for (int i = 0; i < cnt; ++i)
	{
		if (colans == -1 || sz[i] < sz[colans])
			colans = i;
	}
	vi ans;
	memset(was, 0, sizeof was);
	function<void(int)> dfs4 = [&](int u)
	{
		was[u] = 1;
		ans.inb(u + 1);
		for (int to : g[u])
		{
			if (!was[to])
				dfs4(to);
		}
	};
	for (int i = 0; i < n; ++i)
	{
		if (col[i] == colans)
		{
			dfs4(i);
			break;
		}
	}
	printf("%d\n", (int)ans.size());
	for (int x : ans)
		printf("%d ", x);
	puts("");
	return 0;
}