#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 1e5 + 239;
const int N = 2 * 1e3 + 239;

#define tm lkeklekekek

vector<vector<int> > v(M), u(M);
int n, m, h, tm[M];
set<pair<int, int> > be;
vector<pair<int, int> > rb;

void read()
{
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> tm[i];
    for (int i = 0; i < m; i++)
    {
        int s, f;
        cin >> s >> f;
        s--, f--;
        if (tm[s] == (tm[f] + 1) % h)
        {
            if (be.find(make_pair(f, s)) != be.end())
                continue;
            be.insert(make_pair(f, s));
            v[f].push_back(s);
            u[s].push_back(f);
            rb.push_back(make_pair(f, s));
        }
        if (tm[f] == (tm[s] + 1) % h)
        {
            if (be.find(make_pair(s, f)) != be.end())
                continue;
            be.insert(make_pair(s, f));
            v[s].push_back(f);
            u[f].push_back(s);
            rb.push_back(make_pair(s, f));
        }
    }
    m = rb.size();
}

int comp[M], r;
bool used[M];
vector<int> topsort;
vector<vector<int> > c(M);

void dfs(int p)
{
    used[p] = 1;
    for (int i : v[p])
        if (!used[i])
            dfs(i);
    topsort.push_back(p);
}

void dfs_back(int p)
{
    used[p] = 1;
    comp[p] = r;
    c[r].push_back(p);
    for (int i : u[p])
        if (!used[i])
            dfs_back(i);
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    read();
    memset(used, 0, sizeof(used));
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);
    reverse(topsort.begin(), topsort.end());
    //for (int i : topsort)
    //    cerr << i << " ";
    //cerr << "\n";
    memset(used, 0, sizeof(used));
    r = 0;
    for (int i = 0; i < n; i++)
        if (!used[topsort[i]])
        {
            dfs_back(topsort[i]);
            r++;
        }
    memset(used, 0, sizeof(used));
    for (pair<int, int> t : rb)
        if (comp[t.first] != comp[t.second])
            used[comp[t.first]] = 1;
    pair<int, int> ans = make_pair(BIG, BIG);
    for (int i = 0; i < r; i++)
        if (!used[i])
            ans = min(ans, make_pair((int)c[i].size(), i));
    cout << ans.first << "\n";
    for (int t : c[ans.second])
        cout << t + 1 << " ";
    return 0;
}
