#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 2 * 1e5 + 239;
const int N = 2 * 1e3 + 239;

int p, n, d, b;
vector<int> a;

int solve(int n, int d, int b, vector<int> a, int wr)
{
    vector<int> pr(n, 0);
    pr[0] = a[0];
    for (int i = 1; i < n; i++)
        pr[i] = a[i] + pr[i - 1];
    int ans = 0;
    for (int i = 0; i < wr; i++)
    {
        int c = min(1LL * (ll)(i + 1) * (ll)d + (ll)i, (ll)(n - 1));
        int s = pr[c] - (i - ans) * b;
        if (s < b)
            ans++;
    }
    return ans;
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> p >> n >> d >> b;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (p == 1)
    {
        cout << solve(n, d, b, a, n);
        return 0;
    }
    int l1 = (n + 1) / 2;
    int l2 = n / 2;
    int s = 0;
    vector<int> x1(n, 0);
    vector<int> x2(n, 0);
    for (int i = 0; i < n; i++)
    {
        s += a[i];
        if (s >= l1 * b)
        {
            x1[i] = l1 * b + a[i] - s;
            x2[i] = s - l1 * b;
            for (int j = i + 1; j < n; j++)
                x2[j] = a[j];
            break;
        }
        x1[i] = a[i];
        x2[i] = 0;
    }
    reverse(x2.begin(), x2.end());
    cout << max(solve(n, d, b, x1, l1), solve(n, d, b, x2, l2));
    return 0;
}
