#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int T = (1 << 19);
const int M = 3010;
const int N = (1 << 14) + 3010;

int n, a[M], k;
int sz[T];
bitset<N> our, now;
int ans, m1, m2;
bool cool[T];

inline bool check(int ms1, int ms2)
{
    now = 0;
    for (int l1 = ms1; l1 > 0; l1 = ((l1 - 1) & ms1))
        for (int l2 = ms2; l2 > 0; l2 = ((l2 - 1) & ms2))
            now[l1 + (1 << k) - 1 - l2] = 1;
    for (int l1 = ms1; l1 > 0; l1 = ((l1 - 1) & ms1))
        now[l1 + (1 << k) - 1] = 1;
    for (int l2 = ms2; l2 > 0; l2 = ((l2 - 1) & ms2))
        now[(1 << k) - 1 - l2] = 1;
    now[(1 << k) - 1] = 1;
    return ((now & our) == our);
}

void dfs(int ms1, int mk2)
{
    if (!check(ms1, mk2))
    {
        for (int ms2 = mk2; ms2 >= 0; ms2 = ((ms2 == 0) ? -1 : ((ms2 - 1) & mk2)))
            cool[ms2] = true;
        return;
    }
    if (sz[ms1] + sz[mk2] < ans)
    {
        ans = sz[ms1] + sz[mk2];
        m1 = ms1, m2 = mk2;
    }
    cool[ms1] = true;
    for (int d = 0; d < k; d++)
        if ((mk2 >> d) & 1)
            if (!cool[mk2 ^ (1 << d)])
                dfs(ms1, mk2 ^ (1 << d));
}

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    sort(a, a + n);
    n = unique(a, a + n) - a;
    k = 0;
    while (1)
    {
        bool ch = 1;
        for (int i = 0; i < n; i++)
            if (2 * abs(a[i]) >= (1 << k))
                ch = false;
        if (ch) break;
        k++;
    }
    for (int i = 0; i < n; i++)
        our[(1 << k) - 1 + a[i]] = 1;
    for (int ms = 0; ms < (1 << k); ms++)
        sz[ms] = __builtin_popcount(ms);
    if (k >= 2)
    {
        ans = k;
        m1 = (1 << (k - 1)) - 1;
        m2 = (1 << (k - 1));
    }
    else
    {
        ans = 2 * k;
        m1 = (1 << k) - 1;
        m2 = (1 << k) - 1;
    }
    for (int ms1 = 0; ms1 < (1 << k); ms1++)
    {
        int mk = (1 << k) - 1 - ms1;
        for (int ms2 = mk; ms2 >= 0; ms2 = ((ms2 == 0) ? -1 : ((ms2 - 1) & mk)))
            cool[ms2] = false;
        dfs(ms1, mk);
    }
    cout << ans << "\n";
    for (int i = 0; i < k; i++)
        if ((m2 >> i) & 1)
            cout << -(1 << i) << " ";
    for (int i = 0; i < k; i++)
        if ((m1 >> i) & 1)
            cout << (1 << i) << " ";
    //cerr << TIME << "\n";
    return 0;
}
