#include <iostream>
#include <vector>
#include <set>
#include <cstdio>
#include <climits>
#include <cstdlib>
#include <cassert>
#include <algorithm>

using namespace std;
typedef unsigned int index;

size_t dfs(index v, const vector<vector<index>> &g, vector<bool> &used)
{
    if (used[v])
        return 0;
    used[v] = true;
    size_t ans = 1;
    for (auto i: g[v])
        ans += dfs(i, g, used);
    return ans;
}

int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    size_t n, m, h;
    cin >> n >> m >> h;
    vector<index> a(n);
    for (auto &i: a)
        cin >> i;
    vector<vector<index>> g(n);
    for (index i = 0; i < m; i++)
    {
        index l, r;
        cin >> l >> r;
        l--, r--;
        if ((a[l] + 1) % h == a[r])
            g[l].push_back(r);
        if ((a[r] + 1) % h == a[l])
            g[r].push_back(l);
    }
    size_t ans = ULONG_MAX;
    vector<index> ids;
    for (index i = 0; i < n; i++)
    {
        vector<bool> used(n);
        size_t sv = dfs(i, g, used);
        if (sv < ans)
        {
            ans = sv;
            ids = {};
            for (index j = 0; j < n; j++)
                if (used[j])
                    ids.push_back(j);
        }
    }
    cout << ans << endl;
    for (auto i: ids)
        cout << i + 1 << " ";
    cout << endl;
}
