#include <iostream>
#include <vector>
#include <set>
#include <cstdio>
#include <climits>
#include <cstdlib>
#include <cassert>
#include <algorithm>

using namespace std;
typedef unsigned int index;

size_t solve(size_t n, size_t d, int b, const vector<int> &a)
{
    vector<long long> pf(n + 1);
    for (index i = 0; i < n; i++)
        pf[i + 1] = pf[i] + a[i];
    size_t ans = 0;
    for (index i = 0; i < n; i++)
    {
        size_t r = min(i + (d * (i + 1)) + 1, n);
        if (pf[r] - ans * b >= b)
            ans += 1;
    }
    return ans;
}

int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    size_t p, n, d;
    int b;
    cin >> p >> n >> d >> b;
    assert(p == 1);
    vector<int> a(n);
    for (auto &i: a)
        cin >> i;
    cout << n - solve(n, d, b, a) << endl;
}
