#include <iostream>
#include <vector>
#include <set>
#include <cstdio>
#include <climits>
#include <cstdlib>
#include <cassert>
#include <algorithm>

using namespace std;
typedef unsigned int index;

int solve(size_t n, size_t d, int b, const vector<int> &a)
{
    vector<long long> pf(a.size() + 1);
    for (index i = 0; i < a.size(); i++)
    {
        pf[i + 1] = pf[i] + a[i];
    }
    size_t ans = 0;
    for (auto i = 0; i < n; i++)
    {
        size_t r = min(a.size(), i + (i + 1) * d + 1);
        if (pf[r] - ans * b >= b)
            ans++;
    }

    return n - ans;
}


int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    size_t p, n, d;
    int b;
    cin >> p >> n >> d >> b;
    vector<int> a(n);
    for (auto &i: a)
        cin >> i;
    if (p == 1)
    {
        cout << solve(n, d, b, a) << endl;
    }
    else
    {
        vector<int> sec(n);
        long long sum = (long long)n * b;
        long long need = (n / 2 + n % 2) * (long long)b;
        for (index i = 0; i < n; i++)
        {
            if (sum - a[n - 1 - i] > need)
            {
                sum -= a[n - 1 - 1];
                sec[i] = a[n - 1 - i];
                a[n - 1 - i] = 0;
            }
            else
            {
                sec[i] = (int)(sum - need);
                a[n - 1 - i] -= sec[i];
                break;
            }
        }

        cout << max(solve(n / 2 + n % 2, d, b, a), solve(n / 2, d, b, sec)) << endl;
    }
}
