#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

void run()
{
    int n, p, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    for (auto &x: a)
        cin >> x;
    ll s = 0;
    int c = 0, ans = 0;
    for (int i = 0; i < n; i++)
    {
        int nc = min(n, c + d + 1);
        while (c < nc)
        {
            s += a[c];
            debug2(c << ":" << a[c]);
            c++;
        }
        debug(s << " " << nc);
        if (s < b)
        {
            ans++;
        }
        else
        {
            s -= b;
        }
    }
    cout << ans;
}
/*
1 5 3 1
0 0 0 5 0

1 5 3 10
5 1 1 1 42
*/
