#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

void run()
{
    int n, p, d, b;
    cin >> p >> n >> d >> b;
    vector<int> a(n);
    for (auto &x: a)
        cin >> x;
    if (p == 1)
    {
        int c = 0;
        ll s = 0;
        int ans = 0;
        for (int i = 0; i < n; i++)
        {
            int nc = min(n, c + d + 1);
            while (c < nc)
            {
                s += a[c];
                c++;
            }
            if (s < b)
                ans++;
            else
                s -= b;
        }
        cout << ans;
    }
    else
    {
        int c1 = 0, c2 = n - 1;
        ll s1 = 0, s2 = 0, sc = 0;
        bool f = 1;
        int ans1 = 0, ans2 = 0;
        for (int i = 0, j = n - 1; i <= j; i++, j--)
        {
            int nc1 = min(j, c1 + d + 1);
            while (c1 < nc1)
            {
                s1 += a[c1];
                if (c1 > c2)
                {
                    s1 -= a[c1];
                    s2 -= a[c1];
                    sc += a[c1];
                }
                c1++;
            }
            int nc2 = max(i, c2 - d - 1);
            while (c2 > nc2)
            {
                s2 += a[c2];
                if (c1 > c2)
                {
                    s1 -= a[c2];
                    s2 -= a[c2];
                    sc += a[c2];
                }
                c2--;
            }
            bool f1 = 0, f2 = 0;
            if (s1 >= b)
                s1 -= b;
            else
                f1 = 1;
            if (s2 >= b)
                s2 -= b;
            else
                f2 = 1;
            if (ans1 >= ans2 && f1 && s1 + sc >= b)
            {
                sc += s1;
                s1 = 0;
                sc -= b;
            }
            else if (f1)
                ans1++;
            if (ans1 <= ans2 && f2 && s2 + sc >= b)
            {
                sc += s2;
                s2 = 0;
                sc -= b;
            }
            else if (f2)
                ans2++;
        }
        cout << max(ans1, ans2);
    }
}
/*

*/
