#include <bits/stdc++.h>
#define ll long long
#define F first
#define S second

using namespace std;

const int N=1e5+10;

ll a[N], o[N];
int tree[4*N];
bool d1[4*N];
int p, n, d, b, ans1, ans2;

void sol1(int i)
{

    ll sum=0;
    for (int j=max((ll)1, i-(ll)i*d); j<i; j++){
        sum+=o[j];
    }

    for (int j=i+1; j<=min((ll)n, i+(ll)i*d); j++){
        sum+=o[j];
    }

    if (sum+o[i]<b){
        ans1++; return;
    }

    for (int j=max((ll)1, i-(ll)i*d); j<i; j++){
        if (o[i]+o[j]<b){
            o[i]+=o[j];
            o[j]=0;
        }
        else {
            ll r=b-o[i];
            o[i]+=r;
            o[j]-=r; break;
        }
    }

    if (o[i]==b){
        o[i]=0; return;
    }

    for (int j=i+1; j<=min((ll)n, i+(ll)i*d); j++){
        if (o[i]+o[j]<b){
            o[i]+=o[j];
            o[j]=0;
        }
        else {
            ll r=b-o[i];
            o[i]+=r;
            o[j]-=r; break;
        }
    }

    o[i]=0;

}

void sol2(int i)
{

    ll sum=0;
    for (int j=n-i+2; j<=min((ll)n, n-i+1+(ll)i*d); j++){
        sum+=o[j];
    }

    for (int j=max((ll)1, n-i+1-(ll)i*d); j<n-i+1; j++){
        sum+=o[j];
    }

    if (sum+o[n-i+1]<b){
        ans2++; return;
    }

    for (int j=n-i+2; j<=min((ll)n, n-i+1+(ll)i*d); j++){
        if (o[n-i+1]+o[j]<b){
            o[n-i+1]+=o[j];
            o[j]=0;
        }
        else {
            ll r=b-o[n-i+1];
            o[n-i+1]+=r;
            o[j]-=r; break;
        }
    }

    if (o[n-i+1]==b){
        o[n-i+1]=0; return;
    }

    for (int j=max((ll)1, n-i+1-(ll)i*d); j<n-i+1; j++){
        if (o[n-i+1]+o[j]<b){
            o[n-i+1]+=o[j];
            o[j]=0;
        }
        else {
            ll r=b-o[n-i+1];
            o[n-i+1]+=r;
            o[j]-=r; break;
        }
    }

    o[n-i+1]=0;

}

void build(int i, int j, int num)
{

    if (i==j){
        tree[num]=a[i];
    }
    else {

        int mid=(i+j)/2;

        build(i, mid, num*2);
        build(mid+1, j, num*2+1);

        tree[num]=tree[num*2]+tree[num*2+1];

    }

}

void upd(int i, int j, int num, int l, int r)
{

    if (d1[num]){
        return;
    }

    if (i==l && j==r){
        d1[num]=1; tree[num]=0; return;
    }

    int mid=(i+j)/2;

    if (r<=mid){
        upd(i, mid, num*2, l, r);
    }
    else if (l>mid){
        upd(mid+1, j, num*2+1, l, r);
    }
    else {
        upd(i, mid, num*2, l, mid);
        upd(mid+1, j, num*2+1, mid+1, r);
    }

    tree[num]=tree[num*2]+tree[num*2+1];

}

int get(int i, int j, int num, int l, int r)
{

    if (d1[num]){
        return 0;
    }

    if (i==l && j==r){
        return tree[num];
    }

    int mid=(i+j)/2;

    if (r<=mid){
        return get(i, mid, num*2, l, r);
    }
    else if (l>mid){
        return get(mid+1, j, num*2+1, l, r);
    }
    else {
        return get(i, mid, num*2, l, mid)+get(mid+1, j, num*2+1, mid+1, r);
    }

}

int main()
{

    ios_base::sync_with_stdio(0);

    cin>>p>>n>>d>>b;

    for (int i=1; i<=n; i++){
        cin>>a[i];
    }

    if (p==1){

        build(1, n, 1);

        ll buf=0; int ans=0; set<int> nu; nu.clear();
        for (int i=1; i<=n; i++){

            if (!nu.empty()){
                a[i]=0;
            }

            if (a[i]+buf>=b){
                a[i]+=buf; buf=a[i]-b; a[i]=b;
            }
            else {

                ll sum=get(1, n, 1, i+1, min((ll)n, i+(ll)i*d));
                //cout<<sum<<"\n";

                if (a[i]+sum+buf>=b){

                    a[i]+=buf+sum;
                    buf=0;
                    upd(1, n, 1, i+1, min((ll)n, i+(ll)i*d));
                    nu.insert(min((ll)n, i+(ll)i*d));
                    buf=a[i]-b; a[i]=b;

                }
                else {
                    ans++;
                }

            }

            set<int>::iterator it;
            it=nu.find(i);

            if (it!=nu.end()){
                nu.erase(it);
            }

            //cout<<ans<<"\n";

        }

        cout<<ans<<"\n";

    }
    else if (b==1){

        for (int i=1; i<=(n/2)+(n&1); i++){

            if (ans1>ans2){

                int b1=max((ll)1, i-(ll)i*d), b2=min((ll)n, i+(ll)i*d);
                for (int j=b1; j<i; j++){
                    if (a[i]>=1){
                        break;
                    }
                    if (a[j]>1){
                        a[j]--; a[i]=1; break;
                    }
                }

                if (a[i]==0){

                    for (int j=i+1; j<=b2; j++){
                        if (a[j]>1){
                            a[j]--; a[i]=1; break;
                        }
                    }

                }

                if (a[i]==0){
                    ans1++;
                }

                b1=max((ll)1, n-i+1-(ll)i*d), b2=min((ll)n, n-i+1+(ll)i*d);
                for (int j=n-i+2; j<=b2; j++){
                    if (a[n-i+1]>=1){
                        break;
                    }
                    if (a[j]>1){
                        a[j]--; a[n-i+1]=1; break;
                    }
                }

                if (a[n-i+1]==0){

                    for (int j=n-i; j>=b2; j--){
                        if (a[j]>1){
                            a[j]--; a[n-i+1]=1; break;
                        }
                    }

                }

                if (a[n-i+1]==0){
                    ans2++;
                }

            }
            else {

                int b1=max((ll)1, n-i+1-(ll)i*d), b2=min((ll)n, n-i+1+(ll)i*d);
                for (int j=n-i+2; j<=b2; j++){
                    if (a[n-i+1]>=1){
                        break;
                    }
                    if (a[j]>1){
                        a[j]--; a[n-i+1]=1; break;
                    }
                }

                if (a[n-i+1]==0){

                    for (int j=n-i; j>=b2; j--){
                        if (a[j]>1){
                            a[j]--; a[n-i+1]=1; break;
                        }
                    }

                }

                if (a[n-i+1]==0){
                    ans2++;
                }

                b1=max((ll)1, i-(ll)i*d), b2=min((ll)n, i+(ll)i*d);
                for (int j=b1; j<i; j++){
                    if (a[i]>=1){
                        break;
                    }
                    if (a[j]>1){
                        a[j]--; a[i]=1; break;
                    }
                }

                if (a[i]==0){

                    for (int j=i+1; j<=b2; j++){
                        if (a[j]>1){
                            a[j]--; a[i]=1; break;
                        }
                    }

                }

                if (a[i]==0){
                    ans1++;
                }

            }

        }

        cout<<max(ans1, ans2)<<"\n";

    }
    else {

        for (int i=1; i<=n; i++){
            o[i]=a[i];
        }

        for (int i=1; i<=(n/2)+(n&1); i++){

            bool p1=0, p2=0;
            if (o[i]>=b){
                o[i]-=b; p1=1;
            }
            if (o[n-i+1]>=b){
                o[n-i+1]-=b; p2=1;
            }

            //cout<<p1<<" "<<p2<<"\n";

            if (p1 && p2){
                continue;
            }
            else if (!p1 && p2){
                sol1(i);
            }
            else if (p1 && !p2){
                sol2(i);
            }
            else if (n==(n/2)+(n&1)){
                sol1(i);
            }
            else if (ans1>ans2){
                sol1(i);
                sol2(i);
            }
            else {
                sol2(i);
                sol1(i);
            }

            /*for (int j=1; j<=n; j++){
                cout<<o[j]<<" ";
            }
            cout<<"\n";*/

            //cout<<ans1<<" "<<ans2<<"\n";

        }

        cout<<max(ans1, ans2)<<"\n";

    }

    return 0;
}
