#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

const int maxn = 2e5 + 88;
const int inf = 1e9 + 88;

long long n, p, b, d;
long long a[maxn], type[maxn];

void solve1()
{
    long long i, r = 0, ans = 0, j;
    long long cnt = 0;
    for (i = 0; i < n; i++)
    {
        for (j = r; j <= min(i + (i + 1)*d, n - 1); j++)
            r++, cnt += a[j];
        if (cnt >= b)
            cnt -= b;
        else
            ans++;
    }
    cout << ans;
}

bool check(int x)
{
    long long cnt1 = 0, cnt2 = 0, cnt3 = 0;
    int pref = 0, suff = n - 1, i, j;
    for (i = 0; i < n; i++)
        type[i] = 0;
    for (i = 0; i < x; i++)
    {
        for (j = pref; j <= min(i + (i + 1)*d, n - 1); j++)
        {
            if (type[j] == 2)
            {
                cnt3 += min(a[j], cnt2);
                cnt2 -= min(a[j], cnt2);
                type[j] = 3;
            }
            if (type[j] == 0)
            {
                cnt1 += a[j];
                type[j] = 1;
            }
            pref++;
        }
        for (j = suff; j >= max(n - 1 - i - (i + 1)*d, 0ll); j--)
        {
            suff--;
            if (type[j] == 1)
            {
                cnt3 += min(a[j], cnt1);
                cnt1 -= min(a[j], cnt1);
                type[j] = 3;
            }
            if (type[j] == 0)
            {
                cnt2 += a[j];
                type[j] = 2;
            }
        }
    }
    for (i = x; i < n/2; i++)
    {
        for (j = pref; j <= min(i + (i + 1)*d, n - 1); j++)
        {

            if (type[j] == 2)
            {
                cnt3 += min(a[j], cnt2);
                cnt2 -= min(a[j], cnt2);
                type[j] = 3;
            }
            if (type[j] == 0)
            {
                cnt1 += a[j];
                type[j] = 1;
            }
            pref++;
        }
        for (j = suff; j >= max(n - 1 - i - (i + 1)*d, 0ll); j--)
        {
            suff--;

            if (type[j] == 1)
            {
                cnt3 += min(a[j], cnt1);
                cnt1 -= min(a[j], cnt1);
                type[j] = 3;
            }
            if (type[j] == 0)
            {
                cnt2 += a[j];
                type[j] = 2;
            }
        }
        if (cnt1 + cnt3 < b)
            return false;
        cnt3 -= max(0ll, b - cnt1);
        cnt1 -= min(b, cnt1);
        if (cnt2 + cnt3 < b)
            return false;
        cnt3 -= max(0ll, b - cnt2);
        cnt2 -= min(b, cnt2);
    }
    if (n%2 == 1 && cnt1 + cnt2 + cnt3 < b)
        return false;
    return true;
}

void solve2()
{
    int l = 0, r = (n + 1)/2;
    while (l < r)
    {
        int mid = (l + r)/2;
        if (check(mid))
            r = mid;
        else
            l = mid + 1;
    }
    cout << l;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    long long i;
    cin >> p >> n >> d >> b;
    for (i = 0; i < n; i++)
        cin >> a[i];
    if (p == 1)
        solve1();
    else
        solve2();
    return 0;
}
