#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>

using namespace std;

const int maxn = 2e5 + 88;

vector<int> ans[maxn];
queue<int> q1;
queue<int> q0;
int timer = 0;
string s;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    long long n, m, i, j;
    cin >> s;
    n = s.length();
    int cnt = 0;
    if (s[0] == '1')
    {
        cout << "-1";
        return 0;
    }
    else
    {
        ans[timer++].push_back(0);
        q0.push(0);
    }
    for(i = 1; i < n; i++)
    {
        int cur;
        if (s[i] == '0')
        {
            if (!q1.empty())
            {
                cur = q1.front();
                q1.pop();
            }
            else
                cur = timer++;
            ans[cur].push_back(i);
            q0.push(cur);
        }
        else
        {
            if (q0.empty())
            {
                cout << "-1";
                return 0;
            }
            cur = q0.front();
            q0.pop();
            ans[cur].push_back(i);
            q1.push(cur);
        }
    }
    if (!q1.empty())
    {
        cout << "-1";
        return 0;
    }
    cout << timer << "\n";
    for (i = 0; i < timer; i++)
    {
        cout << ans[i].size() << " ";
        for (j = 0; j < ans[i].size(); j++)
            cout << ans[i][j] + 1 << " ";
        cout << "\n";
    }
    return 0;
}
