#include <iostream>
#include <unordered_set>
#include <vector>
#include <set>

int main() {
    int n, m, h;
    std::cin >> n >> m >> h;
    std::vector<int> t(n);
    for (int &x : t) {
        std::cin >> x;
    }
    std::vector<int> ans(n);
    std::vector< std::unordered_set<int> > ch(n);
    std::vector< std::set<int> > g(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        std::cin >> x >> y;
        --x;
        --y;
        ch[x].insert(t[y]);
        ch[y].insert(t[x]);
        g[x].insert(y);
        g[y].insert(x);
    }
    std::set<int> an;
    for (int i = 1; i <= n; ++i) {
        an.insert(i);
    }
    for (int i = 0; i < n; ++i) {
        int k = (t[i] + 1) % h;
        if (!ch[i].count(k)) {
            std::cout << 1 << "\n" << i + 1;
            return 0;
        }
    }
    std::cout << n << "\n";
    for (int i = 1; i <= n; ++i) {
        std::cout << i << " ";
    }
    return 0;
}
