//
// Created by olymp on 08.03.2018.
//
#include <iostream>
#include <stack>
#include <vector>

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string s;
    std::cin >> s;
    int n = (int) s.size(), cnt = 0;
    std::vector<int> color(s.size());
    std::stack<int> open, close;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (close.empty()) {
                open.push(cnt++);
                color[i] = open.top();
            } else {
                int t = close.top();
                close.pop();
                open.push(t);
                color[i] = t;
            }
        } else {
            if (open.empty()) {
                std::cout << -1;
                return 0;
            } else {
                int t = open.top();
                open.pop();
                close.push(t);
                color[i] = t;
            }
        }
    }
    if (!close.empty()) {
        std::cout << -1;
        return 0;
    }
    std::vector< std::vector<int> > ans((size_t) cnt);
    for (int i = 0; i < n; ++i) {
        ans[color[i]].push_back(i + 1);
    }
    std::cout << ans.size() << '\n';
    for(size_t i = 0; i < ans.size(); ++i) {
        std::cout << ans[i].size() << ' ';
        for (auto j : ans[i]) {
            std::cout << j << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}