#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

int main() {
    ifstream fin("input.txt");
    long long p, n, d, b, bad1, bad2, mid;
    fin >> p >> n >> d >> b;
    vector <long long> v(n);
    for (int i = 0; i < n; i++) {
        fin >> v[i];
    }
    vector <long long> pref_sum(n);
    pref_sum[0] = v[0];
    for (int i = 1; i < n; i++) {
        pref_sum[i] = pref_sum[i - 1] + v[i];
    }
    vector <long long> suf_sum(n);
    suf_sum[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suf_sum[i] = suf_sum[i + 1] + v[i];
    }
    bad1 = 0;
    bad2 = 0;
    if (p == 1) {
        for (int i = 0; i < n; i++) {
            if ((i + 1 - bad1) * b > pref_sum[min(n - 1, i + d * (i + 1))]) {
                bad1++;
            }
        }
        cout << bad1 << '\n';
        return 0;
    }
    mid = (n + 1) / 2;
    for (int i = 0; i < mid; i++) {
        if ((i + 1 - bad1) * b > pref_sum[min(n - 1, i + d * (i + 1))]) {
            bad1++;
        }
    }
    for (int i = n - 1; i >= mid; i--) {
        if ((n - i - bad2) * b > suf_sum[max((long long)(0), i - d *(n - i))]) {
            bad2++;
        }
    }
    //cout << bad1 << ' ' << bad2 << '\n';
    cout << max(bad1, bad2);
    return 0;
}
