#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <string>

using namespace std;

void kill(vector <int> &prev, vector <int> &next, int id) {
    if (prev[id] != -1) {
        next[prev[id]] = next[id];
    }
    if (next[id] != -1) {
        prev[next[id]] = prev[id];
    }
}

int main() {
    ifstream fin("input.txt");
    int n, now_len, num;
    string s1;
    fin >> s1;
    n = s1.size();
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = s1[i] - '0';
    }
    vector <vector <int> > answers;
    vector <int> prev(n);
    vector <int> next(n);
    for (int i = 0; i < n; i++) {
        prev[i] = i - 1;
        next[i] = i + 1;
    }
    next[n - 1] = -1;
    now_len = 0;
    //vector <int> used(n, false);
    for (int i = 0; i != -1; i = next[i]) {
        if (s[i] == 1) {
            cout << "-1\n";
            return 0;
        }
        num = 0;
        kill(prev, next, i);
        answers.push_back(vector <int> ());
        now_len++;
        answers[now_len - 1].push_back(i);
        for (int j = next[i]; j != -1; j = next[j]) {
            if (s[j] != num) {
                kill(prev, next, j);
                answers[now_len - 1].push_back(j);
                num ^= 1;
            }
        }
        if (num == 1) {
            cout << "-1\n";
            return 0;
        }
    }
    cout << now_len << '\n';
    for (int i = 0; i < now_len; i++) {
        cout << answers[i].size() << ' ';
        for (int j = 0; j < int(answers[i].size()); j++) {
            cout << answers[i][j] + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}
