#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

int main() {
    ifstream fin("input.txt");
    int n, now_len, num, next, now;
    string s1;
    fin >> s1;
    n = s1.size();
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = s1[i] - '0';
    }
    set <int> rest[2];
    for (int i = 0; i < n; i++) {
        rest[s[i]].insert(i);
    }
    vector <vector <int> > answers;
    now_len = 0;
    vector <int> used(n, false);
    for (int i = 0; i < n; i++) {
        if (rest[s[i]].find(i) != rest[s[i]].end()) {
            if (s[i] == 1) {
                cout << "-1\n";
                return 0;
            }
            next = 1;
            used[i] = true;
            rest[0].erase(i);
            answers.push_back(vector <int> ());
            now_len++;
            answers[now_len - 1].push_back(i);
            now = i;
            while (rest[next].upper_bound(now) != rest[next].end()) {
                now = *rest[next].upper_bound(now);
                answers[now_len - 1].push_back(now);
                rest[next].erase(now);
                next ^= 1;
            }
            if (next == 0) {
                cout << "-1\n";
                return 0;
            }
        }
    }
    cout << now_len << '\n';
    for (int i = 0; i < now_len; i++) {
        cout << answers[i].size() << ' ';
        for (int j = 0; j < int(answers[i].size()); j++) {
            cout << answers[i][j] + 1 << ' ';
        }
        cout << '\n';
    }
    return 0;
}
