#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    string days;
    cin >> days;
    const int n = days.length();
    vector<list<int>> s;

    for (int i = 0; i < n; i++) {
        vector<list<int>>::iterator it;
        if (days[i] == '1')
            it = upper_bound(s.begin(), s.end(), '0',
                             [&](char ch, const list<int> &a) { return days[a.back()] > ch; });
        else
            it = lower_bound(s.begin(), s.end(), '1',
                             [&](const list<int> &a, char ch) { return days[a.back()] < ch; });
        if (days[i] == '1')
            if (it == s.begin()) {
                cout << -1;
                return 0;
            } else --it;
        if (it == s.end())
            s.emplace_back(1, i);
        else
            it->push_back(i);
    }

    while (days[s.back().back()] == '1' && days[s.front().back()] == '0') {
        swap(s.back(), s.front());
        s.front().splice(s.front().cend(), move(s.back()));
        s.pop_back();
    }

    if (days[s.back().back()] == '1') {
        cout << -1;
        return 0;
    }

    cout << s.size() << '\n';
    for (auto &line: s) {
        cout << line.size() << ' ';
        for (auto &it: line)
            cout << it + 1 << ' ';
        cout << '\n';
    }

    return 0;
}