#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <algorithm>

#pragma warning (disable : 4996)

using namespace std;

const int MAXN = 2e5 + 10;

int n, m, h, u[MAXN], res[MAXN], mi, was[MAXN], wasr[MAXN], col[MAXN], dsu[MAXN];
vector < int > graph[MAXN], now, vans, rgraph[MAXN], tops, condgraph[MAXN];

int get_pr(int x) {
    return dsu[x] == x ? x : dsu[x] = get_pr(dsu[x]);
}

/*long long dfs(int v) {
    was[v] = 1;
    long long sum = 1;
    for (int i = 0; i < graph[v].size(); i++) {
        int to = graph[v][i];
        if (was[to] == 0) {
            if (res[to] == 0) {
                sum += dfs(to);
            }
            else {
                sum += res[to];
            }
        }
    }
    res[v] = sum;
    return res[v];
}

void dfs_(int v) {
    was[v] = 1;
    vans.push_back(v);
    for (int i = 0; i < graph[v].size(); i++) {
        int to = graph[v][i];
        if (was[to] == 0) {
            dfs(to);
        }
    }
}*/

void dfs(int v) {
    was[v] = 1;
    for (int i = 0; i < graph[v].size(); i++) {
        int to = graph[v][i];
        if (was[to] == 0) {
            dfs(to);
        }
    }
    tops.push_back(v);
}

void dfsr(int v) {
    wasr[v] = 1;
    col[v] = get_pr(v);
    for (int i = 0; i < rgraph[v].size(); i++) {
        int to = rgraph[v][i];
        if (wasr[to] == 0) {
            dsu[to] = v;
            dfsr(to);
        }
    }
}

void resdfs(int v) {
    was[v] = 1;
    now.push_back(v);
    for (int i = 0; i < graph[v].size(); i++) {
        int to = graph[v][i];
        if (was[to] == 0) {
            resdfs(to);
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
    /*freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);*/
#endif

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> u[i];
        dsu[i] = i;
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((u[a] + 1) % h == u[b]) {
            graph[a].push_back(b);
            rgraph[b].push_back(a);
        }
        if ((u[b] + 1) % h == u[a]) {
            graph[b].push_back(a);
            rgraph[a].push_back(b);
        }
    }

    for (int i = 0; i < n; i++) {
        if (was[i] == 0) {
            dfs(i);
        }
    }
    reverse(tops.begin(), tops.end());
    for (int i = 0; i < n; i++) {
        if (wasr[tops[i]] == 0) {
            dfsr(tops[i]);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < graph[i].size(); j++) {
            if (col[i] != col[graph[i][j]]) {
                condgraph[col[i]].push_back(col[graph[i][j]]);
            }
        }
    }

    vector < int > ans(n + 1);
    for (int i = 0; i < n; i++) {
        was[i] = 0;
    }
    for (int i = 0; i < n; i++) {
        if (i == get_pr(i) && condgraph[i].size() == 0) {
            now.clear();
            resdfs(i);
            if (now.size() < ans.size()) {
                ans = now;
            }
        }
    }

    
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << " ";
    }
}