#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <set>
#include <map>
#include <functional>
#include <string>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<bool> vb;
typedef vector<double> vd;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define it(v) v.begin(), v.end()
#define fst first
#define scn second
#define mp make_pair
#define pb push_back 
#define eb emplace_back

const int inf = 1e9 + 9;
const int mod = 1e9 + 7;
const ll linf = 1e18 + 1;

vector<vi> g;
vb used;

void dfs(int pos)
{
	used[pos] = true;
	for (auto i : g[pos])
	{
		if (!used[i])
		{
			dfs(i);
		}
	}
}

signed main()
{
	int n, m, h;
	cin >> n >> m >> h;
	vi upd(n);
	g.assign(n, vi());
	for (int i = 0; i < n; i++)
	{
		cin >> upd[i];
	}
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		--u; --v;
		if ((upd[u] + 1) % h == upd[v])
		{
			g[u].pb(v);
		}
		if ((upd[v] + 1) % h == upd[u])
		{
			g[v].pb(u);
		}
	}
	vi res(n + 1, 0);
	for (int i = 0; i < n; i++)
	{
		used.assign(n, false);
		dfs(i);
		if (count(it(used), true) < res.size())
		{
			res.clear();
			for (int j = 0; j < n; j++)
			{
				if (used[j])
				{
					res.pb(j);
				}
			}
		}
	}
	cout << res.size() << "\n";
	for (auto i : res)
	{
		cout << i + 1 << " ";
	}
}

