#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1005000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

int p, n, d, b;
vector<ll> v, pref, suf;

void solve1() {
    vector<ll> pref(n);
    pref[0] = v[0];
    ll ans = 0;
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + v[i];
    }
    ll done = 0, add = 0;
    int r = d;
    for (int i = 0; i < n; ++i) {
        ll can = pref[r] - done;
        if (can >= b) {
            done += b;
        } else {
            ans++;
        }
        r += (d + 1);
        r = min(r, n - 1);
    }
    cout << ans << "\n";
}

bool ask(ll x) {
    ll len = n - x - x;
    if (len <= d + 1) {
        return true;
    }
    int r = d;
    for (int i = 0; i < x - 1; ++i) {
        r += (d + 1);
        r = min(r, n - 1);
    }
    ll sum1 = pref[r];
    ll sum2 = suf[n - 1 - r];
    if (sum1 >= b && sum2 >= b) return true;
    else return false;
}

void solve2() {
    ll l = 0, r = n / 2, m, len;
    while (l < r - 1) {
        m = (l + r) / 2;
        len = n - m - m;
        if (ask(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> p >> n >> d >> b;
    v.resize(n + 10);
    pref.resize(n);
    suf.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    pref[0] = v[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + v[i];
    }
    suf[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suf[i] = suf[i + 1] + v[i];
    }
   /* for (auto i : pref) {
        cout << i << " ";
    }
    cout << "\n";
    for (auto i : suf) {
        cout << i << " ";
    }
    cout << "\n";
    return 0;*/

    if (p == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}
