#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1005000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

ll p, n, d, b;
vector<ll> v, pref, suf;

void solve1() {
    vector<ll> pref(n);
    pref[0] = v[0];
    ll ans = 0;
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + v[i];
    }
    ll done = 0, add = 0;
    ll r = d;
    for (int i = 0; i < n; ++i) {
        ll can = pref[r] - done;
        if (can >= b) {
            done += b;
        } else {
            ans++;
        }
        r += (d + 1);
        r = min(r, n - 1);
    }
    cout << ans << "\n";
}

bool ask(ll x) {
    ll len = n - x - x;
    if (len <= d + 1) {
        return true;
    }
    ll l = x + 1, r = n - x;
    ll can = d + 1;
    for (int i = 0; i < x; ++i) {
        can += (d + 1);
        can = min(can, n);
    }
    ll donel = 0, doner = 0;
    //cout << l << " " << r << " " << can << "\n";
    while (l <= r) {
        if (pref[can - 1] - donel < b) return false;
        if (suf[n - can] - doner < b) return false;
        l++;
        r--;
        donel += b;
        doner += b;
        can += (d + 1);
        can = min(can, n);
    }
    return true;
}

void solve2() {
    ll l = 0, r = n / 2 + 2, m, len;
    while (l < r - 1) {
        m = (l + r) / 2;
        len = n - m - m;
        if (ask(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> p >> n >> d >> b;
    v.resize(n + 10);
    pref.resize(n);
    suf.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    pref[0] = v[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + v[i];
    }
    suf[n - 1] = v[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suf[i] = suf[i + 1] + v[i];
    }
    //ask(1);
    //return 0;

    if (p == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}
