#include <iostream>
#include <vector>

using namespace std;

const int MAX_CARD = 1 << 4;

int n, a;
vector<int> vect;

int get(int k)
{
    if (k < 0)
        k = -k;
    int res = 0;
    while (k > 0) {
        res += k & 1;
        k >>= 1;
    }
    return res;
}

void add_to_vect(int k)
{
    int is = 1;
    if (k < 0) {
        is = -1;
        k = -k;
    }
    int now = 1;
    while (k > 0) {
        if (k & 1)
            vect.push_back(now * is);
        now <<= 1;
        k >>= 1;
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n >> a;
    int res_x = 0;
    int res = -1;
    for (int x = -MAX_CARD; x < MAX_CARD; x++) {
        int y = a - x;
        if (res == -1 || get(x) + get(y) < res) {
            res_x = x;
            res = get(x) + get(y);
        }
    }
    add_to_vect(res_x);
    add_to_vect(a - res_x);
    cout << vect.size() << "\n";
    for (auto v : vect)
        cout << v << ' ';
    return 0;
}
