#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAX_CARD = 1 << 6;

int n, a;
set<int> st;

int get(int k)
{
    if (k < 0)
        k = -k;
    int res = 0;
    while (k > 0) {
        res += k & 1;
        k >>= 1;
    }
    return res;
}

void add_to_set(int k)
{
    int is = 1;
    if (k < 0) {
        is = -1;
        k = -k;
    }
    int now = 1;
    while (k > 0) {
        if (k & 1)
            st.insert(now * is);
        now <<= 1;
        k >>= 1;
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a;
        int res_x = 0;
        int res = -1;
        for (int x = -MAX_CARD; x < MAX_CARD; x++) {
            int y = a - x;
            if (res == -1 || get(x) + get(y) < res) {
                res_x = x;
                res = get(x) + get(y);
            }
        }
        add_to_set(res_x);
        add_to_set(a - res_x);
    }
    cout << st.size() << "\n";
    for (auto v : st)
        cout << v << ' ';
    return 0;
}
