#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
int p, n, d, b;
ll a[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    if (p == 1) {
        int L = -1, R = n;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            ll c[maxn] = {};
            for (int i = 1; i <= n; ++i) {
                c[i] = a[i];
            }
            for (int i = 1; i <= M; ++i) {
                c[M + 1] += c[i];
                c[i] = 0;
            }
            int l = M + 2;
            for (int i = M + 1; i <= n; ++i) {
                int r = min((ll)n, (ll)i + (ll)i * (ll)d);
                for (int j = l; j <= r; ++j)
                    c[i] += c[j], c[j] = 0;
                l = r + 1;
            }
            bool ok = true;
            for (int i = M + 1; i <= n; ++i) {
                if (c[i] < b) {
                    ok = false;
                    break;
                }
                if (c[i] > b)
                    c[i + 1] += c[i] - b;
                c[i] = b;
            }
            if (ok)
                R = M;
            else
                L = M;
        }
        cout << R << endl;
        return 0;
    }
    if (p == 2) {
        cout << b;
        return 0;
    }
}
/*
1 5 3 1
0 0 0 5 0

1 5 3 10
5 1 1 1 42
*/
