#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define endl '\n'

vector<bool> used;
vector<vector<int> > grph;
vector<int> kol;

void dfs(int v) {
	used[v] = true;
	kol.push_back(v);
	for (auto u : grph[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
	return;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, h;
	cin >> n >> m >> h;

	vector<int> hour(n);
	for (int i = 0; i < n; i++) {
		cin >> hour[i];
	}

	int a, b;
	grph.resize(n);
	for (int i = 0; i < m; i++) {
		cin >> a >> b;
		a--;
		b--;
		if ((hour[a] + 1) % h == hour[b]) {
			grph[a].push_back(b);
		}
		if ((hour[b] + 1) % h == hour[a]) {
			grph[b].push_back(a);
		}
	}

	vector<int> mn;
	for (int i = 0; i < n; i++) {
		used.clear();
		used.resize(n);
		kol.clear();
		dfs(i);
		if (kol.size() < mn.size() || mn.size() == 0) {
			mn = kol;
		}
	}

	cout << mn.size() << endl;
	for (int i = 0; i < mn.size(); i++) {
		cout << mn[i] + 1 << " ";
	}
}