#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define endl '\n'

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string s;
	cin >> s;
	int n = s.size();
	set<int> ind0;
	set<int> ind1;

	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '0') {
			ind0.insert(i);
		}
		else {
			ind1.insert(i);
		}
	}

	bool bad = true;
	int last = -1;
	vector<vector<int> > ans(1);
	while (ind1.size() > 0 || bad) {
		if (bad) {
			auto it = ind0.upper_bound(last);
			if (it == ind0.end()) {
				cout << -1;
				return 0;
			}
			bad = !bad;
			last = *it;
			ans.back().push_back(*it + 1);
			ind0.erase(it);
		}
		else {
			auto it = ind1.upper_bound(last);
			if (it == ind1.end()) {
				last = -1;
				ans.resize(ans.size() + 1);
			}
			else {
				last = *it;
				ans.back().push_back(*it + 1);
				ind1.erase(it);
			}
			bad = !bad;
		}
	}

	while (ind0.size() > 0) {
		ans.resize(ans.size() + 1);
		ans.back().push_back(*ind0.begin() + 1);
		ind0.erase(ind0.begin());
	}

	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size() << " ";
		for (int j = 0; j < ans[i].size(); j++) {
			cout << ans[i][j] << " ";
		}
		cout << endl;
	}
}