#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <iterator>
#include <map>
#include <stack>
#define pb push_back
#define ppb pop_back
#define mp make_pair
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
int const MAXN = 100010;
int const INF = 1e9;
int const MOD = 1000000007;

using namespace std;

    int n, m, h, x, y, mn=INF, nom;
    int a[MAXN];
    int d[MAXN];
    bool used[MAXN], used0[MAXN];
    vector <int> g[MAXN];
    set <pair <int, int> > st;

    void dfs (int v, bool p){
        used[v]=true;
        for (int i=0; i<g[v].size(); i++){
            int to=g[v][i];
            if ((a[v]+1)%h==a[to]){
                if (!used[to]){
                    dfs(to, 0);
                    d[v]+=d[to];
                }
                else
                    d[v]+=d[to];
            }
        }
        if (!p) d[v]++;
    }

int main()
{
    ifstream cin ("input.txt");
    ofstream cout ("output.txt");
    ios_base::sync_with_stdio(0);

    cin >> n >> m >> h;
        for (int i=1; i<=n; i++)
            cin >> a[i];
        for (int i=0; i<m; i++){
            cin >> x >> y;
            if (st.find(mp(min(x, y), max(x, y)))==st.end()){
                g[x].pb(y);
                g[y].pb(x);
                st.insert(mp(min(x, y), max(x, y)));
            }
        }
        for (int i=1; i<=n; i++){
            if (!used[i])
                dfs(i, 0);
            else
                dfs(i, 1);
            if (d[i]<mn){
                mn=d[i];
                nom=i;
            }
        }
    cout << mn << endl;
    queue <int> q;
    q.push(nom);
    used0[nom]=true;
    while (!q.empty()){
        int v=q.front();
        q.pop();
        cout << v << " ";
        for (int i=0; i<g[v].size(); i++){
            int to=g[v][i];
            if (!used0[to] && (a[v]+1)%h==a[to]){
                used0[to]=true;
                q.push(to);
            }
        }
    }
    return 0;
}
