#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

void print(vector<auto> &tp)
{
    for (auto i : tp)
        cout << i + 1 << " ";
    cout << endl;
}

int n, m, h, t = 1, push;
vector<vector<int> > g;
vector<vector<int> > g_obr;
vector<int> checked;

vector<int> was;
vector<int> ans;
vector<int> c_ans;


void dfs(int v)
{
    was[v] = t;
    for (int u : g[v])
    {
        if (was[u] != t)
            dfs(u);
    }
}

void dfs_obr(int v)
{
    checked[v] = 1;
    for (int u : g_obr[v])
    {
        if (checked[u] == 0)
            dfs_obr(u);
    }
}

void push_in(int v)
{
    if (push != -1)
        return;
    bool f = true;
    was[v] = t;
    for (int u : g[v])
    {
        if (was[u] != t)
        {
            push_in(u);
            f = false;
        }
    }
    if (f)
    {
        push = v;
        return;
    }
}

int main()
{
    //freopen("file.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin >> n >> m >> h;
    was.assign(n, 0);
    checked.assign(n, 0);
    int ci, cj;
    vector<int> u(n);
    g.resize(n);
    g_obr.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> u[i];
    set<pair<int, int> > s;
    for (int i = 0; i < m; ++i)
    {
        cin >> ci >> cj; ci--; cj--;
        if (ci > cj) swap(ci, cj);
        if (s.find({ci, cj}) != s.end())
            continue;
        s.insert({ci, cj});
        if ((u[ci] + 1) % h == u[cj])
        {
            g[ci].push_back(cj);
            g_obr[cj].push_back(ci);
        }
        if ((u[cj] + 1) % h == u[ci])
        {
            g[cj].push_back(ci);
            g_obr[ci].push_back(cj);
        }

    }
    int cnt = 0;
    /*for (int i = 0; i < n; ++i)
    {
        cout << i + 1 << ": ";
        print(g[i]);
    }
    cout << endl;*/
    for (int i = 0; i < n; ++i)
    {
        t++;
        if (checked[i] == 1)
            continue;
        push = -1;
        push_in(i);
        t++;

        //cout << "from " << push + 1 << endl;
        dfs(push);
        cnt = 0;
        c_ans.clear();
        for (int j = 0; j < n; ++j)
        {
            if (was[j] == t)
            {
                c_ans.push_back(j);
                //checked[j] = 1;
                cnt++;
            }

        }
        for (int v : c_ans)
        {
            if (checked[v] == 1)
                continue;
            dfs_obr(v);
        }
        if (cnt < ans.size() || ans.empty())
            ans.swap(c_ans);
    }
    cout << ans.size() << endl;
    print(ans);
    return 0;
}
