#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 200100;
int n, in, tec, pr, toc;
vector<int> ud0, ud1;
vector<int> g[MAXN];
string s;
set<int> w0, w1;

void read(string &t)
{
    char h = getchar();
    while (h < '0' || h > '1')
        h = getchar();
    while (h >= '0' && h <= '1')
    {
        t += h;
        h = getchar();
    }
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    //ios_base::sync_with_stdio(0);
    read(s);
    n = s.size();
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
        {
            w0.insert(i + 1);
        }
        else
        {
            w1.insert(i + 1);
        }
    }

    w0.insert(n + 1);
    w1.insert(n + 1);

    while (w0.size() != 1)
    {
        tec = *w0.begin();
        g[in].push_back(tec);
        ud0.push_back(tec);
        pr = 1;
        while (true)
        {
            if (pr == 1)
            {
                toc = *(w1.upper_bound(tec));
                if (toc == n + 1)
                    break;
                g[in].push_back(toc);
                ud1.push_back(toc);
                tec = toc;
                pr = 0;
            }
            else
            {
                toc = *(w0.upper_bound(tec));
                if (toc == n + 1)
                {
                    cout << -1;
                    return 0;
                }
                g[in].push_back(toc);
                ud0.push_back(toc);
                tec = toc;
                pr = 1;
            }
        }
        in++;
        for (int i = 0; i < ud0.size(); i++)
        {
            w0.erase(ud0[i]);
        }
        for (int i = 0; i < ud1.size(); i++)
        {
            w1.erase(ud1[i]);
        }
    }

    if (w1.size() != 1)
    {
        cout << -1;
        return 0;
    }

    cout << in << endl;
    for (int i = 0; i < in; i++)
    {
        cout << g[i].size() << " ";
        for (int j : g[i])
            cout << j << " ";
        cout << endl;
    }
    return 0;
}