#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int u[200001];
vector<int> g[200001], inv[200001], sorted, cond[200001];
int col[200001], col_cnt[200001];
bool used[200001];
void top_sort(int u)
{
	used[u] = true;
	for (int v : g[u])
		if (!used[v])
			top_sort(v);
	sorted.push_back(u);
}
void condense(int u, int idx)
{
	used[u] = true;
	col[u] = idx;
	++col_cnt[idx];
	for (int v : inv[u])
		if (!used[v])
			condense(v, idx);
		else if (col[v] != idx)
			cond[col[v]].push_back(idx);
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, h;
	cin >> n >> m >> h;
	for (int i = 1; i <= n; ++i)
		cin >> u[i];
	int c1, c2;
	for (int i = 0; i < m; ++i)
	{
		cin >> c1 >> c2;
		if ((u[c1] + 1) % h == u[c2])
			g[c1].push_back(c2);
		if ((u[c2] + 1) % h == u[c1])
			g[c2].push_back(c1);
	}
	/*for (int i = 1; i <= n; ++i)
		if (g[i].empty())
		{
			cout << "1\n" << i;
			return 0;
		}*/

	for (int i = 1; i <= n; ++i)
		for (int j : g[i])
			inv[j].push_back(i);
	for (int i = 1; i <= n; ++i)
		if (!used[i])
			top_sort(i);
	reverse(sorted.begin(), sorted.end());
	fill(used, used + n + 1, false);
	int cnt = 0;
	for (int i = 0; i < n; ++i)
		if (!used[sorted[i]])
			condense(sorted[i], ++cnt);
	int ans = -1;
	for (int i = 1; i <= n; ++i)
		if (cond[i].empty() && col_cnt[i] != 0)
			if (ans == -1)
				ans = i;
			else if (col_cnt[i] < col_cnt[ans])
				ans = i;
	cout << col_cnt[ans] << '\n';
	for (int i = 1; i <= n; ++i)
		if (col[i] == ans)
			cout << i << ' ';
}