#include <iostream>
#include <stack>
#include <algorithm>
using namespace std;

char s[200001];
int p[200001];
bool used[200001];
int len(int i)
{
	int ans = 1;
	if (p[i])
		ans += len(p[i]);
	used[i] = true;
	return ans;
}
void print(int i)
{
	if (p[i])
		print(p[i]);
	used[i] = true;
	cout << ' ' << i;
}
int main()
{
	cin >> s;
	int n = 0;
	for (int i = 0; s[i]; ++i, ++n)
		s[i] -= '0';
	stack<int> last[2];
	for (int i = 0; i < n; ++i)
	{
		if (s[i] && last[0].empty())
		{
			cout << "-1";
			return 0;
		}
		if (!last[1 - s[i]].empty())
		{
			p[i + 1] = last[1 - s[i]].top();
			last[1 - s[i]].pop();
		}
		last[s[i]].push(i + 1);
	}
	int k = 0;
	for (int i = n; i > 0; --i)
		if (!used[i])
			if (s[i - 1])
			{
				cout << "-1";
				return 0;
			}
			else
				len(i), ++k;
	fill(used, used + 200001, false);
	cout << k << '\n';
	for (int i = n; i > 0; --i)
		if (!used[i])
		{
			cout << len(i);
			print(i);
			cout << '\n';
		}
}