#include <bits/stdc++.h>

using namespace std;

vector <vector <int> > gr;
vector <vector <int> > gr2;
vector <bool> used;
vector <int> topsort;
vector <int> color;

void dfs(int v) {
    used[v] = true;
    for (int i : gr[v]) {
        if (!used[i]) dfs(i);
    }
    topsort.push_back(v);
}

void dfs2(int v, int c) {
    used[v] = true;
    color[v] = c;
    for (int i : gr2[v]) {
        if (!used[i]) dfs2(i, c);
    }
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    gr.resize(n);
    gr2.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        if ((t[u] - t[v] + h) % h == 1) {
            gr[v].push_back(u);
            gr2[u].push_back(v);
        }
        if ((t[v] - t[u] + h) % h == 1) {
            gr[u].push_back(v);
            gr2[v].push_back(u);
        }
    }
    used.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i);
    }
    reverse(topsort.begin(), topsort.end());
    used.clear();
    used.resize(n, false);
    color.resize(n);
    int cur = 0;
    for (int i = 0; i < n; i++) {
        int v = topsort[i];
        if (!used[v]) {
            dfs2(v, cur);
            cur++;
        }
    }
    vector <int> cnt(cur, 0);
    vector <bool> fl(cur, true);
    for (int i = 0; i < n; i++) {
        cnt[color[i]]++;
    }
    for (int i = 0; i < n; i++) {
        for (int j : gr[i]) {
            if (color[i] != color[j]) {
                fl[color[i]] = false;
            }
        }
    }
    int ans = n + 1, id = 0;
    for (int i = 0; i < cur; i++) {
        if (fl[i] && cnt[i] < ans) {
            ans = cnt[i];
            id = i;
        }
    }
    cout << ans << endl;
    for (int i = 0; i < n; i++) {
        if (color[i] == id) {
            cout << i + 1 << " ";
        }
    }
    return 0;
}
