#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

vector<int> take_less(int x)
{
    bool minus = (x < 0);
    if (x < 0)
    {
        x = -x;
    }
    bitset<20> b(static_cast<unsigned long long int>(x));
    vector<int> result;
    for (int i = 0; i < 20; ++i)
    {
        if (b[i])
        {
            result.push_back(!minus ? (1 << i) : -(1 << i));
        }
    }
    return result;
}

vector<int> take_more(int x)
{
    bool minus = (x < 0);
    if (x < 0)
    {
        x = -x;
    }
    int tmp = 0;
    while ((1 << tmp) < x)
    {
        ++tmp;
    }
    bitset<20> br(static_cast<unsigned long long int>((1 << tmp) - x));
    vector<int> result;
    for (int i = 0; i < 20; ++i)
    {
        result.push_back(!minus ? (1 << tmp) : -(1 << tmp));
        if (br[i])
        {
            result.push_back(!minus ? -(1 << i) : (1 << i));
        }
    }
    return result;
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    int n;
    in >> n;
    vector<int> a(static_cast<unsigned int>(n));
    for (int i = 0; i < n; ++i)
    {
        in >> a[i];
    }
    if (n == 1)
    {
        bool minus = (a[0] < 0);
        if (a[0] < 0)
        {
            a[0] = -a[0];
        }
        bitset<20> b(static_cast<unsigned long long int>(a[0]));
        int res1 = b.count();
        int tmp = 0;
        while ((1 << tmp) < a[0])
        {
            ++tmp;
        }
        bitset<20> br(static_cast<unsigned long long int>((1 << tmp) - a[0]));
        int res2 = 1 + br.count();
        if (res1 <= res2)
        {
            out << res1 << '\n';
            for (int i = 0; i < 20; ++i)
            {
                if (b[i])
                {
                    out << (!minus ? (1 << i) : -(1 << i)) << ' ';
                }
            }
        }
        else
        {
            out << res2 << '\n';
            out << (!minus ? (1 << tmp) : -(1 << tmp)) << ' ';
            for (int i = 0; i < 20; ++i)
            {
                if (br[i])
                {
                    out << (!minus ? -(1 << i) : (1 << i)) << ' ';
                }
            }
        }
        out << '\n';
    }
    else
    {
        vector<vector<int>> need_less(static_cast<unsigned int>(n));
        vector<vector<int>> need_more(static_cast<unsigned int>(n));
        for (int i = 0; i < n; ++i)
        {
            need_less[i] = take_less(a[i]);
            need_more[i] = take_more(a[i]);
        }
        int best_s = 1000000000;
        set<int> best;
        for (int i = 0; i < (1 << 11); ++i)
        {
            bitset<11> b(i);
            set<int> take;
            for (int j = 0; j < min(11, n); ++j)
            {
                if (!b[j])
                {
                    for (auto elem : need_less[j])
                    {
                        if (!take.count(elem))
                        {
                            take.insert(elem);
                        }
                    }
                }
                else
                {
                    for (auto elem : need_more[j])
                    {
                        if (!take.count(elem))
                        {
                            take.insert(elem);
                        }
                    }
                }
            }
            if ((int)take.size() < best_s)
            {
                best = take;
                best_s = (int)take.size();
            }
        }
        out << best_s << '\n';
        for (auto elem : best)
        {
            out << elem << ' ';
        }
        out << '\n';
    }
    in.close();
    out.close();
    return 0;
}