#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    string s;
    in >> s;
    int max_num = 0;
    queue<int> que1;
    queue<int> que0;
    vector<int> nums((int)s.size());
    for (int i = 0; i < (int)s.size(); ++i)
    {
        if (s[i] == '0')
        {
            if (que1.empty())
            {
                ++max_num;
                que0.push(max_num);
                nums[i] = max_num;
            }
            else
            {
                que0.push(que1.front());
                nums[i] = que1.front();
                que1.pop();
            }
        }
        else
        {
            if (que0.empty())
            {
                out << "-1\n";
                in.close();
                out.close();
                return 0;
            }
            que1.push(que0.front());
            nums[i] = que0.front();
            que0.pop();
        }
    }
    if (!que1.empty())
    {
        out << "-1\n";
    }
    else
    {
        out << max_num << '\n';
        vector<vector<int>> res(static_cast<unsigned int>(max_num + 1));
        for (int i = 0; i < (int)nums.size(); ++i)
        {
            res[nums[i]].push_back(i);
        }
        for (int i = 1; i <= max_num; ++i)
        {
            out << (int)res[i].size() << ' ';
            for (auto elem : res[i])
            {
                out << elem + 1 << ' ';
            }
            out << '\n';
        }
    }
    in.close();
    out.close();
    return 0;
}