#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>
#include <bitset>

using namespace std;

const int MAXN = 2007;
const int ADD = MAXN / 2;
const int INF = 1e9 + 7;
const int MAXL = 20;

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);
	
	string s;
	cin >> s;

	int n = s.size();

	vector <int> a;
	vector <int> b;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') a.push_back(i);
		else b.push_back(i);
	}

	if (b.size() < a.size()) {
		cout << "-1\n";
		return 0;
	}
	
	vector <int> last(n), next(n);
	for (int i = 0; i < n; ++i) {
		last[i] = next[i] = -1;
	}

	for (int i = 0; i < a.size(); ++i) {
		last[a[i]] = b[i];
		int r = a.size() - i;
		next[a[i]] = b[b.size() - r];

		if (a[i] < last[a[i]] || next[a[i]] < a[i]) {
			cout << "-1\n";
			return 0;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			next[last[i]] = i;
			last[next[i]] = i;
		}
	}
	
	vector <vector <int>> ans;
	for (int i = 0; i < n; ++i) {
		if (last[i] == -1) {
			vector <int> v;
			int curr = i;
			while (curr != -1) {
				v.push_back(curr);
				curr = next[curr];
			}
			ans.push_back(v);
		}
	}

	cout << ans.size() << '\n';
	for (vector <int> v : ans) {
		cout << v.size() << ' ';
		for (int elem : v) {
			cout << elem + 1 << ' ';
		}
		cout << '\n';
	}

	return 0;
}