#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>
#include <cstdio>

using namespace std;

string s;
vector <int> a0, a1;

set <int> s0, s1;

vector <vector <int> > res;

void fail() {
    cout << -1 << endl;
    exit(0);
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> s;
    int n = (int)s.length();

    for (int i = 0; i < n; i++) {
        if (s[i] == '0')
            a0.push_back(i);
        if (s[i] == '1')
            a1.push_back(i);
    }

    int k = (int)a0.size() - (int)a1.size();

    if (k <= 0)
        fail();

    for (int i = 0; i < k; i++) {
        s1.insert(i);
        res.push_back(vector <int> ());
    }

    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (s1.empty())
                fail();
            int id = (*s1.begin());
            s1.erase(s1.begin());
            s0.insert(id);
            res[id].push_back(i);
        }
        else if (s[i] == '1') {
            if (s0.empty())
                fail();
            int id = (*s0.begin());
            s0.erase(s0.begin());
            s1.insert(id);
            res[id].push_back(i);
        }
    }

    cout << k << endl;
    for (int i = 0; i < (int)res.size(); i++) {
        cout << (int)res[i].size() << " ";
        for (int j = 0; j < (int)res[i].size(); j++)
            cout << res[i][j] + 1 << " ";
        cout << endl;
    }

    return 0;
}
