#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int main() {
	int p, n, d, b;
	cin >> p >> n >> d >> b;

	vector<int> rooms(n);
	for (int i = 0; i < n; ++i) {
		cin >> rooms[i];
	}

	int to_take = n - 1, to_build = n - 1;
	while (true) {
		for (; to_take >= 0 && rooms[to_take] <= 1; --to_take);
		for (; to_build >= 0 && rooms[to_build] >= 1; --to_build);

		if (to_take < 0) {
			break;
		}

		if (to_build < 0) {
			break;
		}

		if (to_take - to_build <= (to_build + 1) * d) {
			--rooms[to_take];
			++rooms[to_build--];
		} else {
			--to_take;
		}
	}

	int cnt = n;
	for (int i = 0; i < n; ++i) {
		cnt -= rooms[i] >= 1;
	}

	cout << cnt;

    return 0;
}