#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int main() {
	int p, n, d, b;
	cin >> p >> n >> d >> b;

	vector<int> rooms(n);
	for (int i = 0; i < n; ++i) {
		cin >> rooms[i];
	}

	int to_take = n - 1, to_build = n - 1;
	while (true) {
		for (; to_take >= 0 && rooms[to_take] < 1; --to_take);
		for (; to_build >= 0 && rooms[to_build] >= 1; --to_build);

		if (to_take < 0) {
			cout << to_build + 1;

			return 1;
		}

		if (to_build < 0) {
			cout << 0;

			return 0;
		}

		if (to_take < to_build) {
			--rooms[to_take];
			++rooms[to_build--];
			continue;
		}

		if (rooms[to_take] > 1 && to_take - to_build <= (to_build + 1) * d) {
			--rooms[to_take];
			++rooms[to_build--];
		} else {
			--to_take;
		}
	}

    return 0;
}