#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>


using namespace std;


const int K = 2401;


int main() {
	int n;
	cin >> n;

	bitset<K> needed;
	int cur;
	for (int i = 0; i < n; ++i) {
		cin >> cur;

		needed[cur + K / 2] = 1;
	}

	short min_cnt = 100, min_pos, min_neg;

	for (short mask = 0; mask < (1 << 10); ++mask) {
		bitset<K> reach;
		reach[K / 2] = 1;

		short cnt = 0;

		for (short i = 1; i <= mask; i <<= 1) {
			if (i & mask) {
				reach |= reach << i;
				++cnt;
			}
		}

		bitset<K> creach;
		for (short neg_mask = 0; neg_mask < (1 << 10); ++neg_mask) {
			creach = reach;
			short ccnt = 0;

			for (short i = 1; i <= neg_mask; i <<= 1) {
				if (i & neg_mask) {
					creach |= creach >> i;
					++ccnt;
				}
			}

			if ((creach & needed) == needed) {
				if (cnt + ccnt < min_cnt) {
					min_cnt = cnt + ccnt;
					min_pos = mask;
					min_neg = neg_mask;
				}
			}
		}
	}

	cout << min_cnt << '\n';

	for (short i = 1; i <= min_pos; i <<= 1) {
		if (i & min_pos) {
			cout << i << ' ';
		}
	}

	for (short i = 1; i <= min_neg; i <<= 1) {
		if (i & min_neg) {
			cout << -i << ' ';
		}
	}

    return 0;
}