#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>


using namespace std;


int main() {
	string s;
	cin >> s;

	int n = s.length();
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = s[i] == '1';
	}

	vector<vector<int>> answ;
	vector<int> need_zero, need_one;

	for (int i = 0; i < n; ++i) {
		if (p[i]) {
			if (need_one.empty()) {
				cout << -1;

				return 0;
			}

			int cur = need_one.back();
			answ[cur].push_back(i);
			need_one.pop_back();
			need_zero.push_back(cur);
		} else {
			if (need_zero.empty()) {
				answ.push_back({i});
				need_one.push_back(answ.size() - 1);
			} else {
				int cur = need_zero.back();
				answ[cur].push_back(i);
				need_zero.pop_back();
				need_one.push_back(cur);
			}
		}
	}

	if (!need_zero.empty()) {
		cout << -1;

		return 0;
	}

	cout << answ.size();
	for (auto &zp : answ) {
		cout << '\n' << zp.size();
		for (int i : zp) {
			cout << ' ' << i + 1;
		}
	}

    return 0;
}