#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <string>

using namespace std;

int main()
{
    string s;
    cin >> s;
    int n = s.length();
    set<int> good;
    set<int> bad;
    int tot;
    vector<vector<int> > out;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '1')
        {
            if (good.empty())
            {
                cout << -1;
                return 0;
            }
            out[*good.begin()].push_back(i + 1);
            bad.insert(*good.begin());
            good.erase(good.begin());
        }
        else
            if (bad.empty())
            {
                good.insert(out.size());
                out.push_back({ i + 1 });
            }
            else
            {
                out[*bad.begin()].push_back(i + 1);
                good.insert(*bad.begin());
                bad.erase(bad.begin());
            }
    }
    if (bad.size())
    {
        cout << -1;
        return 0;
    }
    cout << out.size() << "\n";
    for (auto v : out)
    {
        cout << v.size() << " ";
        for (auto el : v)
            cout << el << " ";
        cout << "\n";
    }
    return 0;
}