#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = (int)1e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, m, h;
int ans = (1<<21)-1;
bool used[N];
int need[N];
vector<int> add = {-128, -64, -32, -16, -8, -4, -2, -1, 1, 2, 4, 8, 16, 32, 64, 128};


int bfs(int mask) {
    vi can;
    rep(i, 0, add.size()) {
        if ((mask>>i)&1) can.push_back(add[i]);
    }
    int ret = 0;
    rep(msk, 0, (1<<can.size())) {
        int x = 0;
        rep(i, 0, can.size()) {
            if ((msk>>i)&1) x += can[i];
        }
        if (!used[x+500]) {
            used[x+500] = true;
            ret += need[x+500];
        }
    }
    return ret;
}

void solve(int mask) {
    fill(used, used+1003, false);
    if (bfs(mask) == n) {
        if (__builtin_popcount(mask) < __builtin_popcount(ans)) {
            ans = mask;
        }
    }
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(n);
    rep(i, 0, n) {
        int x;
        read(x);
        need[x+500]++;
    }
    rep(mask, 0, (1<<add.size())) solve(mask);
    vi res;
    rep(i, 0, add.size()) if ((ans>>i)&1) res.push_back(add[i]);
    printf("%d\n", res.size());
    rep(i, 0, res.size()) printf("%d ", res[i]);

    return 0;
}
