#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

const int inf = 2*1e9 + 2018;

int **dp;
void clean(int n, int m) {
    for (int i=0; i<n; i++)
        for (int j=0; j<m; j++)
            dp[i][j] = 0;
}

int main()
{
    ///ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n; fin >> n;
    int item, maxi=0, mini=0;
    vector<int> input;
    for (int i=0; i<n; i++) {
        fin >> item;
        input.pb(item);
        maxi = max(maxi, item);
        mini = min(mini, item);
    }

    int top = max(abs(mini), abs(maxi));

    int k=0;
    int cur_ = 1;
    while (cur_ < top) {
        cur_ *= 2;
        k++;
    }

    vector<int> cards;
    for (int i=0; i<=k; i++) {
        cards.pb(pow(2.0, 1.0*i));
        cards.pb(-pow(2.0, 1.0*i));
    }

    vector<int> cur;
    int _size_ = cards.size();

    top = 2*pow(2.0, 1.0*k);
    //cout << _size_ << ' ' << top << endl;

    /// --------- debug --------- ///
    //for (int i=0; i<cards.size(); i++)
    //    cout << cards[i] << ' ';
    //cout << endl;
    /// --------- debug --------- ///

    dp = new int*[_size_];
    for (int i=0; i<_size_; i++)
        dp[i] = new int[top + 1];

    /// ------------- ///
    int best = inf;
    vector<int> ans;
    /// ------------- ///

    int offset = pow(2.0, 1.0*k);
    mini = -pow(2.0, 1.0*k);
    maxi = pow(2.0, 1.0*k);

    for (int mask=0; mask<(1<<_size_); mask++) {
        cur.clear();
        for (int i=0; i<_size_; i++)
            for (int j=0; j<=top; j++)
                dp[i][j] = 0;

        for (int j=0; j<_size_; j++)
            if ((1<<j) & mask)
                cur.pb(cards[j]);

        dp[0][offset] = 1;
        if (!cur.empty())
            dp[0][cur[0]+offset] = 1;
        for (int i=1; i<cur.size(); i++) {
            for (int j=mini; j<=maxi; j++) {
                if (dp[i-1][j+offset])
                    dp[i][j+offset] = 1;

                if (j-cur[i] >= mini && j-cur[i] <= maxi)
                    if (dp[i-1][(j+offset)-cur[i]])
                        dp[i][j+offset] = 1;
            }
        }

        bool ok = 1;
        if (cur.size()==0) {
            for (int i=0; i<n; i++) {
                if (input[i]!=0) {
                    ok = 0;
                    break;
                }
            }
        } else {
            for (int i=0; i<n; i++) {
                if (!dp[cur.size()-1][input[i]+offset]) {
                    ok = 0;
                    break;
                }
            }
        }

        if (ok && cur.size() < best) {
            best = cur.size();
            ans = cur;
        }
    }

    if (best == inf) { /// impossible case
        fout << -1;
        return 0;
    }

    fout << best << endl;
    for (int i=0; i<best; i++)
        fout << ans[i] << ' ';

    fin.close();
    fout.close();
    return 0;
}
