#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define sz(a) int(a.size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 2e5 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

int a[N], used[N], tin[N], fup[N], t, ans = INFINT, usedfup[N], cntfup[N], ansfup;
vector <int> gr[N], gr2[N];

void dfs(int u) {
 //   cout << "DFS: " << u << endl;
    used[u] = 1;
    tin[u] = t++;
    fup[u] = tin[u];
    for (auto v: gr[u]) {
        if (used[v] == 2) continue;
        if (used[v] == 0) dfs(v);
        fup[u] = min(fup[u], fup[v]);
    }
    used[u] = 2;
    ++cntfup[fup[u]];
    usedfup[fup[u]] = 1;
//    cout << "u: " << u << "fup: " << fup[u] << endl;
}

void dfs2(int u) {
    used[u] = 1;
    if (gr2[u].empty()) {
        if (ans > cntfup[u]) {
            ans = cntfup[u];
            ansfup = u;
        }
    }
    for (auto v: gr2[u]) {
        if (!used[v]) dfs2(v);
    }
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    forn(i, n) cin >> a[i];
    forn(i, m) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if ((a[x] + 1) % h == a[y]) {
            gr[x].push_back(y);
        }
        if ((a[y] + 1) % h == a[x]) {
            gr[y].push_back(x);
        }
    }

    forn(i, n) {
        if (!used[i]) {
            dfs(i);
        }
    }

    forn(u, t) {
        for (auto v: gr[u]) {
            if (fup[u] != fup[v]) {
                gr2[fup[u]].push_back(fup[v]);
            }
        }
    }

    fill(used, used + t, 0);
    forn(i, t) {
        if (!used[i] && usedfup[i]) dfs2(i);
    }
    cout << ans << endl;
    forn(i, n) {
        if (fup[i] == ansfup) cout << i + 1 << ' ';
    }
    cout << endl;
    return 0;
}
