#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define sz(a) int(a.size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int N = 2e5 + 9;
const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;

int a[N], used[N], tin[N], fup[N], t, ans = INFINT;
int clr[N], tclr = 1, cntclr[N], ansclr;
vector <int> gr[N], gr2[N];
map <int, int> mp;

void dfs(int u) {
 //   cout << "DFS: " << u << endl;
    used[u] = 1;
    tin[u] = t++;
    fup[u] = tin[u];
 //   cout << "T: " << t << endl;
    for (auto v: gr[u]) {
        if (used[v] == 2) continue;
        if (used[v] == 0) dfs(v);
        fup[u] = min(fup[u], fup[v]);
    }
    used[u] = 2;
 //   cout << "u: " << u << " fup: " << fup[u] << endl;
}

void dfs2(int u) {
    used[u] = 1;
    if (gr2[u].empty()) {
        if (ans > cntclr[u]) {
            ans = cntclr[u];
            ansclr = u;
        }
    }
    used[u] = 2;
    for (auto v: gr2[u]) {
        if (used[u] == 2) while (true) {};
        if (!used[v]) dfs2(v);
    }
    used[u] = 1;
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    forn(i, n) cin >> a[i];
    forn(i, m) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if ((a[x] + 1) % h == a[y]) {
            gr[x].push_back(y);
        }
        if ((a[y] + 1) % h == a[x]) {
            gr[y].push_back(x);
        }
    }
/*
    cout << "//////////" << endl;
    forn(i, n) {
        cout << i << ' ' << ": ";
        for (auto j: gr[i])
            cout << j << ' ';
        cout << endl;
    }
    cout << "/////////" << endl;
*/
    forn(i, n) {
        if (!used[i]) {
            dfs(i);
        }
    }

    forn(i, n) {
        if (mp[fup[i]] == 0) mp[fup[i]] = tclr++;
        clr[i] = mp[fup[i]];
        ++cntclr[clr[i]];
     //   cout << i << ' ' << clr[i] << endl;
    }

    forn(u, n) {
        for (auto v: gr[u]) {
         //   cout << "clr: " << ' ' << u << ' ' << v << endl;
            if (clr[u] != clr[v]) {
         //       cout << "DSFDSFDSFDSF" << endl;
                gr2[clr[u]].push_back(clr[v]);
            }
        }
    }
/*
    cout << "//////////" << endl;
    forn(i, tclr) {
        cout << i << ' ' << ": ";
        for (auto j: gr2[i])
            cout << j << ' ';
        cout << endl;
    }
    cout << "/////////" << endl;
*/

    fill(used, used + tclr, 0);
    for(int i = 1; i < tclr; ++i) {
        if (!used[i]) dfs2(i);
        if (gr2[i].empty()) {
            if (ans > cntclr[i]) {
                ans = cntclr[i];
                ansclr = i;
            }
        }
    }
    cout << ans << endl;
    forn(i, n) {
        if (clr[i] == ansclr) cout << i + 1 << ' ';
    }
    cout << endl;
    return 0;
}
