#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <ctime>
#include <string>
#include <cmath>
#include <algorithm>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cerr << #x << ": " << (x) << '\n'

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::srand(std::time(NULL));
	std::string s;
	std::cin >> s;
	std::set<int>zero, one;
	FOR(i, s.size()) {
		if (s[i] == '0') {
			zero.insert(i);
		} else {
			one.insert(i);
		}
	}
	std::vector<std::vector<int>>answ(s.size());
	ll all = 0;
	int i = 0;
	while (!zero.empty()) {
		int cur = 0;
		int j = 0;
		while (true) {
			if (j % 2 == 0) {
				auto it = zero.lower_bound(cur);
				if (it == zero.end()) {
					std::cout << -1;
					return 0;
				}
				cur = *it;
				zero.erase(it);
				answ[i].push_back(cur);
			} else {
				auto it = one.lower_bound(cur);
				if (it == one.end()) {
					break;
				}
				cur = *it;
				one.erase(it);
				answ[i].push_back(cur);
			}
			++j;
		}
		++i;
	}
	std::cout << i << '\n';
	FOR(j, answ.size()) {
		if (answ[j].size() > 0) {
			std::cout << answ[j].size() << ' ';
			FOR(q, answ[j].size())
				std::cout << answ[j][q] + 1 << ' ';
			std::cout << '\n';
		}
	}
	return 0;
}