#include <iostream>
#include <string>
#include <map>
#include <set>
#include <vector>

#define FOR(i, n) for(int i = 0; i < n; i++)
#define mk(a, b) make_pair(a, b)
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

set<int> gr[100000];
int hplane[100000];
int vis[100000];
int col = 1;
bool wr = false;
int dfs(int u){
	if (vis[u] == col)
		return 0;
	vis[u] = col;
	int ans = 1;
	if (wr)
		cout << u + 1 << " ";
	for (int v : gr[u]){
		ans += dfs(v);
	}
	return ans;
}
int main(){
	int n, m, h;
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++)
		cin >> hplane[i];
	for (int i = 0; i < m; i++){
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if (hplane[u] == (hplane[v] + 1) % h){
			gr[v].insert(u);
		}
		if (hplane[v] == (hplane[u] + 1) % h){
			gr[u].insert(v);
		}
	}
	int mins = 10000000;
	int ver = 0;
	FOR(i, n){
		int as = dfs(i);
		if (as < mins){
			mins = as;
			ver = i;
		}
		col++;
	}
	wr = true;
	cout << mins << "\n";
	dfs(ver);
	return 0;
}
