#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 200001;

int n, m, h, x, y;

int t[MAXN];

bool u[MAXN];

vector <int> g[MAXN];

int ba = MAXN, bv = -1;

vector <int> ans;

int dfs(int s){
    int cr = 1;
    u[s] = 1;
    for (int i = 0; i < g[s].size(); i++){
        int to = g[s][i];
        if (!u[to]){
            cr += dfs(to);
        }
    }
    return cr;
}

void out(int s){
    u[s] = 1;
    ans.push_back(s);
    for (int i = 0; i < g[s].size(); i++){
        int to = g[s][i];
        if (!u[to]){
            out(to);
        }
    }
}

int main() {
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++){
        cin >> t[i];
    }
    for (int i = 1; i <= m; i++){
        cin >> x >> y;
        if (((t[x] + 1) % h) == t[y]){
            g[x].push_back(y);
        }
        if (((t[y] + 1) % h) == t[x]){
            g[y].push_back(x);
        }
    }
    for (int i = 1; i <= n; i++){
        if (g[i].size() == 0){
            cout << 1 << endl << i;
            return 0;
        }
    }
    /*for (int i = 1; i <= n; i++){
        cout << g[i].size() << ' ';
        for (int j = 0; j < g[i].size(); j++){
            cout << g[i][j] << ' ';
        }
        cout << endl;
    }*/
    for (int i = 1; i <= n; i++){
        if (!u[i]) {
            int cr = dfs(i);
            if (cr < ba) {
                ba = cr;
                bv = i;
            }
        }
    }
    for (int j = 1; j <= n; j++){
        u[j] = 0;
    }
    out(bv);
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++){
        cout << ans[i] << ' ';
    }
    return 0;
}