#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast", "no-stack-protector")
//#pragma GCC target("sse", "sse2", "sse3", "sse4", "abm", "popcnt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define _ inline
#define f first
#define sec second
#define pb push_back
#define ins insert
#define ers erase
#define mk make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define rsz resize
#define forn(i, n) for (int i(1); i <= n; i++)
#define fore(i, n) for (int i(0); i < n; i++)
//#define int ll

#define prev prevv
#define next nextt
#define left leftt
#define right rightt

mt19937 Random(int(time(0)));

const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const int P = 239017;
const ll BINF = 1e18 + 10;
const ld EPS = 1e-9;

const int N = 1e5 + 10;

vector<vector<int> > g, rev_g;
vector<int> arr;
bool used[N];
int comp[N], sz[N];

void dfs1(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) dfs1(u);
    }
    arr.pb(v);
}

void dfs2(int v, int color) {
    comp[v] = color;
    sz[color]++;
    for (auto u : rev_g[v]) {
        if (!comp[u]) dfs2(u, color);
    }
}

_ void source() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t(n + 1);
    g.rsz(n + 1);
    rev_g.rsz(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> t[i];
    }
    for (int i = 1; i <= m; i++) {
        int a, b;
        cin >> a >> b;
        if (((t[a] + 1) % h) == t[b]) {
            g[a].pb(b);
            rev_g[b].pb(a);
        }
        if (((t[b] + 1) % h) == t[a]) {
            g[b].pb(a);
            rev_g[a].pb(b);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(all(arr));
    int cnt = 0;
    for (auto it : arr) {
        if (!comp[it]) {
            cnt++;
            dfs2(it, cnt);
        }
    }
    pair<int, int> ans = {INF, INF};
    vector<bool> tt(cnt + 1, true);
    for (int i = 1; i <= n; i++) {
        for (auto u : g[i]) {
            if (comp[u] != comp[i]) {
                tt[comp[i]] = false;
            }
        }
    }
    for (int i = 1; i <= cnt; i++) {
        if (tt[comp[i]]) {
            ans = min(ans, mk(sz[i], i));
        }
    }
    cout << ans.f << endl;
    for (int i = 1; i <= n; i++) {
        if (comp[i] == ans.sec) {
            cout << i << ' ';
        }
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    source();
    return 0;
}
