#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int n, m, h;
vector<int> upd;
vector<vector<int>> gr;
vector<int> topsort;
vector<bool> was;
int t;
int cnt = 0;

void dfs(int v)
{
    was[v] = 1;
    for(int u: gr[v])
        if(!was[u])
            dfs(u);
    topsort[t] = v;
    t--;
}

void dfs1(int v)
{
    was[v] = 1;
    cnt++;
    for(int u: gr[v])
        if(!was[u])
            dfs1(u);
}

int main()
{
/*    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
    cin >> n >> m >> h;
    t = n - 1;
    gr.resize(n, vector<int>(0));
    upd.resize(n);
    topsort.resize(n);
    was.resize(n, 0);
    for(int i = 0; i < n; i++)
        cin >> upd[i];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        if(((upd[a - 1] + 1) % h) == upd[b - 1])
        {

            gr[a - 1].push_back(b - 1);
        }
        if(((upd[b - 1] + 1) % h) == upd[a - 1]);
        {

            gr[b - 1].push_back(a - 1);
        }
    }
    for(int i = 0; i < n; i++)
        if(!was[i])
            dfs(i);
    for(int i = 0; i < n; i++)
        was[i] = 0;
    dfs1(topsort[n - 1]);
    cout << cnt << '\n';
    for(int i = 0; i < n; i++)
    {
        if(was[i])
            cout << i + 1 << ' ';
    }
    return 0;
}
/*3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3

*/
