#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

#define pii pair<int, int>
#define f first
#define s second

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    int count = 0;
    for(char c: s)
    {
        if(c == '1')
            count--;
        else
            count++;
        if(count < 0)
        {
            cout << -1;
            return 0;
        }
    }
    reverse(s.begin(), s.end());
    count = 0;
    for(char c: s)
    {
        if(c == '1')
            count--;
        else
            count++;
        if(count < 0)
        {
            cout << -1;
            return 0;
        }
    }
    reverse(s.begin(), s.end());
    set<int> b;
    for(int i = 0; i < s.size(); i++)
        if(s[i] == '1')
            b.insert(i);
    if(!b.size())
    {
        cout << s.size() << '\n';
        for(int i = 0; i < s.size(); i++)
            cout << 1 << " " << i + 1 << '\n';
        return 0;
    }
    vector<pair<int, pii>> c(0);
    vector<bool> was(s.size(), 0);
    auto p = b.begin(), l = b.end();
    auto lnext = l;
    --l;
    int x = 0, y = s.size() - 1;
    while(p != lnext)
    {
        while(s[x] != '0')
            x++;
        while(s[y] != '0')
            y--;
        was[x] = was[y] = 1;
        if(*p - x < y - *l)
        {
            c.push_back({x + 1, {*p + 1, y + 1}});
            was[*p] = 1;
            ++p;
        }
        else
        {
            c.push_back({x + 1, {*l + 1, y + 1}});
            was[*l] = 1;
            --l;
            --lnext;

        }
        x++;
        y--;
    }
    cout << c.size() + (s.size() - c.size() * 3) << '\n';
    for(int i = 0; i < c.size(); i++)
        cout << "3 " << c[i].f << " " << c[i].s.f << " " << c[i].s.s << '\n';
    for(int i = 0; i < s.size(); i++)
        if(!was[i])
            cout << "1 " << i + 1 << '\n';
    return 0;
}
