#include <bits/stdc++.h>

#define pb push_back
#define pp pop_back
#define sz(x) x.size()
#define all(x) x.begin(), x.end()
#define per(i, a, b) for(int i = a; i <= b; ++i)
#define rep(i, a, b) for(int i = a; i >= b; --i)
#define F first
#define S second
#define mp make_pair
#define FL v + v, tl, tm
#define FR v + v + 1, tm + 1, tr

using namespace std;

template <typename T> T sqr (T a) {return a * a;}
template <typename T> 
void parr (T *a, int start, int end, bool error = 0) {
	if (error) {
		per (i, start, end)
			cerr << a[i] << ' ';
		cerr << endl;
	}
	else {
		per (i, start, end) 
			cout << a[i] << ' ';
		cout << endl;
	}
}
template <typename T> void view(T var) {cerr << " ---> " << var << " <--- " << endl;}
template <typename T> T bpow(T a, int power) {
	T res = 1;
	while (power) {
		if (power & 1) res = (res * a);
		a = (a * a);
		power >>= 1;
	}
	return res;
}
void setpr(int a) {
	cout.fixed;
	cout.precision(a);
	cerr.fixed;
	cerr.precision(a);
}

typedef long long ll;
typedef unsigned long long ull;

typedef pair< int, int > pii;
                                 
const int N = (int)1e5 + 10;
const int inf = (int)1e9;
const ll INF = (ll)1e18;
const long double pi = acos(-1.0);
const double eps = 1e-7;

int n, m, h, ans = inf, st;
int a[N], c[N], cur, dep[N];

bool us[N];

vector < int > g[N];

void dfs(int v, int col, int d = 0) {
	us[v] = 1;
	c[v] = col;
	dep[v] = d;
	for (auto u : g[v]) {
		if (!us[u])
			dfs(u, col, d + 1);
		else if (c[v] == c[u]) {
			if (abs(dep[v] - dep[u]) + 1 < ans) {
				st = u;
				ans = abs(dep[v] - dep[u]) + 1;
			}
		}
	}
}

void dfs1(int v) {
	us[v] = 1;
	cout << v << ' ';
	for (auto u : g[v]) {
		if (!us[u])
			dfs1(u);
	}
}


int main() {
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
	cin >> n >> m >> h;
	per (i, 1, n)
		cin >> a[i];
	per (i, 1, m) {
		int c1, c2;
		cin >> c1 >> c2;
		if (a[c2] == (a[c1] + 1) % h) g[c1].pb(c2);
		if (a[c1] == (a[c2] + 1) % h) g[c2].pb(c1);
	}	
	for (int i = 1; i <= n; ++i) { 
		if (g[i].empty())
			cout << 1 << endl << i, exit(0);
	}
	for (int i = 1; i <= n; ++i) {             
		if (!us[i]) {
			cur = 0;
			dfs(i, i);
		}
	}
	memset(us, 0, sizeof us);
	cout << ans << endl;
	dfs1(st);
}