#include <iostream>
#include <vector>

using namespace std;

int cnt = 1e9;
vector <int> ans;

void backtrack(int k, int res, vector <int> &A)
{
    if (k == 14)
    {
        if (res == 0 && A.size() < cnt)
        {
            ans = A;
        }
        return;
    }
    A.push_back(k + 1);
    backtrack(k + 1, res + (1 << k), A);
    A.back() = -k - 1;
    backtrack(k + 1, res - (1 << k), A);
    A.pop_back();
    backtrack(k + 1, res, A);
}

int main()
{
    int n;
    cin >> n;
    vector <int> A(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i];
    }
    if (n == 1)
    {
        vector <int> B;
        backtrack(0, A[0], B);
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
    {
        int a;
        if (ans[i] < 0)
        {
            a = (1 << (-ans[i] - 1));
        }
        else
        {
            a = -(1 << (ans[i] - 1));
        }
        cout << a << " ";
    }
    cout << endl;
}