#include <iostream>

using namespace std;

int find_min(int m1, int m2)
{
    int cnt1 = 0, cnt2 = 0;

    for (int i = 0; i < 14; i++)
    {
        if ((m1 & (1 << i)) != 0)
            cnt1++;
        if ((m2 & (1 << i)) != 0)
            cnt2++;
    }
    if (cnt1 > cnt2)
        return m2;
    else
        return m1;
}

void print_mask(int m)
{
    int cnt = 0;
    
    for (int i = 0; i < 14; i++)
        if ((m & (1 << i)) != 0)
            cnt++;
    cout << cnt << endl;
    for (int i = 0; i < 7; i++)
        if ((m & (1 << i)) != 0)
            cout << -(1 << i) << ' ';
    for (int i = 7; i < 14; i++)
        if ((m & (1 << i)) != 0)
            cout << (1 << (i - 7)) << ' ';
    cout << endl;
}

bool check_mask(int m1, int m2)
{
    for (int i = 0; i < 14; i++)
        if ((m2 & (1 << i)) != 0)
            if ((m1 & (1 << i)) == 0)
                return 0;
    return 1;
}

int main()
{
    static int n, curr, cnt = 0, pos[50], mask[50][256], arr[50], sum, min_ans = (1 << 14) - 1;
    bool check, found;

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < (1 << 14); j++)
        {
            sum = 0;
            for (int k = 0; k < 7; k++)
                if ((j & (1 << k)) != 0)
                    sum -= (1 << k);
            for (int k = 7; k < 14; k++)
                if ((j & (1 << k)) != 0)
                    sum += (1 << (k - 7));
            if (sum == arr[i])
            {
                mask[i][pos[i]] = j;
                pos[i]++;
            }
        }
    }
    //cout << endl << endl;
    //for (int i = 0; i < n; i++)
    //    cout << pos[i] << ' ';
    //cout << endl << endl;
    for (int i = 0; i < (1 << 14); i++)
    {
        check = 1;
        for (int j = 0; j < n; j++)
        {
            found = 0;
            for (int k = 0; k < pos[j]; k++)
                if (check_mask(i, mask[j][k]))
                {
                    found = 1;
                    break;
                }
            if (!found)
            {
                check = 0;
                break;
            }
        }
        if (check)
            min_ans = find_min(min_ans, i);
    }
    //cout << min_ans << endl;
    print_mask(min_ans);
    /*cout << endl;
    for (int j = 0; j < n; j++)
    {
        for (int k = 0; k < pos[j]; k++)
            if (check_mask(min_ans, mask[j][k]))
            {
                cout << j << ' ' << k << ' ' << mask[j][k] << endl;
                cout << endl;
                break;
            }
    }*/
    //cin >> n;
}