#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair
#define endl '\n'
#define data q_wqekjasd

#ifndef LOCAL
    #define cerr if(0)cerr
#endif // LOCAL

typedef long long ll;
typedef long double ld;

random_device rd;
mt19937_64 rnd(rd());

struct data {
    int n, m, h;
    vector < int > a;
    vector < pair < int, int > > b;
};

istream &operator >> (istream &IN, data &d) {
    IN >> d.n >> d.m >> d.h;
    d.a.assign(d.n, 0);
    d.b.assign(d.m, {0, 0});
    for (int i = 0; i < d.n; i++) IN >> d.a[i];
    for (int i = 0; i < d.m; i++) IN >> d.b[i].ff >> d.b[i].ss;
    return IN;
}

ostream &operator << (ostream &OUT, data &d) {
    OUT << d.n << ' ' << d.m << ' ' << d.h << endl;
    for (int i = 0; i < d.n; i++) OUT << d.a[i] << ' ';
    OUT << endl;
    for (int i = 0; i < d.m; i++) OUT << d.b[i].ff << ' ' << d.b[i].ss << endl;
    return OUT;
}

struct answer {
    int n;
    vector < int > a;
};

ostream &operator << (ostream &OUT, const answer &ans) {
    OUT << ans.n << endl;
    for (int i = 0; i < ans.n; i++) OUT << ans.a[i] << ' ';
    return OUT;
}

bool compare (data &d, const answer &a, const answer &b) {
    if (a.n != b.n) return 0;
    for (int i = 0; i < a.n; i++) {
        if (a.a[i] <= 0 || a.a[i] > d.n) return 0;
    }
    for (int i = 0; i < b.n; i++) {
        if (b.a[i] <= 0 || b.a[i] > d.n) return 0;
    }
    return a.n == b.n;
}

const int N = 100001;
vector<int> g[N], gr[N], g2[N];

void dfsOrder(int v, vector<int> &order, vector<bool> &used) {
    used[v] = 1;
    for (int to : g[v]) {
        if (used[to]) continue;
        dfsOrder(to, order, used);
    }
    order.p_b(v);
}

void dfsStrong(int v, vector<int> &strong, vector<int> &cntStrong, vector<bool> &used, int &curStrong) {
    strong[v] = curStrong;
    cntStrong[curStrong]++;
    used[v] = 1;
    for (int to : gr[v]) {
        if (used[to]) continue;
        dfsStrong(to, strong, cntStrong, used, curStrong);
    }
}

void calc(int v, vector<int> &under, vector<int> &cntStrong) {
    under[v] = cntStrong[v];
    for (int to : g2[v]) {
        if (under[to] == -1) calc(to, under, cntStrong);
        under[v] += under[to];
    }
}

void rekt(int v, vector<bool> &used, answer &OUTPUT) {
    used[v] = 1;
    OUTPUT.a.p_b(v + 1);
    for (int to : g[v]) {
        if (used[to]) continue;
        rekt(to, used, OUTPUT);
    }
}

answer solve (data &INPUT) {
    answer OUTPUT;
    int n = INPUT.n, m = INPUT.m, h = INPUT.h;
    for (int i = 0; i < n; i++) {
        g[i].clear();
        gr[i].clear();
        g2[i].clear();
    }
    vector<int> a = INPUT.a;
    set < pair < int, int > > was;
    for (int i = 0; i < m; i++) {
        int x = INPUT.b[i].ff, y = INPUT.b[i].ss;
        x--, y--;
        if (x > y) swap(x, y);
        if (was.count({x, y})) continue;
        was.insert({x, y});
        gr[x].p_b(y);
        gr[y].p_b(x);
    }
    for (int i = 0; i < n; i++) {
        for (int to : gr[i]) {
            if ((a[i] + 1) % h == a[to]) g[i].p_b(to);
        }
    }
    for (int i = 0; i < n; i++) gr[i].clear();
    for (int i = 0; i < n; i++) {
        for (int to : g[i]) gr[to].p_b(i);
    }
    vector < int > order;
    vector < bool > used(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        dfsOrder(i, order, used);
    }
    reverse(order.begin(), order.end());
    vector < int > strong(n, 0), cntStrong(n, 0);
    used.assign(n, 0);
    int curStrong = 0;
    for (int v : order) {
        if (used[v]) continue;
        dfsStrong(v, strong, cntStrong, used, curStrong);
        curStrong++;
    }
    set < pair < int, int > > was2;
    for (int i = 0; i < n; i++) {
        for (int to : g[i]) {
            int x = strong[i];
            int y = strong[to];
            if (x > y) swap(x, y);
            if (x == y || was2.count({x, y})) continue;
            was2.insert({x, y});
            g2[x].p_b(y);
        }
    }
    vector<int> p(curStrong);
    for (int i = 0; i < curStrong; i++) p[i] = i;
    random_shuffle(p.begin(), p.end());
    vector<int> under(n, -1);
    for (int i = 0; i < curStrong; i++) {
        if (under[i] == -1) calc(i, under, cntStrong);
    }
    int ans = INT_MAX;
    int ansi;
    for (int i = 0; i < n; i++) {
        if (under[strong[i]] < ans) {
            ans = under[strong[i]];
            ansi = i;
        }
    }
    OUTPUT.n = ans;
    used.assign(n, 0);
    rekt(ansi, used, OUTPUT);
    if (ans != int(OUTPUT.a.size())) {
       // if (ans < -1) exit(1);
    }
    return OUTPUT;
}

vector < int > brute_g[100001], brute_gr[100001];
int brute_run = 2;
int brute_lastRun[100001];
int brute_a[100001];

int brute_kek(int v, bool print, answer &OUTPUT) {
    brute_run++;
    queue < int > q;
    int cnt = 0;
    q.push(v);
    brute_lastRun[v] = brute_run;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        cnt++;
        if (print) OUTPUT.a.p_b(x + 1);
        for (int to : brute_g[x]) {
            if (brute_lastRun[to] == brute_run) continue;
            brute_lastRun[to] = brute_run;
            q.push(to);
        }
    }
    return cnt;
}

bool da;
char aa[100001];

void cycle(int v) {
    aa[v] = 1;
    for (int to : brute_g[v]) {
        if (aa[to] == 0) cycle(to);
        else if (aa[to] == 1) da = 1;
    }
    aa[v] = 2;
}

answer brute (data &INPUT) {
    answer OUTPUT;
    int n = INPUT.n, m = INPUT.m, h = INPUT.h;
    for (int i = 0; i < n; i++) {
        brute_g[i].clear();
        brute_gr[i].clear();
        brute_a[i] = INPUT.a[i];
    }
    set < pair < int, int > > was;
    for (int i = 0; i < m; i++) {
        int x = INPUT.b[i].ff, y = INPUT.b[i].ss;
        x--, y--;
        if (x > y) swap(x, y);
        if (was.count({x, y})) continue;
        was.insert({x, y});
        brute_gr[x].p_b(y);
        brute_gr[y].p_b(x);
    }
    for (int i = 0; i < n; i++) {
        for (int to : brute_gr[i]) {
            if ((brute_a[i] + 1) % h == brute_a[to]) brute_g[i].p_b(to);
        }
    }
    int ans = INT_MAX;
    int ansi;
    for (int i = 0; i < n; i++) {
        int _now = brute_kek(i, 0, OUTPUT);
        if (_now < ans) {
            ans = _now;
            ansi = i;
        }
    }
    OUTPUT.n = ans;
    brute_kek(ansi, 1, OUTPUT);
    for (int i = 0; i < n; i++) aa[i] = 0;
    da = 0;
    for (int i = 0; i < n; i++) {
        if (aa[i]) continue;
        cycle(i);
    }
    if (da) while(1.0 * clock() / CLOCKS_PER_SEC < 0.91) {}
//    if (ans == 1) {
//        do {
//
//        }while(1.0 * clock() / CLOCKS_PER_SEC < 0.92);
//    }
    return OUTPUT;
}


data gen() {
    data d;
    d.n = rnd() % 100 + 500;
    d.m = rnd() % 2 + 2;
    d.h = rnd() % 5 + 2;
    if (rnd() & 1) d.h = rnd() % 10 + 2;
    d.a.assign(d.n, 0);
    d.b.assign(d.m, {0, 0});
    for (int i = 0; i < d.n; i++) d.a[i] = rnd() % d.h;
    for (int i = 0; i < d.m; i++) {
        int x = rnd() % d.n;
        int y = rnd() % d.n;
        if (x == y) y = (y + 1) % d.n;
        d.b[i] = {x + 1, y + 1};
    }
    return d;
}

void stress() {
    static int test = 0;
    data d;
    do {
        test++;
        cerr << "Testing on test " << test << endl;
        d = gen();
    }while(compare(d, solve(d), brute(d)));
    ofstream A("input.txt");
    A << d << "\nsolve:\n" << solve(d) << "\nbrute:\n" << brute(d) << endl;
    A.close();
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    //stress();
    data d;
    cin >> d;
    cout << brute(d);
}
