#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair

typedef long long ll;
typedef long double ld;

random_device rd;
mt19937_64 rnd(rd());

const int N = 100001;
int a[N + 10], strong[N + 10], cntStrong[N + 10], curStrong, under[N + 10];
vector < int > order;
vector < int > g[N + 10], gr[N + 10], g1[N + 10], g2[N + 10];
char used[N + 10];
int MYN;

void dfsOrder(int v) {
    used[v] = 1;
    for (int to : g[v]) {
        if (used[to]) continue;
        dfsOrder(to);
    }
    order.p_b(v);
}

void dfsStrong(int v) {
    strong[v] = curStrong;
    cntStrong[curStrong]++;
    used[v] = 1;
    for (int to : gr[v]) {
        if (used[to]) continue;
        dfsStrong(to);
    }
}

void calc(int v) {
    under[v] = cntStrong[v];
    for (int to : g2[v]) {
        if (under[to] == -1) calc(to);
        under[v] += under[to];
        if (under[to] < -1) {
            if (curStrong == 500 && MYN == 500) exit(1);
        }
    }
}

void go(int v) {
    cout << v + 1 << ' ';
    used[v] = 1;
    for (int to : g[v]) {
        if (used[to]) continue;
        go(to);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, h;
    cin >> n >> m >> h;
    MYN = n;
    for (int i = 0; i < n; i++) cin >> a[i];
    set < pair < int, int > > was;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        if (x > y) swap(x, y);
        if (was.count({x, y})) continue;
        was.insert({x, y});
        g1[x].p_b(y);
        g1[y].p_b(x);
    }
    for (int i = 0; i < n; i++) {
        for (int to : g1[i]) {
            if ((a[i] + 1) % h == a[to]) g[i].p_b(to);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int to : g[i]) gr[to].p_b(i);
    }
    for (int i = 0; i < n; i++) used[i] = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        dfsOrder(i);
    }
    reverse(order.begin(), order.end());
    for (int i = 0; i < n; i++) used[i] = 0;
    curStrong = 0;
    for (int v : order) {
        if (used[v]) continue;
        dfsStrong(v);
        curStrong++;
    }
    set < pair < int, int > > was2;
    for (int i = 0; i < n; i++) {
        for (int to : g[i]) {
            int x = strong[i];
            int y = strong[to];
            if (x == y || was2.count({min(x, y), max(x, y)})) continue;
            was2.insert({min(x, y), max(x, y)});
            g2[x].p_b(y);
        }
    }
//    vector<int> p(curStrong);
//    for (int i = 0; i < curStrong; i++) {
//        p[i] = i;
//        under[i] = -1;
//    }
//    random_shuffle(p.begin(), p.end());
//    for (int v : p) {
    for (int i = 0; i < curStrong; i++) under[i] = -1;
    for (int v = 0; v < curStrong; v++) {
        if (under[v] != -1) continue;
        if (under[v] < -1) exit(1);
        calc(v);
    }
    int ans = INT_MAX / 10;
    int ansi;
    for (int i = 0; i < n; i++) {
        if (under[strong[i]] < ans) {
            ans = under[strong[i]];
            ansi = i;
        }
    }
    cout << ans << endl;
    for (int i = 0; i < n; i++) used[i] = 0;
    go(ansi);
}
