// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

void run()
{
	string s;
	cin >> s;
	vector<int> cnt(2, 0);
	for (auto &x : s)
		++cnt[x - '0'];
	if (cnt[0] <= cnt[1])
	{
		cout << -1 << endl;
		return;
	}
	int k = cnt[0] - cnt[1];
	vector<vector<int>> ans(k);
	vector<set<int>> ends(2);
	for (int i = 0; i < k; ++i)
		ends[1].insert(i);
	int i = 0;
	for (auto &x : s)
	{
		int m = (x - '0' + 1) % 2;
		if (!len(ends[m]))
		{
			cout << -1 << endl;
			return;
		}
		int g = *(ends[m].begin());
		ends[m].erase(g);
		ends[(m + 1) & 1].insert(g);
		ans[g].pb(i);
		++i;
	}
	cout << k << endl;
	for (auto &x : ans)
	{
		cout << len(x) << " ";
		for (auto &y : x)
			cout << y + 1 << " ";
		cout << endl;
	}
}