#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int solve();

int main() {
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // home
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
vector<vector<int> > g;

const ll INF = (ll)1e18 + 1;

int used[100005];
ll ans[100005];
ll curans = 0;

int cc = 0;
void dfs(int v) {
    used[v] = cc;
    curans++;
    for (auto to : g[v]) {
        if (used[to] != cc) dfs(to);
    }
}

void go(int v) {
    cout << v << ' ';
    used[v] = cc;
    for (auto to : g[v]) {
        if (used[to] != cc) go(to);
    }
}

int t[100005];

int solve() {
    int n, m, h; cin >> n >> m >> h;

    g.resize(n + 1);

    for (int i = 1; i <= n; i++) cin >> t[i];

    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        if ((t[a] + 1) % h == t[b]) g[a].push_back(b);//, cout << a << ' ' << b << endl;
        if ((t[b] + 1) % h == t[a]) g[b].push_back(a);//, cout << b <<  ' ' << a << endl;
        //cout << endl;
    }

   // return 0;

    ll A = n + 1;
    ans[n + 1] = INF;

    for (int i = 1; i <= n; i++) {
        cc++; curans = 0;
        dfs(i);
        ans[i] = curans;
        if (ans[i] < ans[A]) A = i;
    }

    cc++;
    cout << ans[A] << endl;
    go(A);
    return 0;
}



