#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

const int MAXN = (int)1e5 + 10;

vector<int> g[MAXN];
vector<int> gr[MAXN];
int used[MAXN];
int u[MAXN];
int comp[MAXN];
int sz[MAXN];
bool pos[MAXN];
vector<int> order;
vector<int> cur;
vector<int> ans;
int cnt = 0;

void top_sort(int v)
{
    used[v] = 1;
    for (int i = 0; i < (int)g[v].size(); i++)
        if (!used[g[v][i]])
            top_sort(g[v][i]);
    order.pb(v);
}

void dfs(int v)
{
    sz[cnt]++;
    used[v] = 1;
    comp[v] = cnt;
    for (int i = 0; i < (int)gr[v].size(); i++)
        if (!used[gr[v][i]])
            dfs(gr[v][i]);
}

int solve()
{
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        if ((u[x] + 1) % h == u[y])
        {
            g[x].pb(y);
            gr[y].pb(x);
        }
        if ((u[y] + 1) % h == u[x])
        {
            g[y].pb(x);
            gr[x].pb(y);
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (g[i].empty())
        {
            cout << 1 << endl;
            cout << i << endl;
            return 0;
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (!used[i])
        {
            top_sort(i);
        }
    }
    reverse(order.rbegin(), order.rend());
    memset(used, 0, sizeof(used));
    int ANS = n + 10;
    for (int i = 0; i < n; i++)
    {
        int v = order[i];
        if (!used[v])
        {
            cnt++;
            pos[cnt] = 1;
            dfs(v);
        }
    }
    for (int i = 1; i <= n; i++)
        for (int j = 0; j < (int)g[i].size(); j++)
        {
            if (comp[i] != comp[g[i][j]])
                pos[comp[i]] = 0;
        }
    int need = 1;
    for (int i = 1; i <= cnt; i++)
        if (pos[i] && sz[i] < ANS)
        {
            ANS = sz[i];
            need = i;
        }
    cout << ANS << endl;
    for (int i = 1; i <= n; i++)
        if (comp[i] == need)
            cout << i << " ";
}

