// t1.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <string>
#include <queue>

using namespace std;


int main()
{
	long long n;
	string s;
	cin >> s;
	n = s.size();
	bool flag = 0;
	long long ctd = 0;
	vector<bool> used(s.size(), 0);
	queue<pair<long long, long long> > q;
	for (long long i = 0; i < n; i++)
	{
		q.push({ s[i] - '0', i + 1 });
	}
	vector<vector<long long> > answ;
	while (!q.empty())
	{
		long long sz = q.size();
		bool need = 0;
		long long cnt = 0;
		for (long long i = 0; i < sz; i++)
		{
			if (q.front().first == need)
			{
				need = !need;
				cnt++;
			}
			q.push(q.front());
			q.pop();
		}
		if (cnt == 0)
		{
			flag = 1;
			break;
		}
		if (!need)
			cnt--;
		answ.push_back(vector<long long>());
		need = 0;
		for (long long i = 0; i < sz; i++)
		{
			if (cnt == 0)
			{
				q.push(q.front());
				q.pop();
				continue;
			}
			if (q.front().first == need)
			{
				need = !need;
				cnt--;
				answ.back().push_back(q.front().second);
			}
			else
			{
				q.push(q.front());
			}
			q.pop();
		}
	}
	if (flag)
		cout << -1;
	else
	{
		cout << answ.size() << endl;
		for (auto &x : answ)
		{
			cout << x.size() << " ";
			for (auto &y : x)
				cout << y << " ";
			cout << endl;
		}
	}
	cin >> n;
    return 0;
}

