#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define null NULL
#define ld long double
#define left left228
#define right right228
#define index index228
#define prev prev228


const int N = 228228;


template<typename T> inline void chkmin(T &x, T y) {
	if (y < x) x = y;
}

template<typename T> inline void chkmax(T &x, T y) {
	if (y > x) x = y;
}



bool used[N];


struct bl
{
    int number;
	int color;
	int cnt;
	int firind;
	bl() {}
	bl(int _cnt, int _color, int _number, int _firind) {
		cnt = _cnt;
		color = _color;
		number = _number;
		firind = _firind;
	}
};


bool operator<(bl a, bl b) {
    return a.number < b.number;
}


struct node
{
	int sum;
	int l, r;
	node() {
		sum = l = r = 0;
	}
};


struct Segment_Tree
{
	vector<node> d;

	Segment_Tree(int _n) {
		int sz = 1;
		while (sz < _n) sz <<= 1;
		sz <<= 1;
		d.resize(sz + 3, node());
	}


	void build(int l, int r, int v = 1) {
		d[v].l = l;
		d[v].r = r;
		if (l == r) return ;
		int m = (l + r) >> 1;
		build(l, m, v << 1);
		build(m + 1, r, v << 1 | 1);
	}


	void upd(int i, int x, int v = 1) {
		if (d[v].l == d[v].r) {
			d[v].sum = x;
		} else {
			int m = (d[v].l + d[v].r) >> 1;
			if (i <= m) {
				upd(i, x, v << 1);
			} else {
				upd(i, x, v << 1 | 1);
			}
			d[v].sum = d[v << 1].sum + d[v << 1 | 1].sum;
		}
	}


	int get(int l, int r, int v = 1) {
		if (l > r || d[v].l > r || d[v].r < l) return 0;
		if (l <= d[v].l && d[v].r <= r) {
			return d[v].sum;
		}
		return get(l, r, v << 1) + get(l, r, v << 1 | 1);
	}

	inline int fir1(int pos) {
	    if (get(pos, pos) == 1) return pos;
		int cur_sum = get(1, pos) + 1;
		int old = cur_sum;
		int v = 1;
		//cout << "needsum=" << cur_sum << "\n";
		while (d[v].l != d[v].r) {
			if (d[v << 1].sum >= cur_sum) {
				v <<= 1;
			} else {
			    cur_sum -= d[v << 1].sum;
				v = (v << 1 | 1);
			}
		}
		if (get(1, d[v].r) != old) return -1;
		return d[v].r;
	}
};





inline void solve() {
	string s;
	cin >> s;
	int n = (int)s.size();
	vector< vector<int> > res;
	Segment_Tree st1 = Segment_Tree(n + 1);
	st1.build(1, n);
	Segment_Tree st2 = Segment_Tree(n + 1);
	st2.build(1, n);
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0') {
			st2.upd(i + 1, 1);
		} else {
			st1.upd(i + 1, 1);
		}
	}
    int us = 0;
    // cout << "st1 : ";
    // for (int i = 1; i <= n;++i) {
    //     cout << st1.get(i, i) << " ";
    // }
    // cout << endl;
    while (us < n) {
        vector<int> cur;
        bool keked = false;
        int pos = st2.fir1(1);
        if (pos == -1) break;
        // cout << "posit=" << pos << endl;
        st1.upd(pos, 0);
        st2.upd(pos, 0);
        ++us;
        int pr = 0;
        cur.push_back(pos);
        while (1) {

        	if (pr == 0) {
        		pos = st1.fir1(pos);
        		//cout << "pr = 0 " << "pos=" << pos << " ";
        		if (pos == -1) break;
        		++us;
        		st1.upd(pos, 0);
        		st2.upd(pos, 0);
        		cur.push_back(pos);
        		pr = 1;
        	} else {
        		pos = st2.fir1(pos);
        		//cout << "pr=1 pos=" << pos << " ";
        		if (pos == -1) {
        			puts("-1");
        			return ;
        		}
        		++us;
        		st1.upd(pos, 0);
        		st2.upd(pos, 0);
        		cur.push_back(pos);
        		pr = 0;
        		//cout << "pos=" << pos << " ";
        	}
        }

        res.push_back(cur);

    }
    // cout << "KEK\n";
    if (us < n) {
        puts("-1");
        return ;
    }
    cout << (int)res.size() << endl;
    for (vector<int> v : res) {
        cout << (int)v.size() << " ";
        for (int i : v) {
            cout << i << " ";
        }
        cout << "\n";
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
