#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define x first
#define y second

vector<int> times;
vector<vector<int>> g;
vector<bool> used;
vector<int> vert;

void dfs(int v) {
    used[v] = true;
    vert.push_back(v);
    for(const int &to : g[v]) {
        //printf("v = %d to = %d\n", v, to);
        if(!used[to]) {
            dfs(to);
        }
    }
}

int main() {
    #ifdef local
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif
    int n, m, h;
    cin >> n >> m >> h;
    times.resize(n + 1);
    g.resize(n + 1);
    used.resize(n + 1);
    vector<pair<int, int>> mlist;
    for(int i = 1; i <= n; i++) {
        cin >> times[i];
    }
    for(int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        mlist.push_back({u, v});
        if(((times[v] + 1) % h) == times[u]) {
            g[v].push_back(u);
        }
        if(((times[u] + 1) % h) == times[v]) {
            g[u].push_back(v);
        }
    }
    int ans = 1e9;
    vector<int> vans;
    for(int v = 1; v <= n; v++) {
        used.assign(n + 1, false);
        vert.clear();
        dfs(v);
        sort(vert.begin(), vert.end());
        bool isGood = true;
        //printf("v = %d vert.sz = %d\n", v, (int)vert.size());
        /*
        for(int i = 0; i < (int)mlist.size(); i++) {
            auto it1 = lower_bound(vert.begin(), vert.end(), mlist[i].x);
            auto it2 = lower_bound(vert.begin(), vert.end(), mlist[i].y);

            if(it1 != vert.end() && it2 != vert.end()) {
                if((*it1) == mlist[i].x && (*it2) == mlist[i].y) {
                    //printf("IN: it1 = %d it2 = %d\n", *it1, *it2);
                    isGood = false;
                    break;
                }
            }
        }*/
        if(isGood && (int)vert.size() < ans) {
            ans = (int)vert.size();
            vans = vert;
        }
    }
    cout << ans << "\n";
    for(int i = 0; i < (int)vans.size(); i++) {
        cout << vans[i] << " ";
    }
    return 0;
}
