#include <bits/stdc++.h>
using namespace std;

typedef long long ll;


/*
int nullsPos = -1;
int onesPos = -1;

int getNullPos(string &s) {
    nullsPos++;
    for(; nullsPos < (int)s.size(); nullsPos++) {
        if(s[nullsPos] == '0') {
            return nullsPos;
        }
    }
    if(nullsPos >= (int)s.size()) {
        return -1;
    }
}

int getOnesPos() {
    onesPos++;
    for(; onesPos < (int)s.size(); onesPos++) {
        if(s[onesPos] == '1') {
            return onesPos;
        }
    }
    if(onesPos >= (int)s.size()) {
        return -1;
    }
}*/

int main() {
    #ifdef local
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif
    set<int> nulls, ones;
    string s;
    cin >> s;
    for(int i = 0; i < (int)s.size(); i++) {
        if(s[i] == '0') {
            nulls.insert(i);
        } else {
            ones.insert(i);
        }
    }
    vector<vector<int>> ans;
    while(true) {
        if(nulls.empty() && ones.empty()) {
            break;
        }
        if(nulls.empty() && !ones.empty()) {
            cout << -1;
            return 0;
        }
        vector<int> tmp;
        int nullPos = *nulls.begin();
        nulls.erase(nulls.begin());
        if(ones.empty()) {
            tmp.push_back(nullPos);
            ans.push_back(tmp);
            continue;
        }
        int onePos = *ones.begin();
        ones.erase(ones.begin());
        if(nullPos > onePos) {
            cout << -1;
            return 0;
        }
        tmp.push_back(nullPos);
        tmp.push_back(onePos);
        while(true) {
            auto it = nulls.upper_bound(onePos);
            if(it == nulls.end()) {
                cout << -1;
                return 0;
            }
            tmp.push_back(*it);
            nullPos = *it;
            nulls.erase(it);
            auto it2 = ones.upper_bound(nullPos);
            if(it2 == ones.end()) {
                break;
            }
            onePos = *it2;
            tmp.push_back(onePos);
            ones.erase(it2);
        }
        ans.push_back(tmp);
    }
    cout << (int)ans.size() << "\n";
    for(int i = 0; i < (int)ans.size(); i++) {
        cout << (int)ans[i].size() << " ";
        for(int val : ans[i]) {
            cout << val + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}
