#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define lp(i,s,e) for(int i = s;i<e;++i)
#define lpi(i,s,e) for(int i = s;i<=e;++i)
typedef pair<int,int> pii;
#define ff first
#define ss second
#define mp(a,b) make_pair(a,b)
#define pb(a) push_back(a)


struct node
{
    int val,y;
    int size;
    int sum;
    node *l,*r;
    node(int val):val(val),y(rand()),size(1),sum(val),l(0),r(0){};
};
typedef node* pnode;

int size(pnode cur)
{
    if(!cur) return 0;
    return cur->size;
}

int sum(pnode cur)
{
    if(!cur) return 0;
    return cur->sum;
}

void upd(pnode cur)
{
    if(!cur) return;
    cur->size = size(cur->l) + 1 + size(cur->r);
    cur->sum = sum(cur->l) + cur->val + sum(cur->r);
}

pnode merge(pnode l,pnode r)
{
    if(!l) return r;
    if(!r) return l;
    if(l->y>r->y){
        l->r = merge(l->r,r);
        upd(l);
        return l;
    }
    r->l = merge(l,r->l);
    upd(r);
    return r;
}

void split(pnode cur,int s,pnode& l,pnode& r)
{
    if(!cur){l = r = 0;return;}
    if(size(cur->l) >= s){
        r = cur;
        split(r->l,s,l,r->l);
        upd(l);
        upd(r);
    }else{
        s-=size(cur->l)+1;
        l = cur;
        split(l->r,s,l->r,r);
        upd(r);
        upd(l);
    }
}

void out(pnode cur)
{
    if(!cur) return;
    out(cur->l);
    cout<<cur->val<<' ';
    out(cur->r);
}

vector<vector<int> > g;
vector<bool> need;

int main()
{
    //freopen("input.txt","r",stdin);
    //cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> t(n);
    lp(i,0,n) cin>>t[i];
    g.resize(n);
    need.assign(n,true);
    lp(i,0,m){
        int x,y;
        cin>>x>>y;
        x--,y--;
        if( (t[x]+1)%h == t[y] ) g[x].pb(y);
        if( (t[y]+1)%h == t[x] ) g[y].pb(x);
    }
    bool flag = false;
    lp(i,0,n) if(!g[i].empty()) need[i] = false;else flag = true;
    if(flag){
        cout<<1<<'\n';
        lp(i,0,n) if(need[i]) return cout<<i+1,0;
    }
    cout<<n<<'\n';
    lp(i,0,n) cout<<i+1<<' ';
    return 0;
}
