#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define lp(i,s,e) for(int i = s;i<e;++i)
#define lpi(i,s,e) for(int i = s;i<=e;++i)
typedef pair<int,int> pii;
#define ff first
#define ss second
#define mp(a,b) make_pair(a,b)
#define pb(a) push_back(a)


struct node
{
    int val,y;
    int size;
    int sum;
    node *l,*r;
    node(int val):val(val),y(rand()),size(1),sum(val),l(0),r(0){};
};
typedef node* pnode;

int size(pnode cur)
{
    if(!cur) return 0;
    return cur->size;
}

int sum(pnode cur)
{
    if(!cur) return 0;
    return cur->sum;
}

void upd(pnode cur)
{
    if(!cur) return;
    cur->size = size(cur->l) + 1 + size(cur->r);
    cur->sum = sum(cur->l) + cur->val + sum(cur->r);
}

pnode merge(pnode l,pnode r)
{
    if(!l) return r;
    if(!r) return l;
    if(l->y>r->y){
        l->r = merge(l->r,r);
        upd(l);
        return l;
    }
    r->l = merge(l,r->l);
    upd(r);
    return r;
}

void split(pnode cur,int s,pnode& l,pnode& r)
{
    if(!cur){l = r = 0;return;}
    if(size(cur->l) >= s){
        r = cur;
        split(r->l,s,l,r->l);
        upd(l);
        upd(r);
    }else{
        s-=size(cur->l)+1;
        l = cur;
        split(l->r,s,l->r,r);
        upd(r);
        upd(l);
    }
}

void out(pnode cur)
{
    if(!cur) return;
    out(cur->l);
    cout<<cur->val<<' ';
    out(cur->r);
}

vector<int> fup;
vector<int> tin;
vector<int> tout;
vector<bool> used;
vector<vector<int> > g;
int timer = 0;
int sz = 0;



void dfs1(int v)
{
    used[v] = true;
    fup[v] = tin[v] = timer++;

    for(auto to:g[v]){
        if(used[to]) {fup[v] = min(fup[v],tin[to]);continue;}
        dfs1(to);
        fup[v] = min(fup[v],fup[to]);
    }
}
int cnt;
vector<int> component;
vector<int> component_size;
vector<bool> bad;
void dfs2(int v)
{
    if(used[v]) return;
    used[v] = true;
    component_size[component[v]]++;
    for(auto to:g[v]){
        if(fup[to] == fup[v]) component[to] = component[v];
        else component[to] = cnt++,bad[component[v]] = true;;
        dfs2(to);
    }
}

int main()
{
    //freopen("input.txt","r",stdin);
    //cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> t(n);
    lp(i,0,n) cin>>t[i];
    g.resize(n);
    lp(i,0,m){
        int x,y;
        cin>>x>>y;
        x--,y--;
        if( (t[x]+1)%h == t[y] ) g[x].pb(y);
        if( (t[y]+1)%h == t[x] ) g[y].pb(x);
    }
    if(h == 2) {
        cout<<n<<'\n';
        lp(i,0,n) cout<<i+1<<' ';
        return 0;
    }
    lp(i,0,n) if(g[i].size()==0) return cout<<1<<'\n'<<i+1,0;
    tin.assign(n,0);
    fup.assign(n,0);
    used.assign(n,false);
    lp(i,0,n) if(!used[i]) dfs1(i);
    fill(used.begin(),used.end(),false);
    component.assign(n,0);
    component_size.assign(n,0);
    bad.assign(n,false);
    lp(i,0,n){
        if(used[i]) continue;
        component[i] = cnt++;
        dfs2(i);
    }
    int ans = 1e9;
    int id = 0;
    lp(i,0,cnt) if(!bad[i] && component_size[i]<ans) ans = component_size[i],id = i;
    cout<<ans<<'\n';
    lp(i,0,n) if(component[i] == id) cout<<i+1<<' ';
    return 0;
}
