// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <stack>

#define x first
#define y second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef string str;

const ll N = 100010;

void start();
void stop();

pair<ll, ll> c[N];
ll u[N];
map <ll, vector<ll> > d;
map <ll, bool> used;
ll n, m, h;

int rec(int ind)
{
	if (used[ind])
		return 0;
	used[ind] = 1;
	int ans = 1;
	for (auto z : d[ind])
	{
		if (u[z] == (u[ind] + 1) % h)
			ans = ans + rec(z);
	}
	return ans;
}

int main()
{
	start();
	
	cin >> n >> m >> h;

	for (int i = 0; i < n; i++)
		cin >> u[i];

	for (int i = 0; i < m; i++)
	{
		cin >> c[i].x >> c[i].y;
		d[c[i].x - 1].push_back(c[i].y - 1);
		d[c[i].y - 1].push_back(c[i].x - 1);
	}

	ll ans = 1e15;

	map<ll, bool> ind;

	for (int i = 0; i < n; i++)
	{
		used.clear();
		int temp = rec(i);
		if ((ll)temp < ans)
		{
			ans = temp;
			ind = used;
		}
	}

	cout << ans << endl;
	for (auto i : ind)
		cout << i.x + 1 << ' ';
	cout << endl;

	stop();
	return 0;
}

void start()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void stop()
{
	//system("pause");
}


/*

3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3

*/