import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class D {

	public static class Tree {
		long[] sum;
		
		public Tree(int n) {
			sum = new long[n];
		}
		
		public void add(int x, long delta) {
			for (; x < sum.length; x = x | (x + 1)) {
				sum[x] += delta;
			}
		}
		
		public long sum(int r) {
			long ans = 0;
			for (; r >= 0; r = r & (r + 1) - 1) {
				ans += sum(r);
			}
			return ans;
		}
		
		public long sum(int l, int r) {
			return sum(r) - sum(l - 1);
		}
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		st = new StringTokenizer(in.readLine());
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = Integer.parseInt(st.nextToken());
		}
		TreeSet<Integer> set = new TreeSet<>();
		for (int i = 0; i < a.length; i++) {
			set.add(a[i]);
		}
		set.remove(0);
		if (set.size() == 0) {
			System.out.println(0);
			return;
		}
		int max = Math.max(Math.abs(set.first()), Math.abs(set.last()));
		int max1 = max;
		a = new int[set.size()];
		int iterator = 0;
		boolean[] used = new boolean[2 * max];
		for (int i : set) {
			a[iterator] = i;
			if (i > 0) {
				used[i - 1] = true;
			} else {
				used[max - i - 1] = true;
			}
			iterator++;
		}
		int pow = 1;
		while (max1 > 0) {
			pow++;
			max1 = (max1 >> 1);
		}
		int size = Integer.MAX_VALUE;
		int[] ans = new int[pow];
		int[] th = new int[pow];
		w :
		while (true) {
			ArrayList<Integer> can = new ArrayList<>();
			can.add(0);
			for (int i = 0; i < th.length; i++) {
//				ArrayList<Integer> can1 = new ArrayList<>();
				int sz = can.size();
				for (int j = 0; j < sz; j++) {
//					can1.add(j);
					if (th[i] == 1) {
						can.add(can.get(j) + (1 << i));
					} else if (th[i] == 2) {
						can.add(can.get(j) + (-1 << i));
					}
				}
//				can = can1;
			}
//			for (int i = 0; i < th.length; i++) {
//				System.out.print(th[i] + " ");
//			}
//			System.out.println(" th");
//			for (int i : can) {
//				System.out.print(i + " ");
//			}
//			System.out.println(" can");
//			boolean flag = true;
//			for (int i = 0; i < a.length; i++) {
//				if (!can.contains(a[i])) {
//					flag = false;
//				}
//			}
			boolean[] used1 = new boolean[used.length];
			for (int i = 0; i < used1.length; i++) {
				used1[i] = used[i];
			}
			for (int i : can) {
				if (i > 0 && i < max + 1) {
					used1[i - 1] = false;
				} else if (i < 0 && i > - max - 1) {
					used1[max - i - 1] = false;
				}
			}
			boolean flag = false;
			for (int i = 0; i < used1.length; i++) {
				flag |= used1[i];
			}
			if (!flag) {
				int x = 0;
				for (int i = 0; i < th.length; i++) {
					if (th[i] != 0) {
						x++;
					}
				}
				if (x < size) {
					size = x;
					for (int i = 0; i < th.length; i++) {
						ans[i] = th[i];
					}
				}
			}
			iterator = 0;
			while (true) {
				if (iterator == pow) {
					break w;
				}
				if (th[iterator] == 2) {
					th[iterator] = 0;
					iterator++;
				} else {
					th[iterator]++;
					break;
				}
			}
		}
		out.println(size);
		for (int i = 0; i < ans.length; i++) {
			if (ans[i] == 1) {
				out.print((1 << i) + " ");
			} else if (ans[i] == 2) {
				out.print((-1 << i) + " ");
			}
		}
		in.close();
		out.close();
	}

}
