import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class D1 {

	public static class Tree {
		long[] sum;

		public Tree(int n) {
			sum = new long[n];
		}

		public void add(int x, long delta) {
			for (; x < sum.length; x = x | (x + 1)) {
				sum[x] += delta;
			}
		}

		public long sum(int r) {
			long ans = 0;
			for (; r >= 0; r = r & (r + 1) - 1) {
				ans += sum(r);
			}
			return ans;
		}

		public long sum(int l, int r) {
			return sum(r) - sum(l - 1);
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		st = new StringTokenizer(in.readLine());
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = Integer.parseInt(st.nextToken());
		}
		TreeSet<Integer> set = new TreeSet<>();
		for (int i = 0; i < a.length; i++) {
			set.add(a[i]);
		}
		set.remove(0);
		if (set.size() == 0) {
			System.out.println(0);
			return;
		}
		TreeSet<Integer> ans = new TreeSet<>();
		while (!set.isEmpty()) {
//			for (int i : set) {
//				System.out.print(i + " ");
//			}
//			System.out.println();
			int max = Math.max(Math.abs(set.first()), Math.abs(set.last()));
			int max1 = max;
			int pow = 0;
			while (max1 > 0) {
				pow++;
				max1 = (max1 >> 1);
			}
			int r = ((1 << pow) + Math.max((1 << (pow - 1)), 0)) / 2;
			boolean plus = false;
			boolean minus = false;
			if (set.last() >= r && r > 1 || set.last() > r) {
				plus = true;
			}
			if (set.first() <= -r && r < -1 || set.first() < -r) {
				minus = true;
			}
//			System.out.println(r + " " + minus + " " + plus);
			if (minus && plus) {
				if (ans.contains((1 << (pow + 1)))) {
					plus = false;
				} else {
					ans.add(-1 << (pow + 1));
					minus = false;
				}
			} else if (!(minus || plus)) {
				while (!(minus || plus)) {
					pow--;
					r = ((1 << pow) + Math.max((1 << (pow - 1)), 0)) / 2;
					plus = false;
					minus = false;
					if (set.last() >= r && r > 1 || set.last() > r) {
						plus = true;
					}
					if (set.first() <= -r && r < -1 || set.first() < -r) {
						minus = true;
					}
					if (minus && plus) {
						if (ans.contains((1 << (pow + 1)))) {
							plus = false;
						} else {
							ans.add(-1 << (pow + 1));
							minus = false;
						}
					}
				}
			}
			if (minus) {
				ans.add(-1 << pow);
			} else {
				ans.add(1 << pow);
			}
			int x = 1 << pow;
			TreeSet<Integer> set1 = new TreeSet<>();
			for (int i : set) {
				if (i <= -r && r < -1 || i < -r) {
					set1.add(i + x);
				} else if (i >= r && r > 1 || i > r) {
					set1.add(i - x);
				} else {
					set1.add(i);
				}
			}
			set1.remove(0);
			set = set1;
		}
		out.println(ans.size());
		for (int i : ans) {
			out.print(i + " ");
		}
		// a = new int[set.size()];
		// int iterator = 0;
		// boolean[] used = new boolean[2 * max];
		// for (int i : set) {
		// a[iterator] = i;
		// if (i > 0) {
		// used[i - 1] = true;
		// } else {
		// used[max - i - 1] = true;
		// }
		// iterator++;
		// }
		// int size = Integer.MAX_VALUE;
		// int[] ans = new int[pow];
		// int[] th = new int[pow];
		// w :
		// while (true) {
		// int[] can = new int[1 << pow];
		// int csz = 1;
		// can[0] = 0;
		// for (int i = 0; i < th.length; i++) {
		//// ArrayList<Integer> can1 = new ArrayList<>();
		// int sz = csz;
		// for (int j = 0; j < sz; j++) {
		//// can1.add(j);
		// if (th[i] == 1) {
		// can[csz] = (can[j] + (1 << i));
		// csz++;
		// } else if (th[i] == 2) {
		// can[csz] = (can[j] + (-1 << i));
		// csz++;
		// }
		// }
		//// can = can1;
		// }
		//// for (int i = 0; i < th.length; i++) {
		//// System.out.print(th[i] + " ");
		//// }
		//// System.out.println(" th");
		//// for (int i : can) {
		//// System.out.print(i + " ");
		//// }
		//// System.out.println(" can");
		//// boolean flag = true;
		//// for (int i = 0; i < a.length; i++) {
		//// if (!can.contains(a[i])) {
		//// flag = false;
		//// }
		//// }
		// boolean[] used1 = new boolean[used.length];
		// for (int i = 0; i < used1.length; i++) {
		// used1[i] = used[i];
		// }
		// for (int i : can) {
		// if (i > 0 && i < max + 1) {
		// used1[i - 1] = false;
		// } else if (i < 0 && i > - max - 1) {
		// used1[max - i - 1] = false;
		// }
		// }
		// boolean flag = false;
		// for (int i = 0; i < used1.length; i++) {
		// flag |= used1[i];
		// }
		// if (!flag) {
		// int x = 0;
		// for (int i = 0; i < th.length; i++) {
		// if (th[i] != 0) {
		// x++;
		// }
		// }
		// if (x < size) {
		// size = x;
		// for (int i = 0; i < th.length; i++) {
		// ans[i] = th[i];
		// }
		// }
		// }
		// iterator = 0;
		// while (true) {
		// if (iterator == pow) {
		// break w;
		// }
		// if (th[iterator] == 2) {
		// th[iterator] = 0;
		// iterator++;
		// } else {
		// th[iterator]++;
		// break;
		// }
		// }
		// }
		// out.println(size);
		// for (int i = 0; i < ans.length; i++) {
		// if (ans[i] == 1) {
		// out.print((1 << i) + " ");
		// } else if (ans[i] == 2) {
		// out.print((-1 << i) + " ");
		// }
		// }
		in.close();
		out.close();
	}

}
