#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int N = (int)2e5 + 100;
vector<int> g[N], gt[N], gg[N];
int used[N], c[N], sz[N], u[N];
vector<int> sorted;

void dfs(int v) {
    used[v] = 1;
    for (const auto &to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    sorted.push_back(v);
}

void dfs1(int v, int col) {
    used[v] = 1;
    c[v] = col;
    sz[col]++;
    for (const auto &to : gt[v]) {
        if (!used[to]) {
            dfs1(to, col);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        if ((u[a] + 1) % h == u[b]) {
            g[a].push_back(b);
            gt[b].push_back(a);
        }

        if ((u[b] + 1) % h == u[a]) {
            g[b].push_back(a);
            gt[a].push_back(b);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }

    int k = 0;
    for (int i = n - 1; i >= 0; --i) {
        int v = sorted[i];
        if (!used[v]) {
            dfs1(v, k++);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (const auto &to : g[i]) {
            if (c[i] != c[to]) {
                gg[c[i]].push_back(c[to]);
            }
        }
    }


    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }

    int res = -1;
    for (int i = 0; i < k; ++i) {
        if (gg[i].empty()) {
            if (res == -1 || sz[res] > sz[i]) {
                res = i;
            }
        }
    }

    cout << sz[res] << '\n';
    for (int i = 0; i < n; ++i) {
        if (c[i] == res) {
            cout << i + 1 << " ";
        }
    }
    return 0;
}