#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int N = (int)1e5 + 100;
ll a[N], have[2][N];

void f(int c) {
    vector<int> res;
    while (c > 0) {
        res.push_back(c % 2);
        c /= 2;
    }

    res.resize(10);
    reverse(res.begin(), res.end());
    for (const auto &it : res) {
        cout << it;
    }
    cout << '\n';
}

int getres(ll k, int n, int d, int b, int fl = 0) {
    ll left = k;
    for (int i = 0; i < n; ++i) {
        if (a[i] >= left) {
            have[0][i] = left;
            have[1][n - 1 - i] = a[i] - left;
            left = 0;
        } else {
            have[0][i] = a[i];
            left -= a[i];
        }
    }

    int ans[2] = {};

    for (int t = 0; t < 1 + fl; ++t) {
        ll cur = have[t][0];
        int j = 1;
        for (int i = 0; i  <= n / 2; ++i) {
            if (t == 1 && i == n / 2)
                continue;
            while (j < n && j <= i + (i + 1) * 1ll * d) {
                cur += have[t][j];
                j++;
            }

            if (cur < b) {
                ans[t]++;
            } else {
                cur -= b;
            }
        }
    }

    return max(ans[0], ans[1]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int ans = inf;
    if (p == 1) {
        ans = getres(1ll * n * b, n, d, b);
    } else {
        for (ll i = 0; i < n * b; ++i) {
            ans = min(ans, getres(i, n, d, b, 1));
        }
    }

    cout << ans;

    return 0;
}