#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int M = (int)1e6 + 100;
const int N = 5;
const int K = 100;
bool can[2 * K];
int a[M];
int ch = 5;

int getcnt(int mask) {
    int res = 0;
    while (mask > 0) {
        res++;
        mask &= (mask - 1);
    }
    return res;
}

vector<int> cur;
vector<int> ans;
bool found = 0;
void dfs(int cnt, int n) {
    if (found && cur.size() > ans.size())
        return;
    if (!cur.empty()) {
        fill(can, can + 2 * K, 0);
        can[K] = 1;
        for (const auto &it : cur) {
            int val;
            if (it < ch)
                val = (1 << it);
            else
                val = -(1 << (it - ch));
            vector<int> gd;
            for (int i = 0; i < 2 * K; ++i) {
                if (can[i])
                    gd.push_back(i);
            }
            for (auto i : gd) {
                if (i + val >= 0 && i + val < 2 * K) {
                    can[i + val] = 1;
                }
            }
        }

        bool good = 1;
        for (int i = 0; i < n; ++i) {
            if (!can[a[i] + K]) {
                good = 0;
            }
        }

        if (good) {
            if (ans.size() > cur.size() || !found) {
                ans = cur;
            }
            found = 1;
            return;
        }
    }
    for (int i = 0; i < 2 * N; ++i) {
        if (cnt <= N) {
            cur.push_back(i);
            dfs(cnt + 1, n);
            cur.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (n == 1 && a[0] == 0) {
        cout << 0;
        return 0;
    }

    dfs(0, n);
    cout << ans.size() << '\n';
    for (const auto &it : ans) {
        if (it < ch) {
            cout << (1 << it) << " ";
        } else {
            cout << -(1 << (it - ch)) << " ";
        }
    }

    return 0;
}