
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#define ll long long



int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    int n, m, t, t1;
    cin >> n >> m >> t;
    map<int, vector<int>>A;
    vector<vector<int>>g(n, vector<int>(n));
    for (int i = 0; i < n; i++)
    {
        cin >> t1;
        vector<int> K = A[t1];
        K.push_back(i);
        A[t1] = K;
    }
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a - 1][b - 1] = 1;
        g[b - 1][a - 1] = 1;
    }
    set<int>ans;
    set<int>ans1;
    for (auto it = A.begin(); it != A.end(); it++)
    {
        int t1 = (it->first + 1) % t;
        for (int j = 0; j < it->second.size(); j++)
        {
            int a = it->second[j];
            for (int i = 0; i < A[t1].size(); i++)
            {
                int b = A[t1][i];
                if (g[a][b])
                {
                    ans.insert(a);
                    ans1.insert(b);
                }
            }
        }
    }
    if (ans1.size() < ans.size())
        ans = ans1;
    cout << ans.size() << endl;
    for (auto it = ans.begin(); it != ans.end(); it++)
    {
        cout << *it + 1 << " ";
    }
          
    return 0;
}