
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#define ll long long

bool cmp(vector<int> a, vector<int> b)
{
    return a.size() > b.size();
}

set<int>ans;
vector<bool>used(1000, 0);
void dfs(int v, vector<vector<int>> &g1, vector<vector<int>> & g2)
{
    used[v] = 1;
    if (g1[v].size() + g2[v].size() > 1)
    {
        ans.insert(v);
    }
    for (int i = 0; i < g1[v].size(); i++)
    {
        int to = g1[v][i];
        if (!used[to])
        {
            dfs(to, g1, g2);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    int n, m, t, t1;
    cin >> n >> m >> t;
    map<int, vector<int>>A;
    vector<vector<bool>>g(m, vector<bool>(m, 0));
    for (int i = 0; i < n; i++)
    {
        cin >> t1;
        vector<int> K = A[t1];
        K.push_back(i);
        A[t1] = K;
    }
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a - 1][b - 1] = 1;
        g[b - 1][a - 1] = 1;
    }
    vector<vector<int>>g1(m);
    vector<vector<int>>g2(m);
    for (auto it = A.begin(); it != A.end(); it++)
    {
        int t1 = (it->first + 1) % t;
        for (int j = 0; j < it->second.size(); j++)
        {
            int a = it->second[j];
            for (int i = 0; i < A[t1].size(); i++)
            {
                int b = A[t1][i];
                if (g[a][b])
                {
                    g1[a].push_back(b);
                    g2[b].push_back(a);
                }
            }
        }
    }
    int k = 0, ma = 1e9;
    for (int i = 0; i < n; i++)
    {
        if(!used[i])
        dfs(i, g1, g2);
    }
    dfs(k, g1, g2);
    cout << ans.size() << endl;
    for (auto it = ans.begin(); it != ans.end(); it++)
    {
        cout << *it + 1 << " ";
    }

    return 0;
}