
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <queue>
using namespace std;

#define ll long long

void scan(vector<pair<int, int>>&A)
{
    cout << A.size() <<endl ;
    for (int i = 0; i < A.size(); i++)
    {
        cout << A[i].first << " " << A[i].second << endl;
    }
}

void push_zero(int i, vector <vector<pair<int,int>>>&ans )
{
    vector<pair<int, int>> A;
    A.push_back({ 0, i });
    ans.push_back(A);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    int n;
    int r = 0;
    string s;
    cin >> s;
    int f = 0;
    n = s.size();
    vector<bool>used(s.size(), 0);
    vector<vector<pair<int, int> >>ans;
    queue<pair<int, int> >K;
    if (s[0] == '1')
    {
        cout << -1;
        return 0;
    }
    push_zero(0, ans);
    int p = 0;
    for (int i = 1; i < n; i++)
    {
        int k = s[i] - '0';
        bool f = 0;
        if (k == 0)
        {
            if (p != 0)
            {
                if (ans[p - 1][ans[p - 1].size() - 1].first == 1)
                {
                    ans[p - 1].push_back({ k, i });
                    p--;
                    f = 1;
                }
            }
           
        }
        else
        {

            if (ans[p][ans[p].size() - 1].first == 0)
            {
                ans[p].push_back({ k, i });
                p++;
                f = 1;
            }
        }
       
        if (!f)
        {
            if (k == 1)
            {
                cout << -1;
                return 0;
            }
            else
            {
                push_zero(i, ans);
            }
        }

    }
    
    for (int j = 0; j < ans.size(); j++)
    {
        if (ans[j][ans[j].size() - 1].first == 1)
        {
            cout << -1;
            return 0;
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i].size() << " ";
        for (int j = 0; j < ans[i].size(); j++)
        {
            cout << ans[i][j].second + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}