// ███▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓▓▓╬╬╬╬╬╬▓█
// ███▓███████▓▓╬╬╬╬╬╬╬╬╬╬╬╬▓███▓▓▓▓█▓╬╬╬▓█
// ███████▓█████▓▓╬╬╬╬╬╬╬╬▓███▓╬╬╬╬╬╬╬▓╬╬▓█
// ████▓▓▓▓╬╬▓█████╬╬╬╬╬╬███▓╬╬╬╬╬╬╬╬╬╬╬╬╬█
// ███▓▓▓▓╬╬╬╬╬╬▓██╬╬╬╬╬╬▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬╬╬╬▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓███████▓▓███▓╬╬╬╬╬╬▓███████▓╬╬╬╬▓█
// ████████████████▓█▓╬╬╬╬╬▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬█
// ███▓▓▓▓▓▓▓╬╬▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬▓▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓▓█▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓██▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// █████▓▓▓▓▓████▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓█▓▓▓▓██▓▓▓▓██╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓▓███▓▓▓▓▓▓▓██▓╬╬╬╬╬╬╬╬╬╬╬╬█▓╬▓╬╬▓██
// █████▓███▓▓▓▓▓▓▓▓████▓▓╬╬╬╬╬╬╬█▓╬╬╬╬╬▓██
// █████▓▓█▓███▓▓▓████╬▓█▓▓╬╬╬▓▓█▓╬╬╬╬╬╬███
// ██████▓██▓███████▓╬╬╬▓▓╬▓▓██▓╬╬╬╬╬╬╬▓███
// ███████▓██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬████
// ███████▓▓██▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓████
// ████████▓▓▓█████▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█████
// █████████▓▓▓█▓▓▓▓▓███▓╬╬╬╬╬╬╬╬╬╬╬▓██████
// ██████████▓▓▓█▓▓▓╬▓██╬╬╬╬╬╬╬╬╬╬╬▓███████
// ███████████▓▓█▓▓▓▓███▓╬╬╬╬╬╬╬╬╬▓████████
// ██████████████▓▓▓███▓▓╬╬╬╬╬╬╬╬██████████
// ███████████████▓▓▓██▓▓╬╬╬╬╬╬▓███████████
#include <bits/stdc++.h>
#define x first 
#define y second
#define pb push_back
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;} 
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;} 

const string FILENAME = "input";
typedef pair<int, int> point;

const int MAXN = 2e5 + 10;

int n, m, h;
int t[MAXN];
bool used[MAXN], cool[MAXN];
int cnt = 1, clr[MAXN], s[MAXN];
vector<int> edge[MAXN], rev[MAXN];
vector<int> topsort;

int get(int t) {
	if (t == h - 1) {
		return 0;
	}
	return t + 1;
}

void dfs(int i) {
	if (used[i]) return;
	used[i] = true;
	for (auto j : edge[i]) {
		dfs(j);
	}
	topsort.pb(i);
}

void dfs_color(int i) {
	if (clr[i]) return;
	clr[i] = cnt;
	s[cnt]++;
	for (auto j : rev[i]) {
		dfs_color(j);
	}
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n >> m >> h;
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		if (get(t[a]) == t[b]) {
			edge[a].pb(b);
			//cout << a + 1 << ' ' << b + 1 << endl;
			rev[b].pb(a);
		} 
		if (get(t[b]) == t[a]) {
			edge[b].pb(a);
			//cout << b + 1 << ' ' << a + 1 << endl;
			rev[a].pb(b);
		} 
	}
	for (int i = 0; i < n; ++i) dfs(i);
	reverse(topsort.begin(), topsort.end());
	for (int i : topsort) {
		dfs_color(i);
		++cnt;
	}
	for (int i = 0; i < n; ++i) {
		for (auto j : edge[i]) {
			if (clr[i] != clr[j]) {
				cool[clr[i]] = true;
			}
		}
	}
	int ans = -1;
	for (int i = 1; i < cnt; ++i) {
		if (cool[i] || !s[i]) continue;
		if (ans == -1 || s[ans] > s[i]) {
			ans = i;
		}
	}
	cout << s[ans] << '\n';
	for (int i = 0; i < n; ++i) {
		if (clr[i] == ans) {
			cout << i + 1 << ' ';
		}
	}
	cout << '\n';
}

//open-2018-342
