// ███▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓▓▓╬╬╬╬╬╬▓█
// ███▓███████▓▓╬╬╬╬╬╬╬╬╬╬╬╬▓███▓▓▓▓█▓╬╬╬▓█
// ███████▓█████▓▓╬╬╬╬╬╬╬╬▓███▓╬╬╬╬╬╬╬▓╬╬▓█
// ████▓▓▓▓╬╬▓█████╬╬╬╬╬╬███▓╬╬╬╬╬╬╬╬╬╬╬╬╬█
// ███▓▓▓▓╬╬╬╬╬╬▓██╬╬╬╬╬╬▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬╬╬╬▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓███████▓▓███▓╬╬╬╬╬╬▓███████▓╬╬╬╬▓█
// ████████████████▓█▓╬╬╬╬╬▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬█
// ███▓▓▓▓▓▓▓╬╬▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬▓▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓▓█▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓██▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// █████▓▓▓▓▓████▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓█▓▓▓▓██▓▓▓▓██╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓▓███▓▓▓▓▓▓▓██▓╬╬╬╬╬╬╬╬╬╬╬╬█▓╬▓╬╬▓██
// █████▓███▓▓▓▓▓▓▓▓████▓▓╬╬╬╬╬╬╬█▓╬╬╬╬╬▓██
// █████▓▓█▓███▓▓▓████╬▓█▓▓╬╬╬▓▓█▓╬╬╬╬╬╬███
// ██████▓██▓███████▓╬╬╬▓▓╬▓▓██▓╬╬╬╬╬╬╬▓███
// ███████▓██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬████
// ███████▓▓██▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓████
// ████████▓▓▓█████▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█████
// █████████▓▓▓█▓▓▓▓▓███▓╬╬╬╬╬╬╬╬╬╬╬▓██████
// ██████████▓▓▓█▓▓▓╬▓██╬╬╬╬╬╬╬╬╬╬╬▓███████
// ███████████▓▓█▓▓▓▓███▓╬╬╬╬╬╬╬╬╬▓████████
// ██████████████▓▓▓███▓▓╬╬╬╬╬╬╬╬██████████
// ███████████████▓▓▓██▓▓╬╬╬╬╬╬▓███████████
#include <bits/stdc++.h>
#define x first 
#define y second
#define pb push_back
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;} 
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;} 

const string FILENAME = "input";
typedef pair<int, int> point;

const int MAXN = 2e5;

int s = 1e9;
vector<int> ans;

int n;
vector<int> a;

map<vector<int>, vector<int>> lay[20];

void try_update(int k, vector<int> b, vector<int> way) {
	set<int> used;
	vector<int> a;
	for (int i : b) {
		if (!used.count(i)) {
			a.pb(i);
			used.insert(i);
		}
	} 
	if (lay[k].count(a)) {
		if (lay[k][a].size() > way.size()) {
			lay[k][a] = way;
		}
	} else {
		lay[k][a] = way;
	}
}

void res() {
	for (int k = 0; k < 20; ++k) {
		int w = (1 << k);
		for (auto res : lay[k]) {
			if (res.y.size() >= s) continue;
			bool OK = false;
			bool L = false;
			bool R = false;
			vector<int> elem;
			for (int i = 0; i < res.x.size(); ++i) {
				if (res.x[i] != 0) OK = true;
				if (abs(res.x[i]) & w) {
					if (res.x[i] < 0) L = true;
					else R = true;
					elem.pb(i);
				}
			}
			if (!OK) {
				if (s > res.y.size()) {
					s = res.y.size();
					ans = res.y;
				}
				continue;
			}
			if (k == 18) continue;
			if (elem.size() == 0) {
				try_update(k + 1, res.x, res.y);
			} else {
				pair<vector<int>, vector<int>> q = res;
				q.y.pb(w);
				for (int i : elem) q.x[i] -= w;
				try_update(k + 1, q.x, q.y);
				q.y.pop_back();
				q.y.pb(-w);
				for (int i : elem) q.x[i] += (w << 1);
				try_update(k + 1, q.x, q.y);
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	lay[0][a] = {};
	res();
	cout << s << endl;
	for (auto i : ans) cout << i << ' '; cout << endl;
}
