// ███▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓▓▓╬╬╬╬╬╬▓█
// ███▓███████▓▓╬╬╬╬╬╬╬╬╬╬╬╬▓███▓▓▓▓█▓╬╬╬▓█
// ███████▓█████▓▓╬╬╬╬╬╬╬╬▓███▓╬╬╬╬╬╬╬▓╬╬▓█
// ████▓▓▓▓╬╬▓█████╬╬╬╬╬╬███▓╬╬╬╬╬╬╬╬╬╬╬╬╬█
// ███▓▓▓▓╬╬╬╬╬╬▓██╬╬╬╬╬╬▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬╬╬╬▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓███████▓▓███▓╬╬╬╬╬╬▓███████▓╬╬╬╬▓█
// ████████████████▓█▓╬╬╬╬╬▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬█
// ███▓▓▓▓▓▓▓╬╬▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ████▓▓▓╬╬╬╬▓▓▓▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// ███▓█▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓▓█▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█
// █████▓▓▓▓▓▓▓██▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// █████▓▓▓▓▓████▓▓▓█▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓█▓▓▓▓██▓▓▓▓██╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬██
// ████▓▓███▓▓▓▓▓▓▓██▓╬╬╬╬╬╬╬╬╬╬╬╬█▓╬▓╬╬▓██
// █████▓███▓▓▓▓▓▓▓▓████▓▓╬╬╬╬╬╬╬█▓╬╬╬╬╬▓██
// █████▓▓█▓███▓▓▓████╬▓█▓▓╬╬╬▓▓█▓╬╬╬╬╬╬███
// ██████▓██▓███████▓╬╬╬▓▓╬▓▓██▓╬╬╬╬╬╬╬▓███
// ███████▓██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬████
// ███████▓▓██▓▓▓▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓████
// ████████▓▓▓█████▓▓╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬╬▓█████
// █████████▓▓▓█▓▓▓▓▓███▓╬╬╬╬╬╬╬╬╬╬╬▓██████
// ██████████▓▓▓█▓▓▓╬▓██╬╬╬╬╬╬╬╬╬╬╬▓███████
// ███████████▓▓█▓▓▓▓███▓╬╬╬╬╬╬╬╬╬▓████████
// ██████████████▓▓▓███▓▓╬╬╬╬╬╬╬╬██████████
// ███████████████▓▓▓██▓▓╬╬╬╬╬╬▓███████████
#include <bits/stdc++.h>
#define x first 
#define y second
#define pb push_back
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;} 
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;} 

const string FILENAME = "input";
typedef pair<int, int> point;

const int MAXN = 1 << 18;

int s = 1e9;
vector<short int> ans;

int n;
vector<int> a;

int cnt = 1;
int used[MAXN * 2 + 1];
unordered_map<long long, vector<int>> hsh[20];
map<long long, vector<short int>> lay[20];

void try_update(int k, vector<int> &b, vector<short int> &way) {
	++cnt;
	vector<int> a;
	for (int i : b) {
		if (i && used[i + MAXN] != cnt) {
			a.pb(i);
			used[i + MAXN]!= cnt;
		}
	} 
	if (a.size() == 0) {
		if (s > way.size()) {
			s = way.size();
			ans = way;
		}
	} else {
		long long hashing = 0;
		for (int i : a) {
			hashing *= 10000007;
			hashing += i;
		}
		if (hsh[k].count(hashing) == 0) {
			hsh[k][hashing] = a;
		}
		auto it = lay[k].find(hashing);
		if (it == lay[k].end()) {
			lay[k][hashing] = way;
		} else if ((it -> y).size() > way.size()) {
			it -> y = way;
		}
	}
}

long long t;

void res() {
	for (int k = 0; k < 18; ++k) {
		//cout << lay[k].size() << endl;
		if (1. * (clock() - t) > 0.85 * CLOCKS_PER_SEC) break;
		int minv = 1e9;
		int w = (1 << k);
		for (auto res : lay[k]) {
			if (res.y.size() >= s - 1) continue;
			if (lay[k].size() > 250) if (rand() & 1) continue;
			pair<vector<int>, vector<short int>> q = {hsh[k][res.x], res.y};
			vector<int> elem;
			for (int i = 0; i < q.x.size(); ++i) {
				if (abs(q.x[i]) & w) {
					elem.pb(i);
				}
			}
			if (elem.size() == 0) {
				try_update(k + 1, q.x, q.y);
			} else {
				q.y.pb((k + 1));
				for (int i : elem) q.x[i] -= w;
				try_update(k + 1, q.x, q.y);
				q.y.pop_back();
				q.y.pb(-(k + 1));
				for (int i : elem) q.x[i] += (w << 1);
				try_update(k + 1, q.x, q.y);
			}
		}
		lay[k].clear();
		hsh[k].clear();
	}	
}

int M = 100000;

int main() {
	t = clock();
	ios::sync_with_stdio(0);
	srand(time(0));
	//read(FILENAME);
	//n = rand() % 10000 + 1;
	cin >> n;
	a.resize(n);
	int w = 0;
	for (int i = 0; i < n; ++i) {
		//a[i] = rand() % (M * 2) - M;
		cin >> a[i];
		chkmax(w, abs(a[i]));
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < 18; ++i) {
		ans.pb(pow(-1, i) * (i + 1));
		if ((1 << i) >= w * 2) break;
	}
	s = ans.size();
	vector<short int> c = {};
	try_update(0, a, c);
	res();
	cout << s << '\n';
	for (auto i : ans) {
		int s = i / abs(i);
		i = abs(i) - 1;
		cout << s * (1 << i) << ' ';
	}
	cout << endl;
}
