#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace std::chrono_literals;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("b.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

int dfsCount(const vector<vector<int>>& g, vector<ll>& visited, int v) {
    int ans = 1;
    visited[v] = 1e6;
    for (int w : g[v]) {
        if (visited[w]!=-1) {
            v += visited[w];
            continue;
        }
        ans += dfsCount(g, visited, w);
    }
    return visited[v] = ans;
}
void dfsExplore(const vector<vector<int>>& g, vector<int>& out, vector<bool>& visited, int v) {
    visited[v] = true;
    for (int w : g[v]) {
        if (visited[w]) continue;
        dfsExplore(g, out, visited, w);
    }
    out.push_back(v);
}

void $main(ll testId) {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    vector<int> c1(m), c2(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> g(n), g_i(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        for (int __j = 0; __j < 2; ++__j) {
            swap(u, v);
            if ((a[u] + 1) % h == a[v]) {
                g[u].push_back(v);
                g_i[v].push_back(u);
            }
        }
    }

    for (auto gg : {&g, &g_i}) {
        for (auto& row : *gg) {
            sort(row.begin(), row.end());
            row.erase(unique(row.begin(), row.end()), row.end());
        }
    }



    vector<ll> used(n, -1);
    vector<ll> vec(n);
    for (int i = 0; i < n; ++i) {
        vec[i] = dfsCount(g, used, i);
    }
    auto best = min_element(vec.begin(), vec.end());
    vector<int> t;
    vector<bool> visited(n);
    dfsExplore(g, t, visited, best - vec.begin());

    cout << t.size() << endl;
    for (auto x  : t) cout <<x << " ";
    cout << endl;
}
