
#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("c.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    //partial
    p = 1;
    b = 1;
    //n = clamp(n, 1, 1000);
    //end partial
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int r = 0;
    int x = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < a[i]; ++j) {
            int dist = abs(r - i);
            int numSteps = (dist - 1) / d + 1;
            int numAll = r + 2;
            if (numSteps > numAll) {
                ++x;
            }
            ++r;
        }
    }
    cout << x << "\n";
}
