#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    string s;
    cin >> s;
    vector<vector<int>> ans;
    while (s.size()) {
        vector<int> t;
        char n = '0';
        for (int i = 0; i < s.size(); ++i) {
            if (s[i] == n) {
                t.push_back(i);
                n = '1' - n + '0';
            }
        }
        if (t.size() == 0) break;
        ans.push_back(t);
        reverse(t.begin(), t.end());
        for (auto i : t) {
            s[i] = '#';
        }
    }
    bool ok = true;
    for (auto c : s) {
        if (c != '#') ok = false;
    }
    if (!ok) {
        cout << "-1\n";
    } else {
        cout << ans.size() << "\n";
        for (auto& r : ans) {
            cout << r.size() << " ";
            for (auto x : r) {
                cout << x << " ";
            }
            cout << "\n";
        }
    }
}
