#include <iostream>
#include <vector>
#include <stdio.h>
#include <algorithm>

using namespace std;

vector <int> cnt;
vector <bool> used;
vector <bool> inuse;
vector <vector <int> > g;
vector <int> tout;
vector <int> colors;

int time=0;

void dfs(int v){
    used[v]=true;
    time++;
    for (int i=0;i<g[v].size();i++){
        int u=g[v][i];
        if (!used[u]){
            dfs(u);
            used[u]=true;
        }
    }
    time++;
    tout[v]=time;
    //cout<<"tout "<<tout[v]<<" "<<v<<endl;
}

int dfs1(int v,int color){
    used[v]=true;
    colors[v]=color;
    int ans=1;
    for (int i=0;i<g[v].size();i++){
        int u=g[v][i];
        if (!used[u]){
            int ansd=dfs1(u,color);
            if (ansd==1000000){
                return 1000000;
            }
            ans+=ansd;
            used[u]=true;
        }else{
            if (colors[u]!=-1&&colors[u]!=color){
                return 1000000;
            }
        }
    }
    return ans;
}

int main(){
    int n,m,h;
    cin>>n>>m>>h;
    vector <int> serv[h];
    used.assign(n,false);
    cnt.assign(n,0);
    tout.assign(n,0);
    vector <int> zero;
    g.assign(n,zero);
    inuse.assign(n,false);
    colors.assign(n,-1);
    int times[n];
    for (int i=0;i<n;i++){
        cin>>times[i];
    }
    for (int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        if (times[a-1]==(times[b-1]+1)%h){
            g[b-1].push_back(a-1);
        }
        int buf=a;
        a=b;
        b=buf;
        if (times[a-1]==(times[b-1]+1)%h){
            g[b-1].push_back(a-1);
        }
    }

    vector <pair<int,int> > t;
    for (int i=0;i<n;i++){
        if (!used[i]){
            dfs(i);
        }
        t.push_back(make_pair(tout[i],i));
    }
    for (int i=0;i<n;i++){
        used[i]=false;
    }
    sort(t.begin(),t.end());
    int col=0;
    int ans=1000000;
    int ansi=0;
    for (int i=0;i<n;i++){
        if (!used[i]){
            int now=dfs1(t[i].second,col);
            if (ans>now){
                ans=now;
                ansi=i;
            }
        }
        col++;
    }
    cout<<ans<<endl;
    int anscolor=colors[t[ansi].second];
    for (int i=0;i<n;i++){
        if (colors[i]==anscolor){
            cout<<i+1<<" ";
        }
    }
    return 0;
}
