#include <bits/stdc++.h>

#define pii pair<int, int>
#define f first
#define s second
#define ll long long
#define pll pair<ll, ll>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define output(a) for (auto el : a) cout << el << ' '; cout << '\n';

using namespace std;

const int INF = 1e9;

void dfs(vector<vector<int>>& g, int v, vector<bool>& used, vector<int>& x, const int inf) {
    used[v] = 1;
    x[inf] += 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(g, u, used, x, inf);
        }
    }
}

void dfs(vector<vector<int>>& g, int v, vector<bool>& used, vector<int>& ans) {
    used[v] = 1;
    ans.emplace_back(v);
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(g, u, used, ans);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if ((a[u] + 1) % h == a[v]) {
            g[u].emplace_back(v);
        }
        if ((a[v] + 1) % h == a[u]) {
            g[v].emplace_back(u);
        }
    }
    vector<int> x(n, 0);
    vector<bool> used(n);
    for (int i = 0; i < n; ++i) {
        used.assign(n, 0);
        dfs(g, i, used, x, i);
    }
    int ans = -1, cur = INF;
    for (int i = 0; i < n; ++i) {
        if (x[i] >= 1 && x[i] < cur) {
            cur = x[i];
            ans = i;
        }
    }
    if (ans == -1) {
        cout << "1\n1";
        return 0;
    }
    vector<int> p;
    used.assign(n, 0);
    dfs(g, ans, used, p);
    cout << sz(p) << '\n';
    for (auto el : p) {
        cout << el + 1 << ' ';
    }
    return 0;
}
