#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#define endl '\n'

using namespace std;

typedef long long ll;

void dfs(vector<vector<int>> &g, vector<int> &used, int cv) {
    used[cv] = 1;
    for (int nv : g[cv]) {
        if (!used[nv]) {
            dfs(g, used, nv);
        }
    }
}

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t(n), ans(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
        ans[i] = i + 1;
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if ((t[a - 1] + 1) % h == t[b - 1]) {
            g[a - 1].push_back(b - 1);
        }
        if ((t[b - 1] + 1) % h == t[a - 1]) {
            g[b - 1].push_back(a - 1);
        }
    }

    for (int i = 0; i < n; ++i) {
        vector<int> used(n);
        dfs(g, used, i);
        int cc = 0;
        for (int j = 0; j < n; ++j) {
            if (used[j]) {
                cc++;
            }
        }
        if (cc < ans.size()) {
            ans.clear();
            for (int j = 0; j < n; ++j) {
                if (used[j]) {
                    ans.push_back(j + 1);
                }
            }
        }
    }

    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i << " ";
    }
    cout << endl;
//    vector<int> ans(n);
//    for (int i = 0; i < n; ++i) {
//        ans[i] = i + 1;
//    }
//    for (int k = 0; k < n; ++k) {
//        sumt[k] = (sumt[k] + 1) % h;
//
//        for (int i = 0; i < n; ++i) {
//            int flag = 0;
//            for (int j = 0; j < n; ++j) {
//                if (i == j || j == k) {
//                    continue;
//                }
//                if (sumt[i] == t[j]) {
//                    vector<int> res;
//                    set_intersection(v[i].begin(), v[i].end(), v[j].begin(), v[j].end(), back_inserter(res));
//                    if (!res.empty()) {
//                        sumt[j] = (t[j] + 1) % h;
//                    }
//                }
//            }
//        }
//        vector<int> cans;
//        for (int i = 0; i < n; ++i) {
//            if (t[i] != sumt[i]) {
//                cans.push_back(i + 1);
//            }
//        }
//        if (cans.size() < ans.size()) {
//            ans.resize(cans.size());
//            for (int i = 0; i < cans.size(); ++i) {
//                ans[i] = cans[i];
//            }
//        }
//
//        sumt[k]--;
//        if (sumt[k] == -1) {
//            sumt[k] += h;
//        }
//    }
//    cout << ans.size() << endl;
//    for (int i : ans) {
//        cout << i << " ";
//    }
//    cout << endl;
}