#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#define endl '\n'

using namespace std;

typedef long long ll;

int main() {
    string s;
    cin >> s;
    set<int> set1, set0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '0') {
            set0.insert(i);
        }
        else {
            set1.insert(i);
        }
    }
    vector<vector<int>> ans;
    while (!set0.empty()) {
        int state = 0, flag = 1;
        int ind = -1;
        ans.push_back({});
        while (flag) {
            if (state == 0) {
                if (set0.empty() || set0.upper_bound(ind) == set0.end()) {
                    flag = 0;
                    break;
                }
                ind = *set0.upper_bound(ind);
                set0.erase(ind);
                ans.back().push_back(ind);
                state = 1;
            }
            else {
                if (set1.empty() || set1.upper_bound(ind) == set1.end()) {
                    flag = 0;
                    break;
                }
                ind = *set1.upper_bound(ind);
                set1.erase(ind);
                ans.back().push_back(ind);
                state = 0;
            }
        }
        if (state == 0) {
            cout << -1 << endl;
            return 0;
        }
    }
    if (!set1.empty()) {
        cout << -1 << endl;
        return 0;
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.size() << " ";
        for (int j : i) {
            cout << j + 1 << " ";
        }
        cout << endl;
    }
}