#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()

typedef long long ll;

const int INF = 1e9;
const int MAXN = 20;

void bye() {
    cout << "\n";
    exit(0);
}

int n, m, h;
vector<vector<int> > g;
vector<bool> can;
vector<int> upd;
vector<bool> used;

void dfs(int v) {
    used[v] = 1;
    can[v] = 1;
    for (auto to : g[v]) {
        if ((upd[v] + 1) % h == upd[to]) {
            can[v] = 0;
        }
        if (!used[to]) {
            dfs(to);
        }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> h;
    g.resize(n);
    used.resize(n);
    can.resize(n);
    upd.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> upd[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (can[i]) {
            cout << 1 << "\n";
            cout << i + 1;
            bye();
        }
    }
    cout << n << "\n";
    for (int i = 1; i <= n; i++) {
        cout << i << " ";
    }
    bye();
}
