#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()

typedef long long ll;

const int INF = 1e9;
const int MAXN = 20;

void bye() {
    cout << "\n";
    exit(0);
}

int n, m, h;
vector<vector<int> > g;
vector<int> ord;
vector<int> upd;
vector<bool> used, can;
vector<vector<int> > gp;
vector<vector<int> > gpp;
vector<vector<int> > cnt;

void dfs(int v) {
    used[v] = 1;
    can[v] = 1;
    for (auto to : g[v]) {
        if ((upd[v] + 1) % h == upd[to]) {
            // cout << v << " " << to << " " << upd[v] << " " << upd[to] << "\n";
            can[v] = 0;
            gp[v].push_back(to);
            gpp[to].push_back(v);
        }
        if (!used[to]) {
            dfs(to);
        }
    }
}

void dfs1(int v) {
    used[v] = 1;
    for (auto to : gp[v]) {
        if (!used[to]) {
            dfs1(to);
        }
    }
    ord.push_back(v);
}

void dfs2(int v) {
    used[v] = 1;
    cnt.back().push_back(v);
    for (auto to : gpp[v]) {
        if (!used[to]) {
            dfs2(to);
        }
    }
}

bool check(vector<int>& ans) {
    vector<bool> nowU(size(g));
    for (int i = 0; i < size(ans); i++) {
        nowU[ans[i]] = 1;
    }
    for (auto v : ans) {
        for (auto to : gp[v]) {
            if (!nowU[to]) {
                return 0;
            }
        }
    }
    return 1;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> h;
    g.resize(n);
    used.resize(n);
    can.resize(n);
    upd.resize(n);
    gp.resize(n);
    gpp.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> upd[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (can[i]) {
            cout << 1 << "\n";
            cout << i + 1;
            bye();
        }
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    used.assign(n, 0);
    reverse(ord.begin(), ord.end());
    for (auto v : ord) {
        if (!used[v]) {
            cnt.push_back({});
            dfs2(v);
        }
    }
    int ans = n + 1;
    int pos = 0;
    cnt.push_back({});
    for (int i = 0; i < n; i++) {
        cnt.back().push_back(i);
    }
    for (int i = 0; i < size(cnt); i++) {
        if (size(cnt[i]) > 1 && size(cnt[i]) < ans && check(cnt[i])) {
            ans = size(cnt[i]);
            pos = i;
        }
    }
    cout << ans << "\n";
    for (auto v : cnt[pos]) {
        cout << v + 1 << " ";
    }
    bye();
}
