#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const int INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

vector<int> tree;
vector<int> tree1;
string s0, s1;

void build1(int v, int l, int r) {
    if (l + 1 == r) {
        tree1[v] = (s1[l] == '0');
        return;
    }
    int mid = (l + r) / 2;
    build1(2 * v + 1, l, mid);
    build1(2 * v + 2, mid, r);
    tree1[v] = tree1[2 * v + 1] + tree1[2 * v + 2];
}

void upd1(int v, int l, int r, int pos, int val) {
    if (l + 1 == r) {
        tree1[v] = val;
        return;
    }
    int mid = (l + r) / 2;
    if (mid > pos) {
        upd1(2 * v + 1, l, mid, pos, val);
    } else {
        upd1(2 * v + 2, mid, r, pos, val);
    }
    tree1[v] = tree1[2 * v + 1] + tree1[2 * v + 2];
}

int leftmost1(int v, int l, int r, int ql, int qr) {
    if (r <= ql) {
        return -1;
    }
    if (tree1[v] == r - l) {
        return -1;
    }
    if (l + 1 == r) {
        return l;
    }
    int mid = (l + r) / 2;
    int req = leftmost1(2 * v + 1, l, mid, ql, qr);
    if (req == -1) {
        return leftmost1(2 * v + 2, mid, r, ql, qr);
    }
    return req;
}





void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = (s0[l] == '1');
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v + 1, l, mid);
    build(2 * v + 2, mid, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void upd(int v, int l, int r, int pos, int val) {
    if (l + 1 == r) {
        tree[v] = val;
        return;
    }
    int mid = (l + r) / 2;
    if (mid > pos) {
        upd(2 * v + 1, l, mid, pos, val);
    } else {
        upd(2 * v + 2, mid, r, pos, val);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int leftmost(int v, int l, int r, int ql, int qr) {
    // cout << v << " " << l << " " << r << " " << ql << " " << qr << "\n";
    if (r <= ql) {
        return -1;
    }
    if (tree[v] == r - l) {
        return -1;
    }
    if (l + 1 == r) {
        return l;
    }
    int mid = (l + r) / 2;
    int req = leftmost(2 * v + 1, l, mid, ql, qr);
    if (req == -1) {
        return leftmost(2 * v + 2, mid, r, ql, qr);
    }
    return req;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    string s;
    cin >> s;
    s0 = s;
    int h = 1;
    while (h < size(s)) {
        h *= 2;
    }
    while (size(s0) <= h) {
        s0 += '1';
    }
    tree.resize(2 * h);
    tree1.resize(2 * h);
    build(0, 0, h);
    s1 = s;
    while (size(s1) <= h) {
        s1 += '0';
    }
    build1(0, 0, h);
    // for (auto v : tree) {
    //     cout << v << " ";
    // }
    // cout << "\n";
    // for (auto v : tree1) {
    //     cout << v << " ";
    // }
    vector<int> nxt(size(s));
    vector<bool> used(size(s));
    for (int i = 0; i < size(s); i++) {
        if (s[i] == '0') {
            int next = leftmost1(0, 0, h, i + 1, h);
            if (next != -1) {
                used[next] = 1;
                upd1(0, 0, h, next, 1);
            }
            nxt[i] = next;
        } else {
            if (!used[i]) {
                cout << -1 << "\n";
                bye();
            }
            int next = leftmost(0, 0, h, i + 1, h);
            if (next == -1) {
                cout << -1 << "\n";
                bye();
            } else {
                used[next] = 1;
                upd(0, 0, h, next, 1);
            }
            nxt[i] = next;
        }
        // cout << nxt[i] << " ";
    }
    // bye();
    used.assign(size(s), 0);
    vector<vector<int> > ans;
    for (int i = 0; i < size(s); i++) {
        if (!used[i]) {
            int now = i;
            ans.push_back({});
            while (now != -1) {
                used[now] = 1;
                ans.back().push_back(now);
                now = nxt[now];
            }
        }
    }
    cout << size(ans) << "\n";
    for (int i = 0; i < size(ans); i++) {
        cout << size(ans[i]) << " ";
        for (auto v : ans[i]) {
            cout << v + 1 << " ";
        }
        cout << "\n";
    }
    bye();
}
