#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

vector<int> toprint;

bool check(vector<int>& res, vector<int>& a) {
    vector<vector<bool>> dp(res.size() + 1, vector<bool>(2000));
    dp[0][1000] = true;
    for (int i = 0; i < res.size(); ++i) {
        for (int j = 0; j < 2000; ++j) {
            if (dp[i][j]) {
                dp[i + 1][j] = dp[i + 1][j + res[i]] = true;
            }
        }
    }
    for (int i = 0; i < a.size(); ++i) {
        if (!dp[res.size()][a[i] + 1000]) {
            return false;
        }
    }
    return true;
}

void getRes(int n, vector<int>& tores, vector<int>& res, vector<int>& a) {
    if (n >= res.size()) {
        if (tores.size() < toprint.size()) {
            if (check(tores, a)) {
                toprint.resize(tores.size());
                for (int i = 0; i < toprint.size(); ++i) {
                    toprint[i] = tores[i];
                }
            }
        }
    } else {
        getRes(n + 1, tores, res, a);
        tores.push_back(res[n]);
        getRes(n + 1, tores, res, a);
        tores.pop_back();
    }
}

int main() {
    toprint.resize(1000);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> res;
    for (int i = 0; i <= 7; ++i) {
        res.push_back(1 << i);
        res.push_back(-(1 << i));
    }
    vector<int> tores;
    getRes(0, tores, res, a);
    cout << toprint.size() << endl;
    for (int i = 0; i < toprint.size(); ++i) {
        cout << toprint[i] << " ";
    }
    return 0;
}
