#include <iostream>
#include <vector>

using namespace std;

int k = 0;
int j;
int n;
vector<int> ans;
int first;

void dfs(vector<vector<int> >& g, int v, vector<int>& used, vector<int>& s)
{
    used[v] = -2;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (used[g[v][i]] == -1)
        {
            dfs(g, g[v][i], used, s);
        }
    }
    used[v] = k;
    s[k] = v;
    k++;
    if (used[v] == n - 1)
        first = v;
    return;
}

bool dfs1(vector<vector<int> >& g, int v, vector<int>& used)
{
    j--;
    used[v] = -1;
    bool u = false;
    if (j == 0)
        u = true;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (used[g[v][i]] != -1)
        {
            u = (dfs1(g, g[v][i], used) | u);
        }
    }
    if (u)
    {
        ans.push_back(v + 1);
        return true;
    }
    return false;
}

int main()
{
    int m, h;
    cin >> n >> m >> h;
    j = n;
    int u[n];
    for (int i = 0; i < n; i++)
        cin >> u[i];
    vector<vector<int> > g(n);
    vector<vector<int> > g1(n);
    vector<int> s(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (u[a] - u[b] == 1 || (u[a] == 0 && u[b] == h - 1))
        {
            g[b].push_back(a);
            g1[a].push_back(b);
        }
        if (u[b] - u[a] == 1 || (u[b] == 0 && u[a] == h - 1))
        {
            g[a].push_back(b);
            g1[b].push_back(a);
        }
    }

    vector<int> used(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (used[i] == -1)
            dfs(g, i, used, s);
    }
    for (int i = n - 1; i >= 0; i--)
    {
        if (used[s[i]] != -1)
            dfs1(g1, s[i], used);
    }
    cout << ans.size() << endl;
    for (int i = 0; i < (int) ans.size(); i++)
        cout << ans[i] << " ";
}
