#include <iostream>
#include <string>
#include <vector>

using namespace std;

int find_nearest(vector<bool>& used, bool k, vector<int>& a0, vector<int>& a1, int i)
{
    if (k)
    {
        if (a1[i] == -1)
            return -1;
        if (used[a1[i]])
        {
            int p = find_nearest(used, k, a0, a1, a1[i]);
            a1[i] = p;
            return p;
        }
        return a1[i];
    }
    else
    {
        if (a0[i] == -1)
            return -1;
        if (used[a0[i]])
        {
            int p = find_nearest(used, k, a0, a1, a0[i]);
            a0[i] = p;
            return p;
        }
        return a0[i];
    }
}

int main()
{
    string s;
    cin >> s;
    int n = s.size();
    int last0 = -1;
    int last1 = -1;
    vector<int> a0(n);
    vector<int> a1(n);
    for (int i = n - 1; i >= 0; i--)
    {
        a0[i] = last0;
        a1[i] = last1;
        if (s[i] == '0')
            last0 = i;
        else
            last1 = i;
    }
    vector<vector<int> > ans;
    int j = -1;
    vector<bool> used(n, false);
    for (int e = 0; e < n; e++)
    {
        if (used[e])
            continue;
        if (s[e] == '1')
        {
            cout << -1;
            return 0;
        }
        ans.resize(ans.size() + 1);
        j++;
        bool k = true;
        int i = e;
        while (true)
        {
            ans[j].push_back(i + 1);
            used[i] = true;
            if (k)
            {
                i = find_nearest(used, k, a0, a1, i);
                k = false;
                if (i == -1)
                    break;
            }
            else
            {
                i = find_nearest(used, k, a0, a1, i);
                k = true;
                if (i == -1)
                {
                    cout << -1;
                    return 0;
                }
            }
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < (int) ans.size(); i++)
    {
        cout << ans[i].size() << " ";
        for (int e = 0; e < (int) ans[i].size(); e++)
            cout << ans[i][e] << " ";
        cout << endl;
    }
}
