#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define ff first
#define ss second
#define int long long

using namespace std;

typedef long long ll;

int n, m, h;
vector<int> t;
vector<pair<int, int>> c;
vector<vector<int>> g, g2;
vector<set<int>> g3;
vector<bool> used;
vector<int> top;
vector<vector<int>> z;
vector<ll> sum;
vector<int> who;

void dfs1(int i) {
    used[i] = 1;
    for (auto el: g[i]) {
        if (!used[el]) dfs1(el);
    }
    top.push_back(i);
}

void dfs2(int i) {
    used[i] = 0;
    z[z.size() - 1].push_back(i + 1);
    who[i] = z.size() - 1;
    //cout << "$ " << i + 1 << endl;
    for (auto el: g2[i]) {
        //cout << el << endl;
        if (used[el]) {
            dfs2(el);
        }
    }
}

void dfs3(int i) {
    sum[i] = z[i].size();
    for (auto el: g3[i]) {
        if (sum[el] == -1) {
            dfs3(el);
            sum[i] += sum[el];
        } else {
            sum[i] += sum[el];
        }
    }
}


signed main() {
    cin >> n >> m >> h;
    t.resize(n);
    for (int i = 0; i < n; i++) cin >> t[i];
    c.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i].ff >> c[i].ss;
        c[i].ff--, c[i].ss--;
    }
    g.resize(t.size());
    g2.resize(t.size());
    used.resize(t.size());
    for (int i = 0; i < m; i++) {
        //cout << c[i].ff << " " << c[i].ss << endl;
        if (t[c[i].ff] == (t[c[i].ss] + 1) % h) {
            g[c[i].ss].push_back(c[i].ff);
            g2[c[i].ff].push_back(c[i].ss);
        }

        if (t[c[i].ss] == (t[c[i].ff] + 1) % h) {
            g[c[i].ff].push_back(c[i].ss);
            g2[c[i].ss].push_back(c[i].ff);
        }
    }
    for (int i = 0; i < g.size(); i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    who.resize(t.size());
    reverse(top.begin(), top.end());
    //cout << "TOP: " <<endl;
    for (auto i: top) {
        //cout << "# " << i + 1<< endl;
        if (used[i]) {
            //cout << "! " << i + 1<< endl;
            z.push_back({});
            dfs2(i);
        }
    }
    g3.resize(z.size());
    sum.resize(z.size(), -1);
    //cout << endl << endl;
    for (int i = 0; i < n; i++) {
        for (auto el: g[i]) {
            g3[who[i]].insert(who[el]);
            //cout << who[i] + 1 << " " << who[el] + 1 << endl;
        }
    }
    for (int i = 0; i < sum.size(); i++) {
        if (sum[i] == -1) {
            dfs3(i);
        }
    }

    /*cout << "Z: " << endl;
    for (auto el: z) {
        for (auto el1: el) cout << el1 << " ";
        cout << endl;
    }
    cout << endl;

    cout << "SUM: " << endl;
    for (auto el: sum) cout << el << " ";
    cout << endl;*/

    int mn_i = 0;
    for (int i = 0; i < z.size(); i++) {
        if (sum[i] < sum[mn_i]) mn_i = i;
    }
    cout << z[mn_i].size() << endl;
    for (auto el: z[mn_i]) cout << el << " ";
    cout << endl;
    return 0;
}

/*
5 5
1 2
2 3
3 4
4 1
2 5


4 4
2 1
2 3
3 4
4 2

4 3
1 2
2 3
3 1


*/

