#include <bits/stdc++.h>
using namespace std;

int n, m, h, timer;

vector<vector<int>> g, r;
vector<bool> used;
vector<int> ans, a, tin, fup;
vector<vector<int>> comp;
map<pair<int, int>, bool> was;

void dfs(int v)
{
    if(used[v])
        return;
    used[v] = true;
    comp.back().push_back(v);
    for(int to : r[v])
        if(was[{v, to}] == false)
            dfs(to);
}
void bridge(int v, int p = -1)
{
    used[v] = true;
    tin[v] = fup[v] = ++timer;
    for(int to : r[v])
    {
        if(to == p)
            continue;
        if(used[to])
            fup[v] = min(fup[v], tin[to]);
        else
        {
            bridge(to, v);
            fup[v] = min(fup[v], fup[to]);
            if(fup[to] > tin[v])
            {
                was[{v, to}] = true;
                was[{to, v}] = true;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> h;
    g.resize(n); a.resize(n);
    r.resize(n); used.resize(n);
    tin.resize(n); fup.resize(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < m; i++)
    {
        int a, b; cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    //check one vertex
    for(int i = 0; i < n; i++)
    {
        bool fit = true;
        for(int to : g[i])
            if(a[to] - a[i] == 1 || a[i] - a[to] == h - 1)
                fit = false;
        if(fit)
            cout << "1\n" << i + 1, exit(0);
    }
    //marking others
    for(int v = 0; v < n; v++)
        for(int to : g[v])
        {
            if(a[to] - a[v] == 1 || a[v] - a[to] == h - 1)
                r[v].push_back(to);
        }
    for(int i = 0; i < n; i++)
    {
        if(used[i])
            continue;
        bridge(i);
    }
    used.assign(n, 0);
    for(int i = 0; i < n; i++)
    {
        if(used[i])
            continue;
        comp.push_back({});
        dfs(i);
    }
    int ind = 0;
    for(int i = 0; i < comp.size(); i++)
    {
        if(comp[i].size() < comp[ind].size())
            ind = i;
    }
    cout << comp[ind].size() << endl;
    for(int i : comp[ind])
        cout << i + 1 << " ";
}
