#include <bits/stdc++.h>
using namespace std;

vector<int> pos = {-8, -4, -2, -1, 1, 2, 4, 8};
vector<vector<int>> cur;
vector<vector<vector<int>>> a;
map<vector<int>, bool> was;
int n;

void brute(int a, int ind, vector<bool> &used)
{
    if(ind == pos.size())
    {
        int sum = 0;
        for(int i = 0; i < pos.size(); i++)
            sum += pos[i] * used[i];
        if(a == sum)
        {
            vector<int> now;
            for(int i = 0; i < pos.size(); i++)
                if(used[i])
                    now.push_back(pos[i]);
            cur.push_back(now);
        }
        return;
    }
    brute(a, ind + 1, used);
    used[ind] = true;
    brute(a, ind + 1, used);
    used[ind] = false;
}

set<int> ans = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};

void dfs(int ind, vector<int> &ch)
{
    if(ind == n)
    {
        set<int> s;
        for(int i = 0; i < n; i++)
            for(int j : a[i][ch[i]])
                s.insert(j);
        if(s.size() < ans.size())
            ans = s;
        return;
    }
    for(int i = 0; i < a[ind].size(); i++)
    {
        ch[ind] = i;
        dfs(ind + 1, ch);
    }
}

int main()
{
    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i++)
    {
        int x; cin >> x;
        cur.clear();
        vector<bool> used(pos.size());
        brute(x, 0, used);
        a[i] = cur;
       /* for(auto j : a[i])
        {
            for(auto k : j)
                cout << k << " ";
            cout << endl;
        }
        cout << endl;*/
    }
    vector<int> ch(n);
    dfs(0, ch);
    cout << ans.size() << endl;
    for(int i : ans)
        cout << i << " ";
}
