#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse2,ssse3,sse4,avx,abm,mmx,tune=native")



#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
#define endl '\n'
#define int long long
using namespace std;
void solve();
signed main(){

    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    solve();

    return 0;
}





























int n, m, h;
vector<vector<int>> graph, graphinv, graphcond;
vector<bool> used;
vector<int> color, times;
vector<int> order;
int cur_col = 0;



void DFS(int v){
    used[v] = true;
    for (auto u : graph[v])
        if (!used[u])
            DFS(u);
    order.push_back(v);
}

void DFSinv(int v){
    used[v] = true;
    color[v] = cur_col;
    for (auto u : graphinv[v]) {
        if (!used[u])
            DFSinv(u);
    }
}




void solve(){
    cin >> n >> m >> h;
    graph.resize(n); graphinv.resize(n); times.resize(n); for (int i = 0; i < n; ++i) cin >> times[i];
    int v, u;
    for (int i = 0; i < m; ++i){
        cin >> v >> u; v--; u--;
        if ((times[v] + 1) % h == times[u]){
            graph[v].push_back(u);
            graphinv[u].push_back(v);
        }
        if ((times[u] + 1) % h == times[v]){
            graph[u].push_back(v);
            graphinv[v].push_back(u);
        }
    }

    used.assign(n, false);
    for (int i = 0; i < n; ++i)
        if (!used[i])
            DFS(i);
    reverse(order.begin(), order.end());
    used.assign(n, false);
    color.resize(n, -1);


    for (auto i : order){
        if (!used[i]){
            DFSinv(i);
            cur_col++;
        }
    }

    graphcond.resize(cur_col); vector<int> cnt(cur_col);
    for  (v = 0; v < n; ++v){
        cnt[color[v]]++;
        for (auto u : graph[v])
            if (color[v] != color[u])
                graphcond[color[v]].push_back(color[u]);
    }
    int res = (int) 1e9 + 7, best = 0;
    for (int i = 0; i < cur_col; ++i){
        if (graphcond[i].size() == 0 && cnt[i] < res)
            res = cnt[i], best = i;
    }
    cout << res << endl;
    for (int i = 0; i < n; ++i)
        if (color[i] == best)
            cout << i + 1 << ' ';

}











































