#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<cmath>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<fstream>
#include<deque>
#include<unordered_map>
#include<unordered_set>

#define ll long long
#define ld long double
#define pii pair<ll,ll>
#define mp make_pair
//#define cin fin
//#define cout fout

using namespace std;

const ll NMAX=211111;
const ll M=1e9+7;
const ll inf=2e9;

ll u[NMAX];
ll n,m,h;

vector<ll> g[NMAX];
vector<ll> tg[NMAX];

ll modh(ll a)
{
	return (a<h)?a:a-h;
}

ll dp[NMAX];
ll used[NMAX];
vector<ll> tsrt;
ll color[NMAX];
set<ll> cg[NMAX];

void dfs1(ll v)
{
	used[v]=1;
	for(ll i=0;i<g[v].size();i++)
	{
		if(!used[g[v][i]])
		{
			dfs1(g[v][i]);
		}
	}
	tsrt.push_back(v);
}

void dfs2(ll v,ll col)
{
	color[v]=col;
	used[v]=1;
	for(ll i=0;i<tg[v].size();i++)
	{
		if(!used[tg[v][i]])
		{
			dfs2(tg[v][i],col);
		}
	}
}

ll cnt[NMAX];

ll ans(ll v)
{
	if(dp[v]!=0)
		return dp[v];
	dp[v]=cnt[v];
	for(auto it=cg[v].begin();it!=cg[v].end();it++)
	{
		dp[v]+=ans(*it);
	}
	return dp[v];
}

int main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin>>n>>m>>h;
	for(ll i=1;i<=n;i++)
		cin>>u[i];
	for(ll i=1;i<=m;i++)
	{
		ll c1,c2;
		cin>>c1>>c2;
		if(u[c2]==modh(u[c1]+1))
		{
			g[c1].push_back(c2);
			tg[c2].push_back(c1);
		}
		if(u[c1]==modh(u[c2]+1))
		{	
			g[c2].push_back(c1);
			tg[c1].push_back(c2);
		}
	}
	for(ll i=1;i<=n;i++)
		if(!used[i])
			dfs1(i);
	for(ll i=1;i<=n;i++)
		used[i]=0;
	ll las=1;
	for(ll i=tsrt.size()-1;i>=0;i--)
	{
		if(!used[tsrt[i]])
		{
			dfs2(tsrt[i],las);
			las++;
		}
	}
	for(ll v=1;v<=n;v++)
	{
		for(auto it=g[v].begin();it!=g[v].end();it++)
		{
			if(color[v]!=color[*it])
				cg[color[v]].insert(color[*it]);
		}
	}
	for(ll i=1;i<=n;i++)
	{
		cnt[color[i]]++;
	}
	ll res=1;
	for(ll i=2;i<las;i++)
	{
		if(ans(res)>ans(i))
		{
			res=i;
		}
	}
	cout<<ans(res)<<endl;
	for(ll i=1;i<=n;i++)
	{
		if(color[i]==res)
			cout<<i<<' ';
	}
	return 0;
}