#include <bits/stdc++.h>

using namespace std;

vector<int> g[100500];
vector<int> ans;
vector<int> used(100500);
vector<int> cost(100500);
int n, m, h;

void dfs(int x)
{
    int t = (cost[x] + 1) % h;
    used[x] = 1;
    ans.push_back(x);
    for(int i : g[x])
    {
        if(cost[i] == t && !used[i]) dfs(i);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.precision(20); cout.tie(); cin.tie();
    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++)
    {
        cin >> cost[i];
    }
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int minans = INT_MAX;
    vector<int> bestans;
    for(int i = 1; i < n + 1; i++)
    {
        ans.clear();
        fill(used.begin(), used.end(), 0);
        dfs(i);
        if(ans.size() < minans) minans = ans.size(), bestans = ans;
    }
    cout << minans << endl;
    sort(bestans.begin(), bestans.end());
    for(int i : bestans) cout << i << " ";
}