#include <bits/stdc++.h>

using namespace std;

vector<int> g[100500];
vector<int> ans(100500);
int cnt = 0;
vector<int> used(100500);
vector<int> cost(100500);
int n, m, h;

void dfs(int x)
{
    int t = (cost[x] + 1) % h;
    used[x] = 1;
    ans[cnt] = x;
    cnt++;
    for(int i : g[x])
    {
        if(cost[i] == t && !used[i]) dfs(i);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.precision(20); cout.tie(); cin.tie();
    scanf("%d %d %d", &n, &m, &h);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d", &cost[i]);
    }
    for(int i = 0; i < m; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int minans = INT_MAX;
    vector<int> bestans;
    for(int i = 1; i < n + 1; i++)
    {
        cnt = 0;
        fill(used.begin(), used.end(), 0);
        dfs(i);
        if(minans > cnt) minans = cnt, bestans = ans;
    }
    printf("%d\n", minans);
    sort(bestans.begin(), bestans.begin() + minans);
    for(int i = 0; i < minans; i++)
    {
        printf("%d ", bestans[i]);
    }
}