#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<stdio.h>
#include<algorithm>
#include<stack>
#include<set>
#include<map>
#include<queue>
#include<tuple>
#include<string>

using namespace std;

void dfs(int v,vector<vector<int>>&g,vector<int>&down){
	down[v]=0;
	int ans=0;
	for(int i=0;i<g[v].size();i++){
		if(down[g[v][i]]==-1){
			dfs(g[v][i],g,down);
		}
		ans+=down[g[v][i]];
	}
	down[v]=ans+1;
}

void rd(int v,vector<vector<int>>&g,vector<int>&down){
	for(int i=0;i<g[v].size();i++){
		if(down[g[v][i]]<down[v]){
			down[g[v][i]]=down[v];
			rd(g[v][i],g,down);
		}
	}
}

void out(int v,vector<vector<int>>&g,vector<bool>&used,vector<int>&ans){
	used[v]=1;
	ans.push_back(v);
	for(int i=0;i<g[v].size();i++){
		if(!used[g[v][i]]){
			out(g[v][i],g,used,ans);
		}
	}
}
int main(){
	int n,m,h;
	cin>>n>>m>>h;
	queue<int>q;
	vector<int>v(n);
	vector<vector<int>>g(n),rg(n);
	for(int i=0;i<n;i++){
		cin>>v[i];
	}
	for(int i=0;i<m;i++){
		int a,b;
		cin>>a>>b;
		--a;
		--b;
		if(v[a]==(v[b]+1)%h){
			g[b].push_back(a);
			rg[a].push_back(b);
		}
		if(v[b]==(v[a]+1)%h){
			g[a].push_back(b);
			rg[b].push_back(a);
		}
	}
	vector<int>down(n,-1);
	for(int i=0;i<n;i++){
		if(down[i]==-1){
			dfs(i,g,down);
			rd(i,rg,down);
		}
	}
	int ans=n,mm=0;
	for(int i=0;i<n;i++){
		if(down[i]<ans){
			ans=down[i];
			mm=i;
		}
	}
	vector<int>ac;
	vector<bool>used(n,0);
	out(mm,g,used,ac);
	cout<<ac.size()<<'\n';
	for(int i=0;i<ac.size();i++){
		cout<<ac[i]+1<<' ';
	}
}