#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const ll inf = 1000000000;

ll kol_vo_ver, kol_vo_reb, day_h;
vector<vector<ll> > v;
vector<ll> used;
vector<ll> need;
vector<ll> when;
set<pair<int, int> > st;

void init(){
    v.resize(kol_vo_ver);
    need.resize(kol_vo_ver, 1);
    used.resize(kol_vo_ver);
    when.resize(kol_vo_ver);
}

void dfs(ll ver){
    used[ver] = 1;
    ll be = (when[ver] + 1) % day_h;
    for(auto to : v[ver]){
        if(when[to] == be){
            if(used[to] == 1){
                need[ver] = inf;
                used[ver] = 2;
                return;
            }
            if(used[to] == 2)need[ver] += need[to];
            else {
                dfs(to);
                need[ver] += need[to];
            }
        }
    }
    used[ver] = 2;
}

void make_path(ll ver){
    cout << ver + 1 << " ";
    //used[ver] = 1;
    ll be = (when[ver] + 1) % day_h;
    for(auto to : v[ver]){
        if(when[to] == be)dfs(to);
    }
    //used[ver] = 2;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    cin >> kol_vo_ver >> kol_vo_reb >> day_h;
    init();
    for(ll c=0; c<kol_vo_ver; c++)
        cin >> when[c];
    for(ll c=0; c<kol_vo_reb; c++){
        ll e, e1;
        cin >> e >> e1;
        e--; e1--;
        if(e > e1)swap(e, e1);
        if(st.find({e, e1}) != st.end())continue;
        v[e].push_back(e1);
        v[e1].push_back(e);
        st.insert({e, e1});
    }
    for(ll c=0; c<kol_vo_ver; c++){
        if(!used[c])dfs(c);
    }
    ll mmin = inf, beg = 0;
    for(ll c=0; c<kol_vo_ver; c++){
        if(mmin > need[c]){
            mmin = need[c];
            beg = c;
        }
    }
    if(mmin >= 100001){
        cout << kol_vo_ver << endl;
        for(int c=0; c<kol_vo_ver; c++)
            cout << c + 1 << " ";
    }
    else {
        cout << mmin << endl;
        /*for(int c=0; c<kol_vo_ver; c++)
            used[c] = false;*/
        make_path(beg);
    }
    return 0;
}
