#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define optimaze ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()

typedef vector<int> vint;
typedef pair<int,int> pii;
typedef long double ld;

template<typename T> istream& operator >> (istream& in, vector<T>& v){ for(int i = 0;i<v.size();i++) in >> v[i]; return in; }
template<typename T> ostream& operator << (ostream& out, vector<T>& v){ for(int i = 0;i<v.size();i++) out << v[i] << " "; return out; }

struct G{
	vint to;
	int h, dp = -1;
	int t = -1;
};

vector<G> g;
int n,m,h;

int timer = 0;

int ab(int v){
	return (v+1)%h;
}

queue<int> upd;
bool isupd = 0;

int solve(int v){
	if(g[v].t == timer){
		isupd = 1;
		return 0;
	}
	if(g[v].dp != -1) return g[v].dp;
	g[v].dp = 1;
	g[v].t = timer;
	for(int u : g[v].to){
		if(g[u].h == ab(g[v].h)){
			g[v].dp += solve(u);
		}
	}
	if(isupd){
		upd.push(v);
	}
	return g[v].dp;
}

vint res;

void dfs(int v){
	if(g[v].t == timer) return;
	g[v].t = timer;
	for(int u : g[v].to){
		if(g[u].h == ab(g[v].h)){
			dfs(u);
		}
	}
	res.push_back(v + 1);
}

set<pii> w;

signed main(){
optimaze;
#ifdef _SANYA
	freopen("abc.txt", "r", stdin);
	cout.rdbuf(cerr.rdbuf());
#endif
	cin >> n >> m >> h;
	g.resize(n); 
	for(int i = 0;i<n;i++){
		cin >> g[i].h;
	}
	for(int i = 0;i<m;i++){
		int a,b; cin >> a >> b; a--;b--;
		pii ab = {a,b};
		if(ab.first > ab.second) swap(ab.first, ab.second);
		if(w.find(ab) != w.end()) continue;
		w.insert(ab);
		g[a].to.push_back(b);
		g[b].to.push_back(a);
	}

	int ans = 1e9, ti;
	for(int i = 0;i<n;i++){
		isupd = 0;
		int q = solve(i);
		while(!upd.empty()){
			int v = upd.front(); upd.pop();
			g[v].dp = q;
		}
		if(ans > q){
			ans = q;
			ti = i;
		}
		timer++;
	}
	if(ans == 1e9) return -1;

	cout << ans << endl;

	dfs(ti);
	if(ans != res.size()) return -1;
	cout << res << endl;

	return 0;
}