#pragma comment(linker, "/STACK:536870912")
#pragma warning(disable:4996)

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include<iostream>
#include<algorithm>
#include<queue>
#include<string>
#include<vector>
#include<map>
#include<list>
#include<set>
#include<cstring>
#include<ctime>
#include<cmath>
#include<limits>
#include<iterator>
#include<functional>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<bitset>
#include<complex>

#define all(v) v.begin(), v.end()
#define setv(ar, val) memset(ar, val, sizeof(ar));
#define ll long long int
#define ull unsigned long long int
#define PI 3.1415926535897932384626433832795
using namespace std;

const int N = 1e5 + 100;
int u[N];
vector<int> v[N], g[N];
vector<int> ord;
bool used[N];
int col[N], sz[N], nleaf[N];
int c = 0;

void topo(int node) {
	if (used[node])
		return;
	used[node] = 1;
	for (int i = 0; i < v[node].size(); i++) {
		topo(v[node][i]);
	}
	ord.push_back(node);
}

void dfs(int node) {
	col[node] = c;
	sz[c]++;
	for (int i = 0; i < g[node].size(); i++) {
		int to = g[node][i];
		if (!col[to])
			dfs(to);
		else if (col[to] != c)
			nleaf[col[to]] = 1;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m, h;
	scanf("%d%d%d", &n, &m, &h);

	for (int i = 0; i < n; i++)
		scanf("%d", &u[i]);

	for (int i = 0; i < m; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;
		if ((u[x] + 1) % h == u[y]) {
			v[x].push_back(y);
			g[y].push_back(x);
		}
		if ((u[y] + 1) % h == u[x]) {
			v[y].push_back(x);
			g[x].push_back(y);
		}
	}

	for (int i = 0; i < n; i++)
		topo(i);

	for (int i = n - 1; i >= 0; i--) {
		if (!col[ord[i]]) {
			++c;
			dfs(ord[i]);
		}
	}

	int t = -1;
	for (int i = 1; i <= c; i++ ) {
		if (!nleaf[i] && (t == -1 || sz[t] > sz[i]))
			t =i;
	}

	printf("%d\n", sz[t]);
	for (int i = 0; i < n; i++)
		if (col[i] == t)
			printf("%d ", i + 1);





	return 0;
}