#pragma comment(linker, "/STACK:536870912")
#pragma warning(disable:4996)

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include<iostream>
#include<algorithm>
#include<queue>
#include<string>
#include<vector>
#include<map>
#include<list>
#include<set>
#include<cstring>
#include<ctime>
#include<cmath>
#include<limits>
#include<iterator>
#include<functional>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<bitset>
#include<complex>

#define all(v) v.begin(), v.end()
#define setv(ar, val) memset(ar, val, sizeof(ar));
#define ll long long int
#define ull unsigned long long int
#define PI 3.1415926535897932384626433832795
using namespace std;

const int N = 1e5 + 100;
ll a[N], t[N * 4];
int p, n, d, b;

void build(int v = 1, int L = 0, int R = n - 1) {
	if (L == R)
		t[v] = a[L];
	else {
		int m = (L + R) >> 1;
		build(v * 2, L, m);
		build(v * 2 + 1, m + 1, R);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}

ll que(int l, int r, int v = 1, int L = 0, int R = n - 1) {
	if (l > r)
		return 0;
	if (l == L && r == R)
		return t[v];
	int m = (L + R) >> 1;
	return que(l, min(m, r), v * 2, L, m) +
		que(max(m + 1, l), r, v * 2+ 1, m + 1, R);
}

void upd(int x, ll d, int v = 1, int L = 0, int R = n - 1) {
	if (L == R) {
		t[v] += d;
	}
	else {
		int m = (L + R) >> 1;
		if (x <= m)
			upd(x, d, v * 2, L, m);
		else
			upd(x, d, v * 2 + 1, m + 1, R);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	scanf("%d%d%d%d", &p, &n, &d, &b);

	for (int i = 0; i < n; i++)
		scanf("%lld", &a[i]);

	build();

	if (p == 1) {
		ll ans = 0, z = 0;
		for (int i = 0; i < n; i++) {
			ll t = min(d * (ll)(i + 1), (ll)(n - i - 1));

			ll g = min(a[i], z);
			upd(i, -g);
			a[i] -= g;
			z -= g;

			if (a[i] > b) {
				upd(i + t, a[i] - b);
				a[i + t] += a[i] - b;
			}
			else if (que(i, i + t) - z < b) {
				upd(i + t, a[i]);
				a[i + t] += a[i];
				ans++;
			}
			else {
				z += b - a[i];
			}
		}
		printf("%lld", ans);
		return 0;
	}

	ll ans = 0, z = 0, y = 0, xl = 0, xr = 0;
	for (int i = 0, j = n - 1; i < j; i++, j--) {
		ll t = min(d * (ll)(i + 1), (ll)(j - i));

		bool q = xl >= xr;
		if (q) {
			ll g = min(a[i], z);
			upd(i, -g);
			a[i] -= g;
			z -= g;

			if (a[i] > b) {
				upd(i + t, a[i] - b);
				a[i + t] += a[i] - b;
				upd(i, -a[i]);
			}
			else if (que(i, i + t) - z < b) {
				upd(i + t, a[i]);
				a[i + t] += a[i];
				xl++;
				upd(i, -a[i]);
			}
			else {
				upd(i, -a[i]);
				z += b - a[i];
			}
		}

		ll g = min(a[j], y);
		upd(j, -g);
		a[j] -= g;
		y -= g;

		if (a[j] > b) {
			upd(j - t, a[j] - b);
			a[j - t] += a[j] - b;
			upd(j, -a[j]);
		}
		else if (que(j - t, j) - y < b) {
			upd(j - t, a[j]);
			a[j - t] += a[j];
			upd(j, -a[j]);
			xr++;
		}
		else {
			upd(j, -a[j]);
			y += b - a[j];
		}

		if (!q) {
			ll g = min(a[i], z);
			upd(i, -g);
			a[i] -= g;
			z -= g;

			if (a[i] > b) {
				upd(i + t, a[i] - b);
				a[i + t] += a[i] - b;
			}
			else if (que(i, i + t) - z < b) {
				upd(i + t, a[i]);
				a[i + t] += a[i];
				xl++;
			}
			else {
				z += b - a[i];
			}
		}
	}

	if ((n & 1) && a[n / 2] - z - y < b)
		xl++;
	printf("%lld", max(xl, xr));

	return 0;
}