#include <bits/stdc++.h>
#define ll long long
#define dd long double
#define pb push_back
using namespace std;

const ll inf = 1e9 + 7;

/*
struct itemp{
    int k,y;
    item(){}
    item(int k) : k(k), y(rand()){}
};
typedef item *pitem;

void upd(pitem &v){
}

void split(pitem v, int k, pitem &l, pitem &r){
    if (!v)
        l = r = nullptr;
    else if (k<v->k)
        split(v->l, k, l, v->l), r = v;
    else
        split(v->r, k, v->r, r), l = v;
    upd(v);
}

void merg(pitem &v, pitem l, pitem r){
    if (!l || !r)
        v = (l? l : r);
    else if (l->y>r->y)
        merg(l->r, l->r, r), v = l;
    else
        merg(r->l, l, r->l), v = r;
    upd(v);
}

struct point{
    int x, y;
    point(){}
    point(double x, double y) : x(x), y(y){}
    point operator+(const point &b)const{
        return point(x + b.x, y + b.y);
    }
    point operator-(const point &b)const{
        return point(x - b.x, y - b.y);
    }
    double operator*(const point &b)const{
        return x*b.y - y*b.x;
    }
};*/

vector<int> graph[100000], ng[100000];
int hi[100000], h;
vector<bool> used(100000, 0), beg(100000, 1);

void dfs(int x){
    used[x] = 1;
    for (int j : graph[x]){
        if (!used[j])
            dfs(j);
        if ((hi[j] - hi[x] + h)%h== 1){
            ng[x].push_back(j);
        }
    }
}

void ndfs(int x){
    for(int j : ng[x]){
        if (beg[j]){
            beg[x] = 0;
            ndfs(j);
        }
    }
}

bool esc;

void cdfs(int x, int &c){
    used[x] = 1;
    c++;
    for (int j : ng[x]){
        if (!used[j] && beg[j])
            esc = 1;
        if (esc)
            return;
        if (!used[j])
            cdfs(j, c);
    }
}

void pdfs(int x){
    used[x] = 1;
    cout<<x+1<<' ';
    for (int j : ng[x])
        if (!used[j])
            pdfs(j);
}

int main(){
    freopen("input.txt","r", stdin);
    freopen("output.txt", "w", stdout);
    //ios::sync_with_stdio(false); cin.tie(0);cout.tie(0);
    int n, m, i;
    cin>>n>>m>>h;
    int x, y;
    for (i = 0; i<n; i++){
        cin>>hi[i];
    }
    for (i = 0; i<m; i++){
        cin>>x>>y;
        x--;
        y--;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    for (i = 0; i<n; i++){
        if (!used[i])
            dfs(i);
    }
    for (i = 0; i<n; i++){
        if (beg[i])
            ndfs(i);
    }
    int ans = inf, ansi, c;
    for (i = 0; i<n; i++){
        used.assign(n, 0);
        c = 0;
        esc = 0;
        cdfs(i, c);
        if (esc)
            beg[i] = 0;
        else if (c<ans)
            ans = c, ansi = i;
    }
    cout<<ans<<endl;
    used.assign(n, 0);
    pdfs(ansi);
}
