#include <bits/stdc++.h>
#define ll long long
#define dd long double
#define pb push_back
using namespace std;

const ll inf = 1e9 + 7;

/*
struct itemp{
    int k,y;
    item(){}
    item(int k) : k(k), y(rand()){}
};
typedef item *pitem;

void upd(pitem &v){
}

void split(pitem v, int k, pitem &l, pitem &r){
    if (!v)
        l = r = nullptr;
    else if (k<v->k)
        split(v->l, k, l, v->l), r = v;
    else
        split(v->r, k, v->r, r), l = v;
    upd(v);
}

void merg(pitem &v, pitem l, pitem r){
    if (!l || !r)
        v = (l? l : r);
    else if (l->y>r->y)
        merg(l->r, l->r, r), v = l;
    else
        merg(r->l, l, r->l), v = r;
    upd(v);
}

struct point{
    int x, y;
    point(){}
    point(double x, double y) : x(x), y(y){}
    point operator+(const point &b)const{
        return point(x + b.x, y + b.y);
    }
    point operator-(const point &b)const{
        return point(x - b.x, y - b.y);
    }
    double operator*(const point &b)const{
        return x*b.y - y*b.x;
    }
};*/

int pr = 1;
vector<int> tree;
vector<pair<int, int> > lr;

void build(int x){
    if (x>=pr)
        return;
    build(x*2);
    build(x*2 + 1);
    tree[x] = tree[x*2] + tree[x*2 + 1];
    lr[x] = {lr[x*2].first, lr[x*2 + 1].second};
}

int take(int l, int r, int v = 1){
    if (l==lr[v].first && r == lr[v].second)
        return tree[v];
    int ans = 0, r1 = lr[v*2].second, l1 = lr[v*2 + 1].first;
    if (l<=r1)
        ans+=take(l, min(r, r1), v*2);
    if (r>=l1)
        ans+=take(max(l, l1), r, v*2 + 1);
    return ans;
}

void decr(int x, int delta, int v = 1){
    tree[v]-=delta;
    if (v>=pr)
        return;
    if (v<=lr[v*2].second)
        decr(x, delta, v*2);
    else
        decr(x, delta, v*2 + 1);
}

int main(){
    freopen("input.txt","r", stdin);
    freopen("output.txt", "w", stdout);
    //ios::sync_with_stdio(false); cin.tie(0);cout.tie(0);
    int p, n, d , b, i;
    cin>>p>>n>>d>>b;
    while (pr<n)
        pr*=2;
    tree.assign(2*pr, 0);
    lr.assign(2*pr, {});
    set<pair<int, int> > st;
    for (i = pr; i<pr + n; i++){
        cin>>tree[i];
        st.insert({i - pr, tree[i]});
    }
    for (i = pr; i<2*pr; i++)
        lr[i] = {i - pr, i - pr};
    build(1);
    int c1 = 0, c2 = 0, l = 0, r = n-1, l1, r1, c, delta, k = 1;
    if (p==1)
        r = n;
    pair<int, int> temp1;
    while (l<r){
        k++;
        if (p==1 || (l<n-1 - r) || (n%2==1 && n - r == n/2) || (l == n-1 - r && c1<c2)){
            l1 = max(0, l - d*(k/2));
            r1 = min(n-1, l + d*(k/2));
            if (take(l1, r1)>=b){
                auto temp = st.lower_bound({l1, tree[pr + l1]});
                c = b;
                while (c>0){
                    delta = min(temp->second, c);
                    decr(temp->first, delta);
                    if (delta==temp->second)
                        st.erase(temp);
                    else{
                        temp1 = *temp;
                        st.erase(temp);
                        temp1.second-=delta;
                        st.insert(temp1);
                    }
                    temp++;
                    c-=delta;
                }
            }
            else
                c1++;
            l++;
        }
        else{
            l1 = max(0, r - d*(k/2)), r1 = min(n-1, r + d*(k/2));
            if (take(l1, r1)>=b){
                auto temp = --(st.upper_bound({r1, tree[pr + r1]}));
                c = b;
                while (c>0){
                    delta = min(temp->second, c);
                    decr(temp->first, delta);
                    if (delta==temp->second)
                        st.erase(temp);
                    else{
                        temp1 = *temp;
                        st.erase(temp);
                        temp1.second-=delta;
                        st.insert(temp1);
                    }
                    temp--;
                    c-=delta;
                }
            }
            else
                c2++;
            r--;
        }
    }
    if (p==2)
        cout<<max(c1, c2);
    else
        cout<<c1;
}
