#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define int long long
#define x first
#define y second
#define sqr(x) ((x) * (x))

const int INFINT = 1e9 + 20;
const ll INFLL = 1e18 + 20;
const ld pi = acos(-1);
const ld eps = 1e-12;
const int N = 2e5 + 20;
const int M = 1e3 + 20;
const int C = 1e2 + 20;

int t[N];
vector <int> g[N];
int used[N];
int n, m, h;
int ans = n + 1;
int r = 0;
int dp[N];

void dfs(int v) {
    used[v] = 1;
    for (int i : g[v])
        if (used[i] == 0) {
            dfs(i);
        } else if (used[i] == 1) {
            cout << n << endl;
            for (int i = 1; i <= n; i++)
                cout << i << ' ';
            exit(0);
        }
    used[v] = 2;
}


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if ((t[x] + 1) % h == t[y])
            g[x].push_back(y);
        if ((t[y] + 1) % h == t[x])
            g[y].push_back(x);
    }

    dfs(0);

    cout << 1 << endl;
    for (int i = 0; i < n; i++)
        if (g[i].size() == 0)
            return cout << i + 1, 0;
    return 0;
}
