#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <ld, ld> pld;

#define int long long
#define x first
#define y second
#define sqr(x) ((x) * (x))

const int INFINT = 1e9 + 20;
const ll INFLL = 1e18 + 20;
const ld pi = acos(-1);
const ld eps = 1e-12;
const int N = 2e5 + 20;
const int M = 1e3 + 20;
const int C = 1e2 + 20;

int t[N];
vector <int> g[N];
int used[N];
int dp[N];
vector <int> p;
vector <int> p1;

int dfs(int v) {
    used[v] = 1;
    int tmp = 1;
    for (int i : g[v]) {
        if (used[i] == 0)
            tmp += dfs(i);
        else if (used[i] == 1) {
            p.push_back(i);
        }

    }
    if (p.back() == v) {
        p1.push_back(v);
        dp[v] = tmp;
        p.pop_back();
    }
    used[v] = 2;
    return tmp;
}

void dfs1(int v) {
    used[v] = 1;
    cout << v + 1 << ' ';
    for (int i : g[v])
        if (used[i] == 0)
            dfs1(i);
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if ((t[x] + 1) % h == t[y])
            g[x].push_back(y);
        if ((t[y] + 1) % h == t[x])
            g[y].push_back(x);
    }
    for (int i = 0; i < n; i++)
        if (g[i].size() == 0)
         return cout << 1 << endl << i + 1, 0;

    int ans = n + 1;
    int r = 0;
    for (int i = 0; i < n; i++) {
        if (used[i] == 2)
            continue;
        dfs(i);
    }
    for (int i = 0; i < p1.size(); i++) {
        if (dp[p1[i]] < ans) {
            ans = dp[p1[i]];
            r = p1[i];
        }
    }

    //for (int i : p1)
     //   cout << i << ' ';
    //cout << endl;
    cout << ans << endl;
    for (int i = 0; i < n; i++)
        used[i] = 0;
    dfs1(r);
    return 0;
}
