#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) x.begin(), x.end()

const int MAXN = 1e5 + 5;

int n, m, h;
int t[MAXN];
vector<int> g0[MAXN];
bool used[MAXN];
vector<int> ts;
int cnt = 0;
vector<int> comp[MAXN];
int col[MAXN];
vector<int> g[MAXN];
int sz[MAXN];
vector<int> ans;
vector<int> gr[MAXN];

void top(int v) {
	used[v] = true;
	for (auto to : g0[v]) {
		if (!used[to]) {
			top(to);
		}
	}
	ts.push_back(v);
}

void cdfs(int v) {
	used[v] = true;
	comp[cnt].push_back(v);
	col[v] = cnt;
	for (auto to : gr[v]) {
		if (!used[to]) {
			cdfs(to);
		}
	}
}

void build_edges(int v) {
	for (auto to : g0[v]) {
		if (col[v] != col[to]) g[col[v]].push_back(col[to]);
	}
}

int dfs(int v) {
	used[v] = true;
	sz[v] = comp[v].size();
	for (auto to : g[v]) {
		if (!used[to]) {
			sz[v] += dfs(to);
		}
	}
	return sz[v];
}

int dfs1(int v) {
	ans.push_back(v);
	used[v] = true;
	for (auto to : g0[v]) {
		if (!used[to]) {
			dfs1(to);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> n >> m >> h;
	rep(i, n) {
		cin >> t[i];
	}

	rep(i, m) {
		int p, q;
		cin >> p >> q;
		p--;
		q--;
		if ((t[p] + 1) % h == t[q]) {
			g0[p].push_back(q);
			gr[q].push_back(p);
		}
		if ((t[q] + 1) % h == t[p]) {
			g0[q].push_back(p);
			gr[p].push_back(q);
		}
	}

	// cin >> n >> m;
	// rep(i, m) {
	// 	int p, q;
	// 	cin >> p >> q;
	// 	g0[p].push_back(q);
	// }


	rep(i, n) {
		if (!used[i]) {
			top(i);
		}
	}

	fill(used, used + n, false);
	rep(i, n) {
		if (!used[ts[i]]) {
			cdfs(ts[i]);
			cnt++;
		}
	}
	
	rep(i, n) {
		build_edges(i);
	}

	// rep(i, cnt) {
		// sort(all(g[i]));
		// g[i].erase(unique(all(g[i])), g[i].end());
		// cout << g[i].size() << " : ";
		// for (auto v : g[i]) {
		// 	cout << v << ' ';
		// } cout << endl;
	// }

	fill(used, used + n, false);
	for (int i = cnt - 1; i >= 0; --i) {
		if (!used[i]) {
			dfs(i);
		}
	}

	int mx = 0;
	rep(i, cnt) {
		if (sz[i] < sz[mx]) {
			mx = i;
		}
	}

	fill(used, used + n, false);
	dfs1(comp[mx][0]);

	cout << ans.size() << endl;
	for (auto v : ans) {
		cout << v + 1 << ' ';
	} cout << endl;
}
