#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define f first
#define s second
#define all(x) x.begin(), x.end()

const int MAXN = 2e5 + 5;

int n;
string s;
stack<int> white;
set<int> black;
int p[MAXN];
bool used[MAXN];

int main() {
	black.insert(-1);
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> s;
	n = s.size();
	fill(p, p + n, -2);
	for (int i = 0; i < n; ++i) {
		if (s[i] == '1') {
			if (white.empty()) {
				cout << "-1" << endl;
				return 0;
			}
			p[i] = white.top();
			auto it = prev(black.lower_bound(white.top()));
			p[white.top()] = *it;
			if (it != black.begin()) black.erase(it);
			white.pop();
			black.insert(i);
		} else {
			white.push(i);
		}
	}

	rep(i, n) {
		if (p[i] == -2) {
			auto it = prev(black.lower_bound(i));
			p[i] = *it;
			if (it != black.begin()) black.erase(it);
		}
	}

	if (black.size() > 1) {
		cout << "-1" << endl;
		return 0;
	}

	// rep(i, n) {
	// 	cout << p[i] << ' ';
	// } cout << endl;

	int k = 0;
	vector<vector<int>> ans;
	fill(used, used + n, false);
	for (int i = n - 1; i >= 0; --i) {
		if (used[i]) continue;
		ans.push_back(vector<int>());
		int v = i;
		while (v != -1) {
			used[v] = true;
			ans[k].push_back(v + 1);
			v = p[v];
		}
		k++;
	}

	cout << k << '\n';
	rep(i, k) {
		reverse(all(ans[i]));
		cout << ans[i].size() << ' ';
		rep(j, ans[i].size()) {
			cout << ans[i][j] << ' ';
		} cout << '\n';
	}
}