#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=1e5+7;

void solve();

#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}

vector<vector<int>> v(MAXN);
int tm1[MAXN];
bool used[MAXN];
set<pair<int,int>> s;

void dfs(int vert, int t){
    tm1[vert]=t;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
        if(used[v[vert][i]]){
            tm1[vert]=min(tm1[vert], tm1[v[vert][i]]);
        }
        else{
            dfs(v[vert][i], t+1);
            if(tm1[vert]<tm1[v[vert][i]]){
                s.emplace(vert, v[vert][i]);
            }
            else{
                tm1[vert]=tm1[v[vert][i]];
            }
        }
    }
}

int ans=0;
bool vp=0;
vector<int> vec;

void dfs1(int vert, bool b){
    if(b){
        vec.emplace_back(vert);
    }
    ans++;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
        if(!used[v[vert][i]]){
            dfs1(v[vert][i], b);
        }
    }
}

void solve(){
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> q;
	q.push_back(0);
    for(int i=1;i<=n;i++){
		int a;
        cin>>a;
		q.push_back(a);
    }
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        if((q[a]+1)%h==q[b]){
            v[a].emplace_back(b);
        }
        if((q[b]+1)%h==q[a]){
            v[b].emplace_back(a);
        }
    }
    int ot=INF, vert=-1;
    for(int i=1;i<=n;i++){
        memset(used, 0, sizeof(used));
        ans=0;
        dfs1(i, 0);
        if(ans<ot){
            ot=ans;
            vert=i;
        }
    }
    memset(used, 0, sizeof(used));
    dfs1(vert, 1);
    cout<<vec.size()<<"\n";
    for(int i=0;i<vec.size();i++){
        cout<<vec[i]<<" ";
    }
}
