#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

using namespace std;

#define mp make_pair

typedef long long ll;

const int INF=1e9+9;
const int MAXN=1e5+7;

void solve();

//#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*#ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG*/
    solve();
}

vector<vector<int>> v(MAXN);
int tm1[MAXN];
int ur[MAXN];
bool used[MAXN];
set<pair<int,int>> s;

void dfs(int vert, int t, int u){
	ur[vert]=u;
    tm1[vert]=t;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
        if(used[v[vert][i]]){
			if(ur[vert]==ur[v[vert][i]]){
				tm1[vert]=min(tm1[vert], tm1[v[vert][i]]);
			}
        }
        else{
            dfs(v[vert][i], t+ 1, u);
		}
        if(tm1[vert]<tm1[v[vert][i]] || ur[vert]!=ur[v[vert][i]]){
            s.insert(mp(vert, v[vert][i]));
        }
        else if(ur[vert]==ur[v[vert][i]]){
            tm1[vert]=min(tm1[vert], tm1[v[vert][i]]);
        }
    }
}

int ans=0;
bool vp=0;
vector<int> vec;

void dfs1(int vert, bool b){
    if(b){
        vec.emplace_back(vert);
    }
    ans++;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
		if(s.find(mp(vert, v[vert][i]))!=s.end()){
            vp=1;
			continue;
		}

        if(!used[v[vert][i]]){
            dfs1(v[vert][i], b);
        }
    }
}

void solve(){
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> q;
	q.push_back(0);
    for(int i=1;i<=n;i++){
		int a;
        cin>>a;
		q.push_back(a);
    }
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        if((q[a]+1)%h==q[b]){
            v[a].emplace_back(b);
        }
        if((q[b]+1)%h==q[a]){
            v[b].emplace_back(a);
        }
    }
	int now=1;
    for(int i=1;i<=n;i++){
        if(!used[i]){
            dfs(i, 1, now);
			now++;
        }
    }
    int otv=INF, vert=-1;
    memset(used, 0, sizeof(used));
    for(int i=1;i<=n;i++){
        if(!used[i]){
            ans=0;
            vp=0;
            dfs1(i, 0);
            if(!vp && ans<otv){
                otv=ans;
                vert=i;
            }
        }
    }
	memset(used, 0, sizeof(used));
    dfs1(vert, 1);
    cout<<vec.size()<<"\n";
    for(int i=0;i<vec.size();i++){
        cout<<vec[i]<<" ";
    }
}
