#define _USE_MATH_DEFINES

#include <iostream>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>

using namespace std;

#define mp make_pair
#define emplace_back push_back

typedef long long ll;

const int INF=1e9+9;
const int MAXN=1e5+7;

void solve();

//#define _DEBUG

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    /*#ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG*/
    solve();
}

/*vector<vector<int>> v(MAXN);
int tm1[MAXN];
int tm2[MAXN];
int ur[MAXN];
bool used[MAXN];
set<pair<int,int>> s;

void dfs(int vert, int t, int u){
	ur[vert]=u;
    tm1[vert]=tm2[vert]=t;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
        if(used[v[vert][i]]){
			if(ur[vert]==ur[v[vert][i]]){
				tm2[vert]=min(tm2[vert], tm2[v[vert][i]]);
			}
			else{
				s.insert(mp(vert, v[vert][i]));
			}
        }
        else{
            dfs(v[vert][i], t+ 1, u);
			tm2[vert]=min(tm2[vert], tm2[v[vert][i]]);
			if(tm1[vert]<tm2[v[vert][i]]){
				s.insert(mp(vert, v[vert][i]));
			}
		}
    }
}

int ans=0;
bool vp=0;
vector<int> vec;

void dfs1(int vert, bool b){
    if(b){
        vec.emplace_back(vert);
    }
    ans++;
    used[vert]=1;
    for(int i=0;i<v[vert].size();i++){
		if(s.find(mp(vert, v[vert][i]))!=s.end()){
            vp=1;
			continue;
		}

        if(!used[v[vert][i]]){
            dfs1(v[vert][i], b);
        }
    }
}

/*void solve(){
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> q;
	q.push_back(0);
    for(int i=1;i<=n;i++){
		int a;
        cin>>a;
		q.push_back(a);
    }
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        if((q[a]+1)%h==q[b]){
            v[a].emplace_back(b);
        }
        if((q[b]+1)%h==q[a]){
            v[b].emplace_back(a);
        }
    }
	int now=1;
    for(int i=1;i<=n;i++){
        if(!used[i]){
            dfs(i, 1, now);
			now++;
        }
    }
    int otv=INF, vert=-1;
    memset(used, 0, sizeof(used));
    for(int i=1;i<=n;i++){
        if(!used[i]){
            ans=0;
            vp=0;
            dfs1(i, 0);
            if(!vp && ans<otv){
                otv=ans;
                vert=i;
            }
        }
    }
	memset(used, 0, sizeof(used));
    dfs1(vert, 1);
    cout<<vec.size()<<"\n";
    for(int i=0;i<vec.size();i++){
        cout<<vec[i]<<" ";
    }
}
/*const int MAXN = ...;
vector<int> g[MAXN];
bool used[MAXN];
int timer, tin[MAXN], fup[MAXN];
 
void dfs (int v, int p = -1) {
	used[v] = true;
	tin[v] = fup[v] = timer++;
	for (size_t i=0; i<g[v].size(); ++i) {
		int to = g[v][i];
		if (to == p)  continue;
		if (used[to])
			fup[v] = min (fup[v], tin[to]);
		else {
			dfs (to, v);
			fup[v] = min (fup[v], fup[to]);
			if (fup[to] > tin[v])
				IS_BRIDGE(v,to);
		}
	}
}
 
void find_bridges() {
	timer = 0;
	for (int i=0; i<n; ++i)
		used[i] = false;
	for (int i=0; i<n; ++i)
		if (!used[i])
			dfs (i);
}*/

const int mx=10;

vector<int> v, ans;
int otv=-1;
vector<int> st(mx);

bool correct(vector<int> &use){
    vector<bool> b(v.back()-v[0]);
    int start=0;
    if(v[0]<0){
        for(int i=0;i<=v.back()-v[0]+st.back();i++){
            b.emplace_back(0);
        }
        b[-v[0]]=1;
        start=-v[0];
    }
    else{
        for(int i=0;i<=v.back()+st.back();i++){
            b.emplace_back(0);
        }
        b[0]=1;
    }
    for(int i=use.size()-1;i>=0;i--){
        vector<bool> now=b;
        int n=st[use[i]];
        for(int j=0;j+n<b.size();j++){
            if(j+n<0) continue;
            if(b[j]){
                now[j+n]=1;
            }
        }
		b=now;
    }
    bool cor=1;
    for(int i=0;i<v.size() && cor;i++){
        if(!b[start+v[i]]) cor=0;
    }
    return cor;
}

void pereb(vector<int> &use, int ur){
    if(ur==mx){
        if(correct(use) && (use.size()<ans.size() || otv==-1)){
            otv=0;
            ans=use;
        }
		return;
    }
    pereb(use, ur+1);
    use.emplace_back(ur);
    pereb(use, ur+1);
    use.pop_back();
}

void solve(){
    st[mx/2-1]=-1;
    st[mx/2]=1;
    for(int i=1;i<mx/2;i++){
        st[mx/2-1-i]=st[mx/2-i]*2;
        st[mx/2+i]=st[mx/2-1+i]*2;
    }
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        int a;
        cin>>a;
        v.emplace_back(a);
    }
    sort(v.begin(),v.end());
    vector<int> vec;
    pereb(vec, 0);
    cout<<ans.size()<<"\n";
    for(int i=0;i<ans.size();i++){
        cout<<st[ans[i]]<<" ";
    }
}