#define CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF=1e9+9;
const int MAXN=1e5+7;

void solve();

int main() {
    srand('a'+'l'+'e'+'x'+'X'+'5'+'1'+'2');
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG
    solve();
}


void solve(){
    string s;
    cin>>s;
    vector<vector<int>> ans;
    vector<int> n, e;
    for(int i=0;i<s.size();i++){
        if(s[i]=='1' && n.empty()){
            cout<<-1;
            return;
        }
        else if(s[i]=='1'){
            ans[n.back()].emplace_back(i);
            e.emplace_back(n.back());
            n.pop_back();
        }
        else if(e.empty()){
            ans.emplace_back();
            ans.back().emplace_back(i);
            n.emplace_back(ans.size()-1);
        }
        else{
            ans[e.back()].emplace_back(i);
            n.emplace_back(e.back());
            e.pop_back();
        }
    }
    if(!e.empty()){
        cout<<-1;
        return;
    }
    cout<<ans.size()<<"\n";
    for(int i=0;i<ans.size();i++){
        cout<<ans[i].size()<<" ";
        for(int j=0;j<ans[i].size();j++){
            cout<<ans[i][j]+1<<" ";
        }
        cout<<"\n";
    }
}
