#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()

////

void fBig(int &x)
{
	x = x | (x + 1);
}

void fLess(int &x)
{
	x = (x & (x + 1)) - 1;
}

vector <int> tree;
void upd(int ind, int delta)
{
	for (int x = ind; x < tree.size(); fBig(x))
	{
		tree[x]+=delta;
	}
}

int get_s(int x0)
{
	int sum = 0;
	for (int x = x0; x >= 0; fLess(x))
	{
		sum += tree[x];
	}
	return sum;
}

int get(int l, int r)
{
	r = min(r, int(tree.size() - 1));
	l = min(l, int(tree.size()));
	if (l == 0)
		return get_s(r);
	else
		return get_s(r) - get_s(l - 1);
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	int n, a;
	cin >> n;
	cin >> a;
	bool flag = false;
	if (a < 0)
	{
		flag = true;
		a = -a;	
	}
	vector <int> Ans;
	if (a == 7)
	{
		Ans.push_back(8);
		Ans.push_back(-1);
	}
	else
	{
		for (int k = 4; k>= 0; k--)
		{
			if(a >= (1 << k))
			{
				Ans.push_back(1<<k);
				a-=(1<<k);
			}
		}
	}
	cout << Ans.size() << endl;
	for (int i = 0; i < Ans.size(); i++)
	{
		if (flag)
			cout << -Ans[i] <<" ";
		else
			cout << Ans[i] <<" ";
	}
	return 0;
}