#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	string s;
	cin >> s;
	vector <vector <int>>subS;
	vector <int> end0;
	vector <int> end1;
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i] == '0')
		{
			if (end1.size() == 0)
			{
				subS.resize(sz(subS) + 1);
				subS.back().push_back(i);
				end0.push_back(sz(subS) - 1);
			}
			else
			{
				int num = end1.back();
				end1.pop_back();
				subS[num].push_back(i);
				end0.push_back(num);
			}
		}
		else
		{
			if (end0.size() == 0)
			{
				cout << -1;
				return 0;
			}
			else
			{
				int num = end0.back();
				end0.pop_back();
				subS[num].push_back(i);
				end1.push_back(num);
			}
		}
	}
	if(end1.size() != 0)
	{
		cout << -1;
		return 0;
	}
	cout << end0.size() << endl;
	for (int i = 0; i < end0.size(); i++)
	{
		cout << subS[end0[i]].size() <<" ";
		for (int j = 0; j < subS[end0[i]].size(); j++)
		{
			cout << subS[end0[i]][j] + 1 << " ";
		}
		cout << endl;
	}
	return 0;
}