#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>


using namespace std;

vector<int> color;
int cnt = 0, cn = 0;
vector<vector<int>> g;
vector<int> tin;
vector<int> comp;

int dfs(int v) {
	int min = v;
	tin[v] = cnt++;
	color[v] = 1;
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int to = g[v][i];
		if (color[to] == 0) {
			int k = dfs(to);
			if (tin[k] < tin[min])
				min = k;
			if (tin[k] > tin[v])
				g[v][i] = v;
		}
		else
			if (color[to] == 1) {
				if (tin[to] < tin[min])
				min = to;
			}
			else
				g[v][i] = v;
	}
	color[v] = 2;
	return min;
}

void dfs1(int v) {
	color[v] = 1;
	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (color[to] == 0)
			dfs1(to);
	}
	comp[v] = cn;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v; --u;
		if (a[v] + 1 == a[u] || a[v] + 1 == a[u] + h)
			g[v].push_back(u);
		if (a[u] + 1 == a[v] || a[u] + 1 == a[v] + h)
			g[u].push_back(v);
	}
	auto g1 = g;
	color.assign(n, 0);
	tin.resize(n);
	comp.assign(n, 0);
	for (int i = 0; i < n; ++i)
		if (color[i] == 0)
			int tmp = dfs(i);
	color.assign(n, 0);
	for (int i = 0; i < n; ++i)
		if (color[i] == 0) {
			dfs1(i);
			++cn;
		}
	vector<int> sum(cn);
	vector<bool> c(cn, true);
	for (int i = 0; i < n; ++i) {
		sum[comp[i]]++;
		for (int j = 0; j < g1[i].size(); ++j) {
			int to = g1[i][j];
			if (comp[to] != comp[i]) {
				c[comp[i]] = false;
				break;
			}
		}
	}
	int t = -1;
	for (int i = 0; i < cn; ++i)
		if (c[i] && (t == -1 || sum[i] < sum[t]))
			t = i;
	cout << sum[t] << '\n';
	for (int i = 0; i < n; ++i)
		if (comp[i] == t)
			cout << i + 1 << ' ';
	n = n;
	return 0;
}
