#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>


using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	string s;
	cin >> s;
	reverse(s.begin(), s.end());
	int n = (int)s.size();
	bitset<200228> a(s);
	deque<int> b0, b1;
	int sum = 0;
	for (int i = 0; i < n; ++i)
		if (a[i]) ++sum;
	int m = n - 2 * sum;
	if (m < 1)
		return cout << -1, 0;
	vector<vector<int>> ans(m);
	for (int i = 0; i < m; ++i)
		b1.push_back(i);
	for (int i = 0; i < n; ++i) {
		if (a[i]) {
			if (b0.empty())
				return cout << -1, 0;
			int k = b0.front();
			ans[k].push_back(i + 1);
			b0.pop_front();
			b1.push_back(k);
		}
		else {
			if (b1.empty())
				return cout << -1, 0;
			int k = b1.front();
			ans[k].push_back(i + 1);
			b1.pop_front();
			b0.push_back(k);
		}
	}
	cout << m << '\n';
	for (int i = 0; i < m; ++i) {
		printf("%d ", ans[i].size());
		for (int j = 0; j < ans[i].size(); ++j)
			printf("%d ", ans[i][j]);
		printf("\n");
	}
	return 0;
}
