#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <string>

using namespace std;

template <class T>
istream& operator>> (istream &is, vector<T>  &v)
{
	for (int i = 0; i < v.size(); i++)
		is >> v[i];
	return is;
}

template <class T>
ostream& operator<< (ostream &os, const vector<T> &v)
{
	for (int i = 0; i < v.size(); i++)
		os << v[i] << ' ';
	os << '\n';
	return os;
}

int cnt1(int x)
{
	int cnt = 0;
	while (x)
		x &= x - 1, cnt++;
	return cnt;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int n, m, H;
	cin >> n >> m >> H;
	vector<pair<int, int>> a(m);
	vector<int> h(n);
	for (int i = 0; i < n; i++)
		cin >> h[i];

	for (int i = 0; i < m; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
	}

	int ans = (1 << n) - 1;
	for (int mask = 1; mask < (1 << n); mask++) {
		bool can = true;
		for (int i = 0; i < m; i++) {
			int t1 = (h[a[i].first] + ((mask >> a[i].first) & 1)) % H;
			int t2 = (h[a[i].second] + ((mask >> a[i].second) & 1)) % H;
			can &= t1 != t2;
		}

		if (can && cnt1(mask) < cnt1(ans))
			ans = mask;
	}

	cout << cnt1(ans) << '\n';
	for (int i = 0; i < n; i++)
		if (ans & (1 << i))
			cout << i + 1 << ' ';
}
