#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG

#include <iostream>
#include <vector>
#include <climits>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <string>

using namespace std;

vector<int> a;
bool check(const vector<int> &b)
{
	unordered_map<int, bool> last, next;
	last[0] = true;

	for (int i = 0; i < b.size(); i++) {
		for (auto it = last.begin(); it != last.end(); it++) {
			next[it->first] = true;
			next[it->first + b[i]] = true;
		}
		next.swap(last);
	}

	for (int i = 0; i < a.size(); i++)
		if (last.count(a[i]) == 0)
			return false;

	return true;
}

bool can;
vector<int> ans;

void rec(int cnt = 0)
{
	queue<vector<int>> q;
	q.push(vector<int> ());
	
	while (true) {
		vector<int> b = q.front();
		if (check(b)) {
			ans = b;
			return;
		}

		for (int i = 0; i < 5; i++)
			for (int p = 0; p < 2; p++) {
				int t = 1 << i;
				if (p == 0)
					t *= -1;
				b.push_back(t);
				q.push(b);
				b.pop_back();
			}
		q.pop();
	}
}

int main()
{
	int n;
	cin >> n;
	a.resize(n);
	
	for (int i = 0; i < n; i++) 
		cin >> a[i];

	rec();

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] << ' ';
}
