#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <string>

using namespace std;

template <class T>
istream& operator>> (istream &is, vector<T>  &v)
{
	for (int i = 0; i < v.size(); i++)
		is >> v[i];
	return is;
}

template <class T>
ostream& operator<< (ostream &os, const vector<T> &v)
{
	for (int i = 0; i < v.size(); i++)
		os << v[i] << ' ';
	os << '\n';
	return os;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	string s;
	cin >> s;

	stack<int> st;
	int n = s.size();
	vector<int> r0(n);
	for (int i = n - 1; i >= 0; i--)
		if (s[i] == '0')
			st.push(i);
		else {
			if (st.empty()) {
				cout << -1;
				return 0;
			}
			else {
				r0[i] = st.top();
				st.pop();
			}
		}
	vector<vector<int>> ans;
	map<int, int> last0;
	vector<bool> used(n);
	for (int i = 0; i < n; i++)
		if (s[i] == '0' && !used[i]) {
			ans.push_back(vector<int> ());
			ans[ans.size() - 1].push_back(i);
			last0[i] = ans.size() - 1;
		}
		else if (s[i] == '0' && used[i])
			continue;
		else {
			auto it = last0.lower_bound(i);
			if (it == last0.begin()) {
				cout << -1;
				return 0;
			}
			else
				--it;
			int nans = it->second;
			ans[nans].push_back(i);
			ans[nans].push_back(r0[i]);
			used[r0[i]] = true;
			last0.erase(it);
			last0[r0[i]] = nans;
		}

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size() << ' ';
		for (int j = 0; j < ans[i].size(); j++)
			cout << ans[i][j] + 1 << ' ';
		cout << '\n';
	}
}
