#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

//kandinsky

const int N = 100005;
int n, m, h;
int a[N];
vector <int> g[N], gr[N];
int sz[N];
int sz1[N];
bool used[N];
bool used1[N];

void dfs(int v) {
    used[v] = true;
    sz[v]++;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
            sz[v] += sz[u];
        }
    }
}

vector <int> ans;
void dfs1(int v) {
    used1[v] = true;
    ans.pb(v);
    for (auto u : g[v]) {
        if (!used1[u]) {
            dfs1(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> n >> m >> h;
    rep(i, n) {
        cin >> a[i];
    }
    vector <pair <int, int>> edges;
    rep(i, m) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (a[v] == (a[u] + 1) % h) {
            g[u].pb(v);
            gr[v].pb(u);
            edges.pb(mp(u, v));
        }
        if ((a[v] + 1) % h == a[u]) {
            g[v].pb(u);
            gr[u].pb(v);
            edges.pb(mp(v, u));
        }
    }

    int minv = 0;
    rep(v, n) {
        rep(i, n) sz[i] = 0;
        rep(i, n) used[i] = 0;
        dfs(v);
        sz1[v] = sz[v];
        if (sz1[v] < sz1[minv])
            minv = v;
    }

    dfs1(minv);
    cout << (int)ans.size() << endl;
    for (auto el : ans) {
        cout << el + 1 << ' ';
    }
    cout << endl;

    return 0;
}
/*

3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3

5 6 4
2 1 0 3 0
4 3
3 2
1 2
1 4
1 3
5 2

*/
