#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

string s;
int n;
bool dp[1000010];
pair <int, int> p[1000010];

bool cmp(int a, int b) {
    return __builtin_popcount(a) < __builtin_popcount(b);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> s;
    n = (int)s.size();
    if (s[0] == '1' || s[n - 1] == '1') {
        cout << -1 << endl;
        return 0;
    }
    if (n > 10) {
        cout << -1 << endl;
        return 0;
    }

    vector <int> ord;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector <int> buf;
        dp[mask] = true;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                if ((s[i] == '0' && !buf.empty() && buf.back() == '0') || (s[i] == '1' && (buf.empty() || buf.back() == '1'))) {
                    dp[mask] = false;
                    break;
                }
                else buf.pb(s[i]);
            }
        }
        dp[mask] &= (buf.empty() || buf.back() == '0');
        if (dp[mask]) {
            p[mask] = {-1, -1};
        }
        ord.pb(mask);
    }
    sort(all(ord), cmp);
    for (int i = 1; i < (1 << n); ++i) {
        for (int j = i; j > 0; --j) {
            if (dp[i] && dp[j] && !(i & j)) {
                dp[i | j] = true;
                p[i | j] = mp(i, j);
            }
        }
    }

    /*rep(i, (1 << n)) {
        cout << i << ' ' << dp[i] << endl;
    }
    return 0;*/

    int full = (1 << n) - 1;
    if (!dp[full]) {
        cout << -1 << endl;
    } else {
        vector <int> endmask;
        queue <int> q;
        q.push(full);
        while (!q.empty()) {
            int mask = q.front();
            q.pop();

            if (p[mask].f == -1)
                endmask.pb(mask);
            else {
                q.push(p[mask].f);
                q.push(p[mask].s);
            }
        }
        cout << (int)endmask.size() << endl;
        for (auto mask : endmask) {
            cout << __builtin_popcount(mask) << ' ';
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    cout << i + 1 << ' ';
                }
            }
            cout << '\n';
        }
    }

    return 0;
}
