#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    string s;
    cin >> s;
    int n = s.size();
    set <int> ones, zeros;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') zeros.insert(i);
        else ones.insert(i);
    }
    vector <bool> used(n);
    int uk = 0;
    vector <vector <int>> ans(1);
        if (s[0] == '1') {
        cout << -1 << endl;
        return 0;
    }
    while (uk < n) {
        used[uk] = 1;
        zeros.erase(zeros.begin());
        ans.back().push_back(uk);
        int cur = uk;
        bool flag = false;
        while (true) {
            auto it = ones.upper_bound(cur);
            if (it == ones.end()) {
                flag = true;
            }
            else {
                cur = *it;
            }
            auto z_it = zeros.upper_bound(cur);
            if (z_it != zeros.end() && !flag){
                zeros.erase(z_it);
                ones.erase(it);
                int ind = *it;
                used[ind] = 1;
                ans.back().push_back(ind);
                ind = *z_it;
                used[ind] = 1;
                ans.back().push_back(ind);
            }
            else {
                break;
            }
        }
        ans.push_back({});
        while (uk < n && used[uk]) ++uk;
        if (uk == n) break;
        if (s[uk] == '1') {
            cout << -1 << endl;
            return 0;
        }
    }
    ans.pop_back();
    cout << ans.size() << endl;
    for (auto l : ans) {
        cout << l.size() << " ";
        for (auto e : l) {
            cout << e + 1 << " ";
        }
        cout << "\n";
    }
}
