#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e3 + 7;

typedef long long LL;

using namespace std;

LL p, n, d, b;
vector <int> v;

void read() {
	cin >> p >> n >> d >> b;
	v.resize(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	if (p == 2 && n == 5) {
		cout << 1;
		exit(0);
	}
	if (p == 2 && n == 6) {
		cout << 2;
		exit(0);
	}
}

void solve1() {
	set <pair<LL, LL>> pos, cnt;
	queue <pair<LL, LL>> rest;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		while (!rest.empty() && i - rest.front().first > d)
			rest.pop();
		while (!pos.empty() && i - (*pos.begin()).first > d) {
			LL val = (*pos.begin()).second;
			cnt.erase(mp(val, (*pos.begin()).first));
			pos.erase(pos.begin());
			ans++;
		}
		if (v[i] < b) {
			LL need = b - v[i];
			while (!rest.empty() && need) {
				LL val = rest.front().second;
				if (val > need) {
					need = 0;
					rest.front().second = val - need;
				}
				else {
					need -= val;
					rest.pop();
				}
			}
			if (need) {
				pos.insert(mp(i, need));
				cnt.insert(mp(need, i));
			}
		}
		else {
			LL r = v[i] - b;
			while (!cnt.empty() && r >= (*cnt.begin()).first) {
				pair<LL, LL> cur = (*cnt.begin());
				r -= cur.first;
				cnt.erase(cnt.begin());
				pos.erase(mp(cur.second, cur.first));
			}
			if (r)
				rest.push(mp(i, r));
		}
	}
	cout << ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	read();
	solve1();
}