#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>

#define mp make_pair
#define pii pair<int, int>

const int N = (int)2e5 + 7;

typedef long long LL;

using namespace std;

vector <int> v[N], zero, one;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	string s; cin >> s;
	int n = s.size();
	int pos = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] == '1' && zero.empty()) {
			cout << -1;
			return 0;
		}
		if (s[i] == '0' && one.empty()) {
			v[pos].push_back(i);
			zero.push_back(pos++);
			continue;
		}
		if (s[i] == '1') {
			v[zero.back()].push_back(i);
			one.push_back(zero.back());
			zero.pop_back();
		}
		if (s[i] == '0') {
			v[one.back()].push_back(i);
			zero.push_back(one.back());
			one.pop_back();
		}
	}
	if (!one.empty()) {
		cout << -1;
		return 0;
	}
	vector <vector <int>> ans;
	for (int i = 0; i < n; i++) {
		if (!v[i].empty()) {
			reverse(v[i].begin(), v[i].end());
			ans.push_back(v[i]);
		}
	}
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i].size() << ' ';
		for (int j = 0; j < (int)ans[i].size(); j++)
			cout << ans[i][j] + 1 << ' ';
		cout << endl;
	}
}