#include <bits/stdc++.h>

using namespace std;

const int MAXN = 512;
const int maxb = 1 << 9;

bitset <MAXN + 1> p[maxb + 5], m[maxb + 5], positive, negative;

vector <int> ans;

int answer, n, k1, k2, v[MAXN], pos[MAXN], neg[MAXN];

int main()
{
    //freopen( "input", "r", stdin );
    //freopen( "output","w", stdout);

    answer = 0x3f3f3f3f;

    int maxn = 0;

    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> v[ i ];
        if (v[ i ] > 0)
            pos[ ++k1 ] = v[ i ];
        else
            pos[ ++k2 ] = -v[ i ];
        maxn = max(maxn, abs(v[ i ]));
    }

    maxn = MAXN;

    p[ 0 ][ 0 ] = 1;
    for (int mask = 0; mask < maxb; mask++) {
        for (int bit = 0; bit < 9; bit++) {
            if (!(mask & (1<<bit))) {
                for (int i = maxn; i >= 0; i--) {
                    if (p[ mask ][ i ]) {
                        p[mask + (1<<bit)][ i ] = 1;
                        if ((1<<bit) + i <= maxn)
                            p[mask + (1<<bit)][i + (1 << bit)] = 1;
                    }
                }
            }
        }
    }

    m[ 0 ][ 0 ] = 1;
    for (int mask = 0; mask < maxb; mask++) {
        for (int bit = 0; bit < 9; bit++) {
            if (!(mask & (1<<bit))) {
                for (int i = maxn; i >= 0; i--) {
                    if (m[ mask ][ i ]) {
                        m[mask + (1<<bit)][ i ] = 1;
                        if ((1<<bit) + i <= maxn)
                            m[mask + (1<<bit)][i + (1 << bit)] = 1;
                    }
                }
            }
        }
    }

    for (int i = 0; i < maxb; i++) {
        for (int j = 0; j < maxb; j++) {
            positive.reset();
            negative.reset();
            for (int k = 0; k <= maxn; k++) {
                positive[ k ] = p[ i ][ k ];
                negative[ k ] = m[ j ][ k ];
            }

            for (int bit = 0; bit < 9; bit++) {
                if (j & (1<<bit)) {
                    for (int k = 0; k <= maxn; k++) {
                        if (p[ i ][ k ]) {
                            if (k - (1<<bit) < 0)
                                negative[ (1<<bit) - k ] = 1;
                            else
                                positive[ k - (1<<bit) ] = 1;
                        }
                    }
                }
                if (i & (1<<bit)) {
                    for (int k = 0; k <= maxn; k++) {
                        if (m[ j ][ k ]) {
                            if (-k + (1<<bit) < 0)
                                negative[ k - (1<<bit) ] = 1;
                            else
                                positive[-k + (1<<bit) ] = 1;
                        }
                    }
                }
            }

            int ok = 1;
            for (int k = 1; k <= n && ok; k++) {
                if (v[ k ] > 0 && positive[ v[ k ] ] == 0)
                    ok = 0;
                if (v[ k ] < 0 && negative[-v[ k ] ] == 0)
                    ok = 0;
            }
            if (ok) {
                int powers = 0;
                for (int bit = 0; bit < 9; bit++) {
                    if (i & (1<<bit))
                        powers++;
                    if (j & (1<<bit))
                        powers++;
                }

                if (powers < answer) {
                    answer = powers;
                    ans.clear();
                    for (int bit = 0; bit < 9; bit++) {
                        if (i & (1<<bit))
                            ans.push_back( (1<<bit) );
                        if (j & (1<<bit))
                            ans.push_back( -(1<<bit));
                    }
                }
            }
        }
    }


    cout << answer << '\n';

    for (int sol: ans)
        cout << sol << " ";

    return 0;
}
