#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, nxt[maxn], top, ones[maxn], ans, zeros[maxn], k;
bool seen[maxn];
char s[maxn];

deque <int> dq;
vector <int> answer[maxn];

void dfs(int pos) {
    answer[ ans ].push_back( pos );
    seen[ pos ] = 1;
    if (nxt[ pos ] != pos)
        dfs( nxt[ pos ]);
}

int main()
{
    //freopen( "input", "r", stdin );
    //freopen( "output","w", stdout);

    cin >> (s + 1);
    n = strlen(s + 1);

    for (int i = 1; i <= n; i++) {
        if (s[ i ] == '1')
            ones[ ++top ] = i;
        else
            zeros[ ++k ] = i;
        nxt[ i ] = i;
    }

    int crt;
    for (int i = top; i >= 1; i--) {
        crt = ones[ i ];
        while (k > 0 && zeros[ k ] > crt) {
            dq.push_front( zeros[ k ]);
            k--;
        }
        if (k == 0 || dq.empty()) {
            cout << -1;
            return 0;
        }

        nxt[ crt ] = dq.back();
        dq.pop_back();
        nxt[ zeros[ k ] ] = crt;
        dq.push_front(zeros[ k ]);
        k--;
    }

    for (int i = 1; i <= n; i++)
        if (!seen[ i ]) {
            ans++;
            dfs( i );
        }

    cout << ans << '\n';
    for (int i = 1; i <= ans; i++) {
        cout << answer[ i ].size() << " ";
        for (int sol: answer[ i ])
            cout << sol << ' ';
        cout << '\n';
    }

    return 0;
}
