#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, nxt[maxn], ans, v[maxn], zeros[maxn], top;
bool seen[maxn];
char s[maxn];

set <int> onright;
set <int>::iterator it;

vector <int> answer[maxn];

void dfs(int pos) {
    answer[ ans ].push_back( pos );
    seen[ pos ] = 1;
    if (nxt[ pos ] != pos)
        dfs( nxt[ pos ]);
}

int main()
{
    //freopen( "input", "r", stdin );
    //freopen( "output","w", stdout);

    cin >> (s + 1);
    n = strlen(s + 1);

    for (int i = 1; i <= n; i++) {
        if (s[ i ] == '1')
            v[ i ] = 1;
        else {
            v[ i ] = 0;
            zeros[ ++top ] = i;
        }
        nxt[ i ] = i;
    }

    for (int i = n; i >= 1; i--) {
        if (v[ i ] == 0) {
            onright.insert( i );
            if (zeros[ top ] == i)
                top--;
        }
        else {
            if (onright.empty() || top == 0) {
                cout << -1;
                return 0;
            }

            it = onright.upper_bound( i );
            if (it == onright.end()) {
                cout << -1;
                return 0;
            }

            nxt[ i ] = *it;
            nxt[ zeros[ top ] ] = i;
            onright.erase( it );
            onright.insert( zeros[ top ] );
            top--;
        }
    }


    for (int i = 1; i <= n; i++)
        if (!seen[ i ]) {
            ans++;
            dfs( i );
        }

    cout << ans << '\n';
    for (int i = 1; i <= ans; i++) {
        cout << answer[ i ].size() << " ";
        for (int sol: answer[ i ])
            cout << sol << ' ';
        cout << '\n';
    }

    return 0;
}
