#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);

int n;
string s;

void read()
{
    cin >> s;
    n = s.size();
}

void solve()
{
    set<int> st[2];
    set<int> S;
    for(int i = 0; i < n; i++)
        S.insert(i), st[s[i] - '0'].insert(i);

    vector<vector<int> > answer;
    while(true)
    {
        auto fr = S.begin();
        if(fr == S.end() || s[*fr] == '1') break;

        vector<int> curr;
        curr.push_back(*fr);

        int last = *fr;
        for(int c = 0; ; c++)
        {
            auto nxt = st[1].upper_bound(last);
            if(nxt == st[1].end()) break;

            auto nxt2 = st[0].upper_bound(*nxt);
            if(nxt2 == st[0].end()) break;

            curr.push_back(*nxt);
            curr.push_back(*nxt2);
            last = *nxt2;
        }

        for(int p: curr)
        {
            S.erase(p);
            st[s[p] - '0'].erase(p);
        }

        answer.push_back(curr);
    }

    if(!S.empty())
    {
        cout << -1 << endl;
        return;
    }

    cout << answer.size() << endl;
    for(int i = 0; i < answer.size(); i++)
    {
        cout << answer[i].size() << " ";
        for(int x: answer[i]) cout << 1 + x << " ";
        cout << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
