#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;
#define endl '\n'

uint32_t h;
vector < uint32_t > u;
vector < vector < uint32_t  > > ss;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    uint32_t n, m;
    cin>>n>>m>>h;
    u.resize(n);
    for(uint32_t i=0; i<n; i++)
        cin>>u[i];
    vector < pair < uint32_t, uint32_t > > c, c1;
    c.resize(m);
    for(uint32_t i=0; i<m; i++)
    {
        cin>>c[i].first>>c[i].second;
        c[i].first--;
        c[i].second--;
        if(c[i].first>c[i].second)
            swap(c[i].first, c[i].second);
    }
    sort(c.begin(), c.end());
    c1.reserve(m);
    c1.push_back(c.front());
    for(uint32_t i=1; i<m; i++)
        if(c1.back()!=c[i])c1.push_back(c[i]);
    c1.shrink_to_fit();
    ss.resize(n);
    for(uint32_t i=0; i<c1.size(); i++)
    {
        ss[c1[i].first].push_back(c1[i].second);
        ss[c1[i].second].push_back(c1[i].first);
    }
}

uint32_t solve(uint32_t pos, vector <uint32_t> &updates)
{
    vector<bool> updated(u.size());
    uint32_t updated_num=0;
    queue<uint32_t> to_update;
    vector<uint32_t> new_utime(u);
    to_update.push(pos);
    while (!to_update.empty())
    {
        uint32_t cur=to_update.front();
        to_update.pop();
        if(updated[cur])continue;
        updated_num++;
        updated[cur]=true;
        updates.push_back(cur);
        new_utime[cur]++;
        if(new_utime[cur]>=h)new_utime[cur]=0;
        for(uint32_t i=0; i<ss[cur].size(); i++)
        {
            //volatile uint32_t tmp=ss[cur][i];
            if(new_utime[cur]==new_utime[ss[cur][i]])
            {
                if(updated[ss[cur][i]])return UINT32_MAX;
                else
                {
                    to_update.push(ss[cur][i]);
                }
            }
        }
    }

    return updated_num;
}

int main()
{
    init();
    uint32_t res=UINT32_MAX;
    vector<uint32_t> updates, updates_best;
    updates.reserve(u.size());
    updates_best.reserve(u.size());
    for(uint32_t i=0; i<u.size(); i++)
    {
        uint32_t tmp=solve(i, updates);
        if(tmp<res)
        {
            res=tmp;
            updates_best=updates;
        }
        updates.clear();
    }
    cout<<res<<endl;
    for(uint32_t i=0; i<updates_best.size(); i++)
        cout<<updates_best[i]+1<<' ';
    cout<<endl;


    return 0;
}