# include <cstdio>
# include <ctime>
# include <vector>
# include <set>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_M = 1e5 + 10;

int n, m, h;
int a[MAX_N];

int u[MAX_N], key;

vector <int> v[MAX_N], crr, ans;

set <pair <int, int>> s;

void dfs (int x)
{
	int i;
	crr.push_back (x);
	u[x] = key;
	for (i = 0; i < (int) v[x].size (); i ++)
		if (u[v[x][i]] != key)
			dfs (v[x][i]);
}

int main ()
{
	int i, p, q;
	scanf ("%d%d%d", &n, &m, &h);
	
	for (i = 1; i <= n; i ++)
	{
		ans.push_back (i);
		scanf ("%d", &a[i]);
	}
	
	for (i = 0; i < m; i ++)
	{
		scanf ("%d%d", &p, &q);
		if (s.find ({p, q}) != s.end ())
			continue;
		s.insert ({p, q});
		s.insert ({q, p});
		if ((a[p] + 1) == a[q] || ((a[p] + 1) == h && !a[q]))
			v[p].push_back (q);
		if ((a[q] + 1) == a[p] || ((a[q] + 1) == h && !a[p]))
			v[q].push_back (p); 
	}
	
	for (i = 1; i <= n; i ++)
		if (!v[i].size ())
		{
			printf ("1\n%d\n", i);
			return 0;
		}
	
	while ((double) clock () < 0.8 * CLOCKS_PER_SEC)
	{
		i = rand () % n + 1;
		crr.clear ();
		key ++;
		dfs (i);
		
		/**
		for (int j = 0; j < (int) crr.size (); j ++)
			printf ("%d ", crr[j]);
		printf ("\n");
		**/
		
		if (crr.size () < ans.size ())
			ans = crr;
	}
	
	printf ("%d\n", (int) ans.size ());
	
	for (i = 0; i < (int) ans.size (); i ++)
		printf ("%d ", ans[i]);
	printf ("\n");

	return 0;
}
