#include <bits/stdc++.h>
#define MAXN 100005
using namespace std;

int n,m,h;
int kad[MAXN];
bool obidjen[MAXN];
vector<int> niz[MAXN];

vector<int> trans[MAXN];
vector<int> sta[MAXN];
stack<int> jasno;
int komponenta[MAXN];
void dfs1(int t){
    obidjen[t]=true;
    for(auto x:niz[t])
        if(!obidjen[x])
            dfs1(x);

    jasno.push(t);
}


void dfs2(int t,int c){
    komponenta[t]=c;
    obidjen[t]=true;
    for(auto x:trans[t]){
        if(!obidjen[x])
            dfs2(x,c);
    }
}

int scc(){
    memset(obidjen,0,sizeof(obidjen));
    for(int i=1;i<=n;i++){
        if(!obidjen[i])
            dfs1(i);
    }
    memset(obidjen,0,sizeof(obidjen));
    int c=0;
    while(!jasno.empty()){
        if(!obidjen[jasno.top()]){
            c++;
            dfs2(jasno.top(),c);
        }
        jasno.pop();
    }
    return c;

}



int main()
{
    scanf("%d %d %d", &n, &m, &h);
    for(int i=1;i<=n;i++)
        scanf("%d", &kad[i]);

    for(int i=0;i<m;i++){
        int t1,t2;
        scanf("%d %d", &t1, &t2);
        if(kad[t2]==(kad[t1]+1)%h){
            niz[t1].push_back(t2);
            trans[t2].push_back(t1);
        }
        if(kad[t1]==(kad[t2]+1)%h){
            niz[t2].push_back(t1);
            trans[t1].push_back(t2);
        }
    }

    for(int i=1;i<=n;i++){
        if(niz[i].size()==0){
            printf("1\n%d",i);
            return 0;
        }
    }

    int kolko=scc();
    for(int i=1;i<=n;i++)
        sta[komponenta[i]].push_back(i);

    int mini=1e9;
    int gde=0;
    for(int i=1;i<=kolko;i++){
        if(sta[i].size()<mini){
            mini=sta[i].size();
            gde=i;
        }
    }
    printf("%d\n",mini);
    for(auto x:sta[gde])
        printf("%d ",x);



    return 0;
}
