#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
using namespace std;
int n,seqbr;
string s;
stack <int> seq0,seq1;
vector <int> seq[200000];

void solve()
{
    int i;
    for(i=0; i<n; i++)
    {
        if(s[i]=='0')
        {
            if(seq1.empty())
            {
                seq[seqbr].push_back(i);
                seq0.push(seqbr++);
            }
            else
            {
                seq[seq1.top()].push_back(i);
                seq0.push(seq1.top());
                seq1.pop();
            }
        }
        else
        {
            if(seq0.empty())
            {
                cout<<"-1"<<endl;
                return;
            }
            seq[seq0.top()].push_back(i);
            seq1.push(seq0.top());
            seq0.pop();
        }
    }
    if(!seq1.empty())
    {
        cout<<"-1"<< endl;
        return;
    }
    cout<<seqbr<< endl;
    for(i=0; i<seqbr; i++)
    {
        cout<<seq[i].size();
        for(int p : seq[i]) cout<<" "<<1+p;
        cout<< endl;
    }
}

int main ()
{
    int i,br0,br1;
    cin>>s;
    n = s.size();
    br0=br1=0;
    for(i=0; i<n; i++)
    {
        if(s[i]=='0') br0++;
        else br1++;
        if(br1>br0)
            {cout<<-1<<endl; return 0;}
    }
    if(br1>=br0)
        {cout<<-1<<endl; return 0;}
    br0=br1=0;
    for(i=n-1; i>=0; i--)
    {
        if(s[i]=='0') br0++;
        else br1++;
        if(br1>br0)
            {cout<<-1<<endl; return 0;}
    }
    solve();
    return 0;
}
