#include <bits/stdc++.h>
#define STIZE(x) fprintf(stderr, "STIZE%d\n", x)
#define PRINT(x) fprintf(stderr, "%s = %d\n", #x, x)
#define NL(x) (" \n"[(x)])
#define all(x) (begin(x),end(x))
#define sz(x) ((int)(x).size())
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-9
#define fi first
#define se second
#define pb push_back
#define pii pair<int,int>
#define lld long long
#define endl '\n'
using namespace std;
#define MAXN 100010
int N, M, H;
int inc(int n) {
    n++;
    if(n >= H) n%=H;
    return n;
}
int u[MAXN], pos[MAXN], in[MAXN], k;
vector<int> adj[MAXN], inv[MAXN], scc[MAXN], adjscc[MAXN];
stack<int> box;
void dfs1(int v) {
    pos[v] = 1;
    box.push(v);
    for(auto x : adj[v]) if(!pos[x]) dfs1(x);
}
void dfs2(int v) {
    in[v] = k;
    scc[k].pb(v);
    for(auto x : inv[v]) if(!in[x]) dfs2(x);
}
void Kosaraju() {
    for(int i = 1; i <= N; i++) if(!pos[i]) dfs1(i);
    while(!box.empty()) {
        int v = box.top(); box.pop();
        if(in[v]) continue;
        k++;
        dfs2(v);
    }
}
int main() {
    ios::sync_with_stdio(false); cin.tie(nullptr);
    cin >> N >> M >> H;
    for(int i = 1; i <= N; i++) {
        cin >> u[i];
    }
    for(int i = 0; i < M; i++) {
        int c1, c2; cin >> c1 >> c2;
        if(inc(u[c1]) == u[c2]) {
            //PRINT(c1); PRINT(c2);
            adj[c1].pb(c2);
            inv[c2].pb(c1);
        }
        if(inc(u[c2]) == u[c1]) {
            //PRINT(c2); PRINT(c1);
            adj[c2].pb(c1);
            inv[c1].pb(c2);
        }
    }
    Kosaraju();
    int najm = N+1, koji = 1;
    for(int i = 1; i <= N; i++) {
        for(auto x : adj[i]) {
            adjscc[in[i]].pb(in[x]);
        }
    }
    for(int i = 0; i <= k; i++) {
        //PRINT(i);
        for(auto x : scc[i]) {
            //cout << x << ' ';
        }
        //cout << endl;
        if(sz(scc[i]) != 0 && sz(adjscc[i]) == 0 && sz(scc[i]) < najm) {
            koji = i, najm = sz(scc[i]);
        }
    }
    cout << sz(scc[koji]) << endl;
    for(auto x : scc[koji]) cout << x << ' ';
    return 0;
}
