#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100000;
const int MAX_M = 100000;

vector<int> graph[1+MAX_N];
int u[1+MAX_N];
bool viz[1+MAX_N];
int top;
int noduri[MAX_N];

FILE *fin, *fout;

void dfs(int nod, int h) {
  viz[nod] = true;
  noduri[top++] = nod;
  bool smec = true;
  for(auto it: graph[nod]) {
    if(!viz[it])
      dfs(it, h);
    if((u[nod] + 1) % h == u[it])
      smec = false;
  }

  if(smec) {
    fprintf(fout , "1\n%d", nod);
    exit(0);
  }
}

int main() {
#ifdef HOME
  fin = fopen("data.in", "r");
  fout = fopen("data.out", "w");
#else
  fin = fopen("input.txt", "r");
  fout = fopen("output.txt", "w");
#endif
  int n, m, h, bigcomp = 0, sizecomp = MAX_N + 1, a, b;
  fscanf(fin, "%d%d%d", &n, &m, &h);
  for(int i = 1; i <= n; ++i)
    fscanf(fin, "%d", &u[i]);
  for(int i = 0; i <= m; ++i) {
    fscanf(fin, "%d%d", &a, &b);
    graph[a].push_back(b);
    graph[b].push_back(a);
  }
  for(int i = 1; i <= n; ++i)
    if(!viz[i]) {
      top = 0;
      dfs(i, h);
      if(top < sizecomp) {
        sizecomp = top;
        bigcomp = i;
      }
    }
  for(int i = 1; i <= n; ++i)
    viz[i] = false;
  top = 0;
  dfs(bigcomp, h);
  fprintf(fout, "%d\n", top);
  for(int i = 0; i < top; ++i)
    fprintf(fout, "%d ", noduri[i]);
  return 0;
}

