#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100000;
const int MAX_M = 100000;

vector<int> graph[1+MAX_N];
int u[1+MAX_N];
int top;
int st[MAX_N];
bool inst[1+MAX_N];
int id[1+MAX_N], low[1+MAX_N], lastid;
int compo[1+MAX_N], comp;
int sizecmp[1+MAX_N];

void dfs(int nod) {
  id[nod] = low[nod] = ++lastid;
  inst[nod] = true;
  st[top++] = nod;
  for(auto it: graph[nod]) {
    if(id[it] == 0)
      dfs(it);
    if(inst[it])
      low[nod] = min(low[it], low[nod]);
  }
  if(low[nod] == id[nod]) {
    ++comp;
    do {
      compo[st[top - 1]] = comp;
      inst[st[top - 1]] = false;
      --top;
      sizecmp[comp]++;
    } while(st[top] != nod);
  }
}

int main() {
#ifdef HOME
  FILE* fin = fopen("data.in", "r");
  FILE* fout = fopen("data.out", "w");
#else
  FILE* fin = fopen("input.txt", "r");
  FILE* fout = fopen("output.txt", "w");
#endif
  int n, m, h, bestcomp, sizecomp = MAX_N + 1, a, b;
  fscanf(fin, "%d%d%d", &n, &m, &h);
  for(int i = 1; i <= n; ++i)
    fscanf(fin, "%d", &u[i]);
  for(int i = 0; i <= m; ++i) {
    fscanf(fin, "%d%d", &a, &b);
    if((u[a] + 1) % h == u[b])
      graph[a].push_back(b);
    if((u[b] + 1) % h == u[a])
      graph[b].push_back(a);
  }
  for(int i = 1; i <= n; ++i)
    if(id[i] == 0) {
      dfs(i);
    }
  for(int i = 1; i <= n; ++i)
    for(auto it: graph[i])
      if(compo[i] != compo[it])
        sizecmp[compo[i]] = MAX_N + 1;
  for(int i = 1; i <= comp; ++i)
    if(sizecmp[i] < sizecomp) {
      sizecomp = sizecmp[i];
      bestcomp = i;
    }
  fprintf(fout, "%d\n", sizecomp);
  for(int i = 1; i <= n; ++i)
    if(compo[i] == bestcomp)
      fprintf(fout, "%d ", i);
  return 0;
}

