#include <bits/stdc++.h>

using namespace std;

const int MAX_L = 14;
const int MAX_X = 1 << MAX_L;
const int SHIFT = MAX_X >> 1;
const int SHIFT_L = MAX_L / 2;
bitset<MAX_X+1> pattern;
bitset<MAX_X+1> dp[MAX_X];
int popcount[MAX_X];

void debugbitset(bitset<MAX_X+1> xd) {
  printf("{");
  for(int i = 0; i <= MAX_X; ++i)
    if(xd[i])
      printf("%d,", i - SHIFT);
  printf("}\n\n");
}

int main() {
#ifdef HOME
  FILE *fin = fopen("munch.in", "r");
  FILE *fout = fopen("munch.out", "w");
#else
  FILE *fin = fopen("input.txt", "r");
  FILE *fout = fopen("output.txt", "w");
#endif
  int n, x, best = 100, rezp = -1;
  fscanf(fin, "%d", &n);
  for(int i = 0; i < n; ++i) {
    fscanf(fin, "%d", &x);
    x += SHIFT;
    pattern[x] = 1;
  }
  dp[0][SHIFT] = 1;
  for(int i = 1; i < (1 << MAX_L); ++i) {
    int l = 0;
    while(!((1 << l) & i))
      ++l;
    popcount[i] = popcount[i ^ (1 << l)] + 1;
    if(l < SHIFT_L)
      dp[i] = (dp[i ^ (1 << l)] >> (1 << l)) | dp[i ^ (1 << l)];
    else {
      dp[i] = (dp[i ^ (1 << l)] << (1 << (l - SHIFT_L))) | dp[i ^ (1 << l)];
    }
  }
  
  for(int i = 0; i < (1 << MAX_L); ++i) {
    if(((pattern & dp[i]) == pattern) && popcount[i] < best) {
      best = popcount[i];
      rezp = i;
    }
  }
  fprintf(fout, "%d\n", best);
  for(int i = 0; i < MAX_L; ++i)
    if(((1 << i) & rezp) && i < SHIFT_L)
      fprintf(fout, "%d ", -(1 << i));
    else if((1 << i) & rezp)
      fprintf(fout, "%d ", (1 << (i - SHIFT_L)));
  fclose(fin);
  fclose(fout);
  return 0;
}

