#include <bits/stdc++.h>
#pragma optimize("O3")

using namespace std;

#define fi first
#define se second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

typedef vector<int> vint;
typedef long double ld;
typedef long long ll;
typedef string str;

const int MX = 1e6;

int num[MX], cur[MX], colored[MX], clr[MX], u[MX];
int n, m, h;

pair<int, int> cen[MX];

vint par[MX];
vint g[MX];

void color(int v, int clr) {
    colored[v] = clr;
    for (int to : g[v])
        if (colored[to] == 0)
            color(to, clr);
}

set<int> been;

bool check(int v) {
    clr[v] = 1;
    been.insert(v);
    bool f = 0;
    for (int to : g[v]) {
        if (clr[to] == 1)
            f = 1;
        else if (clr[to] == 0)
            f = check(to);
    }
    return f;
}

set<int> ans, cur;

void solve(int v) {
    u[v] = 1;
    cur.insert(v);
    for (int to : g[v])
        if (!u[to])
            solve(to);
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> num[i];
    for (int i = 0; i < m; ++i) {
        cin >> cen[i].fi >> cen[i].se;
        --cen[i].fi, --cen[i].se;
        par[cen[i].fi].pb(cen[i].se);
        par[cen[i].se].pb(cen[i].fi);
    }
    for (int i = 0; i < n; ++i) {
        for (int to : par[i]) {
            if (num[to] == num[i] + 1) {
                g[i].pb(to);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        bool f = check(i);
        if (f) {
            for (int x : been)
                u[x] = 1;
        }
        been.clear();
    }
    for (int i = 0; i < n; ++i) {
        if (!u[i]) {
            solve(i);
            if (sz(cur) && (ans.emty() || sz(cur) < sz(ans)))
                ans.swap(cur);
        }
    }
    cout << ans.size() << endl;
    for (int x : ans)
        cout << x + 1 <<  " ";
}
