#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX_N = 200 * 1000 + 5;
int nex[MAX_N];
bool used[MAX_N];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    string s;
    cin >> s;
    for(int i = 0; i < 1000; i++)
        nex[i] = i;
    int i = 0, q = s.size();
    bool exist = true;
    for(int j = 0; j < s.size(); j++){
        if(s[j] == '1'){
            while(i < j && s[i] != '0')
                i++;
            if(i == j){
                exist = false;
                break;
            }
            else{
                nex[i++] = j;
                --q;
            }
        }
    }
    i = s.size() - 1;
    for(int j = s.size() - 1; j >= 0; j--){
        if(s[j] == '1'){
            while(i > j && s[i] != '0')
                --i;
            if(i == j){
                exist = false;
                break;
            }
            else{
                nex[j] = i--;
                q--;
            }
        }
    }
    if(!exist)
        cout << -1;
    else{
        fill(used, used + MAX_N, false);
        int start = 0;
        cout << q << '\n';;
        while(start < s.size()){
            i = start++;
            used[i] = true;
            vector<int> add;
            add.push_back(i);
            while(i < s.size() && nex[i] != i){
                i = nex[i];
                add.push_back(i);
                used[i] = true;
            }
            cout << add.size() << ' ';
            for(int k = 0; k < add.size(); k++)
                cout << add[k] + 1 << ' ';
            cout << '\n';
            while(start < s.size() && used[start])
                ++start;
        }
    }

    /*
    fill(a, a + MAX_N, 0);
    char prev = s[0];
    int n = -1;
    b[0] = (s[0] == '1')? 1: 0;
    for(int i = 0; i < s.size(); i++){
        ++a[++n];
        b[n] = (s[i] == '1')? 1: 0;
        /*if(s[i] == prev)
            ++a[n];
        else{
            prev = s[i];
            ++a[++n];
            b[n] = (prev == '1')? 1: 0;
        }
    }
    ++n;
    vector< vector<int> > ans;
    bool flag = true, exists = true;
    while(flag){
        int i = 0;
        while(i < n && a[i] == 0)
            ++i;
        if(i == n){
            flag = false;
            break;
        }
        if(b[i] == 0){
            vector<int> add;
            add.push_back(i);
            ans.push_back(add);
            --a[i];
        }
        else{
            exists = false;
            flag = false;
            break;
        }
        int prev = 0;
        while(i < n){
            if(a[i] > 0 && b[i] != prev){
                --a[i];
                ans[ans.size() - 1].push_back(i);
                prev = b[i];
            }
            ++i;
        }
        if(prev == 1){
            exists = false;
            flag = false;
            break;
        }
    }*/
    /*if(!exists)
        cout << -1;
    else{
        cout << ans.size() << '\n';
        for(int i = 0; i < ans.size(); i++){
            cout << ans[i].size() << ' ';
            for(int j = 0; j < ans[i].size(); j++)
                cout << ans[i][j] + 1 << ' ';
            cout << '\n';
        }
    }*/
    return 0;
}
