#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX_N = 200 * 1000 + 5;
int nex[MAX_N];
int print[MAX_N];
bool used[MAX_N];

int main(){
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    string s;
    cin >> s;
    for(int i = 0; i < 1000; i++)
        nex[i] = i;
    int i = 0, q = s.size();
    bool exist = true;
    for(int j = 0; j < s.size(); j++){
        if(s[j] == '1'){
            while(i < j && s[i] != '0')
                i++;
            if(i == j){
                exist = false;
                break;
            }
            else{
                nex[i++] = j;
                --q;
            }
        }
    }
    i = s.size() - 1;
    for(int j = s.size() - 1; j >= 0; j--){
        if(s[j] == '1'){
            while(i > j && s[i] != '0')
                --i;
            if(i == j){
                exist = false;
                break;
            }
            else{
                nex[j] = i--;
                q--;
            }
        }
    }
    if(!exist)
        cout << -1;
    else{
        fill(used, used + MAX_N, false);
        int start = 0;
        cout << q << '\n';
        while(start < s.size()){
            int k = 0;
            i = start++;
            used[i] = true;
            print[k++] = i;
            while(i < s.size() && nex[i] != i){
                i = nex[i];
                print[k++] = i;
                used[i] = true;
            }
            cout << k << ' ';
            for(int l = 0; l < k; l++)
                cout << print[l] + 1 << ' ';
            cout << '\n';
            while(start < s.size() && used[start])
                ++start;
        }
    }
    return 0;
}
