#include <bits/stdc++.h>
using namespace std;

int p, n, d, b;
vector<int> a;

vector<pair<int, int> > t;

void build(int v, int tl, int tr)
{
    if(tl == tr)
    {
        t[v].first = t[v].second = a[tl];
    } else
    {
        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm + 1, tr);

        t[v].first = t[2 * v + 1].first + t[2 * v + 2].first;
        t[v].second = -1;
    }
}

int get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
    {
        return 0;
    } else if(t[v].second != -1)
    {
        return t[v].second * (r - l + 1);
    } else if(tl == l && tr == r)
    {
        return t[v].first;
    } else
    {
        int tm = (tl + tr) / 2;

        return get(2 * v + 1, tl, tm, l, min(tm, r)) + get(2 * v + 2, tm + 1, tr, max(tm + 1, l), r);
    }
}

void update(int v, int tl, int tr, int l, int r, int val)
{
    if(l > r)
    {
        return;
    } else if(tl == l && tr == r)
    {
        t[v].second = val;
        t[v].first = (tr - tl + 1) * val;
    } else
    {
        int tm = (tl + tr) / 2;
        if(t[v].second != -1)
        {
            t[2 * v + 1].second = t[2 * v + 2].second = t[v].second;
            t[2 * v + 1].first = t[v].second * (tm - tl + 1);
            t[2 * v + 2].first = t[v].second * (tr - tm);
            t[v].second = -1;
        }

        update(2 * v + 1, tl, tm, l, min(tm, r), val);
        update(2 * v + 2, tm + 1, tr, max(tm + 1, l), r, val);
        t[v].first = t[2 * v + 1].first + t[2 * v + 2].first;
    }
}

void solve1()
{
    int ans = 0;
    for(int i = 0; i < n; ++i)
    {
        int cur_a = get(0, 0, n - 1, i, i);
        if(cur_a < b)
        {
            if(i == n - 1)
            {
                ++ans;
                break;
            }
            /*int last = a[i];
            vector<int> add(n, 0);
            for(int j = i + 1; j <= i + (i + 1) * d && j < n; ++j)
            {
                if(a[j] > 0)
                {
                    int dif = min(b - a[i], a[j]);
                    a[j] -= dif;
                    a[i] += dif;
                    add[j] = dif;
                    if(a[i] == b)
                    {
                        break;
                    }
                }
            }
            if(a[i] < b)
            {
                ++ans;
                a[min(i + d, n - 1)] += last;
                for(int j = i + 1; j < n; ++j)
                {
                    a[j] += add[j];
                }
            }*/
            int l = i + 1,
                r = min(i + d, n - 1);
            while(l != r)
            {
                int mid = (l + r) / 2;
                if(get(0, 0, n - 1, i + 1, mid) >= b - cur_a)
                {
                    r = mid;
                } else
                {
                    l = mid + 1;
                }
            }
            if(get(0, 0, n - 1, i + 1, l) >= b - cur_a)
            {
                int cur_val = 0;
                if(i + 1 < l)
                {
                    cur_val += get(0, 0, n - 1, i + 1, l - 1);
                    update(0, 0, n - 1, i + 1, l - 1, 0);
                }
                int dif = b - cur_a - cur_val;
                int prev_val = get(0, 0, n - 1, l, l);
                update(0, 0, n - 1, l, l, prev_val - dif);
            } else
            {
                ++ans;
                //update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_a);
                int cur_val = get(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1)) + cur_a;
                update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_val);
            }
        } else
        {
            //a[min(i + d, n - 1)] += a[i] - b;
            //update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_a - b);
            int cur_val = get(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1)) + cur_a - b;
            update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_val);
        }
    }
    printf("%d", ans);
}

void solve2()
{

}

int main()
{
    scanf("%d%d%d%d", &p, &n, &d, &b);
    a.resize(n);
    for(int i = 0; i < n; ++i)
    {
        scanf("%d", &a[i]);
    }
    t.resize(4 * n);
    build(0, 0, n - 1);
    if(p == 1)
    {
        solve1();
    } else
    {
        solve2();
    }

    return 0;
}
