#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int p, n, d, b;
vector<int> a;

vector<pair<int, int> > t;

void build(int v, int tl, int tr)
{
    if(tl == tr)
    {
        t[v].first = t[v].second = a[tl];
    } else
    {
        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm + 1, tr);

        t[v].first = t[2 * v + 1].first + t[2 * v + 2].first;
        t[v].second = -1;
    }
}

int get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
    {
        return 0;
    } else if(t[v].second != -1)
    {
        return t[v].second * (r - l + 1);
    } else if(tl == l && tr == r)
    {
        return t[v].first;
    } else
    {
        int tm = (tl + tr) / 2;

        return get(2 * v + 1, tl, tm, l, min(tm, r)) + get(2 * v + 2, tm + 1, tr, max(tm + 1, l), r);
    }
}

void update(int v, int tl, int tr, int l, int r, int val)
{
    if(l > r)
    {
        return;
    } else if(tl == l && tr == r)
    {
        t[v].second = val;
        t[v].first = (tr - tl + 1) * val;
    } else
    {
        int tm = (tl + tr) / 2;
        if(t[v].second != -1)
        {
            t[2 * v + 1].second = t[2 * v + 2].second = t[v].second;
            t[2 * v + 1].first = t[v].second * (tm - tl + 1);
            t[2 * v + 2].first = t[v].second * (tr - tm);
            t[v].second = -1;
        }

        update(2 * v + 1, tl, tm, l, min(tm, r), val);
        update(2 * v + 2, tm + 1, tr, max(tm + 1, l), r, val);
        t[v].first = t[2 * v + 1].first + t[2 * v + 2].first;
    }
}

void solve1()
{
    int ans = 0;
    for(int i = 0; i < n; ++i)
    {
        int cur_a = get(0, 0, n - 1, i, i);
        if(cur_a < b)
        {
            if(i == n - 1)
            {
                ++ans;
                break;
            }
            /*int last = a[i];
            vector<int> add(n, 0);
            for(int j = i + 1; j <= i + (i + 1) * d && j < n; ++j)
            {
                if(a[j] > 0)
                {
                    int dif = min(b - a[i], a[j]);
                    a[j] -= dif;
                    a[i] += dif;
                    add[j] = dif;
                    if(a[i] == b)
                    {
                        break;
                    }
                }
            }
            if(a[i] < b)
            {
                ++ans;
                a[min(i + d, n - 1)] += last;
                for(int j = i + 1; j < n; ++j)
                {
                    a[j] += add[j];
                }
            }*/
            int l = i + 1,
                r = (int)min(ll(i) + ll(i + 1) * ll(d), ll(n - 1));
            while(l != r)
            {
                int mid = (l + r) / 2;
                if(get(0, 0, n - 1, i + 1, mid) >= b - cur_a)
                {
                    r = mid;
                } else
                {
                    l = mid + 1;
                }
            }
            if(get(0, 0, n - 1, i + 1, l) >= b - cur_a)
            {
                int cur_val = 0;
                if(i + 1 < l)
                {
                    cur_val += get(0, 0, n - 1, i + 1, l - 1);
                    update(0, 0, n - 1, i + 1, l - 1, 0);
                }
                int dif = b - cur_a - cur_val;
                int prev_val = get(0, 0, n - 1, l, l);
                update(0, 0, n - 1, l, l, prev_val - dif);
            } else
            {
                ++ans;
                //update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_a);
                int cur_val = get(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1)) + cur_a;
                update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_val);
            }
        } else
        {
            //a[min(i + d, n - 1)] += a[i] - b;
            //update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_a - b);
            int cur_val = get(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1)) + cur_a - b;
            update(0, 0, n - 1, min(i + d, n - 1), min(i + d, n - 1), cur_val);
        }
    }
    printf("%d", ans);
}

void solve2()
{
    int ans = 0;
    vector<vector<int> > dp;
    int s = n / 2 + n % 2;
    dp.resize(s + 1);
    for(int i = 0; i <= s; ++i)
    {
        dp[i].resize(n, 0);
    }
    for(int i = 0; i < n; ++i)
    {
        dp[0][i] = a[i];
    }
    for(int i = 1; i <= s; ++i)
    {
        for(int j = 0; j < n; ++j)
        {
            dp[i][j] += dp[i - 1][j];
            //cout << dp[i][j] << " ";
        }
        //cout << endl;
        int l = i - 1,
            r = n - i;
        if(l > r)
        {
            break;
        }
        if(dp[i][l] == 0)
        {
            for(int j = l + 1; j <= l + i * d && j < n; ++j)
            {
                int st = (j - l) / d;
                if((j - l) % d > 0)
                {
                    ++st;
                }
                int cur_st = n - j;
                if(st > i)
                {
                    break;
                }
                int pu = min(i - st, cur_st - 1);
                if(dp[pu][j] > 0)
                {
                    dp[i][l] = 1;
                    --dp[i][j];
                    break;
                }
            }
        } else if(i + 1 != s)
        {
            for(int j = l + 1; j <= l + d && j < n; ++j)
            {
                dp[i + 1][j] += dp[i][l] - 1;
            }
        }

        if(l != r)
        {
            if(dp[i][r] == 0)
            {
                for(int j = r - 1; j >= r - i * d && j >= 0; --j)
                {
                    int st = (r - j) / d;
                    if((r - j) % d > 0)
                    {
                        ++st;
                    }
                    int cur_st = j + 1;
                    if(st > i)
                    {
                        break;
                    }
                    int pu = min(i - st, cur_st - 1);
                    if(dp[pu][j] > 0)
                    {
                        dp[i][r] = 1;
                        --dp[i][j];
                        break;
                    }
                }
            } else if(i + 1 != s)
            {
                for(int j = max(0, r - d); j <= r - 1; ++j)
                {
                    dp[i + 1][j] += dp[i][r] - 1;
                }
            }
        }
        if(dp[i][l] == 0)
        {
            //cout << l << endl;
            ++ans;
        }
        if(l != r && dp[i][r] == 0)
        {
            //cout << r << endl;
            ++ans;
        }
    }

    printf("%d", ans);
}

int main()
{
    scanf("%d%d%d%d", &p, &n, &d, &b);
    a.resize(n);
    for(int i = 0; i < n; ++i)
    {
        scanf("%d", &a[i]);
    }
    t.resize(4 * n);
    build(0, 0, n - 1);
    if(p == 1)
    {
        solve1();
    } else
    {
        solve2();
    }

    return 0;
}
