#include<bits/stdc++.h>
#define int long long
using namespace std;
const int MAXN = 1e3;
int ver = 0;
vector<int> g[MAXN];
int mt[MAXN];
int used[MAXN];
bool try_kuhn(int v){
    if(used[v]) return 0;
    used[v] = 1;
    for(auto to : g[v]){
        if(mt[to] == -1 || try_kuhn(mt[to])){
            mt[to] = v;
            return 1;
        }
    }
    return 0;
}

signed main(){
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    if(b != 1) return 1;
    for(int i = 0; i < n; i++){
        int a;
        cin >> a;
        vector<int> q;
        for(int j = 0; j < n; j++){
            int dist = abs(i - j);
            int tm;
            if(p == 1 || j < n/2) tm = j + 1;
            else{
                tm = (n - j);
            }
            if(tm * d >= dist){
                q.push_back(j);
            }
        }
        for(int j = 0; j < a; j++){
            g[ver++] = q;
        }
    }
    memset(mt, -1, sizeof(mt));
    for(int i = 0; i < n; i++){
        memset(used,0, sizeof(used));
        try_kuhn(i);
    }
    int sz = 0;
    for(int i = 0; i < n; i++){
        if(mt[i] != -1) sz++;
    }
    cout << n - sz;
    return 0;
}
