#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>


using  namespace std;

typedef long long ll;

vector<int> used;
vector<vector<int> > g;
vector<vector<int> > gT;
vector<int> a;
vector<int> color;

void dfs(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (used[u] == 0) {
            dfs(u);
        }
    }
    a.push_back(v);
}

void dfsT(int v, int col) {
    used[v] = 1;
    color[v] = col;
    for (int u : gT[v]) {
        if (used[u] == 0) {
            dfsT(u, col);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    g.resize(n);
    gT.resize(n);
    color.resize(n);
    used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> u[i];
    }
    vector<int> c1(m);
    vector<int> c2(m);
    for (int i = 0; i < m; i++) {
        cin >> c1[i] >> c2[i];
    }
    for (int i = 0; i < m; i++) {
        c1[i]--;
        c2[i]--;
    }
    for(int i = 0; i < m; i++) {
        if ((u[c1[i]] + 1) % h == u[c2[i]]) {
            g[c1[i]].push_back(c2[i]);
            gT[c2[i]].push_back(c1[i]);
        }
        if ((u[c2[i]] + 1) % h == u[c1[i]]) {
            g[c2[i]].push_back(c1[i]);
            gT[c1[i]].push_back(c2[i]);
        }
    }
    //for (int i = 0; i < n; i++) {
      //  for (int u : g[i]) {
        //    cout << u << " ";
        //}
        //cout << endl;
    //}
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    reverse(a.begin(), a.end());
    for (int i = 0; i < n; i++) {
        used[i] = 0;
    }
    int col = 0;
    for (int i = 0; i < n; i++) {
        if (used[a[i]] == 0) {
            dfsT(a[i], col);
            col++;
        }
    }
    vector<int> num(col);
    for (int i = 0; i < n; i++) {
        num[color[i]]++;
    }
    vector<vector<int> > g_new(col);
    for (int i = 0; i < n; i++) {
        for (int u : g[i]) {
            if (color[u] != color[i]) {
                g_new[color[i]].push_back(color[u]);
            }
        }
    }
    int ans = 1e9;
    int ans_i = 0;
    for (int i = 0; i < col; i++) {
        if (g_new[i].size() == 0) {
            if (num[i] < ans) {
                ans_i = i;
                ans = num[i];
            }
        }
    }
    //for (int i = 0; i < n; i++) {
     //   cout << color[i] << " ";
    //}
    //cout << endl;
    cout << ans << endl;
    for (int i = 0; i < n; i++) {
        if (color[i] == ans_i) {
            cout << i + 1 << " ";
        }
    }
    //system("pause");
    return 0;
}
/*
4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/