#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>


using  namespace std;

typedef long long ll;

vector<int> ans;
vector<int> used;
vector<vector<int> > g;
void dfs(int v) {
    used[v] = 1;
    ans.push_back(v + 1);
    for (int u : g[v]) {
        if (used[u] == 0) {
            dfs(u);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    int n;
    string s;
    cin >> s;
    n = s.size();
    vector<int> a(n);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        a[i] = s[i] - '0';
    }
    int i = 0;
    int j = 0;
    while (i < n && j < n) {
        bool f = 0;
        while (a[j] != 1) {
            j++;
            if (j == n) {
                f = 1;
                break;
            }
        }
        while (a[i] != 0) {
            i++;
            if (i == n) {
                f = 1;
                break;
            }
        }
        if (f == 1) {
            break;
        }
        if (j < i) {
            cout << -1;
            return 0;
        }
        else {
            g[i].push_back(j);
            g[j].push_back(i);
            i++;
            j++;
        }
    }
    if (j != n) {
        cout << -1;
        return 0;
    }
    i = n - 1;
    j = n - 1;
    while (i >= 0 && j >= 0) {
        bool f = 0;
        while (a[j] != 1) {
            j--;
            if (j == -1) {
                f = 1;
                break;
            }
        }
        while (a[i] != 0) {
            i--;
            if (i == -1) {
                f = 1;
                break;
            }
        }
        if (f == 1) {
            break;
        }
        if (j > i) {
            cout << -1;
            return 0;
        }
        else {
            g[i].push_back(j);
            g[j].push_back(i);
            i--;
            j--;
        }
    }
    if (j != -1) {
        cout << -1;
        return 0;
    }
    vector<vector<int> > ans_end;
    used.resize(n);
    for (int i = 0; i < n; i++) {
        ans.clear();
        if (used[i] == 0) {
            dfs(i);
            ans_end.push_back(ans);
        }
    }
    cout << ans_end.size() << endl;
    for (int i = 0; i < ans_end.size(); i++) {
        cout << ans_end[i].size() << " ";
        for (int j = 0; j < ans_end[i].size(); j++) {
            cout << ans_end[i][j] << " ";
        }
        cout << endl;
    }
    //system("pause");
    return 0;
}