#include <bits/stdc++.h>

using namespace std;

int p, n, d, b;
vector<int> a;

int get_sum(vector<int> & s, int l, int r) {
    l = min(n, l);
    r = min(n - 1, r);
    if (l == 0)
        return s[r];
    else
        return s[r] - s[l - 1];
}

int solve(vector<int> & a, int st) {
    vector<int> s(n);
    s[0] = a[0];
    for (int i = 1; i < n; ++i) s[i] = s[i - 1] + a[i];
    int ans = 0, cur = 0;
    for (int i = 0; i < st; ++i) {
        cur += get_sum(s, (d + 1) * i, (d + 1) * i + d);
        if (cur >= b)
            cur -= b;
        else
            ans++;
    }
    return ans;
}

signed main() {
    cin >> p >> n >> d >> b;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (p == 1) {
        cout << solve(a, n) << endl;
    } else {
        vector<int> left(n, 0);
        int sum = 0;
        int sleft = n / 2 + n % 2;
        for (int i = 0; i < n; ++i) {
            if (sum != sleft * b) {
                left[i] = min(sleft * b - sum, a[i]);
                sum += left[i];
            }
        }

        reverse(a.begin(), a.end());
        vector<int> right(n, 0);
        sum = 0;
        int sright = n / 2 + n % 2;
        for (int i = 0; i < n; ++i) {
            if (sum != sright * b) {
                right[i] = min(sright * b - sum, a[i]);
                sum += right[i];
            }
        }
        cout << max(solve(right, sright), solve(left, sleft)) << endl;
    }
}
