#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;





const int N = 1000;
int cl[N];

std::set<int> edg[N];
int par[N];
int deep[N];
int cn[N][N];

void init()
{
    for (int i = 0; i < N; ++i)
    {
        par[i] = i;
        deep[i] = 0;
        cl[i] = 0;
        edg[i].clear();
        for (int j = 0; j < N; ++j)
            cn[i][j] = 0;
    }
}


int get(int v)
{
    if (par[v] == v)
        return v;
    int res = get(par[v]);
    par[v] = res;
    return res;
}

int un(int v1, int v2)
{
    v1 = get(v1);
    v2 = get(v2);
    if (deep[v1] > deep[v2])
        std::swap(v1, v2);
    par[v1] = v2;
    if (deep[v1] == deep[v2])
        ++deep[v2];
    return v2;
}


void dfs(int v, int str)
{
    cl[v] = 1;
    cn[str][v] = 1;
    for (int i : edg[v])
        if (!cl[i])
            dfs(i, str);
}


void get_ans(int n, int m, int h)
{
    init();
    int u[n];
    for (int i = 0; i < n; ++i)
        scanf("%d", u + i);
    int mem1[m], mem2[m];
    for (int i = 0; i < m; ++i)
    {
        int c1, c2;
        scanf("%d %d", &c1, &c2);
        --c1, --c2;
        mem1[i] = c1;
        mem2[i] = c2;
        if ((u[c1] + 1) % h == u[c2])
            edg[c1].insert(c2);
        if ((u[c2] + 1) % h == u[c1])
            edg[c2].insert(c1);
    }
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
            cl[j] = 0;
        dfs(i, i);
    }
    for (int i = 0; i < n - 1; ++i)
        for (int j = i + 1; j < n; ++j)
            if (cn[i][j] && cn[j][i])
                un(i, j);    
    int cnt[n];
    int is_good[n];
    for (int i = 0; i < n; ++i)
    {
        cnt[i] = 0;
        is_good[i] = 1;
    }
    for (int i = 0; i < n; ++i)
        ++cnt[get(i)];
    for (int i = 0; i < m; ++i)
    {
        int c1 = mem1[i], c2 = mem2[i];
        if ((u[c1] + 1) % h == u[c2] && get(c1) != get(c2))
            is_good[c1] = 0;
        if ((u[c2] + 1) % h == u[c1] && get(c2) != get(c1))
            is_good[c2] = 0;
    }
    int ans_yk = -1;
    for (int i = 0; i < n; ++i)
        if (cnt[i] > 0 && is_good[i] && (ans_yk == -1 || cnt[i] < cnt[ans_yk]))
            ans_yk = i;
    std::vector<int> ans;
    for (int i = 0; i < n; ++i)
        if (get(i) == ans_yk)
            ans.push_back(i + 1);
    printf("%d\n", ans.size());
    for (int i : ans)
        printf("%d ", i);
    printf("\n");       
}

int main()
{
    int n, m, h;
    while (scanf("%d %d %d", &n, &m, &h) == 3)
        get_ans(n, m, h);
    return 0;
}