#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <ctime>

using namespace std;
const int MAXN = 1e5 + 100;

int p, n, d, b;
int mas[MAXN];

bool mnr(long long a, long long b, long long c){
    return a <= b * c;
}

void f(vector<int>& ans){
    int cs = 0;
    int r = 0;
    int ca = 0;

    ans[0] = 0;

    for (int i = 0; i < n; ++i){
        while ((r < n) && (mnr(r - i, d, i + 1))){
            cs += mas[r];
            r++;
        }

        if (cs >= b){
            ca++;
            cs -= b;
        }

        ans[i + 1] = ca;
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> p >> n >> d >> b;
    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    if (p == 1){
        vector<int> ans(n + 1);
        f(ans);
        cout << n - ans[n] << endl;
    } else {
        vector<int> ans1(n + 1);
        vector<int> ans2(n + 1);

        f(ans1);
        reverse(mas, mas + n);
        f(ans2);
        int ans = n;

        for (int i = 0; i <= (n + 1) / 2; ++i){
            for (int j = 0; j <= n / 2; ++j){
                if (ans1[i] + ans2[j] <= n){
                    ans = min(ans, max((n + 1) / 2 - ans1[i], n / 2 - ans2[i]));
                }
            }
        }
        cout << ans << endl;
    }

    return 0;
}
