#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <ctime>

using namespace std;
const int MAXN = 202;
const int MAXST = 8;

int n;
int gi[2 * MAXN];
bitset<MAXN> dp[(1 << (2 * MAXST))];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    set<int> st;
    for (int i = 0; i < n; ++i){
        int a;
        cin >> a;
        st.insert(a);
    }

    fill(gi, gi + 2 * MAXN, -1);

    int cur = 0, cnt;
    for (auto e : st){
        gi[e + MAXN] = cur++;
    }
    n = cur;

    pair<int, int> ans;
    ans.first = 2 * MAXST + 1;

    for (int i = 0; i < (1 << (2 * MAXST)); ++i){
        cur = 0;
        cnt = 0;
        for (int j = 0; j < 2 * MAXST; ++j){
            if ((1 << j) & i){
                dp[i] |= dp[(i ^ (1 << j))];
                if (j >= MAXST){
                    cur += (1 << (j - MAXST));
                } else {
                    cur += -(1 << (MAXST - j - 1));
                }
                cnt++;
            }
        }

        if ((-MAXN <= cur) && (cur < MAXN) && (gi[cur + MAXN] != -1)){
            dp[i][(1 << gi[cur + MAXN])] = 1;
        }

        if (dp[i].count() == n){
            if (ans.first > cnt){
                ans = {cnt, i};
            }
        }
    }

    cout << ans.first << endl;
    for (int j = 0; j < 2 * MAXST; ++j){
        if ((1 << j) & ans.second){
            if (j >= MAXST){
                cout << (1 << (j - MAXST)) << ' ';
            } else {
                cout << -(1 << (MAXST - j - 1)) << ' ';
            }
        }
    }
    cout << endl;

    return 0;
}
