#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <string>
#include <ctime>

using namespace std;
const int MAXN = 2e5 + 100;

int n;
string str;
bool used[MAXN];
vector<vector<int>> ans;

bool f(){
    int ozh = 0;
    vector<int> cv;

    for (int i = 0; i < n; ++i){
        if (used[i]) continue;

        if (str[i] - '0' == ozh){
            cv.push_back(i + 1);
            ozh ^= 1;
        }
    }

    if (cv.size() == 0){
        return false;
    }

    if (ozh == 0){
        cv.pop_back();
    }

    if (cv.size() == 0){
        return false;
    }

    ans.push_back(cv);
    for (auto e : cv){
        used[e - 1] = true;
    }

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> str;
    n = str.size();

    fill(used, used + n, false);

    while (f());

    for (int i = 0; i < n; ++i){
        if (!used[i]){
            cout << -1 << endl;
            return 0;
        }
    }

    cout << ans.size() << endl;
    for (auto e : ans){
        cout << e.size() << ' ';
        for (auto e2 : e){
            cout << e2 << ' ';
        }
        cout << '\n';
    }
    cout << endl;

    return 0;
}
