#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 100;
int u[maxn], n, m, h, v[maxn];
int c[maxn];
int fst[maxn], snd[maxn];

void gen(int i, int op, int cl) {
    if (i == n) {
        for (int j = 0; j < n; ++j)
            v[j] = c[j] ? (u[j] + 1) % h : u[j];
        bool g = true;
        for (int j = 0; g &&  j < m; ++j)
            if (v[fst[j]] == v[snd[j]])
                g = false;
        if (g) {
            int cnt = 0;
            for (int j = 0; j < n; ++j)
                cnt += c[j];
            cout << cnt << '\n';
            for (int j = 0; j < n; ++j)
                if (c[j])
                    cout << j + 1 << ' ';
            exit(0);
        }
    } else {
        if (cl)
            gen(1 + i, op, cl - 1);
        if (op) {
            c[i] = 1;
            gen(i + 1, op - 1, cl);
            c[i] = 0;
        }
    }
}

int main() {
   // freopen("inp2.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> u[i];
    for (int i = 0; i < m; ++i) {
        cin >> fst[i] >> snd[i];
        --fst[i];
        --snd[i];
    }
    for (int i = 1; i <= n; ++i)
        gen(0, i, n - i);
    return 0;
}