#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 1000;
int t[maxn], n, m, h, c[maxn];
vector<int> g[maxn], tmp;
bool f = 1;

void dfs(int v) {
    c[v] = 1;
    tmp.push_back(v);
    for (auto u : g[v])
        if (!c[u] && (t[v] + 1) % h == t[u])
            dfs(u);
}

int main() {
    //freopen("inp2.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        dfs(i);
        if (f && (ans.empty() || size(tmp) < size(ans)))
            ans = tmp;
        tmp.clear();
        fill(c, c + n, 0);
        f = 1;
    }
    cout << size(ans) << '\n';
    sort(all(ans));
    for (int i = 0; i < size(ans); ++i)
        cout << ans[i] + 1 << ' ';
    return 0;
}