#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

const int maxn = 1000;
int t[maxn], n, m, h, c[maxn], col[maxn], cnt = 0, siz[maxn];
vector<int> g[maxn], order;
vector<int> w[maxn], rw[maxn];
set<int> a[maxn];
int dp[maxn];

void dfs_or(int v) {
    c[v] = 1;
    for (auto u : rw[v])
        if (!c[u])
            dfs_or(u);
    order.push_back(v);
}

int dfs_csc(int v) {
    int sz = 1;
    col[v] = cnt;
    for (auto u : w[v])
        if (col[u] == -1)
            sz += dfs_csc(u);
        else if (col[u] != col[v])
            a[cnt].insert(col[u]);
    return sz;
}

void dfs(int v) {
    dp[v] = siz[v];
    c[v] = 1;
    for (auto u : a[v]) {
        if (!c[u])
            dfs(u);
        dp[v] += dp[u];
    }
}

int main() {
    //freopen("inp3.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
        sort(all(g[i]));
        g[i].erase(unique(all(g[i])), g[i].end());
    }
    for (int i = 0; i < n; ++i) {
        for (auto u : g[i])
            if ((t[i] + 1) % h == t[u]) {
                w[i].push_back(u);
                //cout << u << ' ';
                rw[u].push_back(i);
            }
        //   cout << endl;
    }
    for (int i = 0; i < n; ++i)
        g[i].clear();
    for (int i = 0; i < n; ++i)
        if (!c[i])
            dfs_or(i);
    reverse(all(order));
    for (int i = 0; i < n; ++i)
        w[i].clear();
    fill(col, col + n, -1);
    for (int i = 0; i < n; ++i) {
        int v = order[i];
        if (col[v] != -1)
            continue;
        siz[cnt] = dfs_csc(v);
        ++cnt;
    }
   // cout << cnt << ' ';
    fill(c, c + cnt, 0);
    for (int i = 0; i < cnt; ++i)
        dfs(i);
    int mn = 0;
    for (int i = 0; i < cnt; ++i)
        if (dp[i] <= dp[mn])
            mn = i;
    cout << dp[mn] << '\n';
    for (int i = 0; i < n; ++i)
        if (col[i] == mn)
            cout << i + 1 << ' ';
    return 0;
}