#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <fstream>

using namespace std;
typedef long long ll;

#define all(v) v.begin(), v.end()
#define size(v) ((int)v.size())

vector<int> a, b, c;
int n, k, sz = 21;
unordered_set<int> prv, dp;

void gen(int i) {
    if (i == k) {
        prv.insert(0);
        dp.insert(0);
        for (int j = 0; j < k; ++j) {
            for (auto u : prv)
                dp.insert(u + b[j]);
            prv = dp;
        }
        bool f = 1;
        for (int j = 0; f && j < n; ++j)
            f = dp.find(a[j]) != dp.end();
        if (f) {
            cout << k << endl;
            sort(all(b));
            for (auto u : b)
                cout << u << ' ';
            exit(0);
        }
        dp.clear();
        prv.clear();
    } else {
        for (int j = 0; j < sz * 2; ++j) {
            b[i] = c[j];
            gen(i + 1);
        }
    }
}

int main() {
    //freopen("inp2.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(312323);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    c.resize(40);
    for (int i = 0; i < sz; ++i) {
        c[i] = 1 << i;
        c[i + sz] = -c[i];
        //cout << c[i] << ' ';
    }
  //  random_shuffle(all(c));
    for (k = 1;; ++k) {
        b.resize(k);
        gen(0);
    }
    return 0;
}