#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef long double ld;

#define endl "\n"
#define mp make_pair
#define pb push_back

const int mod = 1000000007;
const int INF = 1000000000;

int n, m, h, u[100005], used[100005], st[100005], V;
vector <int> e[100005];
vector <int> result, order;

void dfs(int v);
void getOrder(int v);

int main()
{
    int a, b;

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n >> m >> h;

    for (int i = 1; i <= n; i++)
        cin >> u[i];

    for (int i = 0; i < m; i++) {
        cin >> a >> b;

        if (((u[a] + 1) % h) == u[b])
            e[a].push_back(b);

        if (((u[b] + 1) % h) == u[a])
            e[b].push_back(a);
    }

    for (int i = 1; i <= n; i++) {
        if (!used[i])
            dfs(i);
    }

    V = 1;

    for (int i = 1; i <= n; i++) {
        used[i] = 0;

        if (st[i] < st[V])
            V = i;
    }

    getOrder(V);
    result = order;

    /**for (int i = 1; i <= n; i++) {
        for (int j = 0; j < order.size(); j++)
            used[order[j]] = 0;

        order.clear();
        dfs(i);

        if (result.empty() || (order.size() < result.size()))
            result = order;
    }*/

    cout << result.size() << endl;

    for (int i = 0; i < result.size(); i++)
        cout << result[i] << " ";

    return 0;
}

void dfs(int v) {
    used[v] = 1;
    st[v]++;

    for (int i = 0; i < e[v].size(); i++) {
        if (used[e[v][i]] == 1)
            continue;

        if (!used[e[v][i]])
            dfs(e[v][i]);

        st[v] += st[e[v][i]];
    }

    used[v] = 2;
}

void getOrder(int v) {
    order.push_back(v);
    used[v] = 1;

    for (int i = 0; i < e[v].size(); i++) {
        if (!used[e[v][i]])
            getOrder(e[v][i]);
    }
}
