#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define X first
#define Y second
#define ll long long
#define is insert
#define er erase
using namespace std;
using namespace __gnu_pbds;



int p, n, d, b, a[100005], ans, t[400005];

void build(int v, int LG, int RG){
    if(LG == RG){
        t[v] = a[LG];
    }
    else{
        int MG = (LG + RG) / 2;
        build(v * 2, LG, MG);
        build(v * 2 + 1, MG + 1, RG);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

void update(int v, int LG, int RG, int pos, int value){
    if(LG == RG){
        t[v] += value;
    }
    else{
        int MG = (LG + RG) / 2;
        if(pos <= MG){
            update(v * 2, LG, MG, pos, value);
        }
        else{
            update(v * 2 + 1, MG + 1, RG, pos, value);
        }
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int get(int v, int LG, int RG, int l, int r){
    if(r < l){
        return 0;
    }
    if(LG == l && RG == r){
        return t[v];
    }
    int MG = (LG + RG) / 2;
    return get(v * 2, LG, MG, l, min(r, MG)) + get(v * 2 + 1, MG + 1, RG, max(l, MG + 1), r);
}

int main(){
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> p >> n >> d >> b;
    a[0] = 0;
    for(int i = 1; i <= n; ++i){
        cin >> a[i];
    }
    build(1, 1, n);
    if(p == 1){
        ans = 0;
        int r = 2;
        for(int i = 1; i <= n; ++i){
            if(a[i] >= b && i != n){
                a[i + 1] += a[i] - b;
                update(1, 1, n, i + 1, a[i] - b);
            }
            else{
                if(get(1, 1, n, i, min(n, i + d)) >= b){
                    while(r <= n && r <= i + d){
                        if(a[i] < b && a[i] + a[r] > b){
                            update(1, 1, n, r, -(b - a[i]));
                            a[r] -= b - a[i];
                            a[i] += b - a[i];
                            break;
                        }
                        a[i] += a[r];
                        r++;
                    }
                }
                else{
                    ans++;
                    a[i + 1] += a[i];
                    update(1, 1, n, i + 1, a[i]);
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}


