#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100001;

set<int> g[MAXN];

int h[MAXN];
int p[MAXN];
bool used[MAXN];
int tin[MAXN];

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    int n, m, H;
    cin >> n >> m >> H;

    assert(n == 10 || n <= 8);

    for(int i = 0; i < n; ++i)
        cin >> h[i];

    int u, v;
    for(int i = 0; i < m; ++i) {
        cin >> u >> v;
        u--, v--;
        if((h[u] + 1) % H == h[v])
            g[u].insert(v);
        if((h[v] + 1) % H == h[u])
            g[v].insert(u);
    }

    for(int i = 0; i < n; ++i) {
        if(g[i].size() == 0) {
            cout << 1 << "\n";
            cout << i + 1;
            return 0;
        }
    }

    vector<int> res;
    int ans = INT_MAX;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j)
            used[i] = false;

        queue<int> q;

        used[i] = 1;
        tin[i] = 0;
        q.push(i);

        while (!q.empty()) {
            int cur = q.front();
            q.pop();

            for (auto x : g[cur]) {
                if (x == i) {
                    int len = tin[cur] + 1;
                    if(len < ans) {
                        ans = len;
                        res.clear();

                        while(cur != x) {
                            res.push_back(cur);
                            cur = p[cur];
                        }
                        res.push_back(x);
                    }

                    while(q.size())
                        q.pop();
                    break;
                } else if(!used[x]) {
                    used[x] = 1;
                    tin[x] = tin[cur] + 1;
                    p[x] = cur;
                    q.push(x);
                }
            }
        }
    }

    //assert(ans != INT_MAX);

    cout << ans << "\n";
    for(int x : res)
        cout << x + 1 << " ";
}