#include <iostream>
#include <vector>

using namespace std;

int n, m, h;
vector <int> timeS;
vector <vector <int> > g;
vector <bool> used;
vector <int> ans;

const int INF = 1e9;

inline int next_d(int x) {
	return (x + 1) % h;
}

int cnt(int v) {
	used[v] = true;
	int ans = 1;
	for (auto i:g[v]) if (!used[i]) ans += cnt(i);
	return ans;
}

void get_ans(int v) {
	used[v] = true;
	ans.push_back(v);
	for (auto i:g[v]) if (!used[i]) get_ans(i);
}	

int main() {
	cin >> n >> m >> h;
	g.resize(n + 1);
	timeS.resize(n, 0);
	used.resize(n, false);
	for (int i = 0; i < n; i++) {
		cin >> timeS[i];
	}
	for (int x, y, i = 0; i < m; i++) {
		cin >> x >> y; x--; y--;
		if (next_d(timeS[x]) == timeS[y]) {
			g[x].push_back(y);
		}
		if (next_d(timeS[y]) == timeS[x]) {
			g[y].push_back(x);
		}
	}
	int best_ans = 1e9;
	int pos = -1;
	for (int i = 0; i < n; i++) {
		int cur_ans = cnt(i);
		//cout << i << ' ' << cur_ans << endl;
		if (cur_ans < best_ans) {
			best_ans = cur_ans;
			pos = i;
		}
		used.assign(n, false);
	}
	
	used.assign(n, false);
	get_ans(pos);
	cout << ans.size() << endl;
	for (auto i:ans) {
		cout << i + 1 << ' ';
	}
	return 0;
}
