#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

#pragma GCC optimize("-O3")

static int nums_pos[1000], nums_neg[1000], cur_pos[1000], cur_neg[1000];

vector <int> cur_nums_set, ans;

int mask1, mask2;

bool any_ans = false;

int need_pos, need_neg, pos, neg;

inline void cop() {
	for (int i = 0; i < 1000; i++) {
		cur_pos[i] = nums_pos[i];
		cur_neg[i] = nums_neg[i];
	}
	need_pos = pos;
	need_neg = neg;
}

inline void rem(int x) {
	if (x < 0) {
		x = x * -1;
		if (cur_neg[x] == 1) {
			need_neg--;
			cur_neg[x] = 0;
		}
	} else {
		if (cur_pos[x] == 1) {
			need_pos--;
			cur_pos[x] = 0;
		}
	}
}

bool emp() {
	return ((need_pos == 0) && (need_neg == 0));
}
		



/*void make_2(int pos) {
	if (pos == 9) {
		cur_nums_set.clear();
		cur_nums = nums;
		for (int i = 0; i < 11; i++) {
			if (mask1[i]) {
				cur_nums_set.push_back((1ll << i) * (-1ll));
			}
		}
		for (int i = 0; i < 11; i++) {
			if (mask2[i]) {
				cur_nums_set.push_back((1ll << i));
			}
		}
		big_count(0, 0);
		for (auto i:cur_nums_set) {
			cout << i << ' ';
		}
		cout << endl;
		for (auto i:cur_nums) {
			cout << i << ' ';
		}
		cout << endl;
		if ((cur_nums.size() == 0) && (!any_ans || (ans.size() > cur_nums_set.size()))) {
			any_ans = true;
			ans = cur_nums_set;
		
		}
		return;
	}
	mask2[pos] = 0;
	make_2(pos + 1);
	mask2[pos] = 1;
	make_2(pos + 1);
}*/


inline void make() 
{
	for (mask1 = 0; mask1 < (int)(1ll << 8); mask1++) {
		for (mask2 = 0; mask2 < (int)(1ll << 8); mask2++) {
			cur_nums_set.clear();
			cop();
			for (int i = 0; i < 11; i++) {
				if (mask1 & (1ll << i)) {
					cur_nums_set.push_back((1ll << i) * (-1ll));
				}	
			}
			for (int i = 0; i < 11; i++) {
				if (mask2 & (1ll << i)) {
					cur_nums_set.push_back((1ll << i));
				}
			}
			int n = cur_nums_set.size();
			for (int i = 0;i < (1ll << n); i++) {
				int sum = 0;
				for (int j = 0;j < n; j++) {
					if (i & (1ll << j)) sum += cur_nums_set[j];
				}
				rem(sum);
			}
			/*cout << mask1 << ' ' << mask2 << endl;
			for (auto i:cur_nums_set) {
				cout << i << ' ';
			}
			cout << endl;*/
			if (emp() && (!any_ans || (ans.size() > cur_nums_set.size()))) {
				any_ans = true;
				ans = cur_nums_set;
		
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int x, i = 0; i < n; i++) {
		cin >> x;
		if (x < 0) {
			nums_neg[x * -1] = 1;
			neg++;
		} else {
			nums_pos[x] = 1;
			pos++;
		}
	}
	make();
	cout << ans.size() << endl;
	for (auto i:ans) {
		cout << i << ' ';
	}
	return 0;
}
