#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

#pragma GCC optimize("-O3")

static int nums_pos[1000], nums_neg[1000], cur_pos[1000], cur_neg[1000];

vector <int> cur_nums_set, ans;

int mask1, mask2;

bool any_ans = false;

int need_pos, need_neg, pos, neg;

inline void cop() {
	for (int i = 0; i < 500; i++) {
		cur_pos[i] = nums_pos[i];
		cur_neg[i] = nums_neg[i];
	}
	need_pos = pos;
	need_neg = neg;
}

inline void rem(int x) {
	if (x < 0) {
		x = x * -1;
		if (cur_neg[x] == 1) {
			need_neg--;
			cur_neg[x] = 0;
		}
	} else {
		if (cur_pos[x] == 1) {
			need_pos--;
			cur_pos[x] = 0;
		}
	}
}

bool emp() {
	return ((need_pos == 0) && (need_neg == 0));
}


void big_count(int pos, int sum) {
	rem(sum);
	//cout << sum << ' ';
	if (pos == (int)cur_nums_set.size()) return;
	big_count(pos + 1, sum);
	big_count(pos + 1, sum + cur_nums_set[pos]);
}


inline void make() 
{
	for (mask1 = 0; mask1 < (int)(1ll << 9); mask1++) {
		for (mask2 = 0; mask2 < (int)(1ll << 8); mask2++) {
			cur_nums_set.clear();
			cop();
			for (int i = 0; i < 11; i++) {
				if (mask1 & (1ll << i)) {
					cur_nums_set.push_back((1ll << i) * (-1ll));
				}	
			}
			for (int i = 0; i < 11; i++) {
				if (mask2 & (1ll << i)) {
					cur_nums_set.push_back((1ll << i));
				}
			}
			big_count(0, 0);
			if (emp() && (!any_ans || (ans.size() > cur_nums_set.size()))) {
				any_ans = true;
				ans = cur_nums_set;
		
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int x, i = 0; i < n; i++) {
		cin >> x;
		if (x < 0) {
			nums_neg[x * -1] = 1;
			neg++;
		} else {
			nums_pos[x] = 1;
			pos++;
		}
	}
	make();
	cout << ans.size() << endl;
	for (auto i:ans) {
		cout << i << ' ';
	}
	return 0;
}
