#ifndef home
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unroll-all-loops")
#pragma GCC target("abm,mmx,popcnt,avx,tune=native,sse,sse2")
#endif

//#include <bits/extc++.h>
#include <ext/numeric>
#include <iomanip>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <bitset>
#include <deque>
#include <map>
#include <iostream>
#include <queue>
#include <set>
#include <string>
#include <stack>
#include <vector>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <climits>
#include <tuple>
#include <cassert>

using namespace __gnu_cxx;
using namespace std;
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define foru(i, l, r) for(auto i=l;i<r;++i)
#define forn(i, n) foru(i,0,n)
#define ford(i, r, l) for(auto i=r;i>=l;--i)
#define bcnt __builtin_popcount
using ll = long long;
using lint = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
const int inf = INT_MAX;
const ll linf = LLONG_MAX;
template<class X, class C=less<X>, class Y=__gnu_pbds::null_type> using ordered_set=
__gnu_pbds::tree<X, Y, C, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<class X, class C=greater<X>> using heap=__gnu_pbds::priority_queue<X, C>;

template<class X>
inline void mini(X &x, X y) {
    if (x > y)x = y;
}

template<class X>
inline void maxi(X &x, X y) {
    if (x < y)x = y;
}

//#define fast_memory 2e8
#ifdef fast_memory
char allmem[(size_t) fast_memory];
size_t allpos;

inline void *operator new(size_t n) {
    char *res = allmem + allpos;
    allpos += n;
    assert(allpos <= (size_t) fast_memory);
    return (void *) res;
}

inline void operator delete(void *)noexcept {}

inline void operator delete(void *, size_t)noexcept {}

#endif
int a[100002];
int t[400050];
bool fl[400050];

void build(int v, int tl, int tr) {
    if (tl == tr)t[v] = a[tl];
    else {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int get(int v, int tl, int tr, int l, int r, int k) {
//    cout << v << ' ' << tl << ' ' << tr << ' ' << k << endl;
    if (l > tr || r < tl)return -1;
    if (tl == tr) {
        if (t[v] < k)return -1;
        else return tl;
    } else {
        int tm = (tl + tr) / 2;
        if (l <= tl && r >= tr) {
            if (t[v * 2] < k)return get(v * 2 + 1, tm + 1, tr, l, r, k - t[v * 2]);
            else return get(v * 2, tl, tm, l, r, k);
        } else {
            int pos = get(v * 2, tl, tm, l, r, k);
            if (pos == -1)
                return get(v * 2 + 1, tm + 1, tr, l, r, k - t[v * 2]);
            else return pos;
        }
    }
}

void upd(int v, int tl, int tr, int l, int r) {
    if (l > tr || r < tl)return;
    if (tl >= l && tr <= r) {
        fl[v] = 1;
        t[v] = 0;
    } else {
        int tm = (tl + tr) / 2;
        upd(v * 2, tl, tm, l, r);
        upd(v * 2 + 1, tm + 1, tr, l, r);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int ind(int v, int tl, int tr, int pos) {
    if (fl[v])return 0;
    if (tl == tr)return t[v];
    int tm = (tl + tr) / 2;
    if (pos <= tm)return ind(v * 2, tl, tm, pos);
    else return ind(v * 2 + 1, tm + 1, tr, pos);
}

void dec(int v, int tl, int tr, int pos, int val) {
    if (tl == tr)t[v] -= val;
    else {
        int tm = (tl + tr) / 2;
        if (pos <= tm)dec(v * 2, tl, tm, pos, val);
        else dec(v * 2 + 1, tm + 1, tr, pos, val);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int sum(int v, int tl, int tr, int l, int r) {
    if (fl[v] || l > tr || r < tl)return 0;
    if (tl >= l && tr <= r)return t[v];
    int tm = (tl + tr) / 2;
    return sum(v * 2 + 1, tm + 1, tr, l, r) + sum(v * 2, tl, tm, l, r);
}

void solve1(int n, int d, int b) {
    int x = 0;
    forn(i, n) {
        int val = ind(1, 0, n - 1, i);
        dec(1, 0, n - 1, i, val);
        if (val < b) {
            int r = min(n - 1, i + d * (i + 1));
            int l = max(0, i - (i) * d);
            int pos = get(1, 0, n - 1, l, r, b - val);
//            cout << pos << ' ' << r << endl;
            if (pos == -1) {
                if (i < n - 1) {
                    dec(1, 0, n - 1, i, -val);
                }
                x++;
                continue;
            }
            int cur = sum(1, 0, n - 1, l, pos - 1);
            dec(1, 0, n - 1, pos, b - cur - val);
            upd(1, 0, n - 1, l, pos - 1);
        } else if (val > b) {
            if (i < n - 1) {
                dec(1, 0, n - 1, i, b - val);   
            }
        }
    }
    cout << x;
}

int main() {
#ifdef home
    assert(freopen("../input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(11) << fixed;
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    forn(i, n)cin >> a[i];
    build(1, 0, n - 1);
    if (p == 1)solve1(n, d, b);
    return 0;
}