#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 1e5, INF = 1e9;

int n, m, h, tim[maxn];
vector<int> g[maxn], g1[maxn];
vector<int> was, tps;
int curcomp;
vector<int> incomp(maxn, -1);

void dfs1(int v) {
    if(was[v]) return;
    was[v] = true;
    for(int to : g[v]) dfs1(to);
    tps.push_back(v);
}

void dfs2(int v) {
    incomp[v] = curcomp;
    for(int to : g1[v]) if(incomp[to] == -1) dfs2(to);
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    cin >> n >> m >> h;
    for(int i = 0; i < n; i++) cin >> tim[i];
    for(int i = 0; i < m; i++) {
        int u, v; cin >> u >> v; u--; v--;
        if((tim[u] + 1) % h == tim[v]) g[u].push_back(v), g1[v].push_back(u);
        if((tim[v] + 1) % h == tim[u]) g[v].push_back(u), g1[u].push_back(v);
    }
    was.assign(n, false);
    for(int u = 0; u < n; u++) if(!was[u]) dfs1(u);
    reverse(all(tps)); // ???
    for(int u : tps) if(incomp[u] == -1) {
        dfs2(u); curcomp++;
    }
    int o = curcomp;
    vector<int> szcomp(o, 0), degout(o, 0);
    set<pair<int, int>> edges;
    for(int u = 0; u < n; u++) {
        szcomp[incomp[u]]++;
        for(int v : g[u])
            if(incomp[u] != incomp[v] && edges.find({incomp[u], incomp[v]}) == edges.end()) {
                edges.insert({incomp[u], incomp[v]});
                degout[incomp[u]]++;
            }
    }
    int opt = INF, optcomp;
    for(int i = 0; i < o; i++) if(degout[i] == 0 && szcomp[i] < opt) {
        opt = szcomp[i]; optcomp = i;
    }
    cout << opt << '\n';
    for(int u = 0; u < n; u++) if(incomp[u] == optcomp) cout << u + 1 << ' ';
}
