#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 1e5, INF = 1e9;

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int p, n, d, b; cin >> p >> n >> d >> b;
    assert(p == 1);
    deque<pair<int, int>> q;
    for(int i = 0; i < n; i++) {
        int x; cin >> x; q.push_back({i, x});
    }
    int ans = 0;
    for(int i = 0; i < n; i++) {
        int x = 0;
        bool succ = false;
        for(int j = 0; j < sz(q) && x < b && abs(q[j].first - i + d - 1) / d <= i + 1; j++) {
            if(x + q[j].second < b) x += q[j].second;
            else {
                succ = true;
                x = b;
            }
        }
        if(!succ) continue;
        x = 0;
        while(x < b) {
            if(x + q.front().second < b) x += q.front().second, q.pop_front();
            else {
                q.front().second -= b - x;
                x = b;
                if(!q.front().second) q.pop_front();
            }
        }
        ans++;
    }
    cout << n - ans;
}


/*
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,tune=native")
#include <bits/stdc++.h>
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
using namespace std;
using ll = long long;
const int maxn = 1001, ad = 500, INF = 1e9, K = 20;

const int a[] = {-512, -256, -128, -64, -32, -16, -8, -4, -2, -1, 1, 2, 4, 8, 16, 32, 64, 128, 256, 512};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n; cin >> n;
    bitset<maxn> want;
    for(int i = 0; i < n; i++) {
        int x; cin >> x;
        if(!x || want[x + ad]) {
            i--; n--; continue;
        }
        want[x + ad] = 1;
    }
    if(!n) return cout << 0, 0;
    int opt = INF, optmask;
    for(int mask = 1; mask < (1 << K); mask++) {
        int zzz = __builtin_popcount(mask);
        if(zzz >= opt) continue;
        bitset<maxn> foo;
        foo[ad] = 1;
        for(int i = 0; i < K; i++) if(mask & (1 << i)) {
            if(a[i] > 0) {
                foo = foo | (foo << a[i]);
            } else {
                foo = foo | (foo >> (-a[i]));
            }
        }
        if((foo & want).count() == n) opt = zzz, optmask = mask;
    }
    cout << opt << '\n';
    for(int i = 0; i < K; i++) if(optmask & (1 << i)) cout << a[i] << ' ';
}
*/
