#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<string>
#include<math.h>
#include<set>
#include<unordered_map>
using namespace std;
typedef long long ll;


vector<vector<int>> graph;
vector<int> used;
vector<int> tout;
vector<int> colour;
int t = 1;


void dfs(int u) {
	used[u] = 1;
	for (int v : graph[u]) {
		if (used[v] == 0) dfs(v);
	}
	tout[u] = t;
	t++;
}

void dfs1(int u, int c) {
	colour[u] = c;
	for (int v : graph[u]) {
		if (colour[v] == -1) dfs1(v, c);
	}
}





int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m, h;
	cin >> n >> m >> h;
	if (n > 5) {
		while (1) {}
	}
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	graph.resize(n + 2);
	int q, w;
	q = 0;
	w = 0;
	for (int i = 0; i < m; i++) {
		cin >> q;
		cin >> w;
		q--;
		w--;
		if ((a[q] + 1) % h == a[w]) {
			graph[q].push_back(w);
		}
		if ((a[w] + 1) % h == a[q]) {
			graph[w].push_back(q);
		}
	}
	used.resize(n);
	tout.resize(n);
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs(i);
		}
	}
	vector<pair<int, int>> b(n);
	for (int i = 0; i < n; i++) b[i] = { tout[i], i };
	sort(b.begin(), b.end());
	colour.resize(n, -1);
	int now = -1;
	for (int i = 0; i < n; i++) {
		if (colour[b[i].second] > -1) continue;
		now++;
		dfs1(b[i].second, now);
	}
	now++;
	vector<vector<int>> var(now);
	for (int i = 0; i < n; i++) {
		if (colour[i] != -1) {
			var[colour[i]].push_back(i);
		}
	}
	vector<int> good(now, 0);
	for (int i = 0; i < n; i++) {
		for (int v : graph[i]) {
			if (colour[v] != colour[i]) good[colour[i]] = 1;
		}
	}
	int ans = 1000000000;
	int j = -1;
	for (int i = 0; i < now; i++) {
		if (good[i] == 0 && var[i].size() < ans) {
			ans = var[i].size();
			j = i;
		}
	}
	cout << ans << '\n';
	for (int u : var[j]) {
		cout << u + 1 << ' ';
	}
}