#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<string>
#include<math.h>
#include<set>
#include<unordered_map>
using namespace std;
typedef long long ll;

struct node {
	node* left;
	node* right;
	ll l, r, sum, add;
};

node* Empty = new node{ NULL, NULL, 0, 0, 0, 0 };

void update(node* v) {
	v->sum = v->left->sum + v->right->sum;
}



node* build(int l, int r, vector<ll> & a) {
	if (l + 1 == r) return new node{ Empty, Empty, l, r, a[l], 0 };
	int m = (l + r) / 2;
	node* left = build(l, m, a);
	node* right = build(m, r, a);
	return new node{ left, right, l, r, left->sum + right->sum, 0 };
}


void nu(node* v, int l, int r) {
	if (v->l >= l && v->r <= r) v->sum = 0;
	if (v->l >= r || v->r <= l) return;
	nu(v->left, l, r);
	nu(v->right, l, r);
	update(v);
}


pair<int, ll> wh(node* v, ll a) {
	if (v->l + 1 == v->r) return { v->l, a };
	if (v->left->sum >= a) return wh(v->left, a);
	else return wh(v->right, a - v->left->sum);
}


pair<int, int> wh1(node* v, ll a) {
	if (v->l + 1 == v->r) return { v->l, a };
	if (v->right->sum >= a) return wh(v->right, a);
	else return wh(v->left, a - v->right->sum);
}

void ch(node* v, int i, ll y, int M) {
	//if (M == 0) cout << i << ' ' << y << ' ' << v->l << ' ' << v->r << '\n';
	if (v->l == v->r - 1) { v->sum -= y; return; }
	if (i < (v->l + v->r) / 2) ch(v->left, i, y, M);
	else ch(v->right, i, y, M);
	update(v);
}






int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll> pref(n);
	pref[0] = a[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + a[i];
	}
	if (p == 1) {
		ll now = 0;
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			if (pref[min(n - 1, (i + 1) * d + i)] - now >= b) {
				now += b;
			}
			else {
				ans++;
			}
		}
		cout << ans << '\n';
	}
	else {
		int L = -1;
		int R = n;
		while (L + 1 < R) {
			int M = (L + R) / 2;
			int i = 0;
			int j = n - 1;
			int y = 1;
			//cout << M << '\n';
			node* root = build(0, n, a);
			i = M;
			j = n - 1 - M;
			if (i > j) {
				R = M;
				continue;
			}
			bool f = true;
			/*if (M == 2) {
				cout << i << ' ' << j << '\n';
			}*/
			//cout << M << ' ' << i << ' ' << j << '\n';
			while (i < j || (i == j && y == 1)) {
				/*if (M == 0) {
					cout << y << ' ' << i << ' ' << j << '\n';
				}*/
				if (y == 1) {
					pair<int, ll> q = wh(root, b);
					//if (M == 0) { cout << q.first << ' ' << q.second << '\n'; }
					if (q.first > (i + 1) * d + i) {
					    f = false;
					    break;
                    }
					nu(root, 0, q.first);
					ch(root, q.first, q.second, M);
					//cout << root->sum << '\n';
					i++;
				}
				else {
					pair<int, ll> q = wh1(root, b);
					if (q.first < j - i * d) {
						f = false;
						break;
					}
					nu(root, q.first + 1, n);
					ch(root, q.first, q.second, M);
					j--;
				}
				y *= -1;
			}
			if (f) R = M;
			else L = M;
		}
		cout << R << '\n';
	}
	/*int n;
	cin >> n;
	int a1, a;
	cin >> a1;
	if (a1 == 7) {
		cout << 2 << '\n';
		cout << 8 << ' ' << -1 << '\n';
		return 0;
	}
	if (a1 == -7) {
		cout << 2 << '\n';
		cout << -8 << ' ' << 1 << '\n';
		return 0;
	}
	a = abs(a1);
	vector<int> ans;
	int t = 1;
	for (int i = 0; i < 4; i++) {
		if (a % 2 == 1) ans.push_back(t);
		a /= 2;
		t *= 2;
	}
	cout << ans.size() << '\n';
	if (a1 > 0) {
		for (int u : ans) cout << u << ' ';
	}
	else {
		for (int u : ans) cout << -u << ' ';
	}*/
	/*vector<int> a(n);
	if (a == 0) {
		cout << 0 << '\n';
	}*/
	/*for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll si = 25;
	ll ans = 0;
	for (ll i = 0; i < (1 << 20); i++) {
		bool f = 1;
		for (int j = 0; j < 10; j++) {
			if ((((i >> j) | 0) == ((i >> (j + 10)) | 0)) && (((i >> (j + 10)) | 0 == 1))) {
				f = 0;
				break;
			}
		}
		if (!f) break;
		for (int j = 0; j < n; j++) {
			for (int g = 0; g < 20; g++) {

			}
		}
	}*/
}