#include <bits/stdc++.h>

using namespace std;

#define llg long long

const int MAXN = 2 * 1e5 + 7;
const int inf = 1e9 + 7;
const string abc = "abcdefghijklmnopqrstuvwxyz";
const string ABC = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
const string NUM = "0123456789";
ifstream in("input.txt");
ofstream out("output.txt");
vector < int > g[MAXN];
int tim[MAXN];
bool used[MAXN];
vector < int > sorted;

void dfs(int v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++) if (!used[g[v][i]]) dfs(g[v][i]);
    sorted.push_back(v);
}

void dfs2(int v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); i++) if (!used[g[v][i]]) dfs(g[v][i]);
}

main() {
    srand( time (0) );
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) cin >> tim[i];
    for (int i = 0; i < m; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        if ((tim[v1] + 1) % h == tim[v2]) g[v1].push_back(v2);
        if ((tim[v2] + 1) % h == tim[v1]) g[v2].push_back(v1);
    }
    for (int i = 0; i < n; i++) used[i] = false;
    for (int i = 0; i < n; i++) if (!used[i]) dfs(i);
    for (int i = 0; i < n; i++) used[i] = false;
    dfs2(sorted[0]);
    vector < int > ans;
    for (int i = 0; i < n; i++) if (used[i]) ans.push_back(i + 1);
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) cout << ans[i] << ' ';
    return 0;
}
