#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef long double ld;

const int base = 500;

int n , m , h;
vector < vector < int > > g;
vector < bool > f;
int t[1000];

void dfs(int v){
    f[v] = 1;
    for (int i = 0 ; i < g[v].size() ; i++){
        int to = g[v][i];
        if (f[to])
            continue;
        int ct = (t[v] + 1) % h;
        if (t[to] == ct)
            dfs(to);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> m >> h;
    g.resize(n);
    f.resize(n);
    for (int i = 0 ; i < n ; i++){
        cin >> t[i];
    }
    for (int i = 0 ; i < m ; i++){
        int x , y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    int ans = n;
    vector < bool > va(n , 1);
    for (int i = 0 ; i < n ; i++){
        f.assign(n , 0);
        dfs(i);
        int cnt = 0;
        for (int i = 0 ; i < n ; i++){
            cnt += f[i];
        }
        if (cnt < ans)
            ans = cnt , va = f;
    }
    cout << ans << endl;
    for (int i = 0 ; i < ans ; i++)
        if (va[i])
            cout << i + 1 << " ";
    return 0;
}


