#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

const int N = 1e5 + 6;

vector <int> g[N];
int a[N], tmp[N], t[N];

int get(int x, int y)
{
    return x / y + bool(x % y);
}

int p, n, d, b;

bool can(int i)
{
    int sum = a[i];
    for (int x : g[i])
    {
        sum += a[x];
    }
    if (sum < b)
    {
        return false;
    }
    for (int x : g[i])
    {
        if (a[i] >= b)
        {
            break;
        }
        int can_grab = min(b - a[i], a[x]);
        a[x] -= can_grab;
        a[i] += can_grab;
    }
    a[i] -= b;
    return true;
}


int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> p >> n >> d >> b;
    if (p == 1)
    {
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            t[i] = i + 1;
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (i != j && abs(i - j) <= t[j] * d)
                {
                    g[j].push_back(i);
                }
            }
        }
        for (int i = 0; i < n; i++)
        {
            tmp[i] = a[i];
        }
        int ans = 0;
        int l = -1, r = n;
        while (l < r - 1)
        {
            for (int i = 0; i < n; i++)
            {
                a[i] = tmp[i];
            }
            int m = (l + r) / 2;
            bool bad = false;
            for (int i = m; i < n; i++)
            {
                int have = a[i];
                for (int x : g[i])
                {
                    have += a[x];
                }
                if (have < b)
                {
                    bad = true;
                    break;
                }
                for (int x : g[i])
                {
                    if (a[i] >= b)
                    {
                        break;
                    }
                    int need = min(b - a[i], a[x]);
                    a[i] += need;
                    a[x] -= need;
                }
                a[i] -= b;
            }
            if (!bad)
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        cout << r << '\n';
    }
    else
    {
        assert(0);
    }
}
