#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

const int N = 1e5 + 6;

vector <int> g[N];
int a[N], tmp[N], t[N];
int vl[N], vr[N];

int get(int x, int y)
{
    return x / y + bool(x % y);
}

int p, n, d, b;

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> p >> n >> d >> b;
    if (p == 1)
    {
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            t[i] = i + 1;
        }
        for (int i = 0; i < n; i++)
        {
            vl[i] = max((ll) 0, i - t[i] * (ll) d);
            vr[i] = min((ll) n - 1, i + t[i] * (ll) d);
        }
        for (int i = 0; i < n; i++)
        {
            tmp[i] = a[i];
        }
        int ans = 0;
        int l = -1, r = n;
        while (l < r - 1)
        {
            set <int> s;
            for (int i = 0; i < n; i++)
            {
                a[i] = tmp[i];
                if (a[i] != 0)
                    s.insert(i);
            }
            int m = (l + r) / 2;
            bool bad = false;
            for (int i = m; i < n; i++)
            {
                s.erase(i);
                while (true)
                {
                    if (a[i] >= b)
                    {
                        break;
                    }
                    auto it = s.lower_bound(vl[i]);
                    if (it == s.end() || *it > vr[i])
                    {
                        break;
                    }
                    int x = *it;
                    if (a[i] + a[x] <= b)
                    {
                        s.erase(x);
                        a[i] += a[x];
                        a[x] = 0;
                    }
                    else
                    {
                        a[x] -= b - a[i];
                        a[i] = b;
                        break;
                    }
                }
                a[i] -= b;
                if (a[i] < 0)
                {
                    bad = true;
                    break;
                }
                if (a[i] != 0)
                {
                    s.insert(i);
                }
            }
            if (!bad)
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        cout << r << '\n';
    }
    else
    {
         for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            t[i] = min(i + 1, n - i);
        }
        for (int i = 0; i < n; i++)
        {
            vl[i] = max((ll) 0, i - t[i] * (ll) d);
            vr[i] = min((ll) n - 1, i + t[i] * (ll) d);
        }
        for (int i = 0; i < n; i++)
        {
            tmp[i] = a[i];
        }
        int l = -1, r = n;
        while (l < r - 1)
        {
            vector <pair <int, int> > e;
            int m = (l + r) / 2;
            if (n % 2 == 0)
            {
                int cur = 0;
                for (int i = n - 1; i >= n / 2; i--)
                {
                    cur++;
                    if (cur > m)
                        e.push_back({i, 1});
                }
                cur = 0;
                for (int i = 0; i < n / 2; i++)
                {
                    cur++;
                    if (cur > m) e.push_back({i, 0});
                }
            }
            else
            {
                int cur = 0;
                for (int i = n - 1; i > n / 2; i--)
                {
                    cur++;
                    if (cur > m)
                        e.push_back({i, 1});
                }
                cur = 0;
                for (int i = 0; i <= n / 2; i++)
                {
                    cur++;
                    if (cur > m) e.push_back({i, 0});
                }
            }
            sort(e.begin(), e.end(), [] (pair <int, int> a, pair <int, int> b)
            {
                return t[a.first] < t[b.first];
            });
            set <int> s;
            for (int i = 0; i < n; i++)
            {
                a[i] = tmp[i];
                if (a[i] != 0)
                    s.insert(i);
            }
            bool bad = false;
            for (auto c : e)
            {
                int i = c.first, who = c.second;
                s.erase(i);
                while (true)
                {
                    if (a[i] >= b)
                    {
                        break;
                    }
                    if (who == 0)
                    {
                        auto it = s.lower_bound(vl[i]);
                        if (it == s.end() || *it > vr[i])
                        {
                            break;
                        }
                        int x = *it;
                        if (a[i] + a[x] <= b)
                        {
                            s.erase(x);
                            a[i] += a[x];
                            a[x] = 0;
                        }
                        else
                        {
                            a[x] -= b - a[i];
                            a[i] = b;
                            break;
                        }
                    }
                    else
                    {
                        auto it = s.upper_bound(vr[i]);
                        if (it == s.begin() || *prev(it) < vl[i])
                        {
                            break;
                        }
                        int x = *prev(it);
                        if (a[i] + a[x] <= b)
                        {
                            s.erase(x);
                            a[i] += a[x];
                            a[x] = 0;
                        }
                        else
                        {
                            a[x] -= b - a[i];
                            a[i] = b;
                            break;
                        }
                    }
                }
                a[i] -= b;
                if (a[i] < 0)
                {
                    bad = true;
                    break;
                }
                if (a[i] != 0)
                {
                    s.insert(i);
                }
            }
            if (!bad)
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        cout << r << '\n';
    }
}
