#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int N = 2000 + 7;
const int ADD = 1000;

bitset <N> dp;

bool check(const vector <int> &need, const vector <int> &arr)
{
    dp.reset();
    dp[ADD] = 1;
    for (int x : arr)
    {
        if (x < 0)
        {
            dp |= dp >> (-x);
        }
        else
        {
            dp |= dp << x;
        }
    }
    for (int x : need)
    {
        if (!dp[x + ADD])
        {
            return false;
        }
    }
    return true;
}

int ans;

vector <int> cur;
vector <int> need;

int MX = 0;

int nxt(int x)
{
    if (x < 0)
    {
        x /= 2;
    }
    else
    {
        x *= 2;
    }
    if (x == 0) x = 1;
    return x;
}

int here[3000000];

const int KEK = 1e6;

void brute(int last, int i)
{
    if (i == ans)
    {
        if (check(need, cur))
        {
            cout << ans << '\n';
            for (int x : cur) cout << x << ' ';
            cout << '\n';
            exit(0);
        }
    }
    else
    {
        while (last < MX)
        {
            here[last + KEK]++;
            cur.push_back(last);
            if (!here[-last + KEK]) brute(nxt(last), i + 1);
            cur.pop_back();
            here[last + KEK]--;
            last = nxt(last);
        }
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        need.push_back(x);
        MX = max(MX, abs(x * 2));
    }
    while (MX & (MX - 1)) MX++;
    for (ans = 0; ; ans++)
    {
        brute(-(MX / 2), 0);
    }
}
