#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const int N = 6e3 + 1;
const int ADD = 3e3;

bitset <N> dp;

int ans;

vector <int> cur;
vector <int> need;

int MX = 0;

int nxt(int x)
{
    if (x < 0)
    {
        x /= 2;
    }
    else
    {
        x *= 2;
    }
    if (x == 0) x = 1;
    return x;
}

const int KIK = 3e6;
const int KEK = 1e6;

int add[KIK];

vector <int> wtf = {-2048, -512, -256, -128, -32, -16, -8, 1, 2, 4, 64, 1024, 4096};

void brute(int last, int i)
{
    if (clock() / (double) CLOCKS_PER_SEC >= 0.95)
    {
        cout << wtf.size() << '\n';
        for (int x : wtf) cout << x << ' ';
        cout << '\n';
        exit(0);
    }
    if (i == ans)
    {
        for (int x : need)
        {
            if (!dp[x + ADD])
            {
                return;
            }
        }
        cout << ans << '\n';
        for (int x : cur) cout << x << ' ';
        cout << '\n';
        exit(0);
    }
    else
    {
        while (last < MX)
        {
            bitset <N> prev = dp;
            cur.push_back(last);
            if (last < 0) dp |= dp >> (-last);
            else dp |= dp << last;
            add[last + KEK]++;
            if (abs(last) > MX / 4 || !add[-last + KEK])
                brute(nxt(last), i + 1);
            add[last + KEK]--;
            dp = prev;
            cur.pop_back();
            last = nxt(last);
        }
    }
}

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
   // freopen("a.out", "w", stdout);
#endif // ONPC
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        need.push_back(x);
        MX = max(MX, abs(x * 2));
    }
    while (MX & (MX - 1)) MX++;
    for (ans = 0; ; ans++)
    {
        dp[ADD] = 1;
        brute(-(MX / 2), 0);
    }
}
