#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

deque <int> res[N];

int main()
{
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif // ONPC
    string s;
    cin >> s;
    int n = (int) s.size();
    set <int> q;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
        {
            q.insert(i);
            res[i].push_back(i);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '1')
        {
            auto it = q.lower_bound(i);
            if (it != q.end() && it != q.begin())
            {
                auto jt = prev(it);
                int l = *jt, r = *it;
                q.erase(l);
                res[l].push_back(i);
                if (res[r].size() > res[l].size())
                {
                    while (!res[l].empty())
                    {
                        res[r].push_front(res[l].back());
                        res[l].pop_back();
                    }
                }
                else
                {
                    while (!res[r].empty())
                    {
                        res[l].push_back(res[r].front());
                        res[r].pop_front();
                    }
                    res[l].swap(res[r]);
                }
            }
            else
            {
                cout << -1 << '\n';
                return 0;
            }
        }
    }
    cout << q.size() << '\n';
    for (int i = 0; i < n; i++)
    {
        if (!res[i].empty())
        {
            cout << res[i].size() << ' ';
            for (int x : res[i]) cout << x + 1 << ' ';
            cout << '\n';
        }
    }
}
