#include <bits/stdc++.h>
#pragma GCC optimize("O3")


typedef long long ll;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<int, int>

using namespace std;

const int N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1, K = 3;


int n, m, h;
vector<int> u, top_sort, col;
vector<bool> used;
vector<vector<int>> gr, rev_gr;

void dfs_ts(int v) {
	used[v] = true;
	for (auto &to : gr[v]) {
		if (used[to])
			continue;
		dfs_ts(to);
	}
	top_sort.push_back(v);
}

void dfs(int v, vector<int> &way, int color) {
	used[v] = true;
	col[v] = color;
	way.push_back(v);
	for (auto &to : rev_gr[v]) {
		if (used[to])
			continue;
		dfs(to, way, color);
	}
}

int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);	
	cin >> n >> m >> h;
	u.resize(n);
	forn(i, n)
		cin >> u[i];
	
	int fr, to;
	gr.resize(n);
	rev_gr.resize(n);
	forn(i, m) {
		cin >> fr >> to, --fr, --to;
		if ((u[fr] + 1) % h == u[to]) {
			gr[fr].push_back(to);
			rev_gr[to].push_back(fr);
		}
		if ((u[to] + 1) % h == u[fr]) {
			gr[to].push_back(fr);
			rev_gr[fr].push_back(to);
		}
	}

/*/
	forn(i, n)
		if (gr[i].empty()) {
			cout << "1\n" << i + 1;
			return 0;
		}
//*/
	used.resize(n);
	forn(i, n)
		if (!used[i])
			dfs_ts(i);

	/*/
	forn(i, n)
		cout << top_sort[i] << " ";
	cout << endl;
	//*/
	used.clear();
	used.resize(n);
	col.resize(n);
	vector<vector<int>> ans;
	reverse(top_sort.begin(), top_sort.end());
	forn(i, n)
		if (!used[i]) {
			ans.push_back({});
			dfs(i, ans.back(), i);
		}


	vector<int> may_ind;

	forn(i, ans.size()) {
		bool ok = true;
		for (auto &v : ans[i]) {
			for (auto &to : gr[v])
				if (col[to] != col[v])
					ok = false;
			if (!ok)
				break;
		}
		if (ok)
			may_ind.push_back(i);
	}
	int ans_ind = -1;
	for (auto &i : may_ind) {
		// cout << ans_ind << "- ind\n";
		if (ans_ind == -1 || ans[i].size() < ans[ans_ind].size()) {
			ans_ind = i;
		}
	}

	cout << ans[ans_ind].size() << "\n";
	for (auto &p : ans[ans_ind])
		cout << p + 1 << " ";
	return 0;
}