#include <bits/stdc++.h>
#pragma GCC optimize("O3")


typedef long long ll;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<int, int>

using namespace std;

const int N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1, K = 8;

bool getb(int a, int ind) {
	return (a >> ind) & 1;
}

int pushb(int a, int ind) {
	return (1 << ind) | a;
}

int num(int a) {
	int ans = 0;
	forn(i, (K * 2))
		ans += getb(a, i);
	return ans;
}

void out_mask(int a) {
	forn(i, (K * 2))
		cout << getb(a, i);
	cout << "\n";
}

void out_ans(int ans_mask) {
	cout << num(ans_mask) << "\n";
	forn(i, (K * 2)) {
		if (getb(ans_mask, i))
			cout << (i % 2 == 0 ? 1 : -1) * (1 << (i / 2)) << " ";
	}
	cout << "- have\n";
}

bool ok(vector<int> &a, int mask, int L, int R) {
	/*/
	cout << "\n\n";
	out_mask(mask);
	out_ans(mask);
	cout << ":\n";
	cout << L << " " << R << " - L, R\n";
	//*/
	set<int> b;
	for (auto &p : a)
		b.insert(p);

	queue<point> q;
	map<int, bool> used;

	q.push({0, K * 2});
	b.erase(0);
	used[0] = true;
	int k_now = K;
	for(int u = 0; u < 5e2 && !q.empty() && ! b.empty(); ++u) {
		int v = q.front().x;
		int d = q.front().y;
		q.pop();
		// cout << v << "\n";

		for (int i = d - 1; i >= 0; --i) {
			int to = v + (i % 2 == 0 ? 1 : -1) * (1 << (i / 2));
			if (getb(mask, i) && !used[to]) {
				// cout << to << " - to1\n";
				// cout << to << " - to\n";
				q.push({to, i});
				b.erase(to);
				used[to] = true;
			}
		}

	}
	/*/
	if (b.empty()) {
		cout << " - ok\n";
	}
	//*/
	return b.empty();
}


int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);	
	int n;
	cin >> n;
	vector<int> a(n);
	forn(i, n)
		cin >> a[i];

	sort(a.begin(), a.end());

	int max_pow = 0, pow = 0, b = a[0];
	while (b > 0) {
		++pow;
		b >>= 1;
	}
	max_pow = pow;
	pow = 0, b = a.back();
	while (b > 0) {
		++pow;
		b >>= 1;
	}
	max_pow = max(max_pow, pow);

	int L = -(1 << max_pow);
	int R = (1 << max_pow);


	int ans_mask = (1 << (K * 2)) - 1;

	forn(mask, (1 << (K * 2))) {
		if (num(ans_mask) > num(mask) && ok(a, mask, L, R)) {
			ans_mask = mask;
		}
	}


	cout << num(ans_mask) << "\n";
	forn(i, (K * 2)) {
		if (getb(ans_mask, i))
			cout << (i % 2 == 0 ? 1 : -1) * (1 << (i / 2)) << " ";
	}

	return 0;
} 