#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <stack>
#include <deque>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

//---------------------------------------------------------------------
using namespace std;
typedef long long ll;
#define read(v) {for(int i_ = 0; i_ < v.size(); i_++){cin >> v[i_];}}
#define prv(v) {for(auto i_ : v){cout << i_ << " ";}cout<<"\n";}
#define prmat(v) {for(auto i_ : v){prv(i_);}}
//---------------------------------------------------------------------
vector<unordered_set<int>> g;
vector<int> answ;
int used[300000], update[300000];
int n, m, h;
vector<int> now;
int minn = 1e9;
void dfs(int v, int col) {
	used[v] = col;
	now.push_back(v + 1);
	for (auto to : g[v]) {
		if (used[to] != col) {
			dfs(to, col);
		}
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> h;
	g.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> update[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		if ((update[a] + 1) % h == update[b]) {
			g[a].insert(b);
		}
		if ((update[b] + 1) % h == update[a]) {
			g[b].insert(a);
		}
	}
	for (int i = 0; i < n; i++) {
		now.clear();
		dfs(i, i + 1);
		if (now.size() < minn) {
			minn = now.size();
			answ = now;
		}
	}
	cout << answ.size() << "\n";
	prv(answ);
}
/*
3 3 5
4 4 0
1 3
3 2
3 1
*/