#include <bits/stdc++.h>

std::vector <int> getUse( int code ) {
	std::vector <int> res;
	for ( int shift = 0; shift < 12; ++shift ) {
		if ( ( ( code >> shift ) & 1 ) == 1 ) {
			res.push_back( shift );
		}
	}
	return res;
}

void check( const std::vector <int>& use, const std::vector <std::pair <int, int>>& a, std::vector <int> Time, int& res, int h, int code ) {
	for ( int val : use ) {
		++Time[val];
		if ( Time[val] == h ) {
			Time[val] = 0;
		}
	}
	for ( const auto& p : a ) {
		if ( Time[p.first - 1] == Time[p.second - 1] ) {
			return;
		}
	}
	res = std::min( res, code );
}

int main() {
	int n, nCl, h;
	scanf( "%d%d%d", &n, &nCl, &h );
	std::vector <int> Time( n );
	for ( int i = 0; i < n; ++i ) {
		scanf( "%d", &Time[i] );
	}
	std::vector <std::pair <int, int>> a( nCl );
	for ( int i = 0; i < nCl; ++i ) {
		scanf( "%d%d", &a[i].first, &a[i].second );
	}
	int res = 100;
	for ( int code = 1; code < ( 1 << n ); ++code ) {
		std::vector <int> use = getUse( code );
		check( use, a, Time, res, h, code );
	}
	std::vector <int> ans( getUse( res ) );
	printf( "%d\n", (int)ans.size() );
	for ( int val : ans ) {
		printf( "%d ", val + 1 );
	}
	return 0;
}