#include <bits/stdc++.h>

int main() {
	int n, nCl, h;
	scanf( "%d%d%d", &n, &nCl, &h );
	std::vector <int> Time( n );
	for ( int i = 0; i < n; ++i ) {
		scanf( "%d", &Time[i] );
	}
	std::vector <std::pair <int, int>> a( nCl );
	for ( int i = 0; i < nCl; ++i ) {
		scanf( "%d%d", &a[i].first, &a[i].second );
		--a[i].first;
		--a[i].second;
	}
	std::vector <std::vector <int>> edges( n );
	for ( const auto& p : a ) {
		if ( ( p.first + 1 ) % h == p.second ) {
			edges[p.first].push_back( p.second );
		} else if ( ( p.second + 1 ) % h == p.first ) {
			edges[p.second].push_back( p.first );
		}
	}
	std::vector <bool> used;
	std::function <void(int)> Find = [&]( int from ) {
		assert( !used[from] );
		used[from] = true;
		for ( int to : edges[from] ) {
			if ( !used[to] ) {
				Find( to );
			}
		}
	};
	int start = 0, nS = 1000000;
	for ( int i = 0; i < n; ++i ) {
		used.assign( n, false );
		Find( i );
		int curS = 0;
		for ( int val : used ) {
			curS += val;
		}
		if ( curS <= nS ) {
			start = i;
			nS = curS;
		}
	}
	used.assign( n, false );
	Find( start );
	printf( "%d\n", nS );
	for ( int i = 0; i < n; ++i ) {
		if ( used[i] ) {
			printf( "%d ", i + 1 );
		}
	}
	return 0;
}