#include <stdio.h>
#include <bits/stdc++.h>

struct Char {
	char c;
	int index;
};

bool operator < ( const Char& first, const Char& second ) {
	return first.c < second.c;
}

int main() {
	char buffer[200000 + 1];
	scanf( "%200000s", buffer );
	std::string s( buffer );
	std::vector <Char> a( s.size() );
	int n0 = 0;
	for ( int i = 0; i < (int)s.size(); ++i ) {
		a[i].c = s[i];
		a[i].index = i;
		n0 += ( s[i] == '0' );
	}
	std::sort( a.begin(), a.end() );
	std::vector <std::vector <int>> res;
	int size = (int)s.size();
	if ( n0 < ( size - n0 ) * 2 ) {
		printf( "-1" );
		return 0;
	}
	int i0 = 0, i1 = n0;
	while ( true ) {
		if ( i1 == size ) break;
		res.push_back( { a[i0].index, a[i1].index, a[i0 + 1].index } );
		i0 += 2;
		++i1;
	}
	while ( i0 < n0 ) {
		res.push_back( { a[i0].index } );
		++i0;
	}
	printf( "%d\n", (int)res.size() );
	for ( const auto& vec : res ) {
		printf( "%d ", (int)vec.size() );
		for ( int val : vec ) {
			printf( "%d ", val + 1 );
		}
		printf( "\n" );
	}
	return 0;
}