#include <stdio.h>
#include <bits/stdc++.h>

int main() {
	char buffer[200000 + 1];
	scanf( "%200000s", buffer );
	std::string s( buffer );
	if ( s[0] == '1' || s.back() == '1' ) {
		printf( "-1" );
		return 0;
	}
	std::vector <int> next0( s.size(), (int)s.size() - 1 );
	for ( int i = (int)s.size() - 2; i >= 0; --i ) {
		if ( s[i + 1] == '0' ) {
			next0[i] = i + 1;
		} else {
			next0[i] = next0[i + 1];
		}
	}
	std::vector <std::vector <int>> res;
	std::vector <bool> used( s.size(), false );
	int left = 0, right = 0, Count1 = 0;
	for ( char c : s ) {
		Count1 += ( c == '1' );
	}
	for ( int i = 1; i < (int)s.size() - 1; ++i ) {
		if ( s[i] != '1' ) continue;
		if ( left > i ) {
			printf( "-1" );
			return 0;
		}
		while ( right < i || ( used[right] && right < (int)s.size() - 1 ) ) {
			right = next0[right];
		}
		if ( used[right] ) {
			printf( "-1" );
			return 0;
		}
		assert( i < right && right < (int)s.size() );
		res.push_back( { left, i, right } );
		--Count1;
		used[left] = used[i] = used[right] = true;
		while ( used[left] && left < (int)s.size() - 1 ) {
			left = next0[left];
		}
		if ( used[left] && Count1 > 0 ) {
			printf( "-1" );
			return 0;
		}
	}
	while ( left < (int)s.size() - 1 ) {
		if ( !used[left] ) {
			res.push_back( { left } );
		}
		left = next0[left];
	}
	assert( left == (int)s.size() - 1 );
	if ( !used[left] ) {
		res.push_back( { left } );
	}
	printf( "%d\n", (int)res.size() );
	for ( const auto& vec : res ) {
		printf( "%d ", (int)vec.size() );
		for ( int val : vec ) {
			printf( "%d ", val + 1 );
		}
		printf( "\n" );
	}
	return 0;
}