#include <stdio.h>
#include <bits/stdc++.h>

int main() {
	char buffer[200000 + 1];
	scanf( "%200000s", buffer );
	std::string str( buffer );
	int size = (int)str.size();
	int sizeI = (int)std::sqrt( size - 1 ) + 1, sizeJ = ( size + sizeI - 1 ) / sizeI;
	std::vector <std::string> s( sizeI );
	for ( int i = 0; i < size; ++i ) {
		s[i / sizeJ].push_back( str[i] );
	}
	std::vector <int> first0( sizeI, -1 ), first1( sizeI, -1 );
	for ( int i = 0; i < sizeI; ++i ) {
		for ( int j = 0; j < (int)s[i].size(); ++j ) {
			if ( s[i][j] == '0' ) {
				first0[i] = j;
				break;
			}
		}
		for ( int j = 0; j < (int)s[i].size(); ++j ) {
			if ( s[i][j] == '1' ) {
				first1[i] = j;
				break;
			}
		}
	}
	std::vector <std::vector <int>> res;
	std::vector <bool> used( size, false );
	std::function <void(int)> setFirst0 = [&]( int i ) {
		if ( first0[i] == -1 ) return;
		s[i][first0[i]] = '-';
		used[i * sizeJ + first0[i]] = true;
		for ( int j = 0; j < (int)s[i].size(); ++j ) {
			if ( s[i][j] == '0' && !used[i * sizeJ + j] ) {
				first0[i] = j;
				return;
			}
		}
		first0[i] = -1;
	};
	std::function <void(int)> setFirst1 = [&]( int i ) {
		if ( first1[i] == -1 ) return;
		s[i][first1[i]] = '-';
		used[i * sizeJ + first1[i]] = true;
		for ( int j = 0; j < (int)s[i].size(); ++j ) {
			if ( s[i][j] == '1' && !used[i * sizeJ + j] ) {
				first1[i] = j;
				return;
			}
		}
		first1[i] = -1;
	};
	std::function <int(int)> findNext0 = [&]( int i ) {
		int bl = i / sizeJ;
		for ( int j = i % sizeJ; j < (int)s[bl].size(); ++j ) {
			if ( s[bl][j] == '0' ) {
				used[bl * sizeJ + j] = true;
				s[bl][j] = '-';
				setFirst0( bl );
				return bl * sizeJ + j;
			}
		}
		for ( int i = bl + 1; i < sizeI; ++i ) {
			if ( first0[i] != -1 ) {
				int resJ = first0[i];
				setFirst0( i );
				return i * sizeJ + resJ;
			}
		}
		return size;
	};
	std::function <int(int)> findNext1 = [&]( int i ) {
		int bl = i / sizeJ;
		for ( int j = i % sizeJ; j < (int)s[bl].size(); ++j ) {
			if ( s[bl][j] == '1' ) {
				used[bl * sizeJ + j] = true;
				s[bl][j] = '-';
				setFirst1( bl );
				return bl * sizeJ + j;
			}
		}
		for ( int i = bl + 1; i < sizeI; ++i ) {
			if ( first1[i] != -1 ) {
				int resJ = first1[i];
				setFirst1( i );
				return i * sizeJ + resJ;
			}
		}
		return size;
	};
	while ( true ) {
		std::vector <int> cur;
		int i = -1;
		bool is1 = false, found = false;
		while ( true ) {
			if ( is1 ) {
				i = findNext1( i + 1 );
			} else {
				i = findNext0( i + 1 );
			}
			if ( i == size ) {
				if ( !is1 && (int)cur.size() > 0 ) {
					return 0;
				}
				found = true;
				break;
			}
			cur.push_back( i );
			is1 = !is1;
		}
		if ( !found || cur.empty() ) break;
		res.push_back( cur );
	}
	for ( int i = 0; i < size; ++i ) {
		if ( !used[i] ) {
			assert( str[i] == '0' );
			res.push_back( { i } );
		}
	}
	printf( "%d\n", (int)res.size() );
	for ( const auto& vec : res ) {
		printf( "%d ", (int)vec.size() );
		for ( int val : vec ) {
			printf( "%d ", val + 1 );
		}
		printf( "\n" );
	}
	return 0;
}