#include<bits/stdc++.h>
#define ll long long
#define dbl long double

using namespace std;
const int MAXN = 1e5 + 10;
int n, m, h;
vector<int> g[MAXN];
vector<int> rg[MAXN];
vector<int> used;
vector<int> tops;
vector<int> tsp[MAXN];
int p[MAXN];

void topsort(int u) {
    used[u] = -1;
    tops.push_back(u);
    for(auto to : g[u]) {
        if(!used[to]){
            topsort(to);
        }
    }
}
void dfs(int u, int col) {
    used[u] = col;
    tsp[col].push_back(u);
    for(auto to : rg[u]) {
        if(used[to] == -1) {
            dfs(to, col);
        }
    }
}
void resdfs(int u) {
    used[u] = 1;
    cout << u + 1 << " ";
    for(auto i : g[u]) {
        if(!used[i]) {
            resdfs(i);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d%d%d", &n, &m, &h);\
    vector<int> ts(n);
    for(int i = 0; i < n; ++i) {
        scanf("%d", &ts[i]);
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        scanf("%d%d", &u, &v);
        u--; v--;
        if((ts[u] + 1) % h == ts[v]) {
            g[u].push_back(v);
            rg[v].push_back(u);
        }
        if((ts[v] + 1) % h == ts[u]) {
            g[v].push_back(u);
            rg[u].push_back(v);
        }
    }

    ///topsort
    used.assign(n, 0);
    int col = 1;
    for(int i = 0; i < n; ++i) {
        if (!used[i]) {
            tops.clear();
            topsort(i);
            for(auto i : tops) {
                if (used[i] == -1) {
                    dfs(i, col);
                    col++;
                }
            }
        }
    }
    ///endsort

    //vector<int> mt[MAXN] = tsp;
    ///endcol
    for(int i = 1; i < col; ++i) {
        vector<int> use(col, 0);
        p[i] += tsp[i].size();
        use[i] = 1;
        for(auto u : tsp[i]) {
            for(auto to : g[u]) {
                if(!use[to]) {
                    p[i] += tsp[to].size();
                    use[to] = 1;
                }
            }
        }
    }
    int m = 1;
    for(int i = 1; i < col; ++i) {
        if(p[i] < p[m]) {
            m = i;
        }
    }
    //res
    used.assign(n, 0);
    cout << p[m] << "\n";
    resdfs(tsp[m].back());
}