#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimaze("Ofast");
//#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back

const int INF = 1e18;
const int MAXN = 1e6;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

int n, m, h;

vector<vector<int>> g;
vector<int> a;
set<int> ans;
vector<int> used;

void dfs(int v) {
    ans.insert(v);
    used[v] = 1;
    int T = (a[v] + 1) % h;
    used[v] = T + 1;
    for (auto u: g[v]) {
        if (!used[u] && a[u] == T) {
            dfs(u);
        }
        if (T + 1 == used[u]) {
            throw new exception;
        }
    }
}

void dfs_check(int v) {
    used[v] = 1;
    for (auto x: g[v]) {
        if (a[x] == a[v]) {
            throw new exception;
            exit(1);
        }
        if (!used[x]) dfs_check(x);
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
//-------------------------------------------------------------
    cin >> n >> m >> h;
    a.resize(n); g.resize(n); used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    int k = INF;
    set<int> b;
    for (int i = 0; i < n; i++) {
        ans.clear();
        fill(all(used), 0);
        dfs(i);
        if (ans.size() <= k) {
            k = ans.size();
            b = ans;
        }
    }
    fill(all(used), 0);
    for (auto x: ans) a[x] = (a[x] + 1) % h;
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs_check(i);
    }
    cout << ans.size() << "\n";
    for (auto x: ans) cout << x + 1 << " ";
    cout << "\n";

}