#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimaze("Ofast");
//#pragma target("sse3,sse4");

#define int long long
#define ll long long
#define ld long double
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back

const int INF = 1e18;
const int MAXN = 1e6;

ll power(int a, int n, int MOD = INF) {
    if (n == 0) return 1;
    if (n & 1) {
        return (a * power(a, n - 1, MOD)) % MOD;
    } else {
        int b = power(a, n >> 1, MOD);
        return (b * b) % MOD;
    }
}

ll gcd(int a, int b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

signed main() {
    cin.tie(0);
    cout.tie(0);
//-------------------------------------------------------------
    string s;
    cin >> s;
    int n = s.size();
    vector<int> g(n);
    stack<int> arr;
    arr.push(-1);
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '0') {
            arr.push(i);
        } else {
            int cur = arr.top();
            g[i] = cur;
            if (cur != -1) arr.pop();
        }
    }
    if (count(all(g), -1) != 0) {
        cout << -1 << "\n";
        return 0;
    }
    while (!arr.empty()) arr.pop();

    for (int i = 0; i < n; i++) {
        if (s[i] == '1' && arr.empty()) {
            cout << -1 << "\n";
            return 0;
        }
        if (s[i] == '1' && !arr.empty()) {
            if (g[arr.top()] != 0) {
                while (!arr.empty() && g[arr.top()] != 0) {
                    arr.pop();
                }
            }
            if (arr.empty()) {
                cout << -1 << "\n";
                return 0;
            }
            int cur = arr.top();
            g[cur] = i;
        }
        if (s[i] == '0') {
            arr.push(i);
        }
    }
    int i = 0;
    vector<int> used(n);
    int color = 1;
    while (i < n) {
        if (used[i]) {
            i++;
            continue;
        }
        if (s[i] == '0' && g[i] == 0 && used[i] == 0) {
            used[i] = color++;
            i++;
            continue;
        }
        if (s[i] == '0' && g[i] != 0) {
            used[i] = color;
            int j = i;
            while (j < n && g[j] != 0) {
                j = g[j];
                used[j] = color;
            }
            color++;
            i++;
        }
    }
    int k = *max_element(all(used));
    cout << k << "\n";
    vector<vector<int>> ans(k + 1);
    for (int i = 0; i < n; i++) {
        ans[used[i]].pb(i + 1);
    }
    for (int i = 1; i <= k; i++) {
        cout << ans[i].size() << " ";
        for (auto x: ans[i]) cout << x << " ";
        cout << "\n";
    }
    //for (auto x: used) cout << x << " ";

}