#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

int p, n, d, b;

int solve1()
{
    vector<int> a(n);
    vector<int> kek;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        for (int j = 0; j < a[i]; j++)
            kek.push_back(i);
    }
    int ans = 0;
    int curroom = n - 1;
    int curp = 0;
    for (int i = n * b - 1; i >= 0; i--)
    {
        if (abs(kek[i] - curroom) <= d * (curroom + 1))
        {
            curp++;
            if (curp == b)
            {
                curroom--;
                curp = 0;
            }
        }
    }
    cout << curroom + 1 << endl;
    return 0;
}

int solve2()
{
    vector<int> a(n);
    vector<int> pos;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        for (int j = 0; j < a[i]; j++)
            pos.push_back(i);
    }
    int l = 0, r = pos.size() - 1;
    int goodrooms = 0;
    for (int iter = 1, i = 0, j = n - 1; i <= j && l <= r; i++, j--, iter++)
    {
        if (abs(pos[l] - i) <= iter * d)
        {
            goodrooms++;
            l++;
        }
        if (j != i && l <= r)
        {
            if (abs(pos[r] - j) <= iter * d)
            {
                goodrooms++;
                r--;
            }
        }
    }
    cout << n - goodrooms << endl;
    return 0;
}

int solve()
{
    ios::sync_with_stdio(0);
    if (!(cin >> p))
        return 1;
    cin >> n >> d >> b;
    if (p == 1)
    {
        solve1();
        return 0;
    }
    solve2();
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms";
    #endif
    return 0;
}
