#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

int solve()
{
    ios::sync_with_stdio(0);
    int n;
    if (!(cin >> n))
        return 1;
    vector<int> a(n);
    int maxa = 0;
    int maxpos = 0;
    int maxneg = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        maxa = max(maxa, abs(a[i]));
        if (a[i] > 0)
            maxpos = max(maxpos, a[i]);
        else
            maxneg = max(maxneg, -a[i]);
    }
    int st = 0;
    while ((1 << st) <= 2 * maxa)
        st++;
    st += 3;
    int B = (1 << st);
    vector<int> ans;
    for (int i = 0; i < st; i++)
    {
        ans.push_back((1 << i));
        ans.push_back(-(1 << i));
    }
    maxa = (1 << st) + 5;
    //const int maxA = 2060;
    for (int mask1 = 0; mask1 < B; mask1++)
    {
        vector<int> pos;
        for (int i = 0; i < st; i++)
                if ((mask1 & (1 << i)))
                    pos.push_back((1 << i));
        for (int mask2 = 0; mask2 < B; mask2++)
        {
            vector<int> neg;
            for (int i = 0; i < st; i++)
                if ((mask2 & (1 << i)))
                    neg.push_back((1 << i));
            bool OK = true;
            for (int i = 0; i < n; i++)
            {
                if (a[i] > 0)
                {
                    for (int j = st; j >= 0; j--)
                    {
                        if (!(a[i] & (1 << j)))
                            continue;
                        int k = j;
                        while (k >= 0 && (a[i] & (1 << k)))
                            k--;
                        k++;
                        bool ok = false;
                        if ((mask1 & (1 << j + 1)))
                        {
                            int l = k;
                            while (l <= j && !(mask2 & (1 << l)))
                                l++;
                            if (l <= j)
                            {
                                ok = true;
                                for (int bit = l + 1; bit <= k; bit++)
                                    if (!(mask1 & (1 << bit)))
                                        ok = false;
                            }
                        }
                        if (!ok)
                        {
                            ok = true;
                            for (int bit = k; bit <= j; bit++)
                                if (!(mask1 & (1 << bit)))
                                    ok = false;
                        }
                        j = k;
                        if (!ok)
                            OK = 0;
                    }
                }
                if (a[i] < 0)
                {
                    a[i] *= -1;
                    for (int j = st; j >= 0; j--)
                    {
                        if (!(a[i] & (1 << j)))
                            continue;
                        int k = j;
                        while (k >= 0 && (a[i] & (1 << k)))
                            k--;
                        k++;
                        bool ok = false;
                        if ((mask2 & (1 << j + 1)))
                        {
                            int l = k;
                            while (l <= j && !(mask1 & (1 << l)))
                                l++;
                            if (l <= j)
                            {
                                ok = true;
                                for (int bit = l + 1; bit <= k; bit++)
                                    if (!(mask2 & (1 << bit)))
                                        ok = false;
                            }
                        }
                        if (!ok)
                        {
                            ok = true;
                            for (int bit = k; bit <= j; bit++)
                                if (!(mask2 & (1 << bit)))
                                    ok = false;
                        }
                        j = k;
                        if (!ok)
                            OK = 0;
                    }
                    a[i] *= -1;
                }
            }
            if (OK && sz(ans) > sz(pos) + sz(neg))
            {
                ans = pos;
                for (int i : neg)
                    ans.push_back(-i);
            }
        }
    }
    cout << sz(ans) << endl;
    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC << " ms";
    #endif
    return 0;
}
