#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

int solve()
{
    ios::sync_with_stdio(0);
    string s;
    if (!(cin >> s))
        return 1;
    int n = s.size();
    vector<vector<int> > ans;
    vector<int> used(n);
    int curused = 0;
    while (curused < n)
    {
        vector<int> cur;
        for (int i = 0; i < n; i++)
        {
            if (!used[i] && ((sz(cur) % 2 == 1 && s[i] == '1') || (sz(cur) % 2 == 0 && s[i] == '0')))
            {
                cur.push_back(i);
                used[i] = 1;
            }
        }
        if (sz(cur) > 0 && sz(cur) % 2 == 0)
        {
            used[cur.back()] = 0;
            cur.pop_back();
        }
        if (cur.size() == 0)
        {
            cout << -1 << endl;
            return 0;
        }
        curused += sz(cur);
        ans.push_back(cur);
    }
    cout << sz(ans) << endl;
    for (auto kek : ans)
    {
        cout << kek.size() << " ";
        for (int i : kek)
            cout << i + 1 << " ";
        cout << "\n";
    }
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC;
    #endif
    return 0;
}
