#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;
typedef long double ld;

vector<int> p;

int find_set(int v)
{
    return ((v == p[v]) ? v : p[v] = find_set(p[v]));
}

int solve()
{
    ios::sync_with_stdio(0);
    string s;
    if (!(cin >> s))
        return 1;
    int n = s.size();
    vector<int> ones, zeros;
    vector<vector<int> > ans;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '1')
            ones.push_back(i);
        else
            zeros.push_back(i);
    }
    p.assign(n + 1, 0);
    for (int i = 0; i <= n; i++)
        p[i] = i;
    vector<int> used(n);
    int curused = 0;
    while (curused < n)
    {
        vector<int> cur;
       // cout << "MNEM" << endl;
        int last = -1;
        while (true)
        {
            if (sz(cur) % 2)
            {
              //  cout << "KEK" << endl;
                int l = -1, r = ones.size();
                while (r - l > 1)
                {
                    int mid = (r + l) / 2;
                    if (ones[mid] > last)
                        r = mid;
                    else
                        l = mid;
                }
                if (r >= ones.size())
                {
                    break;
                }
                r = find_set(ones[r]);
                if (r >= n)
                {
                    break;
                }
                cur.push_back(r);
            }
            else
            {
                int l = -1, r = zeros.size();
                while (r - l > 1)
                {
                    int mid = (r + l) / 2;
                    if (zeros[mid] > last)
                        r = mid;
                    else
                        l = mid;
                }
                if (r >= zeros.size())
                {
                    break;
                }
                r = find_set(zeros[r]);
                if (r >= n)
                {
                    break;
                }
                cur.push_back(r);
            }
            last = cur.back();
        }
        if (sz(cur) > 0 && sz(cur) % 2 == 0)
        {
            cur.pop_back();
        }
        if (cur.size() == 0)
        {
            cout << -1 << endl;
            return 0;
        }
        curused += sz(cur);
        for (int i : cur)
        {
            used[i] = 1;
            if (s[i] == '1')
            {
                int l = -1, r = ones.size();
                while (r - l > 1)
                {
                    int mid = (r + l) / 2;
                    if (ones[mid] > i)
                        r = mid;
                    else
                        l = mid;
                }
                if (r < ones.size())
                    p[i] = ones[r];
                else
                    p[i] = n;
            }
            else
            {
                int l = -1, r = zeros.size();
                while (r - l > 1)
                {
                    int mid = (r + l) / 2;
                    if (zeros[mid] > i)
                        r = mid;
                    else
                        l = mid;
                }
                if (r < zeros.size())
                    p[i] = zeros[r];
                else
                    p[i] = n;
            }
        }
        ans.push_back(cur);
    }
    cout << sz(ans) << endl;
    for (auto kek : ans)
    {
        cout << kek.size() << " ";
        for (int i : kek)
            cout << i + 1 << " ";
        cout << "\n";
    }
    return 0;
}

//#define KEK
int main()
{
    #ifdef KEK
        freopen("in.txt", "r", stdin);
    #endif
    for (int i = 1;; i++)
    {
        #ifdef KEK
            cerr << "Test #" << i << endl;
        #endif
        if (solve())
            break;
    }
    #ifdef KEK
        cerr << "finished in " << clock() * 1000LL / CLOCKS_PER_SEC;
    #endif
    return 0;
}
