#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>
#include <math.h>

using namespace std;

vector< vector<int> > g;
vector<int> used;
vector<int> now;
int timer = 0;
vector<int> tin, tout;
vector< vector<int> > ua;
int nowi;

void dfs(int v, int p = -1) {
    if (p == -1) {
        p = v;
    }
    ua[p].push_back(v);
    used[v] = nowi;
    timer++;
    tin[v] = timer;
    for (int i = 0; i < g[v].size(); i++) {
        if (used[g[v][i]] < nowi) {
            dfs(g[v][i], p);
        }
    }
    timer++;
    tout[v] = timer;
}

int main()
{
    ifstream fin("input.txt");
    int n, m, h;
    fin >> n >> m >> h;
    g.resize(n);
    vector<int> mn(n, 0);
    used.resize(n);
    now.resize(n);
    tin.resize(n);
    tout.resize(n);
    ua.resize(n);
    int u[n];
    for (int i = 0; i < n; i++) {
        fin >> u[i];
        now[i] = 0;
        used[i] = -1;
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        fin >> a >> b;
        a--; b--;
        if ((u[a] + 1) % h == u[b]) {
            g[a].push_back(b);
        }
        else if ((u[b] + 1) % h == u[a]) {
            g[b].push_back(a);
        }
    }/*
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            cout << i + 1 << " - " << g[i][j] + 1 << endl;
        }
    }*/
    for (int i = 0; i < n; i++) {
        nowi = i;
        dfs(i);
    }
    int mni = 0;
    for (int i = 0; i < n; i++) {
        if (ua[i].size() < ua[mni].size()) {
            mni = i;
        }
    }
    cout << ua[mni].size() << endl;
    for (int i = 0; i < ua[mni].size(); i++) {
        cout << ua[mni][i] + 1 << ' ';
    }
    /*
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (tin[j] >= tin[i] && tout[j] <= tout[i]) {
                mn[i]++;
            }
        }
    }
    int mni = 0;
    for (int i = 0; i < n; i++) {
        if (mn[i] < mn[mni]) {
            mni = i;
        }
    }
    cout << mn[mni] << endl;
    for (int j = 0; j < n; j++) {
        if (tin[j] >= tin[mni] && tout[j] <= tout[mni]) {
            cout << j + 1 << ' ';
        }
    }*/
}
