#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <fstream>
#include <math.h>

using namespace std;

const int mx = 21;

vector<int> a;
int m1[mx], m2[mx];
vector<int> p2(mx);
int p30 = 1073741824;
int n;


int ans(int t = 0)
{
    bool need = false;
    if (t == mx - 1) {
        for (int i = 0; i < n; i++) {
            if (a[i] != 0) {
                return 1000000;
            }
        }
        int s = 0;
        for (int i = 0; i < mx; i++) {
            s += m1[i] + m2[i];
        }
        return s;
    }
    for (int i = 0; i < n; i++) {
        if ((a[i] + p30) % p2[t + 1] != 0) {
            need = true;
            break;
        }
    }
    if (!need) {
        m1[t] = 0;
        m2[t] = 0;
        return ans(t + 1);
    }
    m1[t] = 1;
    m2[t] = 0;
    vector<int> ind;
    for (int i = 0; i < n; i++) {
        if ((a[i] + p30) % p2[t + 1] != 0) {
            a[i] -= p2[t];
            ind.push_back(i);
        }
    }
    int n1 = ans(t + 1);
    for (int i = 0; i < ind.size(); i++) {
        a[ind[i]] += p2[t];
    }
    m1[t] = 0;
    m2[t] = 1;
    ind.clear();
    for (int i = 0; i < n; i++) {
        if ((a[i] + p30) % p2[t + 1] != 0) {
            a[i] += p2[t];
            ind.push_back(i);
        }
    }
    int n2 = ans(t + 1);
    for (int i = 0; i < ind.size(); i++) {
        a[ind[i]] -= p2[t];
    }
    if (n1 < n2) {
        ind.clear();
        m1[t] = 1;
        m2[t] = 0;
        for (int i = 0; i < n; i++) {
            if ((a[i] + p30) % p2[t + 1] != 0) {
                a[i] -= p2[t];
                ind.push_back(i);
            }
        }
        ans(t + 1);
        for (int i = 0; i < ind.size(); i++) {
            a[ind[i]] += p2[t];
        }
    }
    return min(n1, n2);
}

int main()
{
    ifstream fin("input.txt");
    int k = 1;
    for (int i = 0; i < mx; i++) {
        p2[i] = k;
        k *= 2;
    }
    fin >> n;
    for (int i = 0; i < n; i++) {
        int t;
        fin >> t;
        if (t != 0) {
            a.push_back(t);
        }
    }
    n = a.size();
    sort(a.begin(), a.end());
    for (int i = 0; i < mx; i++) {
        m1[i] = 0;
        m2[i] = 0;
    }
    cout << ans() << endl;
    k = 1;
    for (int i = 0; i < mx; i++) {
        if (m1[i] > 0) {
            for (int j = 0; j < m1[i]; j++) {
                cout << k << ' ';
            }
        }
        if (m2[i] > 0) {
            for (int j = 0; j < m2[i]; j++) {
                cout << -k << ' ';
            }
        }
        k = k * 2;
    }
}
