#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 100000 + 100;

int a[N];
int p, n, d, b;

int t[4 * N];

void add(int v, int tl, int tr, int pos, int x)
{
	if (tl + 1 == tr)
	{
		t[v] += x;
	}
	else
	{
		int c = (tl + tr) / 2;
		if (pos < c)
		{
			add(2 * v, tl, c, pos, x);
		}
		else
		{
			add(2 * v + 1, c, tr, pos, x);
		}
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}

inline void add(int pos, int x)
{
	add(1, 0, n, pos, x);
}

int get(int v, int tl, int tr, int l, int r)
{
	if (l >= tr || r <= tl)
	{
		return 0;
	}
	if (tl >= l && tr <= r)
	{
		return t[v];
	}
	int c = (tl + tr) / 2;
	return get(2 * v, tl, c, l, r) + get(2 * v + 1, c, tr, l, r);
}

inline int get(int l, int r)
{
	return get(1, 0, n, l, r);
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> p >> n >> d >> b;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		add(i, a[i]);
	}

	int bad = 0;
	int ptr = 1;

	for (int i = 0; i < n; i++)
	{
		int l = i;
		int r = min(n - 1, i + d * (i + 1)) + 1;
		if (get(l, r) < b)
		{
			++bad;
		}
		else
		{
			int cur = get(l, l + 1);
			int delta = b - cur;
			if (ptr < i + 1)
			{
				ptr = i + 1;
			}
			while (delta > 0)
			{
				int kek = get(ptr, ptr + 1);
				int lol = min(delta, kek);
				delta -= lol;
				add(ptr, -lol);
				if (kek == 0)
				{
					++ptr;
				}
			}
			if (cur > b)
			{
				add(i + 1, cur - b);
			}
		}
	}

	cout << bad;


#ifdef _DEBUG
	while (1);
#endif
}