#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;


signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;
	int n = s.length();

	int cur = 0, cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			++cur;
		}
		else
		{
			--cur;
			++cnt;
		}
		if (cur < 0)
		{
			cout << -1;
			return 0;
		}
	}

	vector<vector<int>> ans;
	
	vector < pair<int, vector<int>>> blocks;
	vector<bool> used(n, false);
	blocks.push_back({ (int)(s[0] - '0'), {1} });

	for (int i = 1; i < s.size(); i++)
	{
		if ((int)(s[i] - '0') == blocks.back().first)
		{
			blocks[(int)blocks.size() - 1].second.push_back(i + 1);
		}
		else
		{
			blocks.push_back({ (int)(s[i] - '0'), {i + 1} });
		}
	}

	while (cnt)
	{
		int want = 0;
		vector<int> cur;
		for (auto &it : blocks)
		{
			if (it.first == want && it.second.size())
			{
				used[it.second.back() - 1] = true;
				cur.push_back(it.second.back());
				it.second.pop_back();
				if (want == 1)
				{
					--cnt;
				}
				want ^= 1;
			}
		}
		ans.push_back(cur);
		if (want != 1)
		{
			cout << -1;
			return 0;
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			ans.push_back({i + 1});
		}
	}


	cout << ans.size() << "\n";
	for (auto it : ans)
	{
		cout << it.size() << " ";
		for (int p : it)
		{
			cout << p << " ";
		}
		cout << "\n";
	}


#ifdef _DEBUG
	while (1);
#endif
}