#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;


signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;
	int n = s.length();

	int cur = 0, cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			++cur;
		}
		else
		{
			--cur;
			++cnt;
		}
		if (cur < 0)
		{
			cout << -1;
			return 0;
		}
	}
	cur = 0, cnt = 0;
	for (int i = n - 1; i >= 0; i--)
	{
		if (s[i] == '0')
		{
			++cur;
		}
		else
		{
			--cur;
			++cnt;
		}
		if (cur < 0)
		{
			cout << -1;
			return 0;
		}
	}

	vector<vector<int>> ans;
	
	int ptr0 = 0;
	int ptr1 = 0;
	while (ptr1 < n && s[ptr1] == '0')
	{
		++ptr1;
	}

	vector<int> pr(n, -1);

	for (int i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			if (ptr1 < i)
			{
				pr[i] = ptr1;
				++ptr1;
				while (ptr1 < n && s[ptr1] == '0')
				{
					++ptr1;
				}
			}
		}
		else
		{
			if (ptr0 < i)
			{
				pr[i] = ptr0;
				++ptr0;
				while (ptr0 < n && s[ptr0] == '1')
				{
					++ptr0;
				}
			}
		}
	}

	vector<bool> used(n, false);

	for (int i = n - 1; i >= 0; i--)
	{
		if (!used[i] && s[i] == '0')
		{
			vector<int> cur;
			int j = i;
			while (1)
			{
				cur.push_back(j);
				used[j] = true;
				if (pr[j] == -1)
				{
					break;
				}
				else
				{
					j = pr[j];
				}
			}
			reverse(cur.begin(), cur.end());
			ans.push_back(cur);
		}
	}

	cout << ans.size() << "\n";
	for (auto it : ans)
	{
		cout << it.size() << " ";
		for (int p : it)
		{
			cout << p + 1 << " ";
		}
		cout << "\n";
	}


#ifdef _DEBUG
	while (1);
#endif
}