#include <bits/stdc++.h>
#define int long long
using namespace std;
vector<vector<int> > data, trans;
vector<int> tout, comp;
vector<bool> used;
int timer;
void dfs(int vertex){
    used[vertex] = true;
    for (int i=0; i < data[vertex].size(); i++){
        int to = data[vertex][i];
        if (used[to]) continue;
        dfs(to);
    }
    tout[vertex] = timer;
    timer++;
}
void Dfs(int vertex){
    comp[vertex] = timer;
    for (int i=0; i < trans[vertex].size(); i++){
        int to = trans[vertex][i];
        if (comp[to] != -1) continue;
        Dfs(to);
    }
}
signed main()
{
    //freopen("1.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i=0; i < n; i++){
        vector<int> a, b;
        data.push_back(a);
        trans.push_back(b);
        tout.push_back(-1);
        comp.push_back(-1);
        used.push_back(false);
    }
    vector<int> sch(n);
    for (int i=0; i < n; i++) cin >> sch[i];
    for (int i=0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--, b--;
        if ((sch[a] + 1) % h == sch[b]) data[a].push_back(b);
        if ((sch[b] + 1) % h == sch[a]) data[b].push_back(a);
    }
    for (int i=0; i < n; i++){
        for (int j=0; j < data[i].size(); j++){
            int to = data[i][j];
            trans[to].push_back(i);
        }
    }
    timer = 0;
    for (int i=0; i < n; i++){
        if (!used[i]) dfs(i);
    }
    vector<pair<int, int> > vv;
    for (int i=0; i < n; i++) vv.push_back(make_pair(tout[i], i));
    sort(vv.begin(), vv.end(), greater<pair<int, int> > ());
    timer = 0;
    for (int i=0; i < n; i++){
        int nv = vv[i].second;
        if (comp[nv] != -1) continue;
        Dfs(nv);
        timer++;
    }
    vector<vector<int> > css(timer);
    for (int i=0; i < n; i++) css[comp[i]].push_back(i);
    int ans = n+1, wh = -1;
    vector<bool> can(timer);
    fill(can.begin(), can.end(), true);
    for (int i=0; i < n; i++){
        for (int j=0; j < data[i].size(); j++){
            int to = data[i][j];
            if (comp[i] == comp[to]) continue;
            can[comp[i]] = false;
        }
    }
    for (int i=0; i < timer; i++){
        if (!can[i]) continue;
        if (css[i].size() < ans){
            ans = css[i].size();
            wh = i;
        }
    }
    cout << ans << endl;
    for (int i=0; i < css[wh].size(); i++) cout << css[wh][i]+1 << " ";
    return 0;
}

