#include <bits/stdc++.h>
#define mp make_pair
#define x first
#define y second
#define pb push_back

using namespace std;

typedef long long ll;

stack <int> q1, q2;
vector <int> hod;
int lev[200005], prav[200005];
bool used[200005];

void dfs(int v)
{
    used[v] = true;
    hod.pb(v + 1);
    if (prav[v] != -1 && !used[prav[v]]) dfs(prav[v]);
    return;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    string s;
    int kol1 = 0, kol2 = 0;
    cin >> s;
    int n = (int) s.length();
    for (int i = 0; i < n; i++)
        if (s[i] == '0') kol1++;
        else kol2++;
    if (kol1 - kol2 <= 0) cout << -1, exit(0);
    for (int i = 0; i < n; i++)
        lev[i] = -1, prav[i] = -1;

    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0') q1.push(i);
        else
        {
            if (q1.empty()) cout << -1, exit(0);
            lev[i] = q1.top();
            prav[q1.top()] = i;
            q1.pop();
        }
    }
    for (int i = n - 1; i >= 0; i--)
    {
        if (s[i] == '0') q2.push(i);
        else
        {
            if (q2.empty()) cout << -1, exit(0);
            prav[i] = q2.top();
            lev[q2.top()] = i;
            q2.pop();
        }
    }

    cout << kol1 - kol2 << '\n';
    for (int i = 0; i < n; i++)
        if (!used[i])
        {
            hod.clear();
            dfs(i);
            cout << (int) hod.size() << ' ';
            for (int j = 0; j < (int) hod.size(); j++)
                cout << hod[j] << ' ';
            cout << '\n';
        }
    return 0;
}
