#include <iostream>

using namespace std;

int n, m, h;

struct user{
	int c1;
	int c2;
};

int upper(bool to_do, int obj){
	if (to_do) return (obj+1)%h;
	else return obj; 
}

bool check(int mask, int data_centrs[], user users[]){
	for (int i = 0; i < m; i++){
		if (upper(mask>>(users[i].c1) & 1, data_centrs[users[i].c1]) == upper(mask>>(users[i].c2) & 1, data_centrs[users[i].c2]))
			return false;
	}
	return true;
}

int count(int mask){
	int n = 0;
	while (mask != 0){
		n += mask % 2;
		mask /= 2;
	}
	
	return n;
}

int main(){
	cin >> n >> m >> h;
	
	int data_centrs[n];
	for (auto &i: data_centrs)
		cin >> i;
	
	user users[m];
	
	for (auto &i: users){
		cin >> i.c1 >> i.c2;
		i.c1--;
		i.c2--;
	}
	
	//cout << "hoho\n";
	
	int min_n = 100;
	int best_mask = -1;
	
	for (int mask = 1; mask < 1<<n; mask++){
		int c = count(mask);
		if (check(mask, data_centrs, users) && c < min_n){
			min_n = c;
			best_mask = mask;
		}
	}
	
	cout << count(best_mask) << '\n';
	
	int p = 1;
	
	while (best_mask != 0){
		if (best_mask % 2 == 1) cout << p << ' ';
		best_mask /= 2;
		p++;
	}
}
