#include <iostream>
#include <vector>
#include <deque>

using namespace std;

struct posl{
	vector<int> positions;
	char last_char = '1'; 
};

int main(){
	string p;
	cin >> p;
	
	deque<posl> p1((int)p.length());
	deque<posl> p2(0);
	
	//int max_j = 0;
	
	for (int i = 0; i < (int)p.length(); i++){
		if (p[i] == '0'){
			p1.rbegin()->positions.push_back(i+1);
			p1.rbegin()->last_char = '0';
			p2.push_back(*(p1.end() - 1));
			p1.erase(p1.end() - 1);
		} else {
			if (p2.size() == 0){
				cout << -1;
				return 0;
			} else {
				p2.rbegin()->positions.push_back(i+1);
				p2.rbegin()->last_char = '1';
				p1.push_back(*(p2.end() - 1));
				p2.erase(p2.end() - 1);
			}
		}
	}
	
	if (p1.size() != 0 && (p1.end() - 1)->positions.size() != 0){
		cout << -1;
		return 0;
	}
	
	cout << p2.size() << '\n';
	
	for (int i = 0; i < (int)p2.size(); i++){
		cout << p2[i].positions.size() << " ";
		for (int j = 0; j < (int)p2[i].positions.size(); j++)
			cout << p2[i].positions[j] << ' ';
		cout << '\n';
	}
}
