#include <iostream>
#include <deque>

using namespace std;

struct posl{
	deque<int> positions;
};

int main(){
	char *p = new char[200000];
	ios::sync_with_stdio(false);
	cin >> p;
	
	deque<posl> p1(0);
	deque<posl> p2(0);
	
	for (int i = 0; p[i] != 0; i++){
		if (p[i] == '0'){
			if (p1.empty()){
				posl np;
				p1.push_back(np);
			}
			p1.rbegin()->positions.push_back(i+1);
			p2.push_back(*(p1.end() - 1));
			p1.erase(p1.end() - 1);
		} else {
			if (p2.empty()){
				cout << "-1\n";
				return 0;
			} else {
				p2.rbegin()->positions.push_back(i+1);
				p1.push_back(*(p2.end() - 1));
				p2.erase(p2.end() - 1);
			}
		}
	}
	
	if (!p1.empty()){
		cout << "-1\n";
		return 0;
	}
	
	cout << p2.size() << '\n';
	
	for (int i = 0; i < (int)p2.size(); i++){
		cout << p2[i].positions.size() << " ";
		for (int j = 0; j < (int)p2[i].positions.size(); j++)
			cout << p2[i].positions[j] << ' ';
		cout << '\n';
	}
}
