#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define int long long
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

void add(ll & val, vector<int> & from, int l, int r) {
	for (int i = l; i <= r; ++i)
		val += from[i];
}

void solve_for_1(int p, int n, ll d, ll b, vector<int> & a) {
	ll nxt = 0, ans = 0, av_sum = 0;

	for (ll i = 0; i < n; ++i) {
		int to_add = min(n, i + (i + 1) * d);
		add(av_sum, a, nxt, to_add);
		nxt = to_add + 1;
		if (av_sum >= b)
			av_sum -= b;
		else
			++ans;
	}
	cout << ans << endl;
}

void find_nxt(int & it, vector<int> & a) {
	while (!a[it]) ++it;
}

void find_prv(int & it, vector<int> & a) {
	while (!a[it]) --it;
}

bool check_left(int n, ll d, ll b, vector<int> a, int mid) {
	vector<int> s(n);
	for (int i = 0; i < n; ++i)
		s[i] = a[i];
	ll steps = mid;
	int l = steps, r = n - steps - 1;
	ll l_from = 0, r_from = n - 1;
	while (l < r) {
		// if (mid == 0)
		// 	cout << steps << ' ';
		s[l] = s[r] = 0;
		if (a[l] > b)
			s[l] = a[l] - b;
		if (a[r] > b)
			s[r] = a[r] - b;

		while (b > a[l]) {
			find_nxt(l_from, s);
			pair<int, int> temp = {l_from, s[l_from]};
			if (abs(temp.f - l) > (steps + 1) * d)
				return false;
			int add = min(temp.s, b - a[l]);
			temp.s -= add;
			a[l] += add;
			a[temp.f] -= add;
			s[l_from] = temp.s;
		}
		while (b > a[r]) {
			find_prv(r_from, s);
			pair<int, int> temp = {r_from, s[r_from]};
			if (abs(temp.f - r) > (steps + 1) * d)
				return false;
			int add = min(temp.s, b - a[r]);
			temp.s -= add;
			a[r] += add;
			a[temp.f] -= add;
			s[r_from] = temp.s;
		}
		++steps;
		++l, --r;
		// if (mid == 0)
		// 	cout << "ok" << endl;
	}
	if (l == r) {
		s[l] = 0;
		if (a[l] > b)
			s[l] = a[l] - b;
		while (b > a[l]) {
			find_nxt(l_from, s);
			pair<int, int> temp = {l_from, s[l_from]};
			if (abs(temp.f - l) > (steps + 1) * d)
				return false;
			int add = min(temp.s, b - a[l]);
			temp.s -= add;
			a[l] += add;
			a[temp.f] -= add;
			s[l_from] = temp.s;
		}
	}

	return true;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// freopen("inputC.txt", "r", stdin);
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (p == 1) {
		solve_for_1(p, n, d, b, a);
		return 0;
	}
	else {
		int l = -1, r = (n + 1) / 2;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (check_left(n, d, b, a, mid))
				r = mid;
			else
				l = mid;
		}
		int ans = n;
		chkmin(ans, r);

		reverse(all(a));
		l = -1, r = (n + 1) / 2;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			// cout << mid << ' ' << endl;
			if (check_left(n, d, b, a, mid))
				r = mid;
			else
				l = mid;
		}
		chkmin(ans, r);
		cout << ans << endl;
	}
	return 0;
}
