#pragma GCC optimize ("O3")
#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN = 1e5;
vector <int> graph[MAXN];
int arr[MAXN], dist[MAXN];


signed main() {
	ios_base::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++) cin >> arr[i];
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		if ((arr[a] + 1) % h == arr[b]) {
			graph[a].push_back(b);
		}
		if ((arr[b] + 1) % h == arr[a]) {
			graph[b].push_back(a);
		}
	}
	pair <int, int> ans = {1e9, 1e9};
	for (int i = 0; i < n; i++) {
		vector <bool> used(n, false);
		used[i] = true;
		queue <int> Q;
		Q.push(i);
		while (!Q.empty()) {
			int v = Q.front(); Q.pop();
			for (auto u : graph[v]) {
				if (!used[u])  {
					used[u] = 1;
					Q.push(u);
				}
			}
		}
		ans = min(ans, {count(used.begin(), used.end(), 1), i});
	}
	vector <bool> used(n, false);
	used[ans.second] = true;
	queue <int> Q;
	Q.push(ans.second);
	while (!Q.empty()) {
		int v = Q.front(); Q.pop();
		for (auto u : graph[v]) {
			if (!used[u])  {
				used[u] = 1;
				Q.push(u);
			}
		}
	}
	cout << ans.first << endl;
	for (int i = 0; i < n; i++) {
		if (used[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << endl;



	return 0;
}