#pragma GCC optimize ("O3")
#include <bits/stdc++.h>
using namespace std;
#define int long long

const int MAXN = 1e5;
vector <int> graph[MAXN];
vector <int> ng[MAXN];
int arr[MAXN], used[MAXN], cur[MAXN], cnt[MAXN], fup[MAXN], sz[MAXN], rep[MAXN], height[MAXN];
vector <int> css[MAXN];
int id[MAXN];

set <pair <int, int> > Br;

void dfs(int v, int p = -1, int h = 0) {
	used[v] = 1;

	cur[h] = v;
	fup[v] = h;
	height[v] = h;

	for (auto u : graph[v]) {
		if (used[u] == 2) {
			if (fup[u] == height[u])
				Br.insert({v, u});
			fup[v] = min(fup[v], fup[u]);
		} else if (used[u] == 0) {
			// cout << v << "--------_>" << u << endl;
			dfs(u, v, h + 1);
			// cout << fup[v] << "--------_>" << fup[u] << endl;
			fup[v] = min(fup[v], fup[u]);
		} else {
			fup[v] = min(fup[v], fup[u]); 
			fup[v] = min(fup[v], height[u]); 
		}
	}
	used[v] = 2;
	// cout << v << "\t\t" << fup[v] << " " << height[v] << endl;
	if (fup[v] == height[v] && p != -1) {
		Br.insert({p, v});
		// cout << "\t" << p << " " << v << endl;
	}
	css[cur[fup[v]]].push_back(v);
	// height[v] = fup[v] = 1e9;
}

void CS(int v, int col) {
	rep[col] = v;
	sz[col]++;
	used[v] = 1;
	id[v] = col;
	for (auto u : graph[v]) {
		if (!used[u] && !Br.count({v, u})) 
			CS(u, col);
	}
}

void df(int v) {
	cnt[v] = sz[v];
	used[v] = 1;
	for (auto u : graph[v]) {
		if (used[u] == 2) {
			cnt[v] += cnt[u];
		} else if (used[u] == 0) {
			df(u);
			cnt[v] += cnt[u];
		}
	}
	used[v] = 2;
}

signed main() {
	ios_base::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++) cin >> arr[i];
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		if ((arr[a] + 1) % h == arr[b]) {
			graph[a].push_back(b);
			// cout << a << " " << b << endl; 
		}
		if ((arr[b] + 1) % h == arr[a]) {
			graph[b].push_back(a);
			// cout << b << " " << a << endl; 
		}
	}
	// for (int i = 0; i < n; i++) {
	// 	graph[0].push_back(i + 1);
	// }
	// pair <int, int> ans = {1e9, 1e9};
	// for (int i = 0; i < n; i++) {
	// 	vector <bool> used(n, false);
	// 	used[i] = true;
	// 	queue <int> Q;
	// 	Q.push(i);
	// 	while (!Q.empty()) {
	// 		int v = Q.front(); Q.pop();
	// 		for (auto u : graph[v]) {
	// 			if (!used[u])  {
	// 				used[u] = 1;
	// 				Q.push(u);
	// 			}
	// 		}
	// 	}
	// 	ans = min(ans, {count(used.begin(), used.end(), 1), i});
	// }
	// vector <bool> used(n, false);
	// used[ans.second] = true;
	// queue <int> Q;
	// Q.push(ans.second);
	// while (!Q.empty()) {
	// 	int v = Q.front(); Q.pop();
	// 	for (auto u : graph[v]) {
	// 		if (!used[u])  {
	// 			used[u] = 1;
	// 			Q.push(u);
	// 		}
	// 	}
	// }
	// cout << ans.first << endl;
	// for (int i = 0; i < n; i++) {
	// 	if (used[i]) {
			// cout << i + 1 << " ";
	// 	}
	// }
	// cout << endl;
	int num = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i])
			dfs(i);
	}
	fill(used, used + n + 1, 0);
	for (int i = 0; i < n; i++) {
		if (!used[i])
			CS(i, num++);
	}

	// for (int i = 0; i < n; i++) {
		// cout << anc[i] << endl;
	// }
	// for (int i = 0; i < n; i++) {
	// 	if (!css[i].empty()) {
	// 		for (auto e : css[i]) {
	// 			id[e] = num;
	// 			rep[num] = e;
	// 		}
	// 		sz[num] = css[i].size();
	// 		num++;
	// 	}
	// }

	for (int i = 0; i < n; i++) {
		for (auto j : graph[i]) {
			if (id[i] != id[j]) {
				ng[id[i]].push_back(id[j]);
			}
		}
	}
	fill(used, used + num, 0);
	for (int i = 0; i < num; i++) {
		if (!used[i])
			df(i);
	}
	// cout << num << endl;
	
	int ans = min_element(cnt, cnt + num) - cnt;


	vector <bool> used(n + 1, false);
	used[rep[ans]] = true;
	queue <int> Q;
	Q.push(rep[ans]);
	while (!Q.empty()) {
		int v = Q.front(); Q.pop();
		for (auto u : graph[v]) {
			if (!used[u])  {
				used[u] = 1;
				Q.push(u);
			}
		}
	}
	cout << cnt[ans] << endl;
	for (int i = 0; i < n; i++) {
		if (used[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << endl;

	return 0;
}