#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#include <iostream>
#define ll long long
using namespace std;
vector <vector <int> > g, g2, gcomp;
vector <int> used, comp_s, c, top;
int k_comp = 0, it = 0;

void dfs_top_sort(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (!used[u])
			dfs_top_sort(u);
	}
	top[it] = v;
	it--;
}

void dfs_comp(int v) {
	used[v] = 1;
	c[v] = k_comp;
	comp_s[k_comp]++;
	for (int u : g2[v]) {
		if (!used[u])
			dfs_comp(u);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, h;
	cin >> n >> m >> h;
	vector <int> t(n);
	for (int i = 0; i < n; i++)
		cin >> t[i];

	g.resize(n);
	g2.resize(n);
	
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if ((t[v] + 1) % h == t[u]) {
			g[v].push_back(u);
			g2[u].push_back(v);
		}
		if ((t[u] + 1) % h == t[v]) {
			g[u].push_back(v);
			g2[v].push_back(u);
		}
	}

	used.assign(n, 0);
	top.resize(n);
	it = n - 1;
	for (int v = 0; v < n; v++) {
		if (used[v] == 0)
			dfs_top_sort(v);
	}
	
	c.resize(n);
	comp_s.resize(n + 1);
	used.assign(n, 0);
	comp_s[n] = n + 10;

	for (int i = 0; i < n; i++) {
		int v = i;
		if (!used[v]) {
			dfs_comp(v);
			k_comp++;
		}
	}

	int ans = n;
	gcomp.resize(k_comp);
	for (int v = 0; v < n; v++) 
		for (int u : g[v]) 
			if (c[v] != c[u])
				gcomp[c[v]].push_back(c[u]);
	
	for (int i = 0; i < k_comp; i++) {
		if ((gcomp[i].size() == 0) && (comp_s[ans] > comp_s[i]))
			ans = i;
	}

	cout << comp_s[ans] << "\n";

	for (int i = 0; i < n; i++) {
		if (c[i] == ans)
			cout << i + 1 << " ";
	}
	return 0;
}