#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>
#include <set>
#include <map>
#include <iostream>
#define ll long long
using namespace std;
int p, n, b;
ll d;
vector <ll> a;
struct node {
	node *left, *right;
	int tl, tr;
	ll sum;
	node(int a = 0, int b = 0) : tl(a), tr(b) { sum = 0; }
};


void update(node*& v) {
	v->sum = v->left->sum + v->right->sum;
}

node* build(int l, int r) {
	if (l >= r)
		return NULL;
	node* v = new node(l, r);
	if (l + 1 == r) {
		v->sum = a[l];
		return v;
	}
	v->left = build(l, (l + r) / 2);
	v->right = build((l + r) / 2, r);
	update(v);
	return v;
}
vector <ll> sum;
/*
int rez1(bool f) {
int ans = 0;
int l = 0;
for (int i = 0; i < n; i++) {
l = max(l, i);
if (a[i] >= b) {
a[i + 1] += a[i] - b;
}
else {
if (a[i] + sum[min(i + d * (i + 1), n)] - sum[l] < b)
a[i + 1] += a[i], ans++;
else {
int pl = l;
a[i + 1] = sum[min(i + d * (i + 1), n)] - sum[l] - b + a[i], l = max(l, min(i + d * (i + 1), n));
for (int j = min(max(pl + 1, i + 2), n); j <= l; j++)
a[j] = 0;
}
}
}
if (f)
cout << ans;
return ans;
}
*/

int check2(int x) {
	vector <ll> aa;
	aa = a;
	int l = 0, r = n - 1;
	for (int i = x; i < n; i++) {
		if (a[i] >= b)
			a[i] -= b;
		else {
			if (l < n)
				a[l] += a[i];
			a[i] = 0;
			while ((l <= min((ll)n - 1, (ll)i + d * (i + 1))) && (a[i] + a[l] < b))
				a[i] += a[l], a[l] = 0, l++;
			if ((l > min((ll)n - 1, (ll)i + d * (i + 1))) && (a[i] < b)) {
				a = aa;
				return 0;
			}
			a[l] -= b - a[i];
			a[i] = 0;
		}
	}
	a = aa;
	return 1;
}

int rez1(bool f) {
	int l = 0, r = n + 1;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if (!check2(m))
			l = m;
		else
			r = m;
	}
	if (f) {
		if (check2(l))
			r = l;
		cout << r;
	}
	return r;
}
int check(int x) {
	vector <ll> aa;
	aa = a;
	int l = 0, r = n - 1;
	for (int i = x; i < n / 2; i++) {
		if (a[i] >= b)
			a[i] -= b;
		else {
			if (l < n)
				a[l] += a[i];
			a[i] = 0;
			while ((l <= min((ll)n - 1, (ll)i + d * (i + 1))) && (a[i] + a[l] < b))
				a[i] += a[l], a[l] = 0, l++;
			if ((l > min((ll)n - 1, (ll)i + d * (i + 1))) && (a[i] < b)) {
				a = aa;
				return 0;
			}
			a[l] -= b - a[i];
			a[i] = 0;
		}
		if (a[n - 1 - i] >= b)
			a[n - 1 - i] -= b;
		else {
			int p = n - i - 1;
			if (r >= 0)
				a[r] += a[p];
			a[p] = 0;
			while ((r >= max((ll)0, (ll)p - d * (i + 1))) && (a[p] + a[r] < b))
				a[p] += a[r], a[r] = 0, r--;
			if ((r < max((ll)0, (ll)p - d * (i + 1))) && (a[p] < b)) {
				a = aa;
				return 0;
			}
			a[r] -= b - a[p];
			a[p] = 0;
		}
	}
	if (n % 2 == 1) {
		ll sum = 0;
		p = n / 2;
		for (int i = max((ll)0, (ll)p - d * (p + 1)); i <= min((ll)n - 1, (ll)p + d * (p + 1)); i++)
			sum += a[i];
		a = aa;
		if (sum < b)
			return 0;
		else
			return 1;
	}
	else {
		a = aa;
		return 1;
	}
}

void rez2() {
	int l = 0, r = n / 2 + 2;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if (!check(m))
			l = m;
		else
			r = m;
	}
	if (check(l))
		r = l;
	cout << r;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> p >> n >> d >> b;
	a.resize(n + 1);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	sum.resize(n + 1);
	sum[0] = a[0];
	for (int i = 1; i <= n; i++) {
		sum[i] = sum[i - 1] + a[i];
	}
	if (p == 1) {
		rez1(1);
		return 0;
	}
	rez2();
	return 0;
}