#include <iostream>
#include <vector>
using namespace std;

vector<vector<int> > g;

vector<bool> used;

vector<int> cur;

vector<int> ans1;

vector<int> changed;

int dfscnt(int v){
    changed.push_back(v);
    used[v] = true;
    int cnt = 1;
    for (auto i : g[v]){
        if (!used[i]){
            cnt += dfscnt(i);
        }
    }
    ans1[v] = cnt;
    return cnt;
}

void dfs(int v){
    used[v] = true;
    cur.push_back(v);
    for (auto i : g[v]){
        if (!used[i]){
            dfs(i);
        }
    }
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> time(n);
    for (int i = 0; i < n; i++){
        cin >> time[i];
    }
    g.resize(n);
    vector<pair<int, int> > p(m);
    vector<vector<int> > q(n);
    for (int i = 0; i < m; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first--;
        p[i].second--;
        q[p[i].first].push_back(i);
        q[p[i].second].push_back(i);
    }
    for (int i = 0; i < n; i++){
        for (auto f : q[i]){
            if (i == p[f].first){
                if (time[p[f].second] == (time[i] + 1) % h){
                    g[i].push_back(p[f].second);
                }
            }else{
                if (time[p[f].first] == (time[i] + 1) % h){
                    g[i].push_back(p[f].first);
                }
            }
        }
    }
    vector<int> answer;
    int ans = 1e9;
    used.resize(n);
    ans1.resize(n);
    for (int i = 0; i < n; i++){
        if (!used[i]){
            dfscnt(i);
            for (auto j : changed){
                used[j] = false;
            }
            changed.resize(0);
        }
    }
    int ind = 0;
    for (int i = 0; i < n; i++){
        if (ans1[i] < ans1[ind]){
            ind = i;
        }
    }
    used.resize(0);
    used.resize(n);
    dfs(ind);
    ans = cur.size();
    answer = cur;
    cout << ans << endl;
    for (auto i : answer){
        cout << i + 1 << ' ';
    }
    cout << endl;
    return 0;
}
