#include <iostream>
#include <vector>

#define ll long long

using namespace std;

vector<int> cnt;

vector <int> us;
vector<bool> used;
vector<vector<int> > g;

int dfscnt(int v, int color){
    us[v] = color;
    int c = 1;
    for (auto i : g[v]){
        if (us[i] != color){
            c += dfscnt(i, color);
        }
    }
    cnt[v] = c;
}

vector<int> ans;

void dfspath(int v){
    used[v] = true;
    ans.push_back(v);
    for (auto i : g[v]){
        if (!used[i]){
            dfspath(i);
        }
    }
}

int main()
{
int n, m, h;
    cin >> n >> m >> h;
    vector<int> time(n);
    for (int i = 0; i < n; i++){
        cin >> time[i];
    }
    g.resize(n);
    us.resize(n, -1);
    used.resize(n);
    cnt.resize(n);
    vector<pair<int, int> > p(m);
    vector<vector<int> > q(n);
    for (int i = 0; i < m; i++){
        cin >> p[i].first >> p[i].second;
        p[i].first--;
        p[i].second--;
        q[p[i].first].push_back(i);
        q[p[i].second].push_back(i);
    }
    for (int i = 0; i < n; i++){
        for (auto f : q[i]){
            if (i == p[f].first){
                if (time[p[f].second] == (time[i] + 1) % h){
                    g[i].push_back(p[f].second);
                }
            }else{
                if (time[p[f].first] == (time[i] + 1) % h){
                    g[i].push_back(p[f].first);
                }
            }
        }
    }
    int ind = 0;
    for (int i = 0; i < n; i++){
        if (us[i] == -1){
            dfscnt(i, i);
        }
        if (cnt[i] < cnt[ind]){
            ind = i;
        }
    }
    dfspath(ind);
    cout << ans.size() << endl;
    for (auto i : ans){
        cout << i + 1 << ' ';
    }
    cout << endl;
    return 0;
}
