#include <iostream>
#include <vector>

#define ll long long
using namespace std;

int main()
{
    string s;
    cin >> s;
    int n = s.size();
    vector<int> a(n);
    for (int i = 0; i< n; i++){
        a[i] = (s[i] == '1');
    }
    int d = 0;
    for (int i = 0; i < n; i++){
        if (a[i] == 0){
            d++;
        }else{
            d--;
        }
    }
    if (d <= 0){
        cout << -1 << endl;
        return 0;
    }
    vector<int> dp(d, 1);
    vector<vector<int> > ans(d);
    for (int i = 0; i < n; i++){
        bool t = false;
        for (int j = 0; j < d; j++){
            if (dp[j] == 1 - a[i]){
                ans[j].push_back(i);
                dp[j] = a[i];
                t = true;
                break;
            }
        }
        if (!t){
            cout << -1 << endl;
            return 0;
        }
    }
    cout << d << endl;
    for (int i = 0; i < d; i++){
        cout << ans[i].size() << ' ';
        for (auto x : ans[i]){
            cout << x + 1 << ' ';
        }
        cout << endl;
    }
    return 0;
}
