#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int n, m, h;
vec<unordered_set<int> > g;
vec<int> color, a;
vec<int> cycle;
vec<vec<int> > comps;
bool f = false;

void dfs(int v) {
    color[v] = true;
    comps[(int)comps.size() - 1].pb(v);
    for (int u : g[v]) {
        if (color[u] == 0) { dfs(u); }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> h;
    g = vec<unordered_set<int> >(n);
    a = color = vec<int>(n);

    for (int &k : a) { cin >> k; }
    for (int k = 0; k < m; k++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        if ((a[v] + 1) % h == a[u]) { g[v].insert(u); }
        if ((a[u] + 1) % h == a[v]) { g[u].insert(v); }
    }

    for (int k = 0; k < n; k++) {
        if (g[k].empty()) { cout << "1 \n" << k + 1 << '\n'; return 0; }
    }
    for (int k = 0; k < n; k++) {
        if (color[k]) { continue; }
        comps.resize(comps.size() + 1);
        dfs(k);
    }

    int i = 0;
    for (int k = 1; k < (int)comps.size(); k++) {
        if (comps[k].size() < comps[i].size()) { i = k; }
    }
    cout << comps[i].size() << '\n';
    for (int k : comps[i]) { cout << k + 1 << " "; }
    return 0;
}
