#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int n, m, h;
vec<unordered_set<int> > g;
vec<int> color, a;
vec<int> cycle, up, t, y;
vec<vec<int> > comps;
bool f = false;

void dfs(int v, int d = 0) {
    color[v] = 1;
    y[v] = comps[(int)comps.size() - 1].size();
    comps[(int)comps.size() - 1].pb(v);
    for (int u : g[v]) {
        if (f) { return; }
        if (color[u] == 2) {
            comps.resize((int)comps.size() - 1);
            f = true;
            return;
        }
        if (color[u] == 0) { dfs(u, d + 1); }
    }
    color[v] = 2;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> h;
    g = vec<unordered_set<int> >(n);
    y = up = a = color = vec<int>(n);

    for (int &k : a) { cin >> k; }
    for (int k = 0; k < m; k++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        if ((a[v] + 1) % h == a[u]) { g[v].insert(u); }
        if ((a[u] + 1) % h == a[v]) { g[u].insert(v); }
    }

    for (int k = 0; k < n; k++) {
        if (g[k].empty()) { cout << "1 \n" << k + 1 << '\n'; return 0; }
    }
    for (int k = 0; k < n; k++) {
        if (color[k]) { continue; }
        comps.resize(comps.size() + 1);
        f = false;
        dfs(k);
    }

    for (int k = 0; k < (int)comps.size(); k++) {
        //for (int i : comps[k]) { cout << i +1 << " "; } cout << '\n';
    }
    vec<int> u(comps.size());
    for (int k = 0; k < (int)u.size(); k++) {
        u[k] = comps[k].size() - 1;
        for (int i : comps[k]) {
            for (int to : g[i]) {
                u[k] = min(u[k], y[to]);
            }
        }
        //cout << u[k] << " ";
    }
    //cout << '\n';

    int i = 0;
    for (int k = 1; k < (int)comps.size(); k++) {
        if (comps[k].size() - u[k] < comps[i].size() - u[i]) { i = k; }
    }
    cout << comps[i].size() - u[i] << '\n';
    for (int k = u[i]; k < (int)comps[i].size(); k++) {
        cout << comps[i][k] + 1 << " ";
    }
    return 0;
}
