#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

int n, m, h;
vec<unordered_set<int> > g, tg;
vec<int> color, a;
vec<int> cycle;
vec<int> best;
vec<vec<int> > comps;
vec<char> used;
bool f = false;
stack<int> st;
unordered_set<int> marked;
bool cont = true;

void dfs(int v) {
    color[v] = 1;
    for (int u : g[v]) {
        if (!cont) { return; }
        if (color[u] == 0) { dfs(u); }
        else if (color[u] == 1) {
            st.push(u);
            marked.insert(u);
        }
        if (!cont) { return; }
    }
    color[v] = 2;
    if (!cont) { return; }
    cycle.pb(v);
    while (!st.empty() && color[st.top()] == 2) { st.pop(); }
    if (st.empty()) {
        cont = false;
        return;
    }
}

void dfs2(int v) {
    used[v] = true;
    for (int u : tg[v]) {
        if (!used[u]) { dfs2(u); }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> h;
    tg = g = vec<unordered_set<int> >(n);
    a = color = vec<int>(n);
    used = vec<char>(n);
    best.resize(n + 1);

    for (int &k : a) { cin >> k; }
    for (int k = 0; k < m; k++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        if ((a[v] + 1) % h == a[u]) { g[v].insert(u); tg[u].insert(v); }
        if ((a[u] + 1) % h == a[v]) { g[u].insert(v); tg[v].insert(u); }
    }

    for (int k = 0; k < n; k++) {
        if (!used[k]) {
            cont = true;
            cycle.clear();
            dfs(k);
            if (cont) { continue; }
            for (int k : cycle) { cout << k + 1 << " "; } cout << '\n';
            if (cycle.size() < best.size()) { best = cycle; }
            dfs2(cycle[0]);
        }
    }
    cout << best.size() << '\n';
    for (int k : best) { cout << k + 1 << " "; } cout << '\n';

    return 0;
}
