//#include "stdafx.h"
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <limits.h>

using namespace std;

#define int long long
#define p_b push_back
#define m_p make_pair

/*void dfs(int v, int p) {
    used[v] = 1;
    fup[v] = tin[v] = timer++;
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (used[gr[v][i]) {
            fup[v] = min(fup[v], tin[to]);
        }
        else {
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
            if (fup[to] > tin[v]) {
                //bridge
            }
        }
    }
}*/

int n, m, h, col, a, b;
vector<int> ans, q, t;
vector<vector<int>> gr;

void dfs(int v) {
    t[v] = (t[v] + 1) % h;
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (t[v] - t[to] == 0) {
            dfs(to);
        }
    }
    t[v] = (t[v] - 1 + h) % h;
    col++;
}

void dfs1(int v) {
    t[v] = (t[v] + 1) % h;
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (t[v] - t[to] == 0) {
            dfs1(to);
        }
    }
    t[v] = (t[v] - 1 + h) % h;
    cout << v + 1 << ' ';
}

signed main()
{
    cin >> n >> m >> h;
    gr.resize(n);
    q.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> q[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        a--;
        b--;
        gr[a].p_b(b);
        gr[b].p_b(a);
    }
    int min_col = 1e8;
    int ind_ans;
    for (int i = 0; i < n; i++) {
        col = 0;
        t = q;
        dfs(i);
        if (col < min_col) {
            ind_ans = i;
            min_col = col;
        }
    }
    cout << min_col << '\n';
    dfs1(ind_ans);
    //system("pause");
    return 0;
}
