//#include "stdafx.h"
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <limits.h>

using namespace std;

#define int long long
#define p_b push_back
#define m_p make_pair

int n, m, h, col, a, b;
vector<int> ans, q, t;
vector<vector<int>> gr;

void dfs(int v) {
    t[v] = (t[v] + 1) % h;
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (t[v] - t[to] == 0) {
            dfs(to);
        }
    }
    col++;
}

void dfs1(int v) {
    t[v] = (t[v] + 1) % h;
    for (int i = 0; i < gr[v].size(); i++) {
        int to = gr[v][i];
        if (t[v] - t[to] == 0) {
            dfs1(to);
        }
    }
    cout << v + 1 << ' ';
}

signed main()
{
    cin >> n >> m >> h;
    gr.resize(n);
    q.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> q[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> a >> b;
        a--;
        b--;
        gr[a].p_b(b);
        gr[b].p_b(a);
    }
    for (int i = 0; i < n; i++) {
        bool flag = 0;
        for (int j = 0; j < gr[i].size(); j++) {
            int to = gr[i][j];
            if ((q[i] + 1) % h - q[to] == 0) {
                flag = 1;
            }
        }
        if (!flag) {
            cout << 1 << '\n';
            cout << i + 1;
            //system("pause");
            return 0;
        }
    }
    cout << n << '\n';
    for (int i = 0; i < n; i++) {
        cout << i + 1 << ' ';
    }
    //system("pause");
    return 0;
}
