#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

using namespace std;

vector<vector<int>> g;
vector<int> used;
vector<int> way;
vector<int> answ;

void dfs(int v)
{
	if (used[v] == 1)
	{
		vector<int> realway;
		int k = way.size() - 1;
		while (k >= 0 && way[k] != v)
			realway.push_back(way[k]), k--;
		if (k >= 0)
			realway.push_back(way[k]);
		if (realway.size() < answ.size() || answ.empty())
			answ = realway;
		return;
	}

	used[v] = 1;

	if (g[v].empty())
		answ = {v};

	way.push_back(v);

	for (auto u : g[v])
		dfs(u);

	way.pop_back();

	used[v] = 2;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;
	vector<int> t(n);
	g.resize(n);
	used.resize(n);

	fi(n)
		cin >> t[i];

	fi(m)
	{
		int u, v;
		cin >> u >> v;
		u--, v--;
		if (t[u] == (t[v] + 1) % h)
			g[v].push_back(u);
		if (t[v] == (t[u] + 1) % h)
			g[u].push_back(v);
	}

	fi(n)
		if (!used[i])
			dfs(i);

	cout << answ.size() << endl;
	for (auto e : answ)
		cout << e + 1 << " ";
	cout << endl;

	return 0;
}

