#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <string>

#define ll long long 
#define fi(n) for (int i = 0; i < (n); i++) 
#define FOR(i, k, n) for (int i = (k); i < (n); i++) 
#define all(v) v.begin(), v.end()

using namespace std;

vector<vector<int>> g;
vector<int> used;
vector<int> way;
vector<int> answ;
vector<int> tpsrt;
vector<bool> u;

bool dfs(int v)
{
	if (used[v] == 1)
		return true;

	if (used[v] == 2)
		return false;

	used[v] = 1;

	way.push_back(v);

	for (auto u : g[v])
		if (!dfs(u))
			return false;

	return true;
}

void dfs1(int v)
{
	u[v] = true;
	for (auto e : g[v])
		if (!u[e])
			dfs1(e);
	tpsrt.push_back(v);
}


int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;
	vector<int> t(n);
	g.resize(n);
	used.resize(n);
	u.resize(n);
	fi(n)
		cin >> t[i];

	fi(m)
	{
		int u, v;
		cin >> u >> v;
		u--, v--;
		if (t[u] == (t[v] + 1) % h)
			g[v].push_back(u);
		if (t[v] == (t[u] + 1) % h)
			g[u].push_back(v);
	}

	fi(n)
		if (g[i].size() == 0)
		{
			cout << 1 << endl;
			cout << i + 1 << endl;
			return 0;
		}

	fi(n)
		if (!u[i])
			dfs1(i);
	
	fi(n)
		if (!used[tpsrt[i]])
		{
			if (!dfs(tpsrt[i]))
				continue;
			if (way.size() < answ.size() || answ.empty())
				answ = way;
			for (auto e : way)
				used[e] = 2;
			way.clear();
		}
	cout << answ.size() << endl;
	for (auto e : answ)
		cout << e + 1 << " ";
	cout << endl;

	return 0;
}

