#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <queue>

typedef long long ll;
typedef long double ld;
using namespace std;

const int N = 100001;
vector<int> g[N], rg[N];
int n, m, h;
int a[N], used[N], col[N], b[N], sz[N];
vector<int> ord;

void dfs(int v) {
    used[v] = 1;
    for (int u : g[v])
        if (!used[u])
            dfs(u);
    ord.push_back(v);
}

void rdfs(int v, int cc) {
    col[v] = cc;
    sz[cc]++;
    for (int u : rg[v])
        if (!col[u])
            rdfs(u, cc);
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
    scanf("%d%d%d", &n, &m, &h);
    for (int i = 0; i < n; i++)
        scanf("%d", &a[i]);
    int x, y;
    for (int i = 0; i < m; i++) {
        scanf("%d%d", &x, &y);
        --x; --y;
        if ((a[x] + 1) % h == a[y]) {
            g[x].push_back(y);
            rg[y].push_back(x);
        }
        if ((a[y] + 1) % h == a[x]) {
            g[y].push_back(x);
            rg[x].push_back(y);
        }
    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);
    int cn = 0;
    for (int i = (int) ord.size() - 1; i >= 0; i--)
        if (!col[ord[i]])
            rdfs(ord[i], ++cn);
    for (int i = 0; i < n; i++) {
        for (int u : g[i])
            if (col[u] != col[i])
                b[col[i]] = 1;
    }
    int ans = 0;
    for (int i = 1; i <= cn; i++) {
        if (!b[i] && (ans == 0 || sz[i] < sz[ans]))
            ans = i;
    }
    printf("%d\n", sz[ans]);
    for (int i = 0; i < n; i++)
        if (col[i] == ans)
            printf("%d ", i + 1);

}
