#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int n, m, h, a, b, ans = 1e9;
vector<vector<int> > g, d, pr;
vector<int> u;

void bfs(int v){
    d[v].resize(n, -1);
    pr[v].resize(n, -1);
    queue<int> q;
    q.push(v);
    d[v][v] = 0;
    while (!q.empty()){
        int p = q.front();
        q.pop();
        for (auto i : g[p])
            if (d[v][i] == -1){
                d[v][i] = d[v][p] + 1;
                pr[v][i] = p;
                q.push(i);
            }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> h;
    g.resize(n);
    d.resize(n);
    pr.resize(n);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        u.push_back(x);
    }
    for (int i = 0; i < m; i++){
        int p, q;
        cin >> p >> q;
        p--;
        q--;
        if ((u[p] + 1) % h == u[q])
            g[p].push_back(q);
        if ((u[q] + 1) % h == u[p])
            g[q].push_back(p);
    }
    if (h == 2){
        cout << n << endl;
        for (int i = 1; i <= n; i++)
            cout << i << ' ';
        cout << endl;
        return 0;
    }
    for (int i = 0; i < n; i++)
        if (g[i].empty())
            return cout << 1 << endl << i + 1 << endl, 0;
    for (int i = 0; i < n; i++)
        bfs(i);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j && d[i][j] != -1 && d[j][i] != -1 && d[i][j] + d[j][i] < ans){
                ans = d[i][j] + d[j][i];
                a = i;
                b = j;
            }
    cout << ans << endl;
    for (int i = a; i != b; i = pr[b][i])
        cout << i + 1 << ' ';
    for (int i = b; i != a; i = pr[a][i])
        cout << i + 1 << ' ';
    cout << endl;

    return 0;
}
