#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(s) s.begin(), s.end()

#define bp __builtin_popcountll
#define b_clz __builtin_clzll
#define b_ctz __builtin_ctzll

typedef long long llong;
typedef unsigned long long ullong;

typedef vector <int> vi;
typedef vector <llong> vl;

typedef pair <int, int> pii;

const int MXN = 1e6 + 1;
const int MNN = 1e3 + 1;
const int INF = 1e9;
const llong MOD = 1e9 + 7;
const llong LINF = 1e18;

llong log2 (llong x) {return 64 - b_clz (x) - 1;};
llong __lcm (llong x, llong y) {return x / __gcd (x, y) * y;};

int n;

vi g[MXN];

string s;

bool used[MXN];

int get (int i, int x) {
	//if (g[i][g[i].size () - 1] < x) return -1;
	int l = 0, r = g[i].size () - 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (g[i][m] < x) l = m;
		else r = m;
	}
	if (g[i][l] > x) return g[i][l];
	if (g[i][r] > x) return g[i][r];
	return -1;
}

int main () {
	//freopen ("input.txt", "r", stdin);
	cin >> s;
	n = s.size ();
	int pos = -1;
	for (int i = 0; i < n; ++ i) {
		g[s[i] - '0'].pb (i);
		if (s[i] == '0' && pos == -1) pos = i;
	}
	if (pos == -1) return cout << -1, 0;
	for (int i = pos; i < n;) {
		used[i] = 1;
		int to = get ((s[i] == '1' ? 0 : 1), i);
		if (to == -1) break;
		i = to;
	}
	vector <vi> ans;
	vi cur;
	for (int i = 0; i < n; ++ i) {
		if (used[i]) cur.pb (i);
	}
	ans.pb (cur);
	for (int i = 0; i < n; ++ i) {
		if (!used[i] && s[i] == '1') return cout << -1, 0;
		if (!used[i] && s[i] == '0') ans.pb ({i});
	}
	cout << ans.size () << '\n';
	for (vi it : ans) {
		cout << it.size () << ' ';
		for (int i : it) cout << i + 1 << ' ';
		cout << '\n';
	}
	return 0;
}