#include <bits/stdc++.h>

using namespace std;

#define sqr(a) ((a)(a))
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int(a.size())
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define x first
#define y second
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const int N = 1e6 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;
const int M = 1e3 + 9;
const ld EPS = 1e-12;
const char C = 'a';

vector<int> g[N], sorted, a;
int hour[N], num[N];
bool used[N];

void top_sort(int v, vector<int> &sorted) {
    used[v] = 1;
    for (auto u : g[v])
        if (!used[u])
            top_sort(u, sorted);
    sorted.push_back(v);
}

int dfs(int v) {
    used[v] = 1;
    num[v] = 1;
    for (auto u : g[v])
        if (!used[u])
            num[v] += dfs(u);
    return num[v];
}

int main()
{
    ios::sync_with_stdio(0);
    int n, m, h, v, u, ans = INFINT, k = -1;
    cin >> n >> m >> h;
    forn(i, n)
        cin >> hour[i];
    forn(i, m) {
        cin >> v >> u;
        v--;
        u--;
        if (hour[v] > hour[u])
            swap(v, u);
        if (hour[v] == 0 && hour[u] == n - 1)
            swap(v, u);
        g[v].pb(u);
    }
    forn(i, n)
        if (!used[i])
            top_sort(i, sorted);
    reverse(sorted.begin(), sorted.end());
    //fill(used, used + n, 0);
    for (auto v : sorted) {
        fill(used, used + n, 0);
        fill(num, num + n, 0);
        dfs(v);
        if (ans > num[v]) {
            k = v;
            ans = num[v];
        }
    }
    fill(used, used + n, 0);
    fill(num, num + n, 0);
    cout << ans << '\n';
    top_sort(k, a);
    for (auto v : a)
        cout << v + 1 << ' ';
    return 0;
}
