#include <bits/stdc++.h>

using namespace std;

#define sqr(a) ((a)(a))
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int(a.size())
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define x first
#define y second
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const int N = 1e6 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;
const int M = 1e3 + 9;
const ld EPS = 1e-12;
const char C = 'a';

vector<int> two_pw, cur;
int a[N];
bool memory[N], used[M];

void to_a(int mask, vector<int> &a, vector<int> &two_pw) {
    a.clear();
    int i = 0;
    while (mask) {
        if (mask & 1)
            a.push_back(two_pw[i]);
        i++;
        mask >>= 1;
    }
}

void rec(int val, bool *pos, vector<int> &cur) {
    pos[val] = 1;
    forn(i, sz(cur)) {
        if (!used[i]) {
            if (!pos[val + cur[i]]) {
                used[i] = 1;
                rec(val + cur[i], pos, cur);
                used[i] = 0;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    int n, m, mini = INFINT;
    vector<int> ans;
    bool *pos = memory + N/2;
    cin >> n;
    forn(i, n)
        cin >> a[i];
    for (int i = 128; i >= 1; i /= 2) {
        two_pw.push_back(i);
        two_pw.push_back(-i);
    }
    m = sz(two_pw);
//    cout << m << endl;
    for (int mask = 0; mask < (1 << m); mask++) {
        bool con = 0;
        fill(pos - 257, pos + 257, 0);
        to_a(mask, cur, two_pw);
        fill(used, used + sz(cur), 0);
        pos[0] = 1;
        rec(0, pos, cur);
        forn(i, n) {
            if (!pos[a[i]]) {
                con = 1;
                break;
            }
        }
//        cout << mask << endl;
        if (con)
            continue;
        if (mini > sz(cur)) {
            mini = sz(cur);
            ans = cur;
        }

    }
    cout << sz(ans) << '\n';
    for (auto v : ans)
        cout << v << ' ';
//    cout << "fhgj";
    return 0;
}
