#include <bits/stdc++.h>

using namespace std;

#define sqr(a) ((a)(a))
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int(a.size())
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define x first
#define y second
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const int N = 1e6 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;
const int M = 1e3 + 9;
const ld EPS = 1e-12;
const char C = 'a';

vector<int> a[N];
bool used[N];

int main()
{
    ios::sync_with_stdio(0);
    string s;
    cin >> s;
    int n = sz(s), k, cnt = 0;
    stack<int> st;
    forn(i, n) {
        if (s[i] == '0')
            st.push(i);
        else if (s[i] == '1'){
            cnt++;
            if (st.empty()) {
                return cout << -1, 0;
            }
            k = st.top();
            used[k] = 1;
            st.pop();
            a[i].pb(k);
        }
    }
    while (sz(st))
        st.pop();
    rforn(i, n) {
        if (s[i] == '0' && !used[i])
            st.push(i);
        else if (s[i] == '1'){
            if (st.empty()) {
                return cout << -1, 0;
            }
            k = st.top();
            used[k] = 1;
            st.pop();
            a[i].pb(k);
        }
    }
    forn(i, n)
        if (!used[i])
            cnt++;
    cout << cnt << '\n';
    forn(i, n) {
        if (s[i] == '0' && !used[i])
            cout << 1 << ' ' << i + 1 << '\n';
        else if (s[i] == '1')
            cout << 3 << ' ' << a[i][0] + 1 << ' ' << i + 1 << ' ' << a[i][1] + 1 << '\n';
    }
    return 0;
}
