#include <bits/stdc++.h>


using namespace std;

vector <int> c;
vector <vector <int> > g, g1;
vector <set <int> > gc;
vector <bool> used;
vector <int> order;
vector <int> sz;
vector <vector <int> > comp;

const int INF = 1e9;

void sortdfs(int v, bool f) {
    if (f) {
        cout << v + 1 << " ";
    }
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            sortdfs(u, f);
        }
    }
    order.push_back(v);
}

void coldfs(int v, int col) {
    c[v] = col;
    sz[col]++;
    comp[col].push_back(v);
    for (int u : g1[v]) {
        if (c[u] == -1) {
            coldfs(u, col);
        }
    }
}



int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> t(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    g.resize(n);
    g1.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if ((t[u] + 1) % h == t[v]) {
            g[u].push_back(v);
            g1[v].push_back(u);
        }
        if ((t[v] + 1) % h == t[u]) {
            g[v].push_back(u);
            g1[u].push_back(v);
        }
    }
    used.resize(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            sortdfs(i, 0);
        }
    }
    reverse(order.begin(), order.end());
    c.resize(n, -1);
    int k = 0;
    sz.resize(n, 0);
    comp.resize(n);
    for (int i = 0; i < n; i++) {
        if (c[order[i]] == -1) {
            coldfs(order[i], k++);
        }
    }
    gc.resize(k);
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            if (c[i] != c[j]) {
                gc[c[i]].insert(c[j]);
            }
        }
    }
    int mn = INF, id;
    for (int i = 0; i < k; i++) {
        if (sz[i] < mn) {
            mn = sz[i];
            id = i;
        }
    }
    cout << mn << endl;
    for (int i : comp[id]) {
        cout << i + 1 << " ";
    }
    return 0;
}
