#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;


const int INF = 1e9;
map <pair <int, int>, set <int> > d;


void f(int pos, int neg, int x, int i) {
    if (i == 14) {
        d[{pos, neg}].insert(x);
        return;
    }
    if (i < 7) {
        f(pos | (1 << i), neg, x, i + 1);
        f(pos | (1 << i), neg, x + (1 << i), i + 1);
    }
    else {
        f(pos, neg | (1 << (i - 8)), x, i + 1);
        f(pos, neg | (1 << (i - 8)), x - (1 << (i - 7)), i + 1);
    }
    f(pos, neg, x, i + 1);
}

int main()
{
    vector <int> cnt(512);
    for (int i = 0; i < 512; i++) {
        for (int j = 0; j < 9; j++) {
            cnt[i] += (bool)(i & (1 << j));
        }
    }
    f(0, 0, 0, 0);
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int mn = INF;
    pair <int, int> ans;
    for (int pos = 0; pos < 128; pos++) {
        for (int neg = 0; neg < 128; neg++) {
            bool f = true;
            for (int j = 0; j < n; j++) {
                if (!d[{pos, neg}].count(a[j])) {
                    f = false;
                    break;
                }
            }
            if (f && cnt[pos] + cnt[neg] < mn) {
                mn = cnt[pos] + cnt[neg];
                ans = {pos, neg};
            }
        }
    }
    cout << mn << endl;
    for (int i = 0; i < 9; i++) {
        if (ans.first & (1 << i)) {
            cout << (1 << i) << " ";
        }
    }
    for (int i = 0; i < 9; i++) {
        if (ans.second & (1 << i)) {
            cout << -(1 << i) << " ";
        }
    }
    return 0;
}
