
#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define int int64_t
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

int get(vector <int> arr, int d, int b) {
    int n = arr.size();
    vector <int> pref(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + arr[i];
    int l = -2, r = n + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        bool flag = true;
        for (int i = m; i < n; ++i) {
            int rr = min(n - 1, i + i * d + d - 1);
            if (pref[rr + 1] < (i - m + 1) * b) {
                flag = false;
                break;
            }
        }
        if (flag) {
            r = m;
        }
        else {
            l = m;
        }
    }
    return r;
}

signed main()
{
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector <int> arr(n);
    cin >> arr;
    vector <int> pref(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + arr[i];
    if (p == 1) {
        cout << get(arr, d, b) << endl;
    }
    else {
        auto arr2 = arr;
        reverse(arr2.begin(), arr2.end());
        int ans = get(arr, d, b) + get(arr2, d, b);
        assert(ans < n);
        cout << get(arr, d, b) + get(arr2, d, b) << endl;
    }
    return 0;
}
