#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

const int MAXN = 10;

bitset <2 * MAXN + 1> ch;

vector <int> pos;

void fill() {
    pos.resize(4);
    pos[pos.size() / 2] = 0;
    for (int i = 1; i <= pos.size() / 2; ++i) {
        pos[pos.size() / 2 + i] = (1 << i);
        pos[pos.size() / 2 - i] = -(1 << i);
    }
}

vector <int> now;

bool broot(int k, int m, bitset <2 * MAXN + 1> & can) {
    if (k == m) {
        //for (int i = 0; i < 2 * MAXN + 1; ++i) {
        //    cout << can[i] << " ";
        //}
        //cout << endl;
        //cout << endl;
        if ((ch | can) == can) {
            return true;
        }
        return false;
    }
    bitset <2 * MAXN + 1> neww;
    for (int i = 0; i < pos.size(); ++i) {
        neww &= 0;
        neww |= can;
        if (pos[i] > 0) {
            neww |= (can << pos[i]);
        }
        else if (pos[i] < 0) {
            neww |= (can >> (-pos[i]));
        }
        if (broot(k + 1, m, neww)) {
            return true;
        }
    }
    return false;
}

void broot_for_ans(int k, int m, bitset <2 * MAXN + 1> & can) {
    if (k == m) {
        if ((ch | can) == can) {
            cout << m << endl;
            cout << now << endl;
            exit(0);
        }
        return;
    }
    bitset <2 * MAXN + 1> neww;
    for (int i = 0; i < pos.size(); ++i) {
        if (pos[i] == 0) {
            neww = can;
        }
        else if (pos[i] > 0) {
            neww = can | (can << pos[i]);
        }
        else {
            neww = can | (can >> -pos[i]);
        }
        now[k] = pos[i];
        broot_for_ans(k + 1, m, neww);
    }
}

signed main()
{
    fill();

    int n;
    cin >> n;
    //cout << "kek" << endl;
    for (int i = 0; i < n; ++i) {
        int a;
        //cout << "lol" << endl;
        cin >> a;
        ch[a + MAXN] = 1;
    }
    //cout << "ch = ";

    //for (int i = 0; i < 2 * MAXN + 1; ++i)
    //    cout << ch[i] << " ";
    //cout << endl;
    bitset <2 * MAXN + 1> can;
    int l = -1, r = 4;
    while (r - l > 1) {
        int m = (r + l) / 2;
        can &= 0;
        can[MAXN] = 1;
        if (broot(0, m, can))
            r = m;
        else
            l = m;
    }
    can &= 0;
    can[MAXN] = 1;
    now.resize(r);
    //cout << "r = " << r << endl;
    broot_for_ans(0, r, can);
    return 0;
}
