#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << p.fi << " " << p.se;
    out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

const int MAXN = 10;

vector <bool> ch(2 * MAXN + 1);

vector <int> pos;

void fill() {
    pos.resize(10);
    pos[pos.size() / 2] = 0;
    for (int i = 1; i <= pos.size() / 2; ++i) {
        pos[pos.size() / 2 + i] = (1 << i);
        pos[pos.size() / 2 - i] = -(1 << i);
    }
}

vector <int> now;

bool broot(int k, int m, vector <bool> & can) {
    //cout << "k, m = " << k << " " << m << endl;
    if (k == m) {
        for (int i = 0; i < 2 * MAXN + 1; ++i) {
            if (ch[i] && !can[i])
                return false;
        }
        return true;
    }
    vector <bool> neww(2 * MAXN + 1);
    for (int i = 0; i < pos.size(); ++i) {
        for (int j = 0; j < 2 * MAXN + 1; ++j) {
            neww[j] = can[j];
            if (j - pos[i] <= 2 * MAXN && j - pos[i] >= 0 && can[j - pos[i]])
                neww[j] = true;
        }
        if (broot(k + 1, m, neww))
            return true;
    }
    return false;
}

void broot_for_ans(int k, int m, vector <bool> & can) {
    //cout << "k = " << k << endl;
    if (k == m) {
        for (int i = 0; i < 2 * MAXN + 1; ++i) {
            if (ch[i] && !can[i])
                return;
        }
        cout << m << endl;
        cout << now << endl;
        return;
    }
    vector <bool> neww(2 * MAXN + 1);
    for (int i = 0; i < pos.size(); ++i) {
        for (int j = 0; j < 2 * MAXN + 1; ++j) {
            neww[j] = can[j];
            if (j - pos[i] <= 2 * MAXN && j - pos[i] >= 0 && can[i - pos[i]])
                neww[j] = true;
        }
        broot_for_ans(k + 1, m, neww);
    }
}

signed main()
{
    fill();

    int n = 1;
    for (int i = 0; i < n; ++i) {
        int a = 9;
        ch[a + MAXN] = true;
    }
    //cout << "kek" << endl;
    int l = -1, r = 4;
    while (r - l > 1) {
        int m = (r + l) / 2;

        //cout << "m = " << m << endl;
        vector <bool> can(2 * MAXN + 1);
        can[MAXN] = true;
        if (broot(0, m, can))
            r = m;
        else
            l = m;
    }
    vector <bool> can(2 * MAXN + 1);
    can[MAXN] = true;
    now.resize(r);
    //cout << "r = " << r << endl;
    broot_for_ans(0, r, can);
    return 0;
}
