#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define kektor vector
#define kektorov vector
#define all(a) a.begin(), a.end()

/*
  :

  :
-   ?
- ,    

 -     ,
         ,
   !   !

- ,  
-    ?

-     ?
- " "?
- " ".

    ,
   .
 ,   
   .
*/

using namespace std;

struct node{
    int u = 0;
    int nom = 0;
    vector<int> go;
};

vector<node> v;
vector<bool> used;
vector<int> dist;

vector<int> ans;
int kol = 1e9 + 1000;

void dfs(int i) {
    used[i] = true;
    for (int j = 0; j < v[i].go.size(); ++j) {
        int u = v[i].go[j];
        if (!used[u]) {
            dfs(u);
        }
        dist[i] = max(dist[i], dist[u]);
    }
    dist[i]++;
}

void dfs1(int i) {
    ans.push_back(v[i].nom);
    //cout << "--> " << v[i].nom << endl;
    used[i] = true;
    for (int j = 0; j < v[i].go.size(); ++j) {
        int u = v[i].go[j];
        //cout << "-> " << u << endl;
        if (!used[u]) {
            dfs1(u);
        }
    }
}

void main60() {
    int n, m, h;
    cin >> n >> m >> h;
    v.resize(n);
    used.resize(n);
    dist.resize(n);
    vector<pair<int, int>> a(n);
    vector<vector<int>> g(n, vector<int> (n, 0));
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(all(a));
    for (int i = 0; i < m; ++i) {
        int u1, u2;
        cin >> u1 >> u2;
        u1--; u2--;
        g[u1][u2] = 1;
        g[u2][u1] = 1;
    }
    for (int i = 0; i < n; ++i) {
        v[i].u = a[i].first;
        v[i].nom = a[i].second + 1;
        int j = 0;
        if (v[i].u == h-1)
            j = 0;
        while (j < n && a[j].first <= (a[i].first + 1) % h) {
            if (a[j].first == (a[i].first + 1) % h) {
                v[i].go.push_back(j);
            }
            j++;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (v[i].go.empty()) {
            cout << 1 << endl << v[i].nom;
            return;
        }
    }

    int vert = 0;
    for (int i = 0; i < n; ++i) {
        dist.clear();
        used.clear();
        dist.resize(n, 0);
        used.resize(n, false);
        dfs(i);
        if (dist[i] < kol) {
            kol = dist[i];
            vert = i;
        }
    }
    used.clear();
    used.resize(n, false);
    dfs1(vert);
    cout << kol << endl;
    for (int i = 0; i < kol; ++i) {
        cout << ans[i] << " ";
    }
}

int main()
{
    main60();
    return 0;
}
