#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> u(n);
    for (int i = 0; i < n; i++) {
        cin >> u[i];
    }
    vector<vector<int> > g(n);
    int x, y;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
          x--;
          y--;
        if ((u[x] + 1) % h == u[y]) {
            g[x].push_back(y);
        }
        else if ((u[y] + 1) % h == u[x]) {
            g[y].push_back(x);
        }
    }
    bool flag = true;
    for (int i = 0; i < n && flag; i++) {
        if (g[i].size() == 0) {
            flag = false;
            cout << 1 << endl << i + 1;
        }
    }
    if (flag) {
        vector<bool> used(n, false);
        queue<int> q;
        vector<int> pr(n);
        vector<int> c;
        used[0] = true;
        q.push(0);
        while(!q.empty() && flag) {
            x = q.front();
            used[x] = true;
            q.pop();
            for (int j = 0; j < g[x].size() && flag; j++) {
                y = g[x][j];
                if (!used[y]) {
                    pr[y] = x;
                    q.push(y);
                }
                else {
                    flag = false;
                    c.push_back(y);
                    while (x != y) {
                        c.push_back(x);
                        x = pr[x];
                    }
                }
            }
        }
        cout << c.size() << endl;
        for (int i = 0; i < c.size(); i++) {
            cout << c[i] + 1 << " ";
        }
    }
    return 0;
}
