#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<iostream>
#include<vector>
#include<unordered_set>
#include<unordered_map>
#include<set>
#include<map>
#include<algorithm>
#include<string>
#include<cmath>
#include<ctime>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const ld e = 1e-7;
const ll mod = 1e9 + 7;

const ll N = 100005;

ll n, m, k;
ll a[N];

void dfs1(ll v, vector<vector<ll> >& g, vector<ll>& used, vector<ll>& order) {
	used[v] = 1;
	for (int i = 0; i < g[v].size(); ++i)
		if (!used[g[v][i]])
			dfs1(g[v][i], g, used, order);
	order.push_back(v);
}

void dfs2(ll v, ll col, vector<vector<ll> >& g, vector<ll>& used, vector<ll>& color) {
	used[v] = 1;
	for (int i = 0; i < g[v].size(); ++i)
		if (!used[g[v][i]])
			dfs2(g[v][i], col, g, used, color);
	color[v] = col;
}

int main() {
	ios_base::sync_with_stdio(false);

	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<ll> > g(n), gt(n), gc;
	for (int i = 0; i < m; ++i) {
		ll x, y;
		cin >> x >> y;
		--x, --y;
		if ((a[x] + 1) % k == a[y]) {
			g[x].push_back(y);
			gt[y].push_back(x);
		}
		if ((a[y] + 1) % k == a[x]) {
			g[y].push_back(x);
			gt[x].push_back(y);
		}
	}

	ll c = 0, ans = INF, ans_c = INF;
	vector<ll> order, used(n), color(n), cnt;
	for(int i = 0; i < n; ++i)
		if (!used[i]) {
			dfs1(i, g, used, order);
		}
	reverse(order.begin(), order.end());
	used.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (!used[order[i]]) {
			dfs2(order[i], c, gt, used, color);
			++c;
		}
	}
	cnt.resize(c);
	gc.resize(c);
	for (int i = 0; i < n; ++i) {
		++cnt[color[i]];
		for (int j = 0; j < g[i].size(); ++j) {
			if (color[i] != color[g[i][j]])
				gc[color[i]].push_back(color[g[i][j]]);
		}
	}
	for(int i = 0; i < c; ++i){
		if (gc[i].size() == 0 && ans > cnt[i]) {
			ans = cnt[i];
			ans_c = i;
		}
	}
	cout << ans << '\n';
	for (int i = 0; i < n; ++i) {
		if (color[i] == ans_c)
			cout << i + 1 << ' ';
	}
	return 0;
}