#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef int ll;
typedef double dl;

ll maxp = 9;

ll sign(ll a)
{
	if (a > 0)
		return 1ll;

	if (a < 0)
		return -1ll;

	return 0;
}

void getp(ll val, vector<ll> &used)
{
	vector<ll> v;

	while (val > 0)
	{
		v.push_back(val % 2);
		val /= 2;
	}

	reverse(v.begin(), v.end());

	ll p = 0;

	for (ll i = v.size() - 1ll; i >= 0; --i)
	{
		used[p] += v[i];
		++p;
	}
}

void pls(vector<ll> &vec, ll mod = 3)
{
	ll ost = 1ll;

	for (ll i = vec.size() - 1ll; i >= 0; --i)
	{
		vec[i] += ost;
		ost = 0;

		if (vec[i] >= mod)
		{
			vec[i] = 0;
			ost = 1ll;
		}
	}
}

int main()
{
    freopen("inputD.txt", "r", stdin);
    //freopen("outputD.txt", "w", stdout);

	
	ll n;
	scanf("%d", &n);

	vector<ll> a(n);

	vector<vector<vector<ll>>> amsk(n);

	for (ll i = 0; i < n; ++i)
	{
		//cin >> a[i];
		scanf("%d", &a[i]);

		vector<ll> msk(maxp, 0);

		for (ll iter = 0; iter < pow(3, maxp); ++iter)
		{
			ll val = 0;
			
			vector<ll> curans;
			for (ll j = 0; j < msk.size(); ++j)
			{
				if (msk[j] == 1ll)
				{
					val += (1ll << j);
					curans.push_back(1ll << j);
				}
				else if (msk[j] == 2)
				{
					val -= (1ll << j);
					curans.push_back(- (1ll << j));
				}
			}

			if (val == a[i])
			{
				amsk[i].push_back(curans);
			}

			pls(msk);
		}
	}

	vector<ll> msk(maxp, 0);
	vector<ll> ans;
	ll change = 0;

	for (ll iter = 0; iter < pow(4, maxp); ++iter)
	{
		vector<ll> bufer;
		for (ll j = 0; j < msk.size(); ++j)
		{
			if (msk[j] == 1ll)
			{
				bufer.push_back(1ll << j);
			}
			else if (msk[j] == 2)
			{
				bufer.push_back(-(1ll << j));
			}
			else if (msk[j] == 3)
			{
				bufer.push_back(-(1ll << j));
				bufer.push_back((1ll << j));
			}
		}

		sort(bufer.begin(), bufer.end());
		
		ll satis = 1ll;
		for (ll i = 0; i < n; ++i)
		{
			ll may = 0;

			for (ll j = 0; j < amsk[i].size(); ++j)
			{
				ll pod = 1ll;

				for (ll val : amsk[i][j])
				{
					if (!binary_search(bufer.begin(), bufer.end(), val))
					{
						pod = 0;
					}
				}

				if (pod)
				{
					may = 1ll;
					break;
				}
			}

			if (!may)
			{
				satis = 0;
				break;
			}
		}

		if (satis && (bufer.size() < ans.size() || change == 0))
		{
			ans = bufer;
			change = 1ll;
		}

		pls(msk, 4);
	}

	
	//cout << ans.size() << endl;
	printf("%d\n", (int)ans.size());

	for (ll i = 0; i < ans.size(); ++i)
	{
		//cout << ans[i]  << " ";
		printf("%d ", (int)ans[i]);
	}
	
	puts("");
    return 0;
}