#include<iostream>
#include<vector>

using namespace std;

void dfs(int curr, vector<vector<int>> &gr, vector<int> &ans, vector<bool> &used) 
{
	if (used[curr]) return;
	used[curr] = true;
	ans.push_back(curr);
	for (int i = 0; i < gr[curr].size(); i++)
	{
		dfs(gr[curr][i], gr, ans, used);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, h;
	cin >> n >> m >> h;

	vector<int> u(n);

	for (int i = 0; i < n; i++)
	{
		cin >> u[i];
	}

	vector<vector<int>> gr(n);

	int c1, c2;
	for (int i = 0; i < m; i++) {
		cin >> c1 >> c2;
		c1--; c2--;
		if ((u[c1] + 1)%h == u[c2])
		{
			gr[c1].push_back(c2);
		}
		if ((u[c2] + 1) % h == u[c1])
		{
			gr[c2].push_back(c1);
		}
	}

	vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		vector<int> res;
		vector<bool> used(n, false);
		dfs(i, gr, res, used);
		if (ans.size() > res.size() || ans.empty()) {
			ans = res;
		}
	}

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << '\n';

	//cout << "Hi\n";

	//system("pause");
	return 0;
}