#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

const int MAXDEPTH = 5;
const int MAXDELTA = 5;

vector<int> ans;

void rec(int curlev, int summ, int ask, vector<int> &curr) {
	if (curlev == MAXDEPTH) {
		if (ask == summ &&(curr.size() < ans.size() || ans.empty())) {
			ans = curr;
		}
		return;
	}

	for (int i = 0; i < MAXDELTA; i++) {
		summ -= pow(2, curlev);
		curr.push_back(-pow(2, curlev));
	}

	for (int i = 0; i < MAXDELTA; i++) {
		rec(curlev + 1, summ, ask, curr);
		summ += pow(2, curlev);
		curr.pop_back();
	}

	for (int i = 0; i < MAXDELTA; i++) {
		summ += pow(2, curlev);
		curr.push_back(pow(2, curlev));
	}

	for (int i = 0; i < MAXDELTA; i++) {
		rec(curlev + 1, summ, ask, curr);
		summ -= pow(2, curlev);
		curr.pop_back();
	}
	rec(curlev + 1, summ, ask, curr);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;

	vector<int> result;

	for (int i = 0; i < n; i++) {
		int val;
		cin >> val;
		ans.clear();
		vector<int> curr;
		rec(0, 0, val, curr);
		for (int j = 0; j < ans.size(); j++) {
			result.push_back(ans[j]);
		}
	}
	
	cout << result.size() << '\n';
	for (int i = 0; i < result.size(); i++) {
		cout << result[i] << ' ';
	}
	cout << '\n';

	//system("pause");
	return 0;
}