#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <utility>
#include <sstream>
using namespace std;
typedef long long ll;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define fors(i, s, n) for (int (i) = (s); (i) < (n); (i)++)
#define all(v) v.begin(), v.end()

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    int n = s.size();
    vector<int> a(n);
    set<int> one;
    set<int> zero;
    forn(i, n) {
        a[i] = s[i] == '1';
    }
    forn(i, n) {
        if (a[i]) {
            one.insert(i);
        }
        else {
            zero.insert(i);
        }
    }
    vector<bool> used(n);
    bool good = true;
    vector<vector<int>> answ;
    forn(i, n) {
        if (!used[i]) {
            if (a[i]) {
                good = false;
                break;
            }
            int p = i;
            used[i] = 1;
            zero.erase(i);
            answ.push_back(vector<int>());
            answ.back().push_back(i);
            while (p < n) {
                auto o = upper_bound(all(one), p);
                if (o == one.end()) break;
                int ov = *o;
                auto z = upper_bound(all(zero), ov);
                if (z == zero.end()) break;
                int zv = *z;
                used[ov] = 1;
                used[zv] = 1;
                answ.back().push_back(ov);
                answ.back().push_back(zv);
                one.erase(o);
                zero.erase(z);
                p = zv;
            }
        }
    }
    if (!good) {
        cout << -1 << endl;
    }
    else {
        cout << answ.size() << endl;
        forn(i, answ.size()) {
            cout << answ[i].size() << " ";
            forn(j, answ[i].size()) {
                cout << answ[i][j] + 1 << " ";
            }
            cout << endl;
        }
    }
#ifdef _MSC_VER
    system("pause");
#endif
    return 0;
}