#include <bits/stdc++.h>

using namespace std;

using int32 = int_fast32_t;
using uint32 = uint_fast32_t;
using int64 = int_fast64_t;
using uint64 = uint_fast64_t;


template <typename T>
istream & operator >> (istream & in, vector<T> & v)
{
    for (uint32 i = 0; i < v.size(); ++i)
    {
        in >> v[i];
    }
    return in;
}

int main()
{
    ifstream cin("input.txt");

    uint32 n = 0;
    uint32 m = 0;
    uint32 h = 0;
    cin >> n >> m >> h;

    vector<uint32> t(n + 1);
    for (uint32 i = 1; i <= n; ++i)
    {
        cin >> t[i];
    }

    vector<vector<uint32>> g(n + 1);
    for (uint32 i = 0; i < m; ++i)
    {
        uint32 w = 0;
        uint32 v = 0;
        cin >> w >> v;

        g[w].push_back(v);
        g[v].push_back(w);
    }

    uint32 cnt = n;
    vector<uint32> taken(n + 1, 1);

    vector<uint32> used(n + 1);
    uint32 iteration = 1;

    uint32 atc = 0;
    vector<uint32> at(n + 1, 0);

    function<void(uint32)> dfs = [&](uint32 u)
    {
        ++atc;
        at[u] = 1;
        used[u] = iteration;

        for (uint32 v : g[u])
        {
            if (used[v] != iteration && t[v] == (t[u] + 1) % h)
            {
                dfs(v);
            }
        }
    };

    for (; iteration <= n; ++iteration)
    {
        atc = 0;
        at = vector<uint32>(n + 1, 0);
        dfs(iteration);
        if (atc < cnt)
        {
            cnt = atc;
            taken = at;
        }
    }

    cout << cnt << '\n';
    for (uint32 i = 1; i <= n; ++i)
    {
        if (taken[i])
        {
            cout << i << ' ';
        }
    }

    return 0;
}