#include <bits/stdc++.h>

using namespace std;

using int32 = int_fast32_t;
using uint32 = uint_fast32_t;
using int64 = int_fast64_t;
using uint64 = uint_fast64_t;


template <typename T>
istream & operator >> (istream & in, vector<T> & v)
{
    for (uint32 i = 0; i < v.size(); ++i)
    {
        in >> v[i];
    }
    return in;
}

int main()
{
    ifstream cin("input.txt");

    uint32 n = 0;
    cin >> n;

    vector<int32> a(n);
    cin >> a;

    static const uint32 size = 50;
    vector<int32> p2;
    {
        int32 p = 1;
        while (p < 10)
        {
            p2.push_back(p);
            p2.push_back(-p);
            p <<= 1;
        }
    }
    uint32 m = p2.size();

    uint32 mm = 0;
    uint32 mc = numeric_limits<uint32>::max();

    for (uint32 mask = 0; mask < (1u << m); ++mask)
    {
        bitset<2 * size> pos;
        pos.set(size);
        uint32 cnt = 0;
        for (uint32 j = 0; j < m; ++j)
        {
            if (mask & (1 << j))
            {
                ++cnt;
                if (p2[j] > 0)
                {
                    pos |= pos << p2[j];
                }
                else
                {
                    pos = pos >> (-p2[j]);
                }
            }
        }

//        for (uint32 i = 0; i < 2 * size; ++i)
//        {
//            cout << pos.test(i) ? 1 : 0;
//        }
//        cout << endl;

        bool all = true;
        for (uint32 i = 0; i < n; ++i)
        {
            if (!pos.test(size + a[i]))
            {
                all = false;
                break;
            }
        }

        if (all)
        {
            if (cnt < mc)
            {
                mc = cnt;
                mm = mask;
            }
        }
    }

    cout << mc << '\n';
    for (uint32 j = 0; j < m; ++j)
    {
        if (mm & (1 << j))
        {
            cout << p2[j] << ' ';
        }
    }


    return 0;
}