#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<set<int> > g;
vector<int> p;
vector<int> used;
int n, m, h;

int free(int u, vector<int> &comp) { // 0 -   1 -    ,  - 
    used[u] = 1;
    comp.push_back(u);
    int t, mt=0;
    bool nxt = 0;
    vector<int> q;
    for(auto v : g[u]) {
        if(p[v] == (p[u]+1)%h) {
            nxt = 1;
            if(used[v] == 0) {
                t = free(v, comp);
                if(t < 0) return t;
                if(t == 0) mt = t;
            }
            else if(used[v] == 1) return 0;
        }
        else if(p[v] == p[u])
            q.push_back(v);
        else if(!nxt)
            mt = -u;
    }
    for(auto v : q)
        if(!used[v])
            free(v, comp);
    used[u] = 2;
    return mt;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> h;

    p.resize(n+1);
    for(int i=1; i<=n; i++)
        cin >> p[i];
    g.resize(n+1, set<int>());
    used.resize(n+1);
    for(int i=0; i<m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].insert(y);
        g[y].insert(x);
    }
    vector<int> ans;
    for(int i=1; i<=n; i++) {
        if(used[i]) continue;
        vector<int> comp;
        int t = free(i, comp);
        if(t < 0) {
            cout << 1 << "\n" << -t;
            return 0;
        }
        else if(t == 0 and ans.size() == 0) {
            ans = comp;
        }
    }
    cout << ans.size() << "\n";
    for(auto v : ans)
        cout << v << " ";
    return 0;
}
