#include<bits/stdc++.h>
#define int long long
#define s second
#define f first
using namespace std;
map<pair<int, int>, bool> rb;
map<pair<int, int>, bool> color;
vector< vector<int> > gr;
vector<int> used;
vector<int> dsu, siz, kek;
vector<pair<int, int> > dan;
map<int, bool> not_ans;
int k;
int f_p(int v) {
    if(dsu[v] == v) {
        return v;
    }
    return dsu[v] = f_p(dsu[v]);
}

int union_sets(int a, int b) {
    a = f_p(a);
    b = f_p(b);
    if(siz[b] > siz[a]) {
        swap(a, b);
    }
    if(a != b) {
        dsu[b] = a;
        siz[a] += siz[b];
    }
    return a;
}

bool update(int v, int val) {
    bool fl = 0;
    for(auto u: gr[v]) {
        if((val + 1) % k == kek[u]) {
            fl = 1;
            u = f_p(u);
            int tmp = f_p(v);
            if(siz[u] == 1)
                union_sets(u, v);
            else {
                color[{tmp, u}] = 1;
                not_ans[v] = 1;
                if(color[{u, tmp}]) {
                    union_sets(u, tmp);
                    not_ans[v] = 0;
                    not_ans[u] = 0;
                }
            }
        }
    }
    return fl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m >> k;
    dan.resize(n);
    used.resize(n, 0);
    gr.resize(n);
    dsu.resize(n);
    siz.resize(n, 1);
    kek.resize(n);
    for(int i = 0; i < n; i++) {
        dsu[i] = i;
    }
    for(int i = 0; i < n; i++) {
        int a;
        cin >> kek[i];
        dan[i] = {kek[i], i};
    }
    sort(dan.begin(), dan.end());
    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if(!rb[{a, b}]) {
            gr[a].push_back(b);
            gr[b].push_back(a);
            rb[{a, b}] = 1;
            rb[{b, a}] = 1;
        }
    }
    for(int i = 0; i < n; i++) {
        if(!update(dan[i].s, dan[i].f)) {
            cout << 1 << "\n";
            cout << dan[i].s + 1 << "\n";
            return 0;
        }
    }
    int minn = 1e9 + 7, ind = -1;
    for(int i = 0; i < n; i++) {
        if(siz[f_p(i)] < minn && !not_ans[f_p(i)]) {
            ind = f_p(i);
            minn = siz[f_p(i)];
        }
    }
    cout << minn << "\n";
    for(int i = 0; i < n; i++) {
        if(f_p(i) == ind) {
            cout << i + 1 << " ";
        }
    }
    return 0;
}
