#include <map>
#include <set>
#include <list>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <cassert>
#include <climits>
#include <complex>
#include <cstdlib>
#include <iomanip>
#include <numeric>
#include <iostream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using namespace chrono;

inline bool hbit(int a, int bit) {
	return (a >> bit) & 1;
}

inline int check(int n, int a, int b) {
	for (int c = a; 42; c--, c &= a) {
		int d = n + c;
		if (d >= 0 && (d | b) == b) {
			return true;
		}
		if (c == 0) {
			break;
		}
	}
	return false;
}

int main() {
	#ifdef DEBUG
		stdin = freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	
	int n; cin >> n;
	vector<int> v(n);
	int mabs = 0;
	for (int i = 0; i < n; i++) {
		cin >> v[i];
		mabs = max(mabs, abs(v[i]));
	}
	int l = 0;
	while (mabs >= (1 << l)) {
		l++;
	}
	l++;
	
	int best = INT_MAX;
	int bi = -1, bj = -1;
	
	for (int i = 0; i < (1 << l); i++) {
		for (int j = 0; j < (1 << l); j++) {
			bool ok = true;
			for (int k = 0; k < n; k++) {
				if (!check(v[k], i, j)) {
					ok = false;
					break;
				}
			}
			if (ok) {
				int val = __builtin_popcount(i) + __builtin_popcount(j);
				if (val < best) {
					best = val;
					bi = i;
					bj = j;
				}
			}
		}
	}
	
	cout << best << endl;
	for (int i = 0; i < l; i++) {
		if (hbit(bi, i)) {
			cout << -(1 << i) << " ";
		}
		if (hbit(bj, i)) {
			cout << (1 << i) << " ";
		}
	}
	cout << endl;
	
	return 0;
}
