#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 100000 + 10;

vector < set <int> > g;
set <int> :: iterator it;
int n, m, h;

int u[MAXN];
pair <int, int> c[MAXN];

vector < pair <int, int> > edge;
vector <int> v;

vector <bool> flag;
vector <int> ans;

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        cin >> c[i].first >> c[i].second;
        c[i].first--; c[i].second--;
        g[c[i].first].insert(c[i].second);
        g[c[i].second].insert(c[i].first);
    }

    for (int i = 0; i < n; i++)
        for (it = g[i].begin(); it != g[i].end(); it++) {
            edge.push_back(make_pair(u[i], u[*it]));
            v.push_back(i);
        }
/*
    cout << edge.size() << endl;
    for (size_t i = 0; i < edge.size(); i++)
        cout << i << " : " << v[i] << " ||| " << edge[i].first << " " << edge[i].second << endl;
*/
    flag.assign(n, true);
    for (size_t i = 0; i < edge.size(); i++) {
        if (!flag[v[i]]) continue;
        if ((edge[i].first + 1) % h == edge[i].second)
            flag[v[i]] = false;
    }
/*
    for (int i = 0; i < n; i++)
        cout << flag[i] << " ";
    cout << endl;
*/
    for (int i = 0; i < n; i++)
        if (flag[i])
            ans.push_back(i + 1);

    if (ans.empty()) {
        for (int i = 0; i < n; i++)
            ans.push_back(i + 1);
    }

    cout << ans.size() << "\n";
    for (size_t i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";
    cout << endl;

    return 0;
}
