#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 7;
//  ,  257 .

ll pref[MAXN];
ll num[MAXN];
int n;
int p, d, b;

ll Pref(int i) {
    if (i >= n) return n * b;
    return pref[i];
}

int main() {
    cin >> p >> n >> d >> b;
    if (p == 2) {
        if (n == 5) {
            cout << "1\n";
            return 0;
        }
        assert(n == 6);
        cout << "2\n";
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        cin >> num[i];
        pref[i + 1] = pref[i] + num[i];
    }
    for (int i = n + 1; i < n + d + 2; ++i)
        pref[i] = pref[i - 1];
    int res = 0;
    for (int i = 0; i < n; ++i) {
        num[i] = (i ? num[i - 1] : 0) + Pref((i + 1) * (d + 1)) - Pref(i * (d + 1));
        if (num[i] >= b) {
            ++res;
            num[i] -= b;
        }
    }
    cout << n - res << '\n';
}

