#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <bitset>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 1e3;
const int MAXL = 8;

int num[MAXN];

bool GetBit(int n, int i) {
    return (n >> i) & 1;
}

int d[2 * MAXN];
int t = 0;

void IsGood(int mask) {
    d[MAXN] = t;
    for (int ma = mask; ma; ma = (ma - 1) & mask) {
        int sum = 0;
        for (int i = 0; i < MAXL; ++i) {
            if (GetBit(ma, i))
                sum += 1 << i;
            if (GetBit(ma, i + MAXL))
                sum -= 1 << i;
        }
        d[sum + MAXN] = t;
    }
}

int Sum(int n) {
    int res = 0;
    for (int i = 0; i < 2 * MAXL; ++i) {
        res += GetBit(n, i);
    }
    return res;
}

int main() {
    int n;
    cin >> n;
    bool q = 0;
    for (int i = 0; i < n; ++i) {
        cin >> num[i];
        q |= num[i];
    }
    if (!q) {
        cout << "0\n";
        return 0;
    }
    int ans = -1;
    for (int mask = 0; mask < (1 << 2 * MAXL); ++mask) {
        if (Sum(mask) >= Sum(ans)) continue;
        ++t;
        IsGood(mask);
        bool cool = 1;
        for (int i = 0; i < n; ++i) {
            if (d[num[i] + MAXN] != t) {
                cool = 0;
                break;
            }
        }
        if (cool)
            ans = mask;
    }
    cout << Sum(ans) << '\n';
    for (int i = 0; i < MAXL; ++i) {
        if (GetBit(ans, i))
            cout << (1 << i) << ' ';
        if (GetBit(ans, i + MAXL))
            cout << -(1 << i) << ' ';
    }
    cout << '\n';
}

