#include <algorithm>
#include <cassert>
#include <fstream>
#include <utility>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 7;

vector<int> ans[MAXN];
set<int> wait[2];
int sz = 0;

int main() {
    string s;
    cin >> s;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        int c = s[i] - '0';
        if (wait[c].size() == 0) {
            if (c) {
                cout << "-1\n";
                return 0;
            } else {
                wait[c].insert(sz);
                ++sz;
            }
        }
        int j = *wait[c].begin();
        wait[c].erase(wait[c].begin());
        ans[j].push_back(i);
        wait[1 - c].insert(j);
    }
    if (wait[0].size()) {
        cout << "-1\n";
        return 0;
    }
    cout << sz << '\n';
    for (int i = 0; i < sz; ++i) {
        cout << ans[i].size() << ' ';
        for (int j : ans[i]) {
            cout << j + 1 << ' ';
        }
        cout << '\n';
    }
}

