#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fr first
#define sc second
#define pb push_back
#ifdef TDEF
#define __int128 ll
#endif

const int inf = 1e9 + 88;
const ll infll = 1e18 + 88;
const ld eps = 1e-9;

bool ldeq(ld a, ld b){return fabs(a - b) < eps;}

const int maxn = 2e5 + 88;

int n, m, h;
int u[maxn];
vector<int> g[maxn];

void solve()
{
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((u[a] + 1) % h == u[b])
        {
            g[a].pb(b);
        }
        if ((u[b] + 1) % h == u[a])
        {
            g[b].pb(a);
        }
    }
    vector<int> mn;
    for (int i = 0; i < n; i++)
        if (g[i].size() == 0)
            mn.pb(i + 1);
    if (mn.size() == 0)
    {
        cout << n << endl;
        for (int i = 0; i < n; i++)
            cout << i + 1 << " ";
    }
    else
    {
        cout << mn.size() << endl;
        for (int i = 0; i < mn.size(); i++)
            cout << mn[i] << " ";
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
