#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

const int N = 100100;
const int MX = 2010;

int p, n, d, b;
vector<int> all[N];
vector<int> add[N];
vector<int> del[N];
int a[N], copy_a[N];
int l[N], r[N];

void solve1() {
  int l = 0;
  for (int i = 0; i < n; i++) {
    int l = 0;
    int cur = i - d;
    for (int j = 17; j >= 0; j--) {
      if (l + (1 << j) < cur - d * (1 << j)){
        l += (1 << j);
        cur -= d * (1 << j);
      }
    }
    if (l < cur) l++;
    all[l].pb(a[i]);
  }
  int cur = 0;
  int ans = 0;
  for (int i = 0; i < n; i++) {
    for (auto it : all[i])
      cur += it;
    if (cur >= b) {
      cur -= b;
      ans++;
    }
  }
  cout << n - ans << endl;
}

bool check(int mid){
  int cntL = (n + 1) / 2 - mid;
  cntL = max(cntL, 0);
  int cntR = n / 2 - mid;
  cntR = max(cntR, 0);
  for (int i = 0; i < n; i++) a[i] = copy_a[i];
  set<int> st;
  int sum = 0;
  for (int i = 0; i < n; i++){
    for (auto it : add[i]){
      sum += a[it];
      st.insert(it);
    }
    for (auto it : del[i]){
      if (st.find(it) != st.end()){
        sum -= a[it];
        st.erase(it);
      }
    }
//    if (mid == 1){
//      cout << sum << endl;
//    }
    if (i < (n + 1) / 2){
      if (cntL == 0) continue;
      if (sum < b) continue;
      int cur = b;
      while (cur > 0){
        auto it = *st.begin();
        if (a[it] <= cur){
          cur -= a[it];
          sum -= a[it];
          a[it] = 0;
          st.erase(st.begin());
        } else {
          sum -= cur;
          a[it] -= cur;
          cur = 0;
        }
      }
      cntL--;
    } else {
      if (cntR == 0) continue;
      if (sum < b) continue;
      int cur = b;
      while (cur > 0){
        auto it = *st.begin();
        if (a[it] <= cur){
          cur -= a[it];
          sum -= a[it];
          a[it] = 0;
          st.erase(st.begin());
        } else {
          sum -= cur;
          a[it] -= cur;
          cur = 0;
        }
      }
      cntR--;
    }
  }
  return cntL + cntR == 0;
}

void solve2() {
  for (int i = 0; i < n; i++) {
    int p = 0;
    int cur = i - d;
    for (int j = 17; j >= 0; j--) {
      if (p + (1 << j) < cur - d * (1 << j)){
        p += (1 << j);
        cur -= d * (1 << j);
      }
    }
    if (p < cur) p++;
    l[i] = p;
    r[n - i - 1] = n - p - 1;
  }
//  for (int i = 0; i < n; i++){
//    cout << l[i] + 1 << ' ' << r[i] + 1 << endl;
//  }
  for (int i = 0; i <= n; i++) add[i].clear();
  for (int i = 0; i <= n; i++) del[i].clear();
  for (int i = 0; i < n; i++){
    add[l[i]].pb(i);
    del[r[i] + 1].pb(i);
  }
  int l = 0, r = n;
  int ans = n;
  while (l <= r){
    int mid = (l + r) >> 1;
    if (check(mid)){
      ans = mid;
      r = mid - 1;
    } else {
      l = mid + 1;
    }
  }
  cout << ans << endl;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  cin >> p >> n >> d >> b;
  for (int i = 0; i < n; i++)
    cin >> a[i];
  for (int i = 0; i < n; i++) copy_a[i] = a[i];
  if (p == 1) {
    solve1();
  } else {
    solve2();
  }
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
