#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

const int N = 100100;
const int MX = 2010;

int a[N];
unordered_map<int, bitset<MX>> all;
bitset<MX> need;
map<int, int> used;
int n;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  all.reserve(20000);
  all.max_load_factor(0.25);
  cin >> n;
  int mx = 0;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    used[a[i]] = 1;
    mx = max(mx, abs(a[i]));
    need[a[i] + MX / 2] = 1;
  }
  int l = 0;
  while ((1 << l) < mx)
    l++;
  l += 2;
  if (mx == 0) {
    cout << 0 << endl;
    return 0;
  }
  vector<int> ans;
  int sz = 1e9;
  vector<int> mask(l);
  while (true) {
    int add = mx + 1;
    vector<int> dp(add + add + 3, 0);
    dp[add] = 1;
    int cnt = 0;
    for (int i = 0; i < l; i++) {
      if (mask[i] == 0)
        continue;
      cnt++;
      if (mask[i] == 1) {
        for (int j = dp.size() - 1; j >= 0; j--) {
          if (dp[j] && j + (1 << i) < dp.size())
            dp[j + (1 << i)] = 1;
        }
      } else {
        for (int j = 0; j < dp.size(); j++) {
          if (dp[j] && j - (1 << i) >= 0)
            dp[j - (1 << i)] = 1;
        }
      }
    }
    bool kek = true;
    for (int i = 0; i < n; i++) {
      if (dp[a[i] + add] == false) {
        kek = false;
      }
    }
    if (kek && cnt < sz) {
      sz = cnt;
      ans.clear();
      for (int i = 0; i < l; i++) {
        if (mask[i] == 0)
          continue;
        if (mask[i] == 1) {
          ans.pb(1 << i);
        } else {
          ans.pb(-(1 << i));
        }
      }
    }
    bool f = false;
    for (int i = 0; i < l; i++) {
      if (mask[i] < 2) {
        mask[i]++;
        for (int j = 0; j < i; j++)
          mask[j] = 0;
        f = true;
        break;
      }
    }
    if (!f)
      break;
  }
  cout << ans.size() << endl;
  for (auto it : ans)
    cout << it << ' ';
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
