#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define F first
#define S second
#define mt make_tuple
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

//template<typename T>
//inline void read(T &x){
//  x = 0;
//  bool _ = false;
//  char c = getchar();
//  while (c < '0' || c >= '9') _ |= (c == '-'), c = getchar();
//  while (c >= '0' && c <= '9'){
//    x *= 10;
//    x += c - '0';
//  }
//  if (_) x = -x;
//}

const int N = 100100;
const int MX = 6010;
const int ADD = MX / 2;

bitset<MX> need;
int st = 0;
int sz = 1e9;
vector<bool> used;
map<int, int> all;
int n;
int a[N];

vector<int> solve(int mask) {
  used.assign(st, 1);
  int del = 0;
  for (int i = 0; i < st; i++) {
    used[i] = 0;
    bitset<MX> cur;
    cur[ADD] = 1;
    for (int j = 0; j < st; j++) {
      if (used[j] == 0)
        continue;
      if (mask >> j & 1) {
        cur |= cur << (1 << j);
      } else {
        cur |= cur >> (1 << j);
      }
    }
    if ((cur & need).count() != n) {
      used[i] = 1;
      if (i == st - 1) {
        int j = st - 1;
        if (mask >> j & 1) {
          cur |= cur << (1 << j);
        } else {
          cur |= cur >> (1 << j);
        }
        if ((cur & need).count() != n){
          vector<int> ans;
          for (int i = 0; i <= st; i++) ans.pb(-1);
          return ans;
        }
      }
    } else {
      del++;
    }
    if (i + 1 - del > sz) {
      vector<int> ans;
      for (int i = 0; i <= sz; i++)
        ans.pb(-1);
      return ans;
    }
  }
  vector<int> ans;
  for (int i = 0; i < st; i++) {
    if (!used[i])
      continue;
    if (mask >> i & 1) {
      ans.pb(1 << i);
    } else {
      ans.pb(-(1 << i));
    }
  }
  return ans;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  cin >> n;
//  n = 5000;
  int mx = 0;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
//    a[i] = rand() % 6000 - 3000;
    mx = max(mx, abs(a[i]));
    all[a[i]] = 1;
    need[a[i] + ADD] = 1;
  }
  n = all.size();
  while ((1 << st) < mx)
    st++;
  st += 2;

//  st = 14;

  sz = 1e9;
  vector<int> ans;

  vector<int> all;
  for (int i = 0; i < (1 << st); i++){
    all.pb(i);
  }
  random_shuffle(all.begin(), all.end());

  for (auto i : all) {
//    cerr << i << endl;
    vector<int> cur = solve(i);
    if (cur.size() < sz) {
      sz = cur.size();
      ans = cur;
    }
    if (1.0 * clock() / CLOCKS_PER_SEC > 0.95) break;
  }
  cout << ans.size() << endl;
  for (auto it : ans)
    cout << it << ' ';
#ifdef LOCAL
  cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
  return 0;
}
