#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = (int)1e3 + 1;

vector<vector<int> > E;

bitset<dd> G[dd];
int used[dd], t[dd];
int cnt;

void dfs(int v) {
	used[v] = 1; cnt++;
	for (int to : E[v]) if (!used[to]) dfs(to);
	//H.push_back(v);
}

int main() {
	int n, m, h;
	cin >> n >> m >> h;
	
	E.resize(n);
	
	for (int i = 0; i < n; i++) cin >> t[i];
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if ((t[a] + 1) % h == t[b]) E[a].push_back(b);
		if ((t[b] + 1) % h == t[a]) E[b].push_back(a);
	}
	
	int ans = n + 7;
	int ind = -1;
	for (int v = 0; v < n; v++) {
		fill(used, used + n, 0);
		cnt = 0;
		
		dfs(v);
		if (cnt < ans) ans = cnt, ind = v;
	}
	
	fill(used, used + n, 0);
	cnt = 0;
	dfs(ind);
	cout << cnt << "\n";
	for (int v = 0; v < n; v++) if (used[v]) cout << v + 1 << " ";
	cout << "\n";
	
	
	return 0;
}