#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int dd = (int)2e5 + 7;

vector<vector<int> > E, ER;

int used[dd], t[dd];
int cnt[dd], out[dd], comp[dd];
vector<int> H, T[dd];

void topsort(int v) {
	used[v] = 1;
	for (int to : E[v]) if (!used[to]) topsort(to);
	H.push_back(v);
}

void mark(int v, int c) {
	comp[v] = c;
	cnt[c]++;
	T[comp[v]].push_back(v);
	for (int to : ER[v]) if (comp[to] == -1) mark(to, c);
}

int main() {
	int n, m, h;
	cin >> n >> m >> h;
	
	E.resize(n);
	ER.resize(n);
	
	for (int i = 0; i < n; i++) cin >> t[i];
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if ((t[a] + 1) % h == t[b]) E[a].push_back(b), ER[b].push_back(a);
		if ((t[b] + 1) % h == t[a]) E[b].push_back(a), ER[a].push_back(b);
	}
	
	for (int v = 0; v < n; v++) if (!used[v]) topsort(v);
	
	reverse(H.begin(), H.end());
	
	fill(comp, comp + n, -1);
	int cc = 0;
	
	for (int v : H) if (comp[v] == -1)
		mark(v, cc++);
		
	for (int v = 0; v < n; v++)
		for (int to : E[v]) if (comp[v] != comp[to]) out[comp[v]] = 1;
		
	int ans = n + 7;
	int ind = -1;
	for (int c = 0; c < cc; c++) if (!out[c]) {
		if (cnt[c] < ans) {
			ans = cnt[c];
			ind = c;
		}
	}
	cout << ans << "\n";
	for (int x : T[ind]) cout << x + 1 << " "; 
	cout << "\n";
	
	
	return 0;
}