#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int main() {
	string s;
	cin >> s;
	
	int n = (int)s.size();
	set<pair<int, int> > S1, S2;
	
	vector<int> pr(n, -1);
	
	for (int i = 0; i < n; i++) {

		if (s[i] == '0') {
			if (S1.size()) {
				auto c = *S1.rbegin();
				S1.erase(--S1.end());
				
				pr[i] = c.first;
				S2.insert({ c.second, i });
				
			} else S2.insert({ i, i }), pr[i] = -1;
		} else {
			
			if (S2.empty()) return 0 * puts("-1");
			
			auto c = *S2.rbegin();
			S2.erase(--S2.end());
			
			auto it = S1.upper_bound(make_pair(c.second, 0));
			if (it == S1.begin()) S1.insert({ i, c.first }), pr[i] = c.second;
			else {
				--it;
				c.first = it->second;
				S1.erase(it);
				S1.insert({ c.second, c.first });
				pr[i] = c.second;
			}
		}
		
		//err("i = %d\n", i);
		//for (auto c : S1) err("(%d, %d), ", c.second, c.first); err("\n");
		//for (auto c : S2) err("(%d, %d), ", c.first, c.second); err("\n");
		
	}
	if (S1.size()) return 0 * puts("-1");
	
	vector<int> used(n);
	
	vector<vector<int> > ans;
	
	//for (int i = 0; i < n; i++) err("pr[%d] = %d\n", i, pr[i]);
	
	for (int i = n - 1; i >= 0; i--) if (!used[i]) {
		vector<int> t;
		for (int j = i; j != -1; j = pr[j]) t.push_back(j), used[j] = 1;
		reverse(t.begin(), t.end());
		ans.push_back(t);
	}
	
	cout << (int)ans.size() << "\n";
	for (auto c : ans) {
		cout << c.size() << " ";
		for (int x : c) cout << x + 1 << " ";
		cout << "\n";
	}
	
	return 0;
}