#include <stdio.h>
#include <bits/stdc++.h>
#define pb push_back
#define pp pop_back
#define mp make_pair
#define f first
#define s second
#define all(x) x.begin(), x.end()
typedef long long ll;

using namespace std;

const int N = 3e5 + 111, inf = 1e9, mod = 1e9 + 7;
const double pi = acos(-1.0), eps = 1e-9;
const ll INF = 1e18;

int n, m, h, u[N], nx[N], sz[N], cnt, ans = -1, col[N];
vector <int> g[N], gr[N], nwg[N], cf, vf;
bool used[N];

void dfs1(int v){
	used[v] = 1;
	for(auto to : g[v]){
		if(!used[to])
			dfs1(to); 
	}
	cf.pb(v);
}

void dfs2(int v){	
	used[v] = 1;
	vf.pb(v);
	for(auto to : gr[v]){
		if(used[to])
			continue;
		dfs2(to);
	}
}

int main(){
	srand(time(NULL));
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	cout << setprecision(10) << fixed;

	cin >> n >> m >> h;

	for(int i = 1; i <= n; ++i)
		cin >> u[i], nx[i] = (u[i] + 1) % h;

   	for(int i = 1; i <= m; ++i){
   		int x, y;
   		cin >> x >> y;
   		if(nx[x] == u[y])
   			g[x].pb(y), gr[y].pb(x);
   		if(nx[y] == u[x])
   			g[y].pb(x), gr[x].pb(y);
   	}

   	for(int i = 1; i <= n; ++i)
	   	if(!used[i])
		   	dfs1(i);

	memset(used, 0, sizeof used);

   	for(int i = n - 1; i >= 0; --i){
   		int v = cf[i];
   		if(used[v])
   			continue;
		vf.clear();
		dfs2(v);
		++cnt;
		sz[cnt] = vf.size();
		for(auto to : vf)
			col[to] = cnt;
   	}

   	for(int i = 1; i <= n; ++i)
   	for(auto to : g[i])
   		if(col[i] != col[to])
			nwg[col[i]].pb(col[to]);   		

	for(int i = 1; i <= cnt; ++i){
		if(nwg[i].size() == 0){
			if(ans == -1 || (sz[ans] > sz[i]))
				ans = i;
		}
	}

	cout << sz[ans] << endl;
	
	for(int i = 1; i <= n; ++i)
		if(col[i] == ans)
			cout << i << " ";

	//cout << (clock() + 0.0) / CLOCKS_PER_SEC;
	return 0;
}