#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 1e5 + 7;
const int NEED = 1e4 + 7;

int p, n, d, need;

int ar[N];
int cur[N];
int can[N];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> p >> n >> d >> need;
    for(int i = 0 ; i < n ; i ++)
        cin >> ar[i];
}

int solve_for_one()
{
    int res = 0;
    for(int i = 0 ; i < n ; i ++)
        can[i] = i / (d+1);
    for(int i = 0 ; i < n ; i ++)
        cur[ can[i] ] += ar[i];
    for(int i = 0 ; i < n-1 ; i ++)
    {
        if(cur[i] < need)
        {
            res ++;
            cur[i + 1] += cur[i];
        }
        else
        {
            cur[i + 1] += cur[i] - need;
        }
    }
    return res;
}

int solve_for_two()
{
    int resl = 0, resr = 0;

    int l = 0, r = n-1;
    while(l < r)
    {
        int dst = d + (l * (d + 1));

        int can_l = 0;
        // cout << l << ' ' << r << ' ' << dst <<endl;

        for(int i = l ; i <= dst ; i ++)
            can_l += ar[i];

        int can_r = 0;
        for(int i = r ; i >= n - dst - 1 ; i --)
            can_r += ar[i];

        // cout << can_l << ' ' << can_r << endl << endl;
        if(resl <= resr)
        {
            int nl = need;
            if(can_l < need)
            {
                resl++;
            }
            else
            {
                for(int i = l ; i <= r ; i ++)
                {
                    if(nl < ar[i])
                    {
                        ar[i] -= nl;
                        break;
                    }
                    else
                    {
                        nl -= ar[i];
                        ar[i] = 0;
                    }
                }
            }
            int nr = need;
            if(can_r < need)
            {
                resr++;
            }
            else
            {
                for(int i = r ; i >= l ; i --)
                {
                    if(nr < ar[i])
                    {
                        ar[i] -= nr;
                        break;
                    }
                    else
                    {
                        nr -= ar[i];
                        ar[i] = 0;
                    }
                }
            }
        }
        else
        {
            int nr = need;
            if(can_r < need)
            {
                resr++;
            }
            else
            {
                for(int i = r ; i >= l ; i --)
                {
                    if(nr < ar[i])
                    {
                        ar[i] -= nr;
                        break;
                    }
                    else
                    {
                        nr -= ar[i];
                        ar[i] = 0;
                    }
                }
            }
            int nl = need;
            if(can_l < need)
            {
                resl++;
            }
            else
            {
                for(int i = l ; i <= r ; i ++)
                {
                    if(nl < ar[i])
                    {
                        ar[i] -= nl;
                        break;
                    }
                    else
                    {
                        nl -= ar[i];
                        ar[i] = 0;
                    }
                }
            }
        }

        l ++;
        r --;

    }

    return max(resl, resr);
}

int solve()
{
    if(p == 1)
        return solve_for_one();
    if(p == 2)
        return solve_for_two();
    return 0;
}

int32_t main()
{
    read();
    cout << solve() << endl;
}
