#include <bits/stdc++.h>

using namespace std;

set<int> getAllSums(vector<int> arr) {
	set<int> sums;
	sums.insert(0);
	for (int mask = 0; mask < (1 << int(arr.size())); ++mask) {
		int sum = 0;
		for (int i = 0; i < int(arr.size()); ++i)
			sum += ((mask >> i) & 1) * arr[i];
		sums.insert(sum);
	}
	return sums;
}

void solve() {
	int n = 0;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	const int MAX_POW = 7;
	int ans = 2e9;
	vector<int> cards;
	for (int mask = 0; mask < (1 << (2 * MAX_POW)); ++mask) {
		vector<int> cur;
		for (int i = 0; i < MAX_POW; ++i) {
			if ((mask >> i) & 1) {
				cur.push_back(1 << i);
			}
		}
		for (int i = MAX_POW; i < 2 * MAX_POW; ++i) {
			if ((mask >> i) & 1) {
				cur.push_back(- (1 << (i - MAX_POW)));
			}
		}
		auto sums = getAllSums(cur);
		bool test = true;

		for (int aa : a) {
			if (sums.find(aa) == sums.end()) {
				test = false;
				break;
			}
		}
		if (test && ans > cur.size()) {
			cards = cur;
			ans = cur.size();
		}
	}
	cout << ans << endl;
	for (int card : cards)
		cout << card << " ";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}