//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int MAXN = (int)1e+5 + 5;

ll p, n, d, b;

ll arr[MAXN], h[MAXN];

ll get(ll l, ll r)
{
    if (l > r)
        return 0;
    return h[r] - h[l - 1];
}

bool check(ll x)
{
    ll sub = 0ll, sum = 0ll;
    for (int i = 1, act = 0; act < x; i++, act++)
        sum += arr[i];
    bool flag = true;
    for (ll i = x + 1ll; i <= n; i++)
    {
        sub -= arr[i - 1];
        ll rb = min(n, i + i * d);
        ll now = get(i, rb);
        flag &= (now + sum - sub >= b);
        sub += b;
    }
    return flag;
}

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    cin >> p >> n >> d >> b;

    for (int i = 1; i <= n; i++)
    {
        cin >> arr[i];
        h[i] = h[i - 1] + arr[i];
    }

    ll l = 0ll, r = n;
    while (l != r)
    {
        ll mid = (l + r) / 2ll;
        if (check(mid))
            r = mid;
        else
            l = mid + 1ll;
    }
    cout << l;

    return 0;
}