#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int MAXN = (int)1e+5 + 5;

ll p, n, d, b;

ll arr[MAXN], h[MAXN];

ll get(ll l, ll r)
{
    if (l > r)
        return 0;
    return h[r] - h[l - 1];
}

bool check(ll x)
{
    if (p == 1)
    {
        ll sub = 0ll, sum = 0ll;
        for (int i = 1, act = 0; act < x; i++, act++)
            sum += arr[i];
        bool flag = true;
        for (ll i = x + 1ll; i <= n; i++)
        {
            if (i > x + 1ll)
                sub -= arr[i - 1];
            ll rb = min(n, i + i * d);
            ll now = get(i, rb);
            flag &= (now + sum - sub >= b);
            sub += b;
        }
        return flag;
    }
    else
    {
        ll subl = 0ll, subr = 0ll;
        ll suml = 0ll, sumr = 0ll;
        for (int i = 1, act = 0; act < x; i++, act++)
            suml += arr[i];
        for (int i = n, act = 0; act < x; i++, act++)
            sumr += arr[i];
        bool flag = true;
        for (ll i = x + 1ll, j = n - x, prev = x, nex = n - x + 1ll; i <= n - x; i++, prev++, nex--)
        {
            subl -= arr[prev];
            subr -= arr[nex];

            ll rb = min(nex - 1ll, i + i * d);
            if (i <= rb)
            {
                ll now = get(i, rb);
                flag &= (now + suml - subl >= b);
                if (flag == false)
                    int xxx = 0;
                subl += b;
            }

            ll lb = max(prev + 1ll, j - j * d);
            if (lb <= j)
            {
                ll now = get(lb, j);
                flag &= (now + sumr - subr >= b);
                if (flag == false)
                    int xxx = 0;
                subr += b;
            }
        }
        return flag;
    }
}

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    cin >> p >> n >> d >> b;

    for (int i = 1; i <= n; i++)
    {
        cin >> arr[i];
        h[i] = h[i - 1] + arr[i];
    }

    ll l = 0ll, r = n;
    if (p == 2ll)
        r = n / 2ll;
    while (l != r)
    {
        ll mid = (l + r) / 2ll;
        if (check(mid))
            r = mid;
        else
            l = mid + 1ll;
    }
    cout << l;

   // check(2ll);

    return 0;
}