//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const int LOGN = 9;
const int MAXC = (1 << (LOGN + 1));

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n;
    cin >> n;

    vector <int> have;
    for (int i = 0; i <= LOGN; i++)
    {
        have.push_back((1 << i));
        have.push_back(-(1 << i));
    }
    int m = (int)have.size();
    vector <int> arr(n);
    forn(i, n)
    {
        cin >> arr[i];
    }

    bool haveans = false;
    vector <int> ans, now;
    bitset <MAXC * 2 + 5> dp;
    forn(mask, (1 << m))
    {
        now.clear();
        dp.reset();
        forn(i, m)
        {
            if ((1 << i) & mask)
                now.push_back(have[i]);
        }

        dp[MAXC] = true;
        forn(i, (int)now.size())
        {
            if (now[i] > 0)
                dp |= (dp << now[i]);
            else
                dp |= (dp >> (-now[i]));
        }

        bool flag = true;
        forn(i, n)
            flag &= dp[arr[i] + MAXC];

        if (flag)
        {
            if (!haveans || (int)now.size() < (int)ans.size())
            {
                ans = now;
                haveans = true;
            }
        }
    }

    cout << (int)ans.size() << endl;
    forn(i, (int)ans.size())
        cout << ans[i] << " ";

    return 0;
}