//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

int main()
{
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    srand(1373737);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    string s;
    cin >> s;

    int n = (int)s.size();
    vector < vector<int> > have(2), save;

    forn(i, n)
        have[s[i] - '0'].push_back(i);

    save = have;

    vector <bool> linked(n);
    vector <int> link(n, -1);
    for (int i = (int)have[1].size() - 1; i >= 0; i--)
    {
        if (have[0].empty() || have[0].back() < have[1][i])
        {
            cout << -1;
            return 0;
        }
        link[have[1][i]] = have[0].back();
        linked[link[have[1][i]]] = true;
        have[0].pop_back();
    }

    have = save;

    set <int> h1;
    forn(i, n)
    {
        if (s[i] == '1')
            h1.insert(i);
    }

    for (int i = n - 1; i >= 0; i--)
    {
        if (s[i] == '0')
        {
            if (linked[i])
                continue;
            auto it = h1.lower_bound(i);
            if (it != h1.end())
            {
                link[i] = *it;
                h1.erase(it);
            }
            continue;
        }
        auto it = h1.lower_bound(link[i]);
        if (it != h1.end())
        {
            link[link[i]] = *it;
            h1.erase(it);
        }
    }

    forn(i, n)
    {
        if (link[i] != -1)
            linked[link[i]] = true;
    }

    forn(i, n)
    {
        if (s[i] == '1' && !linked[i])
        {
            cout << -1;
            return 0;
        }
    }

    vector <bool> used(n);
    vector < vector<int> > ans;

    forn(i, n)
    {
        if (used[i])
            continue;
        ans.push_back({});
        int now = i;
        while (true)
        {
            ans.back().push_back(now);
            used[now] = true;
            now = link[now];
            if (now == -1)
                break;
        }
    }

    cout << (int)ans.size() << endl;

    forn(i, (int)ans.size())
    {
        cout << (int)ans[i].size() << " ";
        forn(j, (int)ans[i].size())
            cout << ans[i][j] + 1 << " ";
        cout << endl;
    }

    return 0;
}