#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m, h;
vector<vector<int> > g;
vector<bool> used;

void dfs(int u) {
	used[u] = 1;
	for (int v : g[u]) {
		if (!used[v]) {
			dfs(v);
		}
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin >> n >> m >> h;
	g.resize(n), used.resize(n);
	vector<int> c(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		if ((c[u] + 1) % h == c[v]) {
			g[u].push_back(v);
		}
		if ((c[v] + 1) % h == c[u]) {
			g[v].push_back(u);
		}
	}
	int ans = n;
	vector<int> all;
	for (int i = 0; i < n; i++) {
		used.assign(n, 0);
		dfs(i);
		int cnt = count(used.begin(), used.end(), true);
		if (cnt <= ans) {
			ans = cnt;
			all.clear();
			for (int j = 0; j < n; j++) {
				if (used[j]) all.push_back(j);
			}
		}
	}
	cout << ans << endl;
	for (int i = 0; i < ans; i++) {
		cout << all[i] + 1 << ' ';
	}
	cout << endl;
	return 0;
}

