#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

//#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------

const int K = 9;
const int MASKLEN = K * 2;
const int C = 305;

bool in_a[2 * C]; // 0 is stored in C
bool dp[(1 << MASKLEN)][2 * C];

int get_val(int p) {
	if (p >= K) {
		return (1 << (p - K));
	}
	else {
		return -(1 << (K - 1 - p));
	}
}

void calc_dp(int mask) {
	int p = 0;
	while (p < MASKLEN && !((1 << p) & mask)) {
		++p;
	}
	//cerr << p << endl;
	int prev = (mask ^ (1 << p));
	for (int i = 0; i < 2 * C; ++i) {
		if (dp[prev][i]) {
			dp[mask][i] = true;
			int new_val = get_val(p) + i;
			if (new_val >= 0 && new_val < 2 * C) {
				dp[mask][new_val] = true;
				//cerr << mask << " " << new_val << endl;
			}
		}
	}
}

int len(int mask) {
	// amount of '1'
	int ans = 0;
	for (int i = 0; i < MASKLEN; ++i) {
		ans += (((1 << i) & mask) != 0);
	}
	return ans;
}

signed main() {
	doRoutine();

	int n;
	cin >> n;
	bool not_0 = false;
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x != 0) {
			not_0 = true;
		}
		in_a[x + C] = true;
	}

	if (!not_0) {
		cout << 0 << endl;
		return 0;
	}

	int best_mask = (1 << MASKLEN) - 1;
	dp[0][C] = true;
	for (int mask = 1; mask < (1 << MASKLEN); ++mask) {
		calc_dp(mask);
		if (len(mask) < len(best_mask)) {
			bool flag = true;
			for (int i = 0; i < 2 * C; ++i) {
				if (in_a[i] && !dp[mask][i]) {
					flag = false;
				}
			}
			if (flag) {
				best_mask = mask;
			}
		}

		//cerr << mask << endl;
		for (int v = 0; v < 2 * C; ++v) {
			//cerr << v << ": " << dp[mask][v] << endl;
		}
	}

	cout << len(best_mask) << endl;
	for (int i = 0; i < MASKLEN; ++i) {
		if ((1 << i) & best_mask) {
			cout << get_val(i) << " ";
		}
	}

	return 0;
}