#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

// ------------------------------------- CODE NOW ---------------------------------------

void fail() {
	cout << -1 << endl;
	exit(0);
}

signed main() {
	doRoutine();

	string s;
	cin >> s;
	int n = s.size();

	set<int> a0, a1;
	for (int i = 0; i < n; ++i) {
		if (s[i] == '0') {
			a0.insert(i);
		}
		else {
			a1.insert(i);
		}
	}

	vvi ans;
	while (!a0.empty()) {
		int x = -1;
		int flag = 0;
		vi cur;
		while (true) {
			if (flag == 0) {
				auto it = a0.upper_bound(x);
				if (it == a0.end()) {
					fail();
				}
				else {
					cur.pb(*it);
					x = *it;
					a0.erase(it);
					flag = 1;
				}
			}
			else if (flag == 1) {
				auto it = a1.upper_bound(x);
				if (it == a1.end()) {
					break;
				}
				else {
					cur.pb(*it);
					x = *it;
					a1.erase(it);
					flag = 0;
				}
			}
		}

		ans.pb(cur);
	}

	if (!a1.empty()) {
		fail();
	}
	cout << ans.size() << endl;
	for (auto t : ans) {
		cout << t.size() << " ";
		for (auto el : t) {
			cout << el + 1 << " ";
		}
		cout << endl;
	}

	return 0;
}