#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

vector <int> best;
vector <set<int>> gt;
vector <bool> used;
vector <int> path;

int n, m, h;
int mn = 1e18;
int x = -1;
void dfs(int v, int d)
{
    path.push_back(v);
    used[v] = true;
    for (auto i : gt[v])
    {
        if (!used[i])
        {
            dfs(i, d + 1);
        }
        else
        {
            mn = min(mn, d);
            x = v;
        }
    }
}

signed main()
{
    cin >> n >> m >> h;
    vector <int> wu(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &wu[i]);
    }
    gt.resize(n);
    int a, b;
    for (int i = 0; i < m; i++)
    {
        scanf("%d %d", &a, &b);
        a--;
        b--;
        if ((wu[a] + 1) % h == wu[b])
            gt[a].insert(b);
        if ((wu[b] + 1) % h == wu[a])
            gt[b].insert(a);
    }
    for (int i = 0; i < n; i++)
    {
        if (gt[i].size() == 0)
            return cout << 1 << endl << i + 1 << endl, 0;
    }
    used = vector <bool> (n);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
            dfs(i, 0);
    }
    path.clear();
    used = vector <bool> (n);
    dfs(x, 0);
    cout << path.size() << endl;
    for (auto p: path)
        cout << p + 1 << " ";
    cout << endl;
    return 0;
}

/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
