#include <iostream>
#include <vector>

using namespace std;

int dfs1(vector<int>* graph, int* visited, int* vtime, int i)
{
    static int timecnt = 0;
    if(visited[i] == 3)
        return (1 << 31) - 1;
    if(visited[i])
        return vtime[i];
    visited[i] = 1;
    vtime[i] = ++timecnt;
    int ans = vtime[i];
    for(int j : graph[i])
        ans = min(ans, dfs1(graph, visited, vtime, j));
    if(ans >= vtime[i])
        visited[i] = 2;
    return vtime[i] = ans;
}

void dfs2(vector<int>* graph, int* visited, int i, int* compnos, int cn, int& compno)
{
    static int timecnt = 0;
    if(visited[i] == 3)
        return;
    if(visited[i] == 2)
        cn = ++compno;
    visited[i] = 3;
    compnos[i] = cn;
    for(int j : graph[i])
        dfs2(graph, visited, j, compnos, cn, compno);
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    int uph[n];
    for(int i = 0; i < n; i++)
        cin >> uph[i];
    vector<int> graph[n];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if(uph[b] == (uph[a] + 1) % h)
            graph[a].push_back(b);
        if(uph[a] == (uph[b] + 1) % h)
            graph[b].push_back(a); 
    }
    int visited[n];
    for(int i = 0; i < n; i++)
        visited[i] = 0;
    int compno = 0;
    int compnos[n];
    for(int i = 0; i < n; i++)
        compnos[i] = 0;
    int vtime[n];
    for(int i = 0; i < n; i++)
        if(compnos[i] == 0)
        {
            dfs1(graph, visited, vtime, i);
            compno++;
            dfs2(graph, visited, i, compnos, compno, compno);
        }
    int ans[compno];
    for(int i = 0; i < compno; i++)
        ans[i] = 0;
    for(int i = 0; i < n; i++)
        ans[compnos[i] - 1]++;
    for(int i = 0; i < n; i++)
        for(int j : graph[i])
            if(compnos[i] != compnos[j])
                ans[compnos[i] - 1] = 0;
    int mn = n;
    int winner = -1;
    for(int i = 0; i < compno; i++)
        if(ans[i] != 0 && ans[i] <= mn)
        {
            mn = ans[i];
            winner = i + 1;
        }
    bool need_space = false;
    cout << mn << endl;
    for(int i = 0; i < n; i++)
        if(compnos[i] == winner)
        {
            if(need_space)
                cout << ' ';
            else
                need_space = true;
            cout << i + 1;
        }
    cout << endl;
    return 0;
}
