#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int n;

int fix(int x)
{
    if (x < 0)
        return 0;
    else if (x >= n)
        return n - 1;
    else
        return x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int p, d, b, i, j;
    cin >> p >> n >> d >> b;

    vector<int> num(n, 0);
    for (i = 0; i < n; i++)
        cin >> num[i];

    vector<int> indices;
    if (p == 1)
    {
        for (i = 0; i < n; i++)
            indices.push_back(i);
    }
    else
    {
        for (i = 0; i < n / 2; i++)
        {
            indices.push_back(i);
            indices.push_back(n - 1 - i);
        }

        if (n % 2 == 1)
            indices.push_back(n / 2);
    }

    vector<int> ans(2, 0);
    for (int i : indices)
    {
        int dir = (    ((n % 2 == 0) && (i < n / 2))
                    || ((n % 2 == 1) && (i <= n / 2))
                    || (p == 1));

        if (dir == 0)
            dir--;

        if (num[i] >= b)
        {
            num[fix(i + dir * d * (i + 1))] += num[i] - b;
            num[i] = b;

            continue;
        }

        int sum = 0;
        for (j = i + 1; j <= fix(i + dir * d * (i + 1)); j++)
            sum += num[j];

        if (sum + num[i] < b)
        {
            num[fix(i + dir * d * (i + 1))] += num[i];
            num[i] = 0;
            ans[(dir == -1) ? 0 : 1]++;
        }
        else
        {
            for (j = i + 1; j <= fix(i + dir * d * (i + 1)); j++)
            {
                if (num[i] + num[j] <= b)
                {
                    num[i] += num[j];
                    num[j] = 0;
                }
                else
                {
                    num[j] -= (b - num[i]);
                    num[i] = b;
                }
            }
        }
    }

    cout << max(ans[0], ans[1]) << endl;

    return 0;
}
