//#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

const int MAXN = 1e5 + 100;
int n, m, h;
set <int> g[MAXN];
vector <int> ng[MAXN];
int t[MAXN];
int used[MAXN];
vector <int> order;

void read() {
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].insert(v - 1);
        g[v - 1].insert(u - 1);
    }
}

void dfs(int v, int c) {
    used[v] = c;
    for (auto u : ng[v]) {
        if (used[u] != c) {
            dfs(u, c);
        }
    }
    order.push_back(v);
}

void dfs1(int v, vector <int> &ans, int c) {
    used[v] = c;
    ans.push_back(v);
    for (auto u : ng[v]) {
        if (used[u] != c) {
            dfs1(u, ans, c);
        }
    }
}

void solve() {
    for (int v = 0; v < n; v++) {
        for (auto u : g[v]) {
            if (t[u] == (t[v] + 1) % h) {
                ng[v].push_back(u);
                rng[u].push_back(v);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i] != 1) {
            dfs(i, 1);
        }
    }
    vector <int> ans;
    dfs1(order[0], ans, 2);
    cout << ans.size() << '\n';
    for (auto c : ans) {
        cout << c + 1 << ' ';
    }
}

int main() {
    read();
    solve();
    return 0;
}

