#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int ans = 0;
    ll p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<ll> a(n);
    vector<pair<int, int>> edges(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        edges[i] = {i, i};
    }

    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                edges[j].first -= d;
                edges[j].second += d;
            }
            if (a[i] < b) {
                ll sm = 0;
                for (int j = i + 1; j < n; ++j) {
                    if (edges[j].first <= i)
                        sm += max(0ll, a[j] - b);
                }
                if (a[i] + sm < b) {
                    a[min(i + d, n - 1)] += a[i];
                    a[i] = 0;
                    ++ans;
                } else {
                    for (int j = i + 1; j < n; ++j) {
                        if (edges[j].first <= i) {
                            ll toadd = a[j] - b;
                            if (a[i] + toadd >= b) {
                                a[j] -= b - a[i];
                                a[i] = b;
                                break;
                            } else {
                                a[j] -= toadd;
                                a[i] += toadd;
                            }
                        }
                    }
                }
            } else {
                ll toadd = a[i] - b;
                a[min(i + d, n - 1)] += toadd;
                a[i] -= toadd;
            }
        }
    }
    cout << ans;
    return 0;
}

/*
 1 10 5 1
 0 0 0 0 0 0 0 0 0 10
 */