#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>

typedef long long ll;

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    string s;
    cin >> s;
    n = s.size();

    set<int> zeros, ones;
    vector<int> p(n, -1);

    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (ones.empty()) {
                zeros.insert(i);
                p[i] = -1;
            } else {
                int k = *ones.begin();
                ones.erase(k);
                p[i] = k;
                zeros.insert(i);
            }
        } else {
            if (zeros.empty()) {
                cout << -1;
                return 0;
            } else {
                int k = *zeros.begin();
                zeros.erase(k);
                p[i] = k;
                ones.insert(i);
            }
        }
    }

    if (!ones.empty()) {
        cout << -1;
    } else {
        vector<vector<int>> ans;
        for (int st : zeros) {
            vector<int> cr;
            for (; st != -1; st = p[st]) {
                cr.push_back(st);
            }
            reverse(cr.begin(), cr.end());
            ans.push_back(cr);
        }

        cout << ans.size() << endl;
        for (auto &i : ans) {
            cout << i.size() << ' ';
            for (auto &j : i) {
                cout << j + 1 << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}
