#include "bits/stdc++.h"
//#define int long long
#define double long double
#pragma GCC optimize("03")
using namespace std;

const int INF = 1e9;
const int MAXN = 2e5 + 100;

vector<vector<pair<int, vector<int>>>> g(MAXN);
vector<vector<int>> p(MAXN);
vector<int> t(MAXN);
vector<pair<int, int>> k;
vector<int> used(MAXN);

int n, m, h;

int best = 0, beg = INF;
int cur = 0;

vector<int> ans;

void dfs(int v) {
    if (used[v] || cur >= best)
        return;
    ++cur;
    used[v] = true;
    auto cur = p[v];
    int next_time = (t[v] == h? 1 : t[v] + 1);
    for (auto &i : g[next_time]) {
        if (used[i.first])
            continue;
        vector<int> temp;
        set_intersection(i.second.begin(), i.second.end(), cur.begin(), cur.end(), back_inserter(temp));
        if (temp.size())
            dfs(i.first);

        temp.clear();
    }
}

void find_ans(int v) {
    if (used[v])
        return;
    used[v] = true;
    ans.push_back(v + 1);
    auto cur = p[v];
    int next_time = (t[v] == h? 1 : t[v] + 1);
    for (auto &i : g[next_time]) {
        if (used[i.first])
            continue;
        vector<int> temp;
        set_intersection(i.second.begin(), i.second.end(), cur.begin(), cur.end(), back_inserter(temp));
        if (temp.size())
            find_ans(i.first);

        temp.clear();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    best = n + 100;
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
        if (t[i] == 0)
            t[i] = h;
    }

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        k.push_back({a, b});
        p[a].push_back(i);
        p[b].push_back(i);
    }



    for (int i = 0; i < n; ++i) {
        g[t[i]].push_back({i, p[i]});
    }

    for (int i = 0; i < n; ++i) {
        used.assign(n + 5, false);
        cur = 0;
        dfs(i);
        if (best > cur) {
            best = cur;
            beg = i;
        }
    }

    cout << best << '\n';
    cur = 0;
    used.assign(n + 1, false);
    find_ans(beg);
    for (auto i : ans)
        cout << i << ' ';

    return 0;
}
