#include "bits/stdc++.h"
#define int long long
#define double long double
#pragma GCC optimize("03")
using namespace std;

const int INF = 1e9;
const int MAXN = 2e5 + 100;

int p, n, b, d;

int solve(vector<int> a) {
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int index = max(i, j - b);
            a[index] += a[j];
            a[j] = 0;
        }

        if (a[i] >= d) {
            a[i + 1] += a[i] - d;
        } else {
            ++sum;
            a[i + 1] += a[i];
        }
    }
    return sum;
}

int solve(vector<int> a, int sz) {
    int sum = 0;

    a.push_back(0);
    for (int i = 0; i < min((int)a.size() - 1, sz); ++i) {
        for (int j = i + 1; j < a.size(); ++j) {
            int index = max(i, j - b);
            a[index] += a[j];
            a[j] = 0;
        }

        if (a[i] >= d) {
            a[i + 1] += a[i] - d;
        } else {
            ++sum;
            a[i + 1] += a[i];
        }
    }
    return sum + max(0ll, sz - a.size());
}

signed main() {
    cin >> p >> n >> b >> d;

    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    if (p == 1) {
        cout << solve(a);
    } else {
        int best = INF;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j <= a[i]; ++j) {
                int sum = 0;
                vector<int> temp1 = a, temp2 = a;
                temp1.resize(i + 1);
                temp1[temp1.size() - 1] = j;
                sum += solve(temp1, (n + 1) / 2);
                reverse(temp2.begin(), temp2.end());
                temp2.resize(n - i);
                temp2[temp2.size() - 1] = a[i] - j;
                sum += solve(temp2, n / 2);
                best = min(best, sum);
                //cout << sum << ' ';
            }
        }
        cout << best;
    }

    return 0;
}


