#include <bits/stdc++.h>

using namespace std;

vector <int> u, tout, ord, lord, am, sz;
vector <vector <int> > g, tran, con;
vector <bool> vis;
int h, n, t;

void add_edge (int a, int b) {
    int ta = (u[a] + 1) % h;
    int tb = (u[b] + 1) % h;
    if (ta == u[b])
        g[a].push_back(b), tran[b].push_back(a);
    if (tb == u[a])
        g[b].push_back(a), tran[a].push_back(b);
}

void dfs (int v) {
    vis[v] = true;
    for (int j = 0; j < g[v].size(); j++) {
        int to = g[v][j];
        if (!vis[to])
            dfs(to);
    }
    tout[v] = ++t;
}

void bfs (int v) {
    vis[v] = true;
    lord[v] = t;
    for (int j = 0; j < tran[v].size(); j++) {
        int to = tran[v][j];
        if (!vis[to])
            bfs(to);
    }
}

int sfd(int v) {
    if (am[v])
        return am[v];

    am[v] = sz[v];
    for (int j = 0; j < con[v].size(); j++) {
        am[v] += sfd(con[v][j]);
    }
    return am[v];
}

int main()
{
    //ios_base::sync_with_stdio(false);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    n = 50000;
//    cout << n << ' ' << n << ' ' << n << '\n';
//    for (int j = 0; j < n; j++) {
//        cout << j << ' ';
//    }
//    for (int j = 0; j < n; j++) {
//        cout << j + 1 << ' ' << (j + 1) % n + 1 << '\n';
//    }
//    return 0;
    int m, a, b;
    cin >> n >> m >> h;
    g.resize(n);
    u.resize(n);
    tout.resize(n);
    ord.resize(n);
    lord.resize(n);
    tran.resize(n);
    vis.resize(n, false);
//    for (int j = 0; j < m; j++)  {
//        cin >> a >> b;
//        g[a].push_back(b);
//        tran[b].push_back(a);
//    }
    for (int j = 0; j < n; j++) {
        cin >> u[j];
    }
    for (int j = 0; j < m; j++) {
        cin >> a >> b;
        add_edge(--a, --b);
    }
    for (int j = 0; j < n; j++) {
        if (!vis[j])
            dfs(j);
    }
    for (int j = 0; j < n; j++) {
        ord[n - tout[j]] = j;
        vis[j] = false;
    }
    t = 0;
    for (int j = 0; j < n; j++) {
        int i = ord[j];
        if (!vis[i]) {
            bfs(i);
            t++;
        }
    }
    con.resize(t);
    sz.resize(t, 0);
    am.resize(t, 0);
    for (int j = 0; j < n; j++) {
        b = lord[j];
        sz[b]++;
        for (int i = 0; i < g[j].size(); i++) {
            a = lord[g[j][i]];
            if (a != b) {
                con[b].push_back(a);
            }
        }
    }
    int mn = 2e9, id;

    for (int j = 0; j < t; j++) {
        if (sfd(j) < mn) {
            mn = am[j];
            id = j;
        }
    }
    cout << sz[id] << '\n';
    for (int j = 0; j < n; j++) {
        if (lord[j] == id)
            cout << j + 1 << ' ';
    }
}
