#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unrool-loops")/**/


#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stdio.h>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

#define prev aksdnasd
#define hash askdaksd
#define y1 alsmdasdas
#define y2 alsdnmasds
#define rank asdasdas

using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

struct SegmentTreeSum{
    vector<int> tree;
    int b;

    SegmentTreeSum(vector<int> s){
        int n = s.size();
        b = 1;
        while (b < n)
            b *= 2;
        tree.reserve(2 * b - 1);
        for (int i = 0; i < n; i++)
            tree[b - 1 + i] = s[i];
        for (int i = b - 2; i >= 0; i--)
            tree[i] = tree[i * 2 + 1] + tree[i * 2 + 2];
    }

    void update(int pos, int v){
        pos += b - 1;
        tree[pos] = v;
        while (pos > 0){
            pos = (pos - 1) / 2;
            tree[pos] = tree[pos * 2 + 1] + tree[pos * 2 + 2];
        }
    }

    int getSum(int v, int vl, int vr, int l, int r){
        if (vl > r || vr < l)
            return 0;
        if (vl >= l && vr <= r)
            return  tree[v];
        int vm = (vl + vr) / 2;
        return getSum(v * 2 + 1, vl, vm, l, r) + getSum(v * 2 + 2, vm + 1, vr, l, r);
    }

    int get(int l, int r){
        return getSum(0, 0, b - 1, l, r);
    }
};


int get(vector<int> s, int d, int b){
    int n = s.size();
    int summa = 0;
    for (int i = 0; i < n; i++)
        summa += s[i];
    int k = summa / b;
    SegmentTreeSum tree = SegmentTreeSum(s);
    int p = 0;
    int answer = 0;
    for (int i = 0; i < k; i++){
        int l = i;
        int r = min(i + d * (i + 1), n - 1);
        if (tree.get(l, r) + p < b){
            answer++;
            p = tree.get(l, r) + p;
        }
        else
            p = tree.get(l, r) + p - b;
    }
    return answer;
}


int main()
{
    #ifdef KEK
        freopen("test.in", "r", stdin);/**/
    #endif // KEK
    /*freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);/**/
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    if (p == 1){
        cout << get(s, d, b) << endl;
        return 0;
    }
    vector<int> s1, s2;
    int k = (n + 1) / 2 * b;
    int cur = 0;
    while (k > 0){
        s1.push_back(min(k, s[cur]));
        int was = k;
        k -= min(k, s[cur]);
        if (k == 0){
            s2.push_back(s[cur] - was);
            for (int i = cur + 1; i < n; i++)
                s2.push_back(s[i]);
            reverse(s2.begin(), s2.end());
            //\cout << get(s2, d, b) << endl;
            cout << max(get(s1, d, b), get(s2, d, b)) << endl;
            return 0;
        }
        cur++;
    }
    return 0;
}
