#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST


int p, n, d, b;
int *a;
int __main() {
    cin >> p >> n >> d >> b;
    a = new int[n];
    for (int i = 0; i < n; i++)cin >> a[i];
    assert(p == 1);

    int nd = 0;
    int overflow = 0;
    int x = 0;
    for (int i = 0; i < n; i++) {
        nd += d;
        for (int j = i + 1; j < min(n, i+nd+1); j++) {
                a[i] += a[j];
                a[j] = 0;
        }
        
        a[i] += overflow;
        overflow = max(0, a[i] - b);

        if (a[i] < b)x++;
    }
    cout << x;
    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}