#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <string>
using namespace std;
#define int long long
#define INF 1791791791
struct node
{
    int x = 0;
    node *left = nullptr, *right = nullptr;
    int l, r;
    node(int l, int r) : l(l), r(r)
    {
        if (r - l > 1) {
            int m = (l + r) / 2;
            left = new node(l, m);
            right = new node(m, r);
        }
    }
};
signed main()
{
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);
    string s;
    cin >> s;
    set<int> p[2] = {};
    for (int i = 0; i < s.size(); ++i) {
        p[s[i] - '0'].insert(i);
    }
    int c = p[0].size() - p[1].size();
    vector<vector<int>> res(c);
    for (int i = 0; i < c; ++i) {
        int j = 0;
        bool cur = false;
        while (true) {
            auto k = p[cur].lower_bound(j);
            if (k == p[cur].end())
                break;
            j = *k;
            p[cur].erase(k);
            res[i].push_back(j);
            cur = !cur;
        }
        if (!cur || res[i].size() == 0) {
            cout << -1;
            return 0;
        }
    }
    if (p[0].size() || p[1].size()) {
        cout << -1;
        return 0;
    }
    cout << res.size() << '\n';
    for (int i = 0; i < c; ++i) {
        cout << res[i].size();
        for (int x : res[i])
            cout << ' ' << x + 1;
        cout << '\n';
    }
}

