#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e5 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

int t[maxn];
int t1[maxn];
int f[maxn];
int dp[maxn];
int csz[maxn];
vector<int> g[maxn], g1[maxn], gt[maxn];
bool used[maxn];
vector<int> tmp, comp;
set<int> ans;
int n, m, h;

void dfs1(int v){
    used[v] = 1;
    for(int to : g[v])
        if(!used[to])
            dfs1(to);
    tmp.pb(v);
}

void dfs2(int v){
    used[v] = 1;
    comp.pb(v);
    for(int to : g1[v])
        if(!used[to])
            dfs2(to);
}

void dfs3(int v){
    used[v] = 1;
    dp[v] = csz[v];
    set<int> go;
    for(int to : gt[v]){
        if(go.count(to))
            continue;
        if(!used[to])
            dfs3(to);
        dp[v] += dp[to];
        go.insert(to);
    }
}

void dfs4(int v){
    used[v] = 1;
    ans.insert(v);
    for(int to : gt[v])
        if(!used[to])
            dfs4(to);
}

int solve(){
    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++){
        cin >> t[i];
        t1[i] = t[i] + 1;
        if(t1[i] == h)
            t1[i] = 0;
    }
    for(int i = 0; i < m; i++){
        int v, u;
        cin >> v >> u;
        if(t1[v] == t[u]){
            g[v].pb(u);
            g1[u].pb(v);
        }
        if(t1[u] == t[v]){
            g[u].pb(v);
            g1[v].pb(u);
        }
    }
    for(int i = 1; i <= n; i++)
        used[i] = 0;
    for(int i = 1; i <= n; i++)
        if(!used[i])
            dfs1(i);
    for(int i = 1; i <= n; i++)
        used[i] = 0;
    reverse(tmp.begin(), tmp.end());
    int c = 0;
    for(int v : tmp){
        if(!used[v]){
            dfs2(v);
            for(int u : comp)
                f[u] = c;
            csz[c] = comp.size();
            comp.clear();
            c++;
        }
    }
    for(int i = 1; i <= n; i++){
        for(int to : g[i]){
            if(f[i] != f[to])
                gt[f[i]].pb(f[to]);
        }
    }
    for(int i = 0; i <= n; i++)
        used[i] = 0;
    for(int i = 0; i < c; i++){
        if(!used[i])
            dfs3(i);
    }
    int mn = 0;
    for(int i = 0; i < c; i++)
        if(dp[i] < dp[mn])
            mn = i;
    for(int i = 1; i <= n; i++)
        used[i] = 0;
    cout << dp[mn] << "\n";
    dfs4(mn);
    for(int i = 1; i <= n; i++)
        if(ans.count(f[i]))
            cout << i << " ";
    return dp[mn];
}

void dfs(int v){
    used[v] = 1;
    tmp.pb(v);
    for(int to : g[v])
        if(!used[to])
            dfs(to);

}

int solve70(){
    n = 500, m = 1000, h = 10;
    for(int i = 0; i <= n; i++){
        g[i].clear();
        g1[i].clear();
        gt[i].clear();
    }
//    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++){
//        cin >> t[i];
        t[i] = rand() % h;
        t1[i] = t[i] + 1;
        if(t1[i] == h)
            t1[i] = 0;
    }
    for(int i = 0; i < m; i++){
        int v, u;
        v = rand() % n + 1, u = rand() % n + 1;
//        cin >> v >> u;
        if(t1[v] == t[u]){
            g[v].pb(u);
            g1[u].pb(v);
        }
        if(t1[u] == t[v]){
            g[u].pb(v);
            g1[v].pb(u);
        }
    }
    vector<int> ans;
    for(int i = 1; i <= n; i++){
        tmp.clear();
        dfs(i);
        for(int j = 1; j <= n; j++)
            used[j] = 0;
        if(ans.size() == 0 || ans.size() > tmp.size()){
            ans = tmp;
        }
    }
    tmp.clear();
    if(ans.size() != solve()){
        cout << "KEK\n";
        cout << n << " " << m << " " << h << "\n";
        for(int i = 1; i <= n; i++)
            cout << t[i] << " ";
        cout << "\n";
        for(int i = 1; i <= n; i++)
            for(int to : g[i])
//                if(to > i)
                cout << i << " " << to << "\n";
        cout << "-------\n" << ans.size() << " " << solve();
        exit(0);

    }
//    cout << ans.size() << "\n";
//    for(int x : ans)
//        cout << x << " ";
}

int main()
{
//    srand(2);
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    solve();
//    solve70();
//    for(int i = 0; i < 100000; i++){
////        if(i % 100 == 0)
//        if(i % 1000 == 0)
//            cout << i << endl;
//        solve70();
//    }
    return 0;
}
