#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e5 +123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

ll a[maxn];
ll t[maxn * 4];

void build(int v, int l, int r){
    if(l == r){
        t[v] = a[l];
        return;
    }
    int c = (l + r)/2;
    build(v * 2, l, c);
    build(v * 2 + 1, c + 1, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

ll get(int v, int tl, int tr, int l, int r){
    if(l > r)
        return 0;
    if(tl == l && tr == r)
        return t[v];
    int c = (tl + tr)/2;
    return get(v * 2, tl, c, l, min(r, c)) +
           get(v * 2 + 1, c + 1, tr, max(c + 1, l), r);
}

void update(int v, int l, int r,int pos, ll d){
    if(l == r){
        t[v] += d;
        return;
    }
    int c = (l + r)/2;
    if(pos <= c)
        update(v * 2, l, c, pos, d);
    else
        update(v * 2 + 1, c + 1, r, pos, d);
    t[v] += d;
}

void solve(){
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    build(1, 1, n);
    int ans = 0;
    if(p == 1){
        int r = d + 1;
        ll inRooms = 0;
        for(int i = 1; i <= n; i++){
            if(get(1, 1, n, 1, r) - inRooms < b){
                ans++;
            }
            else{
                inRooms += b;
            }
            r = min(r + d + 1, n);
        }
    }
    else{
        int l = 1, r = n;
        int lg = 1 + d, rg = n - d;
        int ans1 = 0, ans2 = 0;
        while(l <= r){
            ll sum = 0;
            for(int i = 1; i <= lg; i++)
                sum += a[i];
            if(sum >= b){
                for(int i = 1; i <= lg; i++){
                    if(a[l] >= b)
                        break;
                    a[l] += a[i];
                    a[i] = 0;
                    if(a[l] > b){
                        a[i] = a[l] - b;
                        a[l] = b;
                    }
                }
                a[l] -= b;
            }
            else{
//                a[l + 1] += a[l];
                ans1++;
            }
            l++;
            if(r < l)
                break;
            lg = min(lg + 1 + d, n);
            sum = 0;
            for(int i = n; i >= rg; i--)
                sum += a[i];
            if(sum >= b){
//                a[r - 1] += a[r];
//                a[r] = 0;
                for(int i = n; i >= rg; i--){
                    if(a[r] >= b)
                        break;
                    a[r] += a[i];
                    a[i] = 0;
                    if(a[r] > b){
                        a[i] = a[r] - b;
                        a[r] = b;
                    }
                }
                a[r] -= b;
            }
            else{
//                a[r - 1] += a[r];
                ans2++;
            }
            rg = max(1, rg - d - 1);
            r--;
        }
        ans = max(ans1, ans2);
        /*
        int l = n - d, r = d + 1;
        int la = 1, ra = n;
        for(int i = 1; i <= n/2; i++){
            if(get(1, 1, n, la, r) < b){
                ans++;
//                update(1, 1, n, i + 1, get(1, 1, n, i, i));
            }
            else{
                int bb = b;
                while(bb > 0){
                    ll delt = get(1, 1, n, la, la);
                    if(delt > bb){
                        update(1, 1, n, la, -bb);
                        bb = 0;
                    }
                    else{
                        update(1, 1, n, la, -delt);
                        bb -= delt;
                        la++;
                    }
                }
            }
            if((n & 1) && (i == n/2))
                break;
            r = min(r + d + 1, n);
            if(get(1, 1, n, l, ra) < b){
                ans++;
//                update(1, 1, n, n - i, get(1, 1, n, n - i + 1, n - i + 1));
            }
            else{
                int bb = b;
                while(bb > 0){
                    ll delt = get(1, 1, n, ra, ra);
                    if(delt > bb){
                        update(1, 1, n, ra, -bb);
                        bb = 0;
                    }
                    else{
                        update(1, 1, n, ra, -delt);
                        bb -= delt;
                        ra--;
                    }
                }
            }
            l = max(l - d - 1, 1);
        }
        */
    }
    cout << ans;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
