#include <bits/stdc++.h>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int maxn = 1e5 + 123;
const ld eps = 1e-9;
const int inf = 1e9 + 1234;
const ll infll = 1e18 + 1243;
const ll mod = 1e9 + 9;

ll a[maxn];
ll bb[maxn];
ll sum[maxn];
ll p, n, d, b;
ll t[maxn * 4];

void build(int v, int l, int r){
    if(l == r){
        t[v] = a[l];
        return;
    }
    int c = (l + r)/2;
    build(v * 2, l, c);
    build(v * 2 + 1, c + 1, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

ll get(int v, int tl, int tr, int l, int r){
    if(l > r)
        return 0;
    if(tl == l && tr == r)
        return t[v];
    int c = (tl + tr)/2;
    return get(v * 2, tl, c, l, min(r, c)) +
           get(v * 2 + 1, c + 1, tr, max(c + 1, l), r);
}

void update(int v, int l, int r,int pos, ll d){
    if(l == r){
        t[v] += d;
        return;
    }
    int c = (l + r)/2;
    if(pos <= c)
        update(v * 2, l, c, pos, d);
    else
        update(v * 2 + 1, c + 1, r, pos, d);
    t[v] += d;
}
bool check(ll x){
    for(int i = 1; i <= n; i++)
        a[i] = bb[i];
    int l = 1 + x, r = n - x;
    ll lg = 1 + d * (x + 1) + x, rg = n - d * (x + 1) - x;
    lg = min(lg, n);
    rg = max(rg, 1ll);
    int la = 1, ra = n;
    int ans1 = 0, ans2 = 0;
    while(l <= r){
        ll sum = 0;
        for(int i = la; i <= lg; i++){
            sum += a[i];
            if(sum >= b)
                break;
        }
        if(sum >= b){
            int bb = b;
            for(int i = la; i <= lg; i++){
                if(bb == 0)
                    break;
                if(a[i] > bb){
                    a[i] -= bb;
                    bb = 0;
                    break;
                }
                else{
                    bb -= a[i];
                    a[i] = 0;
                    la++;
                }
            }
        }
        else{
            return 0;
        }
        l++;
        if(r < l)
            break;
        lg = min(lg + 1 + d, n);
        sum = 0;
        for(int i = n; i >= rg; i--){
            sum += a[i];
            if(sum >= b)
                break;
        }
        if(sum >= b){
//                a[r - 1] += a[r];
//                a[r] = 0;
            int bb = b;
            for(int i = ra; i >= rg; i--){
                if(bb == 0)
                    break;
                if(a[i] > bb){
                    a[i] -= bb;
                    bb = 0;
                    break;
                }
                else{
                    bb -= a[i];
                    a[i] = 0;
                    ra--;
                }
            }
        }
        else{
            return 0;
        }
        rg = max(1ll, rg - d - 1);
        r--;
    }
    return 1;
}

void solve(){
//    cin >> p >> n >> d >> b;
    p = 2, n = 100000, d = 4, b = 1000;
    for(int i = 1; i <= n; i++){
//        cin >> a[i];
        a[i] = rand();
        bb[i] = a[i];
    }
    build(1, 1, n);
    int ans = 0;
    if(p == 1){
        int r = d + 1;
        ll inRooms = 0;
        for(int i = 1; i <= n; i++){
            if(get(1, 1, n, 1, r) - inRooms < b){
                ans++;
            }
            else{
                inRooms += b;
            }
            r = min(r + d + 1, n);
        }
    }
    else{
        for(int i = 1; i <= n; i++)
            sum[i] = sum[i - 1] + a[i];
        int l = 0, r = n/2, mid;
        while(l < r){
            mid = (l + r)/2;
            if(check(mid))
                r = mid;
            else
                l = mid + 1;
            cout << mid << " " << 1000.0 * clock() / CLOCKS_PER_SEC << endl;
        }
        ans = l;
    }
    cout << ans;
}

int main()
{
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
