#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

//ifstream cin("input.txt");
//ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	vector <int> ans;
	bool good = true;
	bool zero = true;
	for (int i = 0; i < s.size(); i++) {
		if (zero && s[i] == '0') {
			ans.push_back(i + 1);
			zero = false;
			continue;
		}
		if (!zero && s[i] == '1') {
			zero = true;
			ans.push_back(i + 1);
			continue;
		}
		if (zero && s[i] == '1') {
			cout << -1;
			exit(0);
		}
	}
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	cout << s.size() - ans.size() + 1 << endl;
	cout << ans.size();
	for (int i = 0; i < ans.size(); i++) {
		cout << " " << ans[i];
	}
	cout << endl;
	ans.push_back(s.size() + 1);
	for (int i = 0; i < ans.size() - 1; i++) {
		if (ans[i + 1] - ans[i] > 1) {
			for (int j = ans[i] + 1; j < ans[i + 1]; j++) {
				cout << 1 << " " << j << endl;
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}