#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

//ifstream cin("input.txt");
//ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	int count = 0;
	for (int i = 0; i < s.size() - 1; i++) {
		if (s[i] == s[i + 1] && s[i] == '1') {
			cout << -1;
			exit(0);
		}
		if (s[i] == '1') {
			count++;
		}
	}
	cout << s.size() - 2 * count << endl;
	cout << 2 * count + 1;
	bool zero = false;
	vector <int> ans;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] - '0' == zero) {
			zero = !zero;
			cout <<" " << i + 1;
		}
		else {
			ans.push_back(i + 1);
		}
	}
	cout << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << 1 << " " << ans[i] << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}