#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

//ifstream cin("input.txt");
//ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == 1) {
		cout << -1;
		exit(0);
	}
	int count = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '1') {
			count++;
		}
	}
	vector <vector <int> > ans;
	while (count) {
		ans.push_back({});
		int zero = 0;
		for (int i = 0; i < s.size(); i++) {
			if (s[i] == '-') {
				continue;
			}
			if (ans.back().size() == 0 && s[i] == '1') {
				cout << -1;
				exit(0);
			}
			if (s[i] - '0' == zero) {
				ans.back().push_back(i + 1);
				zero = abs(zero - 1);
				s[i] = '-';
			}
		}
		count -= ans.back().size() / 2;
		if (ans.back().size() % 2 == 0) {
			cout << -1;
			exit(0);
		}
	}
	vector <int> zero;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '1') {
			cout << -1;
			exit(0);
		}
		if (s[i] == '0') {
			zero.push_back(i + 1);
		}
	}
	cout << ans.size() + zero.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size();
		for (int j = 0; j < ans[i].size(); j++) {
			cout << " " << ans[i][j];
		}
		cout << endl;
	}
	for (int i = 0; i < zero.size(); i++) {
		cout << 1 << " " << zero[i] << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}