#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long long L;

//ifstream cin("input.txt");
//ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		return;
	}
	vector <pair <char, int> >count;
	count.push_back({ '0',1 });
	for (int i = 1; i < s.size(); i++) {
		if (count.back().first != s[i]) {
			count.push_back({ s[i],1 });
		}
		else {
			count.back().second++;
		}
	}
	set <int> zero;
	vector <vector <int> > one;
	int sum = 1;
	for (int i = 0; i < count.size(); i++) {
		if (count[i].first == '1') {
			for (int j = 0; j < count[i].second; j++) {
				if (one.size() == j) {
					one.push_back({ 0,sum });
				}
				else {
					one[j].push_back(sum);
				}
				sum++;
			}
		}
		else {
			for (int j = 0; j < count[i].second; j++) {
				zero.insert(sum);
				sum++;
			}
		}
	}
	vector <vector <int> > normal;
	for (int i = 0; i < one.size(); i++) {
		normal.push_back({});
		for (int j = 0; j < one[i].size(); j++) {
			auto now = zero.lower_bound(one[i][j]);
			if (now == zero.end()) {
				cout << -1;
				return;
			}
			if (one[i][j] != 0) {
				if (normal[i].back() > one[i][j]) {
					cout << -1;
					return;
				}
				normal[i].push_back(one[i][j]);
			}
			normal[i].push_back(*now);
			zero.erase(now);
		}
	}
	cout << zero.size() + normal.size() << endl;
	for (int i = 0; i < normal.size(); i++) {
		cout << normal[i].size();
		for (int j = 0; j < normal[i].size(); j++) {
			cout << " " << normal[i][j];
		}
		cout << endl;
	}
	for (auto now : zero) {
		cout << 1 << " " << now << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(15);
	solve();

	return 0;
}