//#include <iostream>

#pragma GCC optimize("unroll-loos")
#pragma GCC oprimize("Ofast")

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef int L;

ifstream cin("input.txt");
ofstream cout("output.txt");

void solve() {
	string s;
	cin >> s;
	if (s[0] == '1' || s.back() == '1') {
		cout << -1;
		exit(0);
	}
	set <int> zero;
	set <int> one;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '1') {
			one.insert(i + 1);
		}
		else {
			zero.insert(i + 1);
		}
	}
	vector <vector <int> > ans;
	while (one.size() != 0 && zero.size() != 0) {
		int first = 0;
		auto flag = zero.lower_bound(first);
		ans.push_back({ *flag });
		zero.erase(flag);
		vector <int> to_erase;
		for (auto now : one) {
			if (now < ans.back().back()) {
				if (ans.back().size() == 1) {
					cout << -1;
				}
				else {
					continue;
				}
			}
			auto kek = zero.lower_bound(now);
			if (kek == zero.end()) {
				cout << -1;
				return;
			}
			to_erase.push_back(now);
			ans.back().push_back(now);
			ans.back().push_back(*kek);
			zero.erase(kek);
		}
		if (ans.back().size() == 1) {
			cout << -1;
			return;
		}
		for (auto now : to_erase) {
			one.erase(now);
		}
	}
	if (one.size() != 0) {
		cout << -1;
		return;
	}
	cout << zero.size() + ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout <<ans[i].size();
		for (int j = 0; j < ans[i].size(); j++) {
			cout << " " << ans[i][j];
		}
		cout << endl;
	}
	for (auto now : zero) {
		cout << 1 << " " << now << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
	cout.precision(15);
	solve();

	return 0;
}