#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <bitset>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cctype>
#include <cmath>
#include <iomanip>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define fr first
#define sc second
#define get0 get<0>
#define get1 get<1>
#define get2 get<2>
#define pb push_back
#define pp pop_back

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tiii;
typedef pair<ll, ll> pll;
typedef tuple<ll, ll, ll> tlll;

const int INF = 1e9 + 7;
const int SZ = 2e5 + 100;
int h[SZ];
int used[SZ];
int c[SZ];
vector<int> cnt[SZ];
vector<int> g[SZ], rg[SZ];
vector<int> cond[SZ];
vector<int> ts;
int cr = 0;

void dfs(int v)
{
    used[v] = 1;
    for (int u : g[v])
        if (!used[u])
            dfs(u);
    ts.pb(v);
}

void dfs2(int v)
{
    //cout << v << ' ' << cr << endl;
    c[v] = cr;
    cnt[cr].pb(v);
    for (int u : rg[v])
        if (!c[u])
            dfs2(u);
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, hm;
    cin >> n >> m >> hm;
    for (int i = 1; i <= n; i++)
        cin >> h[i];
    for (int i = 0; i < m; i++)
    {
        int v1, v2;
        cin >> v1 >> v2;
        if (((h[v1] + 1) % hm) == h[v2])
        {
            g[v1].pb(v2);
            rg[v2].pb(v1);
        }
        if (((h[v2] + 1) % hm) == h[v1])
        {
            g[v2].pb(v1);
            rg[v1].pb(v2);
        }
    }
    for (int i = 1; i <= n; i++)
        if (!used[i])
            dfs(i);
    reverse(ts.begin(), ts.end());
    //for (int v : ts)
    //    cout << v << ' '; cout << endl;
    for (int v : ts)
    {
        if (c[v]) continue;
        cr++;
        dfs2(v);
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
    {
        for (int u : g[i])
        {
            if (c[u] == c[i]) continue;
            cond[c[i]].pb(c[u]);
            //cout << 'k' << ' ' << c[i] << ' ' << c[u] << endl;
        }
    }
    for (int i = 1; i <= cr; i++)
    {
        if (cond[i].size() > 0) continue;
        if (ans == 0 || cnt[ans].size() > cnt[i].size())
            ans = i;
    }
    //cout << ans << endl;
    cout << cnt[ans].size() << endl;
    for (int i : cnt[ans])
        cout << i << ' ';
    return 0;
}