#include<iostream>
#include <vector>

using namespace std;

typedef long long ll;

int main() {
    string s;
    cin >> s;
    int n = s.size();
    vector<int> zeb;
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0') {
            if (zeb.empty() || s[zeb.back()] == '1') {
                zeb.push_back(i);
                used[i] = true;
            }
        } else {
            if (!zeb.empty() && s[zeb.back()] == '0') {
                zeb.push_back(i);
                used[i] = true;
            } else {
                cout << "-1\n";
                return 0;
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ans.push_back(i);
        }
    }
    cout << ans.size() + 1 << "\n";
    cout << zeb.size() << " ";
    for (auto p : zeb) cout << p + 1 << " ";
    cout << "\n";
    for (auto p : ans) {
        cout << "1 " << p + 1 << "\n";
    }
    return 0;
}