#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(),(x).end()
//#define int long long

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <ll> vll;
typedef vector <pii> vpii;
typedef long double ld;

template <typename T1, typename T2> bool umax(T1 &x, const T2 &y){if(x<y)return x=y,true;else return false;}
template <typename T1, typename T2> bool umin(T1 &x, const T2 &y){if(x>y)return x=y,true;else return false;}

template <typename T>
T getint() {
    T x = 0, p = 1;
    char c = getchar();
    while(c == '\n' || c == ' ')
        c = getchar();
    if(c == '-') p = -1, c = getchar();
    while('0' <= c && c <= '9') {
        x = x*10+c-'0';
        c = getchar();
    }
    return x*p;
}

const int N = (int)1e6+10;
const int mod = (int)1e9+7;
const int INF = (int)2e9+10;
const ll LLINF = (ll)1e18+10;
const ld pi = acos(-1.0);
const ld eps = (ld)1e-5;

vi g[N];
int n, m, h;
int u[N];
int in[N];
bool used[N];

void go(int v) {
    used[v] = true;
    for(auto u: g[v]) {
        --in[u];
        if(!in[u] && !used[u])
            go(u);
    }
}

void dfs(int v, vi &ord) {
    ord.pb(v);
    used[v] = true;
    for(auto u: g[v]) {
        if(!used[u]) dfs(u, ord);
    }
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    n = getint<int>();
    m = getint<int>();
    h = getint<int>();
    for(int i = 1; i <= n; ++i) {
        u[i]= getint<int>();
    }
    for(int i = 1; i <= m; ++i) {
        int x = getint<int>();
        int y = getint<int>();
        if(u[x]>u[y]) swap(x, y);
        if(u[y]-u[x]==1) {
            g[x].pb(y);
            in[y]++;
        }
        if(u[y]-u[x]==h-1) {
            g[y].pb(x);
            in[x]++;
        }
    }
    for(int i = 1; i <= n; ++i) {
        if(g[i].size()==0) {
            printf("1\n%d\n", i);
            return 0;
        }
    }
    for(int i = 1; i <= n; ++i) {
        if(!in[i] && !used[i]) go(i);
    }
    vi ans;
    for(int i = 1; i <= n; ++i) {
        if(used[i]) continue;
        vi ord; dfs(i, ord);
        if(!ans.size() || ans.size()>ord.size())
            ans = ord;
    }
    printf("%d\n", (int)ans.size());
    for(auto x: ans) {
        printf("%d ", x);
    }
    return 0;
}
