#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;



void run() {
	
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	assert(p == 1);
	vector<int> mas(2 * n);
	for (int i = 0; i < n; i++)
		cin >> mas[i];

	int l = 0;
	int r = d;
	int s = accumulate(mas.begin(), mas.begin() + d + 1, 0);
	mas[0] = s;
	for (int i = 1; i <= d; i++)
		mas[i] = 0;
	int ans = 0;
	for (int i = 0; i < n - d; i++) {
		if (s >= b) {
			mas[i] = b;
			s -= b;
			s += mas[i + 1 + d];
			mas[i + 1 + d] = 0;
			mas[i + 1] = s;
		}
		else {
			ans++;
			mas[i] = 0;
			mas[i + 1] = s;
			s += mas[i + 1 + d];
			mas[i + 1 + d] = 0;
		}
	}
	for (int i = n - d; i < n; i++) {
		if (s >= b) {
			mas[i] = b;
			s -= b;
		}
		else {
			ans++;
		}
	}

	cout << ans;

}