#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,abm,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <memory.h>
#include <cassert>
#include <string>
#include <chrono>
#include <queue>
#include <deque>
#include <numeric>

using namespace std;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define pii pair<int, int>
#define x first
#define y second
#define pb push_back
#define eb emplace_back

typedef long long ll;
typedef long double ld;

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int INF = 1e9;
const int N = 1e5 + 123;
const int MOD = 1e9 + 7;



void run() {
	
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	assert(p == 1);
	vector<int> mas(n);
	for (int i = 0; i < n; i++)
		cin >> mas[i];

	int s = 0;
	for (int i = 0; i <= d; i++)
		s += mas[i];

	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (s < b) {
			ans++;
		}
		else {
			s -= b;
		}
		int start = (i + 1) * (d + 1);
		for (int j = start; j < min(n, start + d); j++) {
			s += mas[j];
		}
	}

	cout << ans;

}