import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    ArrayList<Integer> g[];
    boolean can[];
    public void solve() throws IOException {
        int n = nextInt();
        can = new boolean[n];
        int m = nextInt();
        int h = nextInt();
        g = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }
        int uc[] = new int[n];
        for (int i = 0; i < n; i++) {
            uc[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            int x = nextInt() - 1, y = nextInt() - 1;
            g[x].add(y);
            g[y].add(x);
        }
        for (int i = 0; i < n; i++) {
            for(int u : g[i]){
                if((uc[i] + 1) % h == uc[u]){
                    can[i] = true;
                    break;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            if(!can[i]){
                out.println(1);
                out.print((i + 1));
                return;
            }
        }
        out.println(n);
        for (int i = 1; i <= n; i++) {
            out.print(i + " ");
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
