import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    int tree[], n, l, r;
    int sz = 1;
    int a[];

    void build() {
        while (sz < n) sz <<= 1;
        tree = new int[2 * sz];
        for (int i = 0; i < n; i++) {
            tree[sz + i] = a[i];
        }
        for (int i = sz - 1; i > 0; i++) {
            tree[i] = tree[2 * i] + tree[2 * i + 1];
        }
    }

    int sign(int x) {
        if (x >= 0) return 1;
        return -1;
    }

    public void solve() throws IOException {
        int n = nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int ans = Integer.MAX_VALUE, cur = 0;
        int mn = 17;

        ArrayList<Integer> bits = new ArrayList<>();
        for (int mask = 0; mask < (1 << mn); mask++) {
            int mask2 = (mask >> (mn / 2));
            int mask3 = (mask & ((1 << (mn / 2)) - 1));
            bits.clear();
            if (Integer.bitCount(mask) >= ans) continue;
            int cnt = -1;
            for (int i = 0; i < mn; i++) {
                if ((mask & (1 << i)) == (1 << i)) {
                    if (cnt == -1 && i >= mn / 2) cnt = bits.size();
                    bits.add(i);
                }
            }
            boolean t = true;
            for (int i = 0; i < n && t; i++) {
                if (a[i] == 0) continue;
                boolean res = false;
                if (a[i] >= 0) {
                    for (int mask1 = 0; mask1 < (1 << bits.size()) && !res; mask1++) {
                        int sum = 0;
                        for (int j = 0; j < cnt; j++) {
                            if ((mask1 & (1 << j)) == (1 << j))
                                sum += (1 << (bits.get(j)));
                        }
                        sum += a[i];
                        if ((sum & mask2) == sum) res = true;
                    }
                } else {
                    for (int mask1 = 0; mask1 < (1 << bits.size()) && !res; mask1++) {
                        int sum = 0;
                        for (int j = cnt; j < bits.size(); j++) {
                            if ((mask1 & (1 << j)) == (1 << j))
                                sum += (1 << (bits.get(j) - mn/2));
                        }
                        sum -= a[i];
                        if ((sum & mask3) == sum) res = true;
                    }
                }
                if (!res) t = false;

            }
            if (t) {
                if (ans > Integer.bitCount(mask)) {
                    ans = Integer.bitCount(mask);
                    cur = mask;
                }
            }
        }
        out.println(ans);
        bits.clear();
        for (int i = 0; i < mn; i++) {
            if ((cur & (1 << i)) == (1 << i)) bits.add(i);
        }
        for (int j = 0; j < bits.size(); j++) {
            out.print(sign(bits.get(j) - mn / 2) * (1 << (sign(bits.get(j) - mn / 2) == -1 ? bits.get(j) : bits.get(j) - mn / 2)) + " ");
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}