import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.sql.Array;
import java.util.*;

public class Main {
    public void solve() throws IOException {
        char s[] = nextToken().toCharArray();
        int n = s.length;
        TreeSet<Integer> set0 = new TreeSet<>(), set1 = new TreeSet<>();
        ArrayList<Integer> a[] = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            a[i] = new ArrayList<>();
            set1.add(i);
        }
        for (int i = 0; i < n; i++) {
            if (s[i] == '0') {
                int j = set1.first();
                a[j].add(i);
                set1.remove(j);
                set0.add(j);
            } else {
                if(set0.size() == 0){
                    out.print(-1);
                    return;
                }
                int j = set0.first();
                a[j].add(i);
                set0.remove(j);
                set1.add(j);
            }
        }
        int cnt = 0;
        for (int j = 0; j < n; j++) {
            if (a[j].size() == 0) break;
            cnt++;
            if (s[a[j].get(a[j].size() - 1)] == '1') {
                out.print(-1);
                return;
            }
        }
        StringBuilder sb = new StringBuilder();
        sb.append(cnt);
        sb.append("\n");

        for (int i = 0; i < cnt; i++) {
            sb.append(a[i].size());
            sb.append(" ");

            for (int j : a[i]) {
                sb.append(j + 1);
                sb.append(" ");
            }
            sb.append("\n");
        }
        out.print(sb);

    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer sc;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
