#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 2e5 + 123;

int n, m, hours;
int u[N];
int c1[N], c2[N];
vector<int> g[N], h[N];
int comps;
int cnt[N];
vector<int> comp[N];
bool used[N];
vector<int> ord;
int deg[N];
int what[N];

void dfs1(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (!used[u]) {
			dfs1(u);
		}
	}
	ord.pb(v);
}

void dfs2(int v, int cur) {
	used[v] = 1;
	comp[cur].pb(v);
	what[v] = cur;
	for (int u : h[v]) {
		if (!used[u]) {
			dfs2(u, cur);
		}
	}
}

void run() {
	cin >> n >> m >> hours;
	rep(i, 0, n) {
		cin >> u[i];
	}
	rep(i, 0, m) {
		cin >> c1[i] >> c2[i];
		c1[i]--; c2[i]--;
		if ((u[c1[i]] + 1) % hours == u[c2[i]]) {
			g[c1[i]].pb(c2[i]);
			h[c2[i]].pb(c1[i]);
		}
		if ((u[c2[i]] + 1) % hours == u[c1[i]]) {
			g[c2[i]].pb(c1[i]);
			h[c1[i]].pb(c2[i]);
		}
	}
	
	rep(i, 0, n) {
		if (!used[i]) dfs1(i);
	}
	
	memset(used, 0, sizeof used);
	reverse(all(ord));
	for (int v : ord) {
		if (!used[v]) {
			dfs2(v, comps);
			comps++;
		}
	}
	
	rep(v, 0, n) {
		for (int u : g[v]) {
			int uu = what[u];
			int vv = what[v];
			if (uu != vv) {
				deg[vv]++;
			}
		}
	}
	
	int ans = INF;
	int best_comp = -1;
	rep(i, 0, comps) {
		if (deg[i]) continue;
		if (mini(ans, sz(comp[i]))) {
			best_comp = i;
		}
	}
	cout << ans << "\n";
	for (int v : comp[best_comp]) {
		cout << v + 1 << " ";
	}
	cout << "\n";
}
