#pragma GCC target("popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 1e6 + 123;
const ll LINF = (ll) 1e18 + 1e9 + 123;

#define rep(i, s, t) for (auto i = (s); i < (t); ++(i))
#define per(i, s, t) for (auto i = (s); i >= (t); --(i))
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back

template<typename A, typename B> bool mini(A &x, const B &y) {
	if (y < x) {
		x = y;
		return 1;
	}
	return 0;
}

template<typename A, typename B> bool maxi(A &x, const B &y) {
	if (y > x) {
		x = y;
		return 1;
	}
	return 0;
}

void run();

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = 2005;
const int K = 14;

int n;
int a[N];
bitset<N> dp[1 << K];

void run() {
	cin >> n;
	int mi = INF, ma = -INF;
	rep(i, 0, n) {
		cin >> a[i];
		mini(mi, a[i]);
		maxi(ma, a[i]);
	}
	int x = max(ma, abs(mi));
	int k = 10;
	
	int ans = INF;
	int best_pos = -1, best_neg = -1;
	
	rep(mask, 0, 1 << k) {
		rep(i, 0, 1 << k) {
			dp[i].reset();
		}
		for (int submask = mask; submask > 0; submask = (submask - 1) & mask) {
			int pos = submask;
			rep(i, 0, n) {
				int neg = pos - a[i];
				if (neg >= 0) {
					dp[neg][i] = 1;
				}
			}
		}
		rep(i, 0, n) {
			if (a[i] <= 0) {
				dp[-a[i]][i] = 1;
			}
		}
		
		int cur_cnt = __builtin_popcount(mask);
		
		rep(i, 0, 1 << k) {
			if (i) {
				int w = i & (i - 1);
				dp[i] |= (dp[w] | dp[i ^ w]);
			}
			if ((int)dp[i].count() == n && mini(ans, cur_cnt + __builtin_popcount(i))) {
				best_pos = mask;
				best_neg = i;
			}
		}
	}
	
	assert(ans != INF);
	
	cout << ans << "\n";
	rep(i, 0, k) if (best_pos & (1 << i)) cout << (1 << i) << " ";
	rep(i, 0, k) if (best_neg & (1 << i)) cout << (-(1 << i)) << " ";
	cout << "\n";
}
