#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 100001;

int n, m, h, mini, col;
int t[N], c[N];
vector<int> a[N], b[N];
bool was[N];
int used[N];
vector<int> s;
vector<int> ans;

void dfs(int v)
{
    was[v] = true;
    for (int i = 0; i < a[v].size(); i++)
    {
        int u = a[v][i];
        if (!was[u])
        {
            dfs(u);
        }
    }
    s.push_back(v);
}

void dfs_r(int v)
{
    used[v] = col;
    for (int i = 0; i < b[v].size(); i++)
    {
        int u = b[v][i];
        if (!used[u])
        {
            dfs_r(u);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
    {
        cin >> t[i];
    }
    int x, y;
    for (int i = 0; i < m; i++)
    {
        cin >> x >> y;
        x--, y--;
        if ((t[x] + 1) % h == t[y]) {
            a[x].push_back(y);
            b[y].push_back(x);
        }
        if ((t[y] + 1) % h == t[x]) {
            a[y].push_back(x);
            b[x].push_back(y);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (a[i].size() == 0)
        {
            cout << 1 << endl;
            cout << i + 1 << endl;
            return 0;
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!was[i])
            dfs(i);
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[s[i]])
        {
            col++;
            dfs_r(s[i]);
        }
    }
    for (int i = 0; i < n; i++)
    {
        used[i]--;
        //cout << used[i] << ' ';
        c[used[i]]++;
    }
    for (int i = 0; i < n; i++)
    {
        b[i].clear();
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < a[i].size(); j++)
        {
            int u = a[i][j];
            if (used[i] != used[u])
                b[used[i]].push_back(used[u]);
        }
    }
    mini = -1;
    int ind = -1;
    for (int i = 0; i < col; i++)
    {
        if (b[i].size() == 0)
        {
            if (mini == -1 || mini > c[i])
            {
                mini = c[i];
                ind = i;
            }
        }
    }
    if (mini == -1)
    {
        return 1;
    }
    cout << mini << endl;
    for (int i = 0; i < n; i++)
    {
        if (used[i] == ind)
        {
            cout << i + 1 << ' ';
        }
    }

    return 0;
}

/*
3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3

2 1 2
0 1
1 2

4 5 3
0 2 0 1
1 4
1 2
2 4
2 3
3 4

3 2 2
0 1 1
1 2
1 3

6 7 3
0 1 2 0 1 2
1 2
2 3
3 4
4 5
5 6
6 1
1 5

 4

*/
