#define _CRT_SECURE_NO_WARNINGS
typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<algorithm>
#include<map>
#include<cmath>
#include<math.h>
#include<set>
#include<queue>
#include<deque>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<bitset>
#include<stack>

using namespace std;
ll INF = 1e17;
ld eps = 1e-9;
ll MOD = 1e9 + 7;
ld PI = atan2(0, -1);

vector<vector<int>>g;
vector<int>used;
stack<int>main_q;

void dfs(int v, int st,stack<int>&q) {
	q.push(v);
	used[v] = 1;
	for (auto to : g[v]) {
		if (used[to] == 0) {
			dfs(to,v,q);
		}
		else {
			if (to == st && main_q.size() > q.size()) {
				main_q = q;
			}
		}
	}
	q.pop();
}

int main() {
	cin.tie(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	int n, m, h;
	cin >> n >> m >> h;
	g.resize(n + 1);
	vector<int>u(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> u[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
		}
		if ((u[b] + 1) % h == u[a]) {
			g[b].push_back(a);
		}
	}
	for (int i = 1; i <= n; i++) {
		sort(g[i].begin(), g[i].end());
		g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
	}

	stack<int>ans;
	for (int i = 1; i <= n; i++) {
		ans.push(i);
	}

	for (int i = 1; i <= n; i++) {
		if (g[i].size() == 0) {
			cout << 1 << '\n' << i;
			return 0;
		}
		used.assign(n + 1, 0);
		stack<int>q;
		while (!main_q.empty()) {
			main_q.pop();
		}
		dfs(i, i, q);
	}

	cout << ans.size() << endl;
	while (!ans.empty()) {
		cout << ans.top() << ' ';
		ans.pop();
	}

	return 0;
}