#define _CRT_SECURE_NO_WARNINGS
typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<algorithm>
#include<map>
#include<cmath>
#include<math.h>
#include<set>
#include<queue>
#include<deque>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<bitset>
#include<stack>

using namespace std;
ll INF = 1e17;
ld eps = 1e-9;
ll MOD = 1e9 + 7;
ld PI = atan2(0, -1);

vector<vector<int>>g;
vector<vector<int>>rev_g;
vector<int>used;
vector<int>order;
int color = 0;
vector<vector<int>>comp;
vector<int>color_v;


 void good_dfs(int v) {
	used[v] = 1;
	for (auto to : g[v]) {
		if (used[to] == 0) {
			good_dfs(to);
		}
	}
	order.push_back(v);
}

void dfs2(int v) {
	used[v] = 1;
	comp[color].push_back(v);
	color_v[v] = color;
	for (auto to : rev_g[v]) {
		if (used[to] == 0) {
			dfs2(to);
		}
	}
}




int main() {
	cin.tie(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	int n, m, h;
	cin >> n >> m >> h;
	g.resize(n + 1);
	rev_g.resize(n+1);
	vector<int>u(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> u[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		if ((u[a] + 1) % h == u[b]) {
			g[a].push_back(b);
			rev_g[b].push_back(a);
		}
		if ((u[b] + 1) % h == u[a]) {
			g[b].push_back(a);
			rev_g[a].push_back(b);
		}
	}
	for (int i = 1; i <= n; i++) {
		sort(g[i].begin(), g[i].end());
		g[i].erase(unique(g[i].begin(), g[i].end()), g[i].end());
		sort(rev_g[i].begin(), rev_g[i].end());
		rev_g[i].erase(unique(rev_g[i].begin(), rev_g[i].end()), rev_g[i].end());
	}

	used.assign(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		if (used[i] == 0) {
			good_dfs(i);
		}
	}
	used.assign(n + 1, 0);
	color_v.resize(n + 1, 0);
	reverse(order.begin(), order.end());
	for (int i = 0; i < order.size(); i++) {
		if (used[order[i]] == 0) {
			comp.push_back({});
			dfs2(order[i]);
			color++;
		}
	}

	int ans = INF;
	int num_ans = 0;

	for (int i = 1; i < comp.size(); i++) {
		int fl = 1;
		for (auto now : comp[i]) {
			if (fl == 0) {
				break;
			}
			for (auto to : g[now]) {
				if (color_v[to] != color_v[now]) {
					fl = 0;
					break;
				}
			}
		}
		if (fl == 1 && comp[i].size() < ans) {
			ans = comp[i].size();
			num_ans = i;
		}
	}


	cout << ans << endl;
	for (auto now : comp[num_ans]) {
		cout << now << ' ';
	}

	return 0;
}

/*
5 5 3
0 1 2 1 2
1 2
2 3
3 1
4 5
1 5
5
5 4 3 2 1


*/