#include <bits/stdc++.h>
#define fr first
#define sc second

using namespace std;
#define int long long
typedef pair<int, int> ii;
typedef long long ll;
typedef unsigned long long u64;
const int NMAX = 1e5 + 9, INF = 1e9 + 7, MOD = 1e9 + 7;

int fnw[NMAX];

int get(int i) {
    int ans = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        ans += fnw[i];
    }
    return ans;
}

void upd(int i, int x) {
    for (; i < NMAX; i |= (i + 1)) {
        fnw[i] += x;
    }
}

int getSum(int l, int r) {
    if (l == 0) {
        return get(r);
    }
    return get(r) - get(l - 1);
}

main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
    #endif
    ios::sync_with_stdio(0);

    ll p, n, b, d;
    cin >> p >> n >> d >> b;

    vector<int> arr(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        upd(i, arr[i]);
    }

    int ans = 0, rzero = 0;
    if (p == 1) {
        for (int i = 0; i < n; ++i) {
            int l = i - 1, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (getSum(i, m) >= b) {
                    r = m;
                } else {
                    l = m;
                }
            }
            if (r == n) {
                assert(0);
                //if 1 person
                ans += n - i;
                cout << ans;
                return 0;
            }

            if (r - i > (i + 1) * d) {
                upd(i + 1, arr[i]);
                arr[i + 1] += arr[i];
                ++ans;
                continue;
            }
            if (r == i && arr[i] >= b) {
                upd(i + 1, arr[i] - b);
                arr[i + 1] += arr[i] - b;
                continue;
            }

            int x = getSum(i, r);
            if (x > b) {
                assert(arr[r] > (x - b));
                upd(r, (x - b) - arr[r]);
                arr[r] = x - b;
            }
            for (int j = max(rzero, i + 1); j < r + (x == b); ++j) {
                upd(j, -arr[j]);
                arr[j] = 0;
            }
            rzero = max(rzero, r);
        }
        cout << ans;
    }
}
