#include <bits/stdc++.h>
#define pb push_back
#define cina(a, n) a.resize(n); for (auto &i: a) cin >> i;
#define sz(s) ((ll)s.size())

using namespace std;

typedef long long ll;
typedef long double ld;

const ll LINF = (ll)(1e18) + 9;
const int INF = 1e9 + 9;
const ll M = (1ll << 31) - 1;
const ld EPS = 1e-13;

vector <vector<int> > a, ar;
vector<int> h, ts, ans, ans2;
vector<bool> used, ans3;
ll n, m, k;
string s;

void dfs(int v)
{
    used[v] = 1;
    for (auto i: a[v])
        if (!used[i])
            dfs(i);
    ts.pb(v);
}

void dfs2(int v, int cnt)
{
    used[v] = 1;
    for (auto i: ar[v])
        if (!used[i])
            dfs2(i, cnt);
    ans[cnt]++;
    ans2[v] = cnt;
}

int main()
{
    ios_base::sync_with_stdio(0);
    #ifdef MAKS
    {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    #endif // MAKS
    cout << fixed << setprecision(8);
    cin >> n >> m >> k;
    cina(h, n);
    a.resize(n);
    ar.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++)
    {
        int q, w;
        cin >> q >> w;
        q--;
        w--;
        if ((h[q] + 1) % k == h[w])
        {
            a[q].pb(w);
            ar[w].pb(q);
        }
        if ((h[w] + 1) % k == h[q])
        {
            a[w].pb(q);
            ar[q].pb(w);
        }

    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);

    reverse(ts.begin(), ts.end());
    for (int i = 0; i < n; i++)
        used[i] = 0;
    ans2.resize(n);
    int cnt = 0, rez = 0;
    for (int i = 0; i < n; i++)
    {
        //cout << ts[i] << ' ';
        if (!used[ts[i]])
        {
            ans.pb(0);
            dfs2(ts[i], cnt);
            cnt++;
        }
    }
    //cout << '\n';

    ans3.resize(cnt);
    for (int i = 0; i < n; i++)
    {
        //cout << ans2[i] << ' ';
        if (ans3[i])
            continue;
        bool bo = 0;
        for (auto j: a[i])
            if (ans2[i] != ans2[j])
                bo = 1;
        if (bo)
            ans3[i] = 1;
        else
            rez = ans2[i];
    }
    //cout << '\n';

    for (int i = 0; i < cnt; i++)
    {
        if ((!ans3[i]) && ans[rez] > ans[i])
            rez = i;
        //cout << i << ' ' << ans3[i] << ' ' << ans[rez] << ' ' << ans[i] << ' ' << rez << '\n';
    }

    cout << ans[rez] << '\n';
    for (int i = 0; i < n; i++)
        if (ans2[i] == rez)
            cout << i + 1 << ' ';
    return 0;
}
