#include <bits/stdc++.h>
#define pb push_back
#define cina(a, n) a.resize(n); for (auto &i: a) cin >> i;
#define sz(s) ((ll)s.size())

using namespace std;

typedef long long ll;
typedef long double ld;

const ll LINF = (ll)(1e18) + 9;
const int INF = 1e9 + 9;
const ll M = (1ll << 31) - 1;
const ld EPS = 1e-13;

ll n, m, k;
string s;
vector <vector<int> > a, ar;
vector<int> h, ts, ans1, ans2;
vector <bool> used, bans;

void dfs(int v)
{
    used[v] = 1;
    for (auto i: a[v])
        if (!used[i])
            dfs(i);
    ts.pb(v);
}

void dfs2(int v, int cnt)
{
    ans2[v] = cnt;
    ans1[cnt]++;
    for (auto i: ar[v])
    {
        if (ans2[i] == -1)
            dfs2(i, cnt);
        else
            if (ans2[i] != cnt)
                bans[ans2[i]] = 1;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    #ifdef MAKS
    {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    #endif // MAKS
    cout << fixed << setprecision(8);
    cin >> n >> m >> k;
    cina(h, n);
    a.resize(n);
    ar.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++)
    {
        int q, w;
        cin >> q >> w;
        q--;
        w--;
        if ((h[q] + 1) % k == h[w])
        {
            a[q].pb(w);
            ar[w].pb(q);
        }
        if ((h[w] + 1) % k == h[q])
        {
            a[w].pb(q);
            ar[q].pb(w);
        }
    }
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);

    reverse(ts.begin(), ts.end());
    ans2.resize(n, -1);
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        if (ans2[ts[i]] == -1)
        {
            ans1.pb(0);
            bans.pb(0);
            dfs2(ts[i], cnt);
            cnt++;
        }
    }

    int rez = 0;
    for (int i = 0; i < cnt; i++)
    {
        if (bans[i])
            continue;
        if (bans[rez] || ans1[rez] >= ans1[i])
            rez = i;
    }

    cout << ans1[rez] << '\n';
    for (int i = 0; i < n; i++)
        if (ans2[i] == rez)
            cout << i + 1 << ' ';
    return 0;
}
