#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

#define F first
#define S second
#define add push_back
#define ins insert
#define sz(x) (x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

const ll INF = (ll)1e9 + 2018;

const int N = 1e5 + 10;
int arr[N];
set <int> cant[N], must[N];
bool used[N];
set <int> comp;

void dfs(int v) {
    used[v] = 1;
    for (int u : must[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    comp.ins(v);
}

void $main() {
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    int cnt = 0;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if (arr[u] == arr[v]) {
            cant[u].ins(v);
            cant[v].ins(u);
            cnt++;
        }
        if ((arr[u] + 1) % h == arr[v]) {
            must[u].ins(v);
        }
        if ((arr[v] + 1) % h == arr[u]) {
            must[v].ins(u);
        }
    }
    vector <int> ans;
    ans.resize(n + 10, INF);
    for (int i = 0; i < n; i++) {
        memset(used, 0, sizeof(used));
        comp.clear();
        dfs(i);
        int res = 0;
        bool f = 1;
        for (int v : comp) {
            for (int u : cant[v]) {
                if (comp.count(u)) {
                    f = 0;
                    break;
                }
                res++;
            }
            if (!f) {
                break;
            }
        }
        if (res != cnt) {
            f = 0;
        }
        if (f) {
            if (sz(comp) < sz(ans)) {
                ans.clear();
                for (int v : comp) {
                    ans.add(v);
                }
            }
        }
    }
    cout << sz(ans) << endl;
    for (int it : ans) {
        cout << it + 1 << " ";
    }
}

int main() {
    ios::sync_with_stdio(0);
#ifdef flaax
    freopen("input.txt", "r", stdin);
#endif
    $main();
}
