#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define X first
#define Y second
#define inb push_back

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	vector<int> us(n), was(n);
	int sz = 0;
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '1')
		{
			int j = i - 1, x;
			for(; j >= 0; --j)
				if (s[j] == '0' && !was[j])
				{
					if (us[j]) was[j] = x = us[j];
					else was[j] = x = ++sz;
					break;
				}
			if (j == -1) cout << "-1", exit(0);
			us[i] = was[i] = x;
			j = i + 1;
			for(; j < n; ++j)
				if (s[j] == '0' && !us[j])
				{
					us[j] = x;
					break;
				}
			if (j == n) cout << "-1", exit(0);
		}
	}
	vector<int> ans;
	vector<vector<int>> dd;
	for (int i = 0; i < sz; ++i)
	{
		ans.clear();
		for(int j = 0; j < n; ++j)
			if (us[j] == sz || was[j] == sz)
			{
				ans.inb(j);
			}
		dd.inb(ans);
	}
	for(int i = 0; i < n; ++i)
		if (!us[i] && !was[i])
		{
			ans.clear();
			ans.inb(i);
			dd.inb(ans);
		}
	cout << dd.size() << '\n';
	for (int i = 0; i < dd.size(); ++i)
	{
		cout << dd[i].size() << ' ';
		for (int j : dd[i]) cout << j + 1 << ' ';
		cout << '\n';
	}
}