#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <set>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

#define X first
#define Y second
#define inb push_back

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s;
	cin >> s;
	int n = s.size();
	vector<int> us(n), was(n);
	int sz = 0;
	set<int> sl, sr;
	for (int i = n - 1; i >= 0; --i)
		if (s[i] == '0') sr.insert(i);
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '1')
		{
			if (!sl.size()) cout << -1, exit(0);
			int j = *sl.rbegin(), x;
			sl.erase(j);
			if (us[j]) was[j] = x = us[j];
			else was[j] = x = ++sz;
			us[i] = was[i] = x;
			if (!sr.size()) cout << -1, exit(0);
			j = *sr.begin();
			sr.erase(j);
			us[j] = x;
		}
		else
		{
			sl.insert(i);
			sr.erase(i);
		}
	}
	vector<int> ans;
	vector<vector<int>> dd;
	for (int i = 1; i <= sz; ++i)
	{
		ans.clear();
		for(int j = 0; j < n; ++j)
			if (us[j] == i || was[j] == i)
			{
				ans.inb(j);
			}
		dd.inb(ans);
	}
	for(int i = 0; i < n; ++i)
		if (!us[i] && !was[i])
		{
			ans.clear();
			ans.inb(i);
			dd.inb(ans);
		}
	cout << dd.size() << '\n';
	for (int i = 0; i < dd.size(); ++i)
	{
		cout << dd[i].size() << ' ';
		for (int j : dd[i]) cout << j + 1 << ' ';
		cout << '\n';
	}
}