#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 200100;

bool used[N];
int n;

bool cmp(int a, int b) {
    return std::min(a, n - a - 1) < std::min(b, n - b - 1);
}

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string str;
    std::cin >> str;
    n = str.size();
    int zeroL = 0, zeroR = n - 1;
    std::vector<std::vector<int>> ans;
    std::vector<int> order;
    for (int i = 0; i < n; ++i) {
        if (str[i] == '1') {
            order.push_back(i);
        }
    }
    std::sort(order.begin(), order.end(), cmp);
    for (auto i: order) {
        if (str[i] == '1') {
            while (zeroL < i && (used[zeroL] || str[zeroL] != '0')) {
                ++zeroL;
            }
            if (zeroL == i) {
                std::cout << "-1\n";
                return 0;
            }
            used[zeroL] = true;//try
            while (zeroR > i && (used[zeroR] || str[zeroR] != '0')) {
                --zeroR;
            }
            if (zeroR == i) {
                std::cout << "-1\n";
                return 0;
            }
            used[zeroR] = true;
            ans.push_back(std::vector<int>());
            ans.back().push_back(zeroL);
            ans.back().push_back(i);
            ans.back().push_back(zeroR);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (str[i] == '0' && !used[i]) {
            ans.push_back(std::vector<int>());
            ans.back().push_back(i);
        }
    }
    std::cout << ans.size() << '\n';
    for (auto i: ans) {
        std::cout << i.size() << ' ';
        for (auto j: i) {
            std::cout << j + 1 << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}