#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 200100;

bool used[N];
int n;

bool cmp(int a, int b) {
    return std::min(a, n - a - 1) < std::min(b, n - b - 1);
}

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string str;
    std::cin >> str;
    n = str.size();
    std::vector<std::vector<int>> res;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }
        res.push_back(std::vector<int>());
        bool zero = true;
        for (int j = i; j < n; ++j) {
            if (used[j]) {
                continue;
            }
            if (str[j] == '0' && zero || str[j] == '1' && !zero) {
                res.back().push_back(j + 1);
                used[j] = true;
                zero = !zero;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            std::cout << "-1\n";
            return 0;
        }
    }
    for (auto i: res) {
        if (str[i[0] - 1] != '0' || str[i.back() - 1] != '0') {
            std::cout << "-1\n";
            return 0;
        }
    }
    std::cout << res.size() << '\n';
    for (auto i: res) {
        std::cout << i.size() << ' ';
        for (auto j: i) {
            std::cout << j << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}