// O(n^2)

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const ll LINF = (ll)1e18 + 10;
const double EPS = 1e-8;
const double PI = atan2(0, -1);

const int N = 200100;

bool used[N];
int n;

bool cmp(int a, int b) {
    return std::min(a, n - a - 1) < std::min(b, n - b - 1);
}

int main(void) {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::string str;
    std::cin >> str;
    n = str.size();
    std::vector<std::vector<int>> res;
    std::set<int> need0, need1;
    for (int i = 0; i < n; ++i) {
        if (str[i] == '0') {
            if (need0.empty()) {
                res.push_back(std::vector<int>());
                res.back().push_back(i + 1);
                need1.insert(res.size() - 1);
            } else {
                int id = *need0.begin();
                need0.erase(need0.begin());
                res[id].push_back(i + 1);
                need1.insert(id);
            }
        } else {
            if (need1.empty()) {
                std::cout << "-1\n";
                return 0;
            }
            int id = *need1.begin();
            need1.erase(need1.begin());
            res[id].push_back(i + 1);
            need0.insert(id);
        }
    }
    std::cout << res.size() << '\n';
    for (auto i: res) {
        std::cout << i.size() << ' ';
        for (auto j: i) {
            std::cout << j << ' ';
        }
        std::cout << '\n';
    }
    return 0;
}