//{

#include <bits/stdc++.h>

#define forn(i, n) for (auto i = 0; i <= n; i++)
#define mp make_pair
#define pb push_back
#define all(x) x.begin (), x.end ()
#define rall(x) x.rbegin (), x.rend ()

using namespace std;

typedef long long lli;
typedef long double ld;

//}

int n = 0, m = 0, h = 0;
vector <vector <int>> data;
vector <int> u;

int Mod (int a, int b)
{
    return (a % b + b) % b;
}

int Add (int a, int b)
{
    return Mod (a + b, h);
}

int Sub (int a, int b)
{
    return Mod (a - b, h);
}

void DFS (vector <bool>& used, vector <int>& increase, int v)
{
    used[v] = true;
    for (auto it : data[v])
    {
        if (u[it] == u[v])
        {
            u[it] = Add (u[it], 1);
            increase.push_back (it);
            DFS (used, increase, it);
        }
    }
}

vector <int> Check (int v)
{
    vector <int> increase;
    u[v] = Add (u[v], 1);
    increase.push_back (v);
    vector <bool> used (n);
    for (auto it : data[v])
    {
        if (u[it] == u[v])
        {
            u[it] = Add (u[it], 1);
            increase.push_back (it);
            DFS (used, increase, it);
        }
    }
    for (auto it : increase)
        u[it] = Sub (u[it], 1);
    return increase;
}

void Solve ()
{
    cin >> n >> m >> h;
    data.resize (n);
    u.resize (n);
    for (int i = 0; i < n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++)
    {
        int a = 0, b = 0;
        cin >> a >> b;
        a--, b--;
        data[a].push_back (b);
        data[b].push_back (a);
    }
    vector <int> value = Check (0);
    for (int i = 0; i < n; i++)
    {
        vector <int> tmp = Check (i);
        if (tmp.size () < value.size ())
            value = tmp;
    }
    cout << value.size () << '\n';
    for (auto it : value)
        cout << it + 1 << ' ';
}

signed main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
    cout << fixed << setprecision (20);
    Solve ();
    return 0;
}
