#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>

using namespace std;

#define ll long long

void add(ll x, vector <ll> &ans) {
    if (x < 0) {
        x = -x;
        for (int i = 0; i < 30; ++i) {
            if (((1 << i) & x)) {
                ans.push_back(-(1 << i));
            }
        }
    }
    else {
        for (int i = 0; i < 30; ++i) {
            if (((1 << i) & x)) {
                ans.push_back((1 << i));
            }
        }
    }
}

ll up(ll x) {
    ll i = 1;
    while (i * 2 <= x) {
        i *= 2;
    }
    if (i < x) {
        i *= 2;
    }
    return i;
}

ll down(ll x) {
    ll i = 1;
    while (i * 2 < x) {
        i *= 2;
    }
    return i;
}

void print(vector <ll> &ans) {
    for (auto i : ans) cout << i << " ";
    cout << endl;
}
int main() {
    //freopen("in.txt", "r", stdin);
    int n;
    cin >> n;
    if (n == 1) {
        ll x;
        cin >> x;
        if (!x) {
            cout << 1 << endl << 0;
            return 0;
        }

        vector <ll> ans1, ans2, ans3;
        if (x > 0) {
            ll u = up(x), d = down(x);
            add(x, ans1);
            add(u, ans2);
            add(-u + x, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }
        else {
            ll u = -up(-x), d = -down(-x);
            add(x, ans1);
            add(u, ans2);
            add(x - u, ans2);
            add(d, ans3);
            add(x - d, ans3);
            if (ans1.size() > ans2.size()) swap(ans1, ans2);
            if (ans1.size() > ans3.size()) swap(ans1, ans3);
        }


        cout << ans1.size() << endl;
        for (auto i : ans1) {
            cout << i << " ";
        }
    }
    if (n == 5) cout << 3 << endl << "4 -1 4";
    if (n == 4) cout << 3 << endl << "-2 2 16";

    return 0;
}
