#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>

using namespace std;

vector<vector<int> > g;
vector<bool> used;
vector<int> used1, dp;

void dfs(int v, int d)
{
    used1[v] = 1;
    for(int i = 0; i < g[v].size(); i++)
    {
        int to = g[v][i];
        if(used1[to] == 1)
            dp[v] = max(dp[to], d);
        else
        {
            if(used1[to] == 0)
                dfs(to, d + 1);
            dp[v] = dp[to] + 1;
        }
    }
    used1[v] = 2;
}

void print(int v)
{
    used[v] = true;
    cout << v + 1 << " ";
    for(int i = 0; i < g[v].size(); i++)
        if(!used[g[v][i]])
            print(g[v][i]);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    g = vector<vector<int> >(n);
    used1.assign(n, 0);
    dp.assign(n, 0);
    vector<int> time(n);
    for(int i = 0; i < n; i++)
        cin >> time[i];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if(time[a] > time[b])
            swap(a, b);

        if(time[a] + 1 == time[b])
            g[a].push_back(b);
        if(time[a] == 0 && time[b] == h - 1)
            g[b].push_back(a);
    }

    for(int i = 0; i < n; i++)
        if(used1[i] == 0)
            dfs(i, 0);

    /*for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < g[i].size(); j++)
            cout << g[i][j] << " ";
        cout << endl;
    }*/


    //for(int i = 0; i < n; i++)
    //    cout << dp[i] << " ";

    used.assign(n, false);
    auto it = min_element(dp.begin(), dp.end());
    cout << *it + 1 << endl;
    print(it - dp.begin());
}

/*!

4 5 4
2 1 0 3
4 3
3 2
2 1
1 4
1 3

!*/
