#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>

using namespace std;

vector<vector<int> > g;
vector<bool> used;

void dfs(int v)
{
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++)
    {
        int to = g[v][i];
        if(!used[to])
            dfs(to);
    }
}

void print(int v)
{
    used[v] = true;
    cout << v + 1 << " ";
    for(int i = 0; i < g[v].size(); i++)
        if(!used[g[v][i]])
            print(g[v][i]);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    g = vector<vector<int> >(n);
    vector<int> time(n);
    for(int i = 0; i < n; i++)
        cin >> time[i];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if(time[a] > time[b])
            swap(a, b);

        if(time[a] + 1 == time[b])
            g[a].push_back(b);
        if(time[a] == 0 && time[b] == h - 1)
            g[b].push_back(a);
    }

    int answer = 1e9;
    vector<int> result;
    for(int i = 0; i < n; i++)
    {
        used.assign(n, false);
        dfs(i);
        int ans = 0;
        vector<int> res;
        for(int i = 0; i < n; i++)
        {
            if(used[i])
            {
                ans++;
                res.push_back(i);
            }
        }

        if(ans < answer)
        {
            answer = ans;
            result = res;
        }
    }

    cout << answer << endl;
    for(int i = 0; i < result.size(); i++)
        cout << ++result[i] << " ";
}

/*!

4 5 4
2 1 0 3
4 3
3 2
2 1
1 4
1 3

!*/
