#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>

using namespace std;

vector<vector<int> > g, gt;
vector<bool> used;
vector<int> sorted, comp, cmp, value, dp, res;

void dfs1(int v)
{
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++)
        if(!used[g[v][i]])
            dfs1(g[v][i]);
    sorted.push_back(v);
}

void dfs2(int v)
{
    used[v] = true;
    for(int i = 0; i < gt[v].size(); i++)
        if(!used[gt[v][i]])
            dfs2(gt[v][i]);
    comp.push_back(v);
}

void dfs3(int v)
{
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++)
    {
        if(!used[g[v][i]])
            dfs3(g[v][i]);
        dp[v] = max(dp[v], dp[g[v][i]] + 1);
    }
}

void dfs4(int v)
{
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++)
        if(!used[g[v][i]])
            dfs4(g[v][i]);
    res.push_back(v);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int n, m, h;
    cin >> n >> m >> h;
    g = vector<vector<int> >(n);
    gt = g;
    used.assign(n, false);
    vector<pii> req;

    vector<int> time(n);
    for(int i = 0; i < n; i++)
        cin >> time[i];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        req.push_back({a, b});
        a--;
        b--;
        if(time[a] > time[b])
            swap(a, b);

        if(time[a] + 1 == time[b])
        {
            g[a].push_back(b);
            gt[b].push_back(a);
        }
        if(time[a] == 0 && time[b] == h - 1)
        {
            g[b].push_back(a);
            gt[a].push_back(b);
        }
    }

    for(int i = 0; i < n; i++)
        if(!used[i])
            dfs1(i);

    int counter = 0;
    cmp.resize(n);
    used.assign(n, false);
    vector<vector<int> > results;
    for(size_t i = sorted.size(); i--; )
    {
        if(used[sorted[i]])
            continue;
        dfs2(sorted[i]);
        for(int i = 0; i < comp.size(); i++)
            cmp[comp[i]] = counter;
        counter++;
        value.push_back(comp.size());
        results.push_back(comp);
        comp.clear();
    }

    g = vector<vector<int> >(counter);
    for(int i = 0; i < m; i++)
    {
        int a = req[i].first - 1, b = req[i].second - 1;
        if(time[a] > time[b])
            swap(a, b);

        if(time[a] + 1 == time[b])
            g[cmp[a]].push_back(cmp[b]);
        if(time[a] == 0 && time[b] == h - 1)
            g[cmp[b]].push_back(cmp[a]);
    }

    dp.assign(counter, 0);
    used.assign(counter, false);
    for(int i = 0; i < counter; i++)
        if(!used[i])
            dfs3(i);

    //for(int i = 0; i < counter; i++)
    //    cout << dp[i] << " ";

    used.assign(counter, false);
    auto it = min_element(dp.begin(), dp.end());
    dfs4(it - dp.begin());

    vector<int> ans;
    for(int i = 0; i < res.size(); i++)
    {
        int k = res[i];
        for(int j = 0; j < results[k].size(); j++)
            ans.push_back(results[k][j]);
    }

    cout << ans.size() << endl;
    for(int i = 0; i < ans.size(); i++)
        cout << ++ans[i] << " ";
}

/*!

3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
2 1
1 4
1 3

!*/
