#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 10;

vector <int> g[MAXN];
vector <int> tg[MAXN];
int t1[MAXN], t2[MAXN];

bool used[MAXN];

set <int> st;

void dfs(int u)
{
    st.insert(u);
    used[u] = 1;
    for (int v : g[u])
        if (!used[v])
            dfs(v);
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
    {
        cin >> t1[i];
        t2[i] = (t1[i] + 1) % h;
    }
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        tg[u].push_back(v);
        tg[v].push_back(u);
    }

    int ans = n + 1, ansu = 0;
    for (int u = 1; u <= n; u++)
    {
        for (int v : tg[u])
        {
            if (t2[u] == t1[v])
            {
                g[u].push_back(v);
//                cout << u << " " << v;
            }
        }
    }

    for (int u = 1; u <= n; u++)
        if (g[u].empty())
            return cout << "1\n" << u, 0;

    int sz = n + 1;
    set <int> best;
    for (int u = 1; u <= n; u++)
    {
        if (!used[u])
        {
            st.clear();
            dfs(u);
            bool ok = 1;
            for (int i : st)
                for (int v : tg[i])
                    if (st.find(v) != st.end() && t2[i] == t2[v])
                        ok = 0;
            if (ok && st.size() < sz)
            {
                best.swap(st);
                sz = best.size();
            }
        }
    }
    cout << sz << "\n";
    for (int i : best)
        cout << i << " ";

    return 0;
}

//60
