#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 10;

vector <int> g[MAXN];
vector <int> rg[MAXN];
vector <int> tg[MAXN];

int t1[MAXN], t2[MAXN];

bool used[MAXN];

int t = 0;

int tout[MAXN];

void dfs(int u)
{
    used[u] = 1;
    for (int v : g[u])
        if (!used[v])
            dfs(v);
    tout[t++] = u;
}

set <int> st;

void rdfs(int u)
{
    used[u] = 1;
    for (int v : rg[u])
        if (!used[v])
            rdfs(v);
}

void ansdfs(int u)
{
    st.insert(u);
    used[u] = 1;
    for (int v : g[u])
        if (!used[v])
            ansdfs(v);
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
    {
        cin >> t1[i];
        t2[i] = (t1[i] + 1) % h;
    }
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        tg[u].push_back(v);
        tg[v].push_back(u);
    }

    int ans = n + 1, ansu = 0;
    for (int u = 1; u <= n; u++)
    {
        for (int v : tg[u])
        {
            if (t2[u] == t1[v])
            {
                g[u].push_back(v);
                rg[v].push_back(u);
//                cout << u << " " << v;
            }
        }
    }

    for (int i = 1; i <= n; i++)
    {
        if (g[i].empty())
            return cout << "1\n" << i, 0;
        if (!used[i])
            dfs(i);
    }

    for (int i = 1; i <= n; i++)
        used[i] = 0;

    int sz = n + 2;
    set <int> best;
    int last = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        if (!used[tout[i]])
        {
            rdfs(tout[i]);
            last = tout[i];
        }
    }

    for (int i = 1; i <= n; i++)
        used[i] = 0;

    ansdfs(last);

    cout << st.size() << "\n";
    for (int i : st)
        cout << i << " ";

    return 0;
}

//60
