#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 10;

void solve1()
{
    int n, d, b;
    cin >> n >> d >> b;
    vector <int> arr(n + 2);
    vector <int> pre(n + 2);
    for (int i = 1; i <= n; i++)
        cin >> arr[i];

    int ans = 0, j = 1;
    for (int i = 1; i <= n; i++)
    {
        int cur = 0;
        j = max(j, i + 1);
        for (; arr[i] + cur < b && j <= min(n, i + i * d); j++)
        {
            cur += arr[j];
            arr[j] = 0;
        }
        arr[i] += cur;
        j--;
        if (arr[i] >= b)
        {
            arr[i + 1] += arr[i] - b;
            arr[i] = b;
        }
        else
        {
            arr[i + 1] += arr[i];
            arr[i] = 0;
            ans++;
        }
        j++;
    }
    cout << ans;
}

void solve2()
{
    int n, d, b;
    cin >> n >> d >> b;
    vector <int> tmp(n + 2);
    for (int i = 1; i <= n; i++)
        cin >> tmp[i];
    int middle = (n + 1) / 2;

    int best = n + 2;
    for (int k = 1; k <= n; k++)
    {
        vector <int> arr = tmp;
        int ans = 0;
        for (int i = 1, i2 = n; i <= middle && i2 >= middle; i++, i2--)
        {
            int cur = 0;
            bool ok = 0;
            for (int j = i + 1; arr[i] + cur < b && j <= min({i2, k, i + i * d - (i == 1 ? 0 : 1)}); j++)
            {
                cur += arr[j];
                arr[j] = 0;
            }
            arr[i] += cur;
            if (arr[i] >= b)
            {
                arr[i + 1] += arr[i] - b;
                ok = 1;
                arr[i] = b;
            }
            else
            {
                arr[i + 1] += arr[i];
                arr[i] = 0;
                ans++;
            }

            /*if (k == 5)
            {
                for (int j = 1; j <= n; j++)
                    cout << arr[j] << " ";
                cout << "\n" << ans << "\n";
            }*/

            if (i2 != middle)
            {
                int cur2 = 0;
                for (int j2 = i2 - 1; arr[i2] + cur2 < b && j2 >= max(i, i2 - i * d + 1); j2--)
                {
                    cur2 += arr[j2];
                    arr[j2] = 0;
                }
                arr[i2] += cur2;
                if (arr[i2] >= b)
                {
                    arr[i2 - 1] += arr[i2] - b;
                    arr[i2] = b;
                }
                else
                {
                    arr[i2 - 1] += arr[i2];
                    arr[i2] = 0;
                    ans++;
                }
            }

            /*if (k == 5)
            {
                for (int j = 1; j <= n; j++)
                    cout << arr[j] << " ";
                cout << "\n" << ans << "\n";
            }*/
        }

        best = min(best, ans);
    }
    cout << best;
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);

    int p;
    cin >> p;
    if (p == 1)
        solve1();
    else
        solve2();

    return 0;
}

//30
