#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXL = 10;

int used1[1 << MAXL];
int used2[1 << MAXL];

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;
    vector <int> arr(n);
    for (int &i : arr)
        cin >> i;

    int ans = 100, am1 = 0, am2 = 0;

    for (int mask1 = 0; mask1 < (1 << MAXL); mask1++)
    {
        for (int mask2 = 0; mask2 < (1 << MAXL); mask2++)
        {
            for (int i = 0; i < (1 << MAXL); i++)
            {
                used1[i] = 0;
                used2[i] = 0;
            }
            used1[0] = 1;
            for (int sub1 = mask1; sub1 > 0; sub1 = mask1 & (sub1 - 1))
            {
                for (int sub2 = mask2; sub2 > 0; sub2 = mask2 & (sub2 - 1))
                {
                    int cur = 0;
                    for (int i = 0; i < MAXL; i++)
                    {
                        cur += (sub1 & (1 << i));
                        cur -= (sub2 & (1 << i));
                    }
                    if (cur >= 0)
                        used1[cur] = 1;
                    else
                        used2[abs(cur)] = 1;
                }
            }
            for (int sub1 = mask1; sub1 > 0; sub1 = mask1 & (sub1 - 1))
            {
                int cur = 0;
                for (int i = 0; i < MAXL; i++)
                    cur += (sub1 & (1 << i));
                used1[cur] = 1;
            }
            for (int sub2 = mask2; sub2 > 0; sub2 = mask2 & (sub2 - 1))
            {
                int cur = 0;
                for (int i = 0; i < MAXL; i++)
                    cur -= (sub2 & (1 << i));
                used2[abs(cur)] = 1;
            }

            bool ok = 1;
            for (int i : arr)
            {
                if (i >= 0 && !used1[i])
                    ok = 0;
                if (i < 0 && !used2[abs(i)])
                    ok = 0;
            }
            if (ok)
            {
                int cur_ans = __builtin_popcount(mask1) + __builtin_popcount(mask2);
                if (ans > cur_ans)
                {
                    ans = cur_ans;
                    am1 = mask1;
                    am2 = mask2;
                }
            }
        }
    }

    cout << ans << "\n";
    for (int i = 0; i < MAXL; i++)
        if ((am1 >> i) & 1)
            cout << (1 << i) << " ";
    for (int i = 0; i < MAXL; i++)
        if ((am2 >> i) & 1)
            cout << -(1 << i) << " ";

    return 0;
}
