#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 10;

vector <int> g[MAXN];
int t1[MAXN], t2[MAXN];

bool used[MAXN];
int yes[MAXN];
int no[MAXN];

void dfs(int u)
{
    used[u] = 1;
    for (int v : g[u])
    {
        if (yes[u])
        {
            if (t2[u] == t1[v])
                yes[v] = 1;
            if (t2[u] == t2[v])
                no[v] = 1;
        }
        if (no[u])
        {
            if (t1[u] == t1[v])
                yes[v] = 1;
            if (t1[u] == t2[v])
                no[v] = 1;
        }
        if (!used[v] && (yes[v] || no[v]))
            dfs(v);
    }
}

signed main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
    {
        cin >> t1[i];
        t2[i] = (t1[i] + 1) % h;
    }
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int ans = n + 1, ansu = 0;
    for (int i = 1; i <= n; i++)
    {
        yes[i] = 1;
        dfs(i);
        int cnt = 0;
        bool ok = 1;
        for (int j = 1; j <= n; j++)
        {
            if (yes[j])
                cnt++;
            if (yes[j] && no[j])
                ok = 0;
        }
        if (ok && ans > cnt)
        {
            ans = cnt;
            ansu = i;
        }
        for (int j = 1; j <= n; j++)
        {
            used[j] = 0;
            yes[j] = 0;
            no[j] = 0;
        }
    }
    cout << ans << "\n";
    yes[ansu] = 1;
    dfs(ansu);
    for (int i = 1; i <= n; i++)
        if (yes[i])
            cout << i << " ";
    return 0;
}
