#include <bits/stdc++.h>

using namespace std;

const int N = 1e5+5;

int n,m,h,u[N];
bool us[N];
vector<int>ans,t[N],g[N];

bool debug = false;

void scan(){
    scanf("%d%d%d",&n,&m,&h);
    for(int i = 0; i < n; ++i)
        scanf("%d",&u[i]);
    for(int i = 0; i < m; ++i)
    for(int j = 0; j < 2; ++j){
        int x;
        scanf("%d",&x);
        t[i].push_back(x-1);
    }
}

void print(auto &v){
    printf("%d\n",v.size());
    for(auto it: v)
        printf("%d ",it);
}

int true_solve(){
    vector<int>now(n,0);
    for(int mask = 1; mask < (1 << n); ++mask){
        vector<int>v;
        for(int i = 0; i < n; ++i){
            now[i] = (u[i]+((mask>>i)&1))%h;
            if(((mask>>i)&1))
                v.push_back(i+1);
        }
        bool fl = true;
        for(int i = 0; i < m; ++i){
            if(now[t[i][0]] == now[t[i][1]]){
                fl = false;
                break;
            }
        }
        if(fl){
            if(!debug)
                print(v);
            return v.size();
        }
    }
    cout << "Error" << endl;
}

void dfs(int v, auto &res){
    us[v] = true;
    res.push_back(v+1);
    if(res.size() > ans.size())
        return;
    for(auto to: g[v])
        if(!us[to] && u[to] == (u[v]+1)%h)
            dfs(to,res);
}

int solve(){
    ans.clear();
    for(int i = 0; i < m; ++i){
        int v = t[i][0], to = t[i][1];
        g[v].push_back(to);
        g[to].push_back(v);
    }
    for(int i = 0; i < n; ++i)
        ans.push_back(i+1);
    for(int i = 0; i < n; ++i){
        fill(us,us+n,false);
        vector<int>v;
        dfs(i,v);
        if(v.size() < ans.size())
            ans = v;
    }
    if(!debug)
        print(ans);
    return ans.size();
}

void make_test(){
    n = 3, m = 2, h = 10;
    map<int,int>mp;
    mp.clear();
    for(int i = 0; i < n; ++i){
        g[i].clear();
        int key = rand()%h;
        u[i] = key;
        ++mp[key];
    }
    for(int i = 0; i < m; ++i){
        int last = -1;
        t[i].clear();
        for(int j = 0; j < 2; ++j){
            int key = rand()%n;
            while(last == key || u[last] == u[key])
                key = rand()%n;
            t[i].push_back(key);
            last = key;
        }
    }
}

void print_test(int my_ans, int true_ans){
    cout << "---------Test---------" << endl;
    cout << n << ' ' << m << ' ' << h << endl;
    for(int i = 0; i < n; ++i)
        cout << u[i] << ' ';
    cout << endl;
    for(int i = 0; i < m; ++i){
        for(auto it: t[i])
            cout << it << ' ';
        cout << endl;
    }
    cout << "---------Answers---------" << endl;
    cout << "My ans: " << my_ans << endl;
    cout << "True ans: " << true_ans << endl;
}

int main()
{
    if(!debug){
        scan();
        solve();
    } else {
        srand(time(nullptr));
        int my_ans, true_ans;
        while(1){
            make_test();
            true_ans = true_solve();
            my_ans = solve();
            if(my_ans != true_ans)
                break;
            cout << "OK" << endl;
        }
        print_test(my_ans,true_ans);
    }
    return 0;
}
