#include <bits/stdc++.h>

using namespace std;

const int N = 2e5+5;

int n,sz,nx[N],t[N*4];
bool us[N];
string st;

int find_left(){
    int v = 1;
    while(v < sz){
        int vl = v*2, vr = v*2+1;
        v = (t[vl] ? vl : vr);
    }
    return v-sz;
}

int find_right(int v){
    v = v+sz;
    v += v%2;
    v /= 2;
    while(v < sz){
        int vl = v*2, vr = v*2+1;
        if(t[vl] || t[vr])
            v = (t[vl] ? vl : vr);
        else {
            if(v == 1)
                return -1;
            v += v%2;
            v /= 2;
        }
    }
    return v-sz;
}

void upd(int v){
    v += sz;
    --t[v];
    for(; v; v >>= 1)
        t[v] = t[v*2]+t[v*2+1];
}

vector<vector<int> >q;

void dfs(int v){
    us[v] = true;
    q.back().push_back(v+1);
    if(nx[v])
        dfs(nx[v]);
}

int main()
{
    cin >> st;
    n = st.length();

    for(sz = 1; sz < n; sz <<= 1);
    for(int i = 0; i < n; ++i)
        if(st[i] == '0')
            ++t[i+sz];
    for(int i = sz-1; i; --i)
        t[i] = t[i*2]+t[i*2+1];
    for(int i = 0; i < n; ++i)
        if(st[i] == '1'){
            int posl = find_left(), posr = find_right(i);
            if(posl >= i || posr <= i){
                printf("-1");
                return 0;
            }
            nx[posl] = i;
            nx[i] = posr;
            upd(posl);
            upd(posr);
        }
    for(int i = 0; i < n; ++i)
        if(!us[i]){
            q.push_back({});
            dfs(i);
        }
    printf("%d\n",q.size());
    for(auto it: q){
        printf("%d ",it.size());
        for(auto jt: it)
            printf("%d ",jt);
        printf("\n");
    }
    return 0;
}
