#include <bits/stdc++.h>

using namespace std;

const int N = 2e5+5;

int n,nx[N];
bool us[N];
string st;

vector<int>lf,rg;

int find_left(){
    return (lf.empty() ? N : lf.back());
}

int find_right(int v){
    return (rg.empty() ? -1 : rg.back());
}

vector<vector<int> >q;

void dfs(int v){
    us[v] = true;
    q.back().push_back(v+1);
    if(nx[v])
        dfs(nx[v]);
}

int main()
{
    cin >> st;
    n = st.length();
    for(int i = n-1; i >= 0; --i)
        if(st[i] == '0'){
            lf.push_back(i);
            rg.push_back(i);
        }
    for(int i = 0; i < n; ++i){
        while(!rg.empty() && rg.back() <= i)
            rg.pop_back();
        if(st[i] == '1'){
            int posl = find_left(), posr = find_right(i);
            if(posl >= i || posr <= i){
                printf("-1");
                return 0;
            }
            nx[posl] = i;
            nx[i] = posr;
            lf.pop_back();
            rg.pop_back();
        }
    }
    for(int i = 0; i < n; ++i)
        if(!us[i]){
            q.push_back({});
            dfs(i);
        }
    printf("%d\n",q.size());
    for(auto it: q){
        printf("%d ",it.size());
        for(auto jt: it)
            printf("%d ",jt);
        printf("\n");
    }
    return 0;
}
