#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int32_t main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> times(n);
    vector<pii> req(m);
    for (int i = 0; i < n; ++i)
        cin >> times[i];
    for (int i = 0; i < m; ++i)
        cin >> req[i].first >> req[i].second;

    int ans = n + 1;
    vector<int> print;
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector<int> now;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                now.pb(i + 1);
                times[i] = (times[i] + 1) % h;
            }
        }

        bool success = true;
        for (int i = 0; i < m; ++i)
            success &= (times[req[i].first - 1] != times[req[i].second - 1]);
        if (success && now.size() < ans) {
            ans = now.size();
            print = now;
        }

        for (int i = 0; i < n; ++i)
            if (mask & (1 << i))
                times[i] = (times[i] + h - 1) % h;
    }

    cout << ans << endl;
    for (int elem : print)
        cout << elem << " ";

    return 0;
}
