#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

vector<set<int>> graph;
vector<int> times, used, answer;
int n, m, h;

int dfs(int vert, int now, bool create_answer=false)
{
    used[vert] = now;
    int ans = 1;
    if (create_answer)
        answer.pb(vert + 1);

    for (int elem : graph[vert])
        if (used[elem] != now)
            ans += dfs(elem, now, create_answer);

    return ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> h;
    times.resize(n);
    graph.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> times[i];
    for (int i = 0; i < m; ++i) {
        int c1, c2;
        cin >> c1 >> c2;
        c1--;
        c2--;

        if ((times[c1] + 1) % h == times[c2])
            graph[c1].insert(c2);
        if ((times[c2] + 1) % h == times[c1])
            graph[c2].insert(c1);
    }

    /*for (int i = 0; i < n; ++i) {
        cout << i << ": ";
        for (int elem : graph[i])
            cout << elem << " ";
        cout << endl;
    }*/

    int ans = n, pos = 0;
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        int tmp = dfs(i, i + 1);
        if (tmp < ans) {
            ans = tmp;
            pos = i;
        }
    }

    cout << ans << endl;
    dfs(pos, n + 1, true);
    sort(all(answer));
    for (int elem : answer)
        cout << elem << " ";

    return 0;
}
