#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7, MAXP = 6;
const ld EPS = 1e-9, PI = acos(-1);

int n;
vector<int> answer, nums;

bool check(int sz)
{
    vector<int> now(sz, -(1 << MAXP));
        for (;;) {
            bool success = true;
            for (int i = 0; i < n; ++i) {
                int sum = 0;
                bool correct = false;
                for (int mask = 0; mask < (1 << sz); ++mask) {
                    sum = 0;
                    for (int j = 0; j < sz; ++j)
                        if (mask & (1 << j))
                            sum += now[j];

                    if (nums[i] == sum) {
                        correct = true;
                        break;
                    }
                }

                if (!correct) {
                    success = false;
                    break;
                }
            }

            if (success) {
                answer = now;
                return true;
            }

            int i;
            for (i = sz - 1; i > -1; --i) {
                if (now[i] < -1)
                    now[i] /= 2;
                else if (now[i] == -1)
                    now[i] = 1;
                else if (now[i] > 0 && now[i] < (1 << MAXP))
                    now[i] *= 2;
                else {
                    now[i] = -(1 << MAXP);
                    continue;
                }
                break;
            }

            if (i == -1)
                break;
        }
    return false;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    nums.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> nums[i];

    if (n <= 30) {
        for (int i = 0; i < 10; ++i)
            if (check(i))
                break;
    }
    else {
        int left = -1, right = 2 * MAXP + 2;
        while (right - left > 1) {
            int middle = (left + right) / 2;
            if (check(middle))
                right = middle;
            else
                left = middle;
        }
    }

    cout << answer.size() << endl;
    for (int elem : answer)
        cout << elem << " ";

    return 0;
}
