#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <ctime>
using namespace std;

#define int int64_t
#define pb push_back
#define pbb pop_back
#define pf pop_front
#define pff push_front
#define mp make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ld, ld> pldld;

const int INF = 1e9, MOD = 1e9 + 7;
const ld EPS = 1e-9, PI = acos(-1);

int32_t main()
{
    string s;
    cin >> s;
    int n = s.size();

    set<int> pos[2];
    for (int i = 0; i < n; ++i)
        pos[s[i] == '1'].insert(i);

    vector<bool> used(n);
    vector<vector<int>> ans;
    bool success = true;
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        if (s[i] == '1') {
            success = false;
            break;
        }

        vector<int> row;
        int now = i;
        for (;;) {
            row.pb(now + 1);
            used[now] = true;
            pos[s[now] == '1'].erase(now);

            auto next = pos[s[now] != '1'].lower_bound(now);
            if (next == pos[s[now] != '1'].end()) {
                success &= (s[now] == '0');
                break;
            }
            now = *next;
        }
        ans.pb(row);
    }

    if (!success) {
        cout << -1 << endl;
        return 0;
    }

    cout << ans.size() << endl;
    for (auto &velem : ans) {
        cout << velem.size() << " ";
        for (int elem : velem)
            cout << elem << " ";
        cout << endl;
    }

    return 0;
}

