#include <bits/stdc++.h>
using namespace std;
#define S second
#define F first
#define M make_pair
#define pb push_back

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

int cl[1000000], cnx[1000000], lst[1000000], mark[1000000], n, m, h, a[1000000], f[1000000], sz[1000000];
vector <int> NX[1000000], nx[1000000], st, tu, V;

int get(int v) {
	int res = v;
	if (cl[v] != v) res = get(cl[v]);
	cl[v] = res;
	return res;
}

void add(int x, int y) {
	cnx[lst[x]] = y;
	lst[x] = lst[y];
	cl[y] = x;
}

void Dfs(int v) {
	mark[v] = 2; tu.pb(v);
	f[v] = sz[v];
	for (int u = v; u != -1; u = cnx[u]) {
		for (int j = 0; j < nx[u].size(); j++) {
			int J = nx[u][j];
			if (get(J) == v) {
				swap(nx[u][j], nx[u][nx[u].size()-1]);
				nx[u].pop_back();
				j--;
				continue;
			}
			if (mark[get(J)] == 2) continue;
			if (mark[get(J)] == 0) Dfs(get(J));
			f[v] += f[get(J)];
		}
	}
}

void dfs(int v) {
	if (mark[v] == 1) return;
	if (mark[v] == 2) {
		while (st.back() != v) {
			add(get(v) , get(st.back()));
			st.pop_back(); 
		}
		v = get(v);
		st[st.size()-1] = v;
	} else { st.pb(v); tu.pb(v); }
	mark[v] = 2;
	for (int u = v; u != -1; u = cnx[u]) {
		for (int j = 0; j < nx[u].size(); j++) {
			int J = nx[u][j];
			if (get(J) == v) {
				swap(nx[u][j], nx[u][nx[u].size()-1]);
				nx[u].pop_back();
				j--;
				continue;
			}
			dfs(get(J));
			if (st.back() != v) return;
		}
	}
	mark[v] = 1;
	st.pop_back();
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();
	
	cin >> n >> m >> h;
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--; y--;
		NX[x].pb(y);
		NX[y].pb(x);
	}
	for (int i = 0; i < n; i++) {
		int x = (a[i]+1) % h;
		for (int j : NX[i]) {
			if (a[j] == x) nx[i].pb(j);
		}
	}
	for (int i = 0; i < n; i++) { cl[i] = i; cnx[i] = -1; lst[i] = i; }
	for (int i = 0; i < n; i++) mark[i] = 0;
	for (int i = 0; i < n; i++) {
		if (mark[get(i)] == 1) continue;
		tu.clear();
		dfs(i);
		for (int j : tu) mark[j] = 1;
	}
	
	for (int i = 0; i < n; i++) mark[i] = 0;
	for (int i = 0; i < n; i++) {
		if (mark[i] == 1) continue;
		V.pb(get(i));
		for (int j = V.back(); j != -1; j = cnx[j]) { sz[V.back()]++; mark[j] = 1; }
	}
	for (int i = 0; i < n; i++) mark[i] = 0;
	int ans = n+1, nm;
	for (int i : V) {
		tu.clear();
		if (mark[i] == 0) Dfs(i);
		if (f[i] < ans) {
			ans = f[i];
			nm = i;
		}
		for (int j : tu) mark[j] = 1;
	}
	cout << ans << endl;
	for (int i = nm; i != -1; i = cnx[i]) cout << i+1 << " ";
    return 0;
}
