#include <bits/stdc++.h>
#define int long long
#define fastio() ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

using namespace std;

const int inf = (int)1e9;



vector < vector < int > > g;
vector < int > t;
vector < int > used;
vector < int > dp;
int n, m, h;

void dfs1(int v, vector < int > &used){
    used[v] = 1;
    int res = 1;
    for(int i = 0; i < g[v].size(); ++i){
        int u = g[v][i];
        if(used[u] == 0)dfs1(u, used);
        res += dp[u];
    }
    dp[v] = res;
}


void dfs2(int v, vector < int > &used, vector < int > &comp){
    used[v] = 1;
    comp.push_back(v);
    for(int i = 0; i < g[v].size(); ++i){
        int u = g[v][i];
        if(used[u] == 0)dfs2(u, used, comp);
    }
}



signed main()
{
    fastio();
    cin >> n >> m >> h;
    dp.resize(n);
    t.resize(n);
    used.resize(n);
    g.resize(n);
    for(int i = 0; i < n; ++i)cin >> t[i];
    for(int i = 0; i < m; ++i){
        int v, u;
        cin >> v >> u;
        --v, --u;
        if((t[v] + 1) % h == t[u]){
            g[v].push_back(u);
        }
        if((t[u] + 1) % h == t[v]){
            g[u].push_back(v);
        }
    }
    int mn = inf;
    int st = -1;
    for(int i = 0; i < n; ++i){
        if(used[i] == 0)dfs1(i, used);
    }
    for(int i = 0; i < n; ++i){
        if(dp[i] < mn){
            mn = dp[i];
            st = i;
        }
    }
    vector < int > comp;
    fill(used.begin(), used.end(), 0);
    dfs2(st, used, comp);
    cout << comp.size() << "\n";
    for(int i = 0; i < comp.size(); ++i){
        cout << comp[i] + 1 << " ";
    }
}
