#include <bits/stdc++.h>

using namespace std;

int h;
vector <int> vis;
vector <vector <int> > g;
vector <bool> used;

int nt(int t) {
	if (t == h - 1) {
		return 0;
	}
	return t + 1;
}

void dfs(int v) {
	used[v] = true;
	vis.push_back(v);
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m >> h;
	vector <int> u(n);
	for (int& it : u) {
		cin >> it;
	}
	g.resize(n);
	used.resize(n, false);
	int a, b;
	for (int i = 0; i < m; ++i) {
		cin >> a >> b;
		--a; --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; ++i) {
		bool f = false;
		for (int to : g[i]) {
			if (nt(u[i]) == u[to]) {
				f = true;
				break;
			}
		}
		if (!f) {
			cout << 1 << "\n";
			cout << i + 1 << "\n";
			return 0;
		}
	}
	vector <int> ans;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			vis.clear();
			dfs(i);
			if (vis.size() < ans.size() || ans.empty()) {
				ans = vis;
			}
		}
	}
	cout << ans.size() << "\n";
	for (int it : ans) {
		cout << it + 1 << " ";
	}
	cout << "\n";
	return 0;
}