#include <bits/stdc++.h>

using namespace std;

int h;
vector <int> vis;
vector <vector <int> > g;
vector <bool> used;
int last;

int nt(int t) {
	if (t == h - 1) {
		return 0;
	}
	return t + 1;
}

void dfs(int v) {
	used[v] = true;
	vis.push_back(v);
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

void dfs_st(int v) {
	last = v;
	used[v] = true;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs_st(to);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m >> h;
	vector <int> u(n);
	for (int& it : u) {
		cin >> it;
	}
	g.resize(n);
	used.resize(n, false);
	int a, b;
	for (int i = 0; i < m; ++i) {
		cin >> a >> b;
		--a; --b;
		if (nt(u[a]) == u[b])
		g[a].push_back(b);
		if (nt(u[b]) == u[a])
		g[b].push_back(a);
	}
	vector <int> vec;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs_st(i);
			vec.push_back(last);
		}
	}
	used.assign(n, false);
	vector <int> ans;
	for (int v : vec) {
		if (!used[v]) {
			vis.clear();
			dfs(v);
			if (vis.size() < ans.size() || ans.empty()) {
				ans = vis;
			}
		}
	}
	cout << ans.size() << "\n";
	for (int it : ans) {
		cout << it + 1 << " ";
	}
	cout << "\n";
	return 0;
}