#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <fstream>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

int main() {

    string s;
    cin >> s;
    vector<vector<pair<int, int>>> pos(2);
    for (int i = 0; i < s.size(); i++) {
        if ((s[i] - '0') == 0) {
            pos[0].push_back({i + 1, i + 1});
            int tempj = pos[1].size() - 1;
            while (0 <= tempj && pos[1][tempj].second == -1) {
                pos[1][tempj].second = pos[0].size() - 1;
                tempj--;
            }
        } else {
            pos[1].push_back({i + 1, -1});
        }
    }
    vector<bool> used(pos[0].size(), false), usedj(pos[1].size(), false);
    vector<vector<int>> ans;
    int check = 0;
    for (int i = 0; i < pos[0].size(); i++) {
        if (!used[i]) {
            ans.push_back({pos[0][i].first});
            used[i] = 1;
            check++;
            int tempd = i, tempj = 0;
            for (; tempj < pos[1].size(); tempj++) {
                if (!usedj[tempj]) {
                    if (pos[1][tempj].first < pos[0][tempd].first) {
                        continue;
                    }
                    int tempi = pos[1][tempj].second;
                    if (tempi == -1) {
                        break;
                    }
                    while (tempi < used.size() && used[tempi]) {
                        tempi++;
                    }
                    if (tempi == used.size()) {
                        break;
                    }
                    ans[ans.size() - 1].push_back(pos[1][tempj].first);
                    ans[ans.size() - 1].push_back(pos[0][tempi].first);
                    tempd = tempi;
                    used[tempi] = 1, usedj[tempj] = 1;
                    check += 2;
                }
            }
        }
    }
    if (check == s.size()) {
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i].size() << " ";
            for (int j = 0; j < ans[i].size(); j++) {
                cout << ans[i][j] << " ";
            }
            cout << "\n";
        }
    } else {
        cout << -1;
    }
    return 0;
}