#include <bits/stdc++.h>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;

const int INF = 1e9;
const int mx = 3e5;
int n, m, h, t[mx], cmp[mx], sz[mx], used[mx], useful[mx], cmp_cnt = 0;
vector<int> g[mx], g_rev[mx], topsort;
vector<vector<int> > val;

void build_topsort(int v) {
	used[v] = 1;
	for (auto v1 : g[v]) {
		if (used[v1] == 0) {
			build_topsort(v1);
		}
	}
	topsort.push_back(v);
}

void paint(int v, int color) {
	used[v] = 1;
	cmp[v] = color;
	sz[color]++;
	val[color].push_back(v);
	for (auto v1 : g_rev[v]) {
		if (used[v1] == 0)
			paint(v1, color);
	}
}

void cond() {
	for (int i = 0; i < n; ++i) {
		for (auto v : g[i]) {
			g_rev[v].push_back(i);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			build_topsort(i);
		}
	}
	reverse(topsort.begin(), topsort.end());
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		int v = topsort[i];
		if (used[v] == 0) {
			val.push_back(vector<int> ());
			paint(v, cmp_cnt);
			cmp_cnt++;
		}
	}
	/*cout << "components" << endl;
	cout << "number = " << cmp_cnt << endl;
	for (int i = 0; i < cmp_cnt; ++i) {
		cout << "comp " << i << " - ";
		for (auto x : val[i]) {
			cout << x << " ";
		}
		cout << endl;
	}*/
	for (int i = 0; i < cmp_cnt; ++i) {
		useful[i] = 1;
	}
	for (int i = 0; i < n; ++i) {
		for (auto v : g[i]) {
			if (cmp[i] != cmp[v]) {
				useful[cmp[i]] = 0;
			}
		}
	}
}

int main() {
	cin >> n >> m >> h;
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if ((t[u] + 1) % h == t[v]) {
			g[u].push_back(v);
		}
		if ((t[v] + 1) % h == t[u]) {
			g[v].push_back(u);
		}
	}
	/*cout << "graph" << endl;
	for (int i = 0; i < n; ++i) {
		cout << "v: " << i << " - ";
		for (auto x : g[i]) {
			cout << x << " ";
		}
		cout << endl;
	}*/
	cond();
	int pos = -1, ans = INF;
	for (int i = 0; i < cmp_cnt; ++i) {
		if (useful[i] && sz[i] < ans) {
			ans = sz[i];
			pos = i;
		}
	}
	cout << ans << endl;
	for (auto v : val[pos]) {
		cout << v + 1 << " ";
	}
	cout << endl;
	return 0;
}