import java.io.*;
import java.util.*;

public class Main {
    public class pair implements Comparable<pair> {
        int x, y;

        pair(int a, int b) {
            x = a;
            y = b;
        }

        public int compareTo(pair p) {
            if (x == p.x) return y - p.y;
            return x - p.x;
        }
    }

    ArrayList<ArrayList<Integer>> q;
    boolean[] used;

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int h = nextInt();
        q = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            q.add(new ArrayList<>());
        }
        int[] d = new int[n];
        for (int i = 0; i < n; i++) {
            d[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            int a = nextInt() - 1;
            int b = nextInt() - 1;
            q.get(a).add(b);
            q.get(b).add(a);
        }
        ArrayList<Integer> res = new ArrayList<>();
        int y = n + 1;
        for (int i = 0; i < (1 << n) - 1; i++) {
            TreeSet<Integer> f = new TreeSet<>();
            for (int j = 0; j < n; j++) {
                if ((i >> j) % 2 == 0) {
                    f.add(j);
                }
            }
            if (f.size() >= y)continue;
            boolean t = true;
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < q.get(j).size(); k++) {
                    int v = q.get(j).get(k);
                    int x1 = d[j];
                    if (f.contains(j)) {
                        x1++;
                    }
                    x1 %= h;
                    int x2 = d[v];
                    if (f.contains(v)) {
                        x2++;
                    }
                    x2 %= h;
                    if (x1 == x2){
                        t = false;
                    }
                }
            }
            if (t){
                y = f.size();
                res = new ArrayList<>();
                while (f.size() > 0){
                    res.add(f.pollFirst() + 1);
                }
            }
        }
        out.println(y);
        for (int i = 0; i < y; i++) {
            out.print(res.get(i) + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
