import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public void solve() throws IOException {
        int n = nextInt();
        int k = -1;
        int[] a = new int[n];
        ArrayList<Integer> res = new ArrayList<>();
        boolean[] b1 = new boolean[22];
        boolean[] b2 = new boolean[22];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            boolean t = true;
            if (a[i] < 0){
                t = false;
                a[i] = -a[i];
            }
            for (int j = 0; j < 22; j++) {
                if ((a[i] >> j) % 2 == 1){
                    if (t){
                        b1[j] = true;
                    }else {
                        b2[j] = true;
                    }
                }
            }
        }
        for (int i = 0; i < 22; i++) {
            if (b1[i] && b2[i]){
                int c1 = 0;
                for (; c1 < 22; c1++) {
                    if (!b1[c1])break;
                }
                int c2 = 0;
                for (; c2 < 22; c2++) {
                    if (!b2[c2])break;
                }
                if (c1 > c2){
                    for (int j = i; j < c1; j++) {
                        b1[j] = false;
                    }
                    b1[c1] = true;
                }else {
                    for (int j = i; j < c2; j++) {
                        b2[j] = false;
                    }
                    b2[c2] = true;
                }
            }
            if (b1[i]){
                res.add(1 << i);
            }
            if (b2[i]){
                res.add(-1 * (1 << i));
            }
        }
        out.println(res.size());
        for (int i = 0; i < res.size(); i++) {
            out.print(res.get(i) + " ");
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
