#include <bits/stdc++.h>

using namespace std;

const long long maxn = 1e5 + 7;

long long a[maxn];
long long t[4 * maxn];

bool dp[101][101][101];

void build(long long v, long long tl, long long tr){
    if (tl ==  tr){
        t[v] = a[tl];
        return;
    }

    long long tm = (tl + tr) / 2;

    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm + 1, tr);

    t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

long long get(long long v, long long tl, long long tr, long long l, long long r){
    if (l > r)
        return 0;
    if (tl == l && tr == r)
        return t[v];

    long long tm = (tl + tr) / 2;

    return get(v * 2 + 1, tl, tm, l, min(tm, r)) + get(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
}

long long n;

vector<long long> g[maxn];

long long death(long long x){
    return min(x, n - 1 - x);
}

int main()
{
    long long p, d, b;
    cin >> p >> n >> d >> b;
    for (long long i = 0; i < n; ++i)
        cin >> a[i];

    if (p == 1){
        long long ans = 0;
        long long ost = 0;
        long long le = 0;
        build(0, 0, n - 1);
        for (long long i = 0; i < n; ++i){
            ost += get(0, 0, n - 1, le, min(n - 1, i + (i + 1) * d));
            le = min(n - 1, i + (i + 1) * d) + 1;

            if (ost >= b){
                ost -= b;
            }
            else{
                ++ans;
            }
        }

        cout << ans << '\n';
        return 0;
    }

    for (long long i = 0; i < n; ++i){
        if (a[i] != 0){
            for (long long j = 0; j < n; ++j){
                if (i == j)
                    continue;
                if (abs(i - j) / d + bool(abs(i - j) % d != 0) <= death(j))
                    g[i].push_back(j);
            }
        }
    }

    dp[0][0][0] = 1;
    for (long long i = 0; i < n; ++i){
        long long aa = 0, bb = 0;
        for (long long j = 0; j < (long long)g[i].size(); ++j){
            aa += (g[i][j] <= n / 2);
            bb += (g[i][j] > n / 2);
        }

        if (i <= n / 2)
            ++aa;
        else
            ++bb;

        for (long long it = 0; it <= n; ++it)
        for (long long jt = 0; jt <= n; ++jt){
            for (long long j = 0; j <= a[i]; ++j)
            if (j <= aa){
                long long kek = a[i] - j;
                bool mem = dp[it][jt];
                dp[i + 1][it + j][jt + min(bb, kek)] |= dp[i][it][jt];
            }
            dp[i + 1][it][jt] |= dp[i][it][jt];
        }
    }

    long long ans = n + 1;
    long long le = n / 2 + bool(n % 2);
    long long ri = n - le;
    for (long long i = 0; i <= n; ++i)
        for (long long j = 0; j <= n; ++j)
            if (dp[n][i][j])
                ans = min(ans, max(le - i, ri - j));

    cout << ans << '\n';
    return 0;
}
