#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

using namespace std;

typedef long long LL;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int p, n, b;
  LL d;
  cin >> p >> n >> d >> b;

  vector<LL> a(n);
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  vector<LL> pref(n);
  pref[0] = a[0];
  for (int i = 1; i < n; ++i)
    pref[i] = pref[i - 1] + a[i];

  if (p == 1) {
    LL run = 0;

    int ans = 0;
    for (int i = 0; i < n; ++i) {
      run += a[i];
      int L = i + 1, R = min(n - 1ll, i + d * (i + 1));
      LL sum = pref[R] - pref[L - 1];
      if (b <= sum + run) {
        run -= b;
      }
      else {
        ans++;
      }
    }
    cout << ans << endl;
    return 0;
  }
  else if (p == 2) {
    int ansL = 0, ansR = 0;

    LL runL = 0, runR = 0;

    for (int i = 0; i < n / 2; ++i) {
      int j = n - i - 1;
      runL += a[i];
      runR += a[j];
      
      int leftL = i + 1, leftR = min(n - 1ll, i + d * (i + 1)),
        rightR = j - 1, rightL = max(0ll, j - d * (i + 1));
      
      LL sumL = pref[leftR] - pref[leftL - 1] - (i - ansR) * 1ll * b,
        sumR = pref[rightR] - (rightL == 0 ? 0 : pref[rightL - 1]) - (i - ansL) * 1ll * b;

      if (b <= sumL + runL) {
        runL -= b;
      }
      else {
        ansL++;
      }

      if (b <= sumR + runR) {
        runR -= b;
      }
      else {
        ansR++;
      }
    }

    if (n % 2 == 1) {
      // ahah, zatralili prepov (net)
    }

    cout << max(ansL, ansR) << endl;
    return 0;
  }

  return 0;
}