#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

using namespace std;

typedef long long LL;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  string s;
  cin >> s;

  int cnt0 = 0, cnt1 = 0;

  for (auto c : s)
    if (c == '0')
      cnt0++;
    else
      cnt1++;

  int n = cnt0 - cnt1;

  if (n <= 0) {
    cout << -1 << endl;
    return 0;
  }

  vector<pair<int, int>> v01;

  vector<pair<char, int>> tmp;

  for (int i = 0; i < s.length(); ++i) {
    tmp.push_back({ s[i], i });
    if (tmp.size() >= 2 && tmp.back().first == '1' && tmp[tmp.size() - 2].first == '0') {
      v01.push_back({ tmp[tmp.size() - 2].second, tmp.back().second });
      tmp.pop_back();
      tmp.pop_back();
    }
  }

  for (auto t : tmp) {
    if (t.first == '1') {
      cout << -1 << endl;
      return 0;
    }
  }

  vector<vector<int>> ans;
  for (auto t : tmp) {
    ans.push_back(vector<int>(1, t.second));
  }

  reverse(v01.begin(), v01.end());

  struct cmp {
    bool operator()(const pair<int, int> &a, const pair<int, int> &b) {
      return a.first != b.first ? a.first > b.first : a.second < b.second;
    }
  };

  set<pair<int, int>, cmp> order;

  for (int i = 0; i < ans.size(); ++i) {
    order.insert({ ans[i][0], i });
  }

  for (auto t : v01) {
    int id = order.begin()->second;
    order.erase(order.begin());

    if (ans[id].back() <= t.second) {
      cout << -1 << endl;
      return 0;
    }

    ans[id].push_back(t.second);
    ans[id].push_back(t.first);

    order.insert({ ans[id].back(), id });
  }

  cout << ans.size() << '\n';

  for (int i = 0; i < ans.size(); ++i) {
    cout << ans[i].size() << ' ';
    for (int j = (int)ans[i].size() - 1; j > -1; --j) {
      cout << ans[i][j] + 1 << ' ';
    }
    cout << '\n';
  }
  
  return 0;
}