#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <iterator>
using namespace std;

const int mid = 100000 ;
int n, a[112345], record, dp[212345], mmmax ;
vector <int> v, ans ;

void check ()
{
    int i, j, curr ;

    for ( i=mid-mmmax; i<=mid+mmmax; i++ )
        dp[i] = 0 ;

    dp[ mid ] = 1 ;
    for ( i=0; i<v.size(); i++ )
    {
        curr = v[i] ;

        if ( curr > 0 )
        {
            for ( j=mid+mmmax; j>=mid-mmmax; j-- )
                if ( dp[j] == 1 )
                    dp[j + curr] = 1 ;
        }
        else
        {
            for ( j=mid-mmmax; j<=mid+mmmax; j++ )
                if ( dp[j] == 1 )
                    dp[j + curr] = 1 ;
        }

    }

    for ( i=0; i<n; i++ )
        if ( dp[ mid + a[i] ] == 0 )
            return ;

    record = v.size() ;
    ans = v ;

    return ;
}

void rec ( int step )
{
     if ( v.size() >= record )
        return ;

     if ( step > mmmax )
     {
            check ( ) ;
            return ;
     }

     int next = (-step) ;

     if ( step < 0 )
        next *= 2 ;

     rec ( next ) ;

     v.push_back( step ) ;
     rec ( next ) ;

     v.push_back( step ) ;
     rec ( next ) ;

     v.pop_back() ;
     v.pop_back() ;

     return ;
}

int main()
{
    ios_base :: sync_with_stdio ( false ) ;

    int i ;

    cin >> n ;

    mmmax =  0 ;
    for ( i=0; i<n; i++ )
    {
        cin >> a[i] ;
        mmmax = max ( a[i], mmmax ) ;
    }

    record = 1e8 ;
    rec ( 1 ) ;


    cout << ans.size() << endl ;
    for ( i=0; i<ans.size(); i++ )
        cout << ans[i] << " " ;

    return 0;
}
