#include <bits/stdc++.h>

using namespace std;

#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)
#define rand_int (abs((rand() << 15) | rand()))

typedef long long ll;
typedef long double ld;

const int BIG = 1e9 + 239;
const ll INF = 1e18;
const ld pi = acos(-1.0);
const ld eps = 1e-8;
const ll MOD = 1e9 + 7;
const int M = 2 * 1e5 + 239;
const int N = 2 * 1e3 + 239;

vector<vector<int> > v(M);
int n;
bool used[M];
string a;
set<int> s0, s1;

int main()
{   //*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout); /**/
    cin.sync_with_stdio(0);
    cin >> a;
    n = a.size();
    int k = 0;
    for (int i = 0; i < n; i++)
    {
        if (a[i] == '0')
            k++;
        else
            k--;
    }
    if (k <= 0)
    {
        cout << "-1";
        return 0;
    }
    memset(used, 0, sizeof(used));
    int r = k;
    for (int i = 0; i < n && r > 0; i++)
    {
        if (a[i] == '1') continue;
        v[k - r].push_back(i);
        s0.insert(k - r);
        r--;
        used[i] = 1;
    }
    for (int i = 0; i < n; i++)
    {
        if (used[i]) continue;
        if (a[i] == '0')
        {
            if (s1.empty())
            {
                cout << "-1";
                return 0;
            }
            int nm = *s1.begin();
            if (v[nm].back() > i)
            {
                cout << "-1";
                return 0;
            }
            v[nm].push_back(i);
            s1.erase(s1.begin());
            s0.insert(nm);
        }
        else
        {
            if (s0.empty())
            {
                cout << "-1";
                return 0;
            }
            int nm = *s0.begin();
            if (v[nm].back() > i)
            {
                cout << "-1";
                return 0;
            }
            v[nm].push_back(i);
            s0.erase(s0.begin());
            s1.insert(nm);
        }
    }
    if (!s1.empty())
    {
        cout << "-1";
        return 0;
    }
    cout << k << "\n";
    for (int i = 0; i < k; i++)
    {
        cout << v[i].size() << " ";
        for (int x : v[i])
            cout << x + 1 << " ";
        cout << "\n";
    }
    return 0;
}
