#include <iostream>
#include <vector>
#include <set>
#include <cstdio>
#include <climits>
#include <cstdlib>
#include <bitset>
#include <cassert>
#include <algorithm>

using namespace std;
typedef unsigned int index;

const int PLUS = 500;

int pow(int a, size_t b)
{
    int ans = 1;
    while (b --> 0)
        ans *= a;
    return ans;
}

int main()
{
    assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    size_t n;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a)
        cin >> i;
    const size_t MAXST = 10;
    int mx = pow(3, MAXST);
    const size_t sz = 1 << (MAXST + 1);
    const size_t plus = (1 << MAXST);
    bitset<sz> fld(sz);
    vector<int> ans(100, 0);
    for (int mask = 0; mask < mx; mask++)
    {
        vector<int> cur;
        int cmask = mask;
        for (index i = 0; i < MAXST; i++)
        {
            if (cmask % 3 == 1)
                cur.push_back((1 << i));
            if (cmask % 3 == 2)
                cur.push_back(-(1 << i));
            cmask /= 3;
        }
        for (index i = 0; i < fld.size(); i++)
            fld[i] = false;
        fld[plus] = true;
        for (auto i: cur)
        {
            if (i > 0)
            {
                fld |= fld << i;
            }
            else
            {
                fld |= fld >> (-i);
            }
        }
        bool flag = true;
        for (auto i: a)
            if (!fld[i + plus])
            {
                flag = false;
                break;
            }
        if (flag)
        {
            if (ans.size() > cur.size())
                ans = cur;
        }
    }
    cout << ans.size() << endl;
    for (auto i: ans)
        cout << i << " ";
}
