#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#if defined DEBUG && defined LOCAL
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

int mxpw(int x)
{
    int ans = 0;
    if (x < 0)
        x = -x;
    while (x)
    {
        ans++;
        x >>= 1;
    }
    return ans;
}

int tmp[(int)2e5];

void run()
{
    int n;
    cin >> n;
    vector<int> a(n);
    int p = 0;
    bool f = 1;
    for (auto &x: a)
    {
        cin >> x;
        if (x)
            f = 0;
        maxi(p, mxpw(x));
    }
    p++;
    debug("p = " << p);
    if (f)
    {
        cout << 0;
        return;
    }
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    vector<int> mask((1 << (p * 2)));
    for (int i = 0; i < (1 << (p * 2)); i++)
    {
        mask[i] = i;
    }
    sort(all(mask), [](int x, int y)
    {
        return __builtin_popcount(x) < __builtin_popcount(y);
    });
    vector<vector<int>> d((1 << (p * 2)));
    d[0].pb(0);
    for (int i = 1; i < (1 << (p * 2)); i++)
    {
        //debug(i);
        for (int j = 0; j < p * 2; j++)
        {
            if (mask[i] & (1 << j))
            {
                int delt;
                if (j < p)
                    delt = 1 << j;
                else
                    delt = -(1 << (j - p));
                for (auto x: d[mask[i] ^ (1 << j)])
                {
                    d[mask[i]].pb(x + delt);
                    d[mask[i]].pb(x);
                }
            }
        }
        sort(all(d[mask[i]]));
        d[mask[i]].resize(unique(all(d[mask[i]])) - d[mask[i]].begin());
        debug(mask[i] << ":");
        debugdo(for (auto x: d[mask[i]]))
            debug2(x);
        debug("");
        if (set_intersection(all(d[mask[i]]), all(a), tmp) - tmp == (int)a.size())
        {
            cout << __builtin_popcount(mask[i]) << "\n";
            for (int j = 0; j < p * 2; j++)
            {
                if (mask[i] & (1 << j))
                {
                    int delt;
                    if (j < p)
                        delt = 1 << j;
                    else
                        delt = -(1 << (j - p));
                    cout << delt << " ";
                }
            }
            return;
        }
    }
    assert(0);
}
/*
4
8 7 -8 -7
*/
