#ifndef LOCAL
    #pragma GCC optimize("Ofast")
    #pragma GCC target("sse,sse2,sse3,sse4")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define F first
#define S second
#define double long double
#define ld double
#define pii pair<int, int>

const int INF = INT_MAX / 2;
const ll LINF = 2e18 + 666, M = 1e9 + 7;
const ld EPS = 1e-10;

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template<class T, class CMP = less<T>>
using ordered_set = tree<T, null_type, CMP, rb_tree_tag, tree_order_statistics_node_update>;

template<class T1, class T2>
bool mini(T1 &x, T2 y)
{
    if (x > y)
    {
        x = y;
        return 1;
    }
    return 0;
}

template<class T1, class T2>
bool maxi(T1 &x, T2 y)
{
    if (x < y)
    {
        x = y;
        return 1;
    }
    return 0;
}

void run();

int main()
{
    srand(time(0));
    cout << setprecision(15) << fixed;
    auto start = clock();
    run();
    #ifdef LOCAL
        cout << "\ntime = " << (ld)(clock() - start) / CLOCKS_PER_SEC;
    #endif
}

#define DEBUG
#ifdef DEBUG
    #define debugdo(x) x
#else
    #define debugdo(x)
#endif
#define debug(x) debugdo(cout << x << endl);
#define debug2(x) debugdo(cout << x << " ");

// ---SOLUTION--- //

void run()
{
    string s;
    cin >> s;
    if (s[0] == '1' || s.back() == '1')
    {
        cout << -1;
        return;
    }
    vector<vector<int>> ans0, ans1;
    for (int i = 0; i < (int)s.size(); i++)
    {
        if (s[i] == '0')
        {
            if (ans1.empty())
                ans0.pb({i});
            else
            {
                ans0.pb({});
                swap(ans1.back(), ans0.back());
                ans1.pop_back();
                ans0.back().pb(i);
            }
        }
        else
        {
            if (ans0.empty())
            {
                cout << -1;
                return;
            }
            else
            {
                ans1.pb({});
                swap(ans1.back(), ans0.back());
                ans0.pop_back();
                ans1.back().pb(i);
            }
        }
    }
    if (ans1.size())
        cout << -1;
    else
    {
        cout << ans0.size() << "\n";
        for (auto &x: ans0)
        {
            cout << x.size() << " ";
            for (auto y: x)
                cout << y + 1 << " ";
            cout << "\n";
        }
    }
}
