#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>
#include <bitset>

using namespace std;

const int maxn = 2e5 + 88;
const int inf = 1e9 + 88;

int n, lg, ans = inf;
vector<int> ansv;
int a[maxn];
bool dp[maxn];

bool check(int mask1, int mask2)
{
    int i, j, cnt = 0;
    int sz = (1 << (lg + 1));
    for (i = 0; i < sz; i++)
        dp[i] = false;
    dp[1 << lg] = true;
    int cur = mask1;
    while (cur)
    {
        cnt += cur&1;
        cur >>= 1;
    }
    cur = mask2;
    while (cur)
    {
        cnt += cur&1;
        cur >>= 1;
    }
    if (cnt >= ans)
        return false;
    cur = 1;
    int curmask = mask1;
    while (curmask)
    {
        if (curmask&1)
            for (i = sz - cur - 1; i >= 0; i--)
                if (dp[i])
                    dp[i + cur] = true;
        curmask >>= 1;
        cur *= 2;
    }
    cur = -1;
    curmask = mask2;
    while (curmask)
    {
        if (curmask&1)
            for (i = -cur; i < sz; i++)
                if (dp[i])
                    dp[i + cur] = true;
        curmask >>= 1;
        cur *= 2;
    }
    for (i = 0; i < n; i++)
        if (!dp[a[i] + (1 << lg)])
            return false;
    ans = cnt;
    ansv.clear();
    cur = 1;
    while (mask1)
    {
        if (mask1&1)
            ansv.push_back(cur);
        mask1 >>= 1;
        cur *= 2;
    }
    cur = -1;
    while (mask2)
    {
        if (mask2&1)
            ansv.push_back(cur);
        mask2 >>= 1;
        cur *= 2;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin("input.txt");
    int i, j;
    cin >> n;
    for (i = 0; i < n; i++)
        cin >> a[i];
    for (i = 0; i < n; i++)
    {
        int cur = abs(a[i]), cnt = 0;
        while (cur)
        {
            cur >>= 1;
            cnt++;
        }
        lg = max(lg, cnt);
    }
    for (i = 0; i < (1 << lg); i++)
        for (j = 0; j < (1 << lg); j++)
            check(i, j);
    cout << ans << "\n";
    for (i = 0; i < ansv.size(); i++)
        cout << ansv[i] << " ";
    return 0;
}
