//
// Created by olymp on 08.03.2018.
//
#include <iostream>
#include <vector>

using ll = long long;

int main() {
    ll p = 0, n = 0, d = 0, b = 0, sum = 0;
    std::cin >> p >> n >> d >> b;
    std::vector<ll> a(n + 1), sum_pref(n + 1), sum_suf(n + 1);
    for (int i = 1; i <= n; ++i) {
        std::cin >> a[i];
        sum_pref[i] = a[i] + sum_pref[i - 1];
    }
    if (p == 1) {
        ll cnt = 0;
        for (int i = 1; i <= n; ++i) {
            ll right = std::min(i * d + i, n);
            ll cursum = sum_pref[right] - cnt * b;
            if (cursum >= b) {
                ++cnt;
            }
        }
        std::cout << n - cnt;
        return 0;
    }
    for (int i = 1; i <= n; ++i) {
        sum_suf[i] = sum_suf[i - 1] + a[n - i + 1];
    }
    sum = sum_suf[n];
    ll i = 1, j = n;
    ll cnt1 = 0, cnt2 = 0;
    while (j - i > (ll) 0) {
        ll right = std::min(i * d + i, n);
        ll left = std::max(j - (n - j + 1) * d, (ll) 1);
        ll cursum1 = sum_pref[right] - cnt1 * b;
        ll cursum2 = sum_suf[n - left + 1] - cnt2 * b;
        ll cursum = sum - (cnt1 + cnt2) * b;
        if (cnt1 <= cnt2 && cursum1 > b && cursum >= b) {
            ++cnt1;
            cursum -= b;
        }
        if (cnt2 < cnt1 && cursum2 > b && cursum >= b) {
            ++cnt2;
        }
        ++i;
        --j;
    }
    if (i == j && sum - (cnt1 + cnt2) * b >= b) {
        ++cnt1;
    }
    std::cout << std::max((n + 1) / 2 - cnt1, n / 2 - cnt2);
    return 0;
}