#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
const int inf = 1000000000;
const int N = 100000;

vector<int> g[N], ts, th;
static bool used[N];

void dfs0 (int v)
{
    used[v] = true;
    for (int u: g[v])
        if (!used[u])
            dfs0(u);
    ts.push_back(v);
}

void dfs1(int v)
{
    used[v] = true;
    th.push_back(v);
    for (int u: g[v])
        if (!used[u])
            dfs1(u);
}

int h;

inline int next(int a) {return a < h - 1 ? a + 1 : 0;}

int main()
{
    int n, m;
    cin >> n >> m >> h;
    int x[n];
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    set< pair<int,int> > e;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b, --a, --b;
        if (a > b)
            swap(a, b);
        e.insert({a, b});
    }
    for (auto t: e)
    {
        if (x[t.first] == next(x[t.second]))
            g[t.second].push_back(t.first);
        if (x[t.second] == next(x[t.first]))
            g[t.first].push_back(t.second);
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs0(i);
    for (int i = 0; i < n; ++i)
        used[i] = false;
    dfs1(ts[0]);
    cout << th.size() << '\n';
    for (int x: th)
        cout << x + 1 << ' ';
    return 0;
}
