#include <iostream>
#include <set>
#include <vector>
using namespace std;
const int N = 100000;

vector<int> g[N], ts, best;
set<int> th;
static bool used[N];
static int U2[N];
bool good;

void dfs0 (int v)
{
    used[v] = true;
    for (int u: g[v])
        if (!used[u])
            dfs0(u);
    ts.push_back(v);
}

void dfs1(int v)
{
    U2[v] = true;
    th.insert(v);
    cout << "in " << v << "\n";
    cout << "g[" << v << "]: ";
    for (int x: g[v])
        cout << x << ' ';
    cout << '\n';
    for (int u: g[v])
        if (!U2[u])
            dfs1(u);
        else if (U2[u] && th.find(u) == th.end())
            good = false;
    cout << "out " << v << '\n';
}

int h;
inline int next(int a) {return a < h - 1 ? a + 1 : 0;}

int main()
{
    int n, m;
    cin >> n >> m >> h;
    int x[n];
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    set< pair<int,int> > e;
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b, --a, --b;
        if (a > b)
            swap(a, b);
        e.insert({a, b});
    }
    for (auto t: e)
    {
        if (x[t.first] == next(x[t.second]))
            g[t.second].push_back(t.first);
        if (x[t.second] == next(x[t.first]))
            g[t.first].push_back(t.second);
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs0(i);
    for (int i = 0; i < n; ++i)
        used[i] = false;
    for (int i = 0; i <= n; ++i)
        best.push_back(i);
    for (int i: ts)
    {
        good = true;
        th.clear();
        if (U2[i])
            continue;
        dfs1(i);
        if (good && th.size() < best.size())
        {
            best.clear();
            for (int x: th)
                best.push_back(x);
        }
    }
    cout << best.size() << '\n';
    for (int x: best)
        cout << x + 1 << ' ';
    return 0;
}
