#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

vector<vector<int>> edges;
vector<int> times;
vector<bool> used;
int n, m, h;

void dfs(int v, vector<int> &vec) {
    if (used[v])
        return;
    used[v] = 1;
    vec.push_back(v);
    for (auto &to: edges[v])
        if (!used[to] && times[to] == (times[v] + 1) % h)
            dfs(to, vec);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);

    cin >> n >> m >> h;

    edges.resize(n);
    times.resize(n);
    used.resize(n, 0);

    for (auto &it: times)
        cin >> it;

    while (m--) {
        int u, v;
        cin >> u >> v;
        edges[--u].push_back(--v);
        edges[v].push_back(u);
    }

    vector<int> ans;
    for (int i = 0; i < n; i++) {
        vector<int> tans;
        dfs(i, tans);
        if (tans.size() < ans.size() || ans.empty())
            ans = move(tans);
        used.assign(n, 0);
    }

    cout << ans.size() << '\n';
    for (auto &it: ans)
        cout << it + 1 << ' ';

    return 0;
}