#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define FILE ""

vector <vector<int> > g, gr;
vector <char> used;
vector <int> o, cmp, cnt, c;
int col = 0;

void dfs1(int v)
{
    used[v] = 1;
    for (int i = 0; i < g[v].size(); ++i)
        if (!used[g[v][i]])
            dfs1(g[v][i]);
    o.push_back(v);
}

void dfs2(int v)
{
    used[v] = 1;
    cnt[col]++;
    c[v] = col;
    for (int i = 0; i < gr[v].size(); ++i)
        if (!used[gr[v][i]])
            dfs2(gr[v][i]);
}

int main()
{
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen(FILE".in", "r", stdin);
    //freopen(FILE".out", "w", stdout);
#endif // LOCAL
    int n, m, h;
    cin >> n >> m >> h;
    int u[n];
    for (int i = 0; i < n; ++i)
    {
        cin >> u[i];
    }
    g.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        int h1 = u[x], h2 = u[y];
        if ((h1 + 1) % h == h2)
            g[x].push_back(y), gr[y].push_back(x);
        if ((h2 + 1) % h == h1)
            g[y].push_back(x), gr[x].push_back(y);
    }
    used.assign(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
            dfs1(i);
    }
    used.assign(n, 0);
    cnt.assign(n + 1, 0);
    c.assign(n, 0);
    unordered_set <int> st;
    for (int i = 0; i < n; ++i)
    {
        int v = o[n - 1 - i];
        if (!used[v])
        {
            col++;
            st.insert(col);
            dfs2(v);
        }
    }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < g[i].size(); ++j)
        {
            if (c[i] != c[g[i][j]])
            {
                st.erase(c[i]);
                break;
            }
        }
    int ans = 2e9, x;
    for (auto i:st)
        if (ans > cnt[i])
        {
            x = i;
            ans = cnt[i];
        }
    cout << cnt[x] << endl;
    for (int i = 0; i < n; ++i)
        if (c[i] == x)
            cout << i + 1 << ' ';
    return 0;
}
