#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define FILE ""

vector <vector<int> > ans;

int main()
{
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen(FILE".in", "r", stdin);
    //freopen(FILE".out", "w", stdout);
#endif // LOCAL
    string c;
    cin >> c;
    ans.resize(c.size());
    if (c[0] == '1' || c.back() == 1)
    {
        cout << -1;
        return 0;
    }
    stack <int> s;
    queue <int> q;
    for (int i = 0; i < c.size(); ++i)
    {
        if (c[i] == '0') s.push(i);
    }
    vector <int> l(c.size(), -1), r(c.size(), -1);
    for (int i = c.size() - 1; i >= 0; --i)
    {
        if (c[i] == '0')
        {
            q.push(i);
            if (s.size() && s.top() == i) s.pop();
            continue;
        }
        if (q.size() == 0 || s.size() == 0)
        {
            cout << -1;
            return 0;
        }
        l[i] = s.top();
        r[i] = q.front();
        q.pop();
        s.pop();
    }
    vector <int> used(c.size(), 2e9);
    for (int i = 0; i < c.size(); ++i)
    {
        if (l[i] != -1)
        {
            ans[min(used[l[i]], i)].push_back(l[i]);
            ans[min(used[l[i]], i)].push_back(i);
            used[l[i]] = used[i] = used[r[i]] = min(used[l[i]], i);
        }
    }
    int out = 0;
    for (int i = 0; i < c.size(); ++i)
    {
        if (used[i] == 0 && c[i] == '1')
        {
            cout << -1;
            return 0;
        }
        if (ans[i].size()) ans[i].push_back(r[ans[i].back()]);
        if (used[i] == 2e9)
            ans[i].push_back(i);
        if (ans[i].size()) out++;
    }
    cout << out << endl;
    for (int i = 0; i < c.size(); ++i)
    {
        if (ans[i].size() == 0) continue;
        cout << ans[i].size() << ' ';
        for (auto j:ans[i])
            cout << j + 1 << ' ';
        cout << endl;
    }
    return 0;
}
