#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <algorithm>

#pragma warning (disable : 4996)

using namespace std;

const int MAXN = 2e5 + 10;

int n, m, h, u[MAXN];
vector < int > graph[MAXN], was, now, ans;

void dfs(int v) {
    now.push_back(v);
    was[v] = 1;
    for (int i = 0; i < graph[v].size(); i++) {
        int to = graph[v][i];
        if (was[to] == 0)
            dfs(to);
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
    /*freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);*/
#endif

    cin >> n >> m >> h;
    for (int i = 0; i < n; i++) {
        cin >> u[i];
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((u[a] + 1) % h == u[b]) {
            graph[a].push_back(b);
        }
        if ((u[b] + 1) % h == u[a]) {
            graph[b].push_back(a);
        }
    }
    int ansi = -1;
    ans.resize(n + 1);
    for (int i = 0; i < n; i++) {
        was.clear();
        now.clear();
        was.resize(n, 0);
        dfs(i);
        if (now.size() < ans.size()) {
            ans = now;
        }
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << " ";
    }
}