#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ctime>

#pragma warning (disable : 4996)

using namespace std;

const int MAXN = 2e3 + 10;

string s;
int n, used[MAXN];
vector < vector < int > > ans;
set < int > nxz, nxo;

int nxtz(int x) {
    nxz.insert(x);
    set < int > ::iterator it = nxz.find(x);
    it++;
    if (it == nxz.end()) {
        nxz.erase(x);
        return -1;
    }
    nxz.erase(x);
    return *it;

}

int nxto(int x) {
    nxo.insert(x);
    set < int > ::iterator it = nxo.find(x);
    it++;
    if (it == nxo.end()) {
        nxo.erase(x);
        return -1;
    }
    nxo.erase(x);
    return *it;

}

int nxt(int now, int x) {
    if (now == 0) {
        return nxto(x);
    }
    else {
        return nxtz(x);
    }
}

void ernx(int now, int x) {
    if (now == 0) {
        nxz.erase(x);
    }
    else {
        nxo.erase(x);
    }
}

void addnx(int now, int x) {
    if (now == 0) {
        nxz.insert(x);
    }
    else {
        nxo.insert(x);
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
    /*freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);*/
#endif

    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            nxz.insert(i);
        }
        else {
            nxo.insert(i);
        }
    }
    int k = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] == '0' && used[i] == 0) {
            ans.push_back(vector<int>());
            used[i] = 1;
            ans.back().push_back(i);
            int now = 0;
            int j = i;
            while (nxt(now, j) != -1) {
                ernx(now, j);
                j = nxt(now, j);
                used[j] = 1;
                ans.back().push_back(j);
                now ^= 1;
            }
            if (now == 1) {
                used[j] = 0;
                ans.back().pop_back();
                addnx(now, j);
            }
            else {
                ernx(now, j);
            }
            k += ans.back().size();
        }
    }

    if (k < n) {
        cout << -1;
        return 0;
    }

    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        if (ans[i].size() > 0) {
            cout << ans[i].size() << " ";
            for (int j = 0; j < ans[i].size(); j++) {
                cout << ans[i][j] + 1 << " ";
            }
            cout << "\n";
        }
    }


}