#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <set>
#include <map>
#include <functional>
#include <string>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<bool> vb;
typedef vector<double> vd;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define it(v) v.begin(), v.end()
#define fst first
#define scn second
#define mp make_pair
#define pb push_back 
#define eb emplace_back

const int inf = 1e9 + 9;
const int mod = 1e9 + 7;
const ll linf = 1e18 + 1;

int n, m, h;
vector<vi> g, g_rev;
vb used;
vi tout;
int t = 0;
vi wh;
vector<vi> conn;

void dfs(int pos)
{
	used[pos] = true;
	for (auto i : g[pos])
	{
		if (!used[i])
		{
			dfs(i);
		}
	}
	tout[pos] = t++;
}

void dfs_rev(int pos, int ind)
{
	used[pos] = true;
	wh[pos] = ind;
	conn[ind].pb(pos);
	for (auto i : g_rev[pos])
	{
		if (!used[i])
		{
			dfs_rev(i, ind);
		}
	}
}

struct cmp
{
	bool operator()(int a, int b) const
	{
		return tout[a] > tout[b];
	}
};

signed main()
{
	cin >> n >> m >> h;
	vi upd(n);
	g.assign(n, vi());
	g_rev.assign(n, vi());
	vector<pii> edges;
	for (int i = 0; i < n; i++)
	{
		cin >> upd[i];
	}
	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		--u; --v;
		if ((upd[u] + 1) % h == upd[v])
		{
			g[u].pb(v);
			g_rev[v].pb(u);
			edges.eb(u, v);
		}
		if ((upd[v] + 1) % h == upd[u])
		{
			g[v].pb(u);
			g_rev[u].pb(v);
			edges.eb(v, u);
		}
	}
	tout.assign(n, -1);
	used.assign(n, false);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(i);
		}
	}
	used.assign(n, false);
	vi ord;
	for (int i = 0; i < n; i++)
	{
		ord.pb(i);
	}
	cmp comp;
	sort(it(ord), comp);
	wh.assign(n, -1);
	int cur = 0;
	for (auto i : ord)
	{
		if (!used[i])
		{
			conn.pb(vi());
			dfs_rev(i, cur++);
		}
	}
	vb out(cur, false);
	for (auto i : edges)
	{
		if (wh[i.fst] != wh[i.scn])
		{
			out[wh[i.fst]] = true;
		}
	}
	int res = -1;
	for (int i = 0; i < cur; i++)
	{
		if (!out[i] && (res == -1 || conn[res].size() > conn[i].size()))
		{
			res = i;
		}
	}
	cout << conn[res].size() << "\n";
	for (auto i : conn[res])
	{
		cout << i + 1 << " ";
	}
}

