#include <iostream>
#include <vector>
#include <list>
#include <deque>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <set>
#include <map>
#include <functional>
#include <string>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;
typedef vector<bool> vb;
typedef vector<double> vd;
typedef vector<ld> vld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define it(v) v.begin(), v.end()
#define fst first
#define scn second
#define mp make_pair
#define pb push_back 
#define eb emplace_back

const int inf = 1e9 + 9;
const int mod = 1e9 + 7;
const ll linf = 1e18 + 1;

int p, n, d, b;
vi a, pref;

bool check1(int x)
{
	int cur = (x + 1) * d;
	for (int i = x; i < n; i++)
	{
		if (pref[min(n, i + cur + 1)] < (i - x + 1) * b)
		{
			return false;
		}
		cur += d;
	}
	return true;
}

bool check2(int x)
{
	int cur = (x + 1) * d;
	for (int i = 0; i < (n - x) / 2; i++)
	{
		if (pref[min(n, i + x + cur + 1)] + pref[n] - pref[max(0, n - x - 1 - i - cur)] < (i + 1) * b * 2)
		{
			return false;
		}
		if (pref[min(n, i + x + cur + 1)] < (i + 1) * b)
		{
			return false;
		}
		if (pref[n] - pref[max(0, n - x - 1 - i - cur)] < (i + 1) * b)
		{
			return false;
		}
		cur += d;
	}
	return true;
}

bool check(int x)
{
	if (p == 1)
	{
		return check1(x);
	}
	else
	{
		return check2(x);
	}
}

signed main()
{
	cin >> p >> n >> d >> b;
	a.assign(n, 0);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	pref.assign(n + 1, 0);
	for (int i = 0; i < n; i++)
	{
		pref[i + 1] = pref[i] + a[i];
	}
	int res = 0;
	int l = -1, r = n / 2;
	while (r - l > 1)
	{
		int mid = (l + r) / 2;
		if (check(mid))
		{
			r = mid;
		}
		else
		{
			l = mid;
		}
	}
	check(r);
	cout << r;
}

