#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1005000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

int n, m, h;
vector<vector<int> > v, vrev;
vector<bool> used;
vector<int> topsort, comp, val;

void dfs1(int ver) {
    used[ver] = true;
    for (int i = 0; i < (int)v[ver].size(); ++i) {
        int to = v[ver][i];
        if (!used[to]) {
            dfs1(to);
        }
    }
    topsort.push_back(ver);
}

void dfs2(int ver) {
    comp.push_back(ver);
    used[ver] = true;
    for (int i = 0; i < (int)vrev[ver].size(); ++i) {
        int to = vrev[ver][i];
        if (!used[to]) {
            dfs2(to);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> h;
    val.resize(n);
    used.resize(n);
    v.resize(n);
    vrev.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> val[i];
    }
    int to, from;
    for (int i = 0; i < m; ++i) {
        cin >> to >> from;
        to--;
        from--;
        if (((val[to] + 1) % h) == val[from]) {
            v[to].push_back(from);
            vrev[from].push_back(to);
        }
        if (((val[from] + 1) % h) == val[to]) {
            v[from].push_back(to);
            vrev[to].push_back(from);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    used.clear();
    used.resize(n);
    reverse(topsort.begin(), topsort.end());
    vector<int> ans;
    int s = MAXN;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.clear();
            dfs2(i);
            if (s > comp.size()) {
                ans = comp;
                s = comp.size();
            }
        }
    }
    cout << s << "\n";
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    cout << "\n";
    return 0;
}
