#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1005000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

int n, m, h;
vector<vector<int> > v, vrev;
vector<bool> used;
vector<int> topsort, comp, val, color;

void dfs1(int ver) {
    used[ver] = true;
    for (int i = 0; i < (int)v[ver].size(); ++i) {
        int to = v[ver][i];
        if (!used[to]) {
            dfs1(to);
        }
    }
    topsort.push_back(ver);
}

void dfs2(int ver) {
    comp.push_back(ver);
    used[ver] = true;
    for (int i = 0; i < (int)vrev[ver].size(); ++i) {
        int to = vrev[ver][i];
        if (!used[to]) {
            dfs2(to);
        }
    }
}

bool find_out() {
    for (auto i : comp) {
        for (auto j : v[i]) {
            if (color[i] != color[j]) return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);
    cin >> n >> m >> h;
    val.resize(n);
    used.resize(n);
    v.resize(n);
    vrev.resize(n);
    color.resize(n, -1);
    for (int i = 0; i < n; ++i) {
        cin >> val[i];
    }
    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        a--;
        b--;
        if (((val[a] + 1) % h) == val[b]) {
            v[a].push_back(b);
            vrev[b].push_back(a);
        }
        if (((val[b] + 1) % h) == val[a]) {
            v[b].push_back(a);
            vrev[a].push_back(b);
        }
    }
    /*for (int i = 0; i < n; ++i) {
        cout << i << ": ";
        for (auto j : v[i]) {
            cout << j <<  " ";
        }
        cout << "\n";
    }
    cout << "\n";*/
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    used.clear();
    used.resize(n);
    reverse(topsort.begin(), topsort.end());
    /*for (auto i : topsort) {
        cout << i << " ";
    }
    cout << "\n";*/
    vector<int> ans;
    int s = MAXN;
    //cout << "\n";
    for (int i = 0; i < n; ++i) {
        if (!used[topsort[i]]) {
            comp.clear();
            dfs2(topsort[i]);
            /*for (auto q : comp) {
                cout << q + 1 << " ";
            }
            cout << "\n\n";*/
            for (auto j : comp) {
                color[j] = i;
            }
            if (s > comp.size() && find_out()) {
                ans = comp;
                s = comp.size();
            }
        }
    }
    cout << s << "\n";
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    cout << "\n";
    return 0;
}
