#include <iostream>

using namespace std;

typedef long long ll;

const int SZ = 1e5 + 10;

int p, n, d, b;

int tree[SZ * 4];
int sz = 1;

void build_tree()
{
    while (sz < n)
        sz <<= 1;
    for (int i = 0; i < n; i++)
        cin >> tree[sz + i];
    for (int i = sz - 1; i > 0; i--)
        tree[i] = tree[i * 2] + tree[i * 2 + 1];
}

void upd_elem(int ind, int x)
{
    ind += sz;
    tree[ind] = x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

void add_to_elem(int ind, int x)
{
    ind += sz;
    tree[ind] += x;
    ind >>= 1;
    while (ind > 0) {
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
        ind >>= 1;
    }
}

int get_sum(int L, int R)
{
    L += sz;
    R += sz;
    int res = 0;
    while (L <= R) {
        if (L & 1)
            res += tree[L++];
        if (~R & 1)
            res += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return res;
}

int elem(int ind)
{
    return tree[sz + ind];
}

void action_p1()
{
    int ans = 0;
    int d_start = d;
    for (int i = 0; i < n; i++) {
        int L = max(0, i - d);
        int R = min(n - 1, i + d);
        if (get_sum(L, R) < b) {
            ans++;
            continue;
        }
        for (int j = L; j <= R; j++) {
            if (elem(i) >= b)
                break;
            int how = min(b - elem(i), elem(j));
            add_to_elem(i, how);
            add_to_elem(j, -how);
        }
        add_to_elem(i, -b);
        d += d_start;
    }
    cout << ans;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    build_tree();
    if (p == 1)
        action_p1();
    return 0;
}
