#include <iostream>
#include <vector>

using namespace std;

const int MAX_CARD = 1 << 21;

int n, a;
vector<int> vect;

int get_size(int k)
{
    if (k < 0)
        k = -k;
    int res = 0;
    while (k != 0) {
        res += k & 1;
        k >>= 1;
    }
    return res;
}

void add_to_vect(int a)
{
    int is = 1;
    if (a < 0) {
        a = -a;
        is = -1;
    }
    int now = 1;
    while (a > 0) {
        if (a & 1)
            vect.push_back(now * is);
        a >>= 1;
        now <<= 1;
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n >> a;
    int x_ans = -MAX_CARD;
    int res_ans = 0;
    for (int x = -MAX_CARD + 1; x < MAX_CARD; x++) {
        int y = a - x;
        int now_res = get_size(x) + get_size(y);
        if (x_ans == -MAX_CARD || now_res < res_ans) {
            x_ans = x;
            res_ans = now_res;
        }
    }
    add_to_vect(x_ans);
    add_to_vect(a - x_ans);
    cout << vect.size() << "\n";
    for (int i : vect)
        cout << i << ' ';
    return 0;
}
