#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int SZ = 2e5 + 10;

string s;
bool used[SZ];
int pref[SZ];
int suf[SZ];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> s;
    int ind_pref = 0;
    int ind_suf = 0;
    for (int i = 0; i < s.size(); i++) {
        while (ind_pref < s.size() && used[ind_pref])
            ind_pref++;
        ind_suf = max(ind_suf, i + 1);
        while (ind_suf < s.size() && used[ind_suf])
            ind_suf++;while (ind_pref < s.size() && used[ind_pref])
            ind_pref++;
        
        if (s[i] == '0')
            continue;
        if (ind_pref > i || ind_suf == s.size()) {
            cout << -1;
            return 0;
        }
        pref[i] = ind_pref;
        suf[i] = ind_suf;
        used[ind_pref] = true;
        used[ind_suf] = true;
        used[i] = true;
    }
    int cnt = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '0' && !used[i])
            cnt++;
        else if (s[i] == '1')
            cnt++;
    }
    cout << cnt << "\n";
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '0' && !used[i])
            cout << 1 << ' ' << i + 1 << "\n";
        else if (s[i] == '1')
            cout << 3 << ' ' << pref[i] + 1 << ' ' << i + 1 << ' ' << suf[i] + 1 << "\n";
    }
    return 0;
}
