#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int SZ = 2e5 + 10;

string s;
vector<int> res[SZ];
int cnt = 0;

set<int> st_zero;
set<int> st_one;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> s;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '0') {
            if (!st_one.empty()) {
                int now = *st_one.begin();
                res[now].push_back(i + 1);
                st_one.erase(st_one.begin());
                st_zero.insert(now);
            }
            else {
                res[cnt].push_back(i + 1);
                st_zero.insert(cnt++);
            }
        }
        else {
            if (st_zero.empty()) {
                cout << -1;
                return 0;
            }
            int now = *st_zero.begin();
            res[now].push_back(i + 1);
            st_one.insert(now);
            st_zero.erase(st_zero.begin());
        }
    }
    if (!st_one.empty()) {
        cout << -1;
        return 0;
    }
    cout << cnt << "\n";
    for (int i = 0; i < cnt; i++) {
        cout << res[i].size() << ' ';
        for (auto x : res[i])
            cout << x << ' ';
        cout << "\n";
    }
    return 0;
}
