#include <bits/stdc++.h>

#define int long long
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define ford(i, a, b) for (int i = a; i > b; --i)
#define fs first
#define sc second
#define mp(x, y) make_pair(x, y)
#define pb(x) push_back(x)
#define sz(x) (int)x.size()
#define len(x) (int)x.length()
#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
using namespace std;

const int MAXN = (int)1e5 + 10;
int n;

bool isZebra(string &s) {
    if (!(len(s) % 2))
        return 0;
    for (int i = 0; i < n; i += 2) {
        if (s[i] == '1') return 0;
    }
    for (int i = 1; i < n; i += 2) {
        if (s[i] == '0') return 0;
    }
    return 1;
}

signed main()
{

    string s;
    cin >> s;
    n = len(s);

    if (isZebra(s)) {
        cerr << "ZEBRA" << endl;
        cout << 1 << endl;
        cout << n << ' ';
        forn(i, 0, n) {
            cout << i + 1 << ' ';
        }
        return 0;
    }

    int ones = 0, zeros = 0;
    vi getone;
    forn(i, 0, len(s)) {
        ones += s[i] == '1';
        zeros += s[i] == '0';
        if (s[i] == '1')
            getone.pb(i);
    }

    if (ones >= zeros) {
        cout << -1 << endl;
        return 0;
    }

    int cur = 0, need = 0;

    set<int> st;
    map<int, int> getleft;
    int lst = -1;
    ford(i, n - 1, -1) {
        if (s[i] == '1') {
            lst = i;
            break;
        }
    }
    if (lst == -1) {
        cout << n << endl;
        forn(i, 0, n) {
            cout << 1 << ' ' << i + 1 << endl;
        }
        return 0;
    }
    vector<int> needone;
    map<int, int> getright;
    vi used_zero(n, 0);

    vvi ans;
    while(ones) {
        vi chain;
        int prev = 1;
        forn(i, 0, n) {
            if (s[i] == '0' && prev && !used_zero[i]) {
                used_zero[i] = 1;
                chain.pb(i + 1);
                prev = 0;
                continue;
            }
            else if (s[i] == '1' && !prev && !used_zero[i]) {
                used_zero[i] = 1;
                chain.pb(i + 1);
                prev = 1;
                ones--;
                continue;
            }
        }
        if (sz(chain) > 0 && s[chain.back() - 1] == '1')
            used_zero[chain.back() - 1] = 0, chain.pop_back(), ones++;
        if (!sz(chain))
            break;
        ans.pb(chain);
    }

    if (ones) {
        cout << -1 << endl;
        return 0;
    }

    forn(i, 0, n) {
        if (s[i] == '0' && !used_zero[i]) {
            vi tmp = {i + 1};
            ans.pb(tmp);
        }

    }

    cout << sz(ans) << endl;
    //set<int> was;
    forn(i, 0, sz(ans)) {
        cout << sz(ans[i]) << ' ';
        forn(j, 0, sz(ans[i])) {
            //if (j)
                //assert(ans[i][j] > ans[i][j - 1]);
            //was.insert(ans[i][j]);
            cout << ans[i][j] << ' ';
        }
        cout << endl;
    }

    return 0;
}
