#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
const int inf = 1e9;

int n, m, h;

int t[maxn];
int tt[maxn];
vector<vector<int> > g(maxn);

vector<pair<int, int> > x;

vector<int> top;
bool used1[maxn] = {};
void dfs1(int v) {
    used1[v] = 1;
    for (int to : g[v]) {
        if (!used1[to]) {
            dfs1(to);
        }
    }
    top.push_back(v);
}

int cnt = 0;
vector<int> mas(1, 0);
int color[maxn] = {};
void dfs2(int v, int & sz) {
    color[v] = cnt;
    sz++;
    for (int to : g[v]) {
        if (color[to] == 0) {
            dfs2(to, sz);
        }
    }
}

int solveSlow() {
    int ans = inf;
    for (int i = 1; i < (1 << n); ++i) {
        for (int j = 1; j <= n; ++j) {
            tt[j] = t[j];
            if (i & (1 << (j - 1))) {
                tt[j] = (tt[j] + 1) % h;
            }
        }
        bool ok = true;
        for (auto p : x) {
            if (tt[p.first] == tt[p.second]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            ans = min(ans, __builtin_popcount(i));
        }
    }
    return ans;
    /*for (int i = 1; i < (1 << n); ++i) {
        for (int j = 1; j <= n; ++j) {
            tt[j] = t[j];
            if (i & (1 << (j - 1))) {
                tt[j] = (tt[j] + 1) % h;
            }
        }
        bool ok = true;
        for (auto p : x) {
            if (tt[p.first] == tt[p.second]) {
                ok = false;
                break;
            }
        }
        if (ok && ans == __builtin_popcount(i)) {
            cout << ans << '\n';
            for (int j = 0; j < n; ++j) {
                if (i & (1 << j)) {
                    cout << j + 1 << ' ';
                }
            }
            return 0;
        }
    }*/
}

bool good[maxn];
int solveFast() {
    for (int i = 1; i <= n; ++i) {
        if (!used1[i]) {
            dfs1(i);
        }
    }
    for (int i : top) {
        if (color[i] == 0) {
            cnt++;
            int sz = 0;
            dfs2(i, sz);
            mas.push_back(sz);
            assert(cnt == (int)mas.size() - 1);
        }
    }
    for (int i = 0; i < maxn; ++i)
        good[i] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int to : g[i]) {
            if (color[i] != color[to])
                good[color[i]] = 0;
        }
    }
    pair<int, int> ans = {inf, 0};
    for (int i = 1; i < (int)mas.size(); ++i) {
        if (good[i] == 1) {
            ans = min(ans, {mas[i], i});
        }
    }
    assert(ans.first != inf);
    cout << ans.first << '\n';
    for (int i = 1; i <= n; ++i) {
        if (color[i] == ans.second) {
            cout << i << ' ';
        }
    }
    cout << '\n';
    return ans.first;
    /*cout << ans.first << '\n';*/
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> n >> m >> h;
    assert(h > 1);
    for (int i = 1; i <= n; ++i) {
        cin >> t[i];
        assert(t[i] < h);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        x.push_back({a, b});
        assert(a <= n && b <= n);
        if ((t[a] + 1) % h == t[b]) {
            g[a].push_back(b);
        }
        if ((t[b] + 1) % h == t[a]) {
            g[b].push_back(a);
        }
    }
    if (solveFast() != solveSlow()) assert(0);
    return 0;
}
/*
3 3 5
1 2 3
1 2
1 3
2 3

3 3 5
4 4 0
1 3
3 2
3 1

4 5 4
2 1 0 3
4 3
3 2
1 2
1 4
1 3
*/
