#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
const int inf = 1e9;

int n, m, h;

int t[maxn];
int tt[maxn];
vector<vector<int> > g(maxn);
vector<vector<int> > g2(maxn);

vector<pair<int, int> > x;

vector<int> top;
bool used1[maxn] = {};
void dfs1(int v) {
    used1[v] = 1;
    for (int to : g[v]) {
        if (!used1[to]) {
            dfs1(to);
        }
    }
    top.push_back(v);
}

int cnt = 0;
vector<int> mas(1, 0);
int color[maxn] = {};
void dfs2(int v, int & sz) {
    color[v] = cnt;
    sz++;
    for (int to : g2[v]) {
        if (color[to] == 0) {
            dfs2(to, sz);
        }
    }
}

int good[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> n >> m >> h;
    assert(h > 1);
    for (int i = 1; i <= n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if ((t[a] + 1) % h == t[b]) {
            g[a].push_back(b);
            g2[b].push_back(a);
        }
        if ((t[b] + 1) % h == t[a]) {
            g[b].push_back(a);
            g2[a].push_back(b);
        }
    }
    for (int i = 1; i <= n; ++i) {
        if (!used1[i]) {
            dfs1(i);
        }
    }
    reverse(top.begin(), top.end());
    for (int i : top) {
        if (color[i] == 0) {
            cnt++;
            int sz = 0;
            dfs2(i, sz);
            mas.push_back(sz);
            assert(cnt == (int)mas.size() - 1);
        }
    }
    for (int i = 0; i < maxn; ++i)
        good[i] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int to : g[i]) {
            if (color[i] != color[to])
                good[color[i]] = 0;
        }
    }
    pair<int, int> ans = {inf, 0};
    for (int i = 1; i < (int)mas.size(); ++i) {
        if (good[i] == 1) {
            ans = min(ans, {mas[i], i});
        }
    }
    cout << ans.first << '\n';
    for (int i = 1; i <= n; ++i) {
        if (color[i] == ans.second) {
            cout << i << ' ';
        }
    }
    cout << '\n';
    return 0;
}
