#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 10;
int p, n, d, b;
ll a[maxn];
ll cur[maxn];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> p >> n >> d >> b;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    if (p == 1) {
        int L = -1, R = n;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            ll c[maxn] = {};
            for (int i = 1; i <= n; ++i) {
                c[i] = a[i];
            }
            for (int i = 1; i <= M; ++i) {
                c[M + 1] += c[i];
                c[i] = 0;
            }
            int l = M + 2;
            for (int i = M + 1; i <= n; ++i) {
                int r = min((ll)n, (ll)i + (ll)i * (ll)d);
                for (int j = l; j <= r; ++j)
                    c[i] += c[j], c[j] = 0;
                l = r + 1;
            }
            bool ok = true;
            for (int i = M + 1; i <= n; ++i) {
                if (c[i] < b) {
                    ok = false;
                    break;
                }
                if (c[i] > b)
                    c[i + 1] += c[i] - b;
                c[i] = b;
            }
            if (ok)
                R = M;
            else
                L = M;
        }
        cout << R << endl;
        return 0;
    }
    if (p == 2) {
        ll pref[maxn] = {};
        for (int i = 1; i <= n; ++i) {
            pref[i] = pref[i - 1] + a[i];
        }
        int L = -1, R = n;
        while (L + 1 < R) {
            int M = (L + R) / 2;
            ll c[maxn] = {};
            for (int i = 1; i <= n; ++i)
                c[i] = a[i];
            bool ok = false;
            for (int k = 0; k <= M; ++k) {
                if (ok)
                    break;
                int x = M - k;
                int Left = k + 1;
                int Right = n - x;
                if (Left > (n + 1) / 2)
                    break;
                if (Right < n / 2 + 1)
                    continue;
                c[Left] = pref[Left];
                c[Right] += pref[n] - pref[Right];
                for (int mid = Left - 1; mid <= Right; ++mid) {
                    for (int j = Left; j <= Right; ++j)
                        cur[j] = c[j];
                    int l = Left + 1;
                    for (int i = Left; i <= mid; ++i) {
                        int r = min((ll)mid, (ll)i + (ll)i * (ll)d);
                        for (int j = l; j <= r; ++j)
                            cur[i] += cur[j], cur[j] = 0;
                        l = r + 1;
                    }
                    int rl = Right - 1;
                    for (int i = Right; i >= mid + 1; --i) {
                        int rr = max((ll)mid + 1, (ll)i - (ll)(n - i + 1) * d);
                        for (int j = rl; j >= rr; --j)
                            cur[i] += cur[j], cur[j] = 0;
                        rl = rr - 1;
                    }
                    bool can = true;
                    for (int i = Left; i <= (n + 1) / 2; ++i) {
                        if (cur[i] < b) {
                            can = false;
                            break;
                        }
                        if (cur[i] > b)
                            cur[i + 1] += cur[i] - b;
                        cur[i] = b;
                    }
                    for (int i = Right; i >= n / 2 + 1; --i) {
                        if (cur[i] < b) {
                            can = false;
                            break;
                        }
                        if (cur[i] > b)
                            cur[i - 1] += cur[i] - b;
                        cur[i] = b;
                    }
                    if (can) {
                        ok = true;
                        break;
                    }
                }
            }
            if (ok)
                R = M;
            else
                L = M;
        }
        cout << R << endl;
        return 0;
    }
}
/*
1 5 3 1
0 0 0 5 0

1 5 3 10
5 1 1 1 42

2 5 1 1
1 0 0 0 4

2 6 1 2
3 8 0 1 0 0
*/
