// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pll pair<ll, ll>
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ld long double

int deb = 0;
#define pas(x) if (deb) cout << #x << ' ' << x << endl;

int main() {
	cout.precision(20);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, m, h; cin >> n >> m >> h;
	vector<int> u(n);
	for (int &i : u) cin >> i;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b;
		a--, b--;
		// pas(a); pas(b);
		// cout << endl;
		if ((u[a] - u[b] + h) % h == 1) {
			g[b].pb(a);
			// pas(b);
			// pas(a);
		}
		if ((u[b] - u[a] + h) % h == 1) {
			g[a].pb(b);
			// pas(a);
			// pas(b);
		}
	}

	vector<int> in(n);
	for (int i = 0; i < n; i++) {
		for (int j : g[i]) {in[j]++; pas(j);}
	}

	int time = 0;
	vector<int> used(n, 0);
	vector<int> top_sort;
	function<void(int)> dfs = [&](int v) {
		pas(v);

		top_sort.pb(v);
		for (int u : g[v]) {
			if (used[u]) continue;
			in[u]--;
			pas(u);
		
			if (in[u] == 0) {
				used[u] = 1;
				dfs(u);
			}
		}

	};


	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			used[i] = 1;
			dfs(i);
		}
	}

	vector<vector<int>> gr(n);
	for (int i = 0; i < n; i++) {
		for (int j : g[i]) {
			gr[j].pb(i);
		}
	}

	vector<int> color(n);
	int c = 0;
	used.assign(n, 0);

	function<void(int)> dfs1 = [&](int v) {
		for (int u : gr[v]) {
			if (used[u]) continue;
			used[u] = 1;
			color[u] = c;
			dfs1(u);
		}
	};

	
	for (int i = 0; i < n; i++) {
		int v = top_sort[i];
		if (used[v] == 0) {
			used[v] = 1;
			
			color[v] = c;
			dfs1(v);
			c++;
		}
	}

	pas(c);
	// for (int i = 0; i < n; i)
	vector<vector<int>> gn(c);
	for (int i = 0; i < n; i++) {
		for (int j : g[i]) {
			if (color[i] != color[j])
				gn[color[i]].pb(color[j]);
		}
	}
	vector<int> sz(c);
	for (int i = 0; i < n; i++) sz[color[i]]++;
	int res = 1e9;
	int resc = -1;
	for (int v = 0; v < c; v++) {
		if (gn[v].size() == 0) {
			if (res > sz[v]) res = sz[v], resc = v;
		}
	}

	cout << res << endl;
	for (int i = 0; i < n; i++) {
		if (color[i] == resc) cout << i + 1 << ' ';
	}

	cout << endl;

	


	return 0;
}