#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <iterator>
#include <map>
#include <stack>
#define pb push_back
#define ppb pop_back
#define mp make_pair
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
int const MAXN = 100010;
int const INF = 1e9;
int const MOD = 1000000007;

using namespace std;

    int n, m, h, x, y, mn=INF, nom, sum;
    int a[MAXN];
    int d[MAXN];
    int used[MAXN], used0[MAXN];
    vector <int> ans;
    vector <int> g[MAXN];
    vector <int> komp;
    set <pair <int, int> > st;

    void dfs (int v){
        used[v]=1;
        komp.pb(v);
        for (int i=0; i<g[v].size(); i++){
            int to=g[v][i];
            if ((a[v]+1)%h==a[to]){
                if (!used[to])
                    dfs(to);
                else if (used[to]==2)
                    sum+=d[to];
            }
        }
        used[v]=2;
    }

int main()
{
    ifstream cin ("input.txt");
    ofstream cout ("output.txt");
    ios_base::sync_with_stdio(0);

    cin >> n >> m >> h;
        for (int i=1; i<=n; i++)
            cin >> a[i];
        for (int i=0; i<m; i++){
            cin >> x >> y;
            if (st.find(mp(min(x, y), max(x, y)))==st.end()){
                g[x].pb(y);
                g[y].pb(x);
                st.insert(mp(min(x, y), max(x, y)));
            }
        }
        for (int i=1; i<=n; i++){
            bool p=true;
            for (int j=0; j<g[i].size(); j++){
                int to=g[i][j];
                if ((a[i]+1)%h==a[to]){
                    p=false;
                    break;
                }
            }
            if (p){
                cout << 1 << endl << i;
                return 0;
            }
            if (!used[i]){
                sum=0;
                komp.clear();
                dfs(i);
                sum+=komp.size();
                for (int j=0; j<komp.size(); j++)
                    d[komp[j]]=sum;
            }
            if (d[i]<mn){
                mn=d[i];
                nom=i;
            }
        }
    //cout << mn << endl;
    queue <int> q;
    q.push(nom);
    used0[nom]=1;
    while (!q.empty()){
        int v=q.front();
        q.pop();
        ans.pb(v);
        //cout << v << " ";
        for (int i=0; i<g[v].size(); i++){
            int to=g[v][i];
            if (!used0[to] && (a[v]+1)%h==a[to]){
                used0[to]=1;
                q.push(to);
            }
        }
    }
    cout << ans.size() << endl;
        for (int i=0; i<ans.size(); i++)
            cout << ans[i] << " ";
    return 0;
}
