#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 100100;
int n, m, h, t[MAXN], a, b, mi = -1, in;
vector<int> g[MAXN];
int used[MAXN], pr[MAXN], sz[MAXN];
vector<int> ans;
vector<int> put;
vector<int> go[MAXN];
vector<pair<int, int> > eg;
bool kok[MAXN];

int get_pr(int v)
{
    if (pr[v] == v)
        return v;
    pr[v] = get_pr(pr[v]);
    return pr[v];
}

void uni(int v, int u)
{
    v = get_pr(v);
    u = get_pr(u);
    if (u == v)
        return;
    if (rand() % 2)
    {
        pr[u] = v;
        sz[v] += sz[u];
    }
    else
    {
        pr[v] = u;
        sz[u] += sz[v];
    }
}

void dfs(int v)
{
    used[v] = 1;
    put.push_back(v);
    for (int i : g[v])
    {
        if (used[i] == 2)
            continue;
        if (used[i] == 0)
        {
            dfs(i);
        }
        else
        {
            for (int j = put.size() - 1; j >= 0; j--)
            {
                if (put[j] == i)
                    break;
                uni(put[j], i);
            }
        }
    }
    used[v] = 2;
    put.pop_back();
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
    {
        pr[i] = i;
        sz[i] = 1;
        cin >> t[i];
    }
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b;
        a--;
        b--;
        if ((t[a] + 1) % h == t[b])
        {
            g[a].push_back(b);
            eg.push_back({ a, b });
        }
        if ((t[b] + 1) % h == t[a])
        {
            g[b].push_back(a);
            eg.push_back({ b, a });
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
            dfs(i);
    }

    for (pair<int, int> i : eg)
    {
        if (get_pr(i.X) == get_pr(i.Y))
            continue;
        go[get_pr(i.X)].push_back(get_pr(i.Y));
    }

    for (int i = 0; i < n; i++)
    {
        if ((go[get_pr(i)].size() == 0) 
            && (mi == -1 || sz[get_pr(i)] < mi))
        {
            mi = sz[get_pr(i)];
            in = get_pr(i);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (get_pr(i) == in)
            ans.push_back(i + 1);
    }
    cout << ans.size() << endl;
    for (int i : ans)
        cout << i << " ";
    return 0;
}