#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 100100, LOG = 15;
int n, m, h, t[MAXN], a, b, mi = -1, in;
vector<int> g[MAXN];
int used[MAXN], pr[MAXN], sz[MAXN];
vector<int> ans;
vector<int> put;
vector<int> go[MAXN];
vector<pair<int, int> > eg;
int kak[MAXN];
bool kok[MAXN];

int get_pr(int v)
{
    if (pr[v] == v)
        return v;
    pr[v] = get_pr(pr[v]);
    return pr[v];
}

void uni(int v, int u)
{
    v = get_pr(v);
    u = get_pr(u);
    if (u == v)
        return;
    if (rand() % 2)
    {
        pr[u] = v;
        sz[v] += sz[u];
        kak[v] += kak[u];
        kak[u] = 0;
    }
    else
    {
        pr[v] = u;
        sz[u] += sz[v];
        kak[u] += kak[v];
        kak[v] = 0;
    }
}

void dfs(int v)
{
    used[v] = 1;
    kak[get_pr(v)]++;
    put.push_back(v);
    kok[v] = true;
    for (int i : g[v])
    {
        i = get_pr(i);
        if (used[i] == 0)
        {
            dfs(i);
        }
        else if(kak[i] != 0)
        {
            while (get_pr(put.back()) != get_pr(i))
            {
                uni(put.back(), i);
                kok[put.back()] = false;
                kak[get_pr(put.back())]--;
                put.pop_back();
            }
        }
    }
    used[v] = 2;
    if (kok[v])
    {
        kak[v]--;
        kok[v] = false;
        put.pop_back();
    }
}

int solve2()
{
    mi = -1;
    ans.clear();
    for (int i = 0; i < n; i++)
    {
        kak[i] = 0;
        used[i] = 0;
        pr[i] = i;
        sz[i] = 1;
        kok[i] = false;
    }

    for (int i = 0; i < n; i++)
    {
        if (!used[i])
            dfs(i);
    }

    for (pair<int, int> i : eg)
    {
        if (get_pr(i.X) == get_pr(i.Y))
            continue;
        go[get_pr(i.X)].push_back(get_pr(i.Y));
    }

    for (int i = 0; i < n; i++)
    {
        if ((go[get_pr(i)].size() == 0)
            && (mi == -1 || sz[get_pr(i)] < mi))
        {
            mi = sz[get_pr(i)];
            in = get_pr(i);
        }
    }
    for (int i = 0; i < n; i++)
    {
        if (get_pr(i) == in)
            ans.push_back(i + 1);
    }
    cout << ans.size() << endl;
    for (int i : ans)
        cout << i << " ";
    return 0;
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin >> n >> m >> h;
    for (int i = 0; i < n; i++)
    {
        g[i].clear();
        go[i].clear();
        cin >> t[i];
    }
    eg.clear();
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b;
        a--;
        b--;
        if ((t[a] + 1) % h == t[b])
        {
            g[a].push_back(b);
            eg.push_back({ a, b });
        }
        if ((t[b] + 1) % h == t[a])
        {
            g[b].push_back(a);
            eg.push_back({ b, a });
        }
    }
    
    solve2();

    return 0;
}