#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 200100, MAG = 40;
int p, n, d, b, a[MAXN], a2[MAXN], m1, m2;

int solve1(int gr)
{
    long long kol, cl, ans;
    ans = 0;
    cl = 0;
    kol = 0;
    for (int j = 0; j < gr; j++)
    {
        for (int i = cl; i < n && i <= cl + d; i++)
        {
            kol += a2[i];
        }
        cl = cl + d + 1;
        if (kol < b)
        {
            ans++;
        }
        else
        {
            kol -= b;
        }
    }
    return ans;
}

int solve2(int raz)
{
    int tec = 0, in, ans = 0;
    fill(a2, a2 + n, 0);
    for (int i = 0; i < n; i++)
    {
        if (tec + a[i] > raz)
        {
            a2[i] = raz - tec;
            break;
        }
        tec += a[i];
        a2[i] = a[i];
    }
    ans = solve1(m1);
    for (int i = 0; i < n; i++)
    {
        a2[i] = a[i] - a2[i];
    }
    reverse(a2, a2 + n);
    ans = max(ans, solve1(m2));
    return ans;
}

int solve2T(int raz)
{
    int tec = 0, in, ans = 0, ans2 = 0;
    fill(a2, a2 + n, 0);
    for (int i = 0; i < n; i++)
    {
        if (tec + a[i] > raz)
        {
            a2[i] = raz - tec;
            break;
        }
        tec += a[i];
        a2[i] = a[i];
    }
    ans = solve1(m1);
    for (int i = 0; i < n; i++)
    {
        a2[i] = a[i] - a2[i];
    }
    reverse(a2, a2 + n);
    ans2 = solve1(m2);
    return ans - ans2;
}

int solve2()
{
    int l = 0, r = n * b, lm, rm, anl, anr;
    while (r > l + MAG)
    {
        lm = (l * 2 + r) / 3;
        rm = (l + r * 2) / 3;
        anl = solve2T(lm);
        anr = solve2T(rm);
        if (anl <= 0 && anr >= 0)
        {
            break;
        }
        if (anl > 0)
            l = lm;
        if (anr < 0)
            r = rm;
    }

    int ans = -1, tec;
    for (int i = l; i <= r; i++)
    {
        tec = solve2(i);
        if (ans == -1 || ans > tec)
            ans = tec;
    }
    return ans;
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin >> p >> n >> d >> b;
    m1 = n / 2 + n % 2;
    m2 = n / 2;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        a2[i] = a[i];
    }
    if (p == 1)
    {
        cout << solve1(n);
    }
    else
    {
        cout << solve2();
    }
    return 0;
}