#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

#define X first
#define Y second

const long long MAXN = 200100;
int n, itz = 0, in = 0, lo;
string s;
vector<int> g[MAXN];
bool used[MAXN];
int pr = 0, uk;
bool f = false;

bool obra(int v)
{
    f = false;
    while (itz != v)
    {
        if (!used[itz] && s[itz] == '0')
        {
            f = true;
            break;
        }
        itz++;
    }
    if (!f)
    {
        return true;
    }
    in++;
    g[in].push_back(itz);
    used[itz] = true;
    return false;
}

int main()
{
#if _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; i++)
    {
        if (s[i] == '0')
        {
            if (pr == 0)
            {
                g[in].push_back(i);
                pr = 1;
                used[i] = true;
            }
        }
        else
        {
            if (pr == 1)
            {
                g[in].push_back(i);
                used[i] = true;
                pr = 0;
            }
            else
            {
                if (obra(i))
                {
                    cout << -1;
                    return 0;
                }

                g[in].push_back(i);
                used[i] = true;
                pr = 0;
            }
        }
    }
    if (pr == 0)
    {
        cout << -1;
        return 0;
    }
    itz = 0;
    uk = 0;
    lo = in;
    while (itz < n)
    {
        if (used[itz] || s[itz] == '1')
        {
            itz++;
            continue;
        }
        if (uk < lo && g[uk].back() < itz)
        {
            g[uk].push_back(itz);
            uk++;
        }
        else
        {
            in++;
            g[in].push_back(itz);
        }
        itz++;
    }
    if (uk != lo)
    {
        cout << -1;
        return 0;
    }
    cout << in + 1 << endl;
    for (int i = 0; i <= in; i++)
    {
        cout << g[i].size() << " ";
        for (int j : g[i])
            cout << j + 1 << " ";
        cout << endl;
    }
    return 0;
}