#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const double EPS = 1e-6;
const int MAXN = 1024;
const int M = 10;

vector <int> all(M);
int res = INF;
vector <int> ans(M, 0);
vector <int> a;
int n;

inline void tryUpd() {
    vector <bool> can(2 * MAXN, false);
    can[MAXN] = true;
    int cnt = 0;
    for (int i = 0; i < M; i++) {
        int x = (1 << i) * all[i];
        if (all[i]) {
            cnt++;
        }
        auto can1 = can;
        for (int j = 0; j < 2 * MAXN - x; j++) {
            if (!can[j] || j + x < 0) continue;
            can1[j + x] = true;
        }
        can = can1;
    }
    for (int i = 0; i < n; i++) {
        if (!can[a[i] + MAXN]) {
            return;
        }
    }
    if (res > cnt) {
        res = cnt;
        ans = all;
    }
}

int last;

void force(int now) {
    if (now == M) {
        tryUpd();
        return;
    }
    for (int i = -1; i <= 1; i++) {
        if (now == M - 1 && i && i != last) continue;
        all[now] = i;
        force(now + 1);
    }
}

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    if (a.back() > 0 && abs(a.back()) >= abs(a[0])) {
        last = 1;
    } else {
        last = -1;
    }
    force(0);
    cout << res << "\n";
    for (int i = 0; i < M; i++) {
        if (ans[i]) {
            cout << ans[i] * (1 << i) << " ";
        }
    }
}
