#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-6;

int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    string s;
    cin >> s;
    int n = s.size();
    set <int> a, b;
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            a.insert(i);
        } else {
            b.insert(i);
        }
    }
    int cnt = (int) a.size() - (int) b.size();
    if (cnt <= 0) {
        cout << -1;
        return 0;
    }
    vector <vector <int> > res;
    for (int i = 0; i < cnt - 1; i++) {
        int pos1 = *a.begin();
        int pos2 = *b.begin();
        int pos3 = *a.rbegin();
        a.erase(pos1);
        a.erase(pos3);
        b.erase(pos2);
        res.push_back({pos1, pos2, pos3});
        if (pos1 < pos2 && pos2 < pos3) {
            continue;
        }
        cout << -1;
        return 0;
    }
    vector <int> c;
    c.push_back(*a.begin());
    a.erase(a.begin());
    while (b.size()) {
        c.push_back(*b.begin());
        c.push_back(*a.begin());
        b.erase(b.begin());
        a.erase(a.begin());
    }
    for (int i = 1; i < (int) c.size(); i++) {
        if (c[i] < c[i - 1]) {
            cout << -1;
            return 0;
        }
    }
    res.push_back(c);
    cout << res.size() << "\n";
    for (auto mas : res) {
        cout << mas.size() << " ";
        for (int x : mas) {
            cout << x + 1 << " ";
        }
        cout << "\n";
    }
}
