#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

void build_pref(vector<ll> &v, vector<ll> &pref) {
	pref.resize(v.size() + 1);
	for (int i = 0; i < v.size(); ++i)
		pref[i + 1] = pref[i] + v[i];
}

ll get(int l, int r, vector<ll>& pref) {
	return pref[r + 1] - pref[l];
}

void solve1() {
	int n, d, b;
	cin >> n >> d >> b;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	vector<ll> pref;
	build_pref(v, pref);
	int res = 0;
	int l = 0, r = d;
	ll add = 0;
	for (int i = 0; i < v.size(); ++i) {
		ll sum = get(l, r, pref);
		if (sum + add>= b)
			add -= (b - v[i]);
		else {
			res++;
			add += v[i];
		}
		l++;
		r += d;
		r = min(r, (int)v.size() - 1);
	}
	cout << res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int p;
	cin >> p;
	if (p == 1)
		solve1();
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

