#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <string>
#include <bitset>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

//const int base = 20;

const int add = 128;

bool next_combination(vector<int> & a, int n) {
	int k = (int)a.size();
	for (int i = k - 1; i >= 0; --i)
		if (a[i] < n - k + i + 1) {
			++a[i];
			for (int j = i + 1; j<k; ++j)
				a[j] = a[j - 1] + 1;
			return true;
		}
	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	vector<int> step;
	int start = -add;
	while (start <= add) {
		step.push_back(start);
		if (start < 0)
			start /= 2;
		else
			start *= 2;
		if (start == 0)
			start = 1;
	}
	for (int i = 0; true; ++i) {
		vector<int> a;
		for (int j = 0; j < i; ++j)
			a.push_back(j);
		do {
			vector<int> val;
			for (int b : a)
				val.push_back(step[b]);
			vector<bool> dp(add * 2 + 1, 0);
			vector<bool> next(add * 2 + 1, 0);
			dp[add] = 1;
			for (int p : val) {
				for (int j = 0; j < dp.size(); ++j) {
					if (dp[j]) {
						next[j] = true;
						if (j + p < dp.size() && j + p >= 0)
							next[j + p] = true;
					}
				}
				swap(dp, next);
			}
			char flag = 1;
			for (int p : v) {
				if (!dp[p + add]) {
					flag = 0;
					break;
				}
			}
			if (flag) {
				cout << a.size() << "\n";
				for (int p : a)
					cout << step[p] << ' ';
				return 0;
			}
		} while (next_combination(a, step.size() - 1));
	}
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

