#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

const int add = 131072;
const int MAXN = 40;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	string s;
	cin >> s;
	int n = s.length();
	vector<int> pref(n, 0), suf(n, 0);
	set<int> vnul, vone;
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			pref[i] += pref[i - 1];
		if (s[i] == '0') {
			pref[i]++;
			vnul.insert(i);
		}
		else {
			pref[i]--;
			vone.insert(i);
		}
		if (pref[i] < 0) {
			cout << "-1";
			return 0;
		}
	}

	for (int i = n - 1; i >= 0; --i) {
		if (i != n - 1)
			suf[i] += suf[i + 1];
		if (s[i] == '0')
			suf[i]++;
		else
			suf[i]--;
		if (suf[i] < 0) {
			cout << "-1";
			return 0;
		}
	}
	vector<vector<int> > output;
	while (!vnul.empty()) {
		vector<int> cur;
		int pos = 0;
		while (true) {
			auto it1 = vnul.lower_bound(pos);
			pos = *it1;
			cur.push_back(pos);
			vnul.erase(it1);
			auto it2 = vone.lower_bound(pos);
			if (it2 == vone.end())
				break;
			pos = *it2;
			cur.push_back(pos);
			vone.erase(it2);
		}
		output.push_back(cur);
	}
	cout << output.size() << endl;
	for (int i = 0; i < output.size(); ++i) {
		cout << output[i].size() << ' ';
		for (int val : output[i])
			cout << val + 1 << ' ';
		cout << '\n';
	}
#ifndef ONLINE_JUDGE
	cout << '\n';
	cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

