#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#define X first
#define Y second
#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()

constexpr ll MOD = 1000000007;
mt19937 rnd (228);
constexpr ld pi = acos(-1.0);

constexpr int N = 100005;

int hour [N];
int in_time [N];
int d [N];
int timer;
bool visited [N];
vector<int> adj [N];
vector<int> adj_rev [N];

vector<int> comp_v [N];

int n, m, h;
int ts [N];
int ts_cnt;
int comp_cnt;

int comp [N];
int comp_size [N];

bool bad [N];

void topsort(int v) {

	visited[v] = true;

	for (int u : adj[v]) {
		if (!visited[u]) {
			topsort(u);
		}
	}

	ts[ts_cnt++] = v;
}

void find_comp(int v, int comp_id) {
	comp[v] = comp_id;
	comp_size[comp_id]++;
	comp_v[comp_id].push_back(v);

	//cout << "comp " << comp_id << ", vertex " << v << endl;

	for (int u : adj_rev[v]) {
		if (comp[u] == -1) {
			find_comp(u, comp_id);
		}
	}
}

bool visited2 [N];

void recalc(int v) {
	visited2[v] = true;

	for (int u : adj_rev[v]) {
		if (comp[v] != comp[u]) {
			comp_size[u] += comp_size[v];
		} else if (!visited2[u]) {
			recalc(u);
		}
	}
}

void kosaraju() {

	fill_n(comp, N, -1);
	for (int i = 1; i <= n; i++) {
		if (!visited[i]) topsort(i);
	}

	for (int i = ts_cnt-1; i >= 0; i--) {
		if (comp[ts[i]] == -1) {
			find_comp(ts[i], comp_cnt++);
		}
	}

	for (int i = 0; i < ts_cnt; i++) {
		if (!visited2[ts[i]]) recalc(ts[i]);
	}
}

int main(void) {
	scanf("%d%d%d", &n, &m, &h);

	/*if (h == 2) {

		for (int i = 0; i < m; i++) {
			int a, b;
			scanf("%d%d", &a, &b);

			adj[a].push_back(b);
			adj[b].push_back(a);
		}

		dfs(1);

		for (int i = 1; i <= n; i++) {
			if (!visited[i]) {
				puts("1");
				printf("%d\n", i);
				return 0;
			}
		}

		printf("%d\n", n);
		for (int i = 1; i <= n; i++) {
			printf("%d ", i);
		}
		return 0;
	}*/

	for (int i = 1; i <= n; i++) {
		scanf("%d", hour+i);
	}
	
	
	for (int i = 0; i < m; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		if ((hour[a]+1) % h == hour[b]) {
			adj[a].push_back(b);
			adj_rev[b].push_back(a);
		}
		if ((hour[b]+1) % h == hour[a]) {
			adj[b].push_back(a);
			adj_rev[a].push_back(b);
		}
	}

	kosaraju();

	vector<int> best_one;

	for (int i = comp_cnt-1; i >= 0; i--) {

		if (comp_size[i] == 1) {
			puts("1");
			printf("%d\n", comp_v[i][0]);
			return 0;
		} else {
			if (best_one.empty() || comp_size[i] < (int) best_one.size()) {
				best_one = comp_v[i];
			}
		}
	}

	printf("%d\n", (int) best_one.size());
	for (int a : best_one) {
		printf("%d ", a);
	}

	return 0;
}