#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)

#define X first
#define Y second
#define mp make_pair
#define mt make_tuple
#define all(x) (x).begin(), (x).end()

constexpr ll MOD = 1000000007;
mt19937 rnd (228);
constexpr ld pi = acos(-1.0);

string s;

set<int> zeros;
set<int> ones; 

void fail() {
	puts("-1");
	exit(0);
}

int main(void) {
	//ios_base::sync_with_stdio(false);
	//cin.tie(nullptr);
	cin >> s;

	for (int i = 0; i < (int) s.size(); i++) {
		if (s[i] == '0') {
			zeros.insert(i);
		} else {
			ones.insert(i);
		}
	}
	vector<set<int>> answers;

	while (!ones.empty() || !zeros.empty()) {
		set<int> current_ans;

		if (zeros.empty()) {
			fail();
		}

		if (ones.empty()) {
			current_ans.insert(*zeros.begin());
			zeros.erase(zeros.begin());
			answers.push_back(current_ans);
			continue;
		}

		auto lb = zeros.begin();
		auto rb = zeros.rbegin();

		if ((*lb) > (*ones.begin()) || (*rb) < (*ones.rbegin())) {
			fail();
		}

		current_ans.insert(*lb);
		current_ans.insert(*rb);

		auto lit = ones.lower_bound(*lb);
		auto rit = prev(ones.lower_bound(*rb));

		while (lb != zeros.end() && lit != ones.end() && (*lit) <= (*rit) && (*lb) <= (*rb)) {
			current_ans.insert(*lb);
			current_ans.insert(*lit);
			//cout << "was: " << (*lb) << ", " << (*lit) << endl;
			lb = zeros.lower_bound(*lit);
			lit = ones.lower_bound(*lb);
			//cout << "now: " << (*lb) << ", " << (*lit) << endl;
		}

		for (int a : current_ans) {
			ones.erase(a);
			zeros.erase(a);
		}

		answers.push_back(current_ans);

		/*for (int kek : current_ans) {
			cout << (kek+1) << " ";
		}
		cout << endl;*/

		//cout << ones.size() << " " << zeros.size() << endl;
	}

	cout << (int) answers.size() << endl;

	for (const auto &s : answers) {
		cout << (int) s.size() << " ";
		for (int kek : s) {
			cout << (kek+1) << " ";
		}
		cout << endl;
	}

	return 0;
}