#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

void dfs(int v, vector<vector<int>>& G, vector<int>& used, const int& color, int& res, vector<int>& nums)
{
    used[v] = color;
    nums.push_back(v);
    ++res;
    for (auto u : G[v])
    {
        if (used[u] != color)
        {
            dfs(u, G, used, color, res, nums);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    in.tie(nullptr);
    int n, m, h, c1, c2;
    in >> n >> m >> h;
    vector<int> u(static_cast<unsigned int>(n + 1));
    for (int i = 1; i <= n; ++i)
    {
        in >> u[i];
    }
    vector<vector<int>> G(static_cast<unsigned int>(n + 1));
    for (int i = 0; i < m; ++i)
    {
        in >> c1 >> c2;
        if ((u[c1] + 1) % h == u[c2])
        {
            G[c1].push_back(c2);
        }
        if ((u[c2] + 1) % h == u[c1])
        {
            G[c2].push_back(c1);
        }
    }
    vector<int> used(static_cast<unsigned int>(n + 1));
    vector<int> minnums(static_cast<unsigned int>(n));
    vector<int> nums;
    for (int i = 1; i <= n; ++i)
    {
        minnums[i - 1] = i;
    }
    int color = 1, minres = n, res = 0;
    for (int i = 1; i <= n; ++i)
    {
        dfs(i, G, used, color, res, nums);
        if (res < minres)
        {
            minres = res;
            minnums = nums;
        }
        ++color;
        res = 0;
        nums.clear();
    }
    out << minres << '\n';
    for (auto elem : minnums)
    {
        out << elem << ' ';
    }
    out << '\n';
    in.close();
    out.close();
    return 0;
}