#include<bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long int ull;
typedef double dd;
typedef long double ldd;

ll bp(ll a, ll n)
{
    if (n == 0)
        return 1;
    ll b = bp(a, n / 2);
    return (b * b) * (n % 2 == 1 ? a : 1);
}

/*
        /\
       /()\
      /(88)\
     /(0000)\
    /(0 00 0)\
   /(0 0)(0 0)\
  /(0 0)/\(0 0)\
 /(0 0)/  \(0 0)\
/(0 0)/    \(0 0)\
\(0 0)\    /(0 0)/
 \(0 0)\  /(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)//\\(0 0)\
/(0 0)///\\\(0 0)\
\(0 0)\\\///(0 0)/
 \(0 0)\\//(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)//\\(0 0)\
/(0 0)///\\\(0 0)\
\(0 0)\\\///(0 0)/
 \(0 0)\\//(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)/  \(0 0)\
/(0 0)/    \(0 0)\
\(0 0)\    /(0 0)/
 \(0 0)\  /(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
    \(0 00 0)/
     \(0000)/
      \(88)/
       \()/
        \/
*/

vector<int> t(1e5+1);
vector<vector<int>> gr(1e5+1), rgr(1e5+1);
vector<bool> was(1e5 + 1);
vector<int> ans(1e5+1);
map<pair<int, int>, bool> pw;

int cnt;

void cn(int v, int pr = 0)
{
    ++cnt;
    if (pr)
        ans[v] = pr;
    bool wa = was[v];
    was[v] = !wa;
    for (int i = 0; i < gr[v].size(); ++i)
    {
        int to = gr[v][i];
        if (was[to] == wa)
        {
            cn(to, pr);
        }
    }
}

void fix(int v)
{
    cnt = 0;
    cn(v);
  //  cout << cnt << '\n';
    cn(v, cnt);
}

int dfs(int v)
{
    //cout << v << "__\n";
    int an = 1;
    was[v] = 1;
    for (int i = 0; i < gr[v].size(); ++i)
    {
        int to = gr[v][i];
        if(!was[to]){
            int re = dfs(to);
            if (re == -1){
                an += ans[to];
                continue;
            }
            if (v == re)
                return -1;
            return re;
        }
        else if (was[to] && ans[to] == 0)
        {
            fix(to);
            return to;
        }
        else
        {
            an += ans[to];
        }
    }
    ans[v] = an;
  //  cout <<v << " " << an << '\n';
    return -1;
}

void dfsc(int v)
{
    cout << v + 1 << " ";
    was[v] = 0;
    for (int i = 0; i < gr[v].size(); ++i)
    {
        int to = gr[v][i];
        if (was[to])
            dfsc(to);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("in.in", "r", stdin);

    int n, m, h;

    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    int a, b;
    for (int i = 0; i < m; ++i)
    {
        cin >> a >> b;
        --a;
        --b;
        if (t[a] > t[b])
            swap(a, b);
        if (pw[{a, b}])
            continue;
        pw[{a, b}] = 1;
        if (t[a] == 0)
        {
            if (t[b] == 1)
            {
                gr[a].push_back(b);
            }
            else
            {
                if (t[b] == h-1)
                {
                    gr[b].push_back(a);
                }
            }
        }
        else
        {
            if (t[a] - t[b] == 1)
            {
                gr[b].push_back(a);
            }
            else if (t[b] - t[a] == 1)
            {
                gr[a].push_back(b);
            }
        }
    }

 /*   for (int i = 0; i < n; i++)
    {
        cout << i << ": ";
        for (int j = 0; j < gr[i].size(); j++)
            cout << gr[i][j] << " ";
        cout << '\n';
    }
*/
    int mi = 1e8, th;
    for (int i = 0; i < n; i++)
    {
        if(!was[i])
            dfs(i);
        if (ans[i] < mi)
        {
            mi = ans[i];
            th = i;
        }
      //  cout << ans[i] << " ";
    }
//    cout << '\n';
    cout << mi << '\n';
    dfsc(th);
    return 0;
}
