#include<bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef unsigned long long int ull;
typedef double dd;
typedef long double ldd;

ll bp(ll a, ll n)
{
    if (n == 0)
        return 1;
    ll b = bp(a, n / 2);
    return (b * b) * (n % 2 == 1 ? a : 1);
}

/*
        /\
       /()\
      /(88)\
     /(0000)\
    /(0 00 0)\
   /(0 0)(0 0)\
  /(0 0)/\(0 0)\
 /(0 0)/  \(0 0)\
/(0 0)/    \(0 0)\
\(0 0)\    /(0 0)/
 \(0 0)\  /(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)//\\(0 0)\
/(0 0)///\\\(0 0)\
\(0 0)\\\///(0 0)/
 \(0 0)\\//(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)//\\(0 0)\
/(0 0)///\\\(0 0)\
\(0 0)\\\///(0 0)/
 \(0 0)\\//(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
  /(0 0)/\(0 0)\
 /(0 0)/  \(0 0)\
/(0 0)/    \(0 0)\
\(0 0)\    /(0 0)/
 \(0 0)\  /(0 0)/
  \(0 0)\/(0 0)/
   \(0 0)(0 0)/
    \(0 00 0)/
     \(0000)/
      \(88)/
       \()/
        \/
*/

vector<int> t(1e5+1);
vector<vector<int>> gr(1e5+1);
vector<bool> was(1e5 + 1);
vector<bool> come(1e5+1);
vector<int> ins(1e5+1);

map<pair<int, int>, bool> pw;

ll cnt;

void isc(int v)
{
    ins[v] = 1;
    for (int i = 0; i < gr[v].size(); ++i)
    {
        int to = gr[v][i];
        if (ins[to] == 1){
            come[v] = 1;
        }
        if (ins[to] == 0)
            isc(to);
    }
    //cout << '\n';
    ins[v] = 2;
}

void dfs(int v, bool co = 0)
{
    if (co)
        cout << v + 1 << " ";
    ++cnt;
    bool ws = was[v];
    was[v] = !ws;
    for (int i = 0; i < gr[v].size(); i++)
    {
        if(was[gr[v][i]] == ws)
            dfs(gr[v][i], co);
    }
    was[v] = ws;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("in.in", "r", stdin);

    int n, m, h;

    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    int a, b;
    for (int i = 0; i < m; ++i)
    {
        cin >> a >> b;
        --a;
        --b;
        if (t[a] > t[b])
            swap(a, b);
        if (pw[{a, b}])
            continue;
        pw[{a, b}] = 1;
        if (t[a] == 0)
        {
            if (t[b] == h-1)
                {
                    gr[b].push_back(a);
        //            come[a] = 1;
                }

        }
        if (t[b] - t[a] == 1)
        {
                gr[a].push_back(b);
        //        come[b] = 1;
        }
    }

    /*for (int i = 0; i < n; i++)
    {
        cout << i << ": ";
        for (int j = 0; j < gr[i].size(); j++)
            cout << gr[i][j] << " ";
        cout << '\n';
    }
*/
    //for (int i = 0; i < n; i++)
    //    cout << come[i] << " ";
    //        cout << '\n';
    for (int i = 0; i < n; ++i)
    {
        if (gr[i].size() == 0)
        {
            cout << "1\n" << i+1;
            return 0;
        }
    }
    ll mi = 1e10, th;
    for (int i = 0; i < n; i++)
    {
        if (ins[i] == 0)
            isc(i);
    }
  //  cout << '\n';
    for (int i = 0; i < n; i++)
    {
        if (come[i] == 0)
            continue;
        if (!was[i])
        {
            cnt = 0;
            dfs(i);
            if (cnt < mi)
            {
                mi = cnt;
                th = i;
            }
        }
    }
    cout << mi << '\n';
    dfs(th, 1);
    return 0;
}
