#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>
#include <bitset>

using namespace std;

const int MAXN = 1e5 + 7;

int t[MAXN];
bool can[MAXN];
vector <int> g[MAXN];

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);

	int n, m, h;
	cin >> n >> m >> h;

	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	for (int u = 0; u < n; ++u) {
		can[u] = true;
		for (int v : g[u]) {
			can[u] &= (t[v] != (t[u] + 1) % h);
		}
		if (can[u]) {
			cout << "1\n" << u + 1 << '\n';
			return 0;
		}
	}

	cout << n << '\n';
	for (int i = 1; i <= n; ++i) {
		cout << i << ' ';
	}
	cout << '\n';

	return 0;
}