#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>

using namespace std;
#define int long long

const int MAXN = 1007;
const int INF = 1e9 + 7;

bool can[MAXN][MAXN];
int dp[MAXN][MAXN];
int a[MAXN];
int pref[MAXN];

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);

	int p, n, d, b;
	cin >> p >> n >> d >> b;

	if (n <= 10) return 1;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	
	for (int i = 0; i < n; ++i) {
		pref[i + 1] = pref[i] + a[i];
	}

	for (int i = 0; i < MAXN; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			dp[i][j] = -INF;
			can[i][j] = false;
		}
	}

	can[0][0] = true;
	dp[0][0] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= i; ++j) {
			int r = min(n, i + i * d);
			int add = pref[r] - pref[i - 1];

			can[i][j] = ((can[i - 1][j] && b <= dp[i - 1][j] + add) || (j && can[i - 1][j - 1]));
			if (!can[i][j]) continue;
			dp[i][j] = max(dp[i - 1][j] - b + add, dp[i - 1][j - 1] + add);
			if (j) dp[i][j] = max(dp[i][j], dp[i][j - 1]);
		}
	}

	for (int j = 0; j <= n; ++j) {
		if (can[n][j]) {
			cout << j << '\n';
			return 0;
		}
	}

	return 0;
}