#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <time.h>
#include <string>
#include <random>
#include <algorithm>
#include <bitset>

using namespace std;

const int MAXN = 2007;
const int ADD = MAXN / 2;
const int INF = 1e9 + 7;
const int MAXL = 20;

bitset <MAXN> dp;

inline int getp(int x) {
	return x + ADD;
}

inline int getval(int pw) {
	int p = MAXL / 2;
	if (pw <= p - 1) {
		return -(1 << pw);
	}
	else {
		return (1 << (pw - p));
	}
}

signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(false);

	int n;
	cin >> n;

	vector <int> a(n);
	bool have = false;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		have |= (a[i] % 2);
	}
	
	int ans = INF;
	int best = -1;
	for (int mask = 0; mask < (1 << MAXL); ++mask) {
		int cnt = 0;
		for (int pw = 0; pw < MAXL; ++pw) {
			cnt += ((mask >> pw) & 1);
		}

		if (ans < cnt) continue;

		dp &= false;
		dp[getp(0)] = true;

		for (int pw = 0; pw < MAXL; ++pw) {
			int val = getval(pw);

			if ((mask >> pw) & 1) {
				if (val < 0) {
					dp |= (dp >> abs(val));
				}
				else {
					dp |= (dp << abs(val));
				}
			}

		}

		bool check = true;
		for (int elem : a) {
			check &= (dp[getp(elem)]);
		}

		if (check && cnt < ans) {
			ans = cnt;
			best = mask;
		}
	}

	cout << ans << '\n';

	for (int pw = 0; pw < MAXL; ++pw) {
		if ((best >> pw) & 1) {
			cout << getval(pw) << ' ';
		}
	}

	return 0;
}