#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <map>
#include <cstdio>

using namespace std;

const int MAXN = 2e5;
int a[MAXN], pref[MAXN];

int get(int l, int r) { return pref[r + 1] - pref[l]; }

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int p, n, d, b; cin >> p >> n >> d >> b;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (p == 1) {
        pref[0] = 0;
        for (int i = 0; i < n; i++)
            pref[i + 1] = pref[i] + a[i];
        int last = 0, res = 0;
        for (int i = 0; i < n; i++) {
            int cnt = last + get(min(n - 1, (i - 1) + i * d) + 1, min(n - 1, i + (i + 1) * d));
            if (cnt >= b)
                last = cnt - b;
            else
                last = cnt, res++;
        }
        cout << res << endl;
    } else
        assert(false);

    return 0;
}
