#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int main() {
	int n, m, h;
	cin >> n >> m >> h;

	vector<int> t(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i];
	}

	vector<vector<int>> graph(n);
	int from, to;
	for (int i = 0; i < m; ++i) {
		cin >> from >> to;
		--from;
		--to;

		graph[from].push_back(to);
		graph[to].push_back(from);
	}

	for (int i = 0; i < n; ++i) {
		vector<int> depend;
		for (int v : graph[i]) {
			if ((t[i] + 1) % h == t[v]) {
				depend.push_back(v);
			}
		}

		if (depend.empty()) {
			cout << 1 << '\n' << i + 1;

			return 0;
		}
	}

	cout << n << '\n';
	for (int i = 0; i < n; ++i) {
		cout << i + 1 << ' ';
	}

    return 0;
}