#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

vector<int> arr;
int n, d, b;

bool check(int l)
{
    //cerr << "check " << l << "\n";
    long long s = 0;
    int r = 0;
    for (int i = l; i < n; i++)
    {
        for (int j = 0; r <= min((long long)(n - 1), (long long)(i + 1) * d + i); j++)
            s += arr[r++];
        if (s < b)
            return 0;
        s -= b;
    }
    return 1;
}

int bin_s()
{
    int l = -1, r = n;
    while (r - l > 1)
    {
        int m = (r + l) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    return r;
}

int main()
{
    ifstream cin("input.txt");
    int p;
    cin >> p >> n >> d >> b;
    arr.resize(n);
    for (int &i : arr)
        cin >> i;
    int ans = bin_s();
    //cerr << ans;
    if (p > 1)
    {
        reverse(arr.begin(), arr.end());
        ans = max(ans, bin_s());
    }
    cout << ans;
    return 0;
}