#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstring>
#include <cassert>

using namespace std;

const int maxn = 10000;
const int maxd = 23;
int n;
int arr[maxn];
int arrc[maxd][maxn];

int rec(int d, int& pos, int& neg)
{
    bool f1 = 0, f2 = 0;
    for (int i = 0; i < n; i++)
    {
        if (arr[i])
            f2 = 1;
        if (abs(arr[i]) % 2 != 0)
            f1 = 1;
    }
    //cerr << P << " " << N << " " << f1 << "\n";
    if (!f2)
    {
        pos = neg = 0;
        //cerr << "returned\n";
        return 0;
    }
    if (!f1)
    {
        for (int i = 0; i < n; i++)
            arr[i] /= 2;
        int ret = rec(d, pos, neg);
        pos <<= 1;
        neg <<= 1;
        for (int i = 0; i < n; i++)
            arr[i] *= 2;
        return ret;
    }
    int ret = 100, ret_p, ret_n;
    for (int j = -1; j <= 1; j += 2)
    {
        for (int i = 0; i < n; i++)
            arrc[d][i] = arr[i];
        for (int i = 0; i < n; i++)
            if (arr[i] % 2)
                arr[i] = (arr[i] + j) / 2;
            else
                arr[i] /= 2;
        bool f = 0;
        for (int i = 0; i < n; i++)
            if (arr[i] != arrc[d][i])
                f = 1;
        if (!f)
            continue;
        int nret = rec(d + 1, ret_p, ret_n) + 1;
        ret_p = (ret_p << 1) + int(j < 0);
        ret_n = (ret_n << 1) + int(j > 0);
        if (nret < ret)
        {
            ret = nret;
            pos = ret_p;
            neg = ret_n;
        }
        for (int i = 0; i < n; i++)
            arr[i] = arrc[d][i];
    }
    return ret;
}

int main()
{
    ifstream cin("input.txt");
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    int ans_pos, ans_neg;
    cout << rec(0,ans_pos, ans_neg) << "\n";
    for (int i = 1; i < (1 << 20); i <<= 1)
    {
        if (ans_pos & i)
            cout << i << " ";
        if (ans_neg & i)
            cout << -i << " ";
    }
    return 0;
}