#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = (int)1e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, m, h;
int t[N];
int used[N];
int can[N];
set<pii> was;
vector<int> g[N];
vi ans, way;


void dfs(int v, int p) {
    used[v] = true;
    way.push_back(v);
    for(int to:g[v]) {
        if (!used[to]) dfs(to, v);
    }
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(n, m, h);
    rep(i, 0, n) read(t[i]);
    rep(i, 0, m) {
        int x, y;
        read(x, y);
        --x, --y;
        if (was.count(mp(x, y))) continue;
        was.insert(mp(x, y));
        if ((t[x]+1)%h == t[y]) g[x].push_back(y);
        if ((t[y]+1)%h == t[x]) g[y].push_back(x);
    }
    rep(i, 0, n) {
        if (g[i].empty()) {
            printf("1\n%d\n", i+1);
            return 0;
        }
    }
    rep(i, 0, n) {
        fill(used, used+n, false);
        way.clear();
        dfs(i, i);
        if (way.size() < ans.size() || ans.empty()) {
            ans = way;
        }
    }
    printf("%d\n", ans.size());
    for(int v:ans) printf("%d ", ++v);

    return 0;
}
// Part. score: 60