#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = (int)2e5+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


ll n, p, b, d;
ll a[N];
ll f[N];

void modify(int p, ll x) {
    for(;p < N;p |= (p+1)) {
        f[p] += x;
    }
}

ll getsum(int p) {
    ll ret = 0;
    for(;p >= 0; p=(p&(p+1))-1) {
        ret += f[p];
    }
    return ret;
}

ll getsum(int l, int r) {
    return getsum(r)-(l>0 ? getsum(l-1) : 0);
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    read(p, n, d, b);
    rep(i, 0, n) read(a[i]);
    if (p == 1) {
        ll step = 0;
        int r = 0;
        ll sum = 0, rem = 0, res = 0;
        rep(i, 0, n) {
            step = min(n, step+d);
            while (r < min(n, i+step+1)) {
                sum += a[r];
                ++r;
            }
            ll x = min(a[i], rem);
            a[i] -= x;
            rem -= x;
            sum -= a[i];
            if (a[i] == b) continue;
            if (a[i] > b) {
                a[i+1] += a[i]-b;
                sum += a[i]-b;
                a[i] = b;
                continue;
            }
            if (a[i] < b) {
                if (sum >= b-a[i]) {
                    sum -= b-a[i];
                    rem += b-a[i];
                    a[i] = b;
                }
            }
            if (a[i] != b) {
                ++res;
                sum += a[i];
                a[i+1] += a[i];
            }
        }
        printf("%lld\n", res);
    } else {
        rep(i, 0, n) modify(i, a[i]);
        ll lf = 0, rg = n-1;
        ll step = d, res = 0;
        ll r = 0, l = n-1;
        while (lf <= rg) {
            if (lf == rg) {
                res += a[lf] < b;
                break;
            }
//            step = min(step+d, n);
            if (lf+1 == rg) {
                if (a[lf]+a[rg] > b+b) break;
                res += 2;
                if (a[lf]+a[rg] >= b) --res;
                assert(a[lf]+a[rg]>0);
                break;
            }
            int nxtLf = min(rg-1, lf+d);
            int nxtRg = max(lf+1, rg-d);
            if (a[lf] < 0) {
                modify(lf, -a[lf]);
                modify(lf+1, a[lf]);
                a[lf] = 0;
            }
            if (a[rg] < 0) {
                modify(rg, -a[rg]);
                modify(rg-1, a[rg]);
                a[rg] = 0;
            }
//            cout << a[lf] << ' ' << a[rg] << endl;
            if (a[lf] > b) {
                a[nxtLf] += a[lf]-b;
                modify(nxtLf, a[lf]-b);
                a[lf] = b;
            }
            if (a[lf] < b) {
                r = min(lf+step, rg);
                if (r == rg && getsum(lf+1, r) >= b-a[lf]) {
                    ll x = min(a[rg], b-a[lf]);
                    a[rg] -= x;
                    modify(rg, -x);
                    a[lf] += x;
                }
                if (a[lf] < b && getsum(lf+1, r) >= b-a[lf]) {
                    a[lf+1] += a[lf]-b;
                    modify(lf+1, a[lf]-b);
                    a[lf] = b;
                }
            }
            if (a[rg] > b) {
                a[nxtRg] += a[rg]-b;
                modify(nxtRg, a[rg]-b);
                a[rg] = b;
            }
            if (a[rg] < b) {
                l = max(lf+1, rg-step);
                if (getsum(l, rg-1) >= b-a[rg]) {
                    a[rg-1] -= b-a[rg];
                    modify(rg-1, b-a[rg]);
                    a[rg] = b;
                }
            }
            res += a[lf] < b;
            res += a[rg] < b;
            if (a[lf] != b) {
                a[nxtLf] += a[lf];
                modify(nxtLf, a[lf]);
                modify(lf, -a[lf]);
                a[lf] = 0;
            }
            if (a[rg] != b) {
                a[nxtRg] += a[rg];
                modify(nxtRg, a[rg]);
                modify(rg, -a[rg]);
                a[rg] = 0;
            }
//            cout << a[lf] << ' ' << a[rg] << endl << endl;
            ++lf, --rg;
        }
        printf("%lld\n", res);
    }

    return 0;
}
