#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template <typename T1, typename T2>
bool umax(T1& x, const T2& y) {return x<y ? x=y, true : false;}

template <typename T1, typename T2>
bool umin(T1& x, const T2& y) {return x>y ? x=y, true : false;}

template <typename T>
void read(T& x) {
    char ch;
    T p = 1; x = 0;
    do {ch = getchar();} while (ch <= ' ');
    if (ch == '-') p = -1, ch = getchar();
    while ('0' <= ch && ch <= '9') {
        x = x*10+ch-'0';
        ch = getchar();
    }
    x = (p == -1 ? -x : x);
}

void read(char &ch) {
    do {ch = getchar();} while (ch <= ' ');
}

void read(string& x) {
    char ch; x = "";
    do {ch = getchar();} while (ch <= ' ');
    while(ch > ' ') x += ch, ch = getchar();
}

template<typename T, typename... R>
void read(T& x, R&... y) {read(x); read(y...);}

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;

const int N = (int)2e6+3;
const int INF = (int)1e9+17;
const ll LLINF = (ll)1e18+17;


int n, m, h;
int a[N];
bool used[N];
int ans = (1<<19)-1;
int ppcnt[N];
vector<int> add = {-256, -128, -64, -32, -16, -8, -4, -2, -1, 1, 2, 4, 8, 16, 32, 64, 128, 256};


void solve(int mask) {
    fill(used, used+1003, false);
    if (ppcnt[mask] >= ppcnt[ans]) return;
    used[500] = true;
    rep(i, 0, add.size()) {
        if ((mask>>i)&1) {
            if (add[i] > 0) {
                per(j, 0, 1003) {
                    if (j+add[i] >= 0 && j+add[i] <= 1000) {
                        used[j+add[i]] |= used[j];
                    }
                }
            } else {
                rep(j, 0, 1003) {
                    if (j+add[i] >= 0 && j+add[i] <= 1000) {
                        used[j+add[i]] |= used[j];
                    }
                }
            }
        }
    }
    rep(i, 0, n) if (!used[a[i]+500]) return;
    if (ppcnt[ans] > ppcnt[mask]) ans = mask;
}

int main()
{
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    rep(i, 0, N) ppcnt[i] = __builtin_popcount(i);
    read(n);
    rep(i, 0, n) read(a[i]);
    rep(mask, 0, (1<<add.size())) solve(mask);
//    solve(4608);
    vi res;
    rep(i, 0, add.size()) if ((ans>>i)&1) res.push_back(add[i]);
    printf("%d\n", res.size());
    rep(i, 0, res.size()) printf("%d ", res[i]);

    return 0;
}
