#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <queue>
#include <string>
using namespace std;

#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    string s;
    getline(fin, s);
    int n = s.length();
    int group[200500];
    queue<int> q; /// zeros on the right
    set<int> left; /// available zeros on the left
    for (int i=0; i<n; i++) {
        if (s[i]=='0')
            q.push(i);
        group[i] = -1;
    }
    vector<vector<int> > answer;
    int LastZero = -1;
    for (int i=0; i<n; i++) {
        if (s[i]=='1') {
            if (q.empty() || left.empty()) {
                fout << -1;
                return 0;
            } else {
                LastZero = *left.begin();
                left.erase(LastZero);

                if (group[LastZero]==-1) { /// new group
                    int ind = answer.size();
                    vector<int> _new_;
                    _new_.pb(LastZero);
                    _new_.pb(i);
                    _new_.pb(q.front());
                    answer.pb(_new_);
                    group[LastZero] = group[i] = group[q.front()] = ind;
                } else {
                    answer[group[LastZero]].pb(i);
                    answer[group[LastZero]].pb(q.front());
                    group[i] = group[LastZero];
                    group[q.front()] = group[LastZero];
                }
                q.pop();
            }
        } else {
            left.insert(i);
            if (q.front()==i) q.pop();
        }
    }

    for (int i=0; i<n; i++)
        if (group[i] == -1)
            answer.pb(vector<int> (1, i));

    fout << answer.size() << endl;
    for (int i=0; i<answer.size(); i++) {
        fout << answer[i].size() << ' ';
        for (int j=0; j<answer[i].size(); j++)
            fout << answer[i][j]+1 << ' ';
        fout << endl;
    }

    fin.close();
    fout.close();
    return 0;
}
