//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <stdio.h>
#include <bits/stdc++.h>

#define uint unsigned int
#define ll long long
#define ull unsigned long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, r, l) for (int i = r; i > l; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)
#define y1 dhwjdshg

using namespace std;

const int N = 200000;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int P = 239;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const double eps = 1e-9;
const double pi = atan2(0, -1);
const int ABC = 26;

int u[N];
int c[N][2];
vector<int> g[N], gr[N];
bool used[N];
vector<int> order;

void dfs(int u)
{
    used[u] = true;
    for (int v : g[u])
        if (!used[v])
            dfs(v);
    order.push_back(u);
}

int cnt[N];
int col[N];

void dfs1(int u, int t)
{
    used[u] = true;
    col[u] = t;
    cnt[t]++;
    for (int v : gr[u])
        if (!used[v])
            dfs1(v, t);
}

int go[N];

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    //ll TL = 0.95 * CLOCKS_PER_SEC;
    //clock_t time = clock();
    int n, m, h;
    cin >> n >> m >> h;
    rep(i, 0, n)
        cin >> u[i];
    rep(i, 0, m)
    {
        cin >> c[i][0] >> c[i][1];
        c[i][0]--; c[i][1]--;

        if ((u[c[i][0]] + 1) % h == u[c[i][1]])
        {
            g[c[i][0]].push_back(c[i][1]);
            gr[c[i][1]].push_back(c[i][0]);
        }
        if ((u[c[i][1]] + 1) % h == u[c[i][0]])
        {
            g[c[i][1]].push_back(c[i][0]);
            gr[c[i][0]].push_back(c[i][1]);
        }
    }
    rep(i, 0, n)
        if (!used[i])
            dfs(i);
    fill(used, used + n, false);
    int r = 0;
    repb(i, n - 1, -1)
        if (!used[order[i]])
            dfs1(order[i], r++);
    /*rep(i, 0, n)
        cout << col[i] << " ";
    cout << "\n";*/
    rep(i, 0, n)
        for (int j : g[i])
            if (col[j] != col[i])
                go[col[i]]++;
    int id = -1;
    rep(i, 0, r)
        if (go[i] == 0 && (id == -1 || cnt[i] < cnt[id]))
            id = i;
    vector<int> ans;
    rep(i, 0, n)
        if (col[i] == id)
            ans.push_back(i);
    cout << sz(ans) << "\n";
    for (int i : ans)
        cout << i + 1 << " ";
    cout << "\n";
    return 0;
}