//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <stdio.h>
#include <bits/stdc++.h>

#define uint unsigned int
#define ll long long
#define ull unsigned long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, r, l) for (int i = r; i > l; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)
#define y1 dhwjdshg

using namespace std;

const int N = 200000;
const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int P = 239;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const double eps = 1e-9;
const double pi = atan2(0, -1);
const int ABC = 26;

ll solve(ll n, ll steps, ll d, ll b, vector<ll> &aaa)
{
    vector<ll> a(n, 0);
    rep(i, 0, n)
    {
        ll x = aaa[i];
        ll cnt = (i + 1 + d) / (d + 1);
        a[max(cnt - 1, i - d * cnt)] += x;
    }
    ll ans = 0;
    rep(i, 0, steps)
    {
        if (a[i] < b)
        {
            ans++;
            if (i + 1 < n)
                a[i + 1] += a[i];
        }
        else
        {
            if (i + 1 < n)
                a[i + 1] += (a[i] - b);
        }
    }
    return ans;
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(20);
    cout << fixed;
    //ll TL = 0.95 * CLOCKS_PER_SEC;
    //clock_t time = clock();
    ll p, n, D, B;
    cin >> p >> n >> D >> B;
    if (p == 1)
    {
        vector<ll> aaa(n, 0);
        rep(i, 0, n)
            cin >> aaa[i];
        cout << solve(n, n, D, B, aaa) << "\n";
    }
    else
    {
        vector<ll> aaa(n, 0), a(n), b(n);
        rep(i, 0, n)
            cin >> aaa[i];
        ll cnt = 1LL * n * B;
        ll ans = big;
        rep(x, 0, cnt + 1)
        {
            ll rem = x;
            a.assign(n, 0);
            rep(i, 0, n)
            {
                if (rem == 0)
                    break;
                ll d = min(rem, aaa[i]);
                a[i] += d;
                rem -= d;
            }
            rep(i, 0, n)
                b[i] = aaa[i] - a[i];
            reverse(b.begin(), b.end());
            ans = min(ans, max(solve(n, (n + 1) / 2, D, B, a), solve(n, n / 2, D, B, b)));
        }
        cout << ans << "\n";
    }
    return 0;
}
