#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all (x).begin(), (x).end()
#define pb push_back
#define ft first
#define st second
#define forn(i, n) for(int i = 0;i < n;i++)
struct Solver{
	int n = 0, m = 0, h = 2;
	vector<vector<int>> g;
	vector<int> used, t, ans;
	void dfs(int v, int color){
		used[v] = color;
		for (int u : g[v]){
			if (used[u] != color) dfs(u, color);
		}
	}
	Solver() {
		cin >> n >> m >> h;
		t.resize(n);
		g.resize(n);
		used.resize(n);
		forn(i, n) cin >> t[i];
		forn(i, m){
			int v, u;
			cin >> v >> u;--v,--u;
			if (t[v] == (t[u] + 1) % h) g[u].pb(v);
			if ((t[v] + 1) % h == t[u]) g[v].pb(u);
		}
		int ans = INT_MAX, ind = -1;
		for (int i = 0;i < n;i++){
			dfs(i, i);
			int ans_gg = 0;
			for (int j : used) if (j == i) ans_gg++;
			if (ans > ans_gg){
				ans = ans_gg;
				ind = i;
			}
		}
		dfs(ind, n);
		cout << ans << '\n';
		forn(i, n){
			if (used[i] == n) cout << i + 1 << ' ';
		}
		cout << '\n';
	}
};

int main(){
	int t = 1;
#ifdef LOCAL
	assert(freopen("input.txt", "r", stdin));
	cin >> t;
#else
	ios_base::sync_with_stdio(0);
	cout.tie(0);
#endif
	while(t--){
#ifdef LOCAL
		clock_t c = clock();
#endif
		Solver a = Solver();
		//cout << '\n';
#ifdef LOCAL
		cout << fixed <<"Elapsed " << fabs(c - clock()) / CLOCKS_PER_SEC << "\n";
#endif
	}
}

