#include <bits/stdc++.h>

using namespace std;

int n, m, h, t = 0;
vector<int> u;

vector<set<int>> dep;
vector<vector<int>> adj;
vector<int> cnt;
vector<int> used;

vector<int> res;
vector<int> dp, tim;
vector<int> path;

int find_tail(int v) {
    t++;
    tim[v] = t;
    dp[v] = t;
    for (int u : adj[v]) {
        if (tim[u] == 0) {
            int x = find_tail(u);
            dp[v] = min(dp[v], x);
        } else {
            dp[v] = min(dp[v], tim[u]);
        }
    }
    return dp[v];
}

int count(int v) {
    path.push_back(v);
    used[v] = true;
    int c = 1;
    for (int u : adj[v]) {
        if (!used[u]) {
            c += count(u);
        }
    }
    return c;
}


void out(int v) {
    res.push_back(v);
    used[v] = true;
    for (int u : adj[v]) {
        if (!used[u]) {
            out(u);
        }
    }
}

int main() {
    cin >> n >> m >> h;
    u.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }

    dep.resize(n);
    dp.resize(n);
    tim.resize(n);
    adj.resize(n);
    cnt.resize(n, -1);
    used.resize(n);

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        dep[a].insert(b);
        dep[b].insert(a);
    }

    for (int i = 0; i < n; ++i) {
        for (int j : dep[i]) {
            if ((u[i] + 1) % h == u[j]) {
                adj[i].push_back(j);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (adj[i].empty()) {
            cout << 1 << endl << i + 1 << endl;
            return 0;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (tim[i] == 0) {
            find_tail(i);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (tim[i] != dp[i]) continue;
        int c = count(i);
        for (int x : path) {
            cnt[x] = c;
        }
        path.clear();
    }

    used.assign(n, false);

    int mi = -1;

    for (int i = 0; i < n; ++i) {
        if (mi == -1 || (cnt[i] < cnt[mi])) {
            mi = i;
        }
    }

    out(mi);
    cout << cnt[mi] << endl;
    sort(res.begin(), res.end());
    for (int x : res) {
        cout << x + 1 << " ";
    }
    cout << endl;

    return 0;
}