#include <bits/stdc++.h>

using namespace std;

int n, m, h, t = 0;
vector<int> u;

vector<set<int>> dep;
vector<vector<int>> adj;
vector<int> ans;
vector<bool> used, invalid;

vector<int> res;

int solve(int v) {
    used[v] = true;
    int r = 1;
    for (int u : adj[v]) {
        if (!used[u]) {
            r += solve(u);
        }
    }
    return r;
}

void out(int v) {
    res.push_back(v);
    used[v] = true;
    for (int u : adj[v]) {
        if (!used[u]) {
            out(u);
        }
    }
}

int main() {
    cin >> n >> m >> h;
    u.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }

    dep.resize(n);
    adj.resize(n);
    ans.resize(n, -1);
    used.resize(n);
    invalid.resize(n);

    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        dep[a].insert(b);
        dep[b].insert(a);
    }

    for (int i = 0; i < n; ++i) {
        for (int j : dep[i]) {
            if ((u[i] + 1) % h == u[j]) {
                adj[i].push_back(j);
            }
        }
    }
    int mans = -1;
    int mm = -1;

    for (int i = 0; i < n; ++i) {
        int r = solve(i);
        if (mans == -1 || r < mm) {
            mans = i;
            mm = r;
        }
        ans.assign(n, -1);
        used.assign(n, false);
    }

    cout << mm << endl;
    out(mans);
    sort(res.begin(), res.end());
    for (int v : res) {
        cout << v + 1 << " ";
    }
    cout << endl;


    return 0;
}