#include <bits/stdc++.h>

using namespace std;

struct group {
    int type;
    int len;
    vector<int> ids;
};

list<group> g;
string s;
int n;
vector<vector<int>> seq;

int main() {
    cin >> s;
    n = s.size();

    if (s[0] == '1') {
        cout << -1 << endl;
        return 0;
    }

    int last = 0;
    int len = 0;
    for (int i = 0; i < n; ++i) {
        int cur = s[i] - '0';
        if (cur != last) {
            g.push_back(group {last, len});
            len = 1;
            last = cur;
        } else {
            len++;
        }
    }
    if (len > 0) {
        g.push_back(group {last, len});
    }

    int id = 0;

    for (group &t : g) {
        for (int i = 0; i < t.len; ++i)
            t.ids.push_back(id + i);
        id += t.len;
    }

    int total = 0;

    while (!g.empty() && g.front().type == 0 && g.back().type == 0) {
        vector<int> curseq;
        int mlen = INT32_MAX;
        for (auto it = g.begin(); it != g.end(); it++) {
            mlen = min(it->len, mlen);
        }

        for (auto it = g.begin(); it != g.end(); it++) {
            id = it->ids.back();
            curseq.push_back(id);
            it->ids.erase(it->ids.end() - mlen);
            it->len -= mlen;
        }

        for (auto it = g.begin(); it != g.end();) {
            if (it->len == 0) {
                bool end = false;
                if (it == g.begin()) {
                    end = true;
                }
                else {
                    it++;
                    if (it == g.end())
                        end = true;
                    it--;
                }

                if (end) {
                    auto z = it;
                    z++;
                    g.erase(it);
                    it = z;
                    continue;
                }

                auto prev = it;
                auto next = it;
                prev--;
                next++;
                next->len += prev->len;
                for (int x : prev->ids)
                    next->ids.push_back(x);
                g.erase(prev);
                g.erase(it);
                it = next;
            } else {
                ++it;
            }
        }
        seq.push_back(curseq);
        total += curseq.size();
    }

    if (g.empty()) {
        cout << seq.size() << endl;
        for (auto x : seq) {
            cout << x.size() << " ";
            for (int z : x) {
                cout << z + 1 << " ";
            }
            cout << endl;
        }
    } else {
        cout << -1 << endl;
    }
    return 0;
}