#include <iostream>
#include <queue>
#include <list>
using namespace std;

const int N = 200005;
int n, m, h, a, b;
int t[N] = {};
bool u[N] = {};
list <int> e[N] = {};

int nxt(int x)
{
    if (x == h - 1) return 0;
    else return x + 1;
}

int bfs(int x, bool f = false)
{
    int cnt = 0;
    queue <int> q;
    bool d[N] = {};
    q.push(x);
    while (!q.empty())
    {
        int v = q.front();
        d[v] = true;
        if (f) cout << v << " ";
        cnt++;
        for (auto i : e[v])
        {
            if (!d[i]) q.push(i);
        }
        q.pop();
    }

    return cnt;
}

int main()
{
    freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
    {
        cin >> t[i];
    }
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b;
        if (nxt(t[a]) == t[b]) u[a] = true, e[a].push_back(b);
        if (nxt(t[b]) == t[a]) u[b] = true, e[b].push_back(a);
    }
    for (int i = 1; i <= n; i++)
    {
        if (!u[i])
        {
            cout << 1 << endl << i;
            return 0;
        }
    }
    int mn = n, x = 1;
    for (int i = 1; i <= n; i++)
    {
        int k = bfs(i);
        //cout << k << endl;
        if (k <= mn)
        {
            mn = k;
            x = i;
        }
    }
    cout << mn << endl;
    bfs(x, 1);

    return 0;
}
