#include <iostream>
#include <vector>
#include <set>

using namespace std;
int n, m, h;
vector<int> cur;
vector<bool> used;
vector<set<int>> c;
vector<int> u;
int dfs(int v) {
    int time = (u[v] +1) % h;
    //cout << v << ' '<< time << endl;
    used[v] = true;
    int ans = 1;
    cur.push_back(v + 1);
    for (set<int> :: iterator it = c[v].begin(); it!= c[v].end(); it++) {
        if (u[*it] == time && !used[*it]) {
            ans+=dfs(*it);
        }
    }

    return ans;
}
int main()
{

    cin >> n >> m >> h;
    u.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> u[i];
    }

    c.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        c[a].insert(b);
        c[b].insert(a);
    }
    used.resize(n, false);
    int ans = 1e9;
    vector<int> ansi;
    for (int i = 0; i < n; i++) {
        int f = dfs(i);
        if (f < ans) {
            ans = f;
            ansi.clear();
            ansi = cur;
        }
        used.clear();
        used.resize(n, false);
        cur.clear();
    }

    cout << ans << endl;
    sort(ansi.begin(), ansi.end());
    for(int i = 0; i < ans; i++) {
        cout << ansi[i] <<' ';
    }
    return 0;
}
