#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <ctime>
using namespace std;
int n,i,m,h,deg[200000],ret[200000],a,b,tm1,cnt;
vector <int> g[200000],ans,c[200000];
int used[200000],x[200000],t[200000],ind[200000];
void dfs(int v){
    t[v] = ret[v] = tm1++;
    used[v] = 1;
    for(int i = 0; i < g[v].size(); i++){
        int to = g[v][i];
        if(!used[to]){
            dfs(to);
            ret[v] = min(ret[v], ret[to]);
        }
        else
            ret[v] = min(ret[v], t[to]);
    }
}
void dfs2(int v){
    used[v] = 1;
    c[ind[v]].push_back(v);
    for(int i = 0; i < g[v].size(); i++){
        int to = g[v][i];
        if(!used[to]){
            if(ret[v] < ret[to]){
                deg[ind[v]]++;
                ind[to] = cnt++;
            }
            else
                ind[to] = ind[v];
            dfs2(to);
        }
    }
}
int main(){
    //freopen("input.txt","r",stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();
    cin >> n >> m >> h;
    for(i = 0; i < n; i++)
        cin >> x[i];
    for(i = 0; i < m; i++){
        cin >> a >> b;
        a--; b--;
        if((x[a] + 1) % h == x[b])
            g[a].push_back(b);
        if((x[b] + 1) % h == x[a])
            g[b].push_back(a);
    }
    //n = 5;
    //g[0].push_back(1);
    //g[0].push_back(2);
    //g[2].push_back(0);
    for(i = 0; i < n; i++){
        if(!used[i])
            dfs(i);
    }
    fill(used, used + n, 0);
    for(i = 0; i < n; i++){
        if(!used[i])
            ind[i] = cnt++, dfs2(i);
    }
    int MIN = n + 1;
    for(i = 0; i < cnt; i++){
       // cout << '*'<<c[i].size() << endl;
        if(deg[i] == 0 && c[i].size() < MIN)
            MIN = c[i].size(), ans = c[i];
    }
    cout << ans.size() << endl;
    for(i = 0; i < ans.size(); i++)
        cout << ans[i] + 1 << " ";
    return 0;
}
