#include <iostream>
#include <vector>

using namespace std;

int dfs(int u, vector <bool> &used, vector <vector <int> > &List, vector <int> &res)
{
    used[u] = true;
    res.push_back(u);
    for (int i = 0; i < List[u].size(); ++i)
    {
        if (!used[List[u][i]])
        {
            dfs(List[u][i], used, List, res);
        }
    }
    return 0;
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <vector <int> > List(n);
    vector <int> H(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> H[i];
    }
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        if (H[u] == (H[v] + 1) % h)
        {
            List[v].push_back(u);
        }
        if (H[v] == (H[u] + 1) % h)
        {
            List[u].push_back(v);
        }
    }
    vector <int> ans(n);
    for (int i = 0; i < n; ++i)
    {
        ans[i] = i;
    }
    for (int i = 0; i < n; ++i)
    {
        vector <bool> used(n);
        vector <int> res;
        dfs(i, used, List, res);
        if (res.size() < ans.size())
        {
            swap(ans, res);
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
    {
        cout << ans[i] + 1 << " ";
    }
    cout << endl;
    return 0;
}