#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
struct Th
{
    vector <int> A;
    int cur = 0;
    int ind = 0;
    long long sum = 0;
    int d;
    int b;
    int end;

    Th(const vector <int> &B, bool str, long long su, int end)
    {
        this->end = end;
        this->A = B;
        if (!str)
        {
            reverse(this->A.begin(), this->A.end());
        }
        int i;
        for (i = 0; i < A.size() && su > A[i]; ++i)
        {
            su -= A[i];
        }
        if (i < A.size()) {
            A[i] = su;
            A.resize(i + 1);
        }
    }

    bool launch(int m, int d, int b)
    {
        cur = 0;
        ind = 0;
        sum = 0;
        this->d = d;
        this->b = b;
        for (int i = 0; i < m && i < A.size(); ++i)
        {
            sum += A[i];
            ++cur;
        }
        if (cur < A.size())
        {
            sum += A[cur];
            ++cur;
        }
        ind = m;
        for (int i = 0; i < m * d && cur < A.size(); ++i)
        {
            sum += A[cur++];
        }
        return true;
    }

    bool next()
    {
        if (ind >= end)
        {
            return false;
        }
        for (int i = 0; i < d && cur < A.size(); ++i)
        {
            sum += A[cur];
            ++cur;
        }
        if (sum < b)
        {
            return false;
        }
        sum -= b;
        ++ind;
    }

    bool good()
    {
        return ind >= end;
    }
};
int main()
{
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector <int> A(n);
    int sum = 0;
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i];
        sum += A[i];
    }
    if (p == 1)
    {
        Th C(A, true, sum, A.size());
        int l = -1, r = n;
        while (r - l > 1)
        {
            int m = (r + l) / 2;
            C.launch(m, d, b);
            while (C.next());
            if (C.good())
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        cout << r << endl;
        return 0;
    }
    int l = -1, r = (n + 1) / 2;
    while (r - l > 1)
    {
        int m = (r + l) / 2;
        int L = -1, R = sum;
        while (R - L > 1)
        {
            int M = (R + L) / 2;
            Th A1(A, true, M, (n + 1) / 2);
            A1.launch(m, d, b);
            while (A1.next());
            if (A1.good())
            {
                R = M;
            }
            else
            {
                L = M;
            }
        }
        Th A1(A, true, R, (n + 1) / 2);
        A1.launch(m, d, b);
        while (A1.next());
        Th A2(A, false, sum - R, n / 2);
        A2.launch(m, d, b);
        while (A2.next());
        if (A1.good() && A2.good())
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    cout << r << endl;
    return 0;
}