#include <iostream>
#include <queue>
using namespace std;

int main()
{
    queue <int> q0, q1;
    string c;
    cin >> c;
    vector <vector <int>> ans;
    for (int i = 0; i < c.size(); ++i)
    {
        if (c[i] == '1')
        {
            if (q0.size() == 0)
            {
                cout << -1 << endl;
                return 0;
            }
            ans[q0.front()].push_back(i);
            q1.push(q0.front());
            q0.pop();
        }
        else if (c[i] == '0')
        {
            if (q1.size() == 0)
            {
                q0.push(ans.size());
                ans.push_back({i});
            }
            else
            {
                ans[q1.front()].push_back(i);
                q0.push(q1.front());
                q1.pop();
            }
        }
    }
    if (q1.size() != 0)
    {
        cout << -1 << endl;
        return 0;
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
    {
        cout << ans[i].size() << " ";
        for (int j = 0; j < ans[i].size(); ++j)
        {
            cout << ans[i][j] + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}