#include <iostream>
#include <string>
#include <queue>
#include <algorithm>

using namespace std;

int main()
{
    const int SIZE = 2 * 1e5;
    static vector<int> seq[SIZE], full_seq, part_seq, zeroes, beg_zeroes, ones;
    int n, cnt = 0, full_s_size;
    string str;
    static bool checked[SIZE], last_is_0 = 1;

    cin >> str;
    n = str.size();
    for (int i = 0; i < n; i++)
        if (str[i] == '0')
        {
            if (!last_is_0)
            {
                last_is_0 = 1;
                full_s_size = full_seq.size();
                for (int j = 0; j < min(full_seq.size(), ones.size()); j++)
                {
                    seq[full_seq[full_seq.size() - j - 1]].push_back(ones[j]);
                    part_seq.push_back(full_seq[full_seq.size() - j - 1]);
                    full_seq.pop_back();
                }
                for (int j = 0; j < max(0U, ones.size() - full_s_size); j++)
                {
                    if (!beg_zeroes.empty())
                    {
                        seq[cnt].push_back(beg_zeroes[beg_zeroes.size() - 1]);
                        beg_zeroes.pop_back();
                        seq[cnt].push_back(ones[j + full_s_size]);
                        part_seq.push_back(cnt);
                        cnt++;
                    }
                    else
                    {
                        cout << -1;
                        return 0;
                    }
                }
                ones.clear();
            }
            if (!part_seq.empty())
            {
                seq[part_seq[part_seq.size() - 1]].push_back(i);
                full_seq.push_back(part_seq[part_seq.size() - 1]);
                part_seq.pop_back();
            }
            else
                beg_zeroes.push_back(i);
        }
        else
        {
            last_is_0 = 0;
            ones.push_back(i);
        }
    if (!last_is_0 || !part_seq.empty())
    {
        cout << -1;
        return 0;
    }
    cout << cnt + beg_zeroes.size() << endl;
    for (int i = 0; i < beg_zeroes.size(); i++)
        cout << 1 << ' ' << beg_zeroes[i] + 1 << endl;
    for (int i = 0; i < cnt; i++)
    {
        cout << seq[i].size() << ' ';
        for (int j = 0; j < seq[i].size(); j++)
            cout << seq[i][j] + 1 << ' ';
        cout << endl;
    }
    cin >> n;
}