#include <iostream>
#include <bits/stdc++.h>
#define ll int
struct stick
{
    ll wh;
    bool del;
};
using namespace std;
ll n, m, h, a[100005], u, v, mn, mni, used[100005], p[100005], szv[100005], sze[100005], mem[100005];
ll f[100005];
vector<stick> allEdges;
vector< vector<ll> > g(100005);
set<ll> need;
vector<ll> ans;
map< pair<ll, ll>, bool> mp;
ll findp(ll x)
{
    if(p[x] == x)
        return x;
    p[x] = findp(p[x]);
    for(int i = 0; i < g[x].size(); i++)
    {
        g[p[x]].push_back(g[x][i]);
    }
    g[x].clear();
    g[x].shrink_to_fit();
    return p[x];
}
bool unite(ll x, ll y)
{
    x = findp(x);
    y = findp(y);
    if(sze[x] < sze[y])
        swap(x, y);
    p[y] = x;
    szv[x] += szv[y];
    sze[x] += sze[y];
}
ll dfs(ll x)
{
    used[x] = 1;
    ll cycles = 0;
    for(int i = 0; i < g[x].size(); i++)
    {
        ll to = findp(allEdges[g[x][i]].wh);
        if(allEdges[g[x][i]].del)
            break;
        if(used[to] == 1)
        {
            f[to]++;
            allEdges[g[x][i]].del = true;
            cycles++;
        }
        else if(used[to] == 0)
        {
            ll cur = dfs(to);
            cycles += cur;
            if(cur != 0)
            {
                allEdges[g[x][i]].del = true;
                unite(to, x);
            }
        }
    }
    cycles -= f[x];
    used[x] = 2;
    return cycles;
}
ll dfs2(ll x)
{
    x = p[x];
    if(mem[x] != 0)
    {
        return mem[x];
    }
    mem[x] = szv[x];
    for(int i = 0; i < g[x].size(); i++)
    {
        if(allEdges[g[x][i]].del)
            continue;
        mem[x] += dfs2(allEdges[g[x][i]].wh);
    }
    return mem[x];
}
void dfs3(ll x)
{
    x = p[x];
    used[x] = 1;
    need.insert(x);
    for(int i = 0; i < g[x].size(); i++)
    {
        if(allEdges[g[x][i]].del)
            continue;
        ll to = allEdges[g[x][i]].wh;
        if(used[to] == 0)
        {
            dfs3(to);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    mn = 1e18 + 1;
    cin >> n >> m >> h;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++)
    {
        p[i] = i;
        szv[i] = 1;
        sze[i] = g[i].size();
    }
    for(int i = 0; i < m; i++)
    {
        cin >> u >> v;
        if(mp[{u, v}] || mp[{v, u}])
            continue;
        mp[{u, v}] = true;
        mp[{v, u}] = true;
        ll cu = a[u];
        ll cv = a[v];;
        if(cu == h - 1)
        {
            if(cv == 0)
            {
                allEdges.push_back({v, 0});
                g[u].push_back(allEdges.size() - 1);
            }
        }
        if(cv == h - 1)
        {
            if(cu == 0)
            {
                allEdges.push_back({u, 0});
                g[v].push_back(allEdges.size() - 1);
            }
        }
        if(cv == cu + 1)
        {
            allEdges.push_back({v, 0});
            g[u].push_back(allEdges.size() - 1);
        }
        if(cu == cv + 1)
        {
            allEdges.push_back({u, 0});
            g[v].push_back(allEdges.size() - 1);
        }
    }
    mp.clear();
    for(int i = 1; i <= n; i++)
    {
        if(used[i] == 0)
        {
            dfs(i);
        }
    }
    for(int i = 1; i <= n; i++)
    {
        findp(i);
    }
    for(int i = 1; i <= n; i++)
    {
        ll cur = p[i];
        ll cr = dfs2(cur);
        if(cr < mn)
        {
            mn = cr;
            mni = i;
        }
    }
    for(int i = 1; i <= n; i++)
    {
        used[i] = 0;
    }
    dfs3(mni);
    for(int i = 1; i <= n; i++)
    {
        if(need.count(p[i]) != 0)
            ans.push_back(i);
    }
    cout << ans.size() << "\n";
    for(int i = 0; i < ans.size(); i++)
    {
        cout << ans[i] << " ";
    }
    return 0;
}
