#undef __STRICT_ANSI__
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,popcnt,tune=native")
#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define fst first
#define snd second
#define pb push_back
#define eb emplace_back
using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll; using pii = pair<int, int>;
const int infi = 1e9+100, mod = 1e9+7; const ll infl = 1e18L+1000; const ld infd = INFINITY;
template <typename T> bool mind(T &x, const T &y) {if (y < x) return x = y, true; else return false;}
template <typename T> bool maxd(T &x, const T &y) {if (x < y) return x = y, true; else return false;}
int log2f(int x) {return 32 - __builtin_clz(x) - 1;}
int log2c(int x) {return 32 - __builtin_clz(x) - !!(x&(x-1));}



struct graph {
    int n, t = 1;
    vector<int> d, tp, col, dp;
    vector<vector<int>> g;
    graph(int n) : n(n), d(n), col(n), dp(n+1), g(n) {}
    void ae(int u, int v) {g[u].pb(v);}
    int r = -1;
    void dfs(int u) {
        d[u] = 1;
        tp.pb(u);
        for(int v : g[u]) if (!d[v] && !col[v]) {
            dfs(v);
        }
    }
    void coldfs(int u, int c) {
        col[u] = c;
        dp[c]++;
        for(int v : g[u]) if (!col[v]) {
            coldfs(v, c);
        } else if (col[v] != c) dp[c] = infi;
    }
    vector<int> av;
    void ansdfs(int u) {
        d[u] = 1;
        av.pb(u);
        for(int v : g[u]) {
            if (!d[v]) ansdfs(v);
        }
    }
    void solve() {
        int cur = 1;
        for(int i = 0; i < n; ++i) if (!d[i]) {
            tp.clear();
            dfs(i);
            reverse(all(tp));
            for(int x : tp) if (!col[x]) coldfs(x, cur++);
        }
        //cout << "col: "; for(int i = 0; i < n; ++i) cout << col[i] << ' '; cout << endl;
        //for(int i = 1; i < cur; ++i) cout << dp[i] << ' '; cout << endl;
        int i = min_element(dp.begin()+1, dp.begin()+cur)-dp.begin();
        //cout << i << endl;
        int u = 0; while(col[u] != i) ++u;
        //cout << u << endl;
        d.assign(n, 0);
        ansdfs(u);
        cout << sz(av) << '\n';
        for(int x : av) cout << x+1 << ' ';
    }
};

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout << fixed << setprecision(10);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int n, m, h; cin >> n >> m >> h;
    vector<int> a(n); for(int &x : a) cin >> x;
    auto issucc = [&](int u, int v) {return a[u] + 1 == a[v] || (a[u] == h-1 && a[v] == 0);};
    graph g(n);
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v, --u, --v;
        if (issucc(u, v)) g.ae(u, v);
        if (issucc(v, u)) g.ae(v, u);
    }
    g.solve();
}
