#undef __STRICT_ANSI__
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,popcnt,tune=native")
#include <bits/stdc++.h>
#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define fst first
#define snd second
#define pb push_back
#define eb emplace_back
using namespace std;
using ll = long long; using ld = long double; using ull = unsigned ll; using pii = pair<int, int>;
const int infi = 1e9+100, mod = 1e9+7; const ll infl = 1e18L+1000; const ld infd = INFINITY;
template <typename T> bool mind(T &x, const T &y) {if (y < x) return x = y, true; else return false;}
template <typename T> bool maxd(T &x, const T &y) {if (x < y) return x = y, true; else return false;}
int log2f(int x) {return 32 - __builtin_clz(x) - 1;}
int log2c(int x) {return 32 - __builtin_clz(x) - !!(x&(x-1));}



struct graph {
    int n;
    vector<int> tp, col, dp;
    vector<vector<int>> g, rg;
    graph(int n) : n(n), col(n, -2), dp(n), g(n), rg(n) {}
    void ae(int u, int v) {g[u].pb(v), rg[v].pb(u);}
    void dfs(int u) {
        col[u] = -1;
        for(int v : g[u]) if (col[v] == -2)
            dfs(v);
        tp.pb(u);
    }
    void coldfs(int u, int c) {
        col[u] = c;
        dp[c]++;
        for(int v : rg[u]) if (col[v] == -1)
            coldfs(v, c);
    }
    void solve() {
        for(int u = 0; u < n; ++u) if (col[u] == -2) dfs(u);
        reverse(all(tp));
        int cur = 0;
        for(int u : tp) if (col[u] == -1) coldfs(u, cur++);
        //cout << "KEK" << endl;
        for(int u = 0; u < n; ++u) for(int v : g[u])
            if (col[v] != col[u]) dp[u] = infi;
        int best = min_element(dp.begin(), dp.begin()+cur) - dp.begin();
        int u = 0; while(col[u] != best) ++u;
        tp.clear(), col.assign(n, -2);
        dfs(u);
        cout << sz(tp) << '\n';
        for(int x : tp) cout << x+1 << ' ';

    }
};

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout << fixed << setprecision(10);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int n, m, h; cin >> n >> m >> h;
    vector<int> a(n); for(int &x : a) cin >> x;
    auto issucc = [&](int u, int v) {return a[u] + 1 == a[v] || (a[u] == h-1 && a[v] == 0);};
    graph g(n);
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v, --u, --v;
        if (issucc(u, v)) g.ae(u, v);
        if (issucc(v, u)) g.ae(v, u);
    }
    g.solve();
    /*int n, m; cin >> n >> m;
    graph g(n);
    for(int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v, --u, --v;
        g.ae(u, v);
    }
    g.solve();*/
}
