#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair
#define endl '\n'
#define data q_wqekjasd

#ifndef LOCAL
    #define cerr if(0)cerr
#endif // LOCAL

typedef long long ll;
typedef long double ld;

random_device rd;
mt19937_64 rnd(rd());

struct data {
    int n, m, h;
    vector < int > a;
    vector < pair < int, int > > b;
};

istream &operator >> (istream &IN, data &d) {
    IN >> d.n >> d.m >> d.h;
    d.a.assign(d.n, 0);
    d.b.assign(d.m, {0, 0});
    for (int i = 0; i < d.n; i++) IN >> d.a[i];
    for (int i = 0; i < d.m; i++) IN >> d.b[i].ff >> d.b[i].ss;
    return IN;
}

ostream &operator << (ostream &OUT, data &d) {
    OUT << d.n << ' ' << d.m << ' ' << d.h << endl;
    for (int i = 0; i < d.n; i++) OUT << d.a[i] << ' ';
    OUT << endl;
    for (int i = 0; i < d.m; i++) OUT << d.b[i].ff << ' ' << d.b[i].ss << endl;
    return OUT;
}

struct answer {
    int n;
    vector < int > a;
};

ostream &operator << (ostream &OUT, const answer &ans) {
    OUT << ans.n << endl;
    for (int i = 0; i < ans.n; i++) OUT << ans.a[i] << ' ';
    return OUT;
}

bool compare (data &d, const answer &a, const answer &b) {
    return a.n == b.n;
}

answer solve (data &INPUT) {
    answer OUTPUT;

    return OUTPUT;
}

vector < int > brute_g[100001], brute_gr[100001];
int brute_run = 2;
int brute_lastRun[100001];
int brute_a[100001];

int brute_kek(int v, bool print, answer &OUTPUT) {
    brute_run++;
    queue < int > q;
    int cnt = 0;
    q.push(v);
    brute_lastRun[v] = brute_run;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        cnt++;
        if (print) OUTPUT.a.p_b(x + 1);
        for (int to : brute_g[x]) {
            if (brute_lastRun[to] == brute_run) continue;
            brute_lastRun[to] = brute_run;
            q.push(to);
        }
    }
    return cnt;
}

answer brute (data &INPUT) {
    answer OUTPUT;
    int n = INPUT.n, m = INPUT.m, h = INPUT.h;
        for (int i = 0; i < n; i++) {
        brute_a[i] = INPUT.a[i];
    }
    set < pair < int, int > > was;
    for (int i = 0; i < m; i++) {
        int x = INPUT.b[i].ff, y = INPUT.b[i].ss;
        x--, y--;
        if (x > y) swap(x, y);
        if (was.count({x, y})) continue;
        was.insert({x, y});
        brute_gr[x].p_b(y);
        brute_gr[y].p_b(x);
    }
    for (int i = 0; i < n; i++) {
        for (int to : brute_gr[i]) {
            if ((brute_a[i] + 1) % h == brute_a[to]) brute_g[i].p_b(to);
        }
    }
    int ans = INT_MAX;
    int ansi;
    for (int i = 0; i < n; i++) {
        int _now = brute_kek(i, 0, OUTPUT);
        if (_now < ans) {
            ans = _now;
            ansi = i;
        }
    }
    OUTPUT.n = ans;
    brute_kek(ansi, 1, OUTPUT);
    return OUTPUT;
}


data gen() {
    data d;
    d.n = rnd() % 10 + 1;
    d.m = rnd() % 10 + 1;
    d.h = rnd() % 5 + 2;
    d.a.assign(d.n, 0);
    d.b.assign(d.m, {0, 0});
    for (int i = 0; i < d.n; i++) d.a[i] = rnd() % d.h;
    for (int i = 0; i < d.m; i++) {
        int x = rnd() % d.n;
        int y = rnd() % d.n;
        if (x == y) y = (y + 1) % d.n;
        d.b[i] = {x + 1, y + 1};
    }
    return d;
}

void stress() {
    static int test = 0;
    data d;
    do {
        test++;
        cerr << "Testing on test " << test << endl;
        d = gen();
    }while(compare(d, solve(d), brute(d)));
    ofstream A("input.txt");
    A << "input:\n" << d << "\nsolve:\n" << solve(d) << "\nbrute:\n" << brute(d) << endl;
    A.close();
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    data d;
    cin >> d;
    cout << brute(d);
}
