#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair

typedef long long ll;
typedef long double ld;

random_device rd;
mt19937_64 rnd(rd());

const int N = 200001;
int dsu[N][2];

int get(int id, int v) {
    return dsu[v][id] == v ? v : dsu[v][id] = get(id, dsu[v][id]);
}

void un(int id, int a, int b) {
    a = get(id, a);
    b = get(id, b);
    if (a == b) return;
    if (a < b) swap(a, b);
    dsu[b][id] = a;
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    string s;
    cin >> s;
    int n = int(s.size());
    for (int i = 0; i < n; i++) s[i] -= '0';
    vector < bool > used(n, 0);
    vector < vector < int > > ans;
    while (1) {
        ans.p_b(vector < int >(0));
        int need = 0;
        int last = -1;
        for (int i = 0; i < n; i++) {
            if (used[i]) continue;
            if (s[i] != need) continue;
            last = i;
            used[i] = 1;
            need = 1 - need;
            ans.back().p_b(i);
        }
        if (last == -1) break;
        if (need == 0) {
            used[last] = 0;
            ans.back().pop_back();
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cout << -1;
            return 0;
        }
    }
    if (ans.back().empty()) ans.pop_back();
    cout << int(ans.size()) << endl;
    for (int i = 0 ; i < int(ans.size()); i++) {
        cout << int(ans[i].size()) << ' ';
        for (int j : ans[i]) cout << j + 1 << ' ';
        cout << endl;
    }
//    for (int i = 0; i < n; i++) {
//        dsu[i][0] = dsu[i][1] = i;
//    }
//    for (int i = 1; i < n; i++) {
//        if (s[i] == '0') un(0, i - 1, i);
//        else un(1, i - 1, i);
//    }
//    vector < vector < int > > ans;
//    while (1) {
//
//    }
}
