#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define p_b push_back
#define m_p make_pair

typedef long long ll;
typedef long double ld;

random_device rd;
mt19937_64 rnd(rd());

const int N = 200001;
int dsu[N][2], rght[N][2], sz[N][2];

int get(int id, int v) {
    return dsu[v][id] == v ? v : dsu[v][id] = get(id, dsu[v][id]);
}

void un(int id, int a, int b) {
    a = get(id, a);
    b = get(id, b);
    if (a == b) return;
    if (sz[a][id] < sz[b][id]) swap(a, b);
    dsu[b][id] = a;
    sz[a][id] += sz[b][id];
    rght[a][id] = max(rght[a][id], rght[b][id]);
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    string s;
    cin >> s;
    int n = int(s.size());
    for (int i = 0; i < n; i++) s[i] -= '0';
    for (int i = 0; i < n; i++) {
        dsu[i][0] = dsu[i][1] = rght[i][0] = rght[i][1] = i;
        sz[i][0] = sz[i][1] = 1;
    }
    vector < vector < int > > ans;
    vector < bool > used(n, 0);
    for (int i = 0; i < n - 1; i++) {
        if (!s[i]) un(1, i, i + 1);
        else un(0, i, i + 1);
    }
    while (1) {
        ans.push_back(vector<int>(0));
        int need = 0;
        int v = rght[get(0, 0)][0];
        int last = v;
        if (s[v] == need) while (!used[v]) {
            //cerr << "SZ " << v << ' ' << int(ans.back().size()) << endl;
            //for (int i = 0; i < n; i++) cerr << get(0, i) << ' ' << get(1, i) << endl;
            need = 1 - need;
            v = rght[get(need, v)][need];
            if (used[v] || s[v] != need) {
                //cerr << "V " << v << ' ' << used[v] << ' ' << int(ans.back().size()) << endl;
                if (need == 0) {
                    break;
                }
                used[last] = 1;
                ans.back().p_b(last);
                if (last != n - 1) un(0, last, last + 1);
                break;
            }
            else {
                used[last] = 1;
                ans.back().p_b(last);
                if (last != n - 1) un(1 - need, last, last + 1);
                last = v;
            }
        }
        if (ans.back().empty()) {
            ans.pop_back();
            //cerr << "EMPTY" << endl;
            break;
        }
    }
    //for (int i = 0 ; i < n; i++) cerr << used[i] << ' '; cerr << endl;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cout << -1;
            return 0;
        }
    }
    cout << int(ans.size()) << endl;
    for (int i = 0; i < int(ans.size()); i++) {
        cout << int(ans[i].size()) << ' ';
        for (int j : ans[i]) cout << j + 1 << ' ';
        cout << endl;
    }
}
