// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

int main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

bool test(int m, const vector<int> &v)
{
	bitset<1001> dp;
	dp[500] = 1;
	for (int i = 0; i < 30; ++i)
		if (m & (1 << i))
		{
			int k = (1 << (i >> 1));
			if (i & 1)
				dp |= (dp >> k);
			else
				dp |= (dp << k);
		}
	for (auto x : v)
		if (!dp.test(x + 500))
			return false;
	return true;
}

void run()
{
	int n;
	cin >> n;
	vector<int> arr(n);
	for (auto &x : arr)
		cin >> x;
	int ans = (1 << 30) - 1;
	for (int i = 0; i < (1 << 20); ++i)
		if (__builtin_popcount(i) < __builtin_popcount(ans) && test(i, arr))
			ans = i;
	cout << __builtin_popcount(ans) << endl;
	for (int i = 0; i < 30; ++i)
		if (ans & (1 << i))
		{
			int k = (1 << (i >> 1));
			if (i & 1)
				k *= -1;
			cout << k << " ";
		}
	cout << endl;
}