#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int solve();

int main() {
    ios_base::sync_with_stdio(0);
#ifdef home
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // home
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int p[200005];
int sz[200005];

set<int> x;

void create(int x) {
    p[x] = x;
    sz[x] = 1;
}

int get(int x) {
    return (p[x] == x ? x : p[x] = get(p[x]));
}

void uni(int a, int b) {
    a = get(a);
    b = get(b);

    if (a == b) return;

    if (sz[a] > sz[b]) {
        p[b] = a;
        sz[a] += sz[b];
    } else {
        p[a] = b;
        sz[b] += sz[a];
    }
}

int t[200005];
int solve() {
    int n, m, h; cin >> n >> m >> h;

    for (int i = 1; i <= n; i++) {
        cin >> t[i];
    }

    for (int i = 1; i <= 2 * n + 1; i++) create(i);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if ((t[a] + 1) % h == t[b]) uni(2 * a, 2 * b + 1), uni(2 * a + 1, 2 * b + 1);
        if ((t[b] + 1) % h == t[a]) uni(2 * b, 2 * a + 1), uni(2 * b + 1, 2 * a + 1);
    }

    int mn = 2 * n + 15, ans = -1;
    for (int i = 2; i <= 2 * n + 1; i++) {
        int j = get(i);
        if (sz[j] < mn) mn = sz[j], ans = j;
    }

    for (int i = 2; i <= 2 * n + 1; i++) {
        if (get(i) == ans) x.insert(i / 2);
    }

    cout << x.size() << endl;
    for (auto c : x) cout << c << ' ';
    return 0;
}



