#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

const int MAXN = (int)1e5 + 10;

vector<int> g[MAXN];
vector<int> gr[MAXN];
int used[MAXN];
int u[MAXN];
vector<int> order;
vector<int> cur;
vector<int> ans;

void top_sort(int v)
{
    used[v] = 1;
    for (int i = 0; i < (int)g[v].size(); i++)
        if (!used[g[v][i]])
            top_sort(g[v][i]);
    order.pb(v);
}

void dfs(int v)
{
    used[v] = 1;
    for (int i = 0; i < (int)gr[v].size(); i++)
        if (!used[gr[v][i]])
            dfs(gr[v][i]);
    cur.pb(v);
}

int solve()
{
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 1; i <= n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;
        if ((u[x] + 1) % h == u[y])
        {
            g[x].pb(y);
            gr[y].pb(x);
        }
        if ((u[y] + 1) % h == u[x])
        {
            g[y].pb(x);
            gr[x].pb(y);
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (g[i].empty())
        {
            cout << 1 << endl;
            cout << i << endl;
            return 0;
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (!used[i])
        {
            top_sort(i);
        }
    }
    reverse(order.rbegin(), order.rend());
    memset(used, 0, sizeof(used));
    int ANS = n + 10;
    for (int i = 0; i < n; i++)
    {
        int v = order[i];
        if (!used[v])
        {
            cur.clear();
            dfs(v);
            if (cur.size() < ANS)
            {
                ANS = cur.size();
                ans = cur;
            }
        }
    }
    cout << (int)ans.size() << endl;
    for (size_t i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";
}

