#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

const int MAXN = (int)1e4 + 10;
const int INF = 1e9;

int v[MAXN];
vector<int> a[2];
int pref[MAXN];
int dp[MAXN][MAXN];

void update(vector<int> &a, int b, int d, int x)
{
    vector<int> c;
    c = a;
    int n = (int)a.size();
    if (n == 0)
        return;
    int cur = a[n - 1] - x;
    for (int j = max(0, n - d); j < n - 1 && cur > 0; j++)
        if (c[j] < b)
        {
            if (b - c[j] > cur)
            {
                c[j] += cur;
                c[n - 1] -= cur;
                cur = 0;
            }
            else
            {
                c[n - 1] -= b - c[j];
                cur -= b - c[j];
                c[j] = b;
            }
        }
        c[n - 1] -= cur;
        c[max(0, n - d)] += cur;

    for (int i = n - 1; i >= 0; i--)
    {
        int cur = a[i];
        if (i == n - 1)
            cur = x;
        for (int j = max(0, i - d); j < i && cur > 0; j++)
            if (c[j] < b)
            {
                if (b - c[j] > cur)
                {
                    c[j] += cur;
                    c[i] -= cur;
                    cur = 0;
                }
                else
                {
                    c[i] -= b - c[j];
                    cur -= b - c[j];
                    c[j] = b;
                }
            }
        c[i] -= cur;
        c[max(0, i - d)] += cur;
    }
    a = c;
}

int getans(vector<int> &a, int b, int d)
{
    int n = (int)a.size();
    if (n == 0)
        return 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            dp[i][j] = INF;
    dp[0][0] = a[0];
    for (int i = 1; i < n; i++)
        dp[i][0] = dp[i - 1][0] + a[i];
    for (int i = 0; i <= n; i++)
        dp[n - 1][i] = b * n;

    for (int i = n - 2; i >= 0; i--)
        for (int j = 1; j <= n; j++)
        {
            dp[i][j] = min((i + 1) * b, dp[min(n - 1, i + d)][j - 1]);
        }

    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        int x = dp[i][i];
        if (i > 0)
            x -= dp[i - 1][i];
        if (x < b)
        {
            ans++;
        }
    }
    return ans;
}

int solve()
{
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i];
        pref[i] = pref[i - 1] + v[i];
    }
    int ind = 0;
    for (int i = 1; i <= n; i++)
        if (pref[i] >= b * i)
        {
            ind = i;
            break;
        }
    int x = v[ind - 1], y = v[ind + 1];
    v[ind - 1] += b * (ind - 1) - pref[ind - 1];
    v[ind + 1] += v[ind] - b - (b * (ind - 1) - pref[ind - 1]);
    v[ind] = b;

    for (int i = 1; i < ind; i++)
        a[0].pb(v[i]);
    update(a[0], b, d, x);

    /*for (int i = 0; i < a[0].size(); i++)
        cerr << a[0][i] << " ";*/

    while(v[n] == b && n > ind)
        n--;
    for (int i = n; i > ind; i--)
        a[1].pb(v[i]);
    update(a[1], b, d, y);

    int ans = getans(a[0], b, d);
    if (p == 2)
        ans += getans(a[1], b, d);
    cout << ans << endl;
}
