#include <bits/stdc++.h>

#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}

const int MAXN = 20;

int a[MAXN];
unordered_map<int, bool> pos;
vector<int> v;
int ANS = 1e9;
vector<int> ans;
int mx = 0;

void go(int x, int n)
{
    pos[x] = 1;
    if (abs(x) > mx)
        return;
    for (int i = 0; i < n; i++)
    {
        if (a[i] == 1 || a[i] == 3)
            if (!pos[x + (1 << i)])
            {
                int p = a[i];
                a[i] = 0;
                go(x + (1 << i), n);
                a[i] = p;
            }
        if (a[i] == 2 || a[i] == 3)
            if (!pos[x - (1 << i)])
            {
                int p = a[i];
                a[i] = 0;
                go(x - (1 << i), n);
                a[i] = p;
            }
    }
}

void update(int n)
{
    pos.clear();
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        if (a[i] == 1 || a[i] == 3)
            cnt++;
        if (a[i] == 2 || a[i] == 3)
            cnt++;
    }
    if (cnt >= ANS)
        return;
    pos[0] = 1;
    go(0, n);
    for (int i = 0; i < (int)v.size(); i++)
        if (!pos[v[i]])
        {
            ///cerr << v[i] << endl;
            return;
        }
    ANS = cnt;
    ans.clear();
    for (int i = 0; i < n; i++)
    {
        if (a[i] == 1 || a[i] == 3)
            ans.pb(1 << i);
        if (a[i] == 2 || a[i] == 3)
            ans.pb(-(1 << i));
    }
}

int log2(int a)
{
    int cnt = 0;
    while(a)
    {
        cnt++;
        a >>= 1;
    }
    return cnt;
}

void gen(int i, int n)
{
    if (i == n)
        update(n);
    else
    {
        for (int j = 0; j < 4; j++)
        {
            a[i] = j;
            gen(i + 1, n);
        }
    }
}

int solve()
{
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
        mx = max(abs(v[i]), mx);
    }
    gen(0, log2(mx) + 1);
    /*a[2] = 1;
    a[3] = 1;
    a[0] = 2;
    update(4);*/
    cout << ANS << endl;
    for (int i = 0; i  < (int)ans.size(); i++)
        cout << ans[i] << " ";
}

