// t3.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;


int main()
{
	long long nump, n, d, b;
	cin >> nump >> n >> d >> b;
	vector<long long> cnt(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> cnt[i];
	}
	vector<vector<vector<long long> > > dp(2, vector<vector<long long> >(n + 1, vector<long long>(n + 1, 0)));
	vector<vector<vector<bool> > > used(2, vector<vector<bool> >(n + 1, vector<bool>(n + 1, 0)));
	long long p = -1;
	used[0][0][0] = 1;
	for (long long i = 1; i <= n; i++)
	{
		long long tmp = min(n - 1, i - 1 + i * d);
		long long can = 0;
		for (long long j = p + 1; j <= tmp; j++)
		{
			can += cnt[j];
		}
		for (long long j = 0; j <= n; j++)
		{
			if (i > 0)
			{
				bool flag = 0;
				if (used[0][i - 1][j])
				{
					dp[0][i][j] = max(dp[0][i][j], dp[0][i - 1][j]);
					flag = 1;
				}
				if (used[1][i - 1][j])
				{
					dp[0][i][j] = max(dp[1][i][j], dp[1][i - 1][j]);
					flag = 1;
				}
				used[0][i][j] = flag;
				if (j > 0)
				{
					flag = 0;
					if (used[0][i - 1][j - 1])
					{
						dp[1][i][j] = max(dp[1][i][j], dp[0][i - 1][j - 1]);
						flag = 1;
					}
					if (used[1][i - 1][j - 1])
					{
						dp[1][i][j] = max(dp[1][i][j], dp[1][i - 1][j - 1]);
						flag = 1;
					}
					used[1][i][j] = flag;
				}
			}
			if (used[0][i][j])
			{
				dp[0][i][j] += can;
				if (dp[0][i][j] < b)
					used[0][i][j] = 0;
				else
					dp[0][i][j] -= b;
			}
			if (used[1][i][j])
			{
				dp[1][i][j] += can;
			}
		}
		p = tmp;
	}
	long long answ = 0;
	if (nump == 1)
	{
		for (long long i = 0; i <= n; i++)
		{
			if (used[0][n][i] || used[1][n][i])
			{
				answ = i;
				break;
			}
		}
	}
	else
	{
		long long p = 0;
		long long q = n - 1;
		long long cntt = 0;
		while (p <= q)
		{
			if (cnt[p] > 1)
			{
				cnt[p + 1] += cnt[p] - 1;
				cnt[p] = 1;
			}
			else if (cnt[p] == 0)
			{
				for (long long i = p + 1; i < min(q, p + d * (p + 1)); i++)
				{
					if (cnt[i] > 0)
					{
						cnt[i]--;
						cnt[p] = 1;
						break;
					}
				}
			}
			if (cnt[p] == 0)
				cntt++;
			if (p != q)
			{
				if (cnt[q] > 1)
				{
					cnt[q - 1] += cnt[q] - 1;
					cnt[q] = 1;
				}
				else if (cnt[p] == 0)
				{
					for (long long i = q - 1; i < max(p + 1, q - d * (p + 1)); i++)
					{
						if (cnt[i] > 0)
						{
							cnt[i]--;
							cnt[q] = 1;
							break;
						}
					}
				}
				if (cnt[q] == 0)
					cntt++;
			}
				p++;
				q--;
		}
		answ = cntt;
	}
	cout << answ;
	cin >> n;
    return 0;
}

