#include <iostream>
#include <vector>

using namespace std;

void dfs(int v, vector <bool> & used, vector <int> & qu, vector <vector <int> > & ss){
    qu.push_back(v + 1);
    used[v] = true;
    int n = ss[v].size();
    for (int i = 0; i < n; i++){
        if (!used[ss[v][i]]){
            dfs(ss[v][i], used, qu, ss);
        }
    }
    return;
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> u(n);
    vector <vector <int> > ss(n);
    for (int i = 0; i < n; i++){
        cin >> u[i];
    }
    for (int i = 0; i < m; i++){
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        if ((u[v1] + 1) % h == u[v2]){
            ss[v1].push_back(v2);
        }
        if ((u[v2] + 1) % h == u[v1]){
            ss[v2].push_back(v1);
        }
    }
    for (int i = 0; i < n; i++){
        if (ss[i].empty()){
            cout << 1 << endl << i + 1;
            return 0;
        }
    }
    vector <bool> used(n, false);
    vector <int> ans(n + 5, -1);
    for (int i = 0; i < n; i++){
        if (!used[i]){
            vector <int> qu;
            dfs(i, used, qu, ss);
            if (qu.size() < ans.size()){
                ans = qu;
            }
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++){
        cout << ans[i] << " ";
    }
    return 0;
}
