#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void dfs(int v, vector <bool> & global_used, vector <int> & qu, vector <vector <int> > & ss, vector <bool> & local_used){
    qu.push_back(v + 1);
    //cout << v << endl;
    local_used[v] = true;
    int n = ss[v].size();
    for (int i = 0; i < n; i++){
        //assert(!global_used[ss[v][i]]);
        if (!local_used[ss[v][i]]){
            dfs(ss[v][i], global_used, qu, ss, local_used);
        }
    }
    return;
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> u(n);
    vector <vector <int> > ss(n);
    for (int i = 0; i < n; i++){
        cin >> u[i];
    }
    for (int i = 0; i < m; i++){
        int v1, v2;
        cin >> v1 >> v2;
        v1--;
        v2--;
        if ((u[v1] + 1) % h == u[v2]){
            ss[v1].push_back(v2);
        }
        if ((u[v2] + 1) % h == u[v1]){
            ss[v2].push_back(v1);
        }
    }
    for (int i = 0; i < n; i++){
        if (ss[i].empty()){
            cout << 1 << endl << i + 1;
            return 0;
        }
    }
    for (int i = 0; i < n; i++){
        int r = ss[i].size();
        for (int j = 0; j < r; j++){
            ss[ss[i][j]].push_back(i);
        }
    }
    vector <bool> global_used(n, false);
    vector <int> ans(n + 5, -1);
    for (int i = 0; i < n; i++){
        if (true || !global_used[i]){
            vector <bool> local_used(n, false);
            vector <int> qu;
            dfs(i, global_used, qu, ss, local_used);
            if (qu.size() < ans.size()){
                ans = qu;
            }
            for (int j = 0; j < qu.size(); j++){
                global_used[qu[j]] = true;
            }
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++){
        cout << ans[i] << " ";
    }
    return 0;
}
