#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define null NULL
#define ld long double
#define left left228
#define right right228
#define index index228
#define prev prev228

const int N = 100 * 1000 + 228;

template<typename T> inline void chkmin(T &x, T y) {
	if (y < x) x = y;
}

template<typename T> inline void chkmax(T &x, T y) {
	if (y > x) x = y;
}



int n, m, h;

int T[N];

vector<int> g[N], gt[N];

inline int nxt(int ch) {
    return (ch + 1) % h;
}


bool used[N];

int sz[N], comp[N], out[N];


vector<int> order, order2;


void dfs1(int v) {
    used[v] = true;

    for (int i = 0; i < (int)gt[v].size(); ++i) {
        int to = gt[v][i];
        if (!used[to]) {
            dfs1(to);
        }
    }
    order.push_back(v);
}


void dfs2(int v) {
	used[v] = true;
	order2.push_back(v);
	for (int to : g[v]) {
		if (!used[to]) {
			dfs2(to);
		}
	}
}


inline void solve() {
    cin >> n >> m >> h;
    for (int i = 1; i <= n; ++i) {
        cin >> T[i];
    }
    for (int i = 1; i <= m; ++i) {
        int c1, c2;
        cin >> c1 >> c2;
        if (nxt(T[c1]) == T[c2]) {
            g[c1].push_back(c2);
            gt[c2].push_back(c1);
            //cout << c1 << " -> " << c2 << "\n";
        }
        if (nxt(T[c2]) == T[c1]) {
            g[c2].push_back(c1);
            gt[c1].push_back(c2);
            //cout << c2 << " -> " << c1 << endl;
        }
    }
    for (int v = 1; v <= n; ++v) {
    	if (!used[v]) {
    		dfs1(v);
    	}
    }
    memset(used, 0, sizeof(used));
    int cur_comp = 1;
    reverse(order.begin(), order.end());
    for (int v : order) {
    	if (!used[v]) {
    		order2.clear();
    		dfs2(v);
    		sz[cur_comp] = (int)order2.size();
    		for (int u : order2) {
    			comp[u] = cur_comp;
    		}
    		++cur_comp;
    	}
    }
    for (int v = 1; v <= n; ++v) {
    	for (int to : g[v]) {
            if (comp[to] != comp[v]) {
                ++out[comp[v]];
            }
    	}
    }
    vector<int> res;
    int component = 0;
    int ans = 1e9 + 228;
    for (int c = 1; c < cur_comp; ++c) {
    	if (out[c] == 0 && sz[c] < ans) {
    		ans = sz[c];
    		component = c;
    	}
    }
    for (int i = 1; i <= n; ++i) {
    	if (comp[i] == component) {
    		res.push_back(i);
    	}
    }
    cout << ans << endl;
    for (int i : res) {
    	cout << i << " ";
    }
    cout << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
