import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class A {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
              neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        String s = r.readLine();
        int l = s.length();
        if(s.charAt(0) == '1' || s.charAt(l - 1) == '1') {
            System.out.println("-1");
            return;
        }
        char[] ca = s.toCharArray();
        List<List<Integer>> seq = new ArrayList<>();
        List<Integer> curSeq = new ArrayList<>();
        int proc = 0;
        while(proc < l) {
            char lastChar = '-';
            for (int i = 0; i < l; i++) {
                char c = ca[i];
                switch (c) {
                    case '0': {
                        if (lastChar != '0') {
                            lastChar = '0';
                            curSeq.add(i);
                            ca[i] = '-';
                            proc++;
                        }
                        break;
                    }
                    case '1': {
                        if (lastChar == '0') {
                            lastChar = '1';
                            curSeq.add(i);
                            ca[i] = '-';
                            proc++;
                        } else if(lastChar == '-') {
                            System.out.println("-1");
                            return;
                        }
                        break;
                    }
                }
            }
            if(lastChar == '1') {
                System.out.println("-1");
                return;
            }
            seq.add(curSeq);
            curSeq = new ArrayList<>();
        }


        System.out.println(seq.size());
        for(List<Integer> sq : seq) {
            System.out.print(sq.size());
            System.out.print(' ');
            sq.stream().map(x -> Integer.toString(x + 1)).reduce((s1, s2) -> s1 + ' ' + s2).ifPresent(System.out::println);
        }
    }

}
