#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

const long long inf = 1e15;

long long n, m, h;

vector < long long > pos;
vector < vector < long long > > g;

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> h;
	pos.assign(n, -1);
	g.assign(n, vector < long long >());

	for (int i = 0; i < n; i++){
		cin >> pos[i];
	}


	for (int i = 0; i < m; i++){
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if ((pos[v] + 1) % h == pos[u]){
			g[v].push_back(u);
		}
		if ((pos[u] + 1) % h == pos[v]){
			g[u].push_back(v);
		}
	}

	for (int i = 0; i < n; i++){
		if (g[i].size() == 0){
			cout << 1 << endl << i + 1;
			system("pause");
			return 0;
		}
	}

	cout << n << "\n";

	for (int i = 1; i <= n; i++){
		cout << i << " ";
	}

	system("pause");
	return 0;
}