#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define lp(i,s,e) for(int i = s;i<e;++i)
#define lpi(i,s,e) for(int i = s;i<=e;++i)
typedef pair<int,int> pii;
#define ff first
#define ss second
#define mp(a,b) make_pair(a,b)
#define pb(a) push_back(a)




vector<int> fup;
vector<int> tin;
vector<int> tout;
vector<bool> used;
vector<vector<int> > g;
int timer = 0;
int sz = 0;



void dfs1(int v)
{
    used[v] = true;
    fup[v] = tin[v] = timer++;

    for(auto to:g[v]){
        if(used[to] && tout[to]==0) {fup[v] = min(fup[v],tin[to]);continue;}
        if(used[to]) continue;
        dfs1(to);
        fup[v] = min(fup[v],fup[to]);
    }
    tout[v] = timer++;
}
int cnt;
vector<int> component;
vector<int> component_size;
vector<bool> bad;

int get_comp(int v)
{
    if(component[v]==-1) component[v] = cnt++;
    return component[v];
}

void dfs2(int v)
{
    if(used[v]) return;
    used[v] = true;
    component_size[get_comp(v)]++;
    for(auto to:g[v]){
        if(fup[to] <= tin[v]) component[to] = get_comp(v);
        else component[to] = get_comp(to),bad[get_comp(v)] = true;
        dfs2(to);
    }
}

int main()
{
    //freopen("input.txt","r",stdin);
    //cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n,m,h;
    cin>>n>>m>>h;
    vector<int> t(n);
    lp(i,0,n) cin>>t[i];
    g.resize(n);
    lp(i,0,m){
        int x,y;
        cin>>x>>y;
        x--,y--;
        if( (t[x]+1)%h == t[y] ) g[x].pb(y);
        if( (t[y]+1)%h == t[x] ) g[y].pb(x);
    }
    if(h == 2) {
        cout<<n<<'\n';
        lp(i,0,n) cout<<i+1<<' ';
        return 0;
    }

    lp(i,0,n) if(g[i].size()==0) return cout<<1<<'\n'<<i+1,0;
    tin.assign(n,0);
    tout.assign(n,0);
    fup.assign(n,0);
    used.assign(n,false);
    lp(i,0,n) if(!used[i]) dfs1(i);
    fill(used.begin(),used.end(),false);
    component.assign(n,-1);
    component_size.assign(n,0);
    bad.assign(n,false);
    lp(i,0,n){
        if(used[i]) continue;
        dfs2(i);
    }
    int ans = 1e9;
    int id = 0;
    lp(i,0,cnt) if(!bad[i] && component_size[i]<ans) ans = component_size[get_comp(i)],id = i;
    if(ans==1e9 || ans > n || ans<h) return -1;
    cout<<ans<<'\n';
    lp(i,0,n) if(component[i] == id) cout<<i+1<<' ';
    return 0;
}
