#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define lp(i,s,e) for(int i = s;i<e;++i)
#define lpi(i,s,e) for(int i = s;i<=e;++i)
typedef pair<int,int> pii;
#define ff first
#define ss second
#define mp(a,b) make_pair(a,b)
#define pb(a) push_back(a)


struct node
{
    int val,y;
    int size;
    int sum;
    node *l,*r;
    node(int val):val(val),y(rand()),size(1),sum(val),l(0),r(0){};
};
typedef node* pnode;

int size(pnode cur)
{
    if(!cur) return 0;
    return cur->size;
}

int sum(pnode cur)
{
    if(!cur) return 0;
    return cur->sum;
}

void upd(pnode cur)
{
    if(!cur) return;
    cur->size = size(cur->l) + 1 + size(cur->r);
    cur->sum = sum(cur->l) + cur->val + sum(cur->r);
}

pnode merge(pnode l,pnode r)
{
    if(!l) return r;
    if(!r) return l;
    if(l->y>r->y){
        l->r = merge(l->r,r);
        upd(l);
        return l;
    }
    r->l = merge(l,r->l);
    upd(r);
    return r;
}

void split(pnode cur,int s,pnode& l,pnode& r)
{
    if(!cur){l = r = 0;return;}
    if(size(cur->l) >= s){
        r = cur;
        split(r->l,s,l,r->l);
        upd(l);
        upd(r);
    }else{
        s-=size(cur->l)+1;
        l = cur;
        split(l->r,s,l->r,r);
        upd(r);
        upd(l);
    }
}

void out(pnode cur)
{
    if(!cur) return;
    out(cur->l);
    cout<<cur->val<<' ';
    out(cur->r);
}

int main()
{
    //freopen("input.txt","r",stdin);
    //cin.tie(0);
    ios_base::sync_with_stdio(0);
    string s;
    cin>>s;
    int n = s.length();
    vector<int> zeros,ones;
    int cnt0,cnt1;
    cnt0 = cnt1 = 0;
    vector<int> prev(n,-1);
    lp(i,0,n){
        if(s[i] == '1' && cnt0 == zeros.size()) {return cout<<-1,0;}
        if(s[i] == '1') prev[i] = zeros[cnt0++],ones.pb(i);
        else{
            prev[i] = cnt1==ones.size()?-1:ones[cnt1];
            cnt1 = min((int)ones.size(),cnt1+1);
            zeros.pb(i);
        }
    }
    if(cnt1!=ones.size()) return cout<<-1,0;
    vector<int> next(n,-1);
    int ans = n;
    lp(i,0,n) if(prev[i]!=-1) ans--,next[prev[i]] = i;
    vector<bool> used(n,false);
    cout<<ans<<'\n';
    lp(i,0,n){
        if(used[i]) continue;
        vector<int> cur;
        used[i] = true;
        cur.pb(i);
        int v = i;
        while(next[v]!=-1){
            v = next[v];
            cur.pb(v);
            used[v] = true;
        }
        cout<<cur.size()<<' ';
        for(auto& a:cur) cout<<a+1<<' ';
        cout<<'\n';
    }
    return 0;
}
