// ConsoleApplication1.cpp: определяет точку входа для консольного приложения.
//

#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <stack>

#define sqr(a) ((a) * (a))
#define x first
#define y second
#define mp make_pari

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef string str;

void start();
void stop();

vector<int> a, b, ans;
bool used[200001];

int main()
{
	start();
	b.push_back(-1);

	str s;
	cin >> s;

	if (s[s.size() - 1] == '1' || s[0] == '1')
		return cout << -1 << endl, 0;

	for (int i = 0; i < s.size(); i++)
		if (s[i] == '0')
			a.push_back(i);
		else
			b.push_back(i);

	if (a.size() < b.size())
		return cout << -1 << endl, 0;

	int l = 0, r = 0;
	for (l = 0; l < a.size(); l++)
	{
		if (a[l] < b[r])
			continue;
		used[a[l]] = 1;
		ans.push_back(a[l]);
		while (r < b.size() && b[r] < a[l])
			r++;
		if (r < b.size())
			used[b[r]] = 1, ans.push_back(b[r]);
		else
			break;
	}

	for (int i = 1; i < b.size(); i++)
	{
		if (!used[b[i]])
			return cout << -1 << endl, 0;
	}

	cout << s.size() + 1 - ans.size() << endl;
	cout << ans.size() << ' ';
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + 1 << ' ';
	cout << endl;
	for (int i = 0; i < s.size(); i++)
		if (used[i] == 0)
			cout << "1 " << i + 1 << endl;

	stop();
    return 0;
}

void start()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void stop()
{
	//system("pause");
}

/*

*/