import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class A {

	public static void dfsTopsort(int v) {
		used[v] = true;
		for (int i : to[v]) {
			if (!used[i]) {
				dfsTopsort(i);
			}
		}
		topsort[iterator] = v;
		numberInTopsort[v] = iterator;
		iterator--;
	}
	
	public static void dfs(int v, int c) {
		used[v] = true;
		color[v] = c;
		for (int i : to1[v]) {
			if (!used[i]/* && numberInTopsort[i] < numberInTopsort[v]*/) {
				dfs(i, c);
			}
		}
	}
	
	static ArrayList<Integer>[] to;
	static ArrayList<Integer>[] to1;
	static boolean[] used;
	static int[] topsort;
	static int[] numberInTopsort;
	static int iterator;
	static int[] color;
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		int h = Integer.parseInt(st.nextToken());
		int[] u = new int[n];
		st = new StringTokenizer(in.readLine());
		for (int i = 0; i < u.length; i++) {
			u[i] = Integer.parseInt(st.nextToken());
		}
		to = new ArrayList[n];
		to1 = new ArrayList[n];
		for (int i = 0; i < to.length; i++) {
			to[i] = new ArrayList<>();
			to1[i] = new ArrayList<>();
		}
		for (int i = 0; i < m; i++) {
			st = new StringTokenizer(in.readLine());
			int a = Integer.parseInt(st.nextToken()) - 1;
			int b = Integer.parseInt(st.nextToken()) - 1;
			int x = u[a];
			int y = u[b];
			if ((x + 1) % h == y) {
				to[a].add(b);
				to1[b].add(a);
			}
			if ((y + 1) % h == x) {
				to[b].add(a);
				to1[a].add(b);
			}
		}
		used = new boolean[n];
		topsort = new int[n];
		numberInTopsort = new int[n];
		iterator = n - 1;
		for (int i = 0; i < u.length; i++) {
			if (!used[i]) {
				dfsTopsort(i);
			}
		}
		iterator = 0;
		color = new int[n];
		used = new boolean[n];
		for (int i = 0; i < n; i++) {
			if (!used[topsort[i]]) {
				dfs(topsort[i], iterator);
				iterator++;
			}
		}
//		for (int i = 0; i < to.length; i++) {
//			for (int j : to[i]) {
//				System.out.println(i + " " + j + " dfgh");
//			}
//		}
//		for (int i = 0; i < topsort.length; i++) {
//			System.out.print(topsort[i] + " ");
//		}
//		System.out.println();
//		for (int i = 0; i < color.length; i++) {
//			System.out.print(color[i] + " ");
//		}
//		System.out.println();
		int[] numberOfColor = new int[iterator];
		for (int i = 0; i < color.length; i++) {
			numberOfColor[color[i]]++;
		}
		for (int i = 0; i < to.length; i++) {
			for (int j : to[i]) {
				if (color[i] != color[j]) {
					numberOfColor[color[i]] = Integer.MAX_VALUE;
				}
			}
		}
		int min = Integer.MAX_VALUE;
		int c = -1;
		for (int i = 0; i < numberOfColor.length; i++) {
			if (numberOfColor[i] < min) {
				min = numberOfColor[i];
				c = i;
			}
		}
		out.println(min);
		for (int i = 0; i < color.length; i++) {
			if (color[i] == c) {
				out.print(i + 1 + " ");
			}
		}
		in.close();
		out.close();
	}

}
