import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Stack;


public class A {

	
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		String s = in.readLine();
		Stack<ArrayList<Integer>> zero = new Stack<>();
		Stack<ArrayList<Integer>> one = new Stack<>();
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == '0') {
				if (!one.isEmpty()) {
					ArrayList<Integer> list = one.pop();
					list.add(i);
					zero.add(list);
				} else {
					ArrayList<Integer> list = new ArrayList<>();
					list.add(i);
					zero.add(list);
				}
			} else {
				if (!zero.isEmpty()) {
					ArrayList<Integer> list = zero.pop();
					list.add(i);
					one.add(list);
				} else {
					System.out.println(-1);
					in.close();
					out.close();
					return;
				}
			}
		}
		if (!one.isEmpty()) {
			out.print(-1);
		} else {
			out.println(zero.size());
			for (ArrayList<Integer> list : zero) {
				out.print(list.size() + " ");
				for (int i : list) {
					out.print(i + 1 + " ");
				}
				out.println();
			}
		}
		in.close();
		out.close();
	}

}
