#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int M = (int)1e6 + 100;
const int N = 5;
const int K = 80;
bool can[2 * K];
int a[M];
int ch = 5;

vector<int> cur;
vector<int> ans;
map<int, int> ccnt;
bool found = 0;

void check(int msk, int n) {
    vector<int> cur;
    int pos = 0;
    while (msk > 0) {
        if (msk % 3 != 0) {
            if (msk % 3 == 2)
                cur.push_back(pos);
            cur.push_back(pos);
        }
        pos++;
        msk /= 3;
    }

    if (cur.size() > 2 * N || found && cur.size() > ans.size())
        return;

    fill(can, can + 2 * K, 0);
    can[K] = 1;
    for (const auto &it : cur) {
        int val;
        if (it < ch)
            val = (1 << it);
        else
            val = -(1 << (it - ch));
        vector<int> gd;
        for (int i = 0; i < 2 * K; ++i) {
            if (can[i])
                gd.push_back(i);
        }
        for (auto i : gd) {
            if (i + val >= 0 && i + val < 2 * K) {
                can[i + val] = 1;
            }
        }
    }

    bool good = 1;
    for (int i = 0; i < n; ++i) {
        if (!can[a[i] + K]) {
            good = 0;
        }
    }

    if (good) {
        if (ans.size() > cur.size() || !found) {
            ans = cur;
        }
        found = 1;
    }
}

void dfs(int cnt, int n) {
    if (found && cur.size() > ans.size())
        return;

    if (!cur.empty()) {
        fill(can, can + 2 * K, 0);
        can[K] = 1;
        for (const auto &it : cur) {
            int val;
            if (it < ch)
                val = (1 << it);
            else
                val = -(1 << (it - ch));
            vector<int> gd;
            for (int i = 0; i < 2 * K; ++i) {
                if (can[i])
                    gd.push_back(i);
            }
            for (auto i : gd) {
                if (i + val >= 0 && i + val < 2 * K) {
                    can[i + val] = 1;
                }
            }
        }

        bool good = 1;
        for (int i = 0; i < n; ++i) {
            if (!can[a[i] + K]) {
                good = 0;
            }
        }

        if (good) {
            if (ans.size() > cur.size() || !found) {
                ans = cur;
            }
            found = 1;
            return;
        }
    }

    for (int i = 0; i < 2 * N; ++i) {
        if (cnt <= N && ccnt[i] <= 2) {
            cur.push_back(i);
            ccnt[i]++;
            dfs(cnt + 1, n);
            cur.pop_back();
            ccnt[i]--;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    bool fl = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] != 0)
            fl = 0;
    }

    if (fl) {
        cout << 0;
        return 0;
    }

    int msk = int(pow(3, 10));
    for (int i = 1; i < msk; ++i) {
        check(i, n);
    }

    cout << ans.size() << '\n';
    for (const auto &it : ans) {
        if (it < ch) {
            cout << (1 << it) << " ";
        } else {
            cout << -(1 << (it - ch)) << " ";
        }
    }

    return 0;
}