#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const int inf = (int)1e9 + 7;
const ll mod = (int)1e9 + 7;
int base[2] = {31, 41};

const int N = (int)2e5 + 100;
int used[N];
vector<int> a[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string s;
    cin >> s;
    int j = 0;
    if (s[0] != '0') {
        cout << -1;
        return 0;
    }
    int sz = 0;
    set<pair<int, int>> st;
    bool good = true;
    int n = s.size();
    for (int i = 0; i < n && good; ++i) {
        if (used[i])
            continue;
        if (s[i] == '0') {
            j++;
            while (j < n && (s[j] != '0' || used[j]))
                j++;
            a[sz++].push_back(i);
            st.insert({i, sz - 1});
        } else {
            if (j >= n)
                good = false;
            auto prev = st.begin();
            if (prev == st.end() || prev->first > i) {
                good = false;
            }
            if (!good) continue;
            int ind = prev->second;
            st.erase(prev);
            st.insert({j, ind});
            a[ind].push_back(i);
            a[ind].push_back(j);
            used[j] = 1;
            j++;
            while (j < n && (s[j] != '0' || used[j]))
                j++;
        }
    }

    if (!good) {
        cout << -1;
    } else {
        cout << sz << '\n';
        for (int i = 0; i < sz; ++i) {
            cout << a[i].size() << " ";
            for (const auto &it : a[i]) {
                cout << it + 1 << ' ';
            }
            cout << '\n';
        }
    }

    return 0;
}