
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <queue>
using namespace std;

#define ll long long

void scan(vector<pair<int, int>>&A)
{
    cout << A.size() <<endl ;
    for (int i = 0; i < A.size(); i++)
    {
        cout << A[i].first << " " << A[i].second << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    int n;
    int r = 0;
    string s;
    cin >> s;
    int f = 0;
    n = s.size();
    vector<bool>used(s.size(), 0);
    vector<vector<pair<int, int>>>ans;
    queue<pair<int, int> >K;
    for (int i = 0; i < n; i++)
    {
        if (s[i] - '0' == 1)
            f++;
        K.push({ s[i] - '0', i });

    }
  
    int m = 0;
    while (!K.empty() && f)
    {
        r = 0;
        vector<pair<int, int> >A;
        queue<pair<int, int> >K1;
        pair<int, int> p = K.front();
       // cout << p.first << " " << p.second << endl;
        if (p.first == 1)
        {
            cout << "-1";
            return 0;
        }
        
        while (!K.empty())
        {
            pair<int, int> p1 = K.front();
           // cout << r << " " << p1.first << " " << p1.second << endl;
            if (r != p1.first)
            {
                K1.push(p1);
                K.pop();
            }
            else 
            {
                r = !r;
                A.push_back(p1);
                if (r == 1)
                    f--;
                K.pop();
            }
           
        }
        if (A.size() > 0)
        {
            if (A[A.size() - 1].first == 1)
            {
                K1.push(A[A.size() - 1]);
                A.pop_back();

            }
            ans.push_back(A);
           // scan(A);
        }
          K = K1;
       
    }
    while(!K.empty())
    {
      
        vector<pair<int, int> >A;
        pair<int, int> p = K.front();
        if (p.first == 1)
        {
            cout << "-1";
            return 0;
        }
        A.push_back(p);
        ans.push_back(A);
        K.pop();
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i].size() << " ";
        for (int j = 0; j < ans[i].size(); j++)
        {
            cout << ans[i][j].second + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}