#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}
int dfs(int v, const vector<vector<int>>& g, vector<bool>& visited, vector<int>& out) {
    visited[v] = true;
    int ans = 1;
    for (int w : g[v]) {
        if (visited[w]) continue;
        ans += dfs(w, g, visited, out);
    }
    out.push_back(v);
    return ans;
}

void $main(ll testId) {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    vector<int> c1(m), c2(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> g(n), g_i(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        for (int __j = 0; __j < 2; ++__j) {
            swap(u, v);
            if ((a[u] + 1) % h == a[v]) {
                g[u].push_back(v);
                g_i[v].push_back(u);
            }
        }
    }

    vector<bool> visited(n);
    vector<int> best;
    int bsize = 1e9;
    for (int v = 0; v < n; ++v) {
        vector<int> t;
        for (int w = 0; w < n; ++w) visited[w] = false;
        if (dfs(v, g, visited, t) < bsize) {
            bsize = t.size();
            best  =t;
        }
    }

    cout << best.size() << "\n";
    for (auto x : best) cout << x + 1 << " ";
    cout << "\n";
}
