#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("d.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

template<typename Cb>
void generate(vector<int>& cur, int kMax, int n, int i, const Cb& cb) {
    cb(cur);
    if (i == n) {
        return;
    }
    for (int k = -kMax; k <= kMax; ++k) {
        if (k == 0) continue;
        int ak = abs(k);
        int sgn = (ak == k ? 1 : -1);
        int ap = (1 << (ak - 1));
        int p = sgn*ap;
        cur.push_back(p);
        generate(cur, kMax, n, i+1, cb);
        cur.pop_back();
    }
}

void $main(ll testId) {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >>a[i];
    vector<int> ____;
    vector<int> best = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    generate(____, 4, 4 * 1, 0, [&](vector<int> vec){
        bitset<40> bs;
        const int OFF = 20;
        bs[OFF] = true;
        for (auto x : vec) {
            bs |= (bs >> x);
        }
        bool ok = true;
        for (auto t : a) {
            if (!bs[t + OFF]) {
                ok  = false;
            }
        }
        if (!ok) return;
        if (vec.size() < best.size()) {
            best = vec;
        }
    });
    cout << best.size() << endl;
    for (auto x : best) cout <<x << " ";
    cout << endl;
}
