#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV

#if DEV == 0
#pragma GCC optimize("Ofast")
#endif // DEV
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
void $main(ll i);

int main() {
    int numTests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
        cin >> numTests;
    } else {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (ll i = 0; i < numTests; ++i) {
        $main(i);
        if (DEV) {
            cout << "-----------\n";
        }
    }
}
template<typename ...Args>
void cprint(bool cond, const Args& ...args) {
    if (!cond) return;
    ((cout << args << " "), ...);
    cout <<  endl;
}

template<typename ...Args>
void dprint(const Args& ...args) {
    cprint(DEV == 1, args...);
}

template<typename ...Args>
void aprint(const Args& ...args) {
    cprint(true, args...);
}

void $main(ll testId) {
    string s;
    cin >> s;
    vector<vector<int>> ans;
    int n = s.size();
    int a = (1 << n);
    vector<int> dp(a, -1);
    dp[0] = -2;
    auto und = [&](int mask){
    vector<int> t;
            int jc  = mask;
            for (int k = 0; k < s.size(); ++k) {
                if (jc & 1) {
                    t.push_back(k);

                }
                jc >>= 1;
            }
            return move(t);
    };

    for (int i = 0; i < a; ++i) {
            if (dp[i] == -1) continue;
        for (int j = 1; j < a; ++j) {
            if (i & j) continue;
            auto t = und(j);
            string tmp;
            for (int k : t) tmp += s[k];
            if (*tmp.begin() != '0') continue;
            if (*tmp.rbegin() != '0') continue;
            bool ok = true;
            for (int k = 0; k < t.size() - 1; ++k) {
                if (tmp[k] == tmp[k+1]) ok = false;
            }
            if (!ok) continue;
            dp[i | j] = j;
        }
    }
    int cur = a - 1;
    if (dp[cur] == -1) {

        cout << "-1\n";
        return;
    }
    while (dp[cur] != -2) {
        auto tr = dp[cur];
        auto ind = und(tr);
        ans.push_back(move(ind));
        cur ^= tr;
    }
    cout << ans.size() << "\n";
    for (auto& ind : ans) {
        cout << ind.size() << " ";
        for (auto tri : ind) {
            cout << tri + 1 << " ";
        }
        cout << "\n";
    }
}
