#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

#define endl '\n'

using namespace std;

typedef long long ll;

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> t(n), sumt(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
        sumt[i] = t[i];
    }
    vector<vector<int>> v(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        v[a - 1].push_back(i + 1);
        v[b - 1].push_back(i + 1);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if ((t[i] + 1) % h == sumt[j]) {
                vector<int> res;
                set_intersection(v[i].begin(), v[i].end(), v[j].begin(), v[j].end(), back_inserter(res));
                if (!res.empty()) {
                    sumt[j] = (t[j] + 1) % h;
                }
            }
        }
    }

    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (t[i] != sumt[i]) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i << " ";
    }
    cout << endl;
}