#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()

typedef long long ll;

const int INF = 1e9;
const int MAXN = 20;

void bye() {
    cout << "\n";
    exit(0);
}

int n, m, h;
vector<vector<int> > g;
vector<bool> can;
vector<int> upd;
vector<bool> used;
vector<vector<int> > gp;
vector<vector<int> > cnt;

void dfs(int v) {
    used[v] = 1;
    can[v] = 1;
    for (auto to : g[v]) {
        if ((upd[v] + 1) % h == upd[to] && !used[to]) {
            // cout << v << " " << to << " " << upd[v] << " " << upd[to] << "\n";
            dfs(to);
        }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> h;
    g.resize(n);
    used.resize(n);
    can.resize(n);
    upd.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> upd[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = INF;
    int pos = -1;
    for (int i = 0; i < n; i++) {
        used.assign(n, 0);
        dfs(i);
        int now = 0;
        for (int j = 0; j < n; j++) {
            // cout << used[i] << " ";
            if (used[j]) {
                now++;
            }
        }
        // cout << "\n";
        if (now < ans) {
            ans = now;
            pos = i;
        }
    }
    used.assign(n, 0);
    dfs(pos);
    cout << ans << "\n";
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            cout << i + 1 << " ";
        }
    }
    bye();
}
