#include <bits/stdc++.h>

using namespace std;

#define size(s) (ll)(s).size()

typedef long long ll;

const int INF = 1e9;

void bye() {
    cout << "\n";
    exit(0);
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    string s;
    cin >> s;
    int done = 0;
    vector<bool> used(size(s));
    vector<vector<int> > ans;
    vector<int> nxt(size(s));
    nxt[size(s) - 1] = INF;
    int lastOne = INF;
    int lastZero = INF;
    lastZero = (s.back() == '0') ? size(s) - 1 : INF;
    lastOne = (s.back() == '1') ? size(s) : INF;
    for (int i = size(s) - 2; i >= 0; i--) {
        if (s[i] == '1') {
            nxt[i] = lastZero;
        } else {
            nxt[i] = lastOne;
        }
        lastZero = (s[i] == '0') ? i : lastZero;
        lastOne = (s[i] == '1') ? i : lastOne;
    }
    int firstNotUsed = 0;
    while (done < size(s)) {
        bool f = 0;
        vector<int> pos;
        for (int i = firstNotUsed; i < size(s); i++) {
            if (!used[i]) {
                if (!f && s[i] == '0') {
                    f ^= 1;
                    done++;
                    used[i] = 1;
                    pos.push_back(i);
                    i = nxt[i] - 1;
                } else if (f && s[i] == '1') {
                    f ^= 1;
                    used[i] = 1;
                    done++;
                    pos.push_back(i);
                    i = nxt[i] - 1;
                }
            }
        }
        if (!f) {
            cout << -1;
            bye();
        }
        ans.push_back(pos);
        firstNotUsed++;
    }
    cout << size(ans) << "\n";
    for (int i = 0; i < size(ans); i++) {
        cout << size(ans[i]) << " ";
        for (int j = 0; j < size(ans[i]); j++) {
            cout << ans[i][j] + 1 << " ";
        }
        cout << "\n";
    }
    bye();
}
