#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int dfs(vector<vector<int>>& g, vector<bool>& used, int v) {
    if (used[v] == true) {
        return 0;
    }
    int res = 1;
    // todo
    used[v] = true;
    int ans = 1;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        ans += dfs(g, used, g[v][i]);
    }
    return ans;
}

int main() {
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        if ((a[u] + 1) % h == a[v]) {
            g[u].push_back(v);
        }
        if ((a[v] + 1) % h == a[u]) {
            g[v].push_back(u);
        }
    }
    vector<bool> used(n);
    pair<int, int> res;
    res.first = 0;
    res.second = dfs(g, used, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            used[j] = false;
        }
        int val = dfs(g, used, i);
        if (val > res.second) {
            res.first = i;
            res.second = val;
        }
    }
    cout << res.second << endl;
    for (int j = 0; j < n; ++j) {
        used[j] = false;
    }
    dfs(g, used, res.first);
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            cout << i + 1 << " ";
        }
    }
    return 0;
}
