#include <bits/stdc++.h>

using namespace std;

vector<int> toprint;

set<int> need;

bool check(vector<int>& res, vector<int>& a) {
    vector<bitset<2048>> dp(res.size() + 1);

    dp[0][1024] = true;
    int mn = 1024;
    int mx = 1024;
    for (int i = 0; i < res.size(); ++i) {

        for (int j = mn; j <= mx; ++j) {
            if (dp[i][j]) {
                dp[i + 1][j] = dp[i + 1][j + res[i]] = true;
                mx = max(mx, j + res[i]);
                mn = min(mn, j + res[i]);
            }
        }
    }
    for (int i = 0; i < a.size(); ++i) {
        if (!dp[res.size()][a[i] + 1024]) {
            return false;
        }
    }
    return true;
}

void getRes(int n, vector<int>& tores, vector<int>& res, vector<int>& a) {
    if (n >= res.size()) {
        if (tores.size() < toprint.size()) {
            if (check(tores, a)) {
                toprint.resize(tores.size());
                for (int i = 0; i < toprint.size(); ++i) {
                    toprint[i] = tores[i];
                }
            }
        }
    } else {
        if (need.find(res[n]) == need.end()) {
            getRes(n + 1, tores, res, a);
        }
        tores.push_back(res[n]);
        getRes(n + 1, tores, res, a);
        tores.pop_back();
    }
}

int main() {
    toprint.resize(100);
    int n;
    cin >> n;
    vector<int> a(n);
    bool fm = false, fx = false;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        need.insert(a[i]);
        fm = fm || (a[i] < -300);
        fx = fx || (a[i] > 300);
    }
    vector<int> res;
    for (int i = 0; i <= 8; ++i) {
        res.push_back(1 << i);
        res.push_back(-(1 << i));
    }
    if (fx) {
        res.push_back(512);
    }
    if (fm) {
        res.push_back(-512);
    }
    vector<int> tores;
    getRes(0, tores, res, a);
    cout << toprint.size() << endl;
    for (int i = 0; i < toprint.size(); ++i) {
        cout << toprint[i] << " ";
    }
    return 0;
}
