#include <iostream>
#include <vector>

using namespace std;

int k = 0;
int n;
vector<int> ans;
int first;

void dfs(vector<vector<int> >& g, int v, vector<int>& used)
{
    used[v] = -2;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (used[g[v][i]] == -1)
        {
            dfs(g, g[v][i], used);
        }
    }
    used[v] = k;
    k++;
    if (used[v] == 0)
        first = v;
    return;
}

void dfs1(vector<vector<int> >& g, int v, vector<int>& used)
{
    ans.push_back(v + 1);
    used[v] = -1;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (used[g[v][i]] != -1)
        {
            dfs1(g, g[v][i], used);
        }
    }
    return;
}

int main()
{
    int m, h;
    cin >> n >> m >> h;
    int u[n];
    for (int i = 0; i < n; i++)
        cin >> u[i];
    vector<vector<int> > g(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (u[a] - u[b] == 1 || (u[a] == 0 && u[b] == h - 1))
        {
            g[b].push_back(a);
        }
        if (u[b] - u[a] == 1 || (u[b] == 0 && u[a] == h - 1))
        {
            g[a].push_back(b);
        }
    }

    vector<int> used(n, -1);
    for (int i = 0; i < n; i++)
    {
        if (used[i] == -1)
            dfs(g, i, used);
    }
    dfs1(g, first, used);
    cout << ans.size() << endl;
    for (int i = 0; i < (int) ans.size(); i++)
        cout << ans[i] << " ";
}
