#include <iostream>
#include <vector>

using namespace std;

int dfs(vector<vector<int> >& g, int v, vector<bool>& used)
{
    int ans = 1;
    used[v] = true;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (!used[g[v][i]])
        {
            ans += dfs(g, g[v][i], used);
        }
    }
    return ans;
}

void dfs1(vector<vector<int> >& g, int v, vector<bool>& used)
{
    cout << v + 1 << " ";
    used[v] = true;
    for (int i = 0; i < (int) g[v].size(); i++)
    {
        if (!used[g[v][i]])
        {
            dfs1(g, g[v][i], used);
        }
    }
    return;
}

int main()
{
    int n, m, h;
    cin >> n >> m >> h;
    int u[n];
    for (int i = 0; i < n; i++)
        cin >> u[i];
    vector<vector<int> > g(n);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (u[a] - u[b] == 1 || (u[a] == 0 && u[b] == h - 1))
            g[b].push_back(a);
        if (u[b] - u[a] == 1 || (u[b] == 0 && u[a] == h - 1))
            g[a].push_back(b);
    }
    vector<bool> used(n);
    int mi = 1000000000;
    int id;
    for (int i = 0; i < n; i++)
    {
        for (int e = 0; e < n; e++)
            used[e] = false;
        int k = dfs(g, i, used);
        if (k < mi)
        {
            mi = k;
            id = i;
        }
    }
    cout << mi << endl;
    for (int e = 0; e < n; e++)
        used[e] = false;
    dfs1(g, id, used);
}
