#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define ff first
#define ss second

using namespace std;

typedef long long ll;

int n, m, h;
vector<int> t;
vector<pair<int, int>> c;
vector<vector<int>> g, g2;
int ans_sm, ans;
vector<bool> used;
vector<int> top;
vector<vector<int>> z;
int T;

void dfs1(int i) {
    used[i] = 1;
    for (auto el: g[i]) {
        if (!used[el]) dfs1(el);
    }
    top.push_back(i);
}

void dfs2(int i) {
    used[i] = 0;
    z[z.size() - 1].push_back(i + 1);
    //cout << "$ " << i + 1 << endl;
    for (auto el: g2[i]) {
        //cout << el << endl;
        if (used[el]) {
            dfs2(el);
        }
    }
}



signed main() {
    /*cin >> n >> m;
    g.resize(n);
    g2.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g2[b].push_back(a);
    }
    for (int i = 0; i < g.size(); i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(top.begin(), top.end());
    for (auto i: top) {
        if (used[i]) {
            cout << "! " << i + 1<< endl;
            z.push_back(0);
            dfs2(i);
        }
    }

    for (auto el: z) cout << el << " ";
    cout << endl;*/
    cin >> n >> m >> h;
    t.resize(n);
    for (int i = 0; i < n; i++) cin >> t[i];
    c.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i].ff >> c[i].ss;
        c[i].ff--, c[i].ss--;
    }
    g.resize(t.size());
    g2.resize(t.size());
    used.resize(t.size());
    for (int i = 0; i < n; i++) {
        if (t[c[i].ff] == (t[c[i].ss] + 1) % h) {
            g[c[i].ss].push_back(c[i].ff);
            g2[c[i].ff].push_back(c[i].ss);
        }

        if (t[c[i].ss] == (t[c[i].ff] + 1) % h) {
            g[c[i].ff].push_back(c[i].ss);
            g2[c[i].ss].push_back(c[i].ff);
        }
    }

    for (int i = 0; i < g.size(); i++) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    reverse(top.begin(), top.end());
    //cout << "TOP: " <<endl;
    for (auto i: top) {
        //cout << "# " << i + 1<< endl;
        if (used[i]) {
            //cout << "! " << i + 1<< endl;
            z.push_back({});
            dfs2(i);
        }
    }
    /*cout << "Z: " << endl;
    for (auto el: z) {
        for (auto el1: el) cout << el1 << " ";
        cout << endl;
    }
    cout << endl;*/

    int mn_i = 0;
    for (int i = 0; i < z.size(); i++) {
        if (z[i].size() < z[mn_i].size()) mn_i = i;
    }
    cout << z[mn_i].size() << endl;
    for (auto el: z[mn_i]) cout << el << " ";
    cout << endl;
    return 0;
}



/*
5 5
1 2
2 3
3 4
4 1
2 5


4 4
2 1
2 3
3 4
4 2

4 3
1 2
2 3
3 1


*/

