#include <iostream>
#include <vector>
#include <bitset>
#define ff first
#define ss second

using namespace std;

vector<int> b;
int mx;

vector<int> w;
vector<bool> items;

const int MX = 5e3 + 100;

bool check() {
    //cout << "check" << endl;
    bitset<4 * MX> ok;
    int shift = mx + 1;
    ok[shift] = 1;
    for (int i = 0; i < w.size(); i++) {
        if (!items[i]) continue;
        /*cout << "ITEM: " << w[i] << endl;
        for (int i = 0; i < 2 * shift; i++) {
            cout << i - shift << " ";
        } cout << endl;
        for (int i = 0; i < 2 * shift; i++) {
            cout << ok[i] << " ";
        } cout << endl; */
        if (w[i] < 0) {
            ok = ok | (ok >> abs(w[i]));
        } else {
            ok = ok | (ok << w[i]);
        }
    }
    for (auto el: b) {
        if (!ok[el + shift]) {
            //cout << "FAIL" << endl;
            return 0;
        }
    }
    //cout << "SUCCES" << endl;
    return 1;
}

int ans_sm;
vector<bool> ans;

void gen(int pos, int sm) {
    if (ans_sm <= sm) return;
    if (pos == w.size()) {
        if (check()) {
            ans_sm = sm;
            ans = items;
        }
        return;
    }
    items[pos] = 0;
    gen(pos + 1, sm);
    items[pos] = 1;
    gen(pos + 1, sm + 1);
}

int main() {
    ans_sm = 1e7;
    int n;
    cin >> n;
    b.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        mx = max(mx, abs(b[i]));
    }
    mx *= 2;
    for (int i = 1; i <= mx; i *= 2) {
        w.push_back(i);
        w.push_back(-i);
    }
    items.resize(w.size());
    gen(0, 0);
    cout << ans_sm << endl;
    for (int i = 0; i < ans.size(); i++) if (ans[i]) cout << w[i] << " ";
    cout << endl;
    return 0;
}
