#include <bits/stdc++.h>
using namespace std;

int n, m, h;

vector<vector<int>> g;
vector<bool> used;
vector<int> ans, a, e;

void dfs(int v)
{
    if(used[v])
        return;
    ans.push_back(v);
    if(ans.size() >= e.size() && e.size())
        return;
    used[v] = true;
    for(int to : g[v])
    {
        if(a[to] - a[v] == 1 || a[v] - a[to] == h - 1)
            dfs(to);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> h;
    g.resize(n); a.resize(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < m; i++)
    {
        int a, b; cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i = 0; i < n; i++)
    {
        used.assign(n, 0);
        ans.clear();
        dfs(i);
        if(e.empty() || ans.size() < e.size())
            e = ans;
    }
    cout << e.size() << endl;
    for(auto i : e)
        cout << i + 1 << " ";
    cout << endl;
}
