#include <bits/stdc++.h>
using namespace std;

int n, m, h, timer;

vector<vector<int>> g, r, rev;
vector<bool> used;
vector<int> ans, a, order;
vector<vector<int>> comp;

void top_sort(int v)
{
    used[v] = true;
    for(int to : r[v])
        if(!used[to])
            top_sort(to);
    order.push_back(v);
}

void dfs(int v)
{
    used[v] = true;
    comp.back().push_back(v);
    for(int to : rev[v])
        if(!used[to])
            dfs(to);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> h;
    g.resize(n); a.resize(n);
    r.resize(n); used.resize(n);
    rev.resize(n);
    map<pair<int, int>, bool> was;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < m; i++)
    {
        int a, b; cin >> a >> b;
        a--, b--;
        if(was[{a, b}])
            continue;
        was[{a, b}] = was[{b, a}] = true;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    //marking others
    for(int v = 0; v < n; v++)
        for(int to : g[v])
        {
            if(a[to] - a[v] == 1 || a[v] - a[to] == h - 1)
            {
                r[v].push_back(to);
                rev[to].push_back(v);
            }
        }
    for(int i = 0; i < n; i++)
        if(r[i].size() == 0)
        {
            cout << i + 1;
            exit(0);
        }
    for(int i = 0; i < n; i++)
    {
        if(used[i])
            continue;
        top_sort(i);
    }
    reverse(order.begin(), order.end());
    used.assign(n, 0);
    for(int i = 0; i < n; i++)
    {
        int v = order[i];
        if(used[v])
            continue;
        comp.push_back({});
        dfs(v);
    }
    int ind = 0;
    for(int i = 0; i < comp.size(); i++)
    {
        bool fit = true;
        for(int v : comp[i])
            if(r[v].size())
                fit = false;
        if(!fit)
            continue;
        if(comp[i].size() <= comp[ind].size())
            ind = i;
    }
    cout << comp[ind].size() << endl;
    for(int i : comp[ind])
        cout << i + 1 << " ";
}
