#include <bits/stdc++.h>

using namespace std;
int n, m, h;

pair <int, vector <int> > cnt(int ind, vector <int> u, map <int, vector <int> > &bad_pair) ///a - ind from day
{
    queue <int> need_move;
    vector <int> ans;
    vector <bool> used(n, false);
    used[ind] = true;
    ans.push_back(ind);
    need_move.push(ind);
    int c = 0;
    while (need_move.size() != 0){
        c++;
        int now = need_move.front();
        need_move.pop();
        u[now] = (u[now] + 1) % h;
        for (auto bad : bad_pair[now])
        {
            if (u[bad] == u[now] && !used[bad])
            {
                need_move.push(bad);
                ans.push_back(bad);
                used[bad] = true;
            }
        }
    }
    return {c, ans};
}

int main()
{
    cin >> n >> m >> h;
    vector <int> u(n, 0);
    vector <pair <int, int> > day;
    for (int i = 0; i < n; i++)
    {
        cin >> u[i];
        day.push_back({u[i], i});
    }
    sort(day.begin(), day.end());
    vector <pair <int, int> > people(m, {0, 0});
    map <int, vector <int> > bad_pair;
    for (int i = 0; i < m; i++)
    {
        cin >> people[i].first >> people[i].second;
        people[i].first--;
        people[i].second--;
        if (bad_pair.find(people[i].first) == bad_pair.end())
        {
            bad_pair[people[i].first] = {people[i].second};
        }
        else{
            bad_pair[people[i].first].push_back({people[i].second});
        }
        if (bad_pair.find(people[i].second) == bad_pair.end())
        {
            bad_pair[people[i].second] = {people[i].first};
        }
        else{
            bad_pair[people[i].second].push_back({people[i].first});
        }
    }

    pair <int, vector <int> > best = {-1, {}};

    for (int i = 0; i < n; i++)
    {
        pair <int, vector <int> > ans = cnt(i, u, bad_pair);
        if (ans.first < best.first || best.first == -1)
        {
            best = ans;
        }
    }

    cout << best.first << "\n";
    for (auto F : best.second)
    {
        cout << F + 1 << " ";
    }
}

