#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

int pos = 0;
vector <int> v[100100], g[100100], tps, comp, ct[100100];
int nv[100100];
vector <short> used;

void topsort(int t) {
    used[t] = 1;
    for (int i = 0; i < v[t].size(); i++) {
        int yo = v[t][i];
        if (!used[yo])
            topsort(yo);
    }
    tps.emplace_back(t);
}

void dfs(int t) {
    used[t] = 1;
    comp[t] = pos;
    ct[pos].emplace_back(t);
    for (int i = 0; i < g[t].size(); i++) {
        int yo = g[t][i];
        if (!used[yo])
            dfs(yo);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    vector <int> u(n);
    for (int i = 0; i < n; i++)
        cin >> u[i];
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        if (u[x] - (u[y] + 1) % h == 0) {
            v[y].emplace_back(x);
            g[x].emplace_back(y);
            //cout << "hey\n";
        }
        if (u[y] - (u[x] + 1) % h == 0) {
            v[x].emplace_back(y);
            g[y].emplace_back(x);
            //cout << "hey2\n";
        }
    }
    used.assign(n, 0);
    comp.assign(n, -1);
    for (int i = 0; i < n; i++)
        if (!used[i])
            topsort(i);
    used.assign(n, 0);
    for (int i = n - 1; i >= 0; i--) {
        int yo = tps[i];
        if (!used[yo]) {
            dfs(yo);
            pos++;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < v[i].size(); j++) {
            int yo = v[i][j];
            if (comp[i] != comp[yo])
                nv[comp[i]]++;
        }
    }
    int ans = -1;
    for (int i = 0; i < pos; i++)
        if (!nv[i] && (ans == -1 || ct[i].size() < ct[ans].size()))
            ans = i;
    cout << ct[ans].size() << '\n';
    for (int i = 0; i < ct[ans].size(); i++)
        cout << ct[ans][i] + 1 << ' ';
    return 0;
}
