#pragma comment(linker, "/STACK:536870912")
#pragma warning(disable:4996)

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include<iostream>
#include<algorithm>
#include<queue>
#include<string>
#include<vector>
#include<map>
#include<list>
#include<set>
#include<cstring>
#include<ctime>
#include<cmath>
#include<limits>
#include<iterator>
#include<functional>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<bitset>
#include<complex>

#define all(v) v.begin(), v.end()
#define setv(ar, val) memset(ar, val, sizeof(ar));
#define ll long long int
#define ull unsigned long long int
#define PI 3.1415926535897932384626433832795
using namespace std;


const int D = 8, N = 1 << D;
int dp[N][N][N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	scanf("%d", &n);

	dp[0][0][0] = 1;
	for (int i = 0; i <n; i++) {
		int a;
		scanf("%d", &a);
		int t = 1, q = a < 0;
		a = abs(a);
		while (t <= a)
			t <<= 1;

		pair<int, int> l, r;
		if (q) {
			l = make_pair(0, a);
			r = make_pair(t - a, t);
		}
		else {
			l = make_pair(a, 0);
			r = make_pair(t, t - a);
		}

		for (int x = 0; x < N; x++) {
			for (int y =0; y < N; y++) {
				if (dp[i][x][y]) {
					dp[i + 1][x | l.first][y | l.second] = 1;
					dp[i + 1][x | r.first][y | r.second] = 1;
				}
			}
		}
	}

	int ans = 1e9, cx, cy;

	for (int x = 0; x < N; x++) {
			for (int y =0; y < N; y++) {
				if (dp[n][x][y]) {
					int w = 0;
					for (int i = 0; i < D; i++)
						w += ((x >> i) & 1) + ((y >> i) & 1);
					if (w < ans) {
						ans = w;
						cx = x;
						cy = y;
					}
				}
			}
		}

	printf("%d\n", ans);
	for (int i = 0; i < D; i++) {
		if ((cx >> i) & 1)
			printf("%d ", 1 << i);
	}
	for (int i = 0; i < D; i++) {
		if ((cy >> i) & 1)
			printf("%d ", -(1 << i));
	}


	return 0;
}