#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second

ostream &operator << (ostream &out, const vector <int> & lst) {
    for (auto p : lst)
        out << p + 1 << ' ';
    return out;
}

typedef long long ll;
typedef pair < int, int > pii;
#ifdef MY
const int N = 20;
#else
const int N = 2e5 + 4;
#endif // MY

int n;
int lst[N][2];
int nxt[N], prv[N];
bool used[N];

vector < vector < int > > ans;

string s;


void clr() {
    ans.clear();
    for (int i = 0; i < N; ++i) {
        //lst[i][0] = lst[i][1] = 0;
        nxt[i] = n;
        prv[i] = -1;
    }
}
/*
int ind (int i, int t, int k) {
    return (i != 0 ? num[i - 1][0] + num[i - 1][1] : 0) + (t != 0 ? num[i][0] : 0) + (k - 1);
}*/

void calc(int &a, int & b) {
    int pro = -1, prz = -1;
    for (int i = 0; i < n; i++) {
        //cout << s[i];
        if (s[i] == '0') {
            if (a == -1)
                a = i;
            else
                nxt[prz] = i;
            prv[i] = prz;
            prz = i;
        } else {
            if (b == -1)
                b = i;
            else
                nxt[pro] = i;
            prv[i] = pro;
            pro = i;
        }
    }
}

void callc(int &a, int & b) {
    a = b = -1;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '0') {
            if (a == -1)
                a = i;
        } else {
            if (b == -1)
                b = i;
        }
    }
}

void solve() {
    n = s.size();
    clr();
    int a = -1, b = -1;
    calc(a, b);
    /*for (int i = 0; i < n; ++i) {
        cout << prv[i] << ' ' << nxt[i] << endl;
    }*/
    //cout << endl;
    nxt[n - 1] = n;
    if (s[n - 1] != '0' || s[0] != '0') {
        cout << "-1\n";
        return;
    }
    for (int i = a; i < n && b < n;) {
        int fnxt = nxt[i];
        if (b < i) {
            cout << "-1\n";
            return;
        }
        nxt[i] = b;
        b = nxt[b];
        i = fnxt;
    }
    callc(a, b);
    for (int i = a; i > -1 && b > -1; ) {
        int fprv = prv[i];
        if (i < b) {
            cout << "-1\n";
            return;
        }
        //prv[i] = b;
        nxt[b] = i;
        b = prv[b];
        nxt[i] = n;
        i = fprv;
    }
    vector < int > res;
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        ans.push_back(res);
        int j = i;
        while (j != n && !(s[j] == '0' && s[nxt[j]] == '0')) {
            //cout << j << ' ' ;
            used[j] = true;
            ans.back().pb(j);
            j = nxt[j];
        }
        if (ans.back().size() == 0)
            ans.pop_back();
        //cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ans.pb(res);
            ans.back().pb(i);
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].size() << ' ' << ans[i] << "\n";
    }
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    while (cin >> s) {
        solve();
    }
    return 0;
}
