#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) x.begin(), x.end()

const int MAXN = 1e5 + 5;

int n, m, h;
int t[MAXN];
vector<int> g[MAXN];
bool used[MAXN];
vector<int> ans;

int dfs(int v) {
	int res = 1;
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to]) {
			res += dfs(to);
		}
	}
	return res;
}

void dfs1(int v) {
	ans.push_back(v + 1);
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to]) {
			dfs1(to);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> n >> m >> h;
	rep(i, n) {
		cin >> t[i];
	}

	rep(i, m) {
		int p, q;
		cin >> p >> q;
		p--;
		q--;
		if ((t[p] + 1) % h == t[q]) g[p].push_back(q);
		if ((t[q] + 1) % h == t[p]) g[q].push_back(p);
	}

	// rep(i, n) {
	// 	cout << g[i].size() << " : ";
	// 	for (auto v : g[i]) {
	// 		cout << v << ' ';
	// 	} cout << endl;
	// }

	int res = INT_MAX, resv = 0;
	rep(i, n) {
		fill(used, used + n, false);
		int v = dfs(i);
		if (v < res) {
			res = v;
			resv = i;
		}
	}

	fill(used, used + n, false);
	dfs1(resv);

	cout << ans.size() << '\n';
	for (auto v : ans) {
		cout << v << ' ';
	} cout << endl;
}