#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define mp make_pair
#define pb push_back
#define f first
#define s second
#define all(x) x.begin(), x.end()

string mtos(int mask, int sz = 8) {
	string res = "";
	rep(i, sz) {
		res += ((mask >> i) & 1) + '0';
	}
	return res;
}

int mcount(int mask) {
	int res = 0;
	for (int i = 0; (1 << i) <= mask; ++i) {
		if (mask & (1 << i)) {
			res++;
		}
	}
	return res;
}

const int MAXN = 1000;
const int MAXP = 10;
int n;
vector<int> a;

bool check(int mask, int negmask) {
	bitset<(4 << MAXP) + 4> bs;
	int md = (2 << MAXP) + 2;
	bs[md] = 1;

	for (int i = 0; (1 << i) <= mask; ++i) {
		if (mask & (1 << i)) {
			bs = bs | (bs >> (1 << i));
		}
	}

	for (int i = 0; (1 << i) <= negmask; ++i) {
		if (negmask & (1 << i)) {
			bs |= (bs << (1 << i));
		}
	}

	// cout << bs << endl;
	rep(i, n) {
		if (!bs[md - a[i]]) {
			// bs[md - a[i]] = true;
			// cout << bs << endl;
			return false;
		}
	}
	return true;
}

int main() {
	cin >> n;
	a.resize(n);
	rep(i, n) {
		cin >> a[i];
	}

	int best = INT_MAX;
	pii ans = {0, 0};
	for (int m1 = 0; m1 < (1 << MAXP); ++m1) {
		for (int m2 = 0; m2 < (1 << MAXP); ++m2) {
			int c1 = mcount(m1);
			int c2 = mcount(m2);
			if (c1 + c2 < best && check(m1, m2)) {
				// cout << ':' << mtos(m1) << ' ' << mtos(m2) << endl;
				best = c1 + c2;
				ans = {m1, m2};
			}
		}
	}

	// cout << best << endl;

	// cout << check(0b1001, 0b0) << endl;
	// cout << mtos(ans.f) << ' ' << mtos(ans.s) << endl;
	cout << best << endl;
	rep(i, MAXP) {
		int bit = (1 << i);
		if (ans.f & bit) {
			cout << (ans.f & bit) << ' ';
		}
		if (ans.s & bit) {
			cout << -(ans.s & bit) << ' ';
		}
	} cout << endl;
}