#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse3,abm,avx,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define all(x) x.begin(), x.end()
#define sz(x) x.size()
////

vector <int> dp;

int get(int l, int r)
{
	r = min(r, int(dp.size() - 1));
	l = min(l, int(dp.size()));
	if (l == 0)
		return dp[r];
	else
		return dp[r] - dp[l - 1];
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.precision(6);
	int p,n,d,b;
	cin >> p >> n >> d >> b;
	vector <int> A(n + 1);
	dp.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
		if (i == 0)
			dp[i] = A[i];
		else
			dp[i] = dp[i - 1] + A[i];
	}

	int lr = -1;
	/*for (int i = 0; i + d < n; i++)
	{
		A[i] += A[i + d];
		A[i + d] = 0;
	}*/

	for (int i = 0; i < n; i++)
	{
		int l = max(lr + 1, i);
		A[i] = get(l, i + (i + 1) * d);
		lr = i + (i + 1) * d;
	}

	/*for (int i = 0; i < n; i++)
	{
		cout << A[i] <<" ";
	}
	cout << endl;*/
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (A[i] < b)
			cnt++;
		else
		{
			int notNeed = A[i] - b;
			A[i + 1] += notNeed;
			A[i] = b;
		}
	}

	/*for (int i = 0; i < n; i++)
	{
		cout << A[i] <<" ";
	}
	cout << endl;*/
	cout << cnt;
	return 0;
}