#include <iostream>
#include <vector>
#include <map>
#include <set>
#define ll long long
#define pb push_back

using namespace std;

vector<vector<int>> g;
vector<int> used;
vector<vector<int>> poss;

void dfs(int v, int u) {
    used[v] = 1;
    poss[u].pb(v);
    for (int s : g[v]) {
        if (!used[s]) dfs(s, u);
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m, h;
    cin >> n >> m >> h;
    for (int i = 0; i < n; ++i) {
        g.pb({});
    }
    vector<int> t;
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        t.pb(a);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if ((t[a] + 1) % h == t[b]) g[a].pb(b);
        if ((t[b] + 1) % h == t[a]) g[b].pb(a);
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            cout << g[i][j] << " ";
        }
        cout << "\n";
    }*/
    for (int i = 0; i < n; ++i) {
        used.pb(0);
        poss.pb({});
    }

    int idx = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) used[j] = 0;
        dfs(i, i);
        if (poss[i].size() < poss[idx].size()) idx = i;
    }
    cout << poss[idx].size() << "\n";
    for (int i = 0; i < poss[idx].size(); ++i) {
        cout << poss[idx][i] + 1 << " ";
    }


    return 0;
}

