#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>


using namespace std;

vector<int> used;
int cnt;
vector<vector<int>> g;

void dfs(int v) {
	cnt++;
	used[v] = true;
	for (int i = 0; i < (int)g[v].size(); ++i) {
		int to = g[v][i];
		if (!used[to])
			dfs(to);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m, h;
	cin >> n >> m >> h;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		if (a[v] + 1 == a[u] || a[v] + 1 == a[u] + h)
			g[v].push_back(u);
		if (a[u] + 1 == a[v] || a[u] + 1 == a[v] + h)
				g[u].push_back(v);
	}
	for (int i = 0; i < n; ++i)
		if (g[i].empty())
			return cout << 1 << '\n' << i + 1, 0;
	int min = n, imin = 0;
	for (int i = 0; i < n; ++i) {
		used.assign(n, false);
		cnt = 0;
		dfs(i);
		if (cnt < min)
			cnt = min, imin = i;
	}
	cout << min << '\n';
	used.assign(n, false);
	cnt = 0;
	dfs(imin);
	for (int i = 0; i < n; ++i)
		if (used[i])
			cout << i + 1 << ' ';
	return 0;
}
