#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#define DEBUG1

#include <iostream>
#include <vector>
#include <climits>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <string>

using namespace std;

vector<vector<int>> gr;
vector<bool> used;
int cnt;

void dfs(int v)
{
	used[v] = true;
	cnt++;

	for (int i = 0; i < gr[v].size(); i++) {
		int u = gr[v][i];
		if (!used[u])
			dfs(u);
	}
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int n, m, H;
	cin >> n >> m >> H;
	vector<int> h(n);
	for (int i = 0; i < n; i++)
		cin >> h[i];
	gr.resize(n);

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if ((h[a] + 1) % H == h[b])
			gr[a].push_back(b);
		if ((h[b] + 1) % H == h[a])
			gr[b].push_back(a);
	}
	used.resize(n);

	int ans = n, ians = 0;
	for (int i = 0; i < n; i++) {
		fill(used.begin(), used.end(), false);
		cnt = 0;
		dfs(i);
		if (ans > cnt) {
			ans = cnt;
			ians = i;
		}
	}
	cout << ans << '\n';
	fill(used.begin(), used.end(), false);
	dfs(ians);
	for (int i = 0; i < n; i++)
		if (used[i])
			cout << i + 1 << ' ';
}
