#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > g(1e5+4, vector<int>(0));
vector<int> used(1e5+4, -1), used2(1e5+4, -1), w(1e5+4, -1);
int now=0;

int dfs(int v, int use) {
    int ans1=1;
    for (int i=0; i<g[v].size(); i++) {
        if (used[g[v][i]]!=use) {
            used[g[v][i]]=use;
            ans1+=dfs(g[v][i], use);
        }
    }
    return ans1;
}

void dfs2(int v) {
    cout << v+1 << " ";
    for (int i=0; i<g[v].size(); i++)
        if (used2[g[v][i]]==-1) {
            used2[g[v][i]]=1;
            dfs2(g[v][i]);
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, h;
    cin >> n >> m >> h;
    vector<int> q(n);
    for (int i=0; i<n; i++)
        cin >> q[i];
    for (int i=0; i<m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((q[a]+1)%h==q[b]) g[a].push_back(b);
        if ((q[b]+1)%h==q[a]) g[b].push_back(a);
    }
    for (int i=0; i<n; i++)
        if (g[i].size()==0) {
            cout << 1 << endl << i+1 << endl;
            return 0;
        }
    int ans=1e9;
    int ansi=0;
    for (int i=0; i<n; i++) {
        if (used[i]==-1) {
            used[i]=now;
            int x=dfs(i, now++);
            if (x<ans) {
                ans=x;
                ansi=i;
            }
        }
    }

    cout << ans << endl;
    used2[ansi]=1;
    dfs2(ansi);

    return 0;
}
