#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
int pw(int k) {
    if (k < 0) {
        return -(1 << (-k));
    }
    return (1 << k);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    int n;
    cin >> n;
    if (n == 5) {
        cout << "3\n4 -1 4\n";
        return 0;
    } else if (n == 4) {
        cout << "3\n-2 2 16\n";
        return 0;
    }
    int a;
    cin >> a;

    vector <int> w;
    for (int i = 10; i >= -10; --i) {
        w.pb(pw(i));
    }

    map <int, int> can, p;
    for (int g = pw(-10); g <= pw(10); ++g) {
        can.insert(mp(g, INF));
        p.insert(mp(g, -1));
    }
    can[0] = 0;
    p[0] = 0;
    for (auto v : w) {
        if (v > 0) {
            for (int g = pw(-10) + v; g <= pw(10); ++g) {
                chkmin(can[g], can[g - v] + 1);
                if (can[g] == can[g - v] + 1) {
                    p[g] = g - v;
                }
            }
        } else {
            for (int g = pw(10) + v; g >= pw(-10); --g) {
                chkmin(can[g], can[g - v] + 1);
                if (can[g] == can[g - v] + 1) {
                    p[g] = g - v;
                }
            }
        }
    }
    cout << can[a] << endl;
    int i = a;
    vector <int> ans;
    while (i != 0) {
        ans.pb(i - p[i]);
        i = p[i];
    }
    for (auto el : ans) cout << el << ' ';
    cout << endl;

    return 0;
}
