#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

//picasso

string s;
int n;

void mrg(vector <int> &a, vector <int> &b) {
    for (auto el : b) {
        a.pb(el);
    }
    b.clear();
}

vector < vector <int> > get(int i, int j) {
    vector < vector <int> > ans;
    if (i == j && s[i] == '0') {
        ans.pb({i});
        return ans;
    }
    while (i < j && s[i + 1] == '0') {
        ans.pb({i});
        i++;
    }
    while (i < j && s[j - 1] == '0') {
        ans.pb({j});
        j--;
    }
    if (i == j || i == j - 1) {
        return ans;
    }

    i++, j--;
    if (i + 1 == j) {
        cout << -1 << '\n';
        exit(0);
    }
    if (i == j) {
        ans.pb({i - 1, i, i + 1});
        return ans;
    }

    auto ans1 = get(i + 1, j - 1);
    ans.pb({i - 1, i});
    ans.pb({j, j + 1});
    int last = (int)ans.size() - 1;
    if ((int)ans1.size() != 1) {
        mrg(ans[last - 1], ans1[0]);
        mrg(ans[last], ans1[(int)ans1.size() - 1]);
    } else {
        mrg(ans[last - 1], ans1[0]);
        mrg(ans[last - 1], ans[last]);
        ans.pop_back();
    }
    for (int k = 1; k < (int)ans1.size() - 1; ++k) {
        ans.pb(ans1[k]);
    }
    ans1.clear();
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> s;
    n = (int)s.size();

    int i = 0, j = n - 1;
    if (s[i] == '1' || s[j] == '1') {
        cout << -1 << endl;
        return 0;
    }
    vector < vector <int> > ans = get(0, n - 1);


    cout << (int)ans.size() << endl;
    for (auto row : ans) {
        cout << (int)row.size() << ' ';
        sort(all(row));
        for (auto el : row) cout << el + 1 << ' ';
        cout << endl;
    }

    vector <int> kek(0);

    return 0;
}
