#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define f first
#define s second
#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

//picasso

string s;
int n;

vector < vector < vector <int> > > ans;

void merge_ans(int i, int j) {
    if ((int)ans[i].size() < (int)ans[j].size())
        ans[i].swap(ans[j]);
    for (auto el : ans[j]) {
        ans[i].pb(el);
    }
    ans[j].clear();
}

void get(int i, int j, int lvl) {
    if (i == j && s[i] == '0') {
        ans[lvl].pb({i});
        return;
    }
    assert(s[i] == '0');

    while (i < j && s[i + 1] == '0') {
        ans[lvl].pb({i});
        i++;
    }
    while (i < j && s[j - 1] == '0') {
        ans[lvl].pb({j});
        j--;
    }
    if (i == j || i == j - 1) {
        ans[lvl].pb({i});
        if (i != j) ans[lvl].pb({j});
        return;
    }
    i++;
    j--;
    if (i == j + 1) {
        cout << -1 << endl;
        exit(0);
    }
    if (i == j) {
        ans[lvl].pb({i - 1, i, i + 1});
        return;
    }

    get(i + 1, j - 1, lvl + 1);
    if ((int)ans[lvl + 1].size() == 1) {

        ans[lvl].pb(ans[lvl + 1][0]);
        ans[lvl][(int)ans[lvl].size() - 1].pb(i - 1);
        ans[lvl][(int)ans[lvl].size() - 1].pb(i);
        ans[lvl][(int)ans[lvl].size() - 1].pb(j);
        ans[lvl][(int)ans[lvl].size() - 1].pb(j + 1);
        ans[lvl + 1].clear();
        return;
    }

    auto k2 = ans[lvl + 1].back();
    ans[lvl + 1].pop_back();
    auto k1 = ans[lvl + 1].back();
    ans[lvl + 1].pop_back();

    k1.pb(i - 1);
    k1.pb(i);
    k2.pb(j);
    k2.pb(j + 1);
    ans[lvl].pb(k1);
    ans[lvl].pb(k2);

    merge_ans(lvl, lvl + 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL), cout.tie(NULL);

    cin >> s;
    n = (int)s.size();
    ans.resize(n + 1);

    int i = 0, j = n - 1;
    if (s[i] == '1' || s[j] == '1') {
        cout << -1 << endl;
        return 0;
    }

    get(0, n - 1, 0);

    cout << (int)ans[0].size() << endl;
    for (auto row : ans[0]) {
        cout << (int)row.size() << ' ';
        sort(all(row));
        for (auto el : row) cout << el + 1 << ' ';
        cout << endl;
    }

    return 0;
}
