
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    int p, n, d, b;
    cin >> p >> n >> d >> b;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (p == 1) {
        int ans = 0;
        int have = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] == b) continue;
            if (a[i] > b) {
                have += a[i] - b;
            }
            else {
                int cur = 0;
                for (int j = i + 1; j <= min(n - 1, (i + 1) * d); ++j) {
                    cur += a[j];
                }
                if (cur + a[i] + have >= b) {
                    cur = 0;
                    for (int j = i + 1; j <= min((i + 1) * d, n - 1); ++j) {
                        if (cur + a[j] < b) {
                            cur += a[j];
                            a[j] = 0;
                        }
                        else {
                            a[j] -= b - a[i] - cur;
                            cur = b - a[i];
                        }
                    }
                    have -= b - a[i] - cur;
                }
                else {
                    have += a[i];
                    ++ans;
                }
            }
        }
        cout << ans << endl;
    }
    else {
        cout << -1 << endl;
    }
}
