#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <stack>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Inf = 1e9;
const double eps = 1e-9;
const ll Linf = 2e18;

const int Mk = 5;

int n;
vector <int> a;
int mx = 40, mn = -40;
vector <int> res;
int ans = Inf;

void rec(int uk, map <int, int> &cnt, int z) {
    if (uk == Mk + 2) {
        set <int> can;
        can.insert(0);
        vector <int> have;
        for (auto p : cnt) {
            for (int i = 0; i < p.second; ++i) {
                if (p.first <= 0) {
                    int cur = (1 << abs(p.first));
                    if (p.first < 0) {
                        cur = -cur;
                    }
                    have.push_back(cur);
                }
                else if (p.first == 1){
                    have.push_back(-1);
                }
                else {
                    int cur = (1 << abs(p.first - 1));
                    if (p.first < 0) {
                        cur = -cur;
                    }
                    have.push_back(cur);
                }
            }
        }
        for (int i = 0; i < have.size(); ++i) {
            int cur = have[i];
            set <int> tmp;
            for (auto e : can) {
                if (mn <= e + cur && e + cur <= mx) {
                    tmp.insert(e + cur);
                }
            }
            for (auto e : tmp) {
                can.insert(e);
            }
        }
        bool flag = true;
        for (auto x : a) {
            if (!can.count(x)) {
                flag = false;
                break;
            }
        }
        if (flag) {
            if (have.size() < ans) {
                ans = have.size();
                res = have;
            }
        }
    }
    else {
        for (int next = 0; next <= 4; ++next) {
            if (z + next > ans) {
                continue;
            }
            cnt[uk] = next;
            rec(uk + 1, cnt, z + next);
            cnt[uk] = 0;
        }
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    #endif
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    map <int, int> tmp;
    rec(-Mk, tmp, 0);
    cout << ans << endl;
    for (auto x : res) {
        cout << x << " ";
    }
}
