#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e5 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int n, m, h;

int add(int x) {
	if (x == h - 1)
		x = 0;
	else
		x++;
	return x;
}

int sub(int x) {
	if (x == 0)
		x = h - 1;
	else
		x--;
	return x;
}

bool cyc;
vector <int> ver, ans(N), ch[N], dp(N);
int used[N] = {};

void dfs(int v) {
	dp[v] = 1;
	used[v] = 1;
	ver.push_back(v);
	for (int i = 0; i < (int)ch[v].size(); i++) {
		int to = ch[v][i];
		if (!used[to])
			dfs(to);
		if (used[to] == 1)
			cyc = true;
		dp[v] += dp[to];
	}
	used[v] = 2;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	cin >> n >> m >> h;
	vector <int> t(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> t[i];
	vector <pii> gr(m);
	for (int i = 0; i < m; i++) {
		cin >> gr[i].first >> gr[i].second;
		if (add(t[gr[i].first]) == t[gr[i].second])
			ch[gr[i].first].push_back(gr[i].second);
		if (add(t[gr[i].second]) == t[gr[i].first])
			ch[gr[i].second].push_back(gr[i].first);
	}
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			cyc = false;
			ver.clear();
			dfs(i);
			if (cyc) {
				for (int j = 0; j < (int)ver.size(); j++)
					dp[ver[j]] = INF;
			}
		}
	}
	ver.clear();
	int st = 1;
	for (int i = 1; i <= n; i++)
		if (dp[st] > dp[i])
			st = i;
	fill(used, used + N, 0);
	dfs(st);
	cout << ver.size() << endl;
	for (int i = 0; i < (int)ver.size(); i++)
		cout << ver[i] << ' ';
}