#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e3 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	int p, n, d, b;
	cin >> p >> n >> d >> b;
	vector <int> v(n + 1);
	for (int i = 1; i <= n; i++) 
		cin >> v[i];
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n && v[i] > 0; j++) {
			if (v[j] == 0) {
				int t = (abs(i - j) + d - 1) / d;
				if (t <= j)
					v[j]++, v[i]--;
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
		if (v[i] == 0)
			ans++;
	cout << ans;
}