#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e3 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

bool dp[21][1030];

int main() {
#ifdef REL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	int n; cin >> n;
	vector <int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int p[100] = {};
	p[0] = -64;
	for (int i = 1; p[i - 1] != -1; i++)
		p[i] = p[i - 1] / 2;
	p[7] = 1;
	for (int i = 8; p[i - 1] != 64; i++)
		p[i] = p[i - 1] * 2;
	vector <int> ans(100);
	for (int i = 0; i < (1 << 14); i++) {
		vector <int> use;
		for (int j = 0; j < 14; j++)
			if (i & (1 << j))
				use.push_back(p[j]);
		bool can[1000] = {};
		for (int j = 0; j < (1 << (int)use.size()); j++) {
			int val = 0;
			for (int k = 0; k < (int)use.size(); k++)
				if (j & (1 << k))
					val += use[k];
			can[val + 128] = true;
		}
		bool fl = true;
		for (int j = 0; j < n; j++) {
			if (!can[v[j] + 128]) {
				fl = false;
				break;
			}
		}
		if (fl && ans.size() > use.size())
			ans = use;
	}
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++)
		cout << ans[i] << ' ';
}