#define _CRT_SECURE_NO_WARNINGS
#define REL

#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <cassert>
#include <string>
#include <queue>

#define mp make_pair
#define pii pair<int, int>
#define endl "\n"

const int N = (int)2e3 + 7;
const int INF = (int)2e9;

typedef long long LL;

using namespace std;

int cnt[(1 << 20)] = {};

void precalc() {
	for (int i = 1; i < (1 << 20); i++) {
		int val = i % 2 == 1;
		cnt[i] = cnt[i / 2] + val;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
#endif
	precalc();
	int n; cin >> n;
	vector <int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int p[100] = {};
	p[0] = -128;
	for (int i = 1; p[i - 1] != -1; i++)
		p[i] = p[i - 1] / 2;
	p[8] = 1;
	for (int i = 9; p[i - 1] != 128; i++)
		p[i] = p[i - 1] * 2;
	vector <int> ans(100), get[200];
	for (int i = 0; i < (1 << 16); i++) {
		int sum = 0;
		for (int j = 0; j < 14; j++)
			if (i & (1 << j))
				sum += p[j];
		for (int j = 0; j < n; j++)
			if (v[j] == sum) {
				get[j].push_back(i);
				break;
			}
	}
	for (int i = 0; i < (1 << 16); i++) {
		vector <int> use;
		for (int j = 0; j < 16; j++) 
			if (i & (1 << j))
				use.push_back(p[j]);
		bool fl = true;
		for (int j = 0; j < n; j++) {
			bool f = false;
			for (int k = 0; k < (int)get[j].size(); k++) {
				if ((i | get[j][k]) == i) {
					f = true;
					break;
				}
			}
			if (!f) {
				fl = false;
				break;
			}
		}
		if (fl && ans.size() > use.size())
			ans = use;
	}
	cout << ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++)
		cout << ans[i] << ' ';
}